/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs


/* Copy the first part of user declarations.  */
#line 1 "gram.y" /* yacc.c:339  */


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRESQL BISON rules/actions
 *
 * Portions Copyright (c) 1996-2024, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  src/backend/parser/gram.y
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET constraint_exclusion TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */
#include "postgres.h"

#include <ctype.h>
#include <limits.h>

#include "access/tableam.h"
#include "catalog/index.h"
#include "catalog/namespace.h"
#include "catalog/pg_am.h"
#include "catalog/pg_trigger.h"
#include "commands/defrem.h"
#include "commands/trigger.h"
#include "gramparse.h"
#include "nodes/makefuncs.h"
#include "nodes/nodeFuncs.h"
#include "parser/parser.h"
#include "storage/lmgr.h"
#include "utils/date.h"
#include "utils/datetime.h"
#include "utils/numeric.h"
#include "utils/xml.h"


/*
 * Location tracking support --- simpler than bison's default, since we only
 * want to track the start position not the end position of each nonterminal.
 */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if ((N) > 0) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (-1); \
	} while (0)

/*
 * The above macro assigns -1 (unknown) as the parse location of any
 * nonterminal that was reduced from an empty rule, or whose leftmost
 * component was reduced from an empty rule.  This is problematic
 * for nonterminals defined like
 *		OptFooList: / * EMPTY * / { ... } | OptFooList Foo { ... } ;
 * because we'll set -1 as the location during the first reduction and then
 * copy it during each subsequent reduction, leaving us with -1 for the
 * location even when the list is not empty.  To fix that, do this in the
 * action for the nonempty rule(s):
 *		if (@$ < 0) @$ = @2;
 * (Although we have many nonterminals that follow this pattern, we only
 * bother with fixing @$ like this when the nonterminal's parse location
 * is actually referenced in some rule.)
 *
 * A cleaner answer would be to make YYLLOC_DEFAULT scan all the Rhs
 * locations until it's found one that's not -1.  Then we'd get a correct
 * location for any nonterminal that isn't entirely empty.  But this way
 * would add overhead to every rule reduction, and so far there's not been
 * a compelling reason to pay that overhead.
 */

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantTargetType targtype;
	ObjectType	objtype;
	List	   *objs;
} PrivTarget;

/* Private struct for the result of import_qualification production */
typedef struct ImportQual
{
	ImportForeignSchemaType type;
	List	   *table_names;
} ImportQual;

/* Private struct for the result of opt_select_limit production */
typedef struct SelectLimit
{
	Node	   *limitOffset;
	Node	   *limitCount;
	LimitOption limitOption;
} SelectLimit;

/* Private struct for the result of group_clause production */
typedef struct GroupClause
{
	bool		distinct;
	List	   *list;
} GroupClause;

/* Private structs for the result of key_actions and key_action productions */
typedef struct KeyAction
{
	char		action;
	List	   *cols;
} KeyAction;

typedef struct KeyActions
{
	KeyAction *updateAction;
	KeyAction *deleteAction;
} KeyActions;

/* ConstraintAttributeSpec yields an integer bitmask of these flags: */
#define CAS_NOT_DEFERRABLE			0x01
#define CAS_DEFERRABLE				0x02
#define CAS_INITIALLY_IMMEDIATE		0x04
#define CAS_INITIALLY_DEFERRED		0x08
#define CAS_NOT_VALID				0x10
#define CAS_NO_INHERIT				0x20


#define parser_yyerror(msg)  scanner_yyerror(msg, yyscanner)
#define parser_errposition(pos)  scanner_errposition(pos, yyscanner)

static void base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner,
						 const char *msg);
static RawStmt *makeRawStmt(Node *stmt, int stmt_location);
static void updateRawStmtEnd(RawStmt *rs, int end_location);
static Node *makeColumnRef(char *colname, List *indirection,
						   int location, core_yyscan_t yyscanner);
static Node *makeTypeCast(Node *arg, TypeName *typename, int location);
static Node *makeStringConstCast(char *str, int location, TypeName *typename);
static Node *makeIntConst(int val, int location);
static Node *makeFloatConst(char *str, int location);
static Node *makeBoolAConst(bool state, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Node *v, int location);
static RoleSpec *makeRoleSpec(RoleSpecType type, int location);
static void check_qualified_name(List *names, core_yyscan_t yyscanner);
static List *check_func_name(List *names, core_yyscan_t yyscanner);
static List *check_indirection(List *indirection, core_yyscan_t yyscanner);
static List *extractArgTypes(List *parameters);
static List *extractAggrArgTypes(List *aggrargs);
static List *makeOrderedSetArgs(List *directargs, List *orderedargs,
								core_yyscan_t yyscanner);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								SelectLimit *limitClause,
								WithClause *withClause,
								core_yyscan_t yyscanner);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Float *v);
static Node *makeAndExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeOrExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeNotExpr(Node *expr, int location);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeSQLValueFunction(SQLValueFunctionOp op, int32 typmod,
								  int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);
static RangeVar *makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner);
static RangeVar *makeRangeVarFromQualifiedName(char *name, List *namelist, int location,
											   core_yyscan_t yyscanner);
static void SplitColQualList(List *qualList,
							 List **constraintList, CollateClause **collClause,
							 core_yyscan_t yyscanner);
static void processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner);
static PartitionStrategy parsePartitionStrategy(char *strategy);
static void preprocess_pubobj_list(List *pubobjspec_list,
								   core_yyscan_t yyscanner);
static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);


#line 293 "gram.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "gram.h".  */
#ifndef YY_BASE_YY_GRAM_H_INCLUDED
# define YY_BASE_YY_GRAM_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int base_yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    IDENT = 258,
    UIDENT = 259,
    FCONST = 260,
    SCONST = 261,
    USCONST = 262,
    BCONST = 263,
    XCONST = 264,
    Op = 265,
    ICONST = 266,
    PARAM = 267,
    TYPECAST = 268,
    DOT_DOT = 269,
    COLON_EQUALS = 270,
    EQUALS_GREATER = 271,
    LESS_EQUALS = 272,
    GREATER_EQUALS = 273,
    NOT_EQUALS = 274,
    ABORT_P = 275,
    ABSENT = 276,
    ABSOLUTE_P = 277,
    ACCESS = 278,
    ACTION = 279,
    ADD_P = 280,
    ADMIN = 281,
    AFTER = 282,
    AGGREGATE = 283,
    ALL = 284,
    ALSO = 285,
    ALTER = 286,
    ALWAYS = 287,
    ANALYSE = 288,
    ANALYZE = 289,
    AND = 290,
    ANY = 291,
    ARRAY = 292,
    AS = 293,
    ASC = 294,
    ASENSITIVE = 295,
    ASSERTION = 296,
    ASSIGNMENT = 297,
    ASYMMETRIC = 298,
    ATOMIC = 299,
    AT = 300,
    ATTACH = 301,
    ATTRIBUTE = 302,
    AUTHORIZATION = 303,
    BACKWARD = 304,
    BEFORE = 305,
    BEGIN_P = 306,
    BETWEEN = 307,
    BIGINT = 308,
    BINARY = 309,
    BIT = 310,
    BOOLEAN_P = 311,
    BOTH = 312,
    BREADTH = 313,
    BY = 314,
    CACHE = 315,
    CALL = 316,
    CALLED = 317,
    CASCADE = 318,
    CASCADED = 319,
    CASE = 320,
    CAST = 321,
    CATALOG_P = 322,
    CHAIN = 323,
    CHAR_P = 324,
    CHARACTER = 325,
    CHARACTERISTICS = 326,
    CHECK = 327,
    CHECKPOINT = 328,
    CLASS = 329,
    CLOSE = 330,
    CLUSTER = 331,
    COALESCE = 332,
    COLLATE = 333,
    COLLATION = 334,
    COLUMN = 335,
    COLUMNS = 336,
    COMMENT = 337,
    COMMENTS = 338,
    COMMIT = 339,
    COMMITTED = 340,
    COMPRESSION = 341,
    CONCURRENTLY = 342,
    CONDITIONAL = 343,
    CONFIGURATION = 344,
    CONFLICT = 345,
    CONNECTION = 346,
    CONSTRAINT = 347,
    CONSTRAINTS = 348,
    CONTENT_P = 349,
    CONTINUE_P = 350,
    CONVERSION_P = 351,
    COPY = 352,
    COST = 353,
    CREATE = 354,
    CROSS = 355,
    CSV = 356,
    CUBE = 357,
    CURRENT_P = 358,
    CURRENT_CATALOG = 359,
    CURRENT_DATE = 360,
    CURRENT_ROLE = 361,
    CURRENT_SCHEMA = 362,
    CURRENT_TIME = 363,
    CURRENT_TIMESTAMP = 364,
    CURRENT_USER = 365,
    CURSOR = 366,
    CYCLE = 367,
    DATA_P = 368,
    DATABASE = 369,
    DAY_P = 370,
    DEALLOCATE = 371,
    DEC = 372,
    DECIMAL_P = 373,
    DECLARE = 374,
    DEFAULT = 375,
    DEFAULTS = 376,
    DEFERRABLE = 377,
    DEFERRED = 378,
    DEFINER = 379,
    DELETE_P = 380,
    DELIMITER = 381,
    DELIMITERS = 382,
    DEPENDS = 383,
    DEPTH = 384,
    DESC = 385,
    DETACH = 386,
    DICTIONARY = 387,
    DISABLE_P = 388,
    DISCARD = 389,
    DISTINCT = 390,
    DO = 391,
    DOCUMENT_P = 392,
    DOMAIN_P = 393,
    DOUBLE_P = 394,
    DROP = 395,
    EACH = 396,
    ELSE = 397,
    EMPTY_P = 398,
    ENABLE_P = 399,
    ENCODING = 400,
    ENCRYPTED = 401,
    END_P = 402,
    ENUM_P = 403,
    ERROR_P = 404,
    ESCAPE = 405,
    EVENT = 406,
    EXCEPT = 407,
    EXCLUDE = 408,
    EXCLUDING = 409,
    EXCLUSIVE = 410,
    EXECUTE = 411,
    EXISTS = 412,
    EXPLAIN = 413,
    EXPRESSION = 414,
    EXTENSION = 415,
    EXTERNAL = 416,
    EXTRACT = 417,
    FALSE_P = 418,
    FAMILY = 419,
    FETCH = 420,
    FILTER = 421,
    FINALIZE = 422,
    FIRST_P = 423,
    FLOAT_P = 424,
    FOLLOWING = 425,
    FOR = 426,
    FORCE = 427,
    FOREIGN = 428,
    FORMAT = 429,
    FORWARD = 430,
    FREEZE = 431,
    FROM = 432,
    FULL = 433,
    FUNCTION = 434,
    FUNCTIONS = 435,
    GENERATED = 436,
    GLOBAL = 437,
    GRANT = 438,
    GRANTED = 439,
    GREATEST = 440,
    GROUP_P = 441,
    GROUPING = 442,
    GROUPS = 443,
    HANDLER = 444,
    HAVING = 445,
    HEADER_P = 446,
    HOLD = 447,
    HOUR_P = 448,
    IDENTITY_P = 449,
    IF_P = 450,
    ILIKE = 451,
    IMMEDIATE = 452,
    IMMUTABLE = 453,
    IMPLICIT_P = 454,
    IMPORT_P = 455,
    IN_P = 456,
    INCLUDE = 457,
    INCLUDING = 458,
    INCREMENT = 459,
    INDENT = 460,
    INDEX = 461,
    INDEXES = 462,
    INHERIT = 463,
    INHERITS = 464,
    INITIALLY = 465,
    INLINE_P = 466,
    INNER_P = 467,
    INOUT = 468,
    INPUT_P = 469,
    INSENSITIVE = 470,
    INSERT = 471,
    INSTEAD = 472,
    INT_P = 473,
    INTEGER = 474,
    INTERSECT = 475,
    INTERVAL = 476,
    INTO = 477,
    INVOKER = 478,
    IS = 479,
    ISNULL = 480,
    ISOLATION = 481,
    JOIN = 482,
    JSON = 483,
    JSON_ARRAY = 484,
    JSON_ARRAYAGG = 485,
    JSON_EXISTS = 486,
    JSON_OBJECT = 487,
    JSON_OBJECTAGG = 488,
    JSON_QUERY = 489,
    JSON_SCALAR = 490,
    JSON_SERIALIZE = 491,
    JSON_TABLE = 492,
    JSON_VALUE = 493,
    KEEP = 494,
    KEY = 495,
    KEYS = 496,
    LABEL = 497,
    LANGUAGE = 498,
    LARGE_P = 499,
    LAST_P = 500,
    LATERAL_P = 501,
    LEADING = 502,
    LEAKPROOF = 503,
    LEAST = 504,
    LEFT = 505,
    LEVEL = 506,
    LIKE = 507,
    LIMIT = 508,
    LISTEN = 509,
    LOAD = 510,
    LOCAL = 511,
    LOCALTIME = 512,
    LOCALTIMESTAMP = 513,
    LOCATION = 514,
    LOCK_P = 515,
    LOCKED = 516,
    LOGGED = 517,
    MAPPING = 518,
    MATCH = 519,
    MATCHED = 520,
    MATERIALIZED = 521,
    MAXVALUE = 522,
    MERGE = 523,
    MERGE_ACTION = 524,
    METHOD = 525,
    MINUTE_P = 526,
    MINVALUE = 527,
    MODE = 528,
    MONTH_P = 529,
    MOVE = 530,
    NAME_P = 531,
    NAMES = 532,
    NATIONAL = 533,
    NATURAL = 534,
    NCHAR = 535,
    NESTED = 536,
    NEW = 537,
    NEXT = 538,
    NFC = 539,
    NFD = 540,
    NFKC = 541,
    NFKD = 542,
    NO = 543,
    NONE = 544,
    NORMALIZE = 545,
    NORMALIZED = 546,
    NOT = 547,
    NOTHING = 548,
    NOTIFY = 549,
    NOTNULL = 550,
    NOWAIT = 551,
    NULL_P = 552,
    NULLIF = 553,
    NULLS_P = 554,
    NUMERIC = 555,
    OBJECT_P = 556,
    OF = 557,
    OFF = 558,
    OFFSET = 559,
    OIDS = 560,
    OLD = 561,
    OMIT = 562,
    ON = 563,
    ONLY = 564,
    OPERATOR = 565,
    OPTION = 566,
    OPTIONS = 567,
    OR = 568,
    ORDER = 569,
    ORDINALITY = 570,
    OTHERS = 571,
    OUT_P = 572,
    OUTER_P = 573,
    OVER = 574,
    OVERLAPS = 575,
    OVERLAY = 576,
    OVERRIDING = 577,
    OWNED = 578,
    OWNER = 579,
    PARALLEL = 580,
    PARAMETER = 581,
    PARSER = 582,
    PARTIAL = 583,
    PARTITION = 584,
    PARTITIONS = 585,
    PASSING = 586,
    PASSWORD = 587,
    PATH = 588,
    PLACING = 589,
    PLAN = 590,
    PLANS = 591,
    POLICY = 592,
    POSITION = 593,
    PRECEDING = 594,
    PRECISION = 595,
    PRESERVE = 596,
    PREPARE = 597,
    PREPARED = 598,
    PRIMARY = 599,
    PRIOR = 600,
    PRIVILEGES = 601,
    PROCEDURAL = 602,
    PROCEDURE = 603,
    PROCEDURES = 604,
    PROGRAM = 605,
    PUBLICATION = 606,
    QUOTE = 607,
    QUOTES = 608,
    RANGE = 609,
    READ = 610,
    REAL = 611,
    REASSIGN = 612,
    RECHECK = 613,
    RECURSIVE = 614,
    REF_P = 615,
    REFERENCES = 616,
    REFERENCING = 617,
    REFRESH = 618,
    REINDEX = 619,
    RELATIVE_P = 620,
    RELEASE = 621,
    RENAME = 622,
    REPEATABLE = 623,
    REPLACE = 624,
    REPLICA = 625,
    RESET = 626,
    RESTART = 627,
    RESTRICT = 628,
    RETURN = 629,
    RETURNING = 630,
    RETURNS = 631,
    REVOKE = 632,
    RIGHT = 633,
    ROLE = 634,
    ROLLBACK = 635,
    ROLLUP = 636,
    ROUTINE = 637,
    ROUTINES = 638,
    ROW = 639,
    ROWS = 640,
    RULE = 641,
    SAVEPOINT = 642,
    SCALAR = 643,
    SCHEMA = 644,
    SCHEMAS = 645,
    SCROLL = 646,
    SEARCH = 647,
    SECOND_P = 648,
    SECURITY = 649,
    SELECT = 650,
    SEQUENCE = 651,
    SEQUENCES = 652,
    SERIALIZABLE = 653,
    SERVER = 654,
    SESSION = 655,
    SESSION_USER = 656,
    SET = 657,
    SETS = 658,
    SETOF = 659,
    SHARE = 660,
    SHOW = 661,
    SIMILAR = 662,
    SIMPLE = 663,
    SKIP = 664,
    SMALLINT = 665,
    SNAPSHOT = 666,
    SOME = 667,
    SPLIT = 668,
    SOURCE = 669,
    SQL_P = 670,
    STABLE = 671,
    STANDALONE_P = 672,
    START = 673,
    STATEMENT = 674,
    STATISTICS = 675,
    STDIN = 676,
    STDOUT = 677,
    STORAGE = 678,
    STORED = 679,
    STRICT_P = 680,
    STRING_P = 681,
    STRIP_P = 682,
    SUBSCRIPTION = 683,
    SUBSTRING = 684,
    SUPPORT = 685,
    SYMMETRIC = 686,
    SYSID = 687,
    SYSTEM_P = 688,
    SYSTEM_USER = 689,
    TABLE = 690,
    TABLES = 691,
    TABLESAMPLE = 692,
    TABLESPACE = 693,
    TARGET = 694,
    TEMP = 695,
    TEMPLATE = 696,
    TEMPORARY = 697,
    TEXT_P = 698,
    THEN = 699,
    TIES = 700,
    TIME = 701,
    TIMESTAMP = 702,
    TO = 703,
    TRAILING = 704,
    TRANSACTION = 705,
    TRANSFORM = 706,
    TREAT = 707,
    TRIGGER = 708,
    TRIM = 709,
    TRUE_P = 710,
    TRUNCATE = 711,
    TRUSTED = 712,
    TYPE_P = 713,
    TYPES_P = 714,
    UESCAPE = 715,
    UNBOUNDED = 716,
    UNCONDITIONAL = 717,
    UNCOMMITTED = 718,
    UNENCRYPTED = 719,
    UNION = 720,
    UNIQUE = 721,
    UNKNOWN = 722,
    UNLISTEN = 723,
    UNLOGGED = 724,
    UNTIL = 725,
    UPDATE = 726,
    USER = 727,
    USING = 728,
    VACUUM = 729,
    VALID = 730,
    VALIDATE = 731,
    VALIDATOR = 732,
    VALUE_P = 733,
    VALUES = 734,
    VARCHAR = 735,
    VARIADIC = 736,
    VARYING = 737,
    VERBOSE = 738,
    VERSION_P = 739,
    VIEW = 740,
    VIEWS = 741,
    VOLATILE = 742,
    WHEN = 743,
    WHERE = 744,
    WHITESPACE_P = 745,
    WINDOW = 746,
    WITH = 747,
    WITHIN = 748,
    WITHOUT = 749,
    WORK = 750,
    WRAPPER = 751,
    WRITE = 752,
    XML_P = 753,
    XMLATTRIBUTES = 754,
    XMLCONCAT = 755,
    XMLELEMENT = 756,
    XMLEXISTS = 757,
    XMLFOREST = 758,
    XMLNAMESPACES = 759,
    XMLPARSE = 760,
    XMLPI = 761,
    XMLROOT = 762,
    XMLSERIALIZE = 763,
    XMLTABLE = 764,
    YEAR_P = 765,
    YES_P = 766,
    ZONE = 767,
    FORMAT_LA = 768,
    NOT_LA = 769,
    NULLS_LA = 770,
    WITH_LA = 771,
    WITHOUT_LA = 772,
    MODE_TYPE_NAME = 773,
    MODE_PLPGSQL_EXPR = 774,
    MODE_PLPGSQL_ASSIGN1 = 775,
    MODE_PLPGSQL_ASSIGN2 = 776,
    MODE_PLPGSQL_ASSIGN3 = 777,
    UMINUS = 778
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 231 "gram.y" /* yacc.c:355  */

	core_YYSTYPE core_yystype;
	/* these fields must match core_YYSTYPE: */
	int			ival;
	char	   *str;
	const char *keyword;

	char		chr;
	bool		boolean;
	JoinType	jtype;
	DropBehavior dbehavior;
	OnCommitAction oncommit;
	List	   *list;
	Node	   *node;
	ObjectType	objtype;
	TypeName   *typnam;
	FunctionParameter *fun_param;
	FunctionParameterMode fun_param_mode;
	ObjectWithArgs *objwithargs;
	DefElem	   *defelt;
	SortBy	   *sortby;
	WindowDef  *windef;
	JoinExpr   *jexpr;
	IndexElem  *ielem;
	StatsElem  *selem;
	Alias	   *alias;
	RangeVar   *range;
	IntoClause *into;
	WithClause *with;
	InferClause	*infer;
	OnConflictClause *onconflict;
	A_Indices  *aind;
	ResTarget  *target;
	struct PrivTarget *privtarget;
	AccessPriv *accesspriv;
	struct ImportQual *importqual;
	InsertStmt *istmt;
	VariableSetStmt *vsetstmt;
	PartitionElem *partelem;
	PartitionSpec *partspec;
	PartitionBoundSpec *partboundspec;
	SinglePartitionSpec *singlepartspec;
	RoleSpec   *rolespec;
	PublicationObjSpec *publicationobjectspec;
	struct SelectLimit *selectlimit;
	SetQuantifier setquantifier;
	struct GroupClause *groupclause;
	MergeMatchKind mergematch;
	MergeWhenClause *mergewhen;
	struct KeyActions *keyactions;
	struct KeyAction *keyaction;

#line 910 "gram.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif



int base_yyparse (core_yyscan_t yyscanner);

#endif /* !YY_BASE_YY_GRAM_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 940 "gram.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  930
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   123437

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  541
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  730
/* YYNRULES -- Number of rules.  */
#define YYNRULES  3415
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  6480

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   778

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   530,     2,     2,
     535,   536,   528,   526,   539,   527,   537,   529,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   540,   538,
     523,   525,   524,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   533,     2,   534,   531,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   532
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   923,   923,   928,   932,   937,   945,   953,   973,   985,
     999,  1000,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,
    1012,  1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,
    1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,
    1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,
    1042,  1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,
    1052,  1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,
    1062,  1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,
    1072,  1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,
    1082,  1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,  1091,
    1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,
    1102,  1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,
    1112,  1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,
    1122,  1123,  1124,  1125,  1126,  1127,  1129,  1136,  1137,  1141,
    1142,  1146,  1147,  1151,  1152,  1153,  1162,  1178,  1190,  1191,
    1192,  1201,  1202,  1206,  1207,  1211,  1216,  1220,  1230,  1238,
    1242,  1246,  1251,  1255,  1303,  1305,  1309,  1313,  1317,  1321,
    1335,  1354,  1363,  1375,  1376,  1380,  1389,  1398,  1407,  1429,
    1437,  1445,  1453,  1461,  1469,  1487,  1506,  1518,  1519,  1530,
    1541,  1552,  1568,  1587,  1594,  1602,  1603,  1604,  1605,  1606,
    1607,  1621,  1628,  1635,  1645,  1654,  1663,  1667,  1676,  1685,
    1693,  1704,  1705,  1714,  1726,  1734,  1743,  1755,  1764,  1773,
    1781,  1791,  1802,  1803,  1807,  1808,  1811,  1813,  1817,  1818,
    1819,  1820,  1824,  1825,  1826,  1832,  1844,  1848,  1852,  1869,
    1877,  1878,  1879,  1883,  1884,  1885,  1889,  1890,  1894,  1898,
    1899,  1907,  1915,  1926,  1934,  1945,  1946,  1951,  1952,  1957,
    1964,  1971,  1978,  1985,  1996,  2007,  2008,  2012,  2013,  2021,
    2037,  2044,  2051,  2058,  2065,  2085,  2095,  2105,  2115,  2125,
    2137,  2149,  2159,  2169,  2179,  2191,  2203,  2213,  2223,  2233,
    2243,  2253,  2263,  2275,  2287,  2297,  2310,  2311,  2315,  2316,
    2320,  2333,  2348,  2362,  2376,  2390,  2407,  2425,  2435,  2445,
    2455,  2465,  2475,  2484,  2493,  2503,  2512,  2522,  2532,  2548,
    2558,  2568,  2578,  2588,  2605,  2615,  2625,  2635,  2646,  2660,
    2676,  2686,  2695,  2711,  2720,  2731,  2742,  2750,  2759,  2768,
    2776,  2784,  2793,  2802,  2811,  2819,  2827,  2836,  2844,  2852,
    2861,  2870,  2879,  2888,  2897,  2906,  2917,  2925,  2934,  2943,
    2952,  2961,  2970,  2979,  2987,  2995,  3003,  3010,  3021,  3022,
    3026,  3035,  3039,  3040,  3044,  3052,  3060,  3068,  3079,  3082,
    3083,  3087,  3088,  3093,  3097,  3101,  3106,  3113,  3115,  3120,
    3124,  3128,  3139,  3146,  3147,  3151,  3152,  3157,  3210,  3223,
    3237,  3249,  3256,  3260,  3274,  3287,  3288,  3293,  3303,  3314,
    3325,  3352,  3359,  3393,  3429,  3452,  3453,  3457,  3458,  3467,
    3468,  3469,  3472,  3473,  3478,  3479,  3483,  3487,  3491,  3495,
    3499,  3503,  3507,  3511,  3515,  3519,  3523,  3527,  3531,  3535,
    3539,  3548,  3552,  3556,  3560,  3564,  3565,  3570,  3574,  3581,
    3588,  3589,  3590,  3591,  3592,  3593,  3597,  3601,  3609,  3620,
    3640,  3660,  3681,  3702,  3723,  3757,  3758,  3759,  3760,  3761,
    3768,  3775,  3776,  3780,  3781,  3785,  3786,  3790,  3794,  3801,
    3805,  3812,  3813,  3814,  3818,  3819,  3822,  3846,  3865,  3887,
    3888,  3892,  3893,  3897,  3898,  3902,  3903,  3907,  3908,  3912,
    3920,  3921,  3922,  3954,  3962,  3970,  3983,  3995,  4008,  4018,
    4028,  4052,  4072,  4073,  4074,  4078,  4079,  4098,  4106,  4114,
    4122,  4134,  4146,  4147,  4148,  4152,  4153,  4154,  4155,  4156,
    4157,  4158,  4159,  4160,  4161,  4170,  4178,  4182,  4196,  4214,
    4230,  4247,  4263,  4283,  4318,  4326,  4330,  4344,  4360,  4361,
    4365,  4366,  4370,  4371,  4374,  4380,  4381,  4384,  4388,  4396,
    4401,  4407,  4408,  4412,  4417,  4424,  4425,  4429,  4439,  4449,
    4457,  4466,  4479,  4491,  4498,  4506,  4514,  4522,  4530,  4540,
    4541,  4545,  4546,  4549,  4561,  4562,  4565,  4576,  4587,  4601,
    4602,  4607,  4608,  4609,  4612,  4613,  4614,  4615,  4618,  4619,
    4622,  4623,  4626,  4646,  4659,  4681,  4682,  4685,  4691,  4697,
    4714,  4723,  4745,  4759,  4776,  4792,  4793,  4794,  4806,  4820,
    4837,  4851,  4852,  4864,  4885,  4896,  4910,  4919,  4931,  4932,
    4935,  4936,  4939,  4940,  4943,  4947,  4951,  4955,  4959,  4963,
    4967,  4971,  4975,  4979,  4983,  4988,  4992,  4996,  5002,  5003,
    5007,  5008,  5009,  5016,  5019,  5020,  5032,  5048,  5064,  5065,
    5073,  5074,  5078,  5079,  5083,  5084,  5088,  5089,  5093,  5094,
    5104,  5116,  5117,  5130,  5138,  5156,  5165,  5177,  5180,  5184,
    5188,  5192,  5199,  5211,  5222,  5225,  5229,  5242,  5252,  5262,
    5272,  5282,  5292,  5302,  5312,  5322,  5332,  5342,  5352,  5362,
    5381,  5393,  5394,  5395,  5396,  5400,  5401,  5405,  5406,  5416,
    5425,  5438,  5439,  5443,  5447,  5455,  5459,  5463,  5470,  5474,
    5479,  5484,  5491,  5498,  5503,  5513,  5526,  5542,  5543,  5548,
    5549,  5553,  5554,  5564,  5574,  5583,  5601,  5622,  5643,  5665,
    5699,  5715,  5716,  5720,  5729,  5744,  5754,  5767,  5768,  5780,
    5789,  5807,  5832,  5850,  5865,  5866,  5870,  5871,  5875,  5876,
    5880,  5881,  5885,  5899,  5903,  5904,  5908,  5909,  5910,  5911,
    5912,  5922,  5934,  5935,  5946,  5969,  6001,  6002,  6003,  6007,
    6009,  6031,  6033,  6035,  6037,  6039,  6044,  6045,  6049,  6050,
    6054,  6066,  6067,  6071,  6080,  6084,  6088,  6093,  6103,  6104,
    6108,  6109,  6113,  6114,  6118,  6119,  6123,  6124,  6125,  6129,
    6133,  6134,  6135,  6139,  6140,  6145,  6146,  6173,  6174,  6175,
    6176,  6177,  6178,  6191,  6202,  6217,  6219,  6224,  6229,  6231,
    6236,  6247,  6248,  6249,  6250,  6261,  6280,  6292,  6305,  6316,
    6327,  6339,  6348,  6356,  6364,  6374,  6384,  6394,  6404,  6414,
    6425,  6435,  6448,  6451,  6452,  6455,  6459,  6466,  6467,  6468,
    6469,  6470,  6471,  6474,  6477,  6478,  6486,  6493,  6494,  6497,
    6499,  6510,  6522,  6534,  6546,  6558,  6587,  6588,  6604,  6620,
    6621,  6625,  6638,  6649,  6658,  6668,  6678,  6679,  6682,  6683,
    6686,  6687,  6688,  6691,  6705,  6710,  6721,  6731,  6744,  6745,
    6749,  6758,  6771,  6782,  6796,  6807,  6830,  6841,  6860,  6871,
    6882,  6893,  6904,  6915,  6926,  6937,  6948,  6959,  6970,  6981,
    6996,  6997,  6998,  6999,  7000,  7001,  7002,  7003,  7004,  7005,
    7006,  7007,  7008,  7018,  7019,  7020,  7021,  7022,  7026,  7027,
    7028,  7029,  7030,  7031,  7032,  7033,  7038,  7039,  7040,  7044,
    7045,  7048,  7049,  7052,  7054,  7059,  7060,  7071,  7083,  7084,
    7085,  7095,  7104,  7113,  7122,  7131,  7140,  7149,  7158,  7167,
    7176,  7190,  7199,  7208,  7217,  7226,  7235,  7244,  7253,  7265,
    7266,  7280,  7291,  7302,  7313,  7324,  7335,  7346,  7357,  7368,
    7379,  7392,  7393,  7396,  7397,  7407,  7414,  7423,  7432,  7441,
    7450,  7459,  7468,  7477,  7486,  7495,  7504,  7513,  7522,  7531,
    7540,  7549,  7558,  7569,  7570,  7573,  7574,  7584,  7602,  7618,
    7646,  7648,  7650,  7652,  7660,  7670,  7671,  7674,  7682,  7690,
    7698,  7705,  7716,  7720,  7727,  7731,  7742,  7751,  7760,  7769,
    7778,  7787,  7796,  7805,  7814,  7823,  7832,  7841,  7850,  7858,
    7867,  7876,  7885,  7894,  7903,  7912,  7921,  7934,  7935,  7939,
    7940,  7945,  7946,  7956,  7967,  7981,  7993,  8011,  8012,  8016,
    8023,  8024,  8025,  8028,  8029,  8039,  8050,  8051,  8055,  8059,
    8063,  8074,  8088,  8103,  8121,  8122,  8123,  8124,  8125,  8126,
    8138,  8170,  8205,  8206,  8210,  8211,  8214,  8215,  8220,  8232,
    8251,  8256,  8261,  8268,  8269,  8272,  8273,  8276,  8277,  8281,
    8282,  8283,  8286,  8287,  8288,  8304,  8318,  8333,  8347,  8364,
    8365,  8368,  8369,  8373,  8374,  8378,  8379,  8384,  8398,  8406,
    8414,  8430,  8431,  8435,  8436,  8451,  8461,  8471,  8481,  8491,
    8504,  8505,  8506,  8507,  8508,  8514,  8518,  8533,  8534,  8540,
    8550,  8554,  8559,  8567,  8609,  8613,  8617,  8621,  8629,  8630,
    8634,  8646,  8647,  8652,  8653,  8658,  8659,  8666,  8670,  8674,
    8678,  8682,  8686,  8690,  8694,  8698,  8702,  8706,  8710,  8714,
    8718,  8722,  8726,  8731,  8738,  8742,  8746,  8750,  8754,  8760,
    8761,  8767,  8777,  8781,  8792,  8798,  8807,  8813,  8814,  8818,
    8819,  8823,  8824,  8827,  8840,  8844,  8859,  8868,  8877,  8890,
    8891,  8896,  8897,  8914,  8925,  8936,  8947,  8958,  8969,  8983,
    8994,  9008,  9019,  9033,  9041,  9043,  9045,  9050,  9052,  9057,
    9058,  9063,  9082,  9092,  9093,  9097,  9101,  9113,  9125,  9137,
    9151,  9152,  9153,  9157,  9170,  9171,  9181,  9194,  9198,  9202,
    9206,  9213,  9235,  9248,  9261,  9276,  9277,  9280,  9281,  9284,
    9285,  9295,  9305,  9323,  9333,  9343,  9353,  9363,  9373,  9383,
    9393,  9403,  9413,  9423,  9433,  9443,  9454,  9465,  9475,  9485,
    9495,  9505,  9515,  9525,  9536,  9547,  9558,  9569,  9580,  9591,
    9602,  9613,  9624,  9635,  9646,  9657,  9669,  9681,  9693,  9705,
    9717,  9729,  9740,  9751,  9763,  9775,  9786,  9797,  9806,  9816,
    9826,  9836,  9846,  9856,  9866,  9876,  9886,  9896,  9911,  9912,
    9915,  9916,  9926,  9936,  9946,  9956,  9967,  9977,  9989,  9990,
   10000, 10010, 10020, 10030, 10040, 10050, 10060, 10070, 10080, 10090,
   10100, 10110, 10120, 10130, 10140, 10150, 10160, 10170, 10180, 10190,
   10200, 10210, 10220, 10230, 10240, 10250, 10260, 10279, 10289, 10290,
   10293, 10295, 10297, 10303, 10304, 10305, 10306, 10307, 10319, 10335,
   10344, 10353, 10362, 10371, 10380, 10389, 10398, 10407, 10416, 10425,
   10434, 10443, 10452, 10461, 10470, 10479, 10488, 10497, 10506, 10515,
   10524, 10533, 10542, 10570, 10578, 10587, 10613, 10622, 10629, 10635,
   10662, 10673, 10682, 10690, 10692, 10714, 10722, 10732, 10742, 10761,
   10780, 10790, 10800, 10810, 10821, 10832, 10843, 10854, 10865, 10883,
   10892, 10909, 10927, 10928, 10929, 10934, 10940, 10949, 10950, 10951,
   10952, 10953, 10957, 10958, 10961, 10962, 10963, 10964, 10968, 10969,
   10970, 10982, 10993, 10994, 10997, 11007, 11014, 11034, 11044, 11053,
   11063, 11073, 11082, 11091, 11100, 11109, 11118, 11127, 11136, 11148,
   11157, 11169, 11170, 11171, 11175, 11178, 11181, 11184, 11187, 11194,
   11196, 11198, 11203, 11205, 11209, 11210, 11211, 11223, 11237, 11251,
   11270, 11292, 11293, 11294, 11295, 11305, 11322, 11333, 11334, 11338,
   11339, 11343, 11347, 11351, 11369, 11370, 11371, 11372, 11373, 11374,
   11375, 11382, 11383, 11394, 11402, 11410, 11419, 11429, 11447, 11456,
   11465, 11474, 11486, 11490, 11501, 11513, 11531, 11538, 11555, 11569,
   11579, 11588, 11597, 11607, 11619, 11631, 11642, 11643, 11654, 11665,
   11677, 11689, 11701, 11713, 11723, 11736, 11737, 11751, 11775, 11784,
   11794, 11806, 11818, 11832, 11833, 11845, 11866, 11877, 11889, 11901,
   11905, 11912, 11913, 11917, 11924, 11925, 11926, 11930, 11931, 11932,
   11936, 11937, 11941, 11942, 11945, 11946, 11949, 11950, 11954, 11955,
   11959, 11966, 11968, 11973, 11974, 11987, 11995, 12006, 12014, 12025,
   12026, 12027, 12028, 12029, 12030, 12031, 12032, 12033, 12034, 12044,
   12055, 12056, 12060, 12061, 12062, 12063, 12064, 12074, 12082, 12100,
   12120, 12121, 12131, 12140, 12149, 12158, 12177, 12195, 12199, 12207,
   12213, 12220, 12226, 12233, 12242, 12243, 12247, 12249, 12254, 12265,
   12275, 12285, 12291, 12300, 12309, 12315, 12316, 12327, 12342, 12343,
   12354, 12365, 12366, 12369, 12370, 12371, 12372, 12373, 12374, 12375,
   12376, 12379, 12380, 12384, 12385, 12386, 12397, 12416, 12417, 12421,
   12426, 12450, 12461, 12462, 12474, 12494, 12495, 12505, 12512, 12519,
   12526, 12536, 12549, 12550, 12554, 12555, 12559, 12560, 12564, 12577,
   12590, 12599, 12608, 12617, 12626, 12638, 12650, 12662, 12665, 12666,
   12667, 12668, 12669, 12670, 12673, 12674, 12675, 12723, 12724, 12728,
   12729, 12744, 12745, 12752, 12760, 12768, 12776, 12784, 12792, 12803,
   12804, 12836, 12852, 12869, 12870, 12889, 12893, 12897, 12912, 12919,
   12926, 12936, 12937, 12940, 12956, 12957, 12958, 12962, 12972, 12983,
   12989, 13001, 13014, 13020, 13021, 13025, 13037, 13045, 13050, 13055,
   13060, 13065, 13073, 13081, 13086, 13091, 13098, 13099, 13103, 13104,
   13105, 13112, 13113, 13117, 13118, 13122, 13123, 13127, 13128, 13132,
   13136, 13137, 13140, 13149, 13162, 13167, 13172, 13176, 13188, 13189,
   13193, 13202, 13218, 13227, 13236, 13245, 13257, 13260, 13265, 13266,
   13274, 13294, 13295, 13297, 13302, 13303, 13307, 13308, 13311, 13312,
   13337, 13346, 13356, 13357, 13361, 13362, 13363, 13364, 13365, 13369,
   13382, 13389, 13396, 13403, 13404, 13408, 13409, 13413, 13414, 13418,
   13419, 13423, 13435, 13436, 13437, 13438, 13442, 13443, 13453, 13460,
   13479, 13480, 13484, 13485, 13491, 13496, 13505, 13513, 13522, 13529,
   13537, 13546, 13555, 13559, 13564, 13571, 13600, 13604, 13618, 13639,
   13661, 13674, 13691, 13697, 13702, 13708, 13715, 13716, 13726, 13732,
   13740, 13744, 13748, 13755, 13763, 13768, 13769, 13770, 13771, 13775,
   13776, 13791, 13795, 13803, 13810, 13817, 13824, 13831, 13842, 13843,
   13856, 13860, 13868, 13882, 13896, 13897, 13912, 13923, 13936, 13941,
   13942, 13945, 13946, 13949, 13950, 13955, 13956, 13961, 13962, 13971,
   13976, 13977, 13981, 13985, 13991, 14016, 14027, 14041, 14042, 14046,
   14060, 14117, 14131, 14133, 14138, 14140, 14142, 14144, 14146, 14151,
   14153, 14158, 14166, 14177, 14205, 14206, 14210, 14212, 14217, 14226,
   14246, 14266, 14284, 14296, 14311, 14312, 14316, 14319, 14332, 14337,
   14344, 14349, 14355, 14360, 14369, 14371, 14374, 14378, 14379, 14380,
   14381, 14382, 14383, 14388, 14394, 14409, 14410, 14411, 14412, 14413,
   14424, 14430, 14438, 14439, 14445, 14450, 14455, 14460, 14465, 14470,
   14475, 14480, 14486, 14492, 14498, 14505, 14527, 14536, 14540, 14548,
   14552, 14560, 14572, 14593, 14597, 14603, 14607, 14620, 14628, 14638,
   14640, 14642, 14644, 14646, 14648, 14653, 14654, 14661, 14670, 14678,
   14687, 14698, 14706, 14707, 14708, 14712, 14714, 14716, 14718, 14720,
   14722, 14724, 14729, 14734, 14740, 14748, 14753, 14760, 14767, 14771,
   14775, 14783, 14818, 14819, 14821, 14830, 14837, 14853, 14855, 14857,
   14859, 14861, 14863, 14865, 14867, 14869, 14871, 14873, 14875, 14877,
   14879, 14882, 14884, 14887, 14889, 14891, 14893, 14896, 14901, 14910,
   14915, 14924, 14929, 14938, 14943, 14953, 14962, 14971, 14980, 14999,
   15008, 15017, 15026, 15035, 15052, 15061, 15070, 15079, 15088, 15097,
   15106, 15110, 15114, 15122, 15130, 15138, 15146, 15167, 15190, 15202,
   15209, 15225, 15230, 15236, 15243, 15250, 15258, 15266, 15283, 15302,
   15328, 15330, 15332, 15334, 15336, 15338, 15340, 15342, 15344, 15346,
   15348, 15350, 15352, 15354, 15356, 15358, 15360, 15362, 15364, 15368,
   15372, 15377, 15393, 15394, 15395, 15412, 15425, 15427, 15429, 15441,
   15466, 15478, 15490, 15498, 15509, 15520, 15530, 15536, 15545, 15555,
   15565, 15578, 15588, 15619, 15655, 15665, 15676, 15677, 15678, 15685,
   15692, 15696, 15700, 15704, 15708, 15712, 15716, 15720, 15724, 15728,
   15732, 15736, 15740, 15747, 15751, 15755, 15759, 15761, 15768, 15775,
   15782, 15789, 15800, 15814, 15824, 15835, 15851, 15861, 15868, 15875,
   15882, 15886, 15894, 15903, 15912, 15916, 15920, 15924, 15928, 15932,
   15941, 15945, 15955, 15959, 15963, 15968, 15979, 15985, 15999, 16010,
   16024, 16040, 16052, 16062, 16071, 16080, 16088, 16110, 16126, 16150,
   16152, 16156, 16158, 16160, 16163, 16166, 16169, 16170, 16173, 16181,
   16191, 16192, 16195, 16196, 16197, 16200, 16201, 16202, 16207, 16211,
   16215, 16219, 16226, 16227, 16235, 16236, 16240, 16241, 16249, 16250,
   16254, 16255, 16260, 16269, 16271, 16286, 16289, 16317, 16318, 16321,
   16322, 16330, 16338, 16346, 16355, 16365, 16383, 16429, 16438, 16447,
   16456, 16465, 16477, 16478, 16479, 16480, 16481, 16495, 16496, 16497,
   16500, 16501, 16504, 16507, 16508, 16509, 16512, 16513, 16516, 16517,
   16518, 16519, 16520, 16521, 16522, 16523, 16524, 16525, 16526, 16527,
   16530, 16532, 16537, 16539, 16544, 16546, 16548, 16550, 16552, 16554,
   16566, 16570, 16577, 16581, 16587, 16591, 16601, 16613, 16614, 16617,
   16618, 16621, 16625, 16629, 16635, 16636, 16641, 16651, 16652, 16653,
   16654, 16655, 16656, 16657, 16658, 16662, 16663, 16664, 16665, 16670,
   16675, 16684, 16705, 16709, 16714, 16725, 16742, 16748, 16749, 16750,
   16753, 16761, 16771, 16786, 16787, 16791, 16803, 16804, 16807, 16808,
   16811, 16815, 16822, 16826, 16830, 16839, 16851, 16852, 16856, 16857,
   16861, 16862, 16865, 16866, 16871, 16872, 16876, 16877, 16881, 16893,
   16894, 16895, 16896, 16897, 16898, 16899, 16900, 16901, 16905, 16907,
   16912, 16913, 16914, 16915, 16916, 16917, 16918, 16920, 16924, 16926,
   16928, 16931, 16935, 16938, 16942, 16951, 16968, 16975, 16980, 16986,
   16987, 16988, 16989, 16990, 16994, 17003, 17017, 17018, 17019, 17020,
   17021, 17030, 17031, 17032, 17033, 17034, 17038, 17040, 17050, 17053,
   17059, 17060, 17061, 17065, 17066, 17067, 17071, 17072, 17076, 17094,
   17114, 17115, 17124, 17125, 17129, 17130, 17133, 17141, 17149, 17157,
   17180, 17181, 17192, 17196, 17202, 17204, 17209, 17211, 17213, 17223,
   17225, 17236, 17240, 17244, 17248, 17252, 17261, 17269, 17301, 17305,
   17312, 17320, 17324, 17328, 17334, 17335, 17337, 17338, 17339, 17343,
   17384, 17412, 17416, 17420, 17426, 17428, 17442, 17478, 17491, 17492,
   17495, 17496, 17513, 17514, 17515, 17520, 17521, 17522, 17527, 17528,
   17529, 17530, 17536, 17537, 17538, 17539, 17540, 17546, 17547, 17567,
   17568, 17569, 17570, 17571, 17572, 17573, 17574, 17575, 17576, 17577,
   17578, 17579, 17580, 17581, 17582, 17583, 17584, 17585, 17586, 17587,
   17588, 17589, 17590, 17591, 17592, 17593, 17594, 17595, 17596, 17597,
   17598, 17599, 17600, 17601, 17602, 17603, 17604, 17605, 17606, 17607,
   17608, 17609, 17610, 17611, 17612, 17613, 17614, 17615, 17616, 17617,
   17618, 17619, 17620, 17621, 17622, 17623, 17624, 17625, 17626, 17627,
   17628, 17629, 17630, 17631, 17632, 17633, 17634, 17635, 17636, 17637,
   17638, 17639, 17640, 17641, 17642, 17643, 17644, 17645, 17646, 17647,
   17648, 17649, 17650, 17651, 17652, 17653, 17654, 17655, 17656, 17657,
   17658, 17659, 17660, 17661, 17662, 17663, 17664, 17665, 17666, 17667,
   17668, 17669, 17670, 17671, 17672, 17673, 17674, 17675, 17676, 17677,
   17678, 17679, 17680, 17681, 17682, 17683, 17684, 17685, 17686, 17687,
   17688, 17689, 17690, 17691, 17692, 17693, 17694, 17695, 17696, 17697,
   17698, 17699, 17700, 17701, 17702, 17703, 17704, 17705, 17706, 17707,
   17708, 17709, 17710, 17711, 17712, 17713, 17714, 17715, 17716, 17717,
   17718, 17719, 17720, 17721, 17722, 17723, 17724, 17725, 17726, 17727,
   17728, 17729, 17730, 17731, 17732, 17733, 17734, 17735, 17736, 17737,
   17738, 17739, 17740, 17741, 17742, 17743, 17744, 17745, 17746, 17747,
   17748, 17749, 17750, 17751, 17752, 17753, 17754, 17755, 17756, 17757,
   17758, 17759, 17760, 17761, 17762, 17763, 17764, 17765, 17766, 17767,
   17768, 17769, 17770, 17771, 17772, 17773, 17774, 17775, 17776, 17777,
   17778, 17779, 17780, 17781, 17782, 17783, 17784, 17785, 17786, 17787,
   17788, 17789, 17790, 17791, 17792, 17793, 17794, 17795, 17796, 17797,
   17798, 17799, 17800, 17801, 17802, 17803, 17804, 17805, 17806, 17807,
   17808, 17809, 17810, 17811, 17812, 17813, 17814, 17815, 17816, 17817,
   17818, 17819, 17820, 17821, 17822, 17823, 17824, 17825, 17826, 17827,
   17828, 17829, 17830, 17831, 17832, 17833, 17834, 17835, 17836, 17837,
   17838, 17839, 17840, 17841, 17842, 17843, 17844, 17845, 17846, 17847,
   17848, 17849, 17850, 17851, 17852, 17853, 17854, 17855, 17856, 17857,
   17858, 17859, 17860, 17861, 17862, 17863, 17864, 17865, 17866, 17867,
   17868, 17869, 17870, 17871, 17872, 17873, 17874, 17875, 17876, 17877,
   17878, 17879, 17880, 17881, 17882, 17883, 17884, 17885, 17886, 17887,
   17888, 17889, 17890, 17891, 17892, 17893, 17894, 17895, 17909, 17910,
   17911, 17912, 17913, 17914, 17915, 17916, 17917, 17918, 17919, 17920,
   17921, 17922, 17923, 17924, 17925, 17926, 17927, 17928, 17929, 17930,
   17931, 17932, 17933, 17934, 17935, 17936, 17937, 17938, 17939, 17940,
   17941, 17942, 17943, 17944, 17945, 17946, 17947, 17948, 17949, 17950,
   17951, 17952, 17953, 17954, 17955, 17956, 17957, 17958, 17959, 17960,
   17961, 17962, 17963, 17964, 17965, 17966, 17967, 17968, 17969, 17970,
   17971, 17985, 17986, 17987, 17988, 17989, 17990, 17991, 17992, 17993,
   17994, 17995, 17996, 17997, 17998, 17999, 18000, 18001, 18002, 18003,
   18004, 18005, 18006, 18007, 18017, 18018, 18019, 18020, 18021, 18022,
   18023, 18024, 18025, 18026, 18027, 18028, 18029, 18030, 18031, 18032,
   18033, 18034, 18035, 18036, 18037, 18038, 18039, 18040, 18041, 18042,
   18043, 18044, 18045, 18046, 18047, 18048, 18049, 18050, 18051, 18052,
   18053, 18054, 18055, 18056, 18057, 18058, 18059, 18060, 18061, 18062,
   18063, 18064, 18065, 18066, 18067, 18068, 18069, 18070, 18071, 18072,
   18073, 18074, 18075, 18076, 18077, 18078, 18079, 18080, 18081, 18082,
   18083, 18084, 18085, 18086, 18087, 18088, 18089, 18090, 18091, 18092,
   18093, 18094, 18107, 18108, 18109, 18110, 18111, 18112, 18113, 18114,
   18115, 18116, 18117, 18118, 18119, 18120, 18121, 18122, 18123, 18124,
   18125, 18126, 18127, 18128, 18129, 18130, 18131, 18132, 18133, 18134,
   18135, 18136, 18137, 18138, 18139, 18140, 18141, 18142, 18143, 18144,
   18145, 18146, 18147, 18148, 18149, 18150, 18151, 18152, 18153, 18154,
   18155, 18156, 18157, 18158, 18159, 18160, 18161, 18162, 18163, 18164,
   18165, 18166, 18167, 18168, 18169, 18170, 18171, 18172, 18173, 18174,
   18175, 18176, 18177, 18178, 18179, 18180, 18181, 18182, 18183, 18184,
   18185, 18186, 18187, 18188, 18189, 18190, 18191, 18192, 18193, 18194,
   18195, 18196, 18197, 18198, 18199, 18200, 18201, 18202, 18203, 18204,
   18205, 18206, 18207, 18208, 18209, 18210, 18211, 18212, 18213, 18214,
   18215, 18216, 18217, 18218, 18219, 18220, 18221, 18222, 18223, 18224,
   18225, 18226, 18227, 18228, 18229, 18230, 18231, 18232, 18233, 18234,
   18235, 18236, 18237, 18238, 18239, 18240, 18241, 18242, 18243, 18244,
   18245, 18246, 18247, 18248, 18249, 18250, 18251, 18252, 18253, 18254,
   18255, 18256, 18257, 18258, 18259, 18260, 18261, 18262, 18263, 18264,
   18265, 18266, 18267, 18268, 18269, 18270, 18271, 18272, 18273, 18274,
   18275, 18276, 18277, 18278, 18279, 18280, 18281, 18282, 18283, 18284,
   18285, 18286, 18287, 18288, 18289, 18290, 18291, 18292, 18293, 18294,
   18295, 18296, 18297, 18298, 18299, 18300, 18301, 18302, 18303, 18304,
   18305, 18306, 18307, 18308, 18309, 18310, 18311, 18312, 18313, 18314,
   18315, 18316, 18317, 18318, 18319, 18320, 18321, 18322, 18323, 18324,
   18325, 18326, 18327, 18328, 18329, 18330, 18331, 18332, 18333, 18334,
   18335, 18336, 18337, 18338, 18339, 18340, 18341, 18342, 18343, 18344,
   18345, 18346, 18347, 18348, 18349, 18350, 18351, 18352, 18353, 18354,
   18355, 18356, 18357, 18358, 18359, 18360, 18361, 18362, 18363, 18364,
   18365, 18366, 18367, 18368, 18369, 18370, 18371, 18372, 18373, 18374,
   18375, 18376, 18377, 18378, 18379, 18380, 18381, 18382, 18383, 18384,
   18385, 18386, 18387, 18388, 18389, 18390, 18391, 18392, 18393, 18394,
   18395, 18396, 18397, 18398, 18399, 18400, 18401, 18402, 18403, 18404,
   18405, 18406, 18407, 18408, 18409, 18410, 18411, 18412, 18413, 18414,
   18415, 18416, 18417, 18418, 18419, 18420, 18421, 18422, 18423, 18424,
   18425, 18426, 18427, 18428, 18429, 18430, 18431, 18432, 18433, 18434,
   18435, 18436, 18437, 18438, 18439, 18440, 18441, 18442, 18443, 18444,
   18445, 18446, 18447, 18448, 18449, 18450, 18451, 18452, 18453, 18454,
   18455, 18456, 18457, 18458, 18459, 18460, 18461, 18462, 18463, 18464,
   18465, 18466, 18467, 18468, 18469, 18470, 18471, 18472, 18473, 18474,
   18475, 18476, 18477, 18478, 18479, 18480, 18481, 18482, 18483, 18484,
   18485, 18486, 18487, 18488, 18489, 18490, 18491, 18492, 18493, 18494,
   18495, 18496, 18497, 18498, 18499, 18500, 18501, 18502, 18503, 18504,
   18505, 18506, 18507, 18508, 18509, 18510, 18511, 18512, 18513, 18514,
   18515, 18516, 18517, 18518, 18519, 18520, 18521, 18522, 18523, 18524,
   18525, 18526, 18527, 18528, 18529, 18530, 18531, 18532, 18533, 18534,
   18535, 18536, 18537, 18538, 18539, 18540, 18541, 18542, 18543, 18544,
   18545, 18546, 18547, 18548, 18549, 18550, 18551, 18552, 18553, 18554,
   18555, 18556, 18557, 18558, 18559, 18560
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENT", "UIDENT", "FCONST", "SCONST",
  "USCONST", "BCONST", "XCONST", "Op", "ICONST", "PARAM", "TYPECAST",
  "DOT_DOT", "COLON_EQUALS", "EQUALS_GREATER", "LESS_EQUALS",
  "GREATER_EQUALS", "NOT_EQUALS", "ABORT_P", "ABSENT", "ABSOLUTE_P",
  "ACCESS", "ACTION", "ADD_P", "ADMIN", "AFTER", "AGGREGATE", "ALL",
  "ALSO", "ALTER", "ALWAYS", "ANALYSE", "ANALYZE", "AND", "ANY", "ARRAY",
  "AS", "ASC", "ASENSITIVE", "ASSERTION", "ASSIGNMENT", "ASYMMETRIC",
  "ATOMIC", "AT", "ATTACH", "ATTRIBUTE", "AUTHORIZATION", "BACKWARD",
  "BEFORE", "BEGIN_P", "BETWEEN", "BIGINT", "BINARY", "BIT", "BOOLEAN_P",
  "BOTH", "BREADTH", "BY", "CACHE", "CALL", "CALLED", "CASCADE",
  "CASCADED", "CASE", "CAST", "CATALOG_P", "CHAIN", "CHAR_P", "CHARACTER",
  "CHARACTERISTICS", "CHECK", "CHECKPOINT", "CLASS", "CLOSE", "CLUSTER",
  "COALESCE", "COLLATE", "COLLATION", "COLUMN", "COLUMNS", "COMMENT",
  "COMMENTS", "COMMIT", "COMMITTED", "COMPRESSION", "CONCURRENTLY",
  "CONDITIONAL", "CONFIGURATION", "CONFLICT", "CONNECTION", "CONSTRAINT",
  "CONSTRAINTS", "CONTENT_P", "CONTINUE_P", "CONVERSION_P", "COPY", "COST",
  "CREATE", "CROSS", "CSV", "CUBE", "CURRENT_P", "CURRENT_CATALOG",
  "CURRENT_DATE", "CURRENT_ROLE", "CURRENT_SCHEMA", "CURRENT_TIME",
  "CURRENT_TIMESTAMP", "CURRENT_USER", "CURSOR", "CYCLE", "DATA_P",
  "DATABASE", "DAY_P", "DEALLOCATE", "DEC", "DECIMAL_P", "DECLARE",
  "DEFAULT", "DEFAULTS", "DEFERRABLE", "DEFERRED", "DEFINER", "DELETE_P",
  "DELIMITER", "DELIMITERS", "DEPENDS", "DEPTH", "DESC", "DETACH",
  "DICTIONARY", "DISABLE_P", "DISCARD", "DISTINCT", "DO", "DOCUMENT_P",
  "DOMAIN_P", "DOUBLE_P", "DROP", "EACH", "ELSE", "EMPTY_P", "ENABLE_P",
  "ENCODING", "ENCRYPTED", "END_P", "ENUM_P", "ERROR_P", "ESCAPE", "EVENT",
  "EXCEPT", "EXCLUDE", "EXCLUDING", "EXCLUSIVE", "EXECUTE", "EXISTS",
  "EXPLAIN", "EXPRESSION", "EXTENSION", "EXTERNAL", "EXTRACT", "FALSE_P",
  "FAMILY", "FETCH", "FILTER", "FINALIZE", "FIRST_P", "FLOAT_P",
  "FOLLOWING", "FOR", "FORCE", "FOREIGN", "FORMAT", "FORWARD", "FREEZE",
  "FROM", "FULL", "FUNCTION", "FUNCTIONS", "GENERATED", "GLOBAL", "GRANT",
  "GRANTED", "GREATEST", "GROUP_P", "GROUPING", "GROUPS", "HANDLER",
  "HAVING", "HEADER_P", "HOLD", "HOUR_P", "IDENTITY_P", "IF_P", "ILIKE",
  "IMMEDIATE", "IMMUTABLE", "IMPLICIT_P", "IMPORT_P", "IN_P", "INCLUDE",
  "INCLUDING", "INCREMENT", "INDENT", "INDEX", "INDEXES", "INHERIT",
  "INHERITS", "INITIALLY", "INLINE_P", "INNER_P", "INOUT", "INPUT_P",
  "INSENSITIVE", "INSERT", "INSTEAD", "INT_P", "INTEGER", "INTERSECT",
  "INTERVAL", "INTO", "INVOKER", "IS", "ISNULL", "ISOLATION", "JOIN",
  "JSON", "JSON_ARRAY", "JSON_ARRAYAGG", "JSON_EXISTS", "JSON_OBJECT",
  "JSON_OBJECTAGG", "JSON_QUERY", "JSON_SCALAR", "JSON_SERIALIZE",
  "JSON_TABLE", "JSON_VALUE", "KEEP", "KEY", "KEYS", "LABEL", "LANGUAGE",
  "LARGE_P", "LAST_P", "LATERAL_P", "LEADING", "LEAKPROOF", "LEAST",
  "LEFT", "LEVEL", "LIKE", "LIMIT", "LISTEN", "LOAD", "LOCAL", "LOCALTIME",
  "LOCALTIMESTAMP", "LOCATION", "LOCK_P", "LOCKED", "LOGGED", "MAPPING",
  "MATCH", "MATCHED", "MATERIALIZED", "MAXVALUE", "MERGE", "MERGE_ACTION",
  "METHOD", "MINUTE_P", "MINVALUE", "MODE", "MONTH_P", "MOVE", "NAME_P",
  "NAMES", "NATIONAL", "NATURAL", "NCHAR", "NESTED", "NEW", "NEXT", "NFC",
  "NFD", "NFKC", "NFKD", "NO", "NONE", "NORMALIZE", "NORMALIZED", "NOT",
  "NOTHING", "NOTIFY", "NOTNULL", "NOWAIT", "NULL_P", "NULLIF", "NULLS_P",
  "NUMERIC", "OBJECT_P", "OF", "OFF", "OFFSET", "OIDS", "OLD", "OMIT",
  "ON", "ONLY", "OPERATOR", "OPTION", "OPTIONS", "OR", "ORDER",
  "ORDINALITY", "OTHERS", "OUT_P", "OUTER_P", "OVER", "OVERLAPS",
  "OVERLAY", "OVERRIDING", "OWNED", "OWNER", "PARALLEL", "PARAMETER",
  "PARSER", "PARTIAL", "PARTITION", "PARTITIONS", "PASSING", "PASSWORD",
  "PATH", "PLACING", "PLAN", "PLANS", "POLICY", "POSITION", "PRECEDING",
  "PRECISION", "PRESERVE", "PREPARE", "PREPARED", "PRIMARY", "PRIOR",
  "PRIVILEGES", "PROCEDURAL", "PROCEDURE", "PROCEDURES", "PROGRAM",
  "PUBLICATION", "QUOTE", "QUOTES", "RANGE", "READ", "REAL", "REASSIGN",
  "RECHECK", "RECURSIVE", "REF_P", "REFERENCES", "REFERENCING", "REFRESH",
  "REINDEX", "RELATIVE_P", "RELEASE", "RENAME", "REPEATABLE", "REPLACE",
  "REPLICA", "RESET", "RESTART", "RESTRICT", "RETURN", "RETURNING",
  "RETURNS", "REVOKE", "RIGHT", "ROLE", "ROLLBACK", "ROLLUP", "ROUTINE",
  "ROUTINES", "ROW", "ROWS", "RULE", "SAVEPOINT", "SCALAR", "SCHEMA",
  "SCHEMAS", "SCROLL", "SEARCH", "SECOND_P", "SECURITY", "SELECT",
  "SEQUENCE", "SEQUENCES", "SERIALIZABLE", "SERVER", "SESSION",
  "SESSION_USER", "SET", "SETS", "SETOF", "SHARE", "SHOW", "SIMILAR",
  "SIMPLE", "SKIP", "SMALLINT", "SNAPSHOT", "SOME", "SPLIT", "SOURCE",
  "SQL_P", "STABLE", "STANDALONE_P", "START", "STATEMENT", "STATISTICS",
  "STDIN", "STDOUT", "STORAGE", "STORED", "STRICT_P", "STRING_P",
  "STRIP_P", "SUBSCRIPTION", "SUBSTRING", "SUPPORT", "SYMMETRIC", "SYSID",
  "SYSTEM_P", "SYSTEM_USER", "TABLE", "TABLES", "TABLESAMPLE",
  "TABLESPACE", "TARGET", "TEMP", "TEMPLATE", "TEMPORARY", "TEXT_P",
  "THEN", "TIES", "TIME", "TIMESTAMP", "TO", "TRAILING", "TRANSACTION",
  "TRANSFORM", "TREAT", "TRIGGER", "TRIM", "TRUE_P", "TRUNCATE", "TRUSTED",
  "TYPE_P", "TYPES_P", "UESCAPE", "UNBOUNDED", "UNCONDITIONAL",
  "UNCOMMITTED", "UNENCRYPTED", "UNION", "UNIQUE", "UNKNOWN", "UNLISTEN",
  "UNLOGGED", "UNTIL", "UPDATE", "USER", "USING", "VACUUM", "VALID",
  "VALIDATE", "VALIDATOR", "VALUE_P", "VALUES", "VARCHAR", "VARIADIC",
  "VARYING", "VERBOSE", "VERSION_P", "VIEW", "VIEWS", "VOLATILE", "WHEN",
  "WHERE", "WHITESPACE_P", "WINDOW", "WITH", "WITHIN", "WITHOUT", "WORK",
  "WRAPPER", "WRITE", "XML_P", "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT",
  "XMLEXISTS", "XMLFOREST", "XMLNAMESPACES", "XMLPARSE", "XMLPI",
  "XMLROOT", "XMLSERIALIZE", "XMLTABLE", "YEAR_P", "YES_P", "ZONE",
  "FORMAT_LA", "NOT_LA", "NULLS_LA", "WITH_LA", "WITHOUT_LA",
  "MODE_TYPE_NAME", "MODE_PLPGSQL_EXPR", "MODE_PLPGSQL_ASSIGN1",
  "MODE_PLPGSQL_ASSIGN2", "MODE_PLPGSQL_ASSIGN3", "'<'", "'>'", "'='",
  "'+'", "'-'", "'*'", "'/'", "'%'", "'^'", "UMINUS", "'['", "']'", "'('",
  "')'", "'.'", "';'", "','", "':'", "$accept", "parse_toplevel",
  "stmtmulti", "toplevel_stmt", "stmt", "opt_single_name",
  "opt_qualified_name", "opt_concurrently", "opt_drop_behavior",
  "CallStmt", "CreateRoleStmt", "opt_with", "OptRoleList",
  "AlterOptRoleList", "AlterOptRoleElem", "CreateOptRoleElem",
  "CreateUserStmt", "AlterRoleStmt", "opt_in_database", "AlterRoleSetStmt",
  "DropRoleStmt", "CreateGroupStmt", "AlterGroupStmt", "add_drop",
  "CreateSchemaStmt", "OptSchemaEltList", "schema_stmt", "VariableSetStmt",
  "set_rest", "generic_set", "set_rest_more", "var_name", "var_list",
  "var_value", "iso_level", "opt_boolean_or_string", "zone_value",
  "opt_encoding", "NonReservedWord_or_Sconst", "VariableResetStmt",
  "reset_rest", "generic_reset", "SetResetClause",
  "FunctionSetResetClause", "VariableShowStmt", "ConstraintsSetStmt",
  "constraints_set_list", "constraints_set_mode", "CheckPointStmt",
  "DiscardStmt", "AlterTableStmt", "alter_table_cmds", "partitions_list",
  "SinglePartitionSpec", "partition_cmd", "index_partition_cmd",
  "alter_table_cmd", "alter_column_default", "opt_collate_clause",
  "alter_using", "replica_identity", "reloptions", "opt_reloptions",
  "reloption_list", "reloption_elem", "alter_identity_column_option_list",
  "alter_identity_column_option", "set_statistics_value",
  "set_access_method_name", "PartitionBoundSpec", "hash_partbound_elem",
  "hash_partbound", "AlterCompositeTypeStmt", "alter_type_cmds",
  "alter_type_cmd", "ClosePortalStmt", "CopyStmt", "copy_from",
  "opt_program", "copy_file_name", "copy_options", "copy_opt_list",
  "copy_opt_item", "opt_binary", "copy_delimiter", "opt_using",
  "copy_generic_opt_list", "copy_generic_opt_elem", "copy_generic_opt_arg",
  "copy_generic_opt_arg_list", "copy_generic_opt_arg_list_item",
  "CreateStmt", "OptTemp", "OptTableElementList",
  "OptTypedTableElementList", "TableElementList", "TypedTableElementList",
  "TableElement", "TypedTableElement", "columnDef", "columnOptions",
  "column_compression", "opt_column_compression", "column_storage",
  "opt_column_storage", "ColQualList", "ColConstraint",
  "ColConstraintElem", "opt_unique_null_treatment", "generated_when",
  "ConstraintAttr", "TableLikeClause", "TableLikeOptionList",
  "TableLikeOption", "TableConstraint", "ConstraintElem",
  "DomainConstraint", "DomainConstraintElem", "opt_no_inherit",
  "opt_column_list", "columnList", "columnElem", "opt_c_include",
  "key_match", "ExclusionConstraintList", "ExclusionConstraintElem",
  "OptWhereClause", "key_actions", "key_update", "key_delete",
  "key_action", "OptInherit", "OptPartitionSpec", "PartitionSpec",
  "part_params", "part_elem", "table_access_method_clause", "OptWith",
  "OnCommitOption", "OptTableSpace", "OptConsTableSpace", "ExistingIndex",
  "CreateStatsStmt", "stats_params", "stats_param", "AlterStatsStmt",
  "CreateAsStmt", "create_as_target", "opt_with_data", "CreateMatViewStmt",
  "create_mv_target", "OptNoLog", "RefreshMatViewStmt", "CreateSeqStmt",
  "AlterSeqStmt", "OptSeqOptList", "OptParenthesizedSeqOptList",
  "SeqOptList", "SeqOptElem", "opt_by", "NumericOnly", "NumericOnly_list",
  "CreatePLangStmt", "opt_trusted", "handler_name", "opt_inline_handler",
  "validator_clause", "opt_validator", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateExtensionStmt", "create_extension_opt_list",
  "create_extension_opt_item", "AlterExtensionStmt",
  "alter_extension_opt_list", "alter_extension_opt_item",
  "AlterExtensionContentsStmt", "CreateFdwStmt", "fdw_option",
  "fdw_options", "opt_fdw_options", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "AlterForeignServerStmt",
  "CreateForeignTableStmt", "ImportForeignSchemaStmt",
  "import_qualification_type", "import_qualification",
  "CreateUserMappingStmt", "auth_ident", "DropUserMappingStmt",
  "AlterUserMappingStmt", "CreatePolicyStmt", "AlterPolicyStmt",
  "RowSecurityOptionalExpr", "RowSecurityOptionalWithCheck",
  "RowSecurityDefaultToRole", "RowSecurityOptionalToRole",
  "RowSecurityDefaultPermissive", "RowSecurityDefaultForCmd",
  "row_security_cmd", "CreateAmStmt", "am_type", "CreateTrigStmt",
  "TriggerActionTime", "TriggerEvents", "TriggerOneEvent",
  "TriggerReferencing", "TriggerTransitions", "TriggerTransition",
  "TransitionOldOrNew", "TransitionRowOrTable", "TransitionRelName",
  "TriggerForSpec", "TriggerForOptEach", "TriggerForType", "TriggerWhen",
  "FUNCTION_or_PROCEDURE", "TriggerFuncArgs", "TriggerFuncArg",
  "OptConstrFromTable", "ConstraintAttributeSpec",
  "ConstraintAttributeElem", "CreateEventTrigStmt",
  "event_trigger_when_list", "event_trigger_when_item",
  "event_trigger_value_list", "AlterEventTrigStmt", "enable_trigger",
  "CreateAssertionStmt", "DefineStmt", "definition", "def_list",
  "def_elem", "def_arg", "old_aggr_definition", "old_aggr_list",
  "old_aggr_elem", "opt_enum_val_list", "enum_val_list", "AlterEnumStmt",
  "opt_if_not_exists", "CreateOpClassStmt", "opclass_item_list",
  "opclass_item", "opt_default", "opt_opfamily", "opclass_purpose",
  "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "object_type_any_name", "object_type_name", "drop_type_name",
  "object_type_name_on_any_name", "any_name_list", "any_name", "attrs",
  "type_name_list", "TruncateStmt", "opt_restart_seqs", "CommentStmt",
  "comment_text", "SecLabelStmt", "opt_provider", "security_label",
  "FetchStmt", "fetch_args", "from_in", "opt_from_in", "GrantStmt",
  "RevokeStmt", "privileges", "privilege_list", "privilege",
  "parameter_name_list", "parameter_name", "privilege_target",
  "grantee_list", "grantee", "opt_grant_grant_option", "GrantRoleStmt",
  "RevokeRoleStmt", "grant_role_opt_list", "grant_role_opt",
  "grant_role_opt_value", "opt_granted_by", "AlterDefaultPrivilegesStmt",
  "DefACLOptionList", "DefACLOption", "DefACLAction",
  "defacl_privilege_target", "IndexStmt", "opt_unique",
  "access_method_clause", "index_params", "index_elem_options",
  "index_elem", "opt_include", "index_including_params", "opt_collate",
  "opt_asc_desc", "opt_nulls_order", "CreateFunctionStmt",
  "opt_or_replace", "func_args", "func_args_list",
  "function_with_argtypes_list", "function_with_argtypes",
  "func_args_with_defaults", "func_args_with_defaults_list", "func_arg",
  "arg_class", "param_name", "func_return", "func_type",
  "func_arg_with_default", "aggr_arg", "aggr_args", "aggr_args_list",
  "aggregate_with_argtypes", "aggregate_with_argtypes_list",
  "opt_createfunc_opt_list", "createfunc_opt_list", "common_func_opt_item",
  "createfunc_opt_item", "func_as", "ReturnStmt", "opt_routine_body",
  "routine_body_stmt_list", "routine_body_stmt", "transform_type_list",
  "opt_definition", "table_func_column", "table_func_column_list",
  "AlterFunctionStmt", "alterfunc_opt_list", "opt_restrict",
  "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt", "oper_argtypes",
  "any_operator", "operator_with_argtypes_list", "operator_with_argtypes",
  "DoStmt", "dostmt_opt_list", "dostmt_opt_item", "CreateCastStmt",
  "cast_context", "DropCastStmt", "opt_if_exists", "CreateTransformStmt",
  "transform_element_list", "DropTransformStmt", "ReindexStmt",
  "reindex_target_relation", "reindex_target_all",
  "opt_reindex_option_list", "AlterTblSpcStmt", "RenameStmt", "opt_column",
  "opt_set_data", "AlterObjectDependsStmt", "opt_no",
  "AlterObjectSchemaStmt", "AlterOperatorStmt", "operator_def_list",
  "operator_def_elem", "operator_def_arg", "AlterTypeStmt",
  "AlterOwnerStmt", "CreatePublicationStmt", "PublicationObjSpec",
  "pub_obj_list", "AlterPublicationStmt", "CreateSubscriptionStmt",
  "AlterSubscriptionStmt", "DropSubscriptionStmt", "RuleStmt",
  "RuleActionList", "RuleActionMulti", "RuleActionStmt",
  "RuleActionStmtOrEmpty", "event", "opt_instead", "NotifyStmt",
  "notify_payload", "ListenStmt", "UnlistenStmt", "TransactionStmt",
  "TransactionStmtLegacy", "opt_transaction", "transaction_mode_item",
  "transaction_mode_list", "transaction_mode_list_or_empty",
  "opt_transaction_chain", "ViewStmt", "opt_check_option", "LoadStmt",
  "CreatedbStmt", "createdb_opt_list", "createdb_opt_items",
  "createdb_opt_item", "createdb_opt_name", "opt_equal",
  "AlterDatabaseStmt", "AlterDatabaseSetStmt", "DropdbStmt",
  "drop_option_list", "drop_option", "AlterCollationStmt",
  "AlterSystemStmt", "CreateDomainStmt", "AlterDomainStmt", "opt_as",
  "AlterTSDictionaryStmt", "AlterTSConfigurationStmt", "any_with",
  "CreateConversionStmt", "ClusterStmt", "cluster_index_specification",
  "VacuumStmt", "AnalyzeStmt", "utility_option_list", "analyze_keyword",
  "utility_option_elem", "utility_option_name", "utility_option_arg",
  "opt_analyze", "opt_verbose", "opt_full", "opt_freeze", "opt_name_list",
  "vacuum_relation", "vacuum_relation_list", "opt_vacuum_relation_list",
  "ExplainStmt", "ExplainableStmt", "PrepareStmt", "prep_type_clause",
  "PreparableStmt", "ExecuteStmt", "execute_param_clause",
  "DeallocateStmt", "InsertStmt", "insert_target", "insert_rest",
  "override_kind", "insert_column_list", "insert_column_item",
  "opt_on_conflict", "opt_conf_expr", "returning_clause", "DeleteStmt",
  "using_clause", "LockStmt", "opt_lock", "lock_type", "opt_nowait",
  "opt_nowait_or_skip", "UpdateStmt", "set_clause_list", "set_clause",
  "set_target", "set_target_list", "MergeStmt", "merge_when_list",
  "merge_when_clause", "merge_when_tgt_matched",
  "merge_when_tgt_not_matched", "opt_merge_when_condition", "merge_update",
  "merge_delete", "merge_insert", "merge_values_clause",
  "DeclareCursorStmt", "cursor_name", "cursor_options", "opt_hold",
  "SelectStmt", "select_with_parens", "select_no_parens", "select_clause",
  "simple_select", "with_clause", "cte_list", "common_table_expr",
  "opt_materialized", "opt_search_clause", "opt_cycle_clause",
  "opt_with_clause", "into_clause", "OptTempTableName", "opt_table",
  "set_quantifier", "distinct_clause", "opt_all_clause",
  "opt_distinct_clause", "opt_sort_clause", "sort_clause", "sortby_list",
  "sortby", "select_limit", "opt_select_limit", "limit_clause",
  "offset_clause", "select_limit_value", "select_offset_value",
  "select_fetch_first_value", "I_or_F_const", "row_or_rows",
  "first_or_next", "group_clause", "group_by_list", "group_by_item",
  "empty_grouping_set", "rollup_clause", "cube_clause",
  "grouping_sets_clause", "having_clause", "for_locking_clause",
  "opt_for_locking_clause", "for_locking_items", "for_locking_item",
  "for_locking_strength", "locked_rels_list", "values_clause",
  "from_clause", "from_list", "table_ref", "joined_table", "alias_clause",
  "opt_alias_clause", "opt_alias_clause_for_join_using",
  "func_alias_clause", "join_type", "opt_outer", "join_qual",
  "relation_expr", "extended_relation_expr", "relation_expr_list",
  "relation_expr_opt_alias", "tablesample_clause", "opt_repeatable_clause",
  "func_table", "rowsfrom_item", "rowsfrom_list", "opt_col_def_list",
  "opt_ordinality", "where_clause", "where_or_current_clause",
  "OptTableFuncElementList", "TableFuncElementList", "TableFuncElement",
  "xmltable", "xmltable_column_list", "xmltable_column_el",
  "xmltable_column_option_list", "xmltable_column_option_el",
  "xml_namespace_list", "xml_namespace_el", "json_table",
  "json_table_path_name_opt", "json_table_column_definition_list",
  "json_table_column_definition", "path_opt",
  "json_table_column_path_clause_opt", "Typename", "opt_array_bounds",
  "SimpleTypename", "ConstTypename", "GenericType", "opt_type_modifiers",
  "Numeric", "opt_float", "Bit", "ConstBit", "BitWithLength",
  "BitWithoutLength", "Character", "ConstCharacter", "CharacterWithLength",
  "CharacterWithoutLength", "character", "opt_varying", "ConstDatetime",
  "ConstInterval", "opt_timezone", "opt_interval", "interval_second",
  "JsonType", "a_expr", "b_expr", "c_expr", "func_application",
  "func_expr", "func_expr_windowless", "func_expr_common_subexpr",
  "xml_root_version", "opt_xml_root_standalone", "xml_attributes",
  "xml_attribute_list", "xml_attribute_el", "document_or_content",
  "xml_indent_option", "xml_whitespace_option", "xmlexists_argument",
  "xml_passing_mech", "within_group_clause", "filter_clause",
  "window_clause", "window_definition_list", "window_definition",
  "over_clause", "window_specification", "opt_existing_window_name",
  "opt_partition_clause", "opt_frame_clause", "frame_extent",
  "frame_bound", "opt_window_exclusion_clause", "row", "explicit_row",
  "implicit_row", "sub_type", "all_Op", "MathOp", "qual_Op", "qual_all_Op",
  "subquery_Op", "expr_list", "func_arg_list", "func_arg_expr",
  "func_arg_list_opt", "type_list", "array_expr", "array_expr_list",
  "extract_list", "extract_arg", "unicode_normal_form", "overlay_list",
  "position_list", "substr_list", "trim_list", "in_expr", "case_expr",
  "when_clause_list", "when_clause", "case_default", "case_arg",
  "columnref", "indirection_el", "opt_slice_bound", "indirection",
  "opt_indirection", "opt_asymmetric", "json_passing_clause_opt",
  "json_arguments", "json_argument", "json_wrapper_behavior",
  "json_behavior", "json_behavior_type", "json_behavior_clause_opt",
  "json_on_error_clause_opt", "json_value_expr", "json_format_clause",
  "json_format_clause_opt", "json_quotes_clause_opt",
  "json_returning_clause_opt", "json_predicate_type_constraint",
  "json_key_uniqueness_constraint_opt", "json_name_and_value_list",
  "json_name_and_value", "json_object_constructor_null_clause_opt",
  "json_array_constructor_null_clause_opt", "json_value_expr_list",
  "json_aggregate_func", "json_array_aggregate_order_by_clause_opt",
  "opt_target_list", "target_list", "target_el", "qualified_name_list",
  "qualified_name", "name_list", "name", "attr_name", "file_name",
  "func_name", "AexprConst", "Iconst", "Sconst", "SignedIconst", "RoleId",
  "RoleSpec", "role_list", "PLpgSQL_Expr", "PLAssignStmt",
  "plassign_target", "plassign_equals", "ColId", "type_function_name",
  "NonReservedWord", "ColLabel", "BareColLabel", "unreserved_keyword",
  "col_name_keyword", "type_func_name_keyword", "reserved_keyword",
  "bare_label_keyword", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,   756,   757,   758,   759,   760,   761,   762,   763,   764,
     765,   766,   767,   768,   769,   770,   771,   772,   773,   774,
     775,   776,   777,    60,    62,    61,    43,    45,    42,    47,
      37,    94,   778,    91,    93,    40,    41,    46,    59,    44,
      58
};
# endif

#define YYPACT_NINF -5894

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-5894)))

#define YYTABLE_NINF -2993

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-2993)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const int yypact[] =
{
   13161,  1621, 20375, -5894, -5894,  1621, 73099, -5894, 82789,  1352,
     908,  1356,   223, 20850, 83299, 94009,   710,   409, 21342,  1621,
   94009,  1433, 63408, 78709,  1084, 94009,  1271,   980, 63408, 94009,
   94519,  1205,  1460,  1031, 95029, 83809, 77179,  1493, 94009,  1495,
     435, 95539, 84319,  1342, 84829,   980, 58319,   424,  1286, 96049,
   94009,120445,   435, 85339, 85339, 85339,  2213,  1876,  1392, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894,  1501, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894,  1962, -5894,  1365,
    2507,  1864,   429,  1706, -5894, -5894,  1964, 73099, 94009, 94009,
   94009,  2047, 94009,  1950, 94009,   978, 73099, 69529, 85849,  2135,
    1960, 54123, 96559, -5894, 73099, 94009, 66979, 73099, 94009, 94009,
   97069, 94009, 97579, 94009,   147, 81259, 94009,  2099, 94009, 94009,
   67489, 98089,  2263,  1764,   275, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894,  1982,  1961, -5894,   293, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, 63918, 94009, 12914,  1271,  1964, -5894,
    2213, 94009,  2251, 94009,  1994, 98599, 94009, -5894, 94009,  2086,
   99109,   996,   775, 69529,  2178, 54652,  2191, 94009, 94009, 69529,
   99619,100129,100639, 94009, 94009, -5894, -5894,  2155, 94009, -5894,
    2286, 70039,   103,  2329,  2503,  2397,  1192, -5894, 86359, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, 72589,   409, -5894,
   -5894,  2349, 73609,  2434, -5894, -5894,101149,120941,  2185, -5894,
    1000, 74119, 70549,  2588,  2194, 55181,  2669, -5894, 74629, -5894,
   71059, 75139, -5894, -5894, -5894, -5894, -5894,101659, -5894,102169,
    2297,  2434, -5894,121437, 71569, -5894,  2498,102679,103189,103699,
    1964,  2228,  1735,  2216, 48405, -5894, -5894, -5894,  2292, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,   382,  2016,
     352,   262,   356, -5894, -5894,   265,   267,   271,   382,  2770,
    2770, -5894, 94009, -5894, -5894,  2016,    74,  2381,  2284,  2284,
    2284,  2549,    17, -5894,  2284,  2410, -5894, -5894, -5894, -5894,
   84829, -5894,  2328,  1271,  2353,  2844,  2445, 63918,  1085, 94009,
   -5894, -5894,  2888,  2444,  2736,  2413, -5894, -5894, -5894,  2679,
    2714,   174,   797,  1271,   420, -5894,  2830, -5894,  2727, 33219,
   33219,  1271, 86869,104209,   347, 72589,  1271, 87379,  2537,  1564,
    2751, -5894, -5894, -5894,   938, -5894,  3020,  2561,  2854,  2413,
    1764, 50469, -5894, -5894,  2556,  1961, 84829, -5894, -5894, -5894,
   63918,  2923, 36387, 94009,  2565, -5894,  2606,  2565, -5894, -5894,
    2665, -5894,  2665,  2665,  2621,  2621,  2860,  2659, -5894, -5894,
   -5894, -5894,  2555,  2665,  2621, -5894,122429, -5894,  1995,  2049,
   -5894, -5894,  3169, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894,  2706, -5894,  1343, -5894,     0, -5894, -5894, -5894, 33219,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894,  2678,  2718,  1864,
   -5894,  6502, 63918, 94009,   450,   450,  3202,   450,  1795,  2043,
   -5894,  2695, -5894,  3089,  3050,  3056, 84829,  2777,  1109, -5894,
    1889,  2784,  2054,  2753,  2018,  2108, -5894,   993, 94009,   301,
    2806, 87889, 10022,  2786,  1961,  2797, -5894, -5894, -5894, -5894,
    2939,   436, -5894, -5894, -5894, -5894,  3136,  3195,  6683,   361,
   88399, -5894, -5894, -5894, -5894, 94009, 94009, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894,  2821,   824, -5894, -5894,
    2833,  3201,  3064, 10154,  1455,  3180,  3018,  1440, 10294,  3082,
    1750,  3234,  8798,  1638,  3236,  2045,  2363, 88909, 94009,  3194,
    3242,  4266,  1786,   973,  3092,  1551,  3180,  3231,  3034,  1440,
    3247,  7067, 94009, -5894,  3154,  3284,  1159, -5894,   203, -5894,
   25882, 36387, 57809, -5894,  1961, -5894,  1778, -5894, -5894, 62898,
   -5894,  2935,  3101,   922, 73099,  2876, 94009, 94009, -5894,120445,
   73099, -5894,  3111, 55710, 73099, -5894, 73099, -5894, -5894,  3244,
  120445, 94009, 94009, -5894, 94009, -5894, -5894,  2877, -5894, -5894,
   -5894, -5894, -5894,  2284, 94009,  3345,120445,  3126,   173,  1923,
    3385, 94009,  3128,  1923,  2929,104719, -5894, -5894,  1923, -5894,
   -5894, -5894, 94009, 94009,  2893,  2600,  3125,   893,  1923,  3145,
    3390,  3401,  3156,  2992,  3160,  2606, -5894,  3362,  3130,  1274,
     241,  2248,  1923,  2970,105229,105739, 94009,  2971, 94009,  3370,
   73099,  3005, 73099, 73099, 94009,  3288, 94009, -5894,  3113, -5894,
   -5894,  1494, -5894, -5894, -5894, -5894, -5894,  3304, -5894,   244,
    3307,  2931,  3310,  1894,  3313,   336, -5894, -5894,  2975, -5894,
    3315,   341, -5894,  3323, -5894,  2942,106249, -5894,106759,107269,
    3328,   383, -5894, 69529,  3329,   341,  3331,  2942,  3333,   341,
    3336,  1037,  3337, -5894,  1301,  3324,  3339,   336,  3340,  2253,
    2942, -5894,  3342,   471, -5894,  3343,   591, -5894,  3346,  3198,
   -5894, 36387, -5894,  3072, -5894,  1286,  2004,  2216,  2016, -5894,
   94009,  2016, 94009,  2016, 94009,  2016, 94009,  2016, 94009, 94009,
   94009,  2016, -5894, -5894, -5894, 94009,  2974, 94009, -5894, 94009,
   -5894, -5894, -5894, 79729, 69529, 80239, -5894, 94009, -5894,   477,
    1271, -5894, -5894,120445,  3473, 69529,  3370,  2094, -5894, -5894,
    3370, -5894, -5894,  3370,  3370, -5894, -5894, -5894,  3261, 94009,
    3347, 79729, 69529,  3348, -5894,107779, -5894, 72589,  3205,  2979,
   -5894, -5894, -5894, -5894, -5894,  1830,  3511,   263,  3515, 36387,
    2987,   263,   263,  2990,  3357, -5894, -5894, -5894,   296,  2995,
    3002, -5894,   290,   290, -5894,  3013,  3014, -5894,   295,  3016,
    3021,  3544,  3547,   307,   308,  3022,  3027,  3028,  3029,  3030,
    3031,  3033,  3036,  3037,  3040,  3041,  3045,  3046,  2555,   263,
    3047, 36387, -5894,  3048,   290,  3049,  3051,  3053,  3549,  3060,
   -5894,  3563,  3062, -5894,   252,   258,  3066,  3067, -5894,  3286,
   -5894,   310,  3069,  3070,  3071,  3075,  3076,  3078,  3079,  3080,
   36387, 36387, 36387, -5894, 30574,  1961,  1271, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894,   311, -5894, 52536, -5894,  3106,
   -5894, -5894,  3287, -5894, -5894, 36387, -5894, -5894,  3450,   839,
   -5894,   312, -5894, -5894, -5894,  1961,  3395,  3081, -5894, -5894,
     370,  3083, -5894,   474, -5894, -5894, -5894, -5894, -5894, -5894,
   72079,  3581, -5894,   365,  1271,   203,  2089,  3518, 61368, 61878,
   -5894, -5894,  3372, -5894, 94009, -5894, -5894,  1961,   232,  2118,
   -5894,  2292, 20524,  2129,  2565, 94009, 94009,  3586, -5894,  3090,
   -5894, -5894, 36387, -5894, -5894, -5894,  2770, -5894,  2665,  2665,
   -5894, -5894,  3589,  3182,  3183,  2770, -5894,  2770, -5894,  3097,
    3098,  2770,  3185,  3186,  3187, -5894,  3102,  3192,  2770, -5894,
   -5894, 64939,  2046, -5894,  3465,   392, -5894, -5894, -5894,  2130,
   -5894,  3107, -5894,  2606, -5894, -5894,  1864,  1864, 36387,  1864,
     998,  1855, 33747, 36915,  3474,  3349,  1370,  1676,  3478, -5894,
    3352,  1795,  2043, 84829, 94009, 84829,108289,  3248, 36387, -5894,
    3583,  3207,  3209,  3269, 60359, -5894,  3212,  3179,  3217,  3277,
    3132,  3219,  3222,  3282, -5894,  3419, -5894, -5894,  3227,  3594,
    3228,108799, -5894, -5894,   325, -5894, -5894, -5894,   325, -5894,
    3153,  1594,  1669,  1605,  3232,   417,  1220,  3590, -5894,  1416,
   -5894, -5894,  3294, -5894, 13379, 94009,  3528,  7323,  3378,   361,
    3293, -5894, -5894, -5894,  3440,  3241, 94009,  3245,  3393,   361,
     372,109309, -5894, -5894, 94009, -5894, -5894, -5894, -5894,  3400,
    3566, 29052, -5894,  2080,  3258,  3223,  3271, 94009, 76159,  2227,
    3367,  3399,  1924,  2279,   971,  3326, 94009,   342,  3410, 94009,
    3181,  3266,  3267,  3523,  3184,   590,  3628,  3188, -5894, -5894,
   -5894,  3593, -5894,  2546,  2580,  3398, -5894,  3522,  3567,  7414,
    3253,  3255,118461, -5894,  3281,    62, 56239, 94009, 94009,  3283,
    3285,109819,  3400,  3602, 80749, 80749,  3289,  3290, 49953,  3618,
     149,  3295, -5894, -5894, -5894,   149,  3297,  3298,110329,  3400,
    3607, 94009,  3299,  3300, 94009,122429,   361, -5894,  3677,   361,
     361,  2112,  3682,  3301,   377,  3466,  1002,  1923,  3188,  3001,
   -5894,  3309,  3311,   358, -5894,  3448, 94009,  3314,  3317,  1596,
    3412,  1271, -5894,  3415, -5894,  3321,  3421,  3322,  1119,  2893,
   -5894, -5894,   742,  3344, 84829,  3432,  3445,  3447,   342,   411,
    1004,  3449,  3188, -5894,  3335,  3338,  3184,  3184, 94009, 94009,
   94009, 94009, 94009,   237,  3734,   286,  3341,   259,    64,  3249,
   -5894,   149, 67999,  3350, -5894,   149, 94009,   353,  1076,  3188,
    1913,  1835, -5894, -5894, -5894,  1764, -5894, 36387, 36387, 36387,
    3251, -5894,  2738, 20524,    92, -5894,   313,  9735,  3250, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, 94009, 63918, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, 94009, -5894, 94009,  3560,120445,
    3568,  3483,  3569,  3573,   361, 94009, 94009,  3576,  3577,  3579,
  120445,  3580,  3582,  3584,  3499,  3361,   202,  3353,  3275,  3774,
    3656, 94009, 64939, -5894,   325, -5894,120445,  3506,  3658, -5894,
   94009,  3525,    83, -5894,  3698,  3354, -5894, -5894,    95, 94009,
   79219,  2893, -5894, -5894,  3662, 69529,   389,  3664,  1271,  3355,
    3665,  3516,  1271, 69529,  3564, 94009, 94009, 94009, 94009,   187,
   -5894, 67999,  3534, -5894, 94009,  3536,  3001,  3539,  3794,   107,
    2284,110839,  3663, -5894,111349,  3302, 94009,  3303,  3303,  3795,
  120445,   407,  3597, -5894, -5894,  2205, -5894,  3456, -5894, 73099,
   -5894, -5894, 73099, -5894, -5894,120445, 94009,  3306,120445,120445,
   -5894, -5894, 73099, 73099, -5894, 69529, 69529,  3679,   471,  3701,
    3386,  3703,  3388, 56239, 56239, -5894,   622, 73099, -5894, 69529,
   73099, -5894, 94009, -5894, 94009, -5894, -5894, -5894, -5894,120445,
  120445, -5894, 69529, 67999,  3705, 94009, 94009, -5894, 94009, 94009,
   -5894, 94009, 94009,  2141,111859,  2216, -5894, 94009, -5894, 94009,
   -5894, 94009, -5894, 94009, -5894, 94009, -5894, -5894, -5894, 94009,
   -5894, 94009,  2147, -5894, -5894,  2152,  1323, 94009, 94009,   913,
   73099, 94009,  3562, 94009, 73099, 73099, 94009, 94009, 94009, 94009,
   94009,  3416,  3083,   833, -5894,   334,  1020, 84829,  3571, -5894,
   -5894,  2183,  2213,    54, 94009, -5894, 94009, 94009, 94009, -5894,
   -5894, 78709,  3691,   493, 80239, 94009, -5894, -5894, 17869, 36387,
    1961, 32686, -5894, -5894, 20524,  3381, 36387, 36387,  3356,  2770,
    2770, -5894,  1259, 36387, 36387, 36387, 30046, 36387, 36387, 34275,
   36387, 36387, 36387, 36387, 36387, 36387,  2770,  2770,  3334, 36387,
    3015, 36387, 56239, 36387, 42195, 26950, 36387, 36387, 31102,   982,
    3013, 36387,  3595, 43245, 36387,  2089,  3596, 36387,  2089,  3015,
    3860,  3860,  1373,  7949,  3358,  1961, -5894,  2770,   234, -5894,
     444,120445, 36387, 36387, 36387, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   36387, -5894, 64939, -5894, -5894, -5894, -5894, -5894, -5894,   948,
   -5894, -5894, -5894, -5894, -5894, -5894,  3491, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   94009, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, 31630, -5894, -5894,
   -5894, -5894,  3359, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894,  2996, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, 32158, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894,  3360, -5894, -5894, 36387, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894,  3426, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894,  1036, 36387, 36387, 36387, 36387, 36387, 36387, 36387,
   36387, 36387, -5894, 36387,   446, -5894, -5894,  3689,  3450,    66,
     551,  3363,  3574, 89419, 33219,  3465, 25882, -5894,   253,  3465,
   -5894, -5894, -5894, 94009,  3581, -5894, -5894,  3436, -5894, -5894,
   -5894, -5894, -5894,   314, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894,  3364, -5894, -5894, -5894, -5894,  3364, -5894,  3365,  3696,
    3702,  1037, 94009,  2879, 36387,   948,   305, 94009, 36387,  3359,
    2996, 36387,  3360, 36387,  3426, -5894, 36387, -5894,  2199,  2083,
   36387,  2200,  3366, -5894, -5894,  3371,  3098,  3380,  3387,  3369,
    3373,  2770,   257,  3374,  1545,   189,  3513,  2770,  3633,  3375,
   -5894, 64939, -5894, 45309,  3427, -5894, -5894, -5894,   435, 94009,
   94009, -5894,  3688, -5894,  3376, -5894, 15552,  3688, -5894, -5894,
   42720,  3514,  3678,  3611, -5894, -5894, -5894,  3384, 20524, 37443,
   37443, -5894,  2630, 20524,  2732, -5894, -5894, -5894, -5894, -5894,
   -5894,   170, -5894, 94009,   873,  3474,  1676,  3451,  1128,  3883,
    3452, 94009, -5894, 50985,  2204, -5894, 69529, 94009, 94009,  3609,
   -5894,  3868, -5894,122429, -5894,  3392, -5894,121933,117469, -5894,
   -5894,   100, -5894,  1122, 69529, -5894, 94009, 94009, 69529, 94009,
   94009, -5894, 69529,  3446, 94009, 94009, -5894, -5894, -5894, -5894,
   -5894, 62388,   102, 78709,  3540, 77689, -5894, -5894,  3396, 94009,
    3638, -5894, -5894,112369, -5894,  3639, 69529, 94009, 94009, 36387,
    3640, 94009, 94009, -5894,  1035,  3492,  3493, -5894, 94009,  3494,
   73099,  3404,120445, 73099, 56768, 73099, 73099,  3775,120445, 94009,
   94009,  1436, 84829,   509,  1105,  3188,  3648, -5894,  1648, -5894,
   69529, -5894, 94009,  3641, -5894, -5894, -5894, 89929,  3899,  3537,
   -5894, -5894, -5894,112879, -5894, -5894,  3643, -5894,  2230, -5894,
   69529, 69529, 94009,  7575,  3417,113389, 94009,  1049,  3714,  3666,
    3715,   139, -5894, -5894, -5894,120445, -5894, 94009, 90439, 94009,
   94009,  3706, 94009, 81769,113899,114409,   106,  1431,  3709, 94009,
   82279,  3711, -5894,  3585, 94009, -5894, -5894, 65449, 69529, 94009,
     943, 64939, -5894,  3693, -5894, 94009, -5894,   994, -5894, 94009,
    9520,  3667, -5894, -5894,  3524,  3532, 94009,   514,  1168,  3188,
    3843, 94009, 94009,  3434,  2240, 69529, 94009, 64939, -5894,  3668,
     123, 69529, 94009, 89929, -5894,  3669, -5894, 84829,  3773, -5894,
    3439,  2284,  2556,  2077,  3439, 69529, 94009, -5894,  3439, 94009,
  104209, -5894, 69529,  1087, -5894, 69529, 94009, 89929, -5894,  3671,
    3614, 69529, 94009, 14020, -5894, -5894, -5894,   361, -5894, -5894,
   -5894, -5894, -5894, 94009, 94009,   361, 94009, 94009,   361,  1880,
   -5894, 69529, 94009, -5894, -5894, -5894,  3587, 69529, 94009, 94009,
     369, 94009, -5894, 94009, 69529,  3496, 94009, 94009, -5894, -5894,
   94009,  6458, 94009, 94009,  3455, 94009, 94009, 94009, 94009, 94009,
   69529, 94009, -5894, -5894,  1577,  1411,  1825,  1920,  1574, 94009,
    3789, 94009,114919,  1271, 69529, 94009, 94009,  1271, 94009, 64939,
    1763, -5894, -5894,  3592, -5894, 69529,  1087, -5894,  8018, 94009,
   94009, 94009,  3545,  3546,   318,  3630, -5894, -5894, -5894,   117,
     117,  3681, -5894, 36387, 36387, 34803,  3460, -5894, -5894, 36387,
    2935, -5894, -5894, -5894,   371,  3954,   371,115429,   371,   371,
    3776,  3526,  3530,   371,   371,   371,  3764,   371,   371,   371,
   94009,  3672, -5894, -5894,  3672,   195, 36387,120445, 94009, -5894,
    2241, -5894,  3488, -5894, -5894, 64939, 94009,   535,  1033,  3851,
    3712, 76669,  1395,  3844, 94009,  3531, 94009,  3979,  3588,  1029,
   -5894,  1395, 94009, -5894,  2281, 78709, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, 94009, -5894, -5894,  3845, 94009, 45825,  3674,
   -5894,  1271,  2893,  2893,  2893,  2893,  3484,  2893, 94009,  3624,
    3869,  1395,  3497,  3871, -5894,  3001,  3876,  1423, 94009,  3732,
   76669,  3570,  3543,  3744,  3999,  2284,  1271,  3747,  3733, -5894,
   60858, -5894,  2893,  4013, 29549,  6249,  8115,  3737,  3799, -5894,
   -5894,  3745,  1121, 94009,  3857,  3858,  3880, -5894,   244, -5894,
    4014,  1894,  3881,   336, -5894,   341, -5894,  2942, -5894, 94009,
   -5894, 94009, 94009, 94009, 94009,   383, -5894, -5894,   341,  2942,
     341,  1037, -5894,  3813,   336,  2942,  3659,  3886,   471, -5894,
     591, -5894,  3751,  1037, -5894,  3768,  2284, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894,  2247, -5894, 94009, -5894,  3861,  3863,
    3864,  3865,  3866,  3529,  3535,  3575, 94009,  3541,  3529,   361,
    3542,  3533, -5894,  3541,  3541,  3529,  3083,  3083,  3529,  3535,
   68509,  4016, 64939, -5894, -5894,  3625,  3548,  3901,   930, -5894,
     946,    94,  3803, -5894, -5894, -5894, -5894,120445, -5894, 69529,
    3601, -5894, -5894, -5894,  3771,  3550, 68509,  1037,   220, -5894,
   73099, 94009,120445, 73099,  3781, 73099, 73099,120445, 94009, 94009,
    2264, -5894,  1647, -5894,  1872, 36387,   217, -5894, 16982,  2276,
   36387,  3551,  3552, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
    3558,  3907, -5894,  2277,  2298, 17107,  2212,120445,  2231,  3572,
   -5894,  3559,   255,  3782,  3565,  5573,  3620,  2300,  3599,   282,
   -5894,  5573,   363,  3578,  8151,  3724,  3598,  2302,  3600,  3605,
   -5894,  6702,  7326,  3608, 17222,  3604,  3610,  3613,  3612, 42195,
   42195, 30574,  2645, -5894, 42195,  3616,  3785,  2309, 15965,  3619,
    3622, 17571, 35331, 36387, 35331, 35331, 17663,  3606,  3623, -5894,
    3967, -5894,  2316, 64939,  3777, 17682,  2326, -5894, 36387, 64939,
    7379, 36387, -5894, 36387,  3626, -5894, -5894,  5703,  5703,  5703,
    3015, -5894, -5894,  3603, -5894, 42195, 42195, -5894,  1802, 30574,
   -5894, -5894,  3929, -5894, -5894,   260, -5894, -5894, -5894, -5894,
   -5894,  2911, -5894, -5894, -5894,  3816,  2212,  2296, 56239,  4407,
   36387,   326, 36387,  3359, 36387,  3670,  5703,  5703,  5703,   439,
     439,   330,   330,   330,  2259,   551, -5894, -5894, -5894,  3621,
    3629,  3574,  3632, 36387, -5894,  3627, 51501, -5894,  2378,  2390,
   94009,  4161,  4964,  6849, -5894, -5894, -5894,  3427,    92,  3427,
   -5894,  1764,  2770,   234, 62898, -5894, -5894, -5894, -5894, -5894,
   -5894, 94009, 20524, -5894, -5894,  3846,  3634,  2332, -5894, -5894,
    2770, -5894, -5894,  2620,  2620,  3637, -5894,  3642, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894,  3636, -5894, -5894, -5894,  3644,
    3645, 46341,  3933,  3646, 44793, 90949,  3635,  2223, -5894, 90949,
   91459, 90949, 90949, -5894,  3647, -5894, -5894,  1961, 36387,  3927,
   -5894, -5894, -5894, 36387, -5894, -5894,   656,  3660,   762,   128,
    2581,  2581,  2630,   961, -5894, -5894,  3652, -5894, 36387,  2767,
   -5894,  2780, -5894, -5894, -5894, -5894,  3083, -5894,  3912, -5894,
   -5894, -5894, 45309,  3694,  3699,  1561, 49437,  3852, -5894, 94009,
   45309, -5894, 94009,   434, -5894,  3657, -5894, -5894, -5894, -5894,
   -5894, -5894,117469,     0, -5894,121933, -5894,121933, -5894,     0,
    4065, -5894,117469,  2026, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, 69529, 69529,  3877,
   94009,  3873,  3884, 36387,  1329, -5894,  4020,  1037, -5894, -5894,
    3740, -5894, 20524, -5894, -5894, -5894, -5894, -5894, 69529, 94009,
   -5894, 72589, -5894, -5894,120445, -5894, -5894, 94009, 94009, -5894,
   -5894, -5894,120445, -5894, -5894, -5894, 94009,  1007,  3743,  3748,
   94009, -5894,  1386,  3448,  8574, 94009, 94009, 94009,  3983, -5894,
   -5894, -5894, -5894,  3896, -5894,  4038, -5894,117469, -5894,  2942,
    1479,  3752,  3188, 36387,  3911, -5894,  1015, 94009,  3673,  3684,
    4048,  1364,  4000,  3690, -5894,  3784, -5894,  3807,  1317, -5894,
   -5894,  3819, -5894, -5894, -5894, -5894,  4067,  1037,  4069,  1037,
   94009, 94009, 94009, 94009,  3833, -5894, -5894, -5894, -5894,  3834,
    3978, -5894, 64939, 64939, 64939,  2350, -5894, -5894,  1271, -5894,
   -5894, -5894, -5894, -5894, -5894,  4029, -5894,  2366, -5894,  1901,
   91969, -5894, -5894, -5894, -5894, -5894,  4079, 69529, 94009,  9240,
   94009, 94009, 94009,  3939,  2113,  1540,120445, -5894,118957, -5894,
   -5894,  2372, -5894,  3716, 94009,  3805, 69529,  3783, -5894, -5894,
   -5894,  4095,  2284,  3870, 80749,  3769,  3769,  2209, -5894, -5894,
   -5894, -5894, -5894,  4004,  3930, -5894,  1164,  3932, 69529,  3791,
   -5894, -5894, -5894, -5894,  4105,  3818, -5894, -5894,  3821,  1235,
    3188,  3001, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894,  3847, -5894, -5894, -5894, -5894, -5894, -5894,  1533,  1533,
   -5894, -5894, -5894,  1533,  1565,   463,  1238,  3188, -5894,   395,
     423, 94009,  3822, -5894,  3823, -5894,  4050, -5894, -5894,  4010,
    4011,  4012,  3829,  3830,  3898,  3853,  3856,  3903, -5894,  3859,
    3904,  3862,  3905,  3872,  4167,  1037,120445,  4007,  1271,  3906,
    4143,  1037, -5894, -5894,  3879, -5894,  3885, -5894,  2380,  4258,
    4259, -5894, 94009, -5894,   528,  1245,  3188, -5894,  3887, -5894,
   69529, 94009, -5894, -5894, -5894, 36387,  3780,  3788,  3792, 20524,
   20524, 36387, -5894, -5894, 20524,  3787, -5894, -5894, -5894, -5894,
  120445, -5894, 94009,  4085, -5894, -5894,   371, 94009, 94009, -5894,
   -5894, -5894, 94009, -5894, -5894, -5894,  4087, -5894,   340,   340,
   -5894, -5894,  4128,  8229,  3793,   385, -5894, 64939, 53065,  2170,
     888,  1923, -5894, 72589, 94009, 72589, -5894,  1033,  4006, 94009,
   94009, 94009,  3798,  3797, -5894, -5894, -5894, -5894, 69529,   246,
   69529,  2770, -5894, -5894,  3882, -5894, 94009,  2284,  4316,  4160,
    3496, -5894,  4289,  3401,   389,  2035,   281,  2992,  4226,  2606,
   36387,   466, -5894, -5894,  1961, 94009,  3543, -5894, -5894, -5894,
   -5894,  1271, -5894,  3809,  3802, -5894, 94009,  4172, 94009, 94009,
   94009, 94009,  3601,  3811, 94009,  3814,120445, 94009,  2359,  3184,
    4311,  4195,  2213,  3570,  3910,  4203, 84829,  3837,  2382, -5894,
   -5894,  1121, -5894,  2384,   227, -5894,  1271, 72589,117965,  4192,
   -5894,  1018,  8115, -5894, -5894,  1018,   240, 94009, -5894, -5894,
   -5894, -5894,  4062,  2145, -5894,  4176, -5894, -5894,  2213, -5894,
  120445,  3831, -5894,  2386, -5894, -5894, -5894,   471,  3894,  1037,
    3895,  1037, -5894, -5894, -5894, -5894, 94009, -5894, 94009, 67999,
   -5894, -5894, 94009, -5894,  4212, -5894, -5894,  3981,  3982,  3984,
    3985,  3986, 94009,  3529, -5894,  3838, 94009, 94009, 69529,  1617,
   -5894, -5894, 69529,   499, -5894,   972, -5894, 84829,  3987, -5894,
   -5894, -5894, -5894,  4223,  4225, -5894, -5894, -5894,  1474, -5894,
   79729,   503, -5894, 69529,  4158,  4159,  4163,  4165,   361,  4166,
    4169,  4170,  4174,  4177, -5894, -5894, -5894,  3867, 18098, 36387,
   -5894,  4237,120445, -5894,  8578, -5894, -5894, -5894, 36387, -5894,
   -5894,  4157, -5894, -5894,  3936,  3938,  3875,  3572,  3724, -5894,
    4088,  4097, 36387,  3724,  4348,  1071, 36387, 36387, 36387, -5894,
   -5894,  4100,  4101, 36387,  2212,  2212, 36387, -5894,  3891, 36387,
   -5894, -5894, -5894, -5894,  2427, 36387, -5894, 36387, -5894, -5894,
   27484,  4399,  4399,  3874,120445, 42195, 42195, 42195, 42195,   979,
    3049, 42195, 42195, 42195, 42195, 42195, 42195, 42195, 42195, 42195,
   42195,   615, -5894,  4096, 36387, 36387, 35859, -5894, -5894,120445,
    3892,  3606,  3893,  3897, 36387, -5894, -5894, -5894,  2388, 43761,
    3908, 64939, -5894, 36387, 16113,  2406,  3931, 18263,  1961,  8965,
    1271, 36387,   683,  2916, 36387,  2407, 36387, -5894, -5894, -5894,
   -5894,  4241, -5894, -5894, -5894, -5894, -5894, -5894,  4130,  2212,
   -5894, -5894, 36387,  3909,  3225, 42195, 42195,  3351, -5894,  4515,
   36387, 30574, -5894,  3681, -5894, 28018,  3900, 36387,116959, -5894,
   -5894,   980,   980,   980,   980, -5894, 94009, 94009, 94009,  3927,
    3913,  3927,   203,  3914, -5894, -5894, -5894, -5894,  2213, -5894,
    3888, -5894, -5894, -5894, -5894, -5894, 36387, 90949, 91459, 90949,
   90949,  3918, 44277, 28535,  2223,  3919, 94009, -5894, -5894,  3921,
   45309,  4196,  4112, -5894, 45309,  4112,  1622,  4112,  4205,  3998,
   52017, -5894, -5894,  3923, -5894, -5894,  4104, -5894,  2080, 20524,
    4381,  4251, -5894,  3925, -5894,  3660,  1603, -5894, -5894, -5894,
    1272, -5894,  4001, -5894, -5894, -5894,  3635, 37971,  4073, -5894,
   -5894, -5894,  3976,  2408, -5894, -5894,  4371,  4073, -5894,  2245,
   -5894,  2421, 50985,  3694, 36387,  1961,  2422,  2104, -5894, -5894,
  117469, -5894,  4005,  2942,  2942,  1538,  3529,  4291,  1538,  8986,
   -5894,  1701, 94009, -5894, 94009, -5894, -5894, -5894,  4426,  3993,
    3994,  4227, -5894,  2753, -5894, -5894, 69529, 94009, -5894, -5894,
   -5894,   542,  1262,  3188, -5894,  4023, -5894, -5894,  4254, 94009,
   -5894,  4413,  4035, 94009,  9603,  4319,  4009, -5894, -5894, 46857,
   94009, 94009, 94009, -5894, 94009, 94009,  1701, 92479, -5894,  4391,
    1701,  4058,  4298,  1927,  3184,   377,  7335, -5894,  1922, -5894,
   -5894,  4022, -5894, 94009, -5894, 94009, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894,  4089, -5894, -5894, -5894, -5894, 65449, -5894,
   -5894, 94009, -5894, 64939, 53065, 64939, -5894, -5894, -5894, 94009,
   -5894,  1570,   552,  1264,  3188, -5894,  4040, -5894,  4329,  4045,
    4046,  4106,   221,   268,  4049,  4051,  4107,  3962,  3964,  3966,
   -5894, 64939, 53594,  4136, 94009,  2942,  3969,  4015, 94009,  3769,
   92989, -5894,  3970, -5894, -5894,  3769,   382,  1271, -5894, -5894,
    1271,  2942,  1271, 94009, 94009, 94009, 94009,   369, -5894, -5894,
   -5894,  4447,  4070, 94009, 94009, 94009, 94009, -5894,  4030, -5894,
   -5894, -5894,  2432, 94009, 94009,  3975,  4340,   940,  2257, 69529,
   94009, 94009, 69529, 94009, 94009, 94009, 94009, 94009, 94009, 94009,
    4204, -5894,  4435,  4357,  2162,  4414,  4068, 94009, -5894, 94009,
    1271, -5894,  3448, 94009, 94009, 94009, 94009, -5894, -5894, -5894,
   -5894, -5894,  3681, -5894,  3995,  4305,   371, -5894,  4306,  4308,
    4309,   371, -5894, -5894,  1923, -5894,   251, 94009, -5894,  2401,
   94009, -5894, -5894, -5894,  3925,  2546,  2580, -5894, -5894, -5894,
   -5894, -5894, -5894,  4002, 94009, 94009, 42195, -5894,  1981,  1892,
    1547, -5894,  4295, 94009,  3286, -5894, -5894, -5894,   915, 94009,
   -5894, -5894, -5894, -5894,  4017, -5894,   754,  3811, -5894,  4330,
   76669,  2942, 69529, 69529,  2942, -5894,120445,  4021,  3543, -5894,
     985,  4093, -5894, 69529,   389,115939,  3355,  4052,  4234,  9633,
   45309, 45825,  1533, -5894,  4008,  4018, -5894, -5894, 94009,  4006,
   67999,  2442,  3001,  4507,   974,  2228, -5894, 78199,  4217,  3811,
    4330, -5894,  3184,  4244,  4242, -5894,  2213, 94009,  3601,  3543,
    1271, 94009,  4009, 53065, -5894,  4548,  2173, -5894,117469, 36387,
   36387, -5894,  4024, -5894,  4027,  8115, -5894,  4108,  4026,  4511,
   36387, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,  4121,
    4036, 94009, 94009,  1121, 94009, -5894,  4034,  3881, -5894,  3881,
   -5894, 94009, -5894, 94009, -5894,  1037, -5894,  4173,  1037, 94009,
   94009, 94009, 94009, 94009, 94009,  3529,   361,  3533, -5894, -5894,
    4390, 68509,  4392, -5894, 64939, -5894, -5894, -5894, -5894, -5894,
    2452, 94009, -5894, -5894, -5894,  4461,  4398,  1037,   493,  1167,
    1167,  1167,  1167,  4353,  1167,  1167,  1167,  1167,  1167, -5894,
   36387, 20524, -5894,  4044, -5894, 20524,  4436,  4341,  4342, -5894,
   -5894,  4053,  4290,  4297, -5894,  4059, 36387,  3724, 18601, -5894,
   -5894,  4300,  4301, -5894,  3724,  3724, 18601, -5894, 18601,  4063,
    9705, 18788, -5894,  2453, 36387, -5894,  1221,  1221,  1221,  3992,
    4409, -5894,  2739,  1221,  1221,  1221,   456,   456,   332,   332,
     332,  4399,   615, 18945, 19099, 19358,  4064, -5894, -5894, -5894,
    3606, -5894, 38499,    99,  4529, 43245, -5894, -5894, -5894,  4114,
    4115,  4071, -5894, 36387, 39027,  4074,122429,  4286, -5894,  1768,
   36387, 36387,  5493, -5894,  4803, 36387, -5894, -5894,  5493,   494,
   36387,  3174,  4233, 36387, 36387,  4662, 10365,  4076, -5894,  2459,
   36387, 10456,  4280, -5894, 94009, 94009, 94009, 94009, -5894, -5894,
   -5894,  4251,  1271,  4251,  1271,  4078, -5894,  4077, -5894, -5894,
   -5894, -5894, 65959,  4075,  3777, 90949,  4080, 94009,  2223, 45309,
   -5894, -5894,  2377, -5894, 45309,  4393, -5894, 45309, 73099, -5894,
   94009,  4082, 94009, -5894,   450, 36387,  4127, 56239, -5894, -5894,
   -5894, -5894,  4180, -5894,  4317, 20524, 33219, -5894,  2213,  2449,
   94009,  1961,    84, -5894, 36387,  4102, 94009, -5894,  4073, 20524,
   -5894,  4164,  2464, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
    4181, 78709,  4444, -5894, -5894,  1921,  4420,   235, -5894,  1037,
   -5894,120445, 94009, 94009, 94009,  3132, -5894, -5894, 94009, 94009,
   94009, 94009, -5894, -5894, 69529, 94009, -5894, -5894, 94009, 36387,
    2469, -5894,  4138,  4557,   245,  2474, -5894,  2485,  1701, -5894,
    2490, -5894, -5894, 93499, -5894,  4006,   369,  1981,  4443,  4445,
    4344, -5894,   361, -5894,  4601,  1981,  4345,   369, -5894, -5894,
   -5894, -5894,  2771, -5894,120445,  1037,  1037, -5894, -5894, -5894,
   -5894, -5894,  4118, -5894,  4585,  4209, 94009, 94009, 94009, 94009,
   94009, 69529, 94009, 94009,  2770,  2770,120445,  4109, -5894,  2770,
    2770,  4110, -5894, 69529, 94009, 94009, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894,  4206, -5894, 36387,
    4579, -5894, -5894, -5894, -5894, -5894, 36387, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, 69529, 94009,  4207,
   -5894,  4208, -5894,   954,  4438, -5894, -5894,  4328, 94009, 94009,
   94009, 94009,  4501, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894,  4502, 94009, -5894, -5894,  1271,  1271,
  120445,  1037,  1037, -5894, -5894, -5894,  4213, -5894, -5894,  4131,
    4442,   371, -5894,   371,   371,   371, -5894,  4142, -5894,  1923,
    4544, -5894,  1701,  2176,  4494, -5894, 36387, -5894,  1685,  3992,
   -5894,  4558,  4642, -5894, -5894, -5894, -5894,  3496,  2284,  3496,
   -5894, -5894, 73099,  1104, -5894,  4481,   535, 64939,  4383, 76669,
     395,   357,  4148,  4287, -5894,  2942,  2942,  4215, 94009,  4651,
   -5894, -5894, -5894, -5894, -5894, -5894, 69529,  3783, -5894,  4400,
    1240,  4517, 94009, 45825, -5894,  3635, -5894, -5894, -5894,  1271,
   -5894, -5894,  4292,  3543, -5894,  1448, 94009,  4401, 76669,  3601,
    2491, -5894, -5894, -5894,  4201,  4636,  3570, -5894,   395,  4217,
   -5894, -5894,  4616,  4263,  4214,  4667, -5894,  4263,  4531,  4402,
    4183, -5894,  3837, -5894, 94009, -5894, 20524, 20524,  1271,122925,
    1018,120445,  4538, -5894, 20524, 94009,   209,  4182,  4360, -5894,
    4504,  1037,  2517, -5894,  1037,  1037, -5894, 94009, -5894,  3529,
    3529,  3529,  3529,  3529, -5894,  4408, -5894, -5894, -5894, -5894,
    4503, -5894, 68509, -5894,  1037, -5894, -5894, -5894, -5894, -5894,
   -5894,  1167, -5894, -5894, -5894, -5894, -5894, 20524, -5894, 94009,
   -5894, -5894, -5894, -5894, -5894, -5894,  3376,  4188, 36387,  2373,
   -5894, -5894,  4191,  4193,  3724,  3724, -5894, -5894, 36387, -5894,
   10994, 42195,  4553, -5894, 36387, 36387, 36387, -5894,  4197,  2518,
    2519, -5894, -5894,    99, -5894,  4529, -5894, -5894, -5894, 11354,
    4253, 20524,  4318,  4198,   987,  5493,  5493,  4803,  5493, 36387,
   36387,  5493,  5493, 36387, -5894, -5894, -5894, 11374, -5894,  4674,
    3681, -5894, -5894, -5894, -5894,  4127, -5894,  4127, -5894,  4347,
   36387, -5894,  2527,  4698, 41139,  4656, -5894, 94009,  2536, -5894,
   36387,  4210, -5894, -5894, 45309,  2377,  4211,  2542, 94009,  2550,
  120445, 39555, 20524, 94009,  3681,  4216, -5894, 94009,  3081, -5894,
    1561, -5894, -5894,  4649, 46857,  4607, 19772, 36387, -5894, -5894,
   -5894, -5894, 68509,  4439, 68509,  1701, -5894, -5894, -5894, -5894,
   -5894, -5894,  4218, -5894, -5894, -5894, -5894,  4296, -5894, -5894,
      75,  3571,  1701, -5894, 11780,  4546, 46857, 57297, 94009, -5894,
   94009, -5894,  4388,  4546,  4546, -5894, -5894, -5894, -5894,  4712,
    4594,  4598, -5894, -5894,  4230, -5894, -5894, -5894,  4435, -5894,
   -5894, 53065, 69529, 94009, -5894,  4320, -5894, -5894, -5894, -5894,
   -5894, -5894, 48921, 56239, -5894,   221,  4235,  4236,   268, -5894,
   -5894, -5894, 94009, 12028,  4238, 12130,  1091,  3571, 94009, 94009,
    4245,  4246,  4247, 94009, 94009,  2572, -5894,  1848,  1773,  1993,
    3529,  4605, 94009, -5894, -5894, -5894,  4435, -5894, -5894, 94009,
   -5894,   371, -5894, -5894, -5894, -5894, 64939, -5894,  3382,  4142,
    1271, 73099,  4734,  4734, 12378,  4482, -5894, -5894,   495,  4310,
    4523,  4310,  4255, 94009,   915,  4256,  2579, -5894, 94009,  4257,
    4396,  2347,  2347, 94009, 94009, 94009,  2586,  2213,  2942,  4015,
     389,  4635, 76669,  4686,  4006,   470, -5894, 94009,  4762, 94009,
    3601,  3811, 94009,  4265, -5894, -5894, 78199,  4491,  2170, 94009,
    2359,  4217,  3570,  1011, 94009, -5894,  1761, -5894,  2213, -5894,
   94009, 84829, 46857,  4628, -5894,121933, -5894,  2590, -5894, -5894,
   -5894,  4349, 21094,  3427,  4403,  4404,  4270,  2207,  4644, 94009,
     964, -5894, -5894, -5894, -5894, -5894, -5894, 94009,   503, -5894,
   -5894, -5894, -5894,  4278, -5894,  4785, 36387,   350, -5894, -5894,
   -5894, -5894, -5894,  4519, -5894,  4294, -5894, -5894,  2405,  2373,
   19824, -5894,  5414, 42195, 20524, 20524, 20524, 36387, -5894, 36387,
   -5894, -5894, -5894, -5894,   785, -5894, -5894,  4623,  4299,  5493,
    5493,  5493, -5894, 36387,   238, -5894, -5894,  2076,  4720, 20170,
    3647, 65959,  4302, -5894, 42195,  2599, -5894,  5441, 94009,  2609,
   -5894, 20524, 94009, -5894, -5894, 36387, -5894,  2610, -5894,  4304,
      68,  4312, 26416,  4313, -5894, -5894, -5894, -5894, -5894, 20524,
    4314, -5894,  4796,  1676, -5894, -5894,  4358, 94009,  2622, -5894,
    1211,  2103,   112, -5894,  4805,  4805, 20524,  1617,  1538,   625,
   -5894, 94009,  4405, -5894,  4557,  4315,  3496, -5894,  4321, -5894,
   -5894,  1443,  3184, 94009,  3496,  3496,  2170,  4660, -5894, -5894,
   36387,  4372, -5894,  1265,  3571, 94009,120445, -5894,   191,  4688,
   -5894,120445,120445, -5894, -5894, -5894, 36387, -5894,  4419, -5894,
   -5894, -5894, 36387, 36387, 75649, -5894,   395, -5894,  4328, -5894,
   -5894, 94009, 94009, 94009, 94009, 94009, -5894,  1037, -5894, -5894,
    2627, -5894, 47889, -5894, -5894,  3385,  1271,  3385,  1986, -5894,
   -5894,  3385,  3385, -5894,  3427, -5894,  4734,  1514, -5894, -5894,
    4573,  4327, 36387,  4659, -5894,   218,  4559, -5894,  4333, -5894,
   73099,  4860, -5894, 64939,  3811,  4330, 94009, -5894, -5894, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,  2642,
    4006,  4707,  3543,  4214, -5894, 94009,  4376, -5894, 45309,  4006,
    2213,  2228, -5894,  4217,  3811,  4330, -5894, -5894,  4339,  4242,
    3570,  2359,  4490, -5894,  4492, -5894,  4806,  4568,  4808,  3601,
   -5894,  4009,  2643, 94009, -5894, -5894,  8115,122925,120445, -5894,
   -5894, -5894,  4346,  4746,  4395,  4397, -5894, -5894, -5894,  2207,
   -5894,   809,  4742,  4406, -5894,  4411, 94009, -5894, -5894,  4006,
    1037, 36387, 64939, 20524, -5894, -5894,  4741, -5894,   323,   284,
    1911,  4584,  4359, 36387,  5414,  2644,  2649,  4415, -5894, -5894,
   -5894,  3606, 40083, 40083, 40083,  4361,  4730,  4732, 94009, -5894,
   94009,  4572, -5894, -5894, 94009,  3992,  4365, 41139, 64939,  2668,
   -5894,119453, -5894,  2691,  2692, -5894, 36387,  4373, 36387, -5894,
   39555, 94009,  4375,  3474,  2213, -5894,  3427, 46857, -5894,  4505,
   -5894,  4641, -5894, -5894, 36387,  4467,  4471, -5894,  4739, -5894,
   -5894, 94009, -5894, 94009,  4310, 56239,  3660,  1443,  2284,  4310,
    4310,  4327, 12572, 36387, -5894,  4479, -5894, -5894,  2693,   843,
    4560,  4560,  2697,  2698, 13412, 94009,  2707,  2724, -5894,  2726,
    2770, -5894, -5894,  3535,  1993,  3535, -5894,  3529, -5894, -5894,
   64939, -5894, -5894, 69019, -5894, -5894, -5894,  1271, -5894,  1271,
    4622, 58829, 59339,  1271,  1271, -5894, -5894, -5894, -5894,  4715,
   -5894,  3001, -5894, 14258,  4486, -5894, -5894, -5894,   570, -5894,
    4617,  4631, -5894,  4412, -5894,  2740, -5894,   395,  4541,  4006,
   -5894, -5894, 94009,  4903,  4904, -5894,  1284, 94009,  3635, -5894,
    4214,  3601,  3570,   395,  4217,  2170, 47373,  4263,  2359,  4242,
   -5894, -5894,  4632, -5894,  4633, -5894,  4416,  4744, -5894,  2117,
    1018, -5894, -5894, -5894,   398,  4769,  4770, -5894, -5894, -5894,
    3385, -5894,  1917,  4417,  4794, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894,  4459,   321,   324, -5894,  4460, -5894,  4604,  4606,
    2373,  1951, -5894, 20524, -5894, -5894, -5894, 41667,  4576,  1336,
   16379,  4809, -5894,  4809,  4809, -5894,  4906,  4909,  1306, -5894,
    4882,  2755, 43245, -5894, -5894, -5894, 94009,  4655,  1186,  4933,
    4609,  2756, 39555,  2760, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, 50985,  4914, 20524,   400,  1592, 68509,  3571,  2761,  3769,
    4446, -5894,  3660,  4523, -5894, -5894, -5894, -5894, 20524, 94009,
   73099,  4915, -5894, -5894, -5894, -5894, -5894, -5894, -5894,  3571,
    4527, -5894, -5894, 75649, -5894, 94009, -5894, -5894,  2762, -5894,
   -5894, -5894, 59849, -5894,  4182, -5894,  4182, -5894, -5894, -5894,
    2146,  4554, 94009,  1030,  1030,  4856, -5894,  4512, -5894,  4448,
   -5894,  4979,  4587, 94009, -5894, -5894,   221,  2213, 76669,  4006,
   -5894, -5894,  2359,  4217,  3570, 36387,  2772, -5894,  4557,   245,
   -5894,  4242,  4263, -5894, -5894, 46857,  4452,  3286,  4847, -5894,
   -5894, -5894,  2009, 73099, 73099, 94009, -5894, -5894, -5894, 36387,
     915, -5894,  4493, -5894,  4496, -5894, -5894,  4687,  4689,  4458,
    2373, -5894,  4961, -5894, -5894, -5894, -5894, -5894,   917, -5894,
   -5894, -5894, 94009, 94009, 94009,  4463, -5894,  3777, -5894, -5894,
   42195, 42195,  4704, -5894, 42195,  1186, -5894, 94009, -5894,  4468,
   -5894, -5894,  2781, -5894,  1640,  1977, -5894,  4709,  4603, -5894,
   -5894,  4713,   659, -5894,   625, -5894, -5894, -5894, -5894, -5894,
    4559,  1701,  1701,  3571, -5894, 94009, -5894,  4472, -5894, -5894,
   -5894, 69019, -5894,  4182, -5894, -5894, -5894, -5894,  4984, -5894,
    1300, -5894, -5894, -5894, -5894, 94009,  4006,  4109,  4214, -5894,
    4242,  3570,  2359, 14725, -5894, 47373, 94009, 94009,  4263, -5894,
    2794, 46857,  3543,  4625, -5894,  2585, -5894, -5894, -5894, -5894,
   -5894, -5894, -5894,   931,  4473,  4474, -5894, -5894, 14803, 73099,
   -5894, -5894,  4627,  4629, -5894,  4702, 40611,  4634, -5894,  4700,
   -5894,  1383,  1424,  1421,116449,  4938,  3992,  3992, -5894,  3992,
   -5894, -5894, 36387, -5894, -5894, -5894, -5894, -5894, 50985, -5894,
    4542,  1561,  4485, 94009, -5894, -5894,  1701, -5894, -5894, -5894,
   36387, -5894, -5894,  2284,  2284,  4006, -5894, -5894,  4263,  2359,
    4242,  4557, -5894, -5894, -5894, -5894,  4744, -5894,  2795,  4263,
    4406,  2438, -5894, -5894,  2458,  2718,  4574,  4846, -5894,  4495,
    4608,  4610,  4884, -5894, -5894, -5894, 94009, 94009, 66469, 94009,
    1046,  2800, -5894,119949, 94009, 15412,  4498, -5894,  4562, 36387,
    2805,  1701,  2807, -5894, -5894, -5894, -5894,  4242,  4263, 94009,
    3286, -5894, 46857,  3427,  4875, -5894,  2585,  4637,  4638, 64429,
   -5894, -5894, -5894, -5894, -5894,  5032,   316,  4927, -5894, -5894,
    1271,  2373,116449,  4733,   821,  2812, -5894,  4570,  2814,   127,
   -5894,  4263, -5894, -5894,  3543, -5894, -5894,   915, -5894,  4564,
    4565, -5894,  2818, -5894, -5894, -5894, -5894, 36387, 66469,  2280,
    4514, -5894, -5894,  4718,  1271,  2405,  4718, -5894, -5894, -5894,
    1561, -5894, -5894,  4263, 73099,  4879,  4880, -5894, 64429,   117,
    4581, 94009,  4525, -5894,  2373, -5894,  1911,  2405,  4583,  3427,
    4530, 73099, 73099, -5894,  4526, 94009,  4983,116449, -5894,  2373,
    1911,  4570, -5894, 64429, -5894, -5894,  1271, -5894,  4532,  2829,
   -5894,  2373, -5894,  2835,116449, -5894, -5894, -5894,  2840, -5894
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
    1724,  1463,   669,  1552,  1551,  1463,     0,   269,     0,  1563,
       0,  1463,   442,  1120,     0,     0,     0,     0,   669,  1463,
       0,  1724,     0,     0,     0,     0,     0,  1737,     0,     0,
       0,     0,     0,  1260,     0,     0,     0,  1463,     0,     0,
    1744,     0,     0,     0,     0,  1737,     0,  1565,     0,     0,
       0,     0,  1744,     0,     0,     0,     0,     0,     2,     9,
      10,    45,    80,    81,    38,    37,    98,    63,    24,    71,
     133,   132,   134,    50,    46,    88,    33,    35,    47,    51,
      73,    75,    40,    53,    64,   110,    72,    31,    70,    76,
      96,    58,    19,    20,    59,    21,    60,    22,    61,   106,
      82,    99,    43,    69,    30,    52,    78,    79,    12,    54,
      86,    18,    65,    66,    68,    91,    92,    93,   116,    94,
     128,    49,   125,   103,   104,   122,   105,   123,    16,   107,
      62,    23,   119,   118,   120,    89,    55,    90,    77,    97,
     117,    34,   121,    25,    26,    28,    29,    27,    67,    36,
      74,    39,    95,   124,   114,   109,   129,   127,    11,   135,
     111,    83,    14,    15,   100,    13,    32,    57,    17,    42,
      41,    56,    48,   131,    44,  1563,   102,   115,   101,    84,
     108,    87,   112,   130,   113,    85,   126,  1688,  1687,  1748,
    1691,  1723,     0,  1703,  1462,  1461,  1476,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   668,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1473,  2452,  2469,  2470,  2471,  2472,  2473,
    2474,  2475,  2476,  2477,  2478,  2479,  2480,  2481,  2482,  2483,
    2485,  2484,  2486,  2487,  2861,  2488,  2489,  2490,  2798,  2799,
    2862,  2800,  2801,  2491,  2492,  2493,  2494,  2495,  2496,  2497,
    2498,  2499,  2802,  2803,  2500,  2501,  2502,  2503,  2504,  2804,
    2863,  2505,  2506,  2507,  2508,  2509,  2510,  2864,  2511,  2512,
    2513,  2514,  2515,  2516,  2517,  2518,  2519,  2520,  2865,  2521,
    2522,  2523,  2866,  2524,  2525,  2526,  2527,  2528,  2529,  2805,
    2806,  2530,  2531,  2532,  2533,  2534,  2535,  2536,  2537,  2538,
    2539,  2540,  2541,  2542,  2543,  2544,  2545,  2546,  2547,  2548,
    2549,  2550,  2551,  2552,  2553,  2554,  2555,  2556,  2557,  2558,
    2559,  2807,  2560,  2561,  2562,  2563,  2808,  2564,  2565,  2566,
    2567,  2809,  2568,  2569,  2570,  2571,  2867,  2868,  2572,  2573,
    2574,  2575,  2576,  2810,  2811,  2577,  2578,  2579,  2580,  2581,
    2582,  2583,  2869,  2584,  2585,  2586,  2587,  2588,  2589,  2590,
    2591,  2592,  2593,  2594,  2595,  2596,  2870,  2812,  2597,  2598,
    2599,  2600,  2813,  2814,  2815,  2601,  2871,  2872,  2602,  2873,
    2816,  2817,  2818,  2819,  2820,  2821,  2822,  2823,  2824,  2825,
    2826,  2603,  2604,  2605,  2606,  2607,  2608,  2609,  2610,  2827,
    2874,  2611,  2875,  2612,  2613,  2614,  2615,  2616,  2617,  2618,
    2619,  2620,  2621,  2622,  2623,  2624,  2828,  2625,  2626,  2627,
    2628,  2629,  2630,  2631,  2632,  2829,  2876,  2830,  2633,  2634,
    2635,  2636,  2637,  2638,  2639,  2640,  2831,  2832,  2641,  2642,
    2643,  2877,  2644,  2833,  2645,  2834,  2646,  2647,  2648,  2649,
    2650,  2651,  2652,  2653,  2654,  2655,  2656,  2835,  2878,  2657,
    2879,  2836,  2658,  2659,  2660,  2661,  2662,  2663,  2664,  2665,
    2666,  2667,  2668,  2669,  2670,  2671,  2672,  2837,  2673,  2838,
    2676,  2674,  2675,  2677,  2678,  2679,  2680,  2681,  2682,  2683,
    2684,  2685,  2686,  2687,  2839,  2688,  2689,  2690,  2691,  2692,
    2693,  2694,  2695,  2696,  2697,  2698,  2699,  2700,  2701,  2702,
    2703,  2704,  2705,  2706,  2880,  2707,  2708,  2709,  2710,  2711,
    2840,  2712,  2713,  2714,  2715,  2716,  2717,  2718,  2719,  2720,
    2721,  2722,  2723,  2724,  2725,  2726,  2727,  2728,  2841,  2729,
    2730,  2881,  2731,  2732,  2842,  2733,  2735,  2734,  2736,  2737,
    2738,  2739,  2740,  2741,  2742,  2743,  2744,  2745,  2746,  2747,
    2748,  2749,  2843,  2750,  2751,  2752,  2753,  2882,  2754,  2755,
    2756,  2757,  2758,  2759,  2760,  2844,  2845,  2761,  2762,  2846,
    2763,  2847,  2764,  2765,  2766,  2767,  2768,  2769,  2771,  2770,
    2772,  2773,  2774,  2775,  2776,  2777,  2778,  2779,  2780,  2781,
    2782,  2848,  2849,  2783,  2883,  2784,  2785,  2786,  2787,  2788,
    2789,  2790,  2791,  2792,  2793,  2794,  2850,  2851,  2852,  2853,
    2854,  2855,  2856,  2857,  2858,  2859,  2860,  2795,  2796,  2797,
     146,     0,     0,  2419,  2453,  2454,  2457,  2452,   412,   411,
    1677,  2416,  2453,  1562,     0,  1541,   669,     0,  1476,   441,
    1724,     0,     0,     0,     0,     0,     0,   886,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     138,     0,   140,     0,     0,   466,   465,     0,     0,  1092,
     471,     0,     0,     0,     0,     0,   659,  1604,  2674,  1602,
    1678,   270,   273,   274,   271,   272,  2435,     0,  1232,  1233,
    1235,     0,     0,  1245,   926,   927,     0,     0,     0,   940,
       0,     0,     0,   924,     0,     0,     0,   946,     0,   943,
       0,     0,   947,   944,   921,   945,   928,     0,   920,     0,
       0,  1245,   948,     0,     0,   922,     0,     0,     0,     0,
    1476,  1601,   472,  1724,     0,  1585,  1586,  1587,  1563,  1575,
    1588,  1580,  1582,  1581,  1583,  1584,  1579,  2434,  2471,  1016,
    1016,  1016,  1016,  1013,  1014,  1016,  1016,  1016,  2695,     0,
       0,   995,     0,   997,  2436,  1016,  1021,  2479,   551,   551,
     551,     0,  1020,  1025,   551,     0,  1444,  1485,  2418,  1736,
       0,   996,  1443,  2761,  1591,     0,     0,     0,     0,  2714,
    1453,   254,  2726,  2844,  2761,   253,   248,   249,   222,     0,
       0,  1020,   551,     0,  1476,  1451,   992,  1743,  1741,     0,
    2403,  2498,  2515,  2614,   245,  2707,  2716,  2726,  2844,  2761,
    2794,   201,   211,   206,     0,   263,  2726,  2844,  2761,   259,
    1473,     0,  1704,  1854,  1853,  2412,     0,  1446,  1445,  1564,
       0,  1567,     0,  2690,  1708,  1711,  1569,  1709,  2455,  1947,
    1976,  1954,  1976,  1976,  1943,  1943,  2545,  1956,  1944,  1945,
    1981,  2001,     0,  1976,  1943,  1948,     0,  1946,  1984,  1984,
    1971,     3,  1926,  1927,  1928,  1929,  1957,  1958,  1930,  1963,
    1964,  1968,  1931,  1998,  1934,  1943,  2456,  1745,  1746,  2403,
       4,  2449,     5,  2330,  2448,     6,     7,  1700,     0,     0,
       1,  1724,     0,  1574,  1740,  1740,     0,  1740,     0,  1692,
    1700,  1695,  1699,     0,     0,     0,     0,     0,     0,  1447,
       0,     0,     0,   951,     0,  1488,  1077,     0,     0,     0,
       0,     0,  1329,     0,  1129,  1128,  2458,  2441,  2442,  2443,
       0,  2439,  2440,  2459,  2460,  2461,     0,  2583,  1329,     0,
       0,  2246,  2257,  2258,  2259,  2502,  2564,  2254,  2255,  2256,
    2248,  2249,  2250,  2251,  2252,  2253,     0,     0,  1227,  2247,
       0,  2583,     0,  1329,     0,   173,     0,   150,  1329,     0,
       0,  2583,     0,     0,  2583,     0,     0,     0,     0,     0,
    2583,     0,     0,     0,     0,     0,   173,  2619,     0,   150,
    2583,     0,     0,  1467,     0,     0,     0,  1469,  1472,  1459,
       0,  2327,     0,  2328,  2420,  1556,     0,  1555,  1549,  1559,
    1554,  1544,     0,  2412,     0,     0,     0,     0,   934,     0,
       0,   924,     0,     0,     0,   935,     0,   936,   937,     0,
       0,     0,     0,   933,     0,  1457,  1449,     0,  1593,  1595,
    1594,  1596,  1592,   551,     0,     0,     0,  2583,     0,   150,
    1527,     0,  2583,   150,     0,     0,   470,   469,   150,  2439,
     468,   467,  2502,  2564,     0,  1119,     0,  1202,   150,  2583,
       0,   194,  2583,   728,  2583,  1569,   139,     0,   672,     0,
     840,  2619,   150,     0,     0,     0,     0,     0,     0,   142,
       0,     0,     0,     0,     0,     0,     0,   658,   669,  1605,
    1603,     0,  1236,   247,   246,  1234,   938,  2583,  1161,   145,
       0,     0,  2583,  1508,  2583,   145,   955,   939,     0,   925,
    2583,   145,  1125,  2583,  2444,   183,     0,   923,  2502,  2564,
    2583,   145,  1229,     0,  2583,   145,  2583,   179,  2583,   145,
    2583,   145,  2583,   673,     0,     0,  2583,   145,  2583,  2619,
     181,   942,  2583,   145,   949,  2583,   145,  2414,  2583,     0,
    1460,     0,  1597,     0,  1577,  2848,     0,  1724,  1016,  1015,
       0,  1016,     0,  1016,     0,  1016,     0,  1016,     0,     0,
       0,  1016,  2437,  2438,   998,     0,  1022,     0,  1030,     0,
    1029,  1028,  1027,     0,     0,     0,  1031,     0,  1858,  1632,
       0,  1441,  1456,     0,     0,     0,   142,     0,  1258,  1255,
     142,  1257,  1256,   142,   142,  1452,   252,   250,     0,     0,
       0,     0,     0,     0,  1458,     0,  1450,     0,     0,     0,
    2422,  2424,  2425,  2260,  2330,     0,  2799,  2800,  2801,  2319,
       0,  2802,  2803,  2804,  2863,  2134,  2120,  2129,  2135,  2121,
    2123,  2130,  2805,  2806,  2069,  2807,  2808,  2432,  2809,  2810,
    2811,  2813,  2814,  2815,  2816,  2817,  2818,  2819,  2820,  2821,
    2822,  2823,  2824,  2826,  2827,  2125,  2127,  2828,  2829,  2830,
    2832,     0,  2433,  2833,  2834,  2652,  2836,  2837,  2839,  2840,
    2131,  2842,  2843,  2132,  2844,  2845,  2846,  2847,  2431,   514,
    2133,  2849,  2851,  2852,  2853,  2854,  2856,  2857,  2858,  2859,
       0,     0,     0,  2409,     0,  2098,     0,  1935,  1936,  1959,
    1960,  1937,  1965,  1966,  1938,     0,  1939,  2408,  2002,  2205,
    2097,  2115,     0,  2103,  2104,     0,  2096,  2092,  2207,  1726,
    2404,     0,  2093,  2421,  2423,  2320,  1726,  2402,   214,   265,
       0,   266,  2410,  2726,   202,   244,   216,   243,   217,   215,
       0,  2500,   203,     0,     0,   204,     0,     0,     0,     0,
     262,   260,     0,  1448,     0,  1856,  1855,  2413,   960,     0,
    1566,  1563,  2270,     0,  1710,     0,     0,     0,  1975,  1962,
    1970,  1969,     0,  1952,  1951,  1950,     0,  1949,  1976,  1976,
    1974,  1953,  1926,     0,     0,     0,  1980,     0,  1978,  1922,
    1918,     0,  1987,  1988,  1989,  1986,  1999,  1985,     0,  1932,
    1990,     0,  1943,  1940,  1811,     0,  1690,  1689,     8,     0,
    1571,  1573,  1547,  1569,  1738,  1739,     0,     0,     0,     0,
       0,     0,     0,     0,  1798,  1756,  1757,  1759,  1795,  1799,
    1807,     0,  1696,     0,     0,     0,  1860,     0,     0,  1474,
       0,     0,     0,     0,     0,  1160,     0,     0,     0,     0,
     952,     0,     0,     0,  1494,     0,  1496,  1497,  1498,     0,
       0,     0,  1499,  1500,  1488,   256,  1507,  1504,  1487,  1489,
    1502,     0,     0,     0,     0,     0,     0,     0,  1519,     0,
     187,   188,     0,   685,   669,     0,  2583,     0,     0,     0,
       0,  1170,  1177,  1328,     0,     0,     0,     0,     0,     0,
       0,     0,  1171,  1169,     0,  1172,   258,  1182,  1209,  1212,
       0,     0,  1127,  1130,     0,     0,     0,     0,     0,  1319,
       0,     0,     0,  1319,     0,     0,     0,  1328,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   281,   283,   296,
     367,     0,   650,     0,     0,     0,   653,     0,  2583,  1329,
       0,     0,     0,  1231,     0,     0,     0,     0,     0,     0,
       0,     0,  1212,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   148,   149,   154,     0,     0,     0,     0,  1212,
       0,     0,     0,     0,     0,     0,     0,   636,   649,     0,
       0,     0,     0,     0,   646,     0,     0,   150,   286,   626,
     632,     0,     0,     0,   735,   734,     0,     0,     0,     0,
       0,     0,  1417,     0,  1416,     0,     0,     0,     0,     0,
    1517,  1516,     0,     0,     0,     0,     0,     0,     0,  1319,
       0,     0,   275,   277,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   404,
     405,     0,     0,     0,   154,     0,     0,  1319,     0,   288,
       0,     0,  1468,  1465,  1466,     0,  1471,     0,     0,     0,
       0,  2106,     0,  2274,  1748,  2272,  1145,  2326,     0,  2462,
    2884,  2885,  2886,  2887,  2888,  2889,  2890,  2891,  2892,  2893,
    2894,  2895,  2896,  2897,  2898,  2899,  2900,  2901,  2902,  2903,
    2904,  2905,  2906,  2907,  2908,  2909,  2910,  2911,  2912,  2913,
    2914,  2915,  2916,  2917,  2918,  2919,  2920,  2921,  2922,  2923,
    2924,  2925,  2926,  2927,  2928,  2929,  2930,  2931,  2932,  2933,
    2934,  2935,  2936,  2937,  2938,  2939,  2940,  2941,  2942,  2943,
    2944,  2945,  2946,  2947,  2948,  2949,  2950,  2951,  2952,  2953,
    2954,  2955,  2956,  2957,  2958,  2959,  2960,  2961,  2323,  2322,
    2417,  2463,  2464,  2465,  2466,  2329,  1539,     0,   233,   234,
     232,  1557,   235,  1558,  1553,     0,  1540,     0,     0,     0,
       0,     0,     0,     0,     0,  2502,  2564,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   848,  1488,  1526,     0,     0,     0,   678,
       0,  2583,     0,   152,   887,     0,   838,   471,     0,     0,
       0,     0,  1393,   152,     0,     0,   190,     0,     0,   732,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     839,     0,     0,   152,     0,  2583,   629,  2583,     0,   551,
     551,     0,     0,   141,   138,     0,     0,     0,     0,     0,
       0,     0,     0,  1682,  1681,  1684,  1683,     0,  1680,     0,
     143,   144,     0,  1219,  1244,     0,     0,     0,     0,     0,
     916,   941,     0,     0,  1213,     0,     0,  2583,   145,  2583,
       0,  2583,     0,     0,     0,  1221,   145,     0,  1215,     0,
       0,  1217,     0,  1419,     0,   932,   930,   929,   931,     0,
       0,   914,     0,     0,     0,     0,     0,   909,     0,     0,
     911,     0,     0,     0,     0,  1724,  1576,     0,  1006,     0,
    1010,     0,  1001,     0,  1007,     0,  1002,   999,  1000,     0,
    1005,     0,     0,   552,   554,     0,     0,  2527,  2544,     0,
    2572,  2607,  2608,  2662,  2680,  2710,  2716,  2722,     0,  2754,
    2766,     0,  1036,  1074,  1026,   744,     0,     0,  1642,  1442,
    2279,     0,  1724,     0,     0,  1259,     0,     0,   138,   251,
     223,     0,     0,  1074,     0,  2714,  1455,   991,   669,     0,
    2094,     0,  2101,  2102,  2318,     0,     0,     0,     0,     0,
       0,  2100,     0,     0,     0,     0,  2375,     0,     0,  2375,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2025,     0,     0,  2278,     0,     0,  2278,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2026,
    2007,  2008,  2098,  2270,     0,  2099,  2428,     0,  1998,  2467,
    2260,     0,  2257,  2258,  2259,  2962,  2963,  2964,  2965,  2966,
    2967,  2968,  2969,  2970,  2971,  2972,  2973,  2974,  2975,  2976,
    2977,  2978,     0,  2979,  2980,  2981,  2982,  2983,  2985,  2984,
    2986,  2987,  2988,  2989,  2990,  2991,  2333,  2993,  2994,  2995,
    2996,  2997,  2998,  2999,  3000,  3001,  3002,  3003,  3004,  3005,
    3006,  3007,  3008,  3009,  3010,  3011,  3012,  3013,  3014,  3015,
    3016,  3017,  3018,  3019,  3020,  3021,  3022,  3023,  3024,  3025,
    3026,  3027,  3028,  3029,  3030,  3031,  3032,  3033,  3034,  3035,
    3036,  3037,  3038,  3039,  3040,  3041,  3042,  3043,  3044,  3045,
    3046,  3047,  3048,  3049,  3050,  3051,  3052,  3053,  3054,  3055,
    3056,  3057,  3058,  3059,  3060,  3061,  3062,  3063,  3064,  3065,
    3066,  3067,  3068,  3069,  3070,  3071,  3072,  3073,  3074,  3075,
    3076,  3077,  3078,  3079,  3080,  3081,  3082,  3083,  3084,  3085,
    3086,  3087,  3088,  3089,  3090,  3091,  3092,  3093,  3094,  3095,
    3096,  3097,  3098,  3099,  3100,  3101,  3102,  3103,  3104,  3105,
    3106,  3107,  3108,  3109,  3110,  3111,  3112,  3113,  3114,  3115,
    3116,  3117,  3118,  3119,  3120,  3121,  3122,  3123,  3124,  3125,
    3126,  3127,  3128,  3129,  3130,  3131,  3132,  3133,  3134,  3135,
    3136,  3137,  3138,  3139,  3140,  3141,  3142,  3143,  3144,  3145,
    3146,  3147,  3148,  3149,  2040,  3150,  3151,  3152,  3153,  3154,
    3155,  3156,  3157,  3158,  3159,  3160,  3161,  3162,  3163,  3164,
    3165,  3166,  3167,  3168,  3169,  3170,  3171,  3172,  3173,  3174,
    3175,  3176,  3177,  3178,  3179,  3180,  3181,  3182,  3183,  3184,
    3185,  3186,  3187,  3188,  3189,  3190,  3191,  3192,  3193,  3194,
    3195,  3196,  3197,  3198,  3199,  3200,  3201,  3202,  3203,  3204,
    3205,  3206,  3207,  3208,  3209,  3210,  3211,  3212,  3213,  3214,
    3215,  2042,  3216,  3217,  3218,  3219,  3220,  3221,  3222,  3223,
    3224,  3225,  3226,  3227,  3228,  3229,  3230,  3231,  3232,  3233,
    3234,  3235,  3236,  3237,  3238,  3239,  3240,  3241,  3242,  3243,
    3244,  3245,  3246,  3247,  3248,  3249,  3250,  3251,  3252,  3253,
    3254,  3257,  3255,  3256,  3258,  3259,  3260,  3261,  3262,  3263,
    3264,  3265,  3266,  3267,  3268,  3269,  3270,  3271,  3272,  3273,
    3274,  3275,  3276,  3277,  3278,  3279,  3280,  3281,  3282,  3283,
    3284,  3285,  3286,  3287,  3288,  3289,  3290,  3291,  3292,  3293,
    3294,  3295,  3296,  3297,  3298,  3299,  3300,  3301,  3302,  3303,
    3304,  3305,  3306,  3307,  3308,  3309,  3310,  3311,  3312,  3313,
    3314,  3316,  3315,  3317,  3318,  3319,  3320,  3321,  3322,  3323,
    3324,  3326,  3325,  3327,  3328,  3329,  3330,  3331,  3332,  3333,
    3334,  3335,  3336,  3337,  3338,  3339,  3340,  3341,  3342,  3343,
    3344,  3345,  3346,  3347,  3348,  3349,  3350,  3351,  3352,  3353,
    3354,  3355,  3356,  3357,  3358,  3359,  3360,  3361,  3362,  3363,
    3364,  3365,  3366,  3367,  3368,  3369,  3370,  3371,  3372,  3374,
    3373,  3375,  3376,  3377,  3378,  3379,  3380,  3381,  3382,  3383,
    3384,  3385,  3386,  3387,  3388,  3389,  3390,  3391,  3392,  3393,
    3394,  3395,  3396,  3397,  3398,  3399,  3400,  3401,  3402,  3403,
    3404,  3405,  3406,  3407,  3408,  3409,  3410,  3411,  3412,  3413,
    3414,  3415,     0,  2254,  2255,  2256,  2248,  2249,  2250,  2251,
    2252,  2253,  2264,     0,     0,  2407,  2468,     0,  2207,     0,
    2022,     0,  2215,     0,     0,  1811,     0,  2426,  2321,  1811,
     267,   268,   264,     0,     0,   219,   218,     0,   237,   241,
     242,   213,   240,     0,   236,   221,  2191,  2190,   220,   212,
     209,   207,   224,   226,   227,   210,   208,   261,     0,     0,
       0,   145,  1574,  1561,     0,     0,  2333,     0,  2268,     0,
       0,  2266,     0,     0,     0,  1808,     0,  1712,     0,  1716,
       0,     0,     0,  1973,  1972,  1923,  1919,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     953,     0,  1941,     0,  1876,  2450,  2451,  2331,  1744,  1574,
       0,  1570,  1707,  1706,  1749,  1750,  1111,  1705,  1778,  1779,
       0,     0,     0,     0,  1804,  1802,  1769,  1760,  1768,     0,
       0,  1766,     0,  1770,  2002,  1797,  1694,  1754,  1755,  1758,
    1693,     0,  1800,     0,  1645,  1798,  1759,  1629,     0,  1607,
       0,     0,  1861,     0,     0,  1475,     0,     0,     0,  1140,
    1142,     0,  1141,     0,  1144,     0,  1153,     0,     0,  1139,
    1158,     0,  1147,  1145,     0,  1515,     0,     0,     0,     0,
       0,  1495,     0,     0,     0,  2754,   255,  1498,  1503,  1490,
    1501,     0,     0,     0,     0,     0,  1076,  1075,     0,     0,
       0,  1522,   545,     0,   369,     0,     0,     0,     0,     0,
       0,     0,     0,   834,   831,     0,     0,   830,     0,   683,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   708,     0,  1319,     0,   294,     0,  1179,     0,  1178,
       0,  1183,     0,     0,  1180,  1175,  1176,  2716,  2726,  2761,
     257,  1181,  1211,     0,  1210,  1206,     0,  1122,     0,  1123,
       0,     0,     0,     0,     0,     0,     0,  2556,     0,  2583,
       0,   514,   307,   331,   536,     0,  1318,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   353,     0,     0,   356,   355,     0,     0,     0,
       0,     0,   361,     0,   339,     0,   340,     0,   360,     0,
       0,     0,   651,   652,     0,     0,     0,  1319,     0,   290,
       0,     0,     0,     0,     0,     0,     0,     0,  1228,     0,
     761,     0,     0,  2716,  1207,     0,  1402,     0,  2753,  1403,
    1406,   551,     0,   551,  1408,     0,     0,  1405,  1407,     0,
       0,   176,     0,   171,   175,     0,     0,  2716,  1208,     0,
       0,     0,     0,     0,   634,   635,   648,     0,   639,   640,
     637,   641,   642,     0,     0,     0,     0,     0,     0,     0,
     633,     0,     0,   730,   729,   733,     0,     0,     0,     0,
       0,     0,  1411,     0,     0,  1202,     0,     0,  1410,  1418,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1262,  1261,     0,     0,     0,     0,  1329,     0,
     877,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   178,   748,     0,   747,     0,   172,   177,     0,     0,
       0,     0,     0,     0,     0,     0,   231,  1464,  1470,  1748,
    1748,  1748,  2112,     0,     0,     0,     0,  1747,  2324,  2327,
    1544,  1550,  1543,  1542,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   418,   415,   416,   418,     0,     0,     0,     0,   850,
       0,   853,   856,  1486,   498,     0,     0,   675,   708,     0,
       0,   474,   185,     0,     0,     0,     0,   763,     0,  1202,
    1201,   147,   138,   194,   472,     0,   193,   195,   197,   198,
     199,   196,   200,     0,   727,   731,     0,     0,     0,     0,
     671,     0,     0,     0,     0,     0,     0,     0,  1881,     0,
       0,   170,     0,     0,   624,   628,     0,     0,     0,     0,
     474,   590,   380,  2583,     0,   551,     0,  2583,     0,   137,
       0,   837,     0,     0,     0,  1164,  1164,     0,     0,   777,
     776,     0,     0,     0,     0,     0,     0,  1679,   145,  1162,
       0,  1509,     0,   145,   956,   145,  1126,   184,  2445,     0,
     918,     0,     0,     0,     0,   145,  1230,   906,   145,   180,
     145,   145,   674,     0,   145,   182,     0,     0,   145,   950,
     145,  2415,     0,   145,  1600,  2583,   551,  1578,  1003,  1012,
    1011,  1009,  1008,  1004,     0,  1023,     0,   550,     0,     0,
       0,     0,     0,  1044,  1045,     0,     0,  1041,  1046,     0,
    1048,  1032,  1034,  1042,  1043,  1049,  1038,  1037,  1050,  1051,
       0,     0,     0,  1063,   742,     0,     0,     0,     0,  1639,
       0,  1637,     0,  1859,  1641,  1630,  1590,     0,  1589,     0,
     617,  1253,  1252,  1254,     0,  1020,     0,   145,     0,  1454,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2283,     0,  2284,     0,     0,  2317,  2313,     0,     0,
       0,     0,     0,  2287,  2290,  2291,  2292,  2289,  2293,  2288,
       0,     0,  2294,     0,     0,  2368,  2385,     0,  2098,  2368,
    2396,     0,  2395,  2401,     0,  2274,  2002,     0,     0,  2392,
    2386,     0,  2392,     0,     0,  2375,     0,     0,     0,     0,
    2175,     0,     0,     0,  2274,  2277,     0,     0,  2840,     0,
       0,     0,     0,  2070,     0,     0,  2241,     0,  2274,     0,
       0,     0,     0,     0,     0,     0,  2270,  2309,     0,   512,
       0,  2060,     0,     0,     0,  2189,     0,  2186,     0,     0,
       0,     0,  2330,     0,     0,  2429,  2003,  2018,  2019,  2020,
    2023,  2406,  2006,     0,  2332,     0,     0,  2004,  2031,     0,
    2310,  2056,     0,  2061,  2046,  2376,  2295,  2296,  2297,  2298,
    2063,     0,  2039,  2044,  2048,     0,  2385,  2027,     0,  2024,
       0,  2333,  2269,     0,  2267,     0,  2015,  2016,  2017,  2009,
    2010,  2011,  2012,  2013,  2014,  2021,  2245,  2243,  2244,     0,
       0,  2215,     0,     0,  2043,     0,     0,  2114,  2575,  2614,
       0,  1737,  1737,  1737,  1725,  1735,  2405,  1876,  1748,  1876,
    2411,     0,     0,  1998,     0,  1857,   958,   959,   957,  1546,
    1560,  1574,  2271,  1568,  1714,     0,     0,     0,  1942,  1955,
       0,  1982,  1983,  1984,  1984,     0,  1924,     0,  1967,  1992,
    1993,  1994,  1995,  1996,  1997,     0,  1991,  1933,   954,  2816,
    2825,     0,  2712,  2860,     0,  1837,  1810,  1812,  1822,  1837,
    1844,  1837,  1837,  2116,  1874,  2117,  2118,  2412,     0,  1781,
    2447,  1548,  1572,     0,  1109,  1110,     0,  1114,  2840,  2712,
       0,     0,     0,     0,  1771,  1805,     0,  1796,     0,  2422,
    1772,  2421,  1773,  1776,  1777,  1767,  1806,  1643,     0,  1801,
    1698,  1697,     0,  1879,     0,     0,     0,  1621,  1609,     0,
       0,  1862,     0,  1811,  1647,     0,  2330,  1809,  1369,  1263,
    1330,  1143,     0,  1943,  1154,     0,  1138,     0,  1137,  1943,
       0,  1155,     0,  1943,  1370,  1264,  1331,  1371,  1265,  1332,
    1372,  1506,  1266,  1505,  1493,  1492,  1491,     0,     0,     0,
       0,     0,     0,     0,     0,   815,  2583,   145,  1520,  1373,
       0,  1267,   368,  1521,  1333,  1525,   833,   832,     0,     0,
    1334,     0,   684,   689,     0,   691,   692,  2502,  2564,   693,
     696,   697,     0,   699,   688,   687,     0,     0,     0,     0,
       0,   705,   710,     0,     0,     0,     0,     0,     0,  1173,
    1174,  1374,  1270,     0,  1335,     0,  1121,     0,  1271,   186,
       0,     0,   282,     0,  2583,   309,     0,     0,     0,     0,
       0,     0,     0,     0,   815,   496,   815,     0,  1321,   306,
     337,     0,   352,   347,   348,   346,  2583,   145,  2583,   145,
       0,     0,     0,     0,     0,   349,   344,   345,   341,     0,
       0,   354,  2474,  2546,  2727,     0,   716,   718,     0,   723,
     357,  1291,   376,   375,   374,     0,   362,     0,   381,   384,
       0,   359,   338,   336,   333,   297,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1223,     0,  1377,
    1336,     0,  1358,  1362,     0,     0,     0,   755,  1380,  1277,
    1339,     0,   551,     0,     0,   566,   566,   551,  1391,  1278,
     174,  1308,   163,     0,     0,   159,     0,     0,     0,     0,
     153,  1381,  1279,  1340,     0,     0,  1382,  1280,     0,     0,
     287,   627,   638,   643,  1285,   647,   644,  1348,   645,  1389,
    1281,     0,  1385,  1311,  1343,   394,   610,   393,  1202,  1202,
    1392,  1412,  1282,  1202,     0,  1319,     0,   276,   278,     0,
     142,     0,     0,  1283,     0,  1341,     0,  1384,  1310,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1528,     0,
       0,     0,     0,     0,     0,   145,     0,     0,     0,  1321,
    2583,   145,   875,  1383,     0,  1316,     0,  1356,     0,     0,
       0,   406,     0,  1309,  1319,     0,   289,  1287,     0,  1350,
       0,     0,   229,   228,   230,     0,     0,     0,     0,  2275,
    2276,     0,  2273,  2107,  2326,     0,  1538,   980,   966,   979,
       0,   962,  2544,     0,   965,   967,     0,     0,     0,   968,
     972,   973,     0,   964,   961,   963,     0,   417,     0,     0,
     772,   773,     0,     0,     0,     0,   852,     0,     0,  1518,
       0,   150,   682,     0,     0,     0,   677,   707,   712,     0,
       0,     0,     0,   473,   477,   481,   482,   483,     0,     0,
       0,     0,   164,   151,     0,   895,     0,   551,     0,   765,
    1202,  1395,     0,   194,   189,     0,     0,   728,     0,  1569,
       0,     0,   605,   608,   607,     0,   380,   847,   845,   844,
     846,   868,   843,     0,  1880,  1882,     0,     0,     0,     0,
       0,     0,   617,   476,     0,     0,   554,     0,   593,     0,
       0,     0,     0,   590,     0,     0,     0,  2455,     0,   864,
     836,     0,  1132,     0,  1150,  1133,     0,     0,     0,     0,
    1187,  1194,  1163,  1188,  1165,  1194,     0,     0,   778,   782,
     781,   785,   783,     0,   779,   656,  1685,  1686,     0,  1220,
       0,     0,  1514,     0,  1512,   917,  1214,   145,     0,   145,
       0,   145,  1222,  1216,  1218,  1420,     0,   915,     0,     0,
     908,   910,     0,   912,     0,  1024,   553,     0,     0,     0,
       0,     0,     0,  1040,   654,  1047,     0,     0,     0,  1062,
    1057,  1059,     0,  1074,  1068,     0,   741,     0,     0,  1640,
    1633,  1635,  1634,     0,     0,  1631,  2280,   907,     0,   623,
       0,  1074,  1065,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1742,  2281,  2282,     0,     0,     0,
    2314,     0,     0,  2151,     0,  2122,  2124,  2137,     0,  2152,
    2105,     0,  2367,  2364,     0,     0,     0,  2368,  2375,  2171,
       0,     0,     0,  2375,     0,  2395,     0,     0,     0,  2166,
    2168,     0,     0,     0,  2385,  2385,     0,  2173,     0,     0,
    2153,  2126,  2128,  2138,     0,     0,  2261,     0,  2141,  2140,
       0,  2072,  2073,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2087,  2142,  2240,     0,     0,     0,  2144,  2143,     0,
       0,  2308,     0,     0,     0,  2149,   513,  2154,     0,     0,
       0,     0,  2160,     0,  2197,     0,     0,     0,  2095,  2271,
       0,     0,     0,     0,     0,     0,     0,  2378,  2379,  2380,
    2377,     0,  2062,  2047,  2065,  2041,  2045,  2049,     0,  2385,
    2064,  2067,     0,     0,  2035,     0,     0,  2033,  2057,  2029,
       0,     0,  2058,     0,  2113,     0,     0,     0,  2218,  2213,
    2214,  1737,  1737,  1737,  1737,  1734,     0,     0,     0,  1781,
       0,  1781,   205,     0,   238,   225,  1545,  1715,  1724,  1961,
       0,  1979,  1977,  1920,  1925,  2000,     0,  1837,  1844,  1837,
    1837,     0,     0,  1700,     0,  1822,     0,  1836,  1820,  1835,
       0,     0,  1850,  1848,     0,  1850,     0,  1850,     0,  1814,
       0,  1840,  1816,  1835,  1818,  1824,     0,  1866,  2413,  1875,
       0,  1794,  1751,     0,  2262,  1114,     0,  1753,  1775,  1774,
       0,  1764,     0,  1803,  1761,  1644,  1628,     0,  1626,  1613,
    1615,  1614,     0,     0,  1616,  2330,     0,  1626,  1608,     0,
    1652,     0,     0,  1879,     0,  1651,     0,  1943,  1135,  1136,
       0,  1159,     0,  1079,  1080,     0,  1078,     0,     0,     0,
     544,   547,     0,  1523,     0,  1390,  1307,   686,     0,     0,
       0,     0,   701,   660,   702,   704,     0,     0,   703,   706,
     709,  1319,     0,   295,  1293,     0,  1354,  1167,     0,     0,
    1124,     0,     0,     0,     0,     0,  1095,   535,  1094,     0,
       0,     0,     0,   815,     0,     0,   539,     0,   495,   492,
     332,     0,     0,     0,     0,   389,     0,   311,   324,   387,
     330,     0,   364,     0,   335,     0,   328,   350,   342,   351,
     343,   363,   365,     0,   720,   721,   719,   715,     0,   722,
     724,     0,   378,     0,     0,     0,   396,   358,   395,     0,
    1376,     0,  1319,     0,   291,  1289,     0,  1352,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1357,     0,     0,     0,     0,   760,     0,   757,     0,   566,
       0,  1404,     0,  1401,  1399,   566,     0,     0,   156,   155,
       0,   162,     0,     0,     0,     0,     0,     0,  1413,  1414,
    1415,     0,     0,     0,     0,     0,     0,   400,     0,   301,
     303,   302,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   407,   371,     0,   871,     0,     0,     0,   409,     0,
       0,  1368,     0,     0,     0,     0,     0,  1375,  1272,  2110,
    2111,  2108,  1748,  2325,     0,     0,     0,   977,     0,     0,
       0,     0,   420,   421,   150,   419,   444,     0,   815,     0,
       0,   849,   854,   862,  2652,  2248,  2249,   860,   855,   857,
     859,   861,   858,     0,     0,     0,     0,   517,     0,     0,
       0,   504,     0,     0,   514,   497,   500,   501,     0,     0,
     678,   681,   679,   680,     0,   700,     0,   476,   524,   580,
       0,   166,     0,     0,   167,   165,     0,     0,   380,   762,
       0,   759,  1394,     0,   192,     0,   732,     0,     0,     0,
       0,     0,  1202,   670,     0,   867,   869,   841,     0,   712,
       0,     0,   629,     0,   551,  1601,   612,     0,   582,   476,
     580,   589,     0,     0,   597,   379,     0,     0,   617,   380,
       0,     0,  1095,     0,   863,     0,     0,  1131,     0,     0,
       0,  1184,  1189,  1185,     0,  1164,  1146,     0,  1186,     0,
       0,  1192,  1117,  1166,  1118,  1436,  1437,  1434,  1435,     0,
       0,     0,     0,     0,     0,  1676,     0,     0,  1510,     0,
     919,     0,   902,     0,   904,   145,   749,     0,   145,     0,
       0,     0,     0,     0,     0,  1039,     0,  1033,  1035,  1060,
       0,     0,  1074,  1073,     0,  1064,  1072,  1070,  1071,  1069,
       0,     0,  1638,  1636,   615,     0,     0,   145,  1074,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2285,
       0,  2316,  2312,     0,  2119,  2286,  2366,  2382,  2384,  2172,
    2374,     0,     0,     0,  2397,     0,     0,  2375,  2335,  2389,
    2388,     0,     0,  2387,  2375,  2375,  2335,  2174,  2335,     0,
       0,     0,  2241,     0,     0,  2071,  2083,  2084,  2085,  2301,
       0,  2090,     0,  2080,  2081,  2082,  2074,  2075,  2076,  2077,
    2078,  2079,  2086,  2305,  2304,     0,     0,  2146,  2147,  2148,
    2307,  2155,     0,  2492,  2198,     0,  2159,  2188,  2187,     0,
       0,     0,  2162,     0,     0,  2184,     0,  2242,  2430,  2005,
       0,     0,  2032,  2311,  2050,     0,  2066,  2068,  2028,  2261,
       0,     0,     0,     0,     0,  2037,     0,     0,  2238,     0,
       0,     0,  2220,  2217,     0,     0,     0,     0,  1728,  1727,
    1733,  1794,  2107,  1794,     0,     0,  1921,     0,  1821,  1817,
    1819,  1825,     0,  2855,     0,  1826,  1833,     0,  1813,     0,
    1849,  1845,     0,  1846,     0,     0,  1847,     0,     0,  1815,
       0,  1833,     0,  1873,  1740,     0,  2209,     0,  1752,  1112,
    1113,  1762,     0,  1765,  2523,  1877,     0,  1627,     0,     0,
       0,  1618,  1624,  1606,     0,     0,     0,  1648,  1626,  1649,
    1156,     0,     0,  1148,  1085,  1086,  1089,  1087,  1084,  1088,
       0,     0,     0,   815,   818,     0,     0,     0,   816,   145,
    1268,     0,     0,     0,     0,   661,  1388,  1269,     0,     0,
       0,     0,  1168,  1322,     0,     0,  1292,   815,     0,     0,
       0,   561,     0,  1108,  1108,     0,   308,     0,   541,   602,
       0,   494,   493,     0,   491,   712,     0,     0,   315,   325,
       0,   320,     0,  1320,     0,     0,     0,     0,   319,   322,
     321,   391,     0,   388,     0,   145,   145,   366,   717,   377,
     382,   383,   386,  1327,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   896,   879,     0,
       0,   897,   898,     0,     0,     0,  1225,  1226,  1224,  1359,
    1360,  1366,  1363,  1361,  1365,  1367,  1364,     0,  1275,     0,
       0,   753,  1323,  1396,  1398,  1397,     0,  1400,   160,   157,
     158,   161,  1324,  1305,  1286,  1349,   611,     0,     0,     0,
    1284,     0,  1342,     0,     0,  1301,  1295,     0,     0,     0,
       0,     0,     0,  1387,  1315,  1347,  1386,  1313,  1345,  1312,
    1344,  1314,  1346,  1306,     0,     0,  1884,   876,     0,     0,
       0,   145,   145,   874,   751,  1288,     0,  1351,  1297,     0,
       0,     0,   969,     0,     0,     0,   971,   425,   445,   150,
       0,   771,   835,     0,     0,   851,     0,   502,     0,   508,
     515,     0,     0,   519,   520,   518,   503,  1202,   551,  1202,
     804,   805,     0,     0,   825,     0,   676,     0,     0,   474,
       0,   521,     0,     0,   478,   169,   168,     0,     0,     0,
     766,   770,   768,   767,   769,   764,     0,   755,   194,  2583,
       0,     0,     0,     0,   609,   603,   606,  1409,   842,     0,
    1883,   745,     0,   380,   625,     0,     0,     0,   474,   617,
       0,   479,   484,   485,   498,     0,   590,   581,     0,   582,
     591,   592,     0,   599,  1484,     0,   618,   599,     0,     0,
       0,   866,     0,   865,     0,  1134,  1151,  1152,     0,     0,
    1194,     0,     0,  1196,  1191,     0,     0,   784,   787,   780,
     663,   145,     0,  1513,   145,   145,  1251,     0,   913,  1054,
    1055,  1056,  1053,  1052,   655,     0,  1058,  1017,  1067,   743,
       0,   616,     0,  1018,   145,   994,   986,   993,   982,   985,
     987,     0,   989,   990,   984,   981,   983,  2315,  2136,     0,
    2381,  2383,  2170,  2394,  2393,  2169,  2400,     0,     0,  2363,
    2391,  2390,     0,     0,  2375,  2375,  2139,  2150,     0,  2240,
    2271,     0,     0,  2091,     0,     0,     0,  2145,  2850,     0,
       0,  2202,  2203,     0,  2199,  2200,  2195,  2196,  2161,     0,
    2640,  2179,     0,     0,  2194,  2054,  2052,  2051,  2036,     0,
       0,  2034,  2030,     0,  2059,  2204,  2237,  2271,  2206,     0,
    1748,  1732,  1731,  1730,  1729,  2209,  2427,  2209,   239,  1719,
       0,  1869,     0,  1872,     0,     0,  1823,     0,     0,  1827,
       0,     0,  1829,  1831,     0,     0,     0,     0,     0,     0,
    2416,     0,  1793,     0,  1748,     0,  1763,     0,  1625,  1610,
       0,  1611,  1617,     0,     0,     0,     0,     0,  1653,  1646,
    1149,  1157,     0,     0,     0,   546,   820,   819,   822,   817,
     821,  1524,     0,   694,   695,   698,  1294,     0,  1355,  1303,
       0,  1642,   537,   310,     0,   556,     0,     0,     0,  1101,
     140,  1100,     0,   556,   556,   490,   489,   498,   318,     0,
       0,     0,   312,   390,     0,   392,   313,   317,   371,   334,
     327,     0,     0,     0,  1290,     0,  1353,  1299,  1326,  1378,
    1273,  1337,     0,     0,   885,     0,     0,     0,     0,  1379,
    1274,  1338,     0,     0,     0,     0,     0,  1642,     0,     0,
       0,     0,     0,     0,     0,     0,   298,     0,     0,     0,
    1533,     0,     0,   370,   873,   872,   371,   408,  1317,     0,
    2109,     0,   970,   975,   976,   974,     0,   414,   422,   425,
       0,     0,  1242,  1242,     0,     0,   499,   516,     0,   601,
     560,   601,     0,     0,     0,     0,     0,   713,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   758,   757,
     191,     0,   474,     0,   712,     0,   870,     0,     0,     0,
     617,   476,     0,     0,  1598,   475,     0,     0,   487,     0,
     593,   582,   590,     0,     0,   614,     0,  1477,     0,   620,
       0,     0,     0,   814,  1190,     0,  1204,     0,  1145,  1115,
    1199,     0,  1724,  1876,     0,     0,     0,     0,   797,     0,
     667,  1243,  1511,   903,   905,   750,  1061,     0,  1074,  1066,
     988,  2365,  2399,  2334,  2336,     0,     0,  2357,  2350,  2353,
    2351,  2352,  2354,     0,  2349,     0,  2167,  2398,  2347,  2361,
    2300,  2242,  2088,     0,  2303,  2302,  2306,     0,  2156,     0,
    2157,  2201,  2163,  2180,     0,  2164,  2192,     0,     0,  2055,
    2053,  2038,  2239,     0,  2224,  1702,  1701,     0,  1722,  1905,
    1874,     0,     0,  1868,     0,     0,  1899,     0,     0,     0,
    1834,  1852,     0,  1830,  1828,     0,  1841,     0,  1843,  2522,
    2811,  2709,     0,  1780,  1782,  1785,  1787,  1786,  1788,  1784,
    2208,  2210,     0,  1759,  2263,  1878,     0,     0,     0,  1096,
       0,     0,  1626,  1655,  1667,  1667,  1650,  1062,     0,   145,
     690,     0,     0,   284,  1108,     0,  1202,   562,  2652,   563,
    1107,  1111,   139,     0,  1202,  1202,   486,     0,   316,   326,
       0,   373,   385,     0,  1642,     0,     0,   883,   892,   892,
     880,     0,     0,   899,  1276,   754,     0,   565,     0,   279,
    1302,  1296,     0,     0,     0,   305,     0,   304,     0,  1535,
    1536,     0,     0,     0,     0,     0,  1325,   145,  1298,   978,
       0,   447,   455,   426,   430,  1527,     0,  1527,     0,   427,
     431,  1527,  1527,   424,  1876,   443,  1242,     0,  1239,  1238,
     549,   631,     0,     0,   506,     0,   571,   505,     0,   826,
       0,     0,   711,     0,   476,   580,     0,   534,   525,   526,
     527,   528,   530,   529,   531,   532,   533,   523,   522,     0,
     712,   889,   380,  1484,   752,     0,     0,   725,     0,   712,
       0,  1601,   613,   582,   476,   580,   480,   498,     0,   597,
     590,   593,     0,   594,     0,   598,     0,     0,     0,   617,
    1537,  1095,     0,     0,   815,  1203,  1164,     0,     0,  1193,
    1197,  1198,     0,     0,     0,     0,  1246,   791,   792,   786,
     788,     0,   799,   803,   662,     0,     0,   666,   657,   712,
     145,     0,     0,  2348,  2355,  2356,     0,  2177,     0,     0,
    2373,     0,     0,     0,  2089,     0,     0,  2182,  2181,  2193,
    2165,  2219,     0,     0,     0,     0,     0,     0,     0,  1713,
       0,  2335,  1867,  1870,     0,  1902,     0,     0,     0,     0,
    1887,     0,  1832,     0,     0,  1842,     0,     0,     0,  1789,
       0,     0,     0,  1798,     0,  1623,  1876,     0,  1620,     0,
    1662,     0,  1654,  1656,     0,     0,     0,  1081,     0,  1082,
    1304,     0,  1102,     0,   601,     0,  1114,  1111,   551,   601,
     601,   631,     0,     0,   329,     0,   292,  1300,     0,     0,
     894,   894,     0,     0,     0,     0,     0,     0,   402,     0,
       0,   300,   299,  1529,     0,  1530,  1531,  1534,   410,   423,
       0,   453,   452,     0,   450,   449,   451,     0,   440,     0,
       0,     0,     0,     0,     0,   413,  1237,  1241,  1240,     0,
     507,     0,   509,     0,     0,   557,   558,   559,     0,   511,
     567,   568,   823,     0,   828,     0,   714,     0,     0,   712,
     579,   736,     0,     0,     0,  1478,     0,     0,   604,   746,
    1484,   617,   590,     0,   582,   488,     0,   599,   593,   597,
     595,   596,     0,  1481,     0,   619,     0,  1104,   813,     0,
    1194,  1205,  1200,  1195,  1440,     0,     0,   789,   794,   793,
    1527,   798,     0,     0,     0,   665,   664,   740,  1019,  2337,
    2338,  2362,     0,     0,     0,  2341,     0,  2339,     0,     0,
    2361,     0,  2178,  2299,  2185,  2158,  2183,  2798,  2523,  2769,
       0,  2236,  2225,  2236,  2236,  2216,     0,     0,     0,  1904,
       0,     0,     0,  1900,  1901,  1885,     0,     0,  1889,  1839,
    1865,     0,     0,     0,  1783,  2211,  2212,  2446,  1612,  1622,
    1097,     0,  1664,  1666,     0,     0,     0,  1642,     0,   566,
       0,  1098,  1114,   560,   815,   815,   323,   314,   372,     0,
       0,     0,   890,   893,   881,   882,   901,   900,   756,  1642,
       0,   398,   397,     0,   401,     0,   448,   458,     0,   456,
     428,   433,     0,   439,   438,   435,   434,   429,   432,   548,
       0,     0,     0,     0,     0,     0,   569,     0,   570,     0,
     827,     0,     0,     0,   738,   888,     0,     0,   474,   712,
    1479,  1599,   593,   582,   590,     0,     0,   584,  1108,  1108,
     461,   597,   599,  1482,  1483,     0,     0,   514,     0,  1116,
    1439,  1438,  1724,     0,     0,     0,   800,   801,   796,     0,
       0,  2342,     0,  2345,     0,  2346,  2340,  2370,  2372,     0,
    2358,  2359,     0,  2229,  2228,  2227,  2231,  2230,     0,  2223,
    2221,  2222,     0,     0,     0,     0,  1871,     0,  1888,  1891,
       0,     0,     0,  1897,     0,  1890,  1892,     0,  1851,     0,
    1863,  1791,     0,  1790,  1876,     0,  1669,     0,     0,  1657,
    1658,     0,     0,  1659,   145,   285,   555,   815,   564,  1099,
     571,   540,   538,  1642,   884,     0,   280,     0,   403,  1532,
     454,     0,   437,   436,   630,   510,   600,   576,     0,   575,
       0,   573,   572,   824,   829,     0,   712,   878,  1484,   726,
     597,   590,   593,     0,   583,     0,   140,   140,   599,   459,
       0,     0,   380,     0,  1422,  1724,  1421,  1423,  1431,  1428,
    1430,  1429,  1427,     0,  1249,  1250,   790,   795,     0,     0,
    2343,  2344,     0,     0,  2176,     0,     0,     0,  2233,     0,
    2234,     0,     0,     0,     0,     0,  1894,  1895,  1896,  1898,
    1893,  1838,     0,  1792,  1619,  1663,  1665,  1660,     0,  1661,
       0,     0,     0,     0,  1670,  1083,   542,   815,   293,   891,
       0,   457,   574,   551,   551,   712,   737,  1480,   599,   593,
     597,  1108,   585,   587,   586,   463,  1104,  1105,     0,   599,
     803,     0,  1432,  1426,  1700,  1687,     0,     0,   802,     0,
       0,     0,     0,  2226,  2232,  2235,     0,     0,     0,     0,
    2633,     0,  1906,     0,     0,     0,  1668,  1674,     0,     0,
       0,   543,     0,   578,   577,   739,   462,   597,   599,   140,
     514,  1103,     0,  1876,     0,  1424,  1724,     0,     0,   808,
    2369,  2371,  2360,  1718,  1717,  2816,     0,     0,  1721,  1914,
       0,  2363,     0,     0,  1917,     0,  1864,     0,     0,     0,
     399,   599,   460,   588,   380,  1106,  1090,     0,  1425,     0,
       0,   810,     0,   806,   809,   811,   812,     0,     0,     0,
       0,  1907,  1908,  1917,     0,  2347,  1917,  1886,  1671,  1675,
       0,  1672,   464,   599,     0,     0,     0,   774,     0,  1748,
       0,     0,     0,  1903,  2363,  1916,  2373,  2347,     0,  1876,
       0,     0,     0,   807,     0,     0,     0,     0,  1911,  2361,
    2373,     0,  1091,   808,  1247,  1248,     0,  1720,     0,     0,
    1909,  2361,  1673,     0,     0,  1912,  1910,   775,     0,  1913
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -5894, -5894, -5894,  4135,  -444, -1733, -5171, -1133,  -901, -5894,
   -5894,  -865, -1364,  3368, -1041, -5894, -5894, -5894,  1497, -5894,
   -5894, -5894, -5894,  4103, -5894, -2964, -5894, -5894,   206,  4054,
   -1386,   185,  3675,  1642, -5894, -1008, -5894, -5894,  -627,     1,
   -5894,  4056,   496, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894,  -697, -5894,  -599,  2107, -5894,  2201,  1432, -3832, -5894,
   -5894, -1541, -3811, -5894,   680, -5894,   707, -4074, -5894, -4861,
    -996, -5894, -5894, -5894,  2088, -5894, -5894, -5894,  2036,  1222,
    -350, -5894, -5894, -5894, -5894, -5894, -5894,  -818, -5894, -5894,
   -1127,     2,  -662, -2994, -4377, -5894, -5894,   525,  -390, -1502,
   -5894,   721, -5894,   723, -5894, -4893, -5894,    23, -2770, -2575,
   -5894, -5894, -5894,  -362, -1500,  1467, -5894,  1530, -5894,  -773,
   -1147,  1910, -2394,  -956, -5894,  -248, -3610, -1101,  -831,  -829,
    -992, -4427, -4951, -5894, -5894, -1131, -3827, -5245, -5493, -4979,
   -4878,  1477, -5894,    -8,   529, -5894,     3, -3706, -3812,     5,
     502, -5894,     6,     7, -5894,   519,  -758,  -978, -1614, -5894,
    -896, -5894, -5894, -5894, -3496, -5894, -5894, -5894,   186, -5894,
   -5894, -5894, -5894,   564, -5894, -5894, -5894, -5894, -5894, -5894,
   -2478,  2057,  2058, -5894, -4438, -5894,  -932, -5894,   729, -3543,
    1458, -5894, -5894,  1216,  4123,   548, -5894, -5894, -5894, -5894,
   -5894, -5894, -1815, -5894, -5894, -5894, -5894,    11,  -332, -5894,
   -5894, -5894, -5894, -5894, -5894, -5894,     8, -5894,  1177,   486,
   -5894, -5894,  -649, -5894, -5894, -5894, -5894, -5894, -5894, -1188,
   -5251, -1319, -1293, -5894, -3506, -5894, -5894, -5894,  -307, -5894,
   -5894, -5894, -5894, -5894,  -882, -5894,  1275, -4210, -5894, -5894,
     523, -5894, -5894, -5894, -5894, -5894,  -963,  -244,  3291, -5894,
    -504,  -735, -5894, -5894, -5894,  -241, -5894, -5894, -5894, -5894,
   -5894,  -521, -1271,  5141,  4497, -1122, 16866,  -841,  -574, -5894,
   -5894, -5894, -2707, -5894, -5894, -4283, -5894,  5132,  2574,  1679,
      12, -5894,    29,   101,  3926, -5894,  1136, -1173, -3147,   483,
    -461, -5894, -5894, -5894,   484, -5894, -1949, -5894, -5894, -5894,
   -5894, -4166,    13, -5894, -4440, -5246, -4669, -4224, -1159, -5894,
   -4904, -5243, -4142, -5894,  2090, -5894, -5894,  -576,  -150,  3254,
   -5894, -1486,  2435, -1429, -5894, -2508,   549,  1626,  3264, -3316,
    -100,  3252, -3045, -5894,  -664,  1208, -5894,  -330, -3834, -5894,
   -5894, -5894, -2838,  -594, -5894, -5894,  1475,   -75, -5894, -5894,
   -5894, -5894,  -670,  3233,  -178, -5894, -5894,  4469, -5894, -5048,
   -5894,  4434, -5894, -5894, -5894, -5894, -5894, -5894, -5894, -5894,
   -5894, -1480,  1387, -5894,  -791, -5894, -5894,  2198,   767, -5894,
   -5894, -5894, -5894,  1476, -1234, -5894, -5894, -5894, -5894, -5894,
   -5894, -5894,  -943, -1172, -5894, -5894, -4613, -5894, -5894, -5894,
   -5894, -5894,  2471,  -965,  -760,  4343,  1100,    14, -5439, -5894,
   -5894,  -491, -5894,  3680, -5894, -5894, -5894, -5894, -5894,   545,
     550, -5894, -5894, -5894, -5894, -4031, -5894, -5894, -5064, -5894,
   -5894,  2177, -5894, -5894,  1361,    16,  3389, -5894, -5894, -5894,
      -3, -5894, -5894, -1028,  2531, -5894, -2426, -5894,  -597, -5894,
   -5894, -1923,    20, -4425, -5894,    51, -5894, -5894, -5136, -1091,
     344, -5894, -5894, -4137,    58, -5894, -5894, -5894, -5894, -5107,
   -5894,    61, -5661,   916, -3381, -5894,    10, -5894,  -403, -5894,
   -5894,  -405, -5894, -5894, -5894, -5893,    22,    31, -5894, -5894,
      60,   921,   -47,   -32,   -28,    21,   151,  3796, -5894, -5894,
   -5894, -4431,  3839, -5894,     9,  -867,  5183,  5184, -5894,  -923,
    -134,   500,  1734,  -677, -2634,  3742,  3746, -5894,  1721,  2540,
   -2493, -2481, -5894, -1174,  -808,  -614, -5894, -5894, -5894, -5894,
   -1726,  -675, -2636, -5894,  3749, -5894, -5894, -5894, -2359, -3414,
   -3331,  1769, -3336, -3233, -5894,  1006,   991, -1167,   -57,   105,
   -1478,  -782,  1635, -5894, -5894,  1779,  -329, -5894, -5894,  -331,
   -3322,   951, -5894, -4637, -2855,  1780, -1099,  -780, -5894,  -928,
   -5894,  -579,  1788, -5894, -4032, -1132, -5894, -3046,  1639,  3820,
    -833, -5894, -5894,  -792, 10759, -5894, -5894, -5894, 11216, 11300,
   -5894, -5894, 11351, 13376, -5894,  -600, 13767, 10996,  -793, -1954,
   -2138, 14234, 17864, -1966,  -283,   122, -5894, -3003, -2604, -5894,
   -5894, -5894,  -296,  1102,  1294, -5894, -5894, -4686, -4485, -5894,
    2681, -2075, -5894,  -585,  1860,  -578, -5894, -5894, -5894, -2817,
   -5612, -2802,  2684, -5894, -5894, -5894,  -187, -5894, 19584, -3292,
   -5894,  -771, -1029, -1597,  3189, -3129, -1928, -5894, -5894, -5894,
   -3131, -5894, -5894, -5894,  -682,  1883, -5894, -5894,  2011, -5894,
   -5894, -5894,  -982,  2250,  -679, -1176,  1890, -4541, -5894,  -519,
   -4184, -5062, -5894, -5716, -4410, -1897, -1114, -3058, -4450, -1930,
    1902, -3144, -5894, -1948,  1983,  1191, -5894, -1969, -5894,  4368,
    -789,  2696,  -799, 18831,  -706, 11054, -1288, -5894,  6359, -4557,
    5406,  7286,    44,  -120,  4760,  -629,  2611,  3230, -5894, -5894,
      -6,  8905,  -660,  -767, -5894,  5195, 16530, 15653, -3742, -5894
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    57,    58,    59,    60,  1110,  1115,  1914,  1933,    61,
      62,  1634,  3072,  2923,  3902,  3903,    63,    64,  1630,    65,
      66,    67,    68,  1544,    69,  1886,  3086,    70,  2756,   852,
     853,   854,  2621,  2622,  3017,  2623,  2611,  1396,  1832,  1566,
     826,   827,  1526,  1567,    72,    73,  1390,  2602,    74,    75,
      76,  1597,  5415,  5416,  1693,  1598,  1599,  1538,  5046,  5884,
    3686,  2878,  3950,  3687,  3688,  4378,  4379,  3766,  4407,  4469,
    5898,  5899,    77,  1709,  1710,    78,    79,  3054,  3868,  4524,
    5437,  5438,  5703,   671,  5069,  5070,  5690,  5691,  5915,  6088,
    6089,  3087,   702,  3945,  4608,  3893,  5140,  3894,  5141,  3895,
    5142,  4934,  4935,  4368,  4369,  3879,  4555,  4556,  2090,  5082,
    4557,  3896,  5101,  5737,  3897,  2844,  2771,  2772,  5930,  3121,
    2005,  2003,  5636,  5716,  4920,  4921,  4443,  5939,  5940,  5941,
    6231,  5103,  5146,  5147,  6126,  6127,  3948,  4614,  5153,  5495,
    5714,  3644,    81,  3921,  3922,    82,   765,  1908,  4049,   766,
    3124,   703,   767,  3088,    87,  3114,  5932,  3115,  1660,  2937,
    4537,  4025,    88,  1138,  4332,  5520,  5797,  5798,   756,    89,
    1894,    90,    91,  3067,  3886,    92,  2789,  3592,    93,    94,
    3611,  3612,  3613,    95,  4565,  5456,  1600,  3675,  3676,  3677,
    3678,  4399,    96,  1889,  3095,  3096,    97,    98,    99,  3226,
    3227,   100,  3003,   101,   102,   103,   104,  4437,  5001,  5117,
    3717,  3909,  4581,  5115,   105,  3872,  3089,  3142,  3983,  3984,
    5518,  5789,  5790,  5791,  5990,  6266,  5793,  5992,  6148,  5994,
    5092,  6412,  6413,  5774,  4321,  4898,   107,  5093,  5094,  5945,
     108,  2787,   109,   110,  1863,  3060,  3061,  4538,  3131,  3958,
    3959,  4594,  4595,   111,  3808,   112,  4977,  4978,   704,  5953,
    5890,  6074,   113,   114,  4981,  4982,   115,   116,   117,   118,
     119,   757,  1072,  1073,   759,  1193,  1194,  3553,  1155,   120,
    2631,   121,  3848,   122,  1268,  5206,   123,   791,  1209,  1210,
    3090,   125,   801,  3245,   803,  3210,  3211,  2021,  4029,  4030,
    4682,   126,   127,  4033,  4034,  4689,  3223,   128,  1531,  2766,
    2767,  4890,  3091,   705,  3638,  5618,  5359,  5619,  6137,  6328,
    5360,  3497,  4277,   130,   706,  1572,  2828,  1161,  1162,  3135,
    3963,  2736,  2737,  1732,  4635,  2739,  3965,  2740,  1505,  2741,
    1148,  1149,  3971,  3972,  3973,  3974,  4631,  4641,  4642,  5512,
    5782,  4638,  1882,  5506,  5507,   131,  1569,  2825,   132,   133,
     134,  1613,   996,  1171,  1172,   135,   718,   719,   136,  5708,
     137,  1151,   138,  5516,   139,   140,  1253,  1254,   818,   141,
     142,  2848,  4381,   143,  1570,   144,   145,  3711,  3712,  4993,
     146,   147,   148,  2909,  2910,   149,   150,   151,   152,   153,
    6256,  6331,  6332,  6333,  4649,  6142,   154,  1241,   155,   156,
     157,   158,   196,  1037,  1038,  1039,   949,  3092,  5497,   160,
     161,  1527,  1528,  1529,  1530,  2761,   162,   163,   164,  3993,
    3994,   165,   166,   167,   168,  1866,   169,   170,  5681,   171,
     172,  1836,   173,   174,  1046,  1047,  1048,  1049,  1834,  3441,
     665,   871,  1421,  1427,  1470,  1471,  1472,   176,   769,   177,
    1244,  1077,   770,  1202,   179,   771,  2718,  3527,  4292,  4293,
    4294,  4297,  5325,  4867,   772,  3523,   182,  2028,  3232,  3235,
    3519,   773,  3533,  3534,  3535,  4301,   774,  5622,  5623,  5624,
    5625,  5865,  6199,  6200,  6203,  6304,   775,   793,  1141,  3146,
     776,  1355,   188,   189,   190,   929,   874,   875,  3446,  5578,
    5829,   192,  2595,  3424,   810,  1476,   917,   918,   919,   938,
    3027,  2684,  2685,  2709,  2710,  1485,  1486,  2697,  2701,  2702,
    3510,  3503,  2690,  4271,  5603,  5604,  5605,  5606,  5607,  5608,
    4856,  2705,  2706,  1488,  1489,  1490,  2714,   193,  2674,  3476,
    3477,  3478,  4247,  4248,  6188,  4262,  4258,  4841,  5302,  3479,
     863,  1239,  1497,  4849,  6190,  3480,  5291,  5292,  5583,  4267,
    3489,  4288,  3933,  3934,  3935,  3481,  5839,  5840,  6185,  6186,
    5585,  5586,  3482,  5831,  6351,  6352,  6390,  6425,  2742,  1450,
     902,  1356,   903,  1463,  1357,  1437,   905,  1358,  1359,  1360,
     908,  1361,  1362,  1363,   911,  1429,  1364,  1365,  1446,  1459,
    1460,  1366,  1422,  5587,  1368,  1369,  1370,  3484,  1371,  4785,
    5263,  5249,  3346,  3347,  2618,  5568,  4781,  4160,  4775,  2588,
    2592,  5314,  5610,  5611,  3417,  4209,  4812,  5280,  5825,  6021,
    6022,  6169,  1372,  1373,  1374,  3409,  2582,   999,  1375,  4540,
    2584,  3337,  3315,  1735,  3316,  2031,  2053,  3264,  3280,  3281,
    3385,  3317,  3325,  3330,  3338,  3371,  1376,  3266,  3267,  4071,
    2055,  1377,  1043,  1738,  1044,  1465,  3366,  5229,  5533,  5534,
    5810,  5811,  5544,  5812,  5545,  5535,  4082,  4083,  6010,  3291,
    3386,  4086,  3299,  3300,  4104,  4093,  3292,  1378,  4095,  1386,
    1387,  1380,  2022,   864,  5298,  1197,  1819,   807,  1381,  1382,
    1383,  1384,  1606,   970,  1164,  1165,   920,   922,   923,  2678,
     661,   653,   972,  3679,  2585,   662,   655,   656,  1824,  2586
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     652,    71,    80,    83,  1050,    84,    85,    86,   106,   928,
     184,  1734,   124,   129,   159,  1104,   175,   804,  1491,   806,
     178,   191,   185,   812,   998,  1230,  1231,  1232,   820,   828,
     832,  1236,   835,   997,  1659,   828,   828,   768,   865,   659,
     868,  1831,   191,  1391,  1948,  2950,   710,   924,   924,   924,
    1379,   180,  1196,  2872,   866,   939,   962,  1144,   181,  1236,
     186,   183,  1825,  1442,  1003,   830,   795,  1008,  1477,  3485,
    1479,  3643,   795,  1726,  1462,  2738,  2842,  3892,  2843,  3520,
    2002,  1664,  3521,  1605,  1418,  2829,  3109,  1891,  2042,  1405,
    1142,  3975,  1433,  1434,  3247,  3923,  1006,   950,  2050,  4051,
    1203,  1423,  1441,  2855,  1050,  4219,  1448,  4221,  4286,  3238,
    1028,  1177,  1510,  2034,  4338,  4593,  4444,  2036,  3322,  3914,
    2037,  2038,  3302,  3263,   802,  1190,  4619,  3771,   650,  4394,
    4606,  4396,  3021,  4858,  3805,  4922,  4542,   831,  4366,  3298,
    4370,  4644,  2738,  4244,  4261,  1071,  2911,  2911,  5295,   862,
    2911,  4300,  4892,  1833,  3355,  2982,  2983,  1050,  3176,   941,
    4873,  5131,  1175,   942,  1714,  1179,  1204,  5543,  3286,  3290,
    3293,  3294,   933,  2670,  3303,  2820,  3305,  3306,  5499,  1187,
    5139,  3128,  5160,  5149,  5616,  1144,  1417,  1601,   232,  5641,
    5100,   652,   953,   953,  4961,  5234,   953,  5235,  5492,  4299,
     964,   877,   865,  5720,  4275,  1000,  3439,  3512,   964,  2977,
    1050,   964,  1623,  5307,   865,  5309,   953,  1640,  1398,   865,
     825,  3515,  1876,   953,  1864,   865,  4306,   859,  1869,  3546,
    3548,  4088,  5148,  1873,  4603,  2820,  3427,  3010,  1900,  5460,
    3429,  3911,  4191,  1883,  5633,  5759,  4259,   851,  4264,  4265,
    4188,  5488,  2820,  3491,  1940,  5361,  5772,  1903, -1984, -2420,
    1944,  1484, -2567,  1487, -1984, -2609,  5967, -2635,   777, -1976,
    1955, -2677,  1050,  2800,  1958,  1820,  4090,   669,  1961,  1899,
    1963, -2455,  1430,  1431,  2989,  1573,  1971,  5491,  1937,  5254,
   -2455, -2455,  1977,  1440,  6159,  1980, -1943,  4177,  1568, -2456,
    5669, -1956, -2866,  4101,  5955,  3243,  2995,  1930, -2456, -2456,
    1856, -2866, -2866, -1981, -2001,  1658, -1971,   716,   716, -2419,
     716,  6006,   716,  5358,  1692,  1033,  1540,  2629,  1514,  3851,
    1021,  3854,  3855,  2992,  1719,  3106,  3859,  3860,  3861,  1568,
    3863,  3864,  3865,  2111,  1568,  4124,   716,  4629,  3364,  1452,
    1861,  1262, -2488,   716,  5683,  5684, -2571,  5339,  6152,  4069,
    6002,  6154,  5889,   777,   716,  4645,  1602,   777,  2608,  3364,
    1602,   716,   777,  1131,  1417,  2635,   777,   716,  -446,  3052,
     777,  1211,  -150,  5016,  4101,  1215,  5514,  5804,  -150,  1144,
    6194,  2914,  5323,   777,  2918,  5709,  5935,  4053,  5876,  1930,
    4974,  3870,  2911,  3832,  1930,  6162,   936,  2675,  2637,  3118,
    2691,  6003,  3070,  5161,  3550,   716,  1515,  5208,  5209,  5210,
    1226,  5212,  5213,  5214,  5215,  5216,  5822,  1453,  6140,  1034,
    1983,   936,  4572,  2846,  3139,  1825,  3119, -1777,  2089,   783,
    1726,  1541,   783,  1878,   783,  2681,  1930,  4979,   783,  6430,
    3412,  2896,  2111,  2998,  3075,   948,  4646,  3140,  2692,  5251,
    3462,  1540,  1123,   784,   837,  1234,   784,  1395,   784,  4124,
    1516,  5847,   784, -2246,  5646,  3406,  6132,  5632,  4043,  1474,
   -2246,  3567,  3407,  2677,  2635,  2609,  3224,  4866,  3084,  3765,
    3715,  2846,  3660,  2600,  3485,  1035,  2815,  5367,   998,  1124,
    1433,  1434,  3239,  2975,  6428,  1454,  6431,  2612,  1455,  2777,
    1913,  5461,  2624,  2624,  2863,  4467,  5969,  2637,  1017,  3081,
      35,  6120,  1400, -2265, -2632,  6196,  3461,  3463,  3464,   783,
   -2265,  4975,  1441,   783,  1930,  1432,  6197,  1461,  1125,  3111,
    5760,  3107,  1448,  2846,  1956,  2604,  5936,  5886,   998,  1018,
    2864,  2920,  4091,   784,   943,  4463,  1235,   784,  1036,  3661,
    5462,  4178,  4530,  1098,  2111,  4044,  4468,  2601,  6472,  1108,
     838,  3716,  3085,  5717,  3568,  2694,  1541,  5252,  4980,  4102,
    3076,  1122,  1456,  2104,  1517,  1475,   890,  3225,  1126,  2846,
    4470,  1825,  5823,  1946,  2846,  2816,  2635,  2897,  3882,  2999,
    5621,  3413,   869,  2064,  2630,  2023,  6302,  1144,  2846,  1227,
    1986,  2673,  3642,  2873,  1946,  6141,  2033,  1931,  3071,  5324,
   -1777,  2610,  2846,  5824,  3141,  4573,  5937,  1456,  4124,  2637,
    3871,  3025,  2846,  2043,  6062,  4647,  3551,  6356,  6248,  3552,
    2047,  2695,  3120,  4590,  4976,   944,  3079,  5748,  4179,  2757,
    3053,  5805,   717,  2807,  1930,  2953,  3835,  5515,  5926,  1053,
    4102,  2651,  4542,  2814,  6343,   865,   981,   953,  3847,   953,
    2672,  5597,   953,   982,   983,   984,  2105,  3221,  2026,  1000,
    1081,  1430,  1431,  3221,  1111,  1930,   953,  3221,  1930,  5711,
    4996,   191,   953,  1273,  1820,  6103,  4124,   945,  3019,  3020,
    4125,  4126,  4127,  1542,  3486,  3265,  2598,  2996,  1862,  1931,
    5340,  4648,  3883,  1235,  1931,  2990,   652,   928,  4790,  1440,
    2648,  1078,  3108,  6131,  5068,   964,  1612,  2724,  1079,  1000,
    1082,  1080,   964,  2955,  1136,   964,  3365,  2997,  4180,   711,
    1144,  5329,  1725,  6470,  1457,  1428,  2917,  6318,  1144,  1144,
    2935,   953,  4630,  2938,  2939,  6476,  1931,  4195,   670,  1235,
    3018,  4522,  4523,  1522,  2993,  1207,  1523,  5109,  1443,  1444,
    5561,  2027,  1543,  2606,  1443,  1444,  1862,  3259,  1041,  6300,
    6007,  3833,  1042,  1932,   191,  6004,  1041,  1445, -2420,  2945,
    1042,  3456,  2948,  1447,  4092, -2632,  2968,  2969, -1976,  6317,
   -2567,  3009,  5962, -2609,   865, -2635,  5156,  1492,  5157, -2677,
   -2455,  3026,  2934,  1255,  2715,  5901,  2716,  6153,  2890,  6005,
    6155,  4103,  1208,  1224,  1213,  1432,  1217,  6368, -2456,  5003,
    1436, -2866,  1221,  1385,  1385,  5007,   865,   828,  2653,  2654,
    6085,   828, -1981,  2065,  1931, -1971,  2107,  2596, -2419,  3432,
    2805,  6417,  2874,  3178,  3194,   865, -2246,  4928,  3408,  2976,
     865,  2581,  5368,  4139,  5965,  2778,  1385,  3485,  1265,  1632,
    3485,  6198, -2632,  5377,  6401,  1939,   998,  6240,   789,   790,
    1943,  4542,   789,   790, -2632,  1847,  3204,  1603,  1604,  6250,
   -2488,  1603,  1604,  1633, -2571,   789,   790,   941,  3219,  6269,
     946,   942,  4261,  -150,  -150,  2824, -2265,  4129,   789,   790,
    1843,  4464,  2889,  1385,  1848,  1238,  1849,  2676,  3485,  4838,
    1862,   187,  1954,  4842,  3884,  1041,  3485,   865,  5530,  1042,
    4458,  4459,    71,    80,    83,  4460,    84,    85,    86,   106,
     865,   184,   187,   124,   129,   159,  2898,   175,  3040,  4584,
    6205,   178,   191,   185,  1838,   865,  1525,  3615,  2824,   870,
    4734,  4735,  3700,  4603,  1931,  5872,  4273,  2578,  2579,  2580,
    2581,  1238,  6216,  4302,   865,  2824,  4503,   927,  6423,   953,
     953,  6301,   180,  4739,  4136,  4137,  4138,  4139,  6130,   181,
    4908,   186,   183,  4130,  4882,  1931,  6059,  6320,  1931,  3080,
    4966,  6064,  6065,  2856,  4828,  4591,  4830,  4831,  3512,  4591,
    1976,   828,   828,  6124,  5110,  4226,  2027,  3221,  1532,  3885,
    6277,  4280,  5072,  2799,  1424,  2873,  3205,  2873,  2875,  4720,
    5712,  5071,  1946,  2758,  1385,  1385,  5747,  4308,  4684,  4309,
    3297,  6104,  4681,  3228,  4558,  4797,   712,  3160,   652,  1394,
     953,  1496, -1915,  1402,   964,  3167,   943,  1000,   964,  2876,
     964,  2593,  1698,  3682,  1880,   953,  1547,  3586,  2677,  4639,
    3692, -1776,  4582,  5817,  6367,  6323,  6324,  2576,  2577,  2578,
    2579,  2580,  2581,  5098,  2877,  4039,  6112,  2834,  3391,   865,
    3732,   960,  4090,  6227,  5090,  3062,   953,   953,  6275,  2873,
    1930,  4041,  6123,  6278,  5753,  1699,  6308,   713,  1263,  1094,
    5111,  5029,   940,  1158,  4750,  1407,  4751,  3339,   865,   865,
     865,  3683,   953,  1825,   652,  2871,   652,   652,  2873,  3486,
    1979,  5410,  4922,  1533,  4339,  4686,  5762,  3122,  6302,  5453,
    4994,  4134,  4135,  4136,  4137,  4138,  4139,   944,  1614,  4517,
     714,  5763,   715,  6249,  6424,  5411,  6434,  6071,  5180, -1943,
     953,  1946,   953,   953,  4681,  6358,  2688,  1050,  4356,  3517,
     716,  5652,  6241,   716,  4303,  3229,  5125,  1499,  3733,   987,
     988,   989,   990,   991,   992,   993,   994,   995,  2838,  6180,
    1408,  2873,  5566,  5988,  6303,  1385,  4334,  6031,  6403,  1248,
    2704,  5112,   825,  1682,  3362,  6279,  4131,  4132,  4133,  4134,
    4135,  4136,  4137,  4138,  4139,  1096,   666,  1097,  3216,  3217,
    1130,  2004,  3606,  2004,  6246,  6247,  1615,   865,   191,   804,
   -2416,  1273,  3392,  3734,  4124,  6072,  3684,  3393, -2993, -2993,
   -2993,  1988, -1943,  1990,  5989,  1992,  3979,  1994,  3524,  1996,
    1997,  1998,  5795,  2040, -1776,   865,  2000,   805,  2873,  2046,
    5454,  2873,  3273,  5091,  2874,   716,  2874,  1409,  2873,  6325,
    4281,  4752,  3180,  1385,  3340,  5567,  5136,   716,  3260,  1259,
    3262,  2689,  3518,  4687,  1131,  2873,  3269,  2873,  3394,  5099,
    6030,  1249,  3283,  3284,  6448,  3735,  5818,  4120,  5948,  3693,
    1700,  3203,  5951,  5137,  3307,  3208,  6181,   928,  3545,  5030,
    3215,  5959,  3206,  3218,  3327,  1385,  3157,  1534,  6228,  5490,
    3342,  3607,  5478,  3616,  1922,  3222,  5961,  5484,  5964,  5543,
    3169,  5976,  1229,  3635,  4081,  4040,  5509,  3980,  2874,  6366,
    2779,  2857,  4372,  3175,  1385,  1385,  1385,  5947,  1385,  3912,
    6373,  4042,  5764,  4121,  4122,  2858,  4923,  2859,  4141,  2840,
    1535,  5997,  6280,  1895,  3153,  3361,  3155,  2874,  4091,  1385,
    4539,  1132,  1946,  3063,  3274,  4108,  4559,  5963,  2594,  6389,
    5113,  3168,  5543,  3468,  3170,  1881,  1408,  5335,  3187,  6402,
    1965,  2947,  4640,  2978,  3363,  1536,  3174,  1500,  3732,  4172,
    4173,  2768,   946,  6229,  3230,  3587,  1896,  3701,   865,  4339,
    1931,  5352,  3313,   961,  1701,   809,  3685,  6369,  2633,  3736,
    6313,  3898,  6432,  2105,  2860,  3231,  1385,  4688,  3842,   998,
    2874,  1095,  6230,  1966,  3207,  1159, -1943,  2820,  3213,  3214,
    2875,  5796,  2875,  3395,  2682,  2683,  5412,  2687,   942,   942,
    3525,   942,  3275,  4282,  6449,  1041,  5114,  4373,  1452,  1042,
    4636,  4448,  5868,  1409,  5205,  3011,     3,     4,  1723,  1537,
    2967,  2876,  1385,  2876,  1250,  1259,  1385,  1385,  6182,  4224,
    1624,  2841,  3494,  6183,  4335,  5862,  3733,   865,   865,   865,
    2722,  6285,  1385,  5668,  3617,  5328,  2877,  2874,  2877,  5296,
    2874,  2950,  3486,  3198,  5858,  3486,  6164,  2874,  5299,  5138,
    3610,  6114,  2780,  5303,  2875,   828,  5305,   934,  1251,  6184,
    1252,  1881,  3637,    40,  2874, -1700,  2874,  3258,   815,  6258,
    3276,  4130,   762,  3277,  1923,  1480,  1453,  2871, -1700,  2871,
    1133,  3734,  3118,  2875, -1700,  2876,  5651,  2904,  1924,  2783,
    2811,  3737,    15,  3486,  5457,   828,  5927,  3702,   953,  3738,
    2784,  3486,  3739,    44,  2928,  4422,   817,  3428,  3724,  3119,
    2877,   865,  2845,  3495,  2876,  3606,  1703,  3981,  1134,  3941,
     865,  4861,  1704,   953, -1095,   935,  5136,  4694,  3923,    20,
    5170,   187,  3982, -1700,  5687,  1625,  3899,  6314,  1496,  2877,
    1496,  1897,  3789,  3735,  5479,  1925,  2875,    48,  3790,  2781,
    1000,  2871,   865,  5137,  1454,   828,  1825,  1455,  2913,  2913,
      49,  2770,  2913,  1482,  4456,  3606, -1700,  4466,  1967,  1590,
    1946,  1525,   828,  6050,  4505,   865,  1525,  2876,   865,  4542,
    2871,  1629,  6258,  1135,    50,  1136,  3485, -1943,  3964,  1137,
    3485,  4910,  3278,  4968,  1862, -1943,  1724,  1432, -1943,  1461,
     953, -1943,  2877,  3526,  5917,  5761,  5919,  5885,  5752,  5085,
    5923,  5924,  3199,  2875,  3607,  6165,  2875, -1700,   865,   936,
    4423,  6239,  5859,  2875,   187,   927,  1033, -1700,  4374,  4375,
     901,  1705,   953,   953,   953,   953,   865,  2773,  -707,   667,
    2875,  2738,  2875,  2871,  2876,  2738,  3200,  2876,  6174,  1926,
     865,  6263,  1525,  5928,  2876,  1898,  1525,  3791,  4884,  4376,
    3201,  1385,  1385,  1385,  3607,  2774,   816,  3736,  6201,  2877,
    3438,  2876,  2877,  2876,  6061,  3795,  1456,   836,  3459,  2877,
    2785,  2768,  1968,  5130, -2993, -2993, -2993,  4134,  4135,  4136,
    4137,  4138,  4139,  3565,  5127,  3485,  2877,  4543,  2877,  3202,
    3608,  2769,  4695,  6258,  4862,  2762,   998,   998,  1076,  3279,
    2871,  4859,  3619,  2871,  3900,  5472,  3166,  2763,  3796,  1626,
    2871,  2111,  1927,  2786,  5089,  6346,  3296,  3296,  3819,  2971,
    1034,  6387,   860,  3156,  1704,  2764,    32,  2871,  6316,  2871,
    4252,  3323,  4351,  3609,  1946,  4546,   194, -2439,  6202,  5062,
    3344,  -173,  2110,  3797,  5066,  2111,  3460,  3662,    40,  6118,
     865,   872,  1627,  4894,  6263,  5766,  6347,  3901,    40,  5293,
     937,   865,  3149,  5767,  4253,   663,   833,  3642, -1700,   953,
     953,  1480,  -173,    40,  5086,  3196,  2637,  2635,  4860,  4844,
     940,   195,   187,  1457, -2993,   953,  1035,  1628,    44,  3737,
    1200,  6440,  1553,  3610,  4424,  3566,  4548,  3738,    44,  6348,
    3739,  3620,  4255,   865,  2913,  1706,   930,  6365,  1458,  3447,
    2637,  4352,  3740,    44,  3663,  1928,  1033,   664,  4461,   953,
     953,   953,   953,  4964,  6349,   998,  4539,  2775,   865,  4362,
    1442,  3792,    48,  3820,  1820,   865,  1041,  4425,  3129,  1466,
    1042,  4895,    48,  3610,  3516,    49,   763,   682,  1707,  1036,
    6209,  4885,  3196,   652,  4992,    49,   652,    48,  4886,  1482,
     931,  5954,  1632,  5968,  1266,  4887,   964,   964,  1456,    50,
      49,  3803,  4426,   194,  3793,  6263,  1862,  1000,  1000,    50,
    1590,   964,  4174,  1708,   964,  3751,  1633,  5975,    56,  6145,
    1480,  2770,  1661,  3196,    50,  3740,  1481,  4462,   764,   953,
     953,  2765,  4965,  5593,  4888,  1404,   953,  5445,   865,  3794,
    1483,  6420,  4551,    56,   663,  2959,  3485,  3485,   195,  4896,
    1034,   684,  2940,  4897,  4290,  2004,  6459,  4889, -2993,   948,
    4257,  -622,   953, -2993,   964,  1662,   191,  3212,   964,   964,
    6471,   865,   865,  5080,   953,  5083,  2960,  5768,  3188,  3289,
    3189,   865,  3190,  5794,  3191,  1881,  3192,  6327,   865,  4552,
    3193,   865,  3129,  4291,  6458,   804,   932,  3997,   804,  3249,
    5081,  3752,  1081,  1385,  5336,  1385,  4553,  2774,  1482,  3755,
    1385,  1385,  3758,   191, -2993,  5528,  1035,  1385,  1385,  1385,
    1385,  1385,  1385,  1385,  1385,  1385,  1385,  1385,  1385,  1385,
    3244,   194,  1979,  1385,  1642,  1385,  1000,  1385,  1385,  1385,
    1385,  1385,  1385,  1078,  4685,  1385,  4938,  1385,  1385,  5084,
    1079,  1385,  1082,  1080,  6160,  2691,  3836,  3837,  3838,  1483,
    6161,  1144,  4697,  3798,  3689,  5459,  1385,  1385,  1385,  4680,
    1694,  1514,  2642,  2738, -1700,  4539,   195,  1643,  5337,  1036,
    3923,  4939,  1663,  2738,  1385,  1206,  2921, -1700,   187,  3488,
    3713,  2924,  3233, -1700,  5826,  6122,  3632,  2950,  3725,  4709,
    3726,  4350,  5682,  2692,  5483,  3248,  6139,  2941,  6405,  6121,
    6008,  4554,  2942,  1695,  5470,  4733,  4681,  1696,  4721,  4746,
    4747,  4748,  4749,  4725,   953,  4753,  4754,  4755,  4756,  4757,
    4758,  4759,  4760,  4761,  4762,   695,  4168,   696,  1247,  4302,
    5946,  4065, -1700,  2616,  1645,  5627,  2646,  5629,  1697,  5048,
    3014,  5783,  3799,   783,  4667,  4724,  2052,  3804,  2738,  1515,
    4729,  4730,  3629,  3015,   700,  5827,  1646,  3001, -1747, -2993,
    2693,  3007,  5049,  1501, -1747, -1700,  2061,   784,  6009,  4940,
    3927,  3928,  3929,  3930,  2940,  3932,  2617,  3800,  3485,  4801,
    4802,  1419,  3713,  3016,  3727,  3485,  3750,  3012,  3842,  4894,
    3485,  6446,  4543,  3485,  4512,   947,  2911,  3989,  4544,  5449,
    3960,  5451,  3995,  1516,  3996,  3768,  1502,  3769,  1647,    40,
    2694,  3773,  4545,  6460,  4002,  5679, -1700,  4003,  5979,  4004,
    4005,  1385,  2111,  4007,  3777,  2102, -1700,  4010,  5920,  4011,
    3013,  3486,  4013,  5921,  2863,  3486,  3991,  3801,  6138,  5680,
    4546,  1503,  4547,  1469,  4375,  4465, -1747,  6242,  3880,    44,
    5996,  6146,  6254,    29,  2635,  4825,  2110,  2846,  2851,  2111,
    2852,  3826,  1979,  4024,  1826,   762, -2993,  1827,  6441,  2847,
    2864,  4923,  3802,  4251,  4952,  1385,  2695,  4895,  2576,  2577,
    2578,  2579,  2580,  2581,  5958,    15,  6147,  2637,  5922,  4827,
    5679,  2635,  1511,    48,  4504,  4251,  4052, -1747, -2993,  3444,
    1648,  4548,  3953,  4923,  5432,  5441,  5433,  5434,  5435,  2846,
    4305,  6442,  5369,  2051,  5680,    56,  1156,  1517,  5860,  1667,
    5375,  2854,    20, -1120,  2637,  3445,  5727,  2853,  1506,  2941,
    4549,  1385,  5925, -1700,  2942,  1512,  1632,  1979,  1670,  5442,
    3486,  6295,  1156,   956,  1123,  5861, -1700,   940,   940,    56,
     940,  4252, -1700,   958,    40,  4896,  4066,  3504,  4615,  4897,
    1633,  4067,  1668,  1649,  6319,  1632,  6296,  1507,  1650,  1901,
    1513,  1508,  3915,  4252,  1973,  6469,  4404, -1700,  5031,  -150,
    5728,  1124,  1518,  5729,  2949,  4253,   979,  4419,  4405,  1633,
    5730,  6329,  6478,  1902,    44,   980,  4192,  1669,  1974,  6207,
    4254, -1700,  5032,  4652,  1671,  4035,  1509,  4253,  4653,  1212,
    1214,  1216,  4550,   682,  1218,  1219,  1220,  4551,  5731,  1652,
    4585,  1519,  4254,  4255,  1225,  1520,   233,  4251,  1622,    35,
    4420,  5164,   668,  1639, -1700,  5679,  4653, -1093,    48,  5787,
     760,  1023, -2993,  5536,  1041,  4255,  1672, -2993,  1042,  4923,
    4023,    49,  4256,  1673,  1635,  4220,  1032,  1674,   834,  5680,
    1521,  1443,  1444,  5788,  4552,  4421,  5537,  1040,  1654,  3485,
    1126,  1084,  5538,  1711,  4256,    50,  1715,  5888,  5732,  1086,
    1445,  4553,  5892,  5893,  6049, -1700,  5539,   684,  2624,  1091,
    1985,  5733,  1655,  1827,  6255, -1700,  1522,  1119, -2993,  1523,
    4123,  2882,  -621,  4874,  5734,  4252,  4312,   777,  6211,  6212,
    1105,  1432,  4151,  2671,  1657,  1443,  1444,  1385,  1385,  1385,
    1385,  1385,  1385,  1385,  1385,  1385,  4158,  1385,  5293,    32,
    5079,  1432,  4165,  2671,  1447,  2883,  4278,   865,  1385,  4253,
    1385,   777,   777,  6433,   686,  1127,   792,   865,  4175,  1128,
    1524,  4257,   792,  1129,  4254, -2412,  2642,   998,    40,  2105,
    1041,    40,  1229,  1041,  1042, -2420,  3599,  1042,  1100,  1146,
    1101,  3486,  3486,  4257,  1438,  1439,   865,  4255,  1385,  1150,
    2035,   953,  1385,  1827,  4881,  1385,  4554,  1385,  1157,  1432,
    1385,  2671,  4206,  3596,  1385,  3600,  3601,  4471,    44,  3440,
    4150,    44,  4152,  4153,  2632,  1273,  4256,  1827,  4124, -1699,
    4231,  4232,  4125,  4126,  4127,  2645,  2679,  3487,  2646,  1827,
    5540,  4222, -1699,   865,   865,  1166,  4323,  3184, -1699,  1167,
    2646,  4340,  6224,  3195,  1385,  5300,  3196,  1675,  3197,  1184,
    3593,  3196,    48,  1385,  1385,    48, -1700,  3144,  1842,  3145,
    3485,  6306,  4307, -2993,  4084,    49,  4085,   865,    49,  1851,
    3628,  3376,  3377,  3378,  3379,  3531,  4380,  3536,  4193,  3236,
    3485,   695,  3237,   696,  5689,  1859,  1676, -1699,  1173,    50,
    1677,  5980,    50,  5197, -1120,  3443,  3448, -2413,  1979,  2646,
    3537,  1191,  1041,  2646,  1229,  1825,  1042,   699,    56,  5204,
    1877,    56,  3485,  3023,  3024,  4257,  4384,   804,  4386,   804,
   -1699,  2672,  4951,  1201,  1041,  1678,  3626,  5735,  1042,  3627,
    5736,  5320,  1679,  1385,  1144,   663,  3707,  3876,  3528,  3708,
    3877,   777,   682,  4015,   652,  5132,  3196,   964,  1000,   964,
     964,  4601,  3569,   953,  3572,  3483,   865,  5227,  5874,  1237,
    4064,  6361,  3731,  2646,  5232,  5233,  5879,  5880,  4268,  1645,
   -2993, -1699,  4073,  4079,  1228,  2646,  2646,   828,  4211,  1229,
    4212, -1699,  2576,  2577,  2578,  2579,  2580,  2581,  5541,  2845,
    4213,  1646,  4214,  4941,  4080,  4948,  4099,  2646,  4110,  3835,
    5542,  2646,  3648,   865,    40,  4143,  4128,   934,  2646,  3659,
    5301,  4612,  4157,  4613,  4923,  2646,   684,  1233,   865,  4926,
   -1748,  4909,  4162,  3486,  4316,  4163, -1748,  1240,  4229,  4129,
    3486,  2646,  6294,  4539,  5242,  3486,  5243,  4696,  3486,    29,
     865,  2738,  2030,  1647,    44,  3823,  4397,  1987,  1243,  4398,
    1989,  4588,  1991,  5073,  1993,  5074,  1995,  5808,  3485,  5809,
    1999,   865,  4402,  1245,  4491,  4403,   187,  3614,  4430,  6204,
    4498,  4431,     3,     4,   828,   935,  4501,  4343,  4624,  4431,
    4627,  4625,  4658,  4628,  4771,  4659,  1273,  4772,    48,  4124,
    1246,  1144,  4967,  4125,  4126,  4127,  1256,   953,  4313,  4314,
     953,    49,  4782,  4793,  4869,  4783,  2646,  4870, -1748,  4439,
    1259,  4791,  4945,   187,  4445,  4130,  1257,  4875,  4880,  -472,
    4876,  3552,  1258,  6128,  4327,    50,   865,   865,  5024,  5644,
    5645,  2603, -1699,   865,  6375,  1648,  6376,  3485,  5133,  5853,
      40,  3196,  4472,  3806,    56,  3809,  3811,  3288,  5199,  5239,
    1260,  2027,  2646,  4531,  1466,  5276, -1688,  5775,  2646, -1748,
    5331,  1267,  4414,  3552,  3767,  5355,  6023,  6024,  5356,   936,
    5362,  3341,  3722,  3196,  3513,  3514,  4560,  1385,  1385,  1385,
      44,  5363,  1261,  1385,  3196,  2110,  5364,  5485,  2111,  3196,
    5486,   953,  2112,  2113,  2114,  1269,  3323,  3323,  1649,  1645,
     695,  3323,   696,  1650,   953,  4821,  4181,  4823,  4182,  1403,
    1385,  6406,   953,  5522,  5558,  5560,  4659,  5559,  2646,  2949,
    2635,  1646,  1406,  5580,    48,  2845,  5581,  2636,  1410,  1877,
     865,  5150,  5590,  1411,  4183,  1979,  3913,    49,  5596,   804,
    1412,  4598,  3323,  3323,  1416,  -472,  5598,  4435,  4843,  4598,
    4846,   953,  3924,  2637,  1652,  5285,  4660,  5287,  4662,  1420,
    4664,    50,  3806,  4057,  1425,  4059,  4060,  5143,  5677,  4451,
    3062,  5678,   953,  1647,  3946,  5722, -1771, -1771,  5723,  4871,
      56, -1433,  5742, -1433,  5483,  3196,  5776,  6462,  2717,  5777,
    2720,  3372,  4923,  3373,  4578,  5836,  1443,  1444,  5837,  3375,
    4129,  1426,  3964,  1654,  3485,  5842,  5845,  1428,  1979,  4598,
    4054, -1775, -1775,   953,  3486,   953,  1432,   953,  5856,  3374,
     937,  5857,  4703,  5909, -1774, -1774,  5910,  1655,  4131,  4132,
    4133,  4134,  4135,  4136,  4137,  4138,  4139,  3942,  5950,  5977,
    6014,  2603,  5857,  4163,  1273,  6015,  2677,  4124,  2646,  1657,
    2004,  4125,  4126,  4127,  1436,  3376,  3377,  3378,  3379,  2738,
    1435,   998,  4184,  3370,  6035,  1648,  1449,  6036,  4185,  5269,
    5575,  2638,  5576,  4925,  1466,  4927,  2639,  6047,  4930,  4592,
    3483,  6170,  6171,  1144,  3375,  1144,  4130,  6039,  6040,  6070,
    1979,  2646,  3237,  6076,  6077,  2110,  3237,  3237,  2111,  2640,
    2304,  1451,  6128,  6080,   652,   953,  2646,   964,  4923,   964,
     964,  2894,   953,  3485,  1467,  4690,  4561,  1726,  4563,  1385,
    6081,  1478,  6082,  2646,  1385,  6083,  1493,  2641,  1649,  4571,
    2635,  4574,  1494,  1650,   928,  5552,  6110, -2993,  1495,  6111,
    3376,  3377,  3378,  3379,   925,   926,  1825,  3380,  3381,  2949,
    1461,  6176,  6191,  3382,  4598,  2646,  6193,  6206,  6220,  2646,
    3196,  6221,  1545,  2637,  5548,  5549,  1574,  1144,  6244,  4274,
    2371,  6245,  1498,  1385,  1385,  1385,  4675,  6293,  1385,  1504,
    5850,  1571,   928,  2677,  1652,  2642,  1385,  1385,  1385,  1385,
    6326,  6371, -2457,  5857,  6372,  3486,  6391,  1576,  4951,  6392,
    4633,  6399,  1385,  6400,  4870,  1385,  2646,  1385,  6427,  4743,
    6429,  6036,  1577,  2646,  6437,  3486,  1612,  6438,  1617,  1385,
    1385,  2110,  3485,  1385,  2111,  6475,  4186,  6252,  6392,  4923,
    1616,  6477,  1618,  1654,  6438,  4800,  6479,  6444,  4187,  6392,
    6447,  1629,  1000,  4770,  1385,  1631,  1385,  3486,  1385,  3348,
    1641,  1644,  3351,  1666,  4777,  1683,  2635,  1655,  4129,  1684,
    1702,  1713,  1712, -2993,  1716,  1721,  1722,  1385,  1835,  1837,
    4210,  1839,  1844,  1855,   865,  1850,  5353,  1858,  1860,  1657,
    1868, -2993,  2644,  1865,  4698,  1870, -2993,   928,  1862,  2637,
    4216,  4217,  4218,  1879,  4809,   865,  5693,  1884,  1885,  4131,
    4132,  4133,  4134,  4135,  4136,  4137,  4138,  4139,  1887,  -137,
    1888,  3383,  1890,  1892,  1893,  1904,  1911,  1913,  1916,  1920,
     213,  1929,  1548,  3384,  1934,   652,  1935,  1936,  3487,  4249,
    1938,  1941,  1942,  4249,  4263,  4249,  4249, -2993,  3035,   928,
    1945,  1946,  1385,  5694,  4130,  1953,  1957,  1385,  1959,  3046,
    1960, -2992,  4905,  1962,  1964,  1969,  1970,  1972,  1549,  1975,
    1978,  4803,  1385,  1981,  5177,  3064,  1982,  1984,  5695,  2001,
    4942,  2032,  2039,  2048,  2049,  2672,  3487, -1947,  2041,  2044,
    4295, -1954,  2056,  4298,  3487,  2057,  3536,  5696,  2058,  2572,
    2059,  3485,  5697,  3486,  3364,  2642,  4991,  2060,  2573,  2574,
    2575,  2576,  2577,  2578,  2579,  2580,  2581, -2993,    56,  2062,
   -1944,  2063, -2993, -1945,  5698, -1948,  2064,  2066,  5699,  3138,
    3370,  1550,  2067,  2068,  2069,  2070,  2071,  1385,  2072, -1946,
    5054,  2073,  2074,  5700,  3150,  2075,  2076,  1156,  3154,  5800,
    2077,  2078,  2079,  2081,  2082,  2089,  2083,  5814,  2084,  5059,
   -2992,   953,   953,  3483,  3475,  2085,  3483,  2086,  1551,  2587,
    6404,  2087,  2088, -2993,  2091,  2092,  2093,  2589,  3173,  1156,
    2094,  2095,  3486,  2096,  2097,  2098,  2591,  2593,  5835,  2607,
    2594,  2619,  2603,  2627,  2649,  2650,  2655,  1385,  2657,  2658,
    2661,  2662, -2993,  2664,  2665,  2666,  3689,  2667,  4962,   187,
    2668,  3485,  2673, -2992,  3483,  1481,  2680,  3485,  1552,  2711,
    2723,  2725,  3483,  1483,  2713,  2726, -2992,  2727,  2728,  5067,
    2744,  2642, -2992,  2745,  3713,  2746,  2747,  2748, -2992,  2671,
    2749,  2750,  2751,  2753, -2992,  2752,  2754, -2992,  2760,  5701,
    2776, -2992,  2782,  2788,  4408,  2802,  2806,  2808,  2809,  2810,
    2813,  4274,  1554,  2812,  2826,  2831,  2849,  4131,  4132,  4133,
    4134,  4135,  4136,  4137,  4138,  4139,  2830,  2850,   865,  2832,
    2861, -2992,  2865, -2992,  2868,  2869,  2867,  2870,  2913,  2871,
    2879,  2881,  2884,  2885,  2886,  1556,  2891,  2880,  2892,  2895,
    2905,  2901,  2919,  2902,  5702,  2929,  2936,  2915,  2916, -2993,
    5505,  2943,  2946,  2922, -2992,  2925,  2926,  2931,  2932,  2944,
    3356,  2576,  2577,  2578,  2579,  2580,  2581,  2951, -2993,  2952,
    1590,  2972,  2957,  2961,  5186,  2958,  2963,  5188,  3485,  2964,
    2966,    35,  2965,  2822,  2973,   865,  1558,  2974,  2979,  3486,
    5194,  2991,  2970,  2980,  3034,  1559,  2981,  3022,  3000,  2994,
    3029,  3037,  3036,  3038,  1560, -2992,  5203,  3039,  3005, -2992,
    3043,  3044,  2823,  3045,  3047, -2992,  3048,  3050,  3049,  3051,
    3056,  3055,  3057,  3058,  3065,  3066,  1562,  3069,   677,  3082,
    3296,  3093,  3097,  3101,  3098,  1563,  3110,  3074,  3113,  1385,
    1564,  3116,  3117,  3137,  3126,  1385,  3159,  3130,  3134,  1663,
    3143,  3152,  3323,  3323,  3323,  3323,   953,  3147,  3323,  3323,
    3323,  3323,  3323,  3323,  3323,  3323,  3323,  3323,  3161,  3162,
    3163,  3164,  3177,  3209,  3220, -2993, -2992,  3234,  3246,  3265,
    3310,  3343,  3349,  2111,  3390,  3410,  4774,  2576,  2577,  2578,
    2579,  2580,  2581,   865,   865,   865,  3431,  1565,  3486,  2677,
    3436,  3270,  3451,  3416,  3369,  3388,  3437,  3353,  3415,  3452,
     865,  3435,  3449,  3434,  3450,  3453,  1456,  3466,   935,  3454,
    3458,  3467,  3323,  3323,  1385,  3493,  3488,  4035,  3506,  3505,
    3507,  3529,  3365,  3508,  3522,  3530,  3541,  3542,  3544,  3570,
    3561,  3573,  2004,   865,   865,  3575,  3578,  3583,   865,  3594,
    3588,  3589,  3591,  5105,  5106,  3618,  3602,  1400,  1404,  3623,
     865,  3625,  3633,  5264,  3639,  3641, -2992,  3651,  3640,  4834,
    3664,  5466,  3669,  3690,  5189,  5190,  5191,  5192,  5193,  3670,
    3698,  3703,  3697,  3706,  3723,  3696,  3714,  3721,  3724,  3744,
   -2992,  3745, -2992, -2992,  3807,  3834,  5143,  5311,  1881,  3761,
    3781,  3822,  3850,  3830,  3831,   936,  3843,  3486,  5341,  3857,
    3856,  5250,  1273,  3858, -2992,  4124,   953,  3862,  3889,  4125,
    4126,  4127,  4618,  3878,  3890,  3904,  3906,  3908,  3918,  3931,
    3212,  4678,  3867,  3936,  3910,  3925,  3937, -2992,  3939, -2992,
   -2992,   865,  3938,  3940,  3944,  3949,  3951,  3952,   187,  3955,
    3961,  3956,  3977,  3947,   865,  3976,  5373,  3978,  4655,  3986,
    3987,  3988,  3990,  3992,  5379,  5380,  4006,  4009,  4008,  4012,
    4014,  4622,  4017,  1385,  4018,  4019,  4020,  4021,  1979,  4807,
    4027,  4022,  1385,  4036,  1976,  4032,  4045,  5318,  4038,  4050,
    1943,  4026,  4058,  4037,  4078,  4081,  1385,  4075,  4076,  1235,
    1385,  1385,  1385,  4048,  4077,  4089,  4094,  1385,  4098,  3287,
    1385,  5877,  4156,  1385,  4096, -2238,  4176,  4190,  4159,  1385,
    4241,  1385,  4227,  4270,  1385,  4171,  4207,  4106,  4200,  1385,
    1385,  1385,  1385,  4283,  4310,  1385,  1385,  1385,  1385,  1385,
    1385,  1385,  1385,  1385,  1385,  4100,  4111,  4109,  1385,  1385,
    1385,  4112,  1238,  3835,  4116,  2646,  4118,  4120,  1385,  4119,
    5427,  5428,  4142,  1385,   928,  4147,  4201,  1385,  4148,  4155,
    4296, -2756,  4170,  4266,  4203,  1385,  3486,  4205,  1385,  4228,
    1385,  4233,  4235,  4285,  4250,  4276,  4234,  4322,  4289,  2065,
    4236,  4242,  4304,  4287,  4317,  4315,  1385,  5315,  4324,  1385,
    1385,  4336,  4318,  4348,  1385,  1385,  4337,  4347,  4349,  1385,
    4353,  1385,  4813,  4355,  5439,  4361,  4364,  4367,  4359,  4371,
     865,   865,   865,  4382,  6286,  6287,  4129,  4274,  6289,  4360,
    4814,  4815,  4816,  4817,  4383,  4365,  4385,  4391,  4392,  4393,
    1385,  4249,  4263,  4249,  4249,  4401,  1385,  4249,  1081,  4409,
    4836,  4432,  2102,  1273,  3487,  4274,  4124,  4418,  3487,   191,
    4125,  4126,  4127,  4434,  4851,  4438,  4436,  4446,  4442,  4440,
   -2756,  4452,  4447,  3323,  4450,  4453,  4454,  4457,  5270,  4455,
    4473,  4474,  4475,  4476,  4477,  4478,  3486,  4479,  4480,  1078,
    5521,  1385,  3486,  5523,  5524,  5350,  1079,  4481,  1082,  1080,
    2102,  1578,  4484,  4486,  4488,  4490,  3536,  1579,  1385,  4493,
    4497,  4482,  4130,  5529,  4483,  2989,  2992,  4485,  4495,  4516,
    4487,  4521,  1685, -2756,  3370,  5450,  4509,  4527,  4564,  4579,
    4489,  4513,  5417,  5418,  4510,  5420, -2756,  4499,  4511,  4529,
    4202,  4580, -2756,  4500,  4569,  4506,  4570,  4583, -2756,  4587,
    4576,  4598,  1581,  4600, -2756,  4597,  4607, -2756,  5505,  4616,
    4610, -2756,  4617,  4924,  2004,  2845,  2004,  5574,  4620,  2004,
    4621,  4932,  4623,  4637,  4651,  4654,  4657,  4661,  4663,  4669,
    4670,  4671,  3483,  4672,  4673,  4674,  3483,  4676,  4692,  4956,
    4693, -2756,  4699,  4700,  4712,  4716,  4691,  4701,  5406,  4702,
    4704,  5613,  4237,  4705,  4706,  4243,  4722,  1686,  4707,  1582,
    2051,  4708,  4717,  3486,  4718,  4723,  1583,  4726,  4731,  4732,
    1584,  4719,  4124,  4744, -2756,  4784, -2237,  2110,  4795,  4853,
    2111,  4796,  4826,  4839,  2112,  2113,  2114,  4737,  4767,  4768,
    4840,  3595,  4847,  4769,  5005,  4848,  4274,  3603,  1585,  4810,
    4854,  4855,  2634,  3475,  4776,  4799,  4863,   927,  4866,  4822,
    4824,  3475,  2635,  4832,  4868,  4835,  4837,  4129,  4852,  2636,
    4857,  4872,  4891,  4883,  4901, -2756,  4902,  4903,  4912, -2756,
    4904,  4911,  4914,  4915,  1586, -2756,  4918,  4933,  4936,  4937,
    4954,  3483,  3637,  4957,  3645,  2637,  2950,  5468,  4969,  4970,
    5008,  5051,  5255,  4971,  4972,  4973,  4985,  4983,  4986,  4984,
    4987,  3767,  4988,  4997,  4999,  5006,  5017,  5000,  5018,  5023,
    5027,  5028,  5044,  5045,  5047,  4131,  4132,  4133,  4134,  4135,
    4136,  4137,  4138,  4139,   953,  2110,  5050,  4943,  2111,  5061,
    5063,  5060,  5064,  5065,  1687,  5087, -2756,  5076,   953,  5102,
    1385,  5116,  5123,  4130,  5128,  5135,  5145,   865,  5122,  5151,
    5152,  5162,  5097,  5095,  1688,  5173,  5108,  5129,  1588,  5903,
    2635,  5905,  5169,  5168,  2845,  5172,  5171, -2993,  1589,  5175,
    5181,  5176,  5187,  5195,  5201,  5202,  3221,  5211,  1590,   865,
    5218,  5219,  5220,  5221,  3487,  3924,  5241,  5223,  5253,  5222,
    1591,  5589,  3806,  2637,  5224,  5225,   809,  5230,  5231,  5236,
    5247,  5144,  5589,  2638,  5256,  5257, -2239,  5258,  2639,  5279,
    5294,   865,  5275,  5262,  5289,  5297,  5290,  5308,  5313,  5317,
    5304,  5334,  5330,  1385,  1385,  5316, -2756,  5327,  5338,  5332,
    5357,  2640,  2304,  1689,  1385,  5358,  1593,  1594,  5370,  5374,
    5371,  5372,  5376,  5381,  5382,  2004,   865,  5383,  5395,  5398,
   -2756,  5404, -2756, -2756,  5402,  5408,  5409,  5414,  5421,  2641,
    5413,  5429,  5422,   865,  5739,  4804,  5431,  5430,  1690,  5692,
     998,  5440,  2110,  5443, -2756,  2111,  5154,  5436,  5447,  1691,
    5448,  6028,  5455,  5463,  5914,  5458,  5464,  5639,  5465,  5467,
    5473,  5477,  5471,  5487, -2756,  5489,  3874, -2756, -2756, -2756,
    5493,  5494,  2371,  5482,  1385,  5498,  5496,  2635,  5500,  5511,
    5501, -2993,  3483,  3483, -2993,  5519, -2993,  2642,  5502,  5526,
    1385,  3196,  5517,  5658,  5532,  5527,  6058,  5546,  5869,  5547,
    5553,  5563,  5557,  5573,  5565,  5564,  5582,  5588,  1385,  5577,
    2637,  5617,  1596,  5620,  5631,  5592,  5595,  5628,  5635,  5643,
    5647,  5648,  5614,  5653,  5630,  5649,  4131,  4132,  4133,  4134,
    4135,  4136,  4137,  4138,  4139,  5650,  1385, -2993,  5655,  1385,
    5661,  5662,  5707,  5666,  6094,  6096,  5685,  1385,  1385,  5086,
    5672,  5673,  5674,  5713,  1385,  1385,  5908,  5715,  5816,  1385,
    5718,  5721,  5745,  5725,  1385,  5726,  5916,  1385,  1385,  5746,
    5750,  5755,  5821,  5757,  1385,  5773,  5786,  5778,   865,   865,
     865,   865,  5273,  2110,  2644,  5792,  2111,  5801,  5784,  5785,
    2112,  2113,  2114,  5802,  5844,  2642,   652,  5806,  5819,  4249,
    5807,  2104,  5828,  3487,  5852,  5820,  5854,  5834,  3487,  5846,
    5864,  3487,   652,  5871,  3806,  5883,  5310,  5848,  2635,  1385,
    5873,  1000,  5850,  5851,  5881,  2636,  5875,  5895, -2993,  5889,
    1385,  5929,  5931, -2993,  4295,  5934,  5944,  5938,  1385,  5942,
    3536,  5952,  5957,   187,  5966,  5970,  4046,  5971,  5972,  5973,
    5974,  2637,  5984,  5991,  5983,   804,  5843,  5985,  5995,  5986,
    6001,  4056,  6011,  6016,  5993,  6012,  4061,  6025,  6026,  5998,
    6027,  5896,  5897,  5228,  6032,  6087,  6052,  6051,  6042,   187,
    4208,  6054,  2845,  1385, -2993,  6055,  6056,  6069,  6073,  6092,
    5333,  2572, -2993,  6099,  6102,  6105,  4087,  5366,  5319,  5321,
    2573,  2574,  2575,  2576,  2577,  2578,  2579,  2580,  2581,  6107,
    6113,  6116,  6117,  6133,  6134,  6223,  6136,  6109,  6143,  6144,
    6150,  6135,  6149,  6100,  3483,  6151,  6156,  6157,  3323,  6158,
    6163,  3483,  6168,  6175, -2758,  6172,  3483,   971,  6173,  3483,
    6179,  6187,  2642,  6195,  6215,  6217,  1007,  6189,  6225,  5907,
    3767,  6103,  6208,  6104,  6233,  6234,  6235,  6251,  6253,  6270,
    1029,  3767,  6271,  1385,  6274,  6272,  6276,  6273,  6284,  2638,
    1385,  6288,  6297,  6292,  2639,  6298,  6299,  6310,  6312,  6330,
    6342,  3323,  6336,  6337,  5900,  6340,  6345,  6341,  6344,  6354,
    6359,  6357,  6377,  6378,   953,  6281,  6282, -2993, -2993, -2993,
    6379,  6407,  1144,  6382,  6380,  6000,  6381,  4302, -2001,   953,
    6397,  2576,  2577,  2578,  2579,  2580,  2581,  6418,  6422,  6302,
    6443,  6424,  6409,  6410,  6455,  2641,  6435,  6436,  6451,  6452,
    6457,  6461,  6466, -2758,  6468,  6463,  1468,  6474,  5780, -2993,
    1385,  6034,  1681,  1680,  1575,  6041,  4225,  6043,  3778,  5902,
    4377,  3695,  3006,  4960,  2626,  4953,   652,  6218,  3821,  5704,
    3869,  4526,  6086,  2845,  6311,  5104,  5756,  4949, -2993,  4950,
    5738,  5446,  2004,  4357,  4320,  6063,  4016,  6210,  5637,  6307,
    6108,  6106,  6232,  2642,  6322,  5475, -2758,  3924,  4363,  5155,
    5126,  5134,  2102,  6066,  5096,  3887,  3888,  4958,  5469, -2758,
     953,  4395,  3946,  4586,  5121, -2758,  1665,  5744,  4626,  5179,
    5987, -2758,  6374,  5692,  6473,  6453,  5719, -2758,  5163,   187,
   -2758,  5660,  4532,  6237, -2758,  5891,  6075,  5663,   865,   758,
     811,  2024,  4677,  1074,  5196,  3073,  5867,  6370,  5198,   865,
     998,  3475,  3136,  3547,  3916,  3475, -2993,  5165,  4311,  3132,
    4643,  3148,  5781,  5981, -2758,  1185,  3165,  1145,  2576,  2577,
    2578,  2579,  2580,  2581,  4274,  5480,  4496,  3818,  4989,  6257,
    4441,   654,  5182,  1413,  6408,  6060,   998,  3846,  2759,  5183,
    2644,  3492,  6360,  6087,  5322,  5659,  3031, -2758,  4877,  5863,
    5866,  2647,  1385,   839,   840,  2599,  5226,  4272,  2708,  4284,
    3502,  2707,  1385,  4328,  6192,  1385,  6044,  2712,  1385,  1385,
    1385,  4331,  5657,  4245,  4829,  3483,   916,  4845,  5594,  5832,
    4238,  4239,  5833,  1144,  4878,  6395,  6178,  6290,  6033,  4240,
    6421,  5815,  2656,  1385,  1385,  4778,  6045,  1385, -2758,  3411,
    3323,  4204, -2758,  3414,  6046,  3329,  4198,  4070, -2758,  3845,
    6426,  4196,  5999,  4189,  1385,  4105,  4727,  1464,  1385,  3490,
    3426,  5706,     0,     0,  1385,     0,     0,     0,  3487,     0,
       0,  3323,  5310,  6305,     0,  1385,     0,  5612,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2572,  4924,     0,
       0,  1385,     0,     0,     0,     0,  2573,  2574,  2575,  2576,
    2577,  2578,  2579,  2580,  2581,     0,     0,     0,     0, -2758,
       0,     0,     0,     0,     0,  4427,     0,  4429,  5615,     0,
    4924,  1000,   953,     0,   953,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   964,  1000,  6439,     0,
       0,     0,   654,     0,     0,     0,     0,     0,     0,   809,
       0,   654,   973,     0,     0,     0,     0,   865,   865,   654,
       0,   973,   654,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5900,  1273,   973,  3483,  4124,   794, -2758,
       0,  4125,  4126,  4127,   794,   964,     0,     0,     0,     0,
       0,     0,     0,  1099,     0,  4492,  3483,  5095,     0,  1099,
       0,  1273,   865, -2758,  4124, -2758, -2758,   865,  4125,  4126,
    4127,  1099,     0,     0,     0,     0,  2845,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   865, -2758,  3483,  5838,
    5144,     0,     0,  5758,     0,     0,     0,     0,     0,  4514,
       0,     0,     0,     0,   953,   865,  4924, -2758,     0,     0,
   -2758, -2758, -2758,  2110,     0,     0,  2111,     0,     0,     0,
       0,  3475,     0,    71,    80,    83,  6454,    84,    85,    86,
     106,     0,   184,     0,   124,   129,   159,  5743,   175,     0,
    1385,     0,   178,   191,   185,     0,     0,   187,  2635,  6362,
    6363,  6364,     0,     0,     0, -2993,     0,  1385,     0,     0,
       0,  1385,     0,  1385,  3323,   928,     0,     0,  5769,     0,
       0,  1144,     0,   180,     0,     0,     0,  1385,     0,     0,
     181,  2637,   186,   183,     0,   652,     0,     0,  1385,     0,
       0,     0,  5841,  2110,     0,  3645,  2111,     0,  6398,  1385,
    2112,  2113,  2114,     0,     0,     0,  1385,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5771,     0,  2634,     0,
       0,     0,  6416,     0,     0,     0,     0,     0,  2635,     0,
       0,     0,     0,     0,  3483,  2636,     0,     0,     0,  4656,
       0,     0,     0,     0,     0,     0,     0,   865, -2993,     0,
       0,     0,     0,     0,  1385,     0,     0,     0,     0,     0,
       0,  2637,     0,     0,     0,     0,     0,     0,     0,     0,
    1385,     0,     0,     0,     0,  4129,  1385,  1385,     0,     0,
       0,  6416,     0,     0,     0,   953,   953,   953,   953,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   998, -2993,
       0,     0,     0,     0, -2993,     0,  6416,     0,     0,     0,
       0,     0,     0,  3483,     0,     0,  1385,     0,     0,     0,
       0,  4713,     0,  2110,   652,     0,  2111,     0,     0,     0,
   -2993, -2993, -2993,     0,  4130,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   865,
       0,     0,  3487,     0,     0, -2993,     0,     0,  2635,  6177,
       0,  4130,     0,     0,     0,  2636,     0,     0,     0,     0,
    3475,     0,     0,  4745,     0,  3475,     0,   865,  3475,  2638,
       0,     0,     0,     0,  2639,     0,     0,     0,     0,     0,
       0,  2637,     0,     0,     0,     0,     0,     0,  4766,   187,
     187,     0,     0,     0,     0,  1385,     0,  2640,  2304,     0,
       0,     0,     0,  2642,     0,     0,     0,  1385,     0,     0,
    5960,     0,     0,     0,     0,     0,  1385,  1385,  1385,     0,
       0,     0,  2004,     0,     0,  2641,     0,     0,  3806,     0,
       0,  1385,     0,     0,     0,     0,     0,     0,     0,     0,
    1385,     0,  1385,     0,  1385,  5612,     0,     0,     0,     0,
       0,  4924,     0,     0,     0,     0,     0,     0,  1385,   973,
       0,     0,     0,     0,     0,     0,     0,  2004,  2371,  1000,
    3483,     0,     0,     0,     0,     0,     0,  1385,   973,     0,
       0,     0,     0,  2642,   973,     0,  2643,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   973,  3323,  3323,  2638,
   -2993,  3323,     0,     0,  2639,     0,     0,     0,     0,     0,
       0,     0,   973,     0,  6048,  2004,  2004,   654,     0,     0,
    6214,     0,   916,     0,     0,     0,   654,   973,     0,     0,
       0,     0,     0,   654,     0,   973,   654,  4131,  4132,  4133,
    4134,  4135,  4136,  4137,  4138,  4139,   953,     0,   916,   973,
       0,     0,     0,     0,     0,  2641,     0,     0,     0,   973,
    6129,     0,     0,     0,  4131,  4132,  4133,  4134,  4135,  4136,
    4137,  4138,  4139,     0,     0,     0,     0,     0,     0,  3483,
    2644,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  6264,  6265,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0, -2993,     0,     0,
       0,  1385,   973,  2642,     0,     0,     0,     0,     0,  2576,
    2577,  2578,  2579,  2580,  2581,     0,  1385,     0,     0,     0,
    5841,     0,     0,     0,   654,   654,  1385,     0,     0,     0,
     973,     0,     0,     0,     0,  3536,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   187,     0,     0,     0,
       0,     0,     0,     0,   964,   973,     0,   654,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   953,
       0,     0,     0,     0,     0,     0,  2004,  2572,  3483,     0,
       0,   916,     0,     0,     0,     0,  2573,  2574,  2575,  2576,
    2577,  2578,  2579,  2580,  2581,     0,     0,     0,     0,     0,
    2644,     0,  2845,  4097,   654,     0,     0,     0,     0,  1385,
       0,     0,     0,     0,     0,     0,     0,   973,     0,  4924,
       0,     0,     0,     0,     0,     0,     0,   964,   964,  6267,
       0,     0,     0,  1385,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   191,     0,     0,  2004,  2004,  6283,     0,
       0,     0,     0,     0,  1385,  1385,     0,  6238,  1385,     0,
       0,  6291,     0,     0,   794,     0,   794,     0,   794,     0,
       0,     0,     0,  6259,   794,  1222,  1223,     0,     0,     0,
    6260,     0,  6262,  6261,     0,     0,     0,     0,  6335,   953,
       0,     0,     0,     0,     0,  5107,     0,  2572,     0,     0,
       0,     0,     0,     0,     0,  3475, -2993, -2993, -2993,  2576,
    2577,  2578,  2579,  2580,  2581,   654,   654,  1821,     0,  6129,
     953,   953,     0,     0,   973,  4924,     0,     0,     0,   654,
       0,     0,     0,     0,   916,   654,     0,  3483,     0,   654,
       0,   654,     0,   652,     0,   916,     0,     0,     0,     0,
    1385,     0,     0,     0,     0,     0,   191,     0,  6353,     0,
       0,   916,     0,     0,     0,     0,  1385,  3966,     0,     0,
       0,     0,  3536,     0,     0,     0,     0,  4295,     0,     0,
       0,  6464,  6465,     0,  1385,     0,  6259,     0,     0,     0,
       0,  1548,     0,  6260,     0,  6262,  6261,     0,     0,     0,
       0,     0,     0,     0,     0,   654,     0,   654,   654,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    6383,  6384,   652,  6388,     0,     0,     0,  1549,  5841,     0,
       0,     0,     0,  1385,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   953,     0,   651,  4924,  3483,   973,     0,
       0,     0,     0,  3483,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   794,  6353,     0,   187,     0,
       0,     0,     0,     0,     0,     0,   654,   191,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1550,  1385,   652,     0,     0,     0,     0,     0,     0,   187,
       0,     0,     0,     0,     0,     0,     0,  6259,   652,   973,
       0,     0,     0,   187,  6260,     0,  6262,  6261,   916,     0,
     973,     0,     0,     0,     0,   964,   964,  1551,     0,  6467,
       0,  6353,     0,     0,     0,   794,     0,   973,     0,     0,
       0,     0,   973,     0,     0,     0,     0,     0,  6353,     0,
       0,     0,  3004,     0,   654,     0,     0,     0,     0,     0,
       0,     0,     0,  1578,     0,     0,     0,     0,     0,  1579,
       0,     0,  3967,     0,  3483,     0,     0,  1552,     0,     0,
       0,     0,  -136,     0,  1685,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   654,     0,     0,     0,
       0,     0,     1,  2102,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     2,  1581,     3,     4,     0,     0,     0,
    5342,  1554,     0,     0,     0,   654,   654,   654,     0,   654,
       0,     0,     0,     5,     0,     0,   951,     0,     0,     0,
       0,     0,     0,     6,     0,   963,     0,     0,     0,     0,
     654,     0,     0,   963,  1556,     7,   963,     8,     9,     0,
       0,     0,     0,     0,    10,     0,    11,     0,     0,  1686,
       0,  1582,     0,  5378,     0,   973,     0,     0,  1583,    12,
       0,    13,  1584,   973,   973,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5394,     0,     0,    14,     0,
      35,    15,     0,     0,     0,  3968,     0,   654,     0,     0,
    1585,     0,     0,     0,  1559,     0,    16,     0,    17,     0,
       0,     0,    18,  1560,     0,  3083,     0,     0,     0,    19,
       0,  2823,     0,  3100,     0,     0,  1821,     0,    20,     0,
      21,  3004,     0,     0,     0,  1562,  1586,    22,     0,  3475,
       0,   187,     0,   654,  1563,     0,     0,   654,   654,  1564,
       0,     0,     0,     0,     0,    23,     0,     0,     0,  5426,
       0,     0,     0,   654,     0,     0,     0,     0,     0,   916,
    3969,     0,    24,     0,     0,     0,  3158,     0,  1578,     0,
       0,     0,  2110,     0,  1579,  2111,     0,     0,     0,  2112,
    2113,  2114,     0,     0,     0,     0,  1687,     0,     0,  1580,
       0,     0,     0,  3004,     0,     0,  1565,  2634,     0,     0,
    3970,     0,     0,     0,     0,     0,  1688,  2635,     0,     0,
    1588,     0,     0,     0,  2636,     0,    25,    26,     0,  1581,
    1589,     0,    27,     0,     0,     0,   916,     0,     0,     0,
    1590,     0,     0,     0,     0,   187,     0,    28,     0,     0,
    2637,     0,  1591,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    29,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   916,     0,   794,
    5510,     0,     0,     0,   794,   794,  1582,     0,     0,     0,
       0,     0,     0,  1583,     0,  3775,     0,  1584,  1593,  1594,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     916,     0,  2652,     0,    30,     0,     0,     0,     0, -2775,
       0,  2659,     0,  2660,     0,  1585,     0,  2663,     0,    31,
    3776,     0,     0,     0,  2669,    32,    33,     0,    34,     0,
       0,  1691,     0,    35,     0,     0,     0,     0,     0,    36,
       0,     0,    37,     0,     0,     0,     0,     0,     0,    38,
       0,  1586,     0,     0,     0,     0,    39,    40,  2638,     0,
       0,     0,     0,  2639,    41,     0,     0,   973,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      43,     0,   654,   654,   654,     0,  2640,  2304,     0,     0,
       0,     0,     0,     0,  1596,     0,     0,    44,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0, -2775,  4492,
       0,     0,     0,     0,  2641,   794,     0,     0,    45,     0,
       0,     0,     0,     0,     0,   794,     0,     0,     0,     0,
      46,  1587,     0,     0,     0,  1588,    47,     0,     0,     0,
       0,    48,     0,     0,     0,  1589,     0,     0,     0,     0,
       0,     0,     0,     0,    49,  1590,     0,  2371,     0,     0,
       0, -2775,     0,     0,     0,     0,     0,  1591,     0,  1222,
    1223,     0,  2642,     0, -2775,  2643,     0,     0,    50,     0,
   -2775,     0,   973,     0,     0,     0, -2775,     0,     0,     0,
       0,     0, -2775,     0,   916, -2775,     0,    56,   187, -2775,
    -136,     0,     0,     0,     0,   916,     0,     0,     0,     0,
    1592,     0,   794,  1593,  1594,   794,   794,  1821,     0,     0,
       0,   916,     0,   187,     0,     0,     0,     0,     0, -2775,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     973,   951,     0,     0,     0,  1595,     0,     0,   973,     0,
     963,     0,  1578,     0,     0,     0,   973,   963,  1579,     0,
     963,     0, -2775,     0,     0,     0,     0,     0,     0,  2644,
       0,     0,     0,     0,     0,   916,     0,     0,     0,     0,
       0,     0,     0,     0,   654,     0,     0,   654,     0,     0,
     916,     0,     0,   916,   916,     0,     0,   654,   654,     0,
     973,   973,     0,  1581,     0,     0,     0,     0,     0,     0,
       0,     0,   654, -2775,   973,   654,     0, -2775,     0,  1596,
       0,     0,     0, -2775,   916,   916,     0,   973,   973,     0,
       0,     0,     0,     0,     0,     0,  6334,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1582,     0,     0,     0,     0,   654,     0,  1583,     0,   654,
     654,  1584,     0,     0,     0,     0,  2572,     0,     0,     0,
       0,     0,     0,     0, -2775,  2573,  2574,  2575,  2576,  2577,
    2578,  2579,  2580,  2581,     0,     0,     0,     0,  4113,  1585,
       0,  4114,     0,     0,   654,     0,   654,     0,     0,     0,
     794,   654,   654,     0,     0,     0,     0,     0,   654,   654,
     654,   654,   654,   654,   654,   654,   654,   654,   654,   654,
     654,     0,     0,     0,   654,  1586,   654,     0,   654,   654,
     654,   654,   654,   654,   809,     0,   654,     0,   654,   654,
       0,     0,   654,     0,     0,  2030,     0,   187,     0,     0,
    2030,  2030,     0,   720,     0,     0,   916,   654,   654,   654,
       0,     0,   808,     0, -2775,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   654,     0,  1821,     0,     0,
       0,     0,     0,     0,     0,     0,  2110,     0, -2775,  2111,
   -2775, -2775,     0,  2112,  2113,  2114,     0,     0,  1578,     0,
       0,     0,     0,     0,  1579,  1688,     0,     0,     0,  1588,
       0,  2634, -2775,     0,     0,     0,     0,     0,     0,  1589,
       0,  2635,     0,  1645,     0,     0,     0,     0,  2636,  1590,
       0,     0, -2775,     0,     0, -2775, -2775, -2775,     0,  2110,
       0,  1591,  2111,     0,     0,  1646,  2112,  2113,  2114,  1581,
       0,     0,     0,     0,  2637,     0,     0,     0,     0,     0,
       0,     0,     0,   951,  2634,     0,     0,  5982,     0,   963,
       0,  4933,     0,   963,  2635,   963,     0,     0,     0,     0,
       0,  2636,     0,     0,  1717,     0,     0,  1593,  1594,  1578,
       0,     0,     0,     0,     0,  1579,     0,  1647,  4943,     0,
       0,     0,     0,     0,     0,  2779,  1582,  2637,     0,     0,
       0,     0,     0,  1583,     0,  3271,  3272,  1584,     0,  1718,
       0,     0,   654,     0,     0,     0,     0,     0,     0,     0,
    6038,     0,  3308,  3309,     0,     0,  3538,     0,     0,  1915,
    1581,  1917,  1918,     0,  4944,  1585,     0,     0,     0,     0,
       0,     0,     0,     0,  3554,     0,     0,     0,  3557,     0,
       0,     0,  3560,  3354,     0,     0,  4945,     0,     0,     0,
       0,     0,  2638,     0,     0,     0,   654,  2639,     0,     0,
       0,  1586,     0,     0,     0,     0,  3579,     0,     0,  1648,
       0,     0,     0,  1596,     0,     0,     0,  1582,     0,     0,
    2640,  2304,     0,     0,  1583,     0,     0,     0,  1584,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3621,     0,     0,     0,     0,  2638,     0,     0,  2641,     0,
    2639,     0,   654,     0,     0,     0,  1585,     0,     0,     0,
    1099,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1578,     0,  1649,  2640,  2304,     0,  1579,  1650,     0,     0,
       0,  1688,     0,     0,     0,  1588,     0,     0,     0,     0,
       0,  2371,  1586,  2949,     0,  1589,     0,  4946,  3680,     0,
       0,  2641,     0,     0,     0,  1590,  2642,     0,     0,  2643,
       0,     0,     0,     0,     0,     0,     0,  1591,     0,     0,
       0,  1581,     0,     0,     0,  3709,     0,     0,  1652,     0,
       0,  3718,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2371,  3728,     0,     0,     0,     0,
       0,     0,  1099,     0,     0,  3741,     0,     0,     0,  2642,
    2803,  3746,  2643,  1593,  1594,     0,     0,     0,     0,     0,
       0,     0,  1587,     0,     0,     0,  1588,  1654,  1582,     0,
       0,  3759,     0,     0,     0,  1583,  1589,  3762,     0,  1584,
       0,     0,     0,     0,  3770,  2804,  1590,     0,     0,     0,
       0,  1655,     0,  2644,     0,     0,     0,     0,  1591,     0,
    3787,     0,     0,     0,     0,     0,     0,  1585,     0,     0,
       0,     0,     0,  1657,  3813,  4947,     0,     0,  4367,     0,
       0,     0,     0,     0,     0,  1099,     0,     0,   654,   654,
     654,   654,   654,   654,   654,   654,   654,     0,   654,     0,
       0,  2887,     0,  1586,  1593,  1594,  2644,     0,     0,   654,
       0,   654,     0,     0,     0,     0,     0,     0,     0,  1596,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2888,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   654,
       0,     0,     0,   654,     0,     0,   654,     0,   654,     0,
    2572,   654,     0,     0,     0,   654,     0,     0,     0,  2573,
    2574,  2575,  2576,  2577,  2578,  2579,  2580,  2581,     0,     0,
       0,     0,     0,  1688,     0,  4115,  1821,  1588,   654,     0,
    2871,     0,     0,     0,     0,     0,     0,  1589,     0,     0,
       0,     0,     0,     0,     0,   654,     0,  1590,     0,     0,
    1596,     0,     0,  2572,   654,   654,     0,     0,     0,  1591,
       0,     0,  2573,  2574,  2575,  2576,  2577,  2578,  2579,  2580,
    2581,     0,     0,     0,     0,     0,     0,     0,  4166,     0,
       0,   973,     0,     0,     0,     0,     0,     0,   916,     0,
       0,     0,   916,   916,     0,     0,     0,     0,     0,   973,
       0,     0,  3631,   973,     0,  1593,  1594,   973,     0,     0,
       0,     0,     0,  1075,     0,     0,   973,     0,     0,  2110,
       0,     0,  2111,     0,     0,     0,  2112,  2113,  2114,     0,
       0,   973,     0,     0,   654,     0,     0,  1595,     0,     0,
    4031,     0,     0,     0,  2634,   654,     0,   916,   654,     0,
     654,   654,  6394,   916,  2635,     0,     0,     0,     0,  4047,
       0,  2636,     0,  1143,   720,   973,  4031,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   973,   973,  2637,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     916,     0,     0,  1578,     0,     0,     0,     0,     0,  1579,
       0,  1596,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1821,   973,     0,     0,  1821,  3455,  3457,     0,
       0,     0,     0,  3465,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     973,     0,  1821,     0,  1581,     0,   973,     0,     0,  1242,
       0,     0,     0,     0,     0,  3511,  3511,     0,     0,     0,
     973,     0,     0,     0,     0,     0,     0,   973,     0,  1264,
     973,     0,     0,     0,     0,     0,   973,  1388,     0,     0,
    1397,  1143,  1399,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2638,   973,     0,     0,     0,
    2639,  1582,   973,  3966,     0,     0,     0,     0,  1583,   973,
       0,  2110,  1584,     0,  2111,     0,     0,   794,  2112,  2113,
    2114,     0,     0,  2640,  2304,   973,     0,  1548,     0,     0,
       0,     0,     0,     0,     0,     0,  2634,     0,     0,   973,
    1585,     0,     0,     0,  1821,     0,  2635,     0,     0,     0,
     973,  2641,     0,  2636,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1549,     0,     0,     0,     0,   654,   654,
     654,     0,     0,     0,   654,     0,  1586,     0,     0,  2637,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2110,
       0,     0,  2111,     0,  2371,     0,  2112,  2113,  2114,     0,
       0,   654,   916,     0,  3647,     0,     0,     0,     0,  2642,
    1821,     0,  2643,     0,  2634,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2635,     0,  1550,     0,     0,     0,
       0,  2636,     0,     0,     0,     0,     0,     0,   951,     0,
       0,   951,     0,   654,     0,     0,     0,     0,     0,     0,
       0,   963,   963,     0,     0,     0,  1688,  2637,     0,     0,
    1588,     0,     0,  1551,     0,     0,   963,     0,     0,   963,
    1589,     0,     0,     0,     0,   916,     0,     0,     0,   916,
    1590,     0,     0,     0,     0,  1143,     0,     0,     0,     0,
       0,     0,  1591,   794,     0,     0,     0,  2638,  4325,     0,
       0,   794,  2639,     0,   794,     0,  2644,     0,  3967,     0,
       0,     0,     0,  1552,     0,     0,   794,     0,     0,   963,
       0,     0,     0,   963,   963,  2640,  2304,     0,     0,     0,
       0,     0,     0,     0,     0,  3824,     0,     0,  1593,  1594,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2641,     0,     0,     0,  1554,     0,     0,
       0,     0,     0,     0,     0,   973,     0,  1821,     0,     0,
    3825,     0,     0,     0,     0,  2638,     0,     0,     0,     0,
    2639,     0,   916,     0,   973,     0,     0,     0,     0,     0,
    1556,   973,     0,     0,     0,   654,  2371,   916,   654,     0,
     654,   654,   916,  2640,  2304,     0,     0,  4410,     0,     0,
     654,  2642,     0,  2572,  2643,   654,     0,     0,     0,     0,
       0,     0,  2573,  2574,  2575,  2576,  2577,  2578,  2579,  2580,
    2581,  2641,   916,     0,     0,  3352,    35,     0,     0,     0,
       0,  1558,     0,     0,  1596,     0,     0,     0,     0,     0,
    1559,     0,     0,     0,     0,     0,     0,     0,     0,  1560,
       0,     0,     0,     0,   654,   654,   654,  2823,     0,   654,
       0,     0,     0,     0,  2371,     0,  2029,   654,   654,   654,
     654,  1562,     0,     0,     0,     0,     0,     0,  1821,  2642,
    1563,     0,  2643,   654,  1821,  1564,   654,     0,   654,     0,
       0,     0,     0,  1143,     0,     0,     0,     0,  2644,     0,
     654,   654,     0,     0,   654,     0,  3969,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   654,     0,   654,  2110,   654,
    4507,  2111,     0,     0,     0,  2112,  2113,  2114,     0,  1578,
       0,     0,  1565,     0,     0,  1579,  3970,     0,   654,     0,
       0,     0,     0,  2634,     0,   794,     0,     0,     0,     0,
       0,     0,     0,  2635,     0,     0,     0,     0,     0,   973,
    2636,     0,     0,     0,     0,     0,  2644,     0,     0,     0,
       0,     0,  2106,     0,     0,     0,     0,     0,     0,     0,
    1581,  2108,     0,     0,     0,     0,  2637,     0,     0,     0,
       0,     0,     0,     0,     0,  2572,   654,  2597,     0,   654,
       0,     0,     0,     0,  2573,  2574,  2575,  2576,  2577,  2578,
    2579,  2580,  2581,   654,     0,     0,  1143,  4107,   654,  2614,
    2615,     0,     0,     0,  1143,  1143,     0,     0,     0,     0,
       0,     0,     0,   654,     0,     0,     0,  1582,     0,     0,
       0,     0,     0,     0,  1583,     0,     0,   654,  1584,     0,
       0,     0,     0,     0,     0,   654,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   916,     0,     0,
     916,     0,   916,  2572,     0,     0,  1585,   916,     0,     0,
       0,     0,  2573,  2574,  2575,  2576,  2577,  2578,  2579,  2580,
    2581,     0,   973,   973,     0,  4528,     0,     0,   654,  3004,
       0,     0,     0,     0,  2638,     0,     0,     0,     0,  2639,
       0,     0,  1586,   973,     0,     0,   973,     0,  4679,   916,
       0,     0,  4683,     0,     0,     0,     0,   916,     0,     0,
       0,     0,  2640,  2304,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   916,  1578,     0,     0,     0,     0,   654,  1579,
    2641,     0,     0,     0,     0,     0,  1645,     0,  4223,     0,
     794,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4230,     0,  1646,     0,
       0,     0,  1688,     0,     0,     0,  1588,  1821,  1821,  1821,
       0,     0,     0,  2371,  1581,     0,  1589,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1590,     0,  2642,     0,
       0,  2643,   973,     0,     0,     0,     0,     0,  1591,     0,
       0,   916,     0,   916,     0,     0,  4279,  4279,     0,     0,
    1647,   973,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1582,     0,   973,     0,     0,     0,     0,  1583,     0,
       0,  4341,  1584,     0,  1593,  1594,     0,     0,     0,  2954,
       0,     0,     0,     0,     0,     0,   915,  2962,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1585,     0,     0,     0,     0,  2110,  4342,     0,  2111,     0,
       0,     0,  2112,  2113,  2114,  2644,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2110,     0,     0,  2111,
    2634,   916,  1648,  2112,  2113,  2114,  1586,     0,     0,     0,
    2635,     0,     0,     0,     0,     0,     0,  2636,     0,     0,
       0,  2634,     0,     0,     0,   973,     0,     0,     0,     0,
     654,  2635,   651,     0,     0,     0,   654,     0,  2636,     0,
       0,     0,     0,  2637,     0,   916,     0,     0,     0,     0,
    1596,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2637,  1649,     0,     0,     0,     0,
    1650,     0,  1821,   916,     0,     0,     0,     0,   973,     0,
     973,     0,     0,     0,     0,     0,  1651,     0,     0,     0,
    1588,     0,  2572,   973,     0,   973,  4906,     0,     0,     0,
    1589,  2573,  2574,  2575,  2576,  2577,  2578,  2579,  2580,  2581,
    1590,     0,     0,     0,  4714,   654,     0,     0,     0,     0,
       0,  1652,  1591,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   916,     0,     0,     0,     0,     0,     0,     0,   951,
       0,     0,   963,     0,   963,   963,     0,     0,     0,     0,
       0,  2638,   973,   916,     0,  1653,  2639,     0,  1593,  1594,
    1654,     0,     0,     0,  3094,     0,     0,     0,  3099,     0,
       0,     0,  2638,     0,     0,   916,     0,  2639,     0,  2640,
    2304,     0,     0,     0,  1655,     0,     0,     0,     0,     0,
    1656,     0,     0,     0,   973,     0,     0,     0,     0,     0,
    2640,  2304,     0,     0,     0,     0,  1657,  2641,     0,     0,
       0,     0,     0,   973,     0,     0,     0,   973,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2641,  5033,
       0,     0,  5036,     0,     0,     0,     0,     0,   973,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2371,     0,     0,     0,   654,  1578,     0,   916,     0,     0,
       0,  1579,     0,   654,  1596,  2642,     0,     0,  2643,     0,
       0,  2371,     0,     0,   794,     0,     0,   654,     0,     0,
       0,   654,   654,   654,     0,     0,  2642,     0,   654,  2643,
       0,   654,     0,     0,   654,     0,     0,  4575,     0,     0,
     654,     0,   654,     0,     0,   654,  1581,     0,     0,   916,
     654,   654,   654,   654,     0,     0,   654,   654,   654,   654,
     654,   654,   654,   654,   654,   654,     0,     0,     0,   654,
     654,   654,     0,  5118,   916,     0,     0,     0,  3282,   654,
       0,     0,     0,     0,   654,     0,  1821,     0,   654,     0,
    3004,     0,     0,     0,     0,     0,   654,     0,     0,   654,
       0,   654,  2644,  1582,     0,     0,     0,     0,     0,     0,
    1583,     0,     0,     0,  1584,     0,     0,   654,     0,     0,
     654,   654,     0,  2644,     0,   654,   654,     0,     0,     0,
     654,     0,   654,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1585,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   654,     0,     0,     0,     0,     0,   654,     0,     0,
       0,  4031,     0,     0,     0,   654,     0,     0,  1586,   654,
       0,     0,     0,     0,     0,     0,     0,   651,     0,     0,
       0,     0,     0,     0,   794,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2572,
       0,     0,   654,     0,     0,     0,     0,     0,  2573,  2574,
    2575,  2576,  2577,  2578,  2579,  2580,  2581,     0,     0,   654,
    2572,  4787,     0,     0,     0,   916,     0,     0,     0,  2573,
    2574,  2575,  2576,  2577,  2578,  2579,  2580,  2581,     0,     0,
       0,     0,  4893,     0,     0,     0,     0,     0,  1688,     0,
       0,   973,  1588,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1589,     0,     0,  1578,     0,     0,     0,     0,
       0,  1579,  1590,     0,   654,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1591,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1821,     0,     0,  1581,     0,  1821,   916,
    1821,     0,     0,     0,     0,     0,     0,  4412,     0,   951,
    1593,  1594,   963,  2110,   963,   963,  2111,     0,     0,     0,
    2112,  2113,  2114,     0,     0,     0,  1821,   916,     0,     0,
       0,     0,   915,     0,     0,     0,     0,     0,  2634,     0,
       0,     0,  4413,  2110,     0,     0,  2111,     0,  2635,     0,
    2112,  2113,  2114,  1582,     0,  2636,     0,     0,   915,     0,
    1583,     0,     0,     0,  1584,     0,     0,     0,  2634,     0,
       0,     0,     0,     0,   973,     0,     0,   973,  2635,     0,
       0,  2637,     0,     0,     0,  2636,     0,     0,     0,     0,
       0,     0,  1585,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2637,     0,     0,     0,  2110,  1596,     0,  2111,     0,
       0,     0,  2112,  2113,  2114,     0,     0,     0,  1586,     0,
       0,  5389,     0,     0,     0,     0,     0,     0,     0,     0,
    2634,   654,     0,  5399,     0,  2110,     0,     0,  2111,     0,
    2635,     0,  2112,  2113,  2114,     0,     0,  2636,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   973,   973,     0,
    2634,   916,     0,     0,     0,     0,     0,     0,   973,     0,
    2635,     0,     0,  2637,     0,   654,   654,  2636,     0,     0,
       0,     0,     0,     0,     0,   973,     0,     0,     0,  2638,
       0,   915,     0,     0,  2639,     0,     0,     0,  1688,     0,
     794,     0,  1588,  2637,     0,     0,     0,     0,   916,     0,
       0,     0,  1589,   916,   654,   654,     0,  2640,  2304,  2638,
     651,     0,  1590,   651,  2639,   654,     0,     0,   794,     0,
       0,     0,     0,     0,  1591,     0,     0,     0,     0,     0,
       0,     0,   794,     0,     0,  2641,     0,  2640,  2304,     0,
       0,     0,     0,   794,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   973,     0,     0,  1821,
       0,   651,     0,     0,     0,  2641,     0,     0,     0,   651,
    1593,  1594,     0,     0,     0,     0,     0,     0,  2371,  3433,
       0,  2638,     0,     0,     0,   654,  2639,     0,     0,     0,
       0,     0,     0,  2642,     0,     0,  2643,     0,     0,     0,
       0,   654,  1595,     0,     0,     0,     0,     0,  2371,  2640,
    2304,  2638,     0,     0,     0,     0,  2639,     0,     0,   654,
       0,  1222,  1223,  2642,     0,  1736,  2643,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2641,     0,  2640,
    2304,     0,  4031,     0,   915,     0,     0,   654,     0,     0,
     654,     0,     0,     0,     0,   915,     0,     0,   654,   654,
       0,   916,     0,     0,     0,   654,   654,  2641,     0,     0,
     654,   915,     0,     0,     0,   654,  1596,     0,   654,   654,
    2371,     0,     0,     0,     0,   654,     0,     0,     0,     0,
    2644,     0,     0,     0,     0,  2642,     0,     0,  2643,     0,
       0,     0,     0,     0,     0,     0,     0,   654,     0,   794,
    2371,     0,     0,     0,   654,     0,     0,     0,     0,   654,
    2644,     0,   654,   654,     0,  2642,     0,  1143,  2643,     0,
     654,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   654,     0,     0,     0,     0,     0,     0,     0,   654,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   794,     0,  1548,     0,     0,     0,     0,     0,
       0,     0,  4031,     0,  4031,     0,   916,     0,     0,     0,
       0,     0,     0,  1399,     0,     0,     0,     0,     0,   973,
       0,     0,  2644,     0,   654,     0,     0,  2572,     0,     0,
    1549,     0,     0,     0,     0,     0,  2573,  2574,  2575,  2576,
    2577,  2578,  2579,  2580,  2581,     0,     0,     0,     0,  4917,
       0,     0,  2644,     0,     0,     0,     0,  2572,   915,   916,
       0,     0,     0,     0,     0,     0,  2573,  2574,  2575,  2576,
    2577,  2578,  2579,  2580,  2581,     0,   973,     0,     0,  5124,
       0,   916,     0,     0,     0,     0,     0,     0,   973,     0,
       0,     0,     0,  1550,     0,     0,     0,     0,     0,  1399,
       0,     0,     0,     0,   654,     0,     0,     0,     0,     0,
       0,   654,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   973,  1399,     0,     0,  1548,     0,     0,  2572,
    1551,     0,     0,     0,     0,     0,     0,     0,  2573,  2574,
    2575,  2576,  2577,  2578,  2579,  2580,  2581,     0,     0,     0,
       0,  5237,     0,     0,     0,   916,     0,     0,     0,  2572,
       0,     0,  1549,     0,     0,     0,     0,     0,  2573,  2574,
    2575,  2576,  2577,  2578,  2579,  2580,  2581,     0,     0,  3028,
    1552,   654,     0,     0,     0,     0,     0,     0,     0,  3812,
       0,     0,     0,  3816,     0,     0,     0,   654,     0,     0,
       0,     0,  1821,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1553,   973,     0,     0,  1554,  1550,     0,     0,   654,     0,
    3849,     0,  3849,     0,  3849,  3849,     0,     0,     0,  3849,
    3849,  3849,     0,  3849,  3849,  3849,     0,     0,     0,     0,
       0,     0,   794,     0,     0,     0,  1555,  1556,   794,     0,
       0,     0,  1551,   794,     0,     0,  1548,     0,     0,     0,
       0,     0,     0,     0,   916,     0,   916,     0,     0,     0,
       0,     0,     0,     0,     0,  2110,     0,     0,  2111,     0,
    5392,  5393,  2112,  2113,  2114,  5396,  5397,  3926,     0,  1557,
       0,     0,  1549,    35,     0,     0,     0,   973,  1558,     0,
    2634,     0,  1552,     0,     0,     0,     0,  1559,     0,  2743,
    2635,     0,  3954,     0,     0,     0,  1560,  2636,     0,     0,
       0,     0,     0,   654,  1561,     0,     0,     0,     0,     0,
       0,     0,     0,   654,     0,     0,   654,     0,  1562,   654,
     654,   654,  1553,  2637,     0,     0,  1554,  1563,     0,     0,
       0,     0,  1564,     0,     0,  1550,     0,     0,     0,     0,
       0,     0,     0,     0,   654,   654,  2110,     0,   654,  2111,
       0,     0,     0,  2112,  2113,  2114,  2743,     0,  1619,  1556,
       0,     0,     0,     0,     0,   654,     0,     0,     0,   654,
       0,  2634,  1551,     0,     0,   654,     0,     0,     0,   654,
       0,  2635,     0,     0,     0,   916,   654,     0,  2636,  1565,
       0,     0,     0,     0,     0,     0,     0,   915,     0,   654,
       0,  1620,   654,     0,     0,    35,     0,   973,     0,   973,
    1558,     0,     0,     0,  2637,     0,     0,     0,     0,  1559,
       0,     0,  1552,     0,     0,     0,     0,     0,  1560,     0,
     915,   654,     0,     0,     0,     0,  1621,     0,     0,     0,
       0,  2638,     0,     0,     0,     0,  2639,     0,     0,     0,
    1562,     0,     0,     0,     0,     0,   916,   973,     0,  1563,
       0,     0,  1553,     0,  1564,     0,  1554,   654,     0,  2640,
    2304,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   651,
       0,     0,     0,   651,     0,     0,     0,  2641,  1636,  1556,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1821,  1736,  1736,  1736,     0,   654,     0,     0,     0,
       0,  1565,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2638,     0,     0,     0,     0,  2639,     0,     0,
    2371,  1637,     0,     0,     0,    35,     0,     0,     0,     0,
    1558,     0,     0,     0,     0,  2642,     0,     0,  2643,  1559,
    2640,  2304,     0,     0,     0,     0,     0,     0,  1560,     0,
       0,     0,     0,     0,     0,     0,  1638,   654,     0,     0,
     916,     0,     0,     0,     0,     0,     0,     0,  2641,     0,
    1562,     0,     0,     0,     0,     0,     0,     0,   651,  1563,
    1143,     0,     0,     0,  1564,     0,     0,     0,     0,     0,
       0,   654,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   915,     0,     0,     0,   654,     0,
       0,  2371,   654,     0,   654,   915,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2642,     0,   654,  2643,
       0,   915,  2644,     0,     0,     0,   654,     0,     0,   654,
       0,  1565,     0,     0,     0,     0,     0,   794,     0,     0,
     654,     0,     0,     0,     0,     0,     0,   654,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     904,     0,     0,     0,     0,     0,  4031,     0,     0,     0,
       0,     0,     0,     0,     0,   915,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     915,     0,     0,   915,   915,   654,     0,     0,     0,     0,
       0,   916,     0,     0,     0,     0,   916,   916,     0,     0,
       0,   654,     0,  2644,     0,     0,     0,   654,   654,   973,
       0,     0,     0,     0,   915,   915,     0,  1143,     0,  2572,
       0,     0,     0,     0,     0,     0,     0,   973,  2573,  2574,
    2575,  2576,  2577,  2578,  2579,  2580,  2581,     0,     0,     0,
       0,  5274,     0,     0,     0,     0,     0,   654,     0,     0,
       0,     0,     0,     0,     0,   654,     0,     0,  1821,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   654,     0,     0,     0,     0,     0,   651,
     651,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4400,     0,     0,     0,     0,     0,
    2572,     0,   916,   916,  1736,     0,     0,     0,     0,  2573,
    2574,  2575,  2576,  2577,  2578,  2579,  2580,  2581,  1736,     0,
       0,  1736,  5278,     0,     0,     0,   654,  1821,     0,     0,
       0,     0,     0,     0,  2110,     0,     0,  2111,   654,     0,
       0,  2112,  2113,  2114,     0,     0,   915,   654,   654,   654,
       0,     0,  4449,     0,     0,     0,     0,     0,     0,  2634,
       0,     0,   654,  1821,     0,     0,   916,     0,     0,  2635,
       0,   654,     0,   654,     0,   654,  2636,   913,     0,     0,
       0,     0,   654,     0,     0,     0,     0,     0,     0,   654,
       0,     0,   660,     0,     0,     0,     0,     0,   709,   660,
       0,     0,  2637,     0,   761,     0,   660,     0,   654,     0,
       0,     0,   660,     0,   814,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4494,     0,     0,     0,   794,     0,
       0,     0,     0,   876,   876,  1821,     0,     0,   973,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3849,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4525,  4525,     0,     0,     0,     0,
       0,   654,     0,     0,  4541,     0,     0,     0,     0,  1143,
       0,  1143,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2638,   651,     0,     0,     0,  2639,     0,     0,   651,     0,
       0,     0,     0,   651,     0,     0,   651,  5306,     0,     0,
       0,     0,   654,     0,     0,     0,     0,  4596,  2640,  2304,
       0,     0,     0,     0,     0,     0,     0,   654,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   654,     0,     0,
       0,     0,     0,     0,     0,     0,  2641,     0,     0,     0,
       0,   973,  4632,  1143,   955,     0,     0,     0,   959,     0,
       0,     0,     0,     0,     0,   654,  1002,   906,     0,  1004,
       0,     0,  1009,  1010,     0,  1013,     0,  1016,   973,     0,
    1022,     0,  1024,     0,     0,     0,     0,     0,     0,  2371,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2642,     0,  6084,  2643,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     654,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     654,     0,     0,     0,     0,     0,     0,     0,   654,   654,
       0,     0,     0,     0,   654,     0,     0,     0,     0,     0,
       0,   907,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2110,     0,     0,  2111,     0,     0,
       0,  2112,  2113,  2114,     0,   654,   654,     0,     0,   654,
       0,     0,     0,     0,  2110,     0,     0,  2111,     0,  2634,
       0,  2112,  2113,  2114,     0,     0,     0,     0,     0,  2635,
       0,  2644,   909,     0,     0,     0,  2636,     0,     0,  2634,
       0,     0,     0,     0,     0,     0,   973,     0,     0,  2635,
       0,     0,     0,     0,     0,     0,  2636,     0,     0,     0,
       0,     0,  2637,     0,     0,     0,     0,     0,     0,     0,
     654,     0,     0,     0,     0,     0,   654,     0,     0,     0,
       0,  5452,  2637,     0,     0,     0,  4788,     0,     0,     0,
       0,     0,     0,     0,   654,     0,     0,     0,     0,     0,
       0,   654,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   651,     0,     0,     0,   904,   654,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1736,     0,     0,     0,   654,     0,     0,  2572,     0,
       0,     0,   904,     0,     0,     0,     0,  2573,  2574,  2575,
    2576,  2577,  2578,  2579,  2580,  2581,     0,     0,     0,     0,
    5551,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   654,     0,     0,     0,     0,   916,     0,
    2638,     0,     0,     0,   654,  2639,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   654,     0,     0,
    2638,     0,     0,     0,  1821,  2639,     0,     0,  2640,  2304,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2640,  2304,
       0,     0,     0,     0,     0,     0,  2641,     0,     0,     0,
       0,     0,   654,   654,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2641,     0,     0,   654,
       0,     0,     0,  1821,     0,     0,     0,     0,  3543,     0,
       0,     0,  2743,  3549,     0,     0,   654,   654,     0,  2371,
       0,     0,     0,     0,     0,   904,     0,     0,  1821,     0,
       0,     0,     0,   651,  2642,     0,     0,  2643,     0,  2371,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   651,  2642,     0,     0,  2643,     0,     0,
    4541,     0,     0,     0,     0,     0,     0,   915,     0,     0,
       0,     0,     0,   915,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   651,     0,     0,  4995,  1052,
       0,     0,     0,   913,     0,     0,     0,     0,     0,     0,
    1089,     0,     0,  5009,  1093,     0,  5010,     0,  5011,     0,
       0,  1106,  1107,     0,     0,  1113,     0,  1117,  1118,   913,
     915,   963,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2644,  1140,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1153,  2644,     0,     0,     0,  6414,  5053,     0,     0,     0,
    2110,     0,     0,  2111,     0,     0,     0,  2112,  2113,  2114,
     963,  1181,  3849,  1183,     0,     0,     0,  3849,     0,     0,
       0,     0,     0,  1199,     0,  2634,     0,     0,   904,     0,
       0,     0,     0,     0,     0,  2635,     0,     0,     0,   904,
       0,     0,  2636,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  6414,   904,   660,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2637,     0,
       0,   651,     0,     0,     0,     0,     0,     0,  2572,  6414,
       0,     0,     0,     0,     0,     0,     0,  2573,  2574,  2575,
    2576,  2577,  2578,  2579,  2580,  2581,     0,     0,  2572,     0,
    5562,     0,   913,     0,     0,     0,     0,  2573,  2574,  2575,
    2576,  2577,  2578,  2579,  2580,  2581,  5158,     0,     0,  4541,
    5572,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   876,     0,     0,
    1736,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     651,     0,     0,   906,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   915,     0,     0,     0,     0,     0,     0,   906,
       0,     0,     0,     0,     0,     0,  2638,     0,     0,     0,
       0,  2639,     0,     0,     0,  5207,  5207,  5207,  5207,     0,
    5207,  5207,  5207,  5207,  5207,     0,     0,     0,     0,     0,
       0,     0,   904,     0,  2640,  2304,     0,     0,     0,     0,
       0,     0,  1539,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   907,     0,     0,
       0,     0,  2641,     0,     0,  2743,     0,     0,  2110,  2743,
       0,  2111,     0,     0,     0,  2112,  2113,  2114,     0,     0,
       0,     0,     0,   907,     0,   913,     0,     0,     0,     0,
       0,     0,     0,  2634,     0,     0,   913,     0,     0,     0,
       0,     0,     0,  2635,     0,  2371,     0,     0,   909,  5943,
    2636,     0,   913,     0,     0,     0,  1720,     0,     0,     0,
    2642,     0,     0,  2643,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   909,     0,  2637,   651,  5286,     0,
    5288,  1841,   906,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1853,     0,  1854,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1857,     0,
    2110,     0,   915,  2111,     0,  1867,     0,  2112,  2113,  2114,
       0,     0,     0,     0,     0,     0,     0,   915,     0,     0,
       0,     0,   915,     0,     0,  2634,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2635,     0,     0,     0,     0,
       0,     0,  2636,     0,     0,     0,     0,  2644,  1919,     0,
    1921,     0,   915,     0,     0,     0,   907,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2637,     0,
       0,     0,     0,     0,     0,     0,   651,     0,     0,     0,
       0,     0,     0,     0,  2638,     0,     0,     0,     0,  2639,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   913,
       0,     0,     0,     0,     0,     0,     0,   909,     0,     0,
       0,     0,  2640,  2304,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   904,   660,     0,   660,     0,   660,     0,
     660,     0,   660,   660,   660,   906,     0,     0,     0,   660,
    2641,     0,     0,     0,     0,     0,   906,     0,     0,     0,
       0,  2025,     0,     0,  2572,     0,     0,     0,     0,     0,
       0,     0,   906,  2573,  2574,  2575,  2576,  2577,  2578,  2579,
    2580,  2581,     0,     0,     0,     0,  5634,     0,     0,     0,
       0,     0,     0,  2371,     0,   651,  2638,     0,     0,     0,
     904,  2639,     0,     0,  5424,  5425,     0,     0,  2642,     0,
       0,  2643,     0,     0,     0,     0,     0,  3849,     0,  3849,
    3849,  3849,     0,     0,  2640,  2304,     0,     0,     0,   907,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     907,   904,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2641,     0,     0,     0,   907,     0,  2110,     0,
       0,  2111,     0,     0,     0,  2112,  2113,  2114,     0,  2613,
       0,     0,     0,     0,   904,     0,     0,     0,     0,     0,
     909,     0,     0,  2634,     0,  5476,     0,     0,     0,     0,
       0,   909,     0,  2635,     0,  2371,     0,     0,     0,   963,
    2636,     0,     0,     0,     0,  2644,     0,   909,     0,     0,
    2642,     0,     0,  2643,     0,     0,     0,  2743,     0,     0,
    3549,     0,  3549,     0,  5504,     0,  2637,  2743,     0,   906,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   876,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   651,     0,     0,  5207,     0,   915,
     913,     0,   963,   963,     0,     0,     0,   915,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2743,     0,     0,     0,     0,  2644,     0,     0,
       0,     0,  2572,   907,     0,     0,     0,     0,     0,     0,
       0,  2573,  2574,  2575,  2576,  2577,  2578,  2579,  2580,  2581,
       0,     0,     0,     0,  5665,     0,     0,   913,     0,     0,
       0,     0,     0,     0,  2638,     0,     0,     0,     0,  2639,
       0,     0,  2110,     0,     0,  2111,     0,     0,     0,  2112,
    2113,  2114,     0,     0,   909,     0,     0,     0,   904,  2801,
       0,     0,  2640,  2304,   651,     0,     0,  2634,   913,   904,
     651,   915,     0,   915,     0,     0,     0,  2635,     0,     0,
       0,     0,     0,     0,  2636,   904,     0,     0,  6339,     0,
    2641,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   913,     0,     0,  2572,     0,     0,     0,     0,     0,
    2637,     0,     0,  2573,  2574,  2575,  2576,  2577,  2578,  2579,
    2580,  2581,     0,     0,     0,     0,  5667,  4541,     0,     0,
       0,  2899,     0,  2371,     0,     0,     0,     0,     0,   904,
       0,     0,     0,     0,     0,     0,     0,     0,  2642,     0,
       0,  2643,     0,     0,   904,     0,     0,   904,   904,     0,
       0,     0,     0,     0,     0,     0,     0,  6386,     0,     0,
       0,   915,     0,     0,     0,     0,     0,  3849,     0,     0,
     906,     0,     0,     0,     0,     0,  5705,     0,   904,   904,
       0,   651,     0,     0,     0,     0,     0,     0,     0,     0,
    1736,     0,     0,     0,     0,     0,  1736,     0,     0,     0,
       0,     0,     0,     0,     0,   915,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2638,     0,
       0,     0,     0,  2639,     0,     0,     0,  6386,     0,     0,
       0,     0,     0,  3549,     0,  2644,     0,   906,     0,     0,
       0,     0,     0,  6450,     0,     0,  2640,  2304,     0,     0,
       0,     0,     0,     0,   907,     0,     0,     0,     0,     0,
     963,   963,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2641,     0,     0,     0,   906,     0,
       0,     0,     0,     0,     0,   913,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   913,     0,     0,     0,
       0,   915,     0,     0,     0,   909,     0,     0,     0,     0,
       0,   906,   913,     0,     0,     0,     0,  2371,     0,     0,
     904,   907,     0,  3549,     0,     0,     0,     0,     0,     0,
       0,     0,  2642,     0,     0,  2643,     0,     0,     0,  3032,
       0,     0,  2572,     0,     0,   915,     0,     0,     0,     0,
       0,  2573,  2574,  2575,  2576,  2577,  2578,  2579,  2580,  2581,
       0,     0,   907,     0,  5710,     0,   913,     0,     0,     0,
       0,     0,   909,     0,  3068,     0,     0,     0,     0,     0,
       0,   913,     0,     0,   913,   913,     0,   721,     0,     0,
       0,     0,  1054,     0,     0,   907,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   909,     0,   913,   913,     0,     0,     0,
    3133,     0,     0,     0,     0,     0,     0,   915,  1143,  2644,
    1055,     0,  5918,     0,     0,     0,     0,     0,     0,     0,
    3151,     0,     0,   724,  1056,     0,   909,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1057,     0,     0,     0,
     725,     0,     0,     0,     0,     0,  3171,     0,  3172,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1058,   915,
       0,     0,     0,  3181,     0,  3182,     0,     0,     0,     0,
       0,   660,     0,   660,     0,   660,     0,   660,     0,   660,
       0,     0,  1059,   660,   915,   906,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   728,   906,     0,     0,     0,
       0,     0,     0,     0,   729,     0,     0,     0,     0,     0,
       0,     0,   906,     0,     0,     0,  2572,   730,     0,     0,
    3241,     0,     0,  1060,     0,  2573,  2574,  2575,  2576,  2577,
    2578,  2579,  2580,  2581,     0,     0,     0,   913,  6067,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1061,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   906,     0,     0,   907,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     907,   906,     0,     0,   906,   906,     0,     0,  1062,     0,
       0,  -136,     0,     0,     0,     0,   907,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     734,     1,     0,     0,     0,   906,   906,     0,     0,     0,
     909,     0,     2,     0,     3,     4,     0,     0,     0,  1143,
       0,   909,     0,  6090,     0,  6091,     0,     0,     0,  6097,
    6098,     0,     5,     0,     0,  2743,     0,   909,     0,     0,
     907,     0,     6,     0,  1063,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     7,   907,     8,     9,   907,   907,
       0,     0,     0,    10,     0,    11,     0,     0,     0,     0,
       0,   737,     0,     0,     0,     0,     0,     0,    12,     0,
      13,   213,  1064,     0,     0,   739,     0,     0,     0,   907,
     907,   909,     0,     0,     0,     0,     0,    14,     0,     0,
      15,     0,     0,     0,     0,     0,   909,     0,     0,   909,
     909,     0,     0,  1065,     0,    16,  1066,    17,     0,     0,
     742,    18,     0,   743,     0,     0,     0,     0,    19,  3549,
     744,     0,     0,   745,     0,     0,     0,    20,     0,    21,
     909,   909,     0,     0,     0,     0,    22,   906,     0,     0,
       0,     0,     0,     0,   746,     0,     0,  3549,     0,     0,
       0,     0,  1067,     0,    23,     0,     0,     0,     0,   748,
       0,     0,  1068,     0,     0,     0,     0,   750,     0,     0,
       0,    24,     0,     0,     0,  1069,     0,   752,     0,     0,
       0,     0,  1070,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   755,
       0,     0,   721,     0,     0,     0,     0,  2790,     0,     0,
       0,   907,     0,     0,     0,    25,    26,     0,     0,     0,
       0,    27,  2110,     0,     0,  2111,     0,   910,     0,  2112,
    2113,  2114,     0,     0,     0,     0,    28,     0,     0,     0,
       0,     0,     0,     0,     0,  2791,     0,  2634,     0,     0,
       0,     0,     0,     0,     0,    29,     0,  2635,   724,     0,
       0,     0,   909,     0,  2636,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   725,     0,     0,     0,     0,
       0,   915,     0,     0,     0,     0,     0,     0,     0,     0,
    2637,     0,   904,  1058,     0,     0,   904,   904,     0,     0,
       0,     0,     0,    30,     0,     0,     0,  1143,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2792,    31,     0,
       0,     0,     0,     0,    32,    33,     0,    34,  3549,     0,
     728,     0,    35,  2743,     0,     0,     0,     0,    36,   729,
       0,    37,     0,     0,     0,     0,     0,     0,    38,     0,
       0,   904,   730,     0,     0,    39,    40,   904,  2793,     0,
       0,     0,     0,    41,     0,     0,     0,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    43,
       0,     0,     0,     0,     0,  1061,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    44,     0,     0,     0,
       0,     0,     0,     0,   904,     0,     0,     0,  2638,     0,
       0,     0,     0,  2639,     0,     0,     0,    45,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    46,
       0,     0,     0,     0,     0,    47,  2640,  2304,     0,     0,
      48,     0,     0,     0,     0,   734,     0,     0,     0,     0,
       0,     0,     0,    49,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2641,  6415,     0,     0,     0,     0,
       0,     0,  2597,     0,     0,     0,  6419,    50,     0,    51,
      52,    53,    54,    55,     0,     0,     0,     0,     0,  2794,
       0,   915,     0,     0,     0,     0,    56,     0,     0,  -136,
       0,     0,     0,     0,     0,     0,     0,  2371,     0,     0,
    6445,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2642,     0,  6415,  2643,   213,  2795,     0,   913,
     739,     0,     0,   913,   913,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  6415,
       0,     0,  5286,     0,     0,     0,     0,     0,  1065,     0,
       0,  2796,     0,     0,     0,     0,     0,     0,   743,     0,
       0,     0,     0,     0,     0,   744,     0,     0,   745,     0,
       0,  3539,  3540,     0,     0,     0,     0,     0,   913,     0,
       0,     0,     0,     0,   913,     0,     0,     0,     0,   746,
    3555,  3556,     0,  3558,  3559,     0,   915,  1067,  3562,  3563,
       0,     0,     0,     0,   748,     0,   904,  1068,   912,  2644,
       0,     0,   750,  3574,     0,     0,     0,  3577,     0,     0,
    2797,  3580,  3581,     0,     0,  3584,  3585,  2798,     0,     0,
       0,   913,  3590,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3605,     0,     0,     0,     0,   915,
       0,     0,     0,     0,   755,     0,  3622,     0,     0,     0,
       0,  3624,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   915,     0,     0,     0,     0,  3630,     0,     0,   904,
    3636,     0,     0,   904,     0,     0,     0,     0,     0,     0,
       0,  3646,     0,     0,  3650,     0,  3652,  3655,  3657,     0,
       0,     0,     0,  3665,  3668,     0,     0,     0,     0,     0,
       0,     0,     0,  3681,     0,     0,  2572,     0,     0,  3691,
       0,     0,     0,  3694,     0,  2573,  2574,  2575,  2576,  2577,
    2578,  2579,  2580,  2581,     0,  3704,  3705,     0,  6078,   906,
    3710,     0,     0,   906,   906,   915,  3719,  3720,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3729,     0,     0,  3730,     0,     0,     0,     0,     0,     0,
    3742,  3743,     0,     0,     0,     0,  3747,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   904,     0,  3754,     0,
       0,  3757,     0,     0,     0,     0,  3760,     0,   906,     0,
       0,   904,  3763,  3764,   906,     0,   904,     0,     0,     0,
    3772,     0,     0,     0,  3774,     0,     0,     0,     0,  3782,
    3783,  3784,  3785,   907,     0,  3788,     0,   907,   907,     0,
       0,     0,     0,     0,     0,  1578,   904,     0,     0,  3814,
    3815,  1579,  3817,   913,     0,     0,     0,     0,  1645,     0,
       0,   906,     0,  3827,  3828,  3829,     0,     0,     0,     0,
       0,     0,     0,     0,  5508,     0,   915,     0,     0,     0,
    1646,     0,     0,     0,   909,     0,     0,     0,   909,   909,
       0,     0,   907,     0,     0,     0,  1581,     0,   907,     0,
       0,     0,     0,   910,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3881,     0,     0,     0,     0,     0,   913,     0,  3905,   910,
     913,     0,  1647,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   909,     0,   907,     0,  3917,     0,   909,
       0,     0,     0,  1582,     0,     0,     0,     0,     0,     0,
    1583,     0,     0,     0,  1584,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1585,     0,     0,     0,   909,  3985,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   915,  3999,     0,  4001,     0,
       0,     0,     0,     0,  1648,     0,     0,     0,  1586,     0,
       0,     0,     0,   913,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   913,     0,
       0,     0,     0,   913,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2110,     0,
       0,  2111,   910,   906,     0,  2112,  2113,  2114,     0,     0,
       0,     0,     0,   913,     0,   914,  3549,  1649,     0,     0,
       0,     0,  1650,  2634,     0,     0,     0,     0,     0,     0,
       0,   904,     0,  2635,   904,     0,   904,     0,  1651,     0,
    2636,   904,  1588,  4063,     0,     0,     0,     0,     0,     0,
       0,     0,  1589,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1590,     0,     0,     0,  2637,     0,     0,     0,
       0,     0,     0,  1652,  1591,     0,   906,     0,     0,     0,
     906,     0,     0,   904,     0,     0,     0,   907,     0,     0,
       0,   904,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   904,  3748,     0,     0,
    1593,  1594,  1654,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   909,     0,
    3549,     0,     0,     0,     0,     0,  1655,     0,     0,     0,
       0,     0,  3749,     0,     0,     0,     0,     0,     0,     0,
     907,     0,     0,     0,   907,   910,     0,     0,  1657,     0,
       0,     0,     0,     0,     0,     0,   910,     0,     0,     0,
       0,     0,     0,   906,  2638,     0,     0,     0,     0,  2639,
       0,     0,   910,     0,     0,   904,     0,   904,   906,     0,
       0,     0,     0,   906,     0,     0,     0,     0,     0,     0,
       0,   909,  2640,  2304,     0,   909,     0,     0,     0,     0,
       0,     0,     0,     0,   912,     0,  1596,     0,     0,     0,
       0,     0,     0,   906,     0,     0,     0,     0,     0,     0,
    2641,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     912,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   907,   913,     0,
       0,   913,     0,   913,     0,     0,     0,     0,   913,     0,
       0,     0,   907,  2371,     0,     0,     0,   907,     0,     0,
       0,   915,     0,     0,     0,   904,   915,   915,  2642,     0,
       0,  2643,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   907,   909,     0,
     913,     0,     0,     0,     0,     0,     0,     0,   913,     0,
       0,     0,     0,   909,     0,     0,     0,     0,   909,   904,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   910,
       0,     0,     0,   913,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   904,   909,     0,
       0,     0,     0,  4326,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4333,     0,     0,   912,  4333,  2644,     0,     0,     0,  4344,
    4345,  4346,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5508,   915,     0,     0,     0,     0,     0,     0,
       0,  4358,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   913,     0,   913,   904,     0,     0,     0,     0,
       0,     0,     0,     0,  4387,  4388,  4389,  4390,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   904,     0,     0,
       0,     0,     0,     0,     0,  2110,     0,     0,  2111,     0,
       0,     0,  2112,  2113,  2114,     0,   915,     0,     0,   904,
       0,     0,  4411,     0,  4415,  4416,  4417,     0,   906,     0,
    2634,   906,     0,   906,     0,     0,     0,     0,   906,     0,
    2635,     0,  2572,     0,     0,     0,     0,  2636,     0,     0,
       0,  2573,  2574,  2575,  2576,  2577,  2578,  2579,  2580,  2581,
       0,     0,     0,     0,  6101,     0,     0,     0,     0,     0,
       0,     0,   913,  2637,     0,     0,     0,     0,     0,     0,
     906,     0,     0,  2110,     0,     0,  2111,     0,   906,     0,
    2112,  2113,  2114,     0,     0,     0,   912,     0,     0,     0,
       0,   904,     0,     0,     0,     0,     0,   912,  2634,     0,
       0,     0,   907,   906,     0,   907,   913,   907,  2635,     0,
       0,     0,   907,   912,     0,  2636,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   913,     0,  4502,     0,     0,     0,
     910,  2637,     0,   904,     0,  4508,     0,     0,     0,     0,
       0,     0,     0,   909,   907,     0,   909,     0,   909,     0,
       0,     0,   907,   909,     0,     0,     0,     0,   904,     0,
       0,  4518,  4519,     0,     0,     0,  4520,     0,     0,     0,
       0,  2638,   906,     0,   906,     0,  2639,   907,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4562,     0,
       0,     0,   913,     0,     0,   909,     0,   910,     0,  2640,
    2304,     0,     0,   909,     0,     0,     0,     0,     0,     0,
       0,   914,     0,     0,   913,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2641,   909,     0,
       0,     0,     0,     0,     0,     0,   913,   914,   910,     0,
    4599,     0,     0,     0,     0,  4605,     0,     0,     0,  2638,
       0,  4611,     0,     0,  2639,     0,   907,     0,   907,     0,
     912,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2371,   910,   906,     0,     0,     0,     0,  2640,  2304,     0,
       0,  4650,     0,     0,     0,  2642,     0,     0,  2643,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2641,     0,   909,     0,   909,
    4665,     0,  4666,     0,     0,     0,   906,     0,   913,   904,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   906,     0,     0,     0,  2371,     0,
       0,     0,     0,     0,     0,     0,   907,     0,     0,     0,
       0,     0,     0,  2642,     0,     0,  2643,     0,     0,     0,
     913,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     914,     0,  2644,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   913,     0,     0,     0,     0,
     907,     0,     0,     0,     0,     0,     0,   909,     0,     0,
       0,     0,   906,   904,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   907,     0,
       0,     0,     0,     0,   906,     0,     0,     0,     0,     0,
       0,   904,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   909,     0,     0,     0,     0,   906,     0,     0,     0,
    2644,     0,     0,     0,     0,   910,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   910,     0,     0,   909,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2572,
       0,     0,   910,     0,     0,     0,   907,     0,  2573,  2574,
    2575,  2576,  2577,  2578,  2579,  2580,  2581,     0,   915,     0,
       0,  6321,     0,     0,     0,     0,     0,     0,   907,     0,
       0,   912,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   906,     0,
     907,     0,     0,   914,     0,     0,   910,   909,     0,     0,
       0,     0,     0,     0,   914,     0,   913,     0,     0,     0,
       0,   910,     0,     0,   910,   910,     0,  2572,     0,   909,
     914,     0,  1736,     0,     0,     0,  2573,  2574,  2575,  2576,
    2577,  2578,  2579,  2580,  2581,   904,     0,     0,   912,  6338,
     906,   909,     0,     0,     0,   910,   910,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   906,     0,     0,     0,     0,
       0,     0,   907,     0,     0,     0,  4899,     0,  4900,   912,
       0,     0,   904,     0,     0,     0,     0,   904,     0,     0,
       0,  4907,     0,     0,     0,     0,     0,     0,     0,     0,
     913,     0,     0,  4913,     0,     0,     0,  4916,     0,     0,
       0,     0,   912,     0,     0,     0,     0,     0,  4929,     0,
       0,     0,  2110,   909,   907,  2111,     0,     0,   913,  2112,
    2113,  2114,     0,     0,     0,     0,     0,  4955,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2634,     0,   907,
       0,     0,     0,     0,     0,  4959,     0,  2635,     0,     0,
       0,     0,     0,  4963,  2636,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   909,     0,   914,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   910,  4998,     0,
    2637,     0,  5002,     0,     0,     0,     0,     0,     0,     0,
     909,     0,     0,     0,     0,     0,     0,  5012,  5013,  5014,
    5015,     0,     0,     0,     0,     0,     0,  5019,  5020,  5021,
    5022,     0,     0,     0,     0,     0,   906,  5025,  5026,     0,
       0,     0,     0,     0,  5034,  5035,     0,  5037,  5038,  5039,
    5040,  5041,  5042,  5043,     0,   904,     0,     0,     0,     0,
       0,     0,     0,  5052,     0,     0,     0,  5055,  5056,  5057,
    5058,     0,  2110,     0,     0,  2111,     0,     0,     0,  2112,
    2113,  2114,   913,     0,     0,     0,     0,     0,     0,     0,
       0,  4333,     0,     0,     0,     0,     0,  2634,     0,     0,
       0,  3494,     0,     0,     0,     0,     0,  2635,     0,  5078,
       0,     0,     0,     0,  2636,     0,   912,     0,  2638,     0,
     907,     0,     0,  2639,     0,     0,     0,   912,     0,   913,
     906,     0,     0,     0,   913,     0,     0,     0,     0,     0,
    2637,     0,     0,   912,     0,     0,  2640,  2304,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   906,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     904,   909,     0,     0,  2641,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5159,     0,     0,     0,     0,
       0,     0,  3495,     0,     0,     0,     0,   912,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   912,     0,   907,   912,   912,  2371,  4333,     0,
       0,     0,     0,   904,     0,  5184,     0,  5185,     0,     0,
       0,     0,  2642,     0,     0,  2643,     0,     0,     0,     0,
       0,     0,   907,     0,     0,   904,   912,   912,   914,     0,
       0,     0,     0,     0,     0,  5200,     0,     0,  2638,     0,
       0,     0,     0,  2639,     0,   909,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2640,  2304,     0,     0,
       0,     0,   913,   909,     0,     0,     0,     0,     0,     0,
       0,     0,   906,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2641,   914,     0,     0,     0,   904,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2644,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   906,
       0,     0,     0,     0,   906,     0,   914,  2371,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   965,
     975,     0,  2642,     0,     0,  2643,     0,   965,     0,   975,
     965,     0,     0,     0,     0,     0,   907,     0,   912,   914,
       0,     0,     0,   975,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   913,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   907,     0,     0,  2572,   909,   907,     0,
     904,     0,     0,     0,     0,  2573,  2574,  2575,  2576,  2577,
    2578,  2579,  2580,  2581,     0,     0,     0,     0,  6396,     0,
     913,     0,     0,     0,     0,     0,  5343,  5344,  5345,  2644,
       0,     0,  5346,  5347,  5348,  5349,     0,     0,     0,  5351,
       0,     0,   913,     0,   909,  2110,     0,     0,  2111,   909,
       0,     0,  2112,  2113,  2114,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2634,     0,   906,     0,     0,     0,     0,     0,     0,     0,
    2635,     0,     0,     0,     0,     0,     0,  2636,     0,     0,
    5384,  5385,  5386,  5387,  5388,  3496,  5390,  5391,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5400,  5401,
       0,     0,     0,  2637,     0,     0,   913,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2572,     0,     0,   904,
       0,     0,  5407,   914,     0,  2573,  2574,  2575,  2576,  2577,
    2578,  2579,  2580,  2581,   914,     0,   907,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     914,     0,     0,     0,     0,     0,     0,     0,     0,   910,
       0,     0,     0,   910,   910,     0,     0,   906,     0,     0,
       0,     0,     0,  2110,     0,     0,  2111,     0,     0,     0,
    2112,  2113,  2114,     0,     0,     0,  4144,   909,     0,     0,
     904,     0,  4145,     0,     0,     0,     0,     0,  2634,     0,
       0,     0,     0,     0,   914,     0,     0,     0,  2635,     0,
       0,  2638,     0,     0,     0,  2636,  2639,   913,   910,   914,
     906,     0,   914,   914,   910,     0,  5474,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2640,
    2304,  2637,   906,     0,     0,     0,     0,     0,     0,     0,
       0,   907,     0,   914,   914,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2641,     0,     0,
       0,   910,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5525,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   909,     0,   907,     0,     0,     0,     0,     0,
    2371,     0,     0,     0,   904,     0,   906,     0,     0,     0,
       0,     0,     0,  5531,     0,  2642,   907,     0,  2643,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   909,   913,     0,     0,  2638,
       0,     0,     0,     0,  2639,     0,     0,   975,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   909,     0,     0,
       0,     0,     0,     0,     0,     0,   975,  2640,  2304,     0,
       0,     0,   975,     0,     0,   914,     0,     0,     0,     0,
     907,     0,     0,     0,   975,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2641,     0,     0,     0,     0,
     975,   660,  4146,     0,     0,     0,     0,   913,     0,     0,
       0,     0,     0,     0,   965,   975,     0,   906,     0,  2110,
       0,   965,  2111,   975,   965,     0,  2112,  2113,  2114,     0,
       0,   909,     0,     0,     0,     0,     0,   975,  2371,     0,
       0,     0,     0,     0,  2634,   904,     0,   975,     0,     0,
     904,   904,     0,  2642,  2635,     0,  2643,     0,     0,     0,
       0,  2636,     0,   910,     0,     0,     0,  5654,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4779,     0,  5664,  2637,     0,     0,
       0,     0,  5670,  5671,     0,     0,     0,     0,     0,     0,
     975,   907,     0,     0,     0,     0,  5686,     0,     0,  2572,
       0,     0,     0,  5688,     0,     0,     0,     0,  2573,  2574,
    2575,  2576,  2577,  2578,  2579,  2580,  2581,     0,   975,     0,
     912,   913,     0,     0,   912,   912,   910,     0,     0,     0,
     910,     0,     0,     0,     0,     0,     0,     0,  5740,  5741,
    2644,     0,   909,   975,     0,     0,   906,     0,     0,     0,
       0,  5749,     0,  5751,     0,     0,     0,   904,     0,     0,
    4780,     0,     0,     0,     0,     0,     0,     0,  5765,  6166,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   912,
       0,     0,     0,     0,     0,   912,     0,     0,     0,     0,
       0,     0,     0,  4333,     0,  2638,     0,     0,     0,     0,
    2639,  5799,     0,     0,     0,   975,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   906,     0,     0,
     904,     0,     0,  2640,  2304,     0,     0,     0,     0,     0,
     907,     0,   912,   910,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2572,   910,     0,
       0,  2641,     0,   910,     0,     0,  2573,  2574,  2575,  2576,
    2577,  2578,  2579,  2580,  2581,     0,     0,     0,     0,     0,
       0,     0,   913,     0,     0,     0,     0,   913,   913,     0,
       0,   909,     0,   910,     0,     0,     0,     0,     0,     0,
       0,  5855,     0,     0,  2371,     0,     0,     0,     0,     0,
       0,   907,     0,     0,     0,  5870,     0,     0,     0,  2642,
       0,     0,  2643,     0,     0,  1823,     0,     0,     0,     0,
       0,     0,   975,     0,     0,     0,     0,     0,     0,  5887,
       0,     0,     0,   965,     0,     0,     0,   965,  6167,   965,
       0,   906,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   909,     0,     0,     0,     0,   974,     0,     0,
       0,     0,     0,     0,     0,     0,   974,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     974,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   913,     0,     0,     0,     0,     0,
    5949,     0,     0,     0,     0,     0,  2644,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   907,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   912,     0,   975,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   913,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4333,     0,     0,     0,     0,     0,   909,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   906,     0,     0,     0,     0,   906,   906,     0,
       0,     0,     0,     0,  6029,     0,     0,   975,     0,     0,
       0,     0,     0,  2572,     0,     0,     0,   912,   975,     0,
       0,   912,  2573,  2574,  2575,  2576,  2577,  2578,  2579,  2580,
    2581,     0,     0,     0,     0,   975,     0,     0,   910,     0,
     975,   910,     0,   910,     0,  6057,     0,     0,   910,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  6079,
       0,     0,     0,     0,     0,     0,   907,     0,     0,     0,
       0,   907,   907,     0,     0,     0,     0,   914,     0,     0,
     910,   914,   914,     0,     0,     0,     0,     0,   910,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2110,     0,   906,  2111,     0,     0,     0,  2112,
    2113,  2114,     0,   910,   912,     0,     0,   909,     0,     0,
       0,  6119,   909,   909,     0,     0,     0,  2634,     0,   912,
    4072,     0,     0,     0,   912,     0,   914,  2635,     0,     0,
       0,     0,   914,     0,  2636,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   975,   912,     0,     0,   906,     0,     0,
    2637,   975,   975,     0,   952,   954,     0,     0,   957,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   907,   914,
       0,     0,   910,     0,   910,     0,     0,     0,  1015,     0,
       0,     0,     0,     0,     0,  1025,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   904,     0,  1823,     0,     0,  2110,     0,     0,
    2111,     0,     0,  6213,  2112,  2113,  2114,     0,     0,   909,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   907,  2634,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2635,     0,     0,     0,  6226,     0,     0,  2636,
       0,     0,     0,     0,     0,     0,     0,  6236,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2638,     0,
       0,     0,   910,  2639,     0,  2637,     0,     0,     0,     0,
       0,     0,   909,     0,   974,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2640,  2304,     0,     0,
       0,     0,     0,   974,     0,     0,     0,     0,     0,   974,
       0,     0,     0,     0,     0,     0,   910,     0,     0,     0,
       0,   974,  2110,     0,  2641,  2111,     0,     0,     0,  2112,
    2113,  2114,     0,     0,     0,     0,     0,   974,     0,     0,
       0,     0,     0,     0,   910,     0,     0,  2634,     0,     0,
       0,     0,   974,     0,     0,     0,     0,  2635,     0,     0,
     974,     0,     0,     0,  2636,     0,     0,  2371,     0,     0,
       0,     0,     0,     0,   974,     0,     0,     0,     0,  6315,
       0,   914,  2642,     0,   974,  2643,     0,     0,     0,     0,
    2637,     0,     0,  2638,     0,     0,     0,     0,  2639,   912,
       0,     0,   912,     0,   912,     0,     0,     0,     0,   912,
       0,     0,   910,     0,     0,     0,     0,     0,     0,     0,
       0,  2640,  2304,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   910,     0,     0,   974,     0,   913,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2641,
       0,   912,     0,     0,   914,   975,   910,     0,   914,   912,
       0,     0,     0,     0,     0,   974,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2644,
       0,     0,     0,     0,   912,     0,     0,     0,     0,     0,
     974,     0,  2371,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2642,  2638,     0,
    2643,     0,     0,  2639,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2640,  2304,   910,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   974,     0,     0,     0,     0,     0,     0,     0,
       0,   914,     0,   912,  2641,   912,     0,     0,     0,     0,
     975,     0,     0,     0,     0,     0,   914,     0,     0,     0,
       0,   914,     0,     0,     0,  6456,  2572,     0,     0,     0,
     910,     0,     0,     0,     0,  2573,  2574,  2575,  2576,  2577,
    2578,  2579,  2580,  2581,  2644,  1823,     0,  2371,     0,     0,
       0,   914,     0,     0,     0,   910,     0,     0,     0,     0,
       0,     0,  2642,     0,     0,  2643,     0,     0,   975,  1085,
       0,  1088,     0,     0,  1090,     0,   975,     0,     0,     0,
       0,     0,     0,     0,   975,     0,  4117,     0,  1116,     0,
       0,     0,     0,     0,  1120,     0,     0,     0,     0,   906,
       0,     0,  1822,   912,     0,     0,     0,     0,     0,   974,
       0,  2110,     0,     0,  2111,     0,     0,     0,  2112,  2113,
    2114,     0,     0,     0,     0,   965,   965,     0,   975,   975,
       0,     0,     0,     0,     0,     0,  2634,     0,     0,  4149,
     965,     0,   975,   965,     0,     0,  2635,   912,     0,     0,
    4081,  2572,     0,  2636,     0,   975,   975,     0,     0,  2644,
    2573,  2574,  2575,  2576,  2577,  2578,  2579,  2580,  2581,     0,
       0,     0,     0,     0,     0,   912,     0,     0,     0,  2637,
       0,     0,     0,   907,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   965,     0,     0,     0,   965,   965,     0,
       0,     0,     0,  2110,     0,     0,  2111,     0,     0,     0,
    2112,  2113,  2114,     0,     0,     0,   910,     0,     0,     0,
       0,     0,  2110,     0,     0,  2111,     0,     0,  2634,  2112,
    2113,  2114,     0,   974,   909,     0,     0,     0,  2635,     0,
       0,     0,     0,   912,     0,  2636,     0,  2634,     0,     0,
    4161,     0,     0,     0,     0,     0,     0,  2635,     0,     0,
       0,     0,     0,     0,  2636,   912,  2572,     0,     0,     0,
       0,  2637,     0,     0,     0,  2573,  2574,  2575,  2576,  2577,
    2578,  2579,  2580,  2581,     0,     0,     0,   912,     0,     0,
    2637,     0,     0,     0,   974,     0,     0,  2638,     0,     0,
       0,     0,  2639,     0,     0,   974,   914,     0,     0,   914,
     910,   914,     0,     0,     0,  1823,   914,     0,     0,     0,
       0,     0,   974,     0,     0,  2640,  2304,   974,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   910,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2641,     0,     0,     0,     0,   914,     0,
       0,     0,     0,     0,     0,     0,   914,     0,     0,   912,
    4154,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1610,  1611,     0,     0,     0,     0,     0,     0,  2638,
       0,   914,     0,     0,  2639,     0,  2371,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2638,     0,
       0,  2642,     0,  2639,  2643,     0,     0,  2640,  2304,     0,
       0,   912,   721,     0,     0,     0,     0,  3250,     0,     0,
       0,     0,     0,     0,     0,     0,  2640,  2304,     0,     0,
       0,     0,     0,     0,     0,  2641,   912,     0,     0,     0,
       0,     0,  1840,     0,     0,     0,     0,     0,     0,     0,
     974,     0,     0,     0,  2641,     0,     0,  1852,   974,   974,
     914,     0,   914,     0,     0,     0,     0,     0,   724,  3251,
       0,     0,   910,     0,     0,     0,     0,     0,  2371,     0,
       0,     0,     0,     0,     0,   725,     0,     0,  1874,  1875,
       0,     0,     0,  2642,     0,     0,  2643,  2371,  2644,     0,
       0,     0,     0,  1058,     0,     0,     0,     0,     0,     0,
       0,  1822,  2642,     0,  1912,  2643,     0,     0,     0,   910,
       0,     0,     0,     0,   910,     0,     0,  3252,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     728,     0,     0,     0,     0,     0,     0,     0,     0,   729,
       0,     0,     0,     0,  1950,  1952,     0,     0,     0,     0,
     914,     0,   730,     0,     0,     0,     0,     0,  3253,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2644,     0,     0,     0,     0,  1061,     0,   912,     0,     0,
       0,     0,     0,     0,   914,  2572,     0,     0,     0,  2644,
       0,     0,     0,     0,  2573,  2574,  2575,  2576,  2577,  2578,
    2579,  2580,  2581,     0,     0,     0,     0,     0,  2110,     0,
       0,  2111,   914,  3254,     0,  2112,  2113,  2114,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2634,     0,   734,     0,     0,     0,     0,
       0,     0,     0,  2635,     0,     0,     0,     0,     0,     0,
    2636,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   910,     0,     0,     0,     0,     0,     0,     0,
       0,   912,     0,     0,     0,     0,  2637,  2572,     0,     0,
     914,     0,     0,     0,     0,     0,  2573,  2574,  2575,  2576,
    2577,  2578,  2579,  2580,  2581,     0,  2572,     0,     0,   912,
       0,     0,   914,     0,     0,  2573,  2574,  2575,  2576,  2577,
    2578,  2579,  2580,  2581,     0,     0,   213,  3255,     0,     0,
     739,     0,     0,     0,   914,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   974,     0,     0,     0,     0,     0,  1065,     0,
       0,  3256,     0,     0,     0,     0,     0,     0,   743,     0,
       0,     0,     0,     0,     0,   744,     0,     0,   745,     0,
       0,     0,     0,  2110,     0,     0,  2111,   910,     0,     0,
    2112,  2113,  2114,     0,     0,     0,     0,     0,     0,   746,
       0,     0,     0,     0,  2638,     0,     0,  1067,  2634,  2639,
       0,  4786,     0,     0,   748,     0,   914,  1068,  2635,     0,
       0,     0,   750,     0,     0,  2636,     0,     0,     0,     0,
       0,     0,  2640,  2304,  1823,     0,     0,  3257,     0,     0,
     910,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2637,     0,   912,     0,     0,     0,     0,     0,     0,
    2641,     0,   910,     0,   755,     0,     0,   974,   914,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   975,
       0,     0,     0,   914,     0,     0,     0,     0,     0,     0,
     912,     0,  1822,  2371,     0,   912,     0,   975,     0,     0,
       0,   975,     0,     0,     0,   975,     0,     0,  2642,     0,
       0,  2643,     0,     0,   975,   974,     0,     0,     0,     0,
       0,     0,     0,   974,     0,     0,   910,     0,     0,   975,
    2821,   974,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   965,     0,   965,   965,
       0,     0,     0,     0,     0,  2866,     0,     0,     0,  2638,
       0,     0,     0,   975,  2639,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   974,   974,     0,     0,     0,
       0,     0,     0,   975,   975,     0,     0,  2640,  2304,   974,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   974,   974,     0,  2644,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2641,     0,     0,     0,     0,
    1823,   975,     0,     0,  1823,     0,     0,     0,     0,     0,
       0,     0,  2956,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4710,     0,   914,     0,     0,   910,   975,     0,
    1823,     0,     0,   912,   975,     0,     0,     0,  2371,     0,
       0,     0,     0,     0,  2984,  2985,  2986,  2987,   975,     0,
       0,     0,     0,  2642,     0,   975,  2643,     0,   975,     0,
       0,     0,     0,     0,   975,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   975,     0,     0,     0,     0,     0,
     975,  2110,  2572,     0,  2111,     0,     0,   975,  2112,  2113,
    2114,  2573,  2574,  2575,  2576,  2577,  2578,  2579,  2580,  2581,
       0,     0,     0,   975,     0,     0,  2634,     0,   914,     0,
       0,     0,     0,     0,     0,     0,  2635,   975,     0,     0,
       0,     0,  1823,  2636,     0,     0,     0,     0,   975,     0,
       0,     0,  1822,     0,     0,     0,   914,     0,   912,     0,
    2644,     0,     0,     0,     0,     0,     0,     0,     0,  2637,
       0,     0,     0,     0,     0,     0,   910,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1367,  1367,     0,     0,     0,     0,     0,
       0,  3041,  3042,     0,     0,     0,     0,     0,  1823,     0,
       0,   912,     0,     0,     0,     0,     0,  3059,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   912,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   910,     0,     0,
       0,  3102,  3103,  3104,  3105,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2572,     0,     0,
       0,     0,     0,  1367,     0,     0,  2573,  2574,  2575,  2576,
    2577,  2578,  2579,  2580,  2581,     0,     0,  2638,  2110,     0,
       0,  2111,  2639,     0,     0,  2112,  2113,  2114,     0,     0,
     914,     0,     0,     0,     0,     0,     0,   912,     0,     0,
       0,     0,     0,  2634,     0,  2640,  2304,     0,     0,     0,
       0,     0,     0,  2635,     0,     0,     0,     0,     0,     0,
    2636,     0,  3179,     0,     0,     0,     0,     0,  3183,     0,
       0,     0,     0,  2641,     0,     0,     0,   914,     0,     0,
       0,     0,   914,     0,     0,     0,  2637,     0,     0,     0,
       0,     0,     0,   975,     0,  1823,     0,     0,     0,     0,
       0,   910,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   975,     0,     0,     0,  2371,     0,     0,   975,
       0,     0,     0,     0,  1733,  1737,   965,     0,   965,   965,
       0,  2642,     0,     0,  2643,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5228,     0,     0,     0,     0,     0,   912,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2110,     0,     0,  2111,     0,
       0,     0,  2112,  2113,  2114,  5238,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2634,     0,     0,     0,  2638,     0,     0,     0,     0,  2639,
    2635,     0,     0,     0,     0,     0,  1823,  2636,     0,     0,
       0,     0,  1823,     0,     0,     0,     0,     0,  2644,     0,
       0,     0,  2640,  2304,     0,     0,     0,     0,     0,     0,
     914,     0,     0,  2637,     0,     0,     0,     0,     0,     0,
       0,     0,   910,     0,     0,     0,  3367,   910,   910,   978,
    2641,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1012,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1031,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   912,     0,     0,
       0,     0,     0,  2371,     0,     0,     0,   975,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2642,     0,
       0,  2643,     0,     0,     0,     0,     0,     0,     0,  2110,
       0,     0,  2111,     0,     0,  2572,  2112,  2113,  2114,     0,
       0,     0,  5244,     0,  2573,  2574,  2575,  2576,  2577,  2578,
    2579,  2580,  2581,     0,  2634,   914,     0,     0,     0,     0,
       0,  2638,     0,  2054,  2635,     0,  2639,     0,   912,     0,
       0,  2636,     0,     0,   910,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2640,
    2304,     0,     0,     0,     0,     0,     0,  2637,     0,     0,
       0,     0,     0,     0,     0,  2080,     0,     0,   914,     0,
       0,     0,     0,     0,     0,  2644,     0,  2641,     0,     0,
       0,  1822,     0,     0,     0,     0,     0,     0,     0,     0,
     914,     0,     0,     0,  2099,  2100,  2101,   910,  2103,     0,
     975,   975,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2590,
    2371,   975,     0,     0,   975,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2642,   974,     0,  2643,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5245,     0,   912,     0,   974,     0,     0,     0,   974,     0,
       0,     0,   974,     0,   914,     0,     0,     0,     0,     0,
       0,   974,     0,     0,     0,  2638,     0,     0,     0,     0,
    2639,     0,  2572,     0,     0,     0,   974,     0,     0,     0,
       0,  2573,  2574,  2575,  2576,  2577,  2578,  2579,  2580,  2581,
       0,     0,     0,  2640,  2304,  1823,  1823,  1823,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     974,     0,  2686,     0,     0,     0,  2698,  2703,     0,     0,
     975,  2641,  2644,     0,     0,     0,     0,     0,     0,     0,
     974,   974,     0,     0,     0,     0,     0,     0,  2110,   975,
       0,  2111,     0,     0,     0,  2112,  2113,  2114,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   975,     0,  2634,  2371,     0,     0,  1822,   974,     0,
       0,  1822,     0,  2635,     0,   914,     0,     0,     0,  2642,
    2636,     0,  2643,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   912,     0,   974,     0,  1822,   912,   912,
       0,   974,     0,     0,     0,     0,  2637,     0,     0,     0,
       0,     0,     0,     0,     0,   974,     0,     0,     0,     0,
       0,     0,   974,     0,     0,   974,     0,     0,     0,  2572,
       0,   974,     0,     0,     0,     0,     0,     0,  2573,  2574,
    2575,  2576,  2577,  2578,  2579,  2580,  2581,     0,     0,     0,
       0,   974,     0,   975,     0,     0,     0,   974,     0,     0,
       0,     0,     0,     0,   974,     0,  1051,     0,     0,     0,
       0,     0,  1083,  3367,     0,     0,  2644,     0,  5246,     0,
     974,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   974,     0,     0,     0,     0,  1822,
    1823,     0,     0,     0,     0,   974,   975,     0,   975,     0,
       0,     0,     0,     0,   914,   912,     0,     0,     0,     0,
       0,   975,     0,   975,  2638,     0,     0,     0,     0,  2639,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2640,  2304,     0,     0,     0,     0,     0,     0,
       0,  1733,  1733,  1733,     0,  1822,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   912,     0,
    2641,     0,     0,  2572,     0,   914,     0,     0,     0,     0,
     975,     0,  2573,  2574,  2575,  2576,  2577,  2578,  2579,  2580,
    2581,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2371,     0,     0,     0,     0,     0,     0,
       0,     0,   975,     0,     0,  3604,     0,     0,  2642,     0,
       0,  2643,     0,  1392,     0,     0,     0,     0,     0,     0,
       0,   975,     0,     0,     0,   975,     0,     0,     0,     0,
       0,     0,  1415,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   975,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   910,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   914,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     974,     0,  1822,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1473,  2644,     0,     0,     0,   974,
       0,     0,     0,     0,     0,     0,   974,     0,     0,     0,
       0,     0,  2110,     0,     0,  2111,     0,     0,     0,  2112,
    2113,  2114,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2634,     0,  3753,
       0,  1609,  3756,     0,  1823,     0,     0,  2635,     0,     0,
       0,     0,     0,     0,  2636,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2110,     0,     0,  2111,     0,     0,
       0,  2112,  2113,  2114,     0,     0,     0,     0,     0,     0,
    2637,     0,     0,     0,     0,     0,     0,     0,     0,  2634,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2635,
       0,     0,  2572,  1822,     0,     0,  2636,     0,     0,  1822,
       0,  2573,  2574,  2575,  2576,  2577,  2578,  2579,  2580,  2581,
     914,     0,     0,     0,     0,   914,   914,     0,     0,     0,
       0,     0,  2637,  3853,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3866,     0,     0,     0,
    3268,     0,     0,     0,  3875,     0,  1872,     0,     0,  3285,
    3285,  3285,  3285,  3295,  3301,  3285,  3304,  3285,  3285,     0,
       0,     0,     0,  3311,     0,  3312,     0,  3314,     0,     0,
    3328,  3331,  3336,     0,     0,  1906,  1909,  1910,  3345,     0,
       0,  3350,     0,  3919,   974,     0,     0,     0,  2638,     0,
       0,     0,     0,  2639,     0,     0,  3357,  3358,  3359,     0,
       0,     0,     0,     0,  3943,     0,     0,     0,     0,   975,
       0,     0,     0,     0,  3360,  5813,  2640,  2304,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   914,     0,     0,     0,     0,     0,     0,     0,
    2638,     0,     0,     0,  2641,  2639,     0,  3998,     0,  4000,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2640,  2304,
       0,  1823,     0,     0,     0,     0,  1823,     0,  1823,     0,
       0,     0,     0,     0,  1392,     0,     0,  2371,     0,     0,
       0,     0,     0,     0,     0,   914,  2641,     0,     0,     0,
       0,     0,  2642,     0,  1823,  2643,     0,     0,     0,     0,
       0,     0,  1392,     0,     0,     0,     0,   974,   974,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4055,   974,  2371,
     912,   974,     0,     0,  4062,     0,     0,     0,     0,     0,
       0,     0,   975,     0,  2642,   975,     0,  2643,     0,     0,
       0,  3368,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2644,
    2110,     0,     0,  2111,     0,     0,     0,  2112,  2113,  2114,
       0,     0,     0,     0,     0,  3387,     0,     0,     0,     0,
       0,     0,  1822,  1822,  1822,  2634,     0,     0,  5830,     0,
       0,     0,     0,     0,     0,  2635,     0,     0,     0,     0,
       0,     0,  2636,     0,     0,   975,   975,   974,     0,     0,
       0,  2644,     0,     0,     0,     0,   975,     0,     0,     0,
       0,     0,     0,     0,     0,  2628,   974,     0,  2637,     0,
       0,  3389,     0,   975,     0,     0,     0,     0,     0,     0,
    5621,     0,     0,     0,     0,     0,     0,     0,   974,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2572,     0,     0,     0,
       0,     0,     0,     0,     0,  2573,  2574,  2575,  2576,  2577,
    2578,  2579,  2580,  2581,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2719,     0,     0,     0,     0,
       0,     0,     0,     0,   975,     0,     0,  1823,  2572,     0,
       0,     0,     0,     0,     0,     0,     0,  2573,  2574,  2575,
    2576,  2577,  2578,  2579,  2580,  2581,     0,     0,     0,     0,
     974,     0,     0,     0,     0,     0,  2638,     0,     0,     0,
       0,  2639,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2640,  2304,     0,     0,     0,     0,
       0,     0,     0,   197,     0,     0,     0,  1822,  2833,     0,
       0,     0,     0,   974,     0,   974,     0,  2862,     0,     0,
       0,     0,  2641,     0,     0,     0,     0,     0,   974,     0,
     974,     0,     0,     0,     0,     0,     0,  3396,  3397,  3398,
    3399,  3400,  3401,  3402,  3403,  3404,     0,  3405,     0,  2900,
       0,     0,     0,     0,   198,  2912,  2912,     0,  1367,  2912,
    1733,     0,     0,  4329,  4330,  2371,     0,     0,     0,     0,
       0,   199,  2930,     0,     0,  2933,     0,     0,     0,     0,
    2642,     0,     0,  2643,     0,     0,     0,     0,     0,   200,
       0,     0,     0,     0,     0,   201,     0,   974,  3360,     0,
       0,     0,  3368,     0,     0,  3387,     0,  3389,     0,     0,
    3442,     0,     0,   202,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   203,     0,     0,     0,
       0,     0,     0,  2988,  2110,   204,     0,  2111,     0,   974,
       0,  2112,  2113,  2114,     0,     0,     0,  3008,   205,     0,
       0,     0,     0,     0,   206,     0,     0,     0,   974,  2634,
       0,   207,   974,  2100,  2101,     0,     0,   975,     0,  2635,
       0,     0,     0,     0,     0,     0,  2636,  2644,     0,     0,
       0,   208,     0,   974,     0,     0,     0,   914,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2637,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   209,
       0,     0,     0,     0,   975,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   975,     0,     0,     0,
       0,   210,     0,  3582,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3030,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3033,     0,
     975,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2572,   211,     0,     0,     0,     0,
       0,  1822,     0,  2573,  2574,  2575,  2576,  2577,  2578,  2579,
    2580,  2581,     0,     0,     0,     0,     0,     0,     0,     0,
    3077,  2912,   212,     0,     0,     0,     0,     0,  4515,     0,
    2638,     0,   213,   214,     0,  2639,   215,     0,     0,     0,
       0,     0,     0,     0,     0,  3112,     0,     0,     0,     0,
       0,     0,  3125,     0,     0,     0,     0,     0,  2640,  2304,
    1823,     0,     0,     0,   216,     0,     0,   217,     0,     0,
       0,   218,     0,     0,   219,     0,     0,     0,     0,   975,
       0,   220,     0,     0,   221,     0,  2641,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   222,     0,     0,     0,     0,
       0,     0,     0,   223,     0,     0,     0,     0,   224,     0,
     225,     0,     0,   226,     0,  3186,     0,     0,   227,  2371,
       0,     0,     0,     0,     0,     0,     0,     0,   228,     0,
       0,     0,     0,   229,  2642,     0,     0,  2643,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   230,  1392,  1392,
       0,     0,     0,     0,     0,   975,     0,     0,     0,     0,
     231,     0,     0,     0,     0,  3240,   974,     0,  3242,     0,
       0,     0,     0,   672,     0,     0,     0,     0,  4668,     0,
       0,     0,     0,     0,     0,     0,     0,  3839,  3840,  1733,
       0,   673,     0,  3844,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   674,     0,     0,     0,
    3873,     0,     0,     0,     0,     0,     0,     0,  1822,   675,
       0,  2644,     0,  1822,     0,  1822,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  -887,     0,     0,     0,
       0,  2583,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1822,     0,     0,   676,     0,     0,     0,     0,     0,
     677,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   975,     0,   975,   678,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   679,     0,     0,     0,     0,  2583,     0,     0,   974,
     680,     0,   974,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   681,     0,     0,     0,     0,     0,     0,
       0,     0,   682,     0,     0,   975,   683,     0,  2572,     0,
       0,     0,     0,     0,     0,   965,     0,  2573,  2574,  2575,
    2576,  2577,  2578,  2579,  2580,  2581, -1093,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1823,
       0,     0,     0,     0,   965,     0,     0,     0,     0,     0,
       0,     0,   974,   974,     0,     0,   684,     0,     0,     0,
       0,     0,     0,   974,     1,     0,  -622,     0,     0,     0,
       0,     0,     0,     0,     0,     2,     0,     3,     4,  4068,
     974,     0,     0,     0,  4074,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     6,     0,     0,     0,     0,
     685,     0,     0,   686,     0,     0,     0,     7,     0,     8,
       9,     0,     0,     0,     0,     0,    10,     0,    11,     0,
       0,     0,     0,     0,     0,  2103,     0,   687,     0,     0,
       0,    12,     0,    13,     0,     0,  3336,     0,  3336,  3336,
       0,   688,     0,     0,     0,     0,     0,     0,     0,  -472,
      14,   974,  4164,    15,  1822,  4167,     0,  4169,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    16,   689,
      17,     0,     0,     0,    18,     0,     0,     0,     0,   690,
       0,  5779,     0,     0,     0,     0,  -472,     0,     0,   691,
      20,     0,    21,     0,  4194,     0,  4197,     0,  4199,    22,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     692,     0,     0,     0,     0,     0,     0,    23,   693,     0,
       0,     0,     0,     0,     0,  -472,     0,     0,   694,     0,
     695,     0,   696,   697,    24,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   698,     0,
       0,     0,     0,     0,     0,     0,   699,  2583,     0,   700,
       0,  2583,   701,     0,     0,     0,     0,   975,     0,     0,
       0,     0,     0,     0,     0,  -472,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   975,     0,     0,    25,    26,
       0,     0,  4269,     0,    27,     0,     0,  2686,     0,     0,
       0,     0,     0,     0,     0,   721,     0,     0,     0,    28,
     722,     0,  2703,     0,     0,     0,  1823,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    29,     0,
       0,     0,     0,     0,     0,     0,  5075,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   723,     0,
    5077,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   724,     0,     0,  3425,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3430,     0,    30,  4319,   725,     0,
       0,     0,     0,     0,   974,     0,     0,     0,     0,     0,
       0,    31,     0,     0,     0,  1823,   726,    32,    33,     0,
      34,     0,     0,  1473,     0,    35,     0,     0,  4640,     0,
       0,    36,     0,     0,    37,     0,     0,     0,     0,     0,
     727,    38,     0,     0,     0,     0,     0,     0,    39,    40,
       0,  1823,     0,   728,     0,     0,    41,  4354,     0,     0,
      42,   974,   729,     0,     0,     0,     0,     0,     0,     0,
    1473,  1473,    43,   974,     0,   730,     0,     0,     0,     0,
       0,   731,     0,     0,     0,     0,     0,     0,   732,    44,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1392,     0,     0,   974,   733,     0,
      45,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    46,  1823,     0,     0,   975,     0,    47,     0,
       0,     0,     0,    48,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    49,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   734,     0,
      50,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1822,     0,    56,
       0,     0,  -136,     0,     0,     0,     0,     0,  2583,     0,
       0,     0,     0,     0,     0,     0,   974,     0,     0,     0,
       0,     0,   735,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2583,   736,     0,     0,  3324,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   737,
    3649,     0,     0,  2583,  2583,  2583,     0,  2583,     0,   213,
     738,     0,     0,   739,     0,  3671,     0,     0,     0,  1733,
       0,     0,     0,     0,     0,  1733,     0,     0,     0,   975,
       0,     0,     0,     0,     0,     0,     0,  3699,     0,     0,
       0,   740,     0,   965,   741,     0,     0,     0,   742,     0,
       0,   743,   974,     0,     0,     0,   975,     0,   744,     0,
       0,   745,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   746,     0,     0,     0,     0,     0,     0,     0,
     747,     0,     0,     0,     0,     0,     0,   748,     0,     0,
     749,     0,     0,     0,  4589,   750,     0,     0,     0,     0,
       0,     0,     0,   751,     0,   752,   965,   965,     0,     0,
     753,     0,     0,  3779,  3780,     0,     0,     0,     0,     0,
    3786,     0,     0,     0,   754,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   755,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   974,     0,   974,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   975,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5419,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3907,     0,     0,
       0,  5423,   974,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4711,     0,     0,     0,     0,     0,     0,
       0,     0,  4715,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3285,     0,     0,     0,
    4728,  3285,  3285,     0,     0,     0,  1822,  3301,     0,     0,
    4736,     0,     0,  4738,     0,     0,     0,     0,     0,  4740,
       0,  4741,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5481,     0,     0,     0,     0,     0,  4763,  4764,
    4765,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3345,     0,     0,
       0,     0,  1823,     0,     0,  4789,     0,     0,  4792,     0,
    4794,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4798,     0,     0,     0,
       0,     0,     0,     0,  4805,  4806,     0,     0,     0,     0,
       0,  4811,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1823,     0,     0,     0,     0,     0,     0,     0,     0,
    3285,     0,     0,     0,   965,   965,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1823,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4865,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4879,     0,
       0,     0,     0,     0,  2583,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   974,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   974,     0,  5640,     0,  5642,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4215,     0,  1822,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2583,     0,  1473,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2583,     0,     0,     0,     0,  2583,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1822,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5770,     0,  1822,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1822,     0,     0,   974,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5166,  5167,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5174,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4433,     0,     0,  5904,     0,
    5906,     0,     0,     0,     0,  2912,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5217,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   974,     0,     0,     0,
    2686,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5240,     0,
       0,     0,  1392,   974,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5259,  5261,     0,
       0,     0,     0,     0,  5265,  5266,     0,     0,     0,  5267,
       0,     0,     0,     0,  5268,     0,     0,  5271,  5272,     0,
       0,     0,     0,     0,  5277,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5312,
    4566,  4567,  4568,     0,     0,     0,     0,     0,     0,     0,
    1367,     0,     0,     0,     0,     0,     0,  4577,  5326,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   974,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4602,  4604,     0,     0,     0,  4609,     0,     0,     0,     0,
       0,     0,     0,  5354,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  6115,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2583,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5403,     0,     0,     0,     0,     0,  2583,
    5405,     0,     0,     0,     0,     0,     0,     0,     0,  2583,
       0,  1392,     0,     0,     0,  2583,     0,     0,  2583,     0,
       0,     0,     0,     0,     0,  2583,  2583,     0,  2583,     0,
       0,     0,     0,  3324,  3324,     0,  4140,     0,  3324,  1822,
       0,     0,  2583,     0,     0,  2583,     0,     0,     0,     0,
    2583,     0,     0,     0,     0,     0,     0,     0,     0,  2583,
       0,     0,     0,     0,  2583,     0,     0,     0,     0,     0,
    5444,  2583,  2583,  2583,  2583,     0,     0,     0,     0,  3324,
    3324,  6219,  2583,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1822,     0,
       0,  2583,     0,  2583,     0,     0,     0,     0,     0,     0,
    2583,  2583,  2583,  2583,  2583,  2583,  2583,  2583,  2583,  2583,
       0,     0,     0,  1822,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2583,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4818,  4819,  4820,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  6309,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3285,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5550,     0,     0,     0,     0,     0,  5554,  5555,
    5556,     0,  1116,  1116,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5569,  5570,     0,     0,  5571,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5579,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5591,     0,  2583,     0,     0,     0,
       0,     0,     0,     0,     0,  5609,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5626,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1116,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5088,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5803,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5120,     0,     0,     0,
       0,  3345,     0,  2583,  2583,     0,     0,     0,  2583,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3125,     0,
       0,     0,     0,     0,     0,     0,     0,  2583,     0,     0,
       0,     0,     0,     0,     0,     0,  2103,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5178,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3186,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5882,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5894,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5933,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5281,  5282,  5283,  5284,     0,
       0,     0,  2583,     0,     0,     0,     0,     0,  2583,     0,
       0,     0,     0,     0,     0,  3285,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  6013,     0,     0,
       0,     0,     0,     0,     0,     0,  6020,  6020,  6020,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4140,  4140,     0,     0,  3324,
    3324,  3324,  3324,     0,  5609,  3324,  3324,  3324,  3324,  3324,
    3324,  3324,  3324,  3324,  3324,  4140,     0,     0,  6053,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  6068,  2583,     0,
       0,  2583,     0,  2583,     0,     0,  4140,  4140,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2583,  3324,
    3324,  2583,     0,  2583,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2583,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  6020,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2583,     0,     0,  5609,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2583,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  6243,
       0,     0,     0,     0,     0,  5503,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5513,     0,     0,     0,
       0,     0,     0,  6268,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3324,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    6020,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  6355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2583,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5675,  5676,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1733,     0,     0,     0,     0,     0,     0,     0,  5724,
       0,     0,     0,     0,  1392,  2583,     0,     0,     0,  2583,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2583,  5754,     0,     0,     0,     0,     0,     0,
    2583,     0,  2583,     0,  2583,  2583,     0,     0,     0,     0,
    4140,  4140,  4140,  4140,     0,     0,     0,  4140,  4140,  4140,
    4140,  4140,  4140,  4140,  4140,  4140,  4140,  2583,  2583,  2583,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2583,     0,     0,  2583,     0,  2583,     0,
       0,     0,  2583,     0,     0,  4140,  4140,     0,     0,  2583,
    2583,     0,     0,     0,     0,  2583,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2583,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2583,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5878,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5956,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5978,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4140,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2583,  2583,     0,     0,     0,     0,     0,     0,  2583,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2583,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2583,  3324,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2583,     0,  2583,     0,     0,     0,  2583,
    2583,  2583,  2583,     0,     0,  2583,  2583,     0,     0,     0,
       0,  2583,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3324,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2583,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2583,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2583,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2583,     0,  2583,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2583,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2583,     0,  4140,  3324,  2583,  2583,
    2583,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2583,  2583,  2583,     0,     0,     0,     0,
       0,     0,     0,  2583,     0,     0,     0,     0,  3324,     0,
       0,  4140,     0,     0,     0,  2583,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2583,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2583,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2583,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4140,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4140,
       0,  3324,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2583,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2583,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2583,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2583,     0,     0,
       0,     0,     0,     0,  2583,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2583,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2583,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3324,  3324,     0,     0,  3324,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2583,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2583,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4140,  4140,     0,  4140,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   234,     0,  1270,   716,     0,
    1271,  1272,  1273,   777,  1274,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,  1727,   244,   245,   246,     0,     0,     0,     0,  1275,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,  1276,   260,  1277,  1278,  2583,
     263,   264,   265,   266,   267,   268,   269,  1279,  1280,   270,
     271,  1281,  1282,   274,     0,   275,   276,   277,   278,  1283,
       0,  1284,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,   298,   299,   300,   301,  1285,  1286,  1287,  1288,
    1289,  1290,  1291,   303,   304,   305,   306,   307,   308,  1292,
    1293,   311,  1294,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,  1728,     0,   324,
     325,   886,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,     0,   337,   338,   339,   340,  1295,
     342,   343,   344,   345,  1296,  1297,   347,     0,   348,   349,
     350,  1298,   352,     0,   353,     0,   354,   355,   356,     0,
     357,   358,   359,   360,   361,     0,   362,  1299,     0,  1300,
     365,   366,     0,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,     0,   377,   378,   379,   380,   381,   382,
     383,   384,     0,   385,   386,   387,   388,   389,   390,   391,
    1301,  1302,     0,  1303,     0,   395,   396,   397,   398,   399,
    1304,  1305,  1306,  1307,  1308,  1309,  1310,  1311,  1312,   409,
    1313,   411,   412,   413,   414,   415,   416,   417,     0,     0,
     418,  1314,   420,   421,   422,     0,   423,   424,   425,  1315,
    1316,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,  1317,   437,   438,   439,   440,   441,   442,   443,   444,
    1318,   446,  1319,   448,   449,   450,   451,   452,   453,   454,
     455,   456,  1320,   458,  1321,   459,   460,   461,   462,  1322,
    1323,   464,  1324,   466,   467,   468,     0,   469,   470,   471,
       0,     0,  1325,   473,   474,     0,     0,   475,   476,   477,
     478,   479,   480,  1326,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
    1327,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,  1328,   515,
     516,   517,   518,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
     534,   535,   536,   537,   538,   539,  1329,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,  1330,   556,   557,   558,   559,   560,   561,
     562,   563,  1331,   565,     0,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,  1332,   583,     0,   584,   585,  1333,     0,   586,   587,
     588,   589,   590,   591,   592,   593,     0,   594,  1334,  1335,
       0,     0,   597,   598,  1336,   600,  1337,  1338,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,  1339,   611,
     612,   613,   614,   615,  1340,     0,   616,   617,   618,   619,
     620,   621,  1341,  1729,   623,   624,   625,   626,   627,   628,
       0,     0,   629,     0,     0,   630,   631,   632,   633,   634,
     635,   636,  1342,  1343,  1344,  1345,   641,  1346,  1347,  1348,
    1349,   646,   647,   648,   649,     0,  1350,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1351,  1352,
    1730,     0,     0,     0,     0,     0,     0,  1354,  1731,   234,
       0,  1270,   716,     0,  1271,  1272,  1273,   777,  1274,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,  1275,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,  1276,
     260,  1277,  1278,     0,   263,   264,   265,   266,   267,   268,
     269,  1279,  1280,   270,   271,  1281,  1282,   274,     0,   275,
     276,   277,   278,  1283,     0,  1284,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,   298,   299,   300,   301,
    1285,  1286,  1287,  1288,  1289,  1290,  1291,   303,   304,   305,
     306,   307,   308,  1292,  1293,   311,  1294,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   886,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,     0,   337,
     338,   339,   340,  1295,   342,   343,   344,   345,  1296,  1297,
     347,     0,   348,   349,   350,  1298,   352,     0,   353,     0,
     354,   355,   356,     0,   357,   358,   359,   360,   361,     0,
     362,  1299,     0,  1300,   365,   366,     0,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,     0,   377,   378,
     379,   380,   381,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,  1301,  1302,     0,  1303,     0,   395,
     396,   397,   398,   399,  1304,  1305,  1306,  1307,  1308,  1309,
    1310,  1311,  1312,   409,  1313,   411,   412,   413,   414,   415,
     416,   417,     0,     0,   418,  1314,   420,   421,   422,     0,
     423,   424,   425,  1315,  1316,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,  1317,   437,   438,   439,   440,
     441,   442,   443,   444,  1318,   446,  1319,   448,   449,   450,
     451,   452,   453,   454,   455,   456,  1320,   458,  1321,   459,
     460,   461,   462,  1322,  1323,   464,  1324,   466,   467,   468,
       0,   469,   470,   471,     0,     0,  1325,   473,   474,     0,
       0,   475,   476,   477,   478,   479,   480,  1326,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,  1327,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,  1328,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,   534,   535,   536,   537,   538,   539,
    1329,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,    40,   551,   552,   553,   554,   555,  1330,   556,   557,
     558,   559,   560,   561,   562,   563,  1331,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,  1332,   583,     0,   584,   585,
    1333,    44,   586,   587,   588,   589,   590,   591,   592,   593,
       0,   594,  1334,  1335,     0,     0,   597,   598,  1336,   600,
    1337,  1338,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,  1339,   611,   612,   613,   614,   615,  1340,     0,
     616,   617,   618,   619,   620,  1205,  1341,     0,   623,   624,
     625,   626,   627,   628,     0,     0,   629,     0,    49,   630,
     631,   632,   633,   634,   635,   636,  1342,  1343,  1344,  1345,
     641,  1346,  1347,  1348,  1349,   646,   647,   648,   649,     0,
    1350,     0,    50,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1351,  1352,     0,     0,     0,     0,     0,     0,
       0,  1354,  5849,   234,     0,  1270,   716,     0,  1271,  1272,
    1273,   777,  1274,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,  1275,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1276,   260,  1277,  1278,     0,   263,   264,
     265,   266,   267,   268,   269,  1279,  1280,   270,   271,  1281,
    1282,   274,     0,   275,   276,   277,   278,  1283,     0,  1284,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
     298,   299,   300,   301,  1285,  1286,  1287,  1288,  1289,  1290,
    1291,   303,   304,   305,   306,   307,   308,  1292,  1293,   311,
    1294,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   886,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,     0,   337,   338,   339,   340,  1295,   342,   343,
     344,   345,  1296,  1297,   347,     0,   348,   349,   350,  1298,
     352,     0,   353,     0,   354,   355,   356,     0,   357,   358,
     359,   360,   361,     0,   362,  1299,     0,  1300,   365,   366,
       0,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,     0,   377,   378,   379,   380,   381,   382,   383,   384,
       0,   385,   386,   387,   388,   389,   390,   391,  1301,  1302,
       0,  1303,     0,   395,   396,   397,   398,   399,  1304,  1305,
    1306,  1307,  1308,  1309,  1310,  1311,  1312,   409,  1313,   411,
     412,   413,   414,   415,   416,   417,     0,     0,   418,  1314,
     420,   421,   422,     0,   423,   424,   425,  1315,  1316,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,  1317,
     437,   438,   439,   440,   441,   442,   443,   444,  1318,   446,
    1319,   448,   449,   450,   451,   452,   453,   454,   455,   456,
    1320,   458,  1321,   459,   460,   461,   462,  1322,  1323,   464,
    1324,   466,   467,   468,     0,   469,   470,   471,     0,     0,
    1325,   473,   474,     0,     0,   475,   476,   477,   478,   479,
     480,  1326,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,  1327,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,  1328,   515,   516,   517,
     518,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,   532,   533,   534,   535,
     536,   537,   538,   539,  1329,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     555,  1330,   556,   557,   558,   559,   560,   561,   562,   563,
    1331,   565,     0,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,  1332,
     583,     0,   584,   585,  1333,     0,   586,   587,   588,   589,
     590,   591,   592,   593,     0,   594,  1334,  1335,     0,     0,
     597,   598,  1336,   600,  1337,  1338,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,  1339,   611,   612,   613,
     614,   615,  1340,     0,   616,   617,   618,   619,   620,   621,
    1341,     0,   623,   624,   625,   626,   627,   628,     0,     0,
     629,     0,     0,   630,   631,   632,   633,   634,   635,   636,
    1342,  1343,  1344,  1345,   641,  1346,  1347,  1348,  1349,   646,
     647,   648,   649,     0,  1350,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1351,  1352,     0,     0,
       0,     0,     0,     0,     0,  1354,  3326,   234,     0,  1270,
     716,     0,  1271,  1272,  1273,   777,  1274,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,  1275,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,   258,  1276,   260,  1277,
    1278,     0,   263,   264,   265,   266,   267,   268,   269,  1279,
    1280,   270,   271,  1281,  1282,   274,     0,   275,   276,   277,
     278,  1283,     0,  1284,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,   298,   299,   300,   301,  1285,  1286,
    1287,  1288,  1289,  1290,  1291,   303,   304,   305,   306,   307,
     308,  1292,  1293,   311,  1294,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   886,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,     0,   337,   338,   339,
     340,  1295,   342,   343,   344,   345,  1296,  1297,   347,     0,
     348,   349,   350,  1298,   352,     0,   353,     0,   354,   355,
     356,     0,   357,   358,   359,   360,   361,     0,   362,  1299,
       0,  1300,   365,   366,     0,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,     0,   377,   378,   379,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,  1301,  1302,     0,  1303,     0,   395,   396,   397,
     398,   399,  1304,  1305,  1306,  1307,  1308,  1309,  1310,  1311,
    1312,   409,  1313,   411,   412,   413,   414,   415,   416,   417,
       0,     0,   418,  1314,   420,   421,   422,     0,   423,   424,
     425,  1315,  1316,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,  1317,   437,   438,   439,   440,   441,   442,
     443,   444,  1318,   446,  1319,   448,   449,   450,   451,   452,
     453,   454,   455,   456,  1320,   458,  1321,   459,   460,   461,
     462,  1322,  1323,   464,  1324,   466,   467,   468,     0,   469,
     470,   471,     0,     0,  1325,   473,   474,     0,     0,   475,
     476,   477,   478,   479,   480,  1326,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,  1327,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
    1328,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,   534,   535,   536,   537,   538,   539,  1329,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,  1330,   556,   557,   558,   559,
     560,   561,   562,   563,  1331,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,  1332,   583,     0,   584,   585,  1333,     0,
     586,   587,   588,   589,   590,   591,   592,   593,     0,   594,
    1334,  1335,     0,     0,   597,   598,  1336,   600,  1337,  1338,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
    1339,   611,   612,   613,   614,   615,  1340,     0,   616,   617,
     618,   619,   620,   621,  1341,     0,   623,   624,   625,   626,
     627,   628,     0,     0,   629,     0,     0,   630,   631,   632,
     633,   634,   635,   636,  1342,  1343,  1344,  1345,   641,  1346,
    1347,  1348,  1349,   646,   647,   648,   649,     0,  1350,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1351,  1352,     0,     0,     0,     0,     0,     0,     0,  1354,
    4742,   234,     0,  1270,   716,     0,  1271,  1272,  1273,   777,
    1274,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,  1275,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
     258,  1276,   260,  1277,  1278,     0,   263,   264,   265,   266,
     267,   268,   269,  1279,  1280,   270,   271,  1281,  1282,   274,
       0,   275,   276,   277,   278,  1283,     0,  1284,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,   301,  1285,  1286,  1287,  1288,  1289,  1290,  1291,   303,
     304,   305,   306,   307,   308,  1292,  1293,   311,  1294,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   886,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
       0,   337,   338,   339,   340,  1295,   342,   343,   344,   345,
    1296,  1297,   347,     0,   348,   349,   350,  1298,   352,     0,
     353,     0,   354,   355,   356,     0,   357,   358,   359,   360,
     361,     0,   362,  1299,     0,  1300,   365,   366,     0,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,     0,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,  1301,  1302,     0,  1303,
       0,   395,   396,   397,   398,   399,  1304,  1305,  1306,  1307,
    1308,  1309,  1310,  1311,  1312,   409,  1313,   411,   412,   413,
     414,   415,   416,   417,     0,     0,   418,  1314,   420,   421,
     422,     0,   423,   424,   425,  1315,  1316,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,  1317,   437,   438,
     439,   440,   441,   442,   443,   444,  1318,   446,  1319,   448,
     449,   450,   451,   452,   453,   454,   455,   456,  1320,   458,
    1321,   459,   460,   461,   462,  1322,  1323,   464,  1324,   466,
     467,   468,     0,   469,   470,   471,     0,     0,  1325,   473,
     474,     0,     0,   475,   476,   477,   478,   479,   480,  1326,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,  1327,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,  1328,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,   534,   535,   536,   537,
     538,   539,  1329,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,  1330,
     556,   557,   558,   559,   560,   561,   562,   563,  1331,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,  1332,   583,     0,
     584,   585,  1333,     0,   586,   587,   588,   589,   590,   591,
     592,   593,     0,   594,  1334,  1335,     0,     0,   597,   598,
    1336,   600,  1337,  1338,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,  1339,   611,   612,   613,   614,   615,
    1340,     0,   616,   617,   618,   619,   620,   621,  1341,     0,
     623,   624,   625,   626,   627,   628,     0,     0,   629,     0,
       0,   630,   631,   632,   633,   634,   635,   636,  1342,  1343,
    1344,  1345,   641,  1346,  1347,  1348,  1349,   646,   647,   648,
     649,     0,  1350,     0,     0,     0,     0,     0,   657,     0,
       0,     0,     0,     0,  1351,  1352,     0,     0,     0,     0,
       0,     0,     0,  1354,  4808,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,  4246,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0, -1837,   299,   300,   301,     0,
       0,     0,     0,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,     0,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,     0,   347,
       0,   348,   349,   350,   351,   352,     0,   353,     0,   354,
     355,     0,     0, -1837,   358,   359,   360,   361,     0,   362,
     363,     0,   364,   365,   366,     0,   367,   368,   369,   370,
     371,     0,   373,   374,   375,   376,     0,   377,   378,   379,
     380,   381,   382,   383,   384,     0,   385, -1837,   387,   388,
     389,   390,   391,   392,   393,     0,   394,     0,   395,     0,
       0,   398, -1837,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,     0,     0,   418,   419, -1837,   421,     0,     0,   423,
     424,   425,     0,     0,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445, -1837,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,     0,   459,   460,
       0,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   470,   471,     0,     0,   472,   473,   474,     0,     0,
     475,   476,   477,     0,   479,     0,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533, -1837,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,     0,   562,   563,   564,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,     0,   584,   585,     0,
       0,   586,     0,   588,   589,   590,   591,   592,   593,     0,
     594,   595,   596,     0,     0,   597,   598,   599,   600,   601,
       0,   602,   603,   604,   605,   606,   607,   608,   609,   610,
       0,     0,   611,   612,   613,   614,   615,     0,     0,   616,
     617,   618,   619,   620,   621,   622,     0,   623,     0,   625,
     626,   627,   628,     0,     0,   629,     0,     0,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,     0,     0,
       0,     0,     0,     0,     0,   878,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1466,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,     0,   879,   260,   880,   881,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   882,   883,   274,     0,   275,   276,   277,   278,     0,
       0,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,   298,   299,   300,   301,     0,     0,     0,   302,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   884,
     885,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   886,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,     0,   337,   338,   339,   340,     0,
     342,   343,   344,   345,     0,     0,   347,     0,   348,   349,
     350,   887,   352,     0,   353,     0,   354,   355,   356,     0,
     357,   358,   359,   360,   361,     0,   362,     0,     0,     0,
     365,   366,     0,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,  2729,   377,   378,   379,   380,   381,   382,
     383,   384,     0,   385,   386,  2730,   388,   389,   390,   391,
     888,   889,     0,   890,     0,   395,   396,   397,   398,   399,
     891,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   411,   412,   413,   414,   415,   416,   417,     0,     0,
     418,     0,   420,   421,   422,     0,   423,   424,   425,     0,
       0,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,     0,   437,   438,   439,   440,   441,   442,   443,   444,
     892,   446,   893,   448,   449,   450,   451,   452,   453,   454,
     455,     0,     0,   458,     0,   459,   460,   461,   462,     0,
       0,   464,   894,   466,   467,   468,     0,   469,   470,   471,
       0,     0,   472,   473,   474,     0,     0,   475,   476,  2732,
     478,   479,   480,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
       0,   498,     0,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   895,   515,
     516,   517,   518,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
     534,   535,   536,   537,   538,   539,     0,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,     0,   556,   557,  2733,   559,   560,   561,
     562,   563,   897,   565,     0,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,     0,   583,     0,   584,   585,     0,     0,   586,   587,
     588,   589,   590,   591,   592,   593,     0,   594,   898,   899,
       0,     0,   597,   598,     0,   600,     0,     0,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,     0,   611,
     612,   613,   614,   615,     0,     0,   616,   617,   618,   619,
     620,     0,   900,  2734,   623,   624,   625,   626,   627,   628,
       0,     0,   629,     0,     0,   630,   631,   632,   633,   634,
     635,     0,   878,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   647,   648,   649,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,  2827,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,     0,   879,   260,   880,   881,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   882,   883,
     274,     0,   275,   276,   277,   278,     0,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,     0,   302,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   884,   885,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   886,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,     0,   342,   343,   344,
     345,     0,     0,   347,     0,   348,   349,   350,   887,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,     0,     0,     0,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
    2729,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,  2730,   388,   389,   390,   391,   888,   889,     0,
     890,     0,   395,   396,   397,   398,   399,   891,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,     0,   420,
     421,   422,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   437,
     438,   439,   440,   441,   442,   443,   444,   892,   446,   893,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     458,     0,   459,   460,   461,   462,     0,     0,   464,   894,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,  2732,   478,   479,   480,
       0,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,     0,   498,     0,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   895,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,     0,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,  2733,   559,   560,   561,   562,   563,   897,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,     0,   583,
       0,   584,   585,     0,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,   898,   899,     0,     0,   597,
     598,     0,   600,     0,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,     0,   900,
    2734,   623,   624,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,     0,   234,
       0,  1270,   716,     0,  1271,  1272,  1273,   777,  1274,   647,
     648,   649,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,  1275,     0,  3962,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,  1276,
     260,  1277,  1278,     0,   263,   264,   265,   266,   267,   268,
     269,  1279,  1280,   270,   271,  1281,  1282,   274,     0,   275,
     276,   277,   278,  1283,     0,  1284,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,   298,   299,   300,   301,
    1285,  1286,  1287,  1288,  1289,  1290,  1291,   303,   304,   305,
     306,   307,   308,  1292,  1293,   311,  1294,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   886,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,     0,   337,
     338,   339,   340,  1295,   342,   343,   344,   345,  1296,  1297,
     347,     0,   348,   349,   350,  1298,   352,     0,   353,     0,
     354,   355,   356,     0,   357,   358,   359,   360,   361,     0,
     362,  1299,     0,  1300,   365,   366,     0,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,     0,   377,   378,
     379,   380,   381,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,  1301,  1302,     0,  1303,     0,   395,
     396,   397,   398,   399,  1304,  1305,  1306,  1307,  1308,  1309,
    1310,  1311,  1312,   409,  1313,   411,   412,   413,   414,   415,
     416,   417,     0,     0,   418,  1314,   420,   421,   422,     0,
     423,   424,   425,  1315,  1316,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,  1317,   437,   438,   439,   440,
     441,   442,   443,   444,  1318,   446,  1319,   448,   449,   450,
     451,   452,   453,   454,   455,   456,  1320,   458,  1321,   459,
     460,   461,   462,  1322,  1323,   464,  1324,   466,   467,   468,
       0,   469,   470,   471,     0,     0,  1325,   473,   474,     0,
       0,   475,   476,   477,   478,   479,   480,  1326,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,  1327,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,  1328,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,  3287,   532,   533,   534,   535,   536,   537,   538,   539,
    1329,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,    40,   551,   552,   553,   554,   555,  1330,   556,   557,
     558,   559,   560,   561,   562,   563,  1331,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,  1332,   583,     0,   584,   585,
    1333,    44,   586,   587,   588,   589,   590,   591,   592,   593,
       0,   594,  1334,  1335,     0,     0,   597,   598,  1336,   600,
    1337,  1338,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,  1339,   611,   612,   613,   614,   615,  1340,     0,
     616,   617,   618,   619,   620,  1205,  1341,     0,   623,   624,
     625,   626,   627,   628,     0,     0,   629,     0,    49,   630,
     631,   632,   633,   634,   635,   636,  1342,  1343,  1344,  1345,
     641,  1346,  1347,  1348,  1349,   646,   647,   648,   649,     0,
    1350,     0,    50,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1351,  1352,     0,     0,     0,   234,     0,  1270,
     716,  1354,  1271,  1272,  1273,   777,  1274,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,  1275,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,   258,  1276,   260,  1277,
    1278,     0,   263,   264,   265,   266,   267,   268,   269,  1279,
    1280,   270,   271,  1281,  1282,   274,     0,   275,   276,   277,
     278,  1283,     0,  1284,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,   298,   299,   300,   301,  1285,  1286,
    1287,  1288,  1289,  1290,  1291,   303,   304,   305,   306,   307,
     308,  1292,  1293,   311,  1294,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   886,   327,   328,     0,   329,   330,   331,
     332,     0,   333,   334,   335,   336,     0,   337,   338,   339,
     340,  1295,   342,   343,   344,   345,  1296,  1297,   347,     0,
     348,   349,   350,  1298,   352,     0,   353,     0,   354,   355,
     356,     0,   357,   358,   359,   360,   361,     0,   362,  1299,
       0,  1300,   365,   366,     0,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,     0,   377,   378,   379,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,  1301,  1302,     0,  1303,     0,   395,   396,   397,
     398,   399,  1304,  1305,  1306,  1307,  1308,  1309,  1310,  1311,
    1312,   409,  1313,   411,   412,   413,   414,   415,   416,   417,
       0,     0,   418,  1314,   420,   421,   422,     0,   423,   424,
     425,  1315,  1316,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,  1317,   437,   438,   439,   440,   441,   442,
     443,   444,  1318,   446,  1319,   448,   449,   450,   451,   452,
     453,   454,   455,   456,  1320,   458,  1321,   459,   460,   461,
     462,  1322,  1323,   464,  1324,   466,   467,   468,     0,   469,
     470,   471,     0,     0,  1325,   473,   474,     0,     0,   475,
     476,   477,   478,   479,   480,  1326,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,   494,
     495,   496,  1327,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
    1328,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,   534,   535,   536,   537,   538,   539,  1329,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,    40,
     551,   552,   553,   554,   555,  1330,   556,   557,   558,   559,
     560,   561,   562,   563,  1331,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,  1332,   583,     0,   584,   585,  1333,    44,
     586,   587,   588,   589,   590,   591,   592,   593,     0,   594,
    1334,  1335,     0,     0,   597,   598,  1336,   600,  1337,  1338,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
    1339,   611,   612,   613,   614,   615,  1340,     0,   616,   617,
     618,   619,   620,  1205,  1341,     0,   623,   624,   625,   626,
     627,   628,     0,     0,   629,     0,    49,   630,   631,   632,
     633,   634,   635,   636,  1342,  1343,  1344,  1345,   641,  1346,
    1347,  1348,  1349,   646,   647,   648,   649,     0,  1350,     0,
      50,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1351,  1352,     0,     0,     0,   234,     0,  1270,   716,  1354,
    1271,  1272,  1273,   777,  1274,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,  1275,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,  1276,   260,  1277,  1278,  3332,
     263,   264,   265,   266,   267,   268,   269,  1279,  1280,   270,
     271,  1281,  1282,   274,     0,   275,   276,   277,   278,  1283,
       0,  1284,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,   298,   299,   300,   301,  1285,  1286,  1287,  1288,
    1289,  1290,  1291,   303,   304,   305,   306,   307,   308,  1292,
    1293,   311,  1294,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   886,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,     0,   337,   338,   339,   340,  1295,
     342,   343,   344,   345,  1296,  1297,   347,     0,   348,   349,
     350,  1298,   352,     0,   353,     0,   354,   355,   356,  3333,
     357,   358,   359,   360,   361,     0,   362,  1299,     0,  1300,
     365,   366,     0,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,     0,   377,   378,   379,   380,   381,   382,
     383,   384,     0,   385,   386,   387,   388,   389,   390,   391,
    1301,  1302,     0,  1303,     0,   395,   396,   397,   398,   399,
    1304,  1305,  1306,  1307,  1308,  1309,  1310,  1311,  1312,   409,
    1313,   411,   412,   413,   414,   415,   416,   417,     0,  3334,
     418,  1314,   420,   421,   422,     0,   423,   424,   425,  1315,
    1316,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,  1317,   437,   438,   439,   440,   441,   442,   443,   444,
    1318,   446,  1319,   448,   449,   450,   451,   452,   453,   454,
     455,   456,  1320,   458,  1321,   459,   460,   461,   462,  1322,
    1323,   464,  1324,   466,   467,   468,     0,   469,   470,   471,
       0,     0,  1325,   473,   474,     0,     0,   475,   476,   477,
     478,   479,   480,  1326,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
    1327,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,  1328,   515,
     516,   517,   518,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
     534,   535,   536,   537,   538,   539,  1329,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,  1330,   556,   557,   558,   559,   560,   561,
     562,   563,  1331,   565,     0,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,  1332,   583,     0,   584,   585,  1333,     0,   586,   587,
     588,   589,   590,   591,   592,   593,     0,   594,  1334,  1335,
       0,  3335,   597,   598,  1336,   600,  1337,  1338,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,  1339,   611,
     612,   613,   614,   615,  1340,     0,   616,   617,   618,   619,
     620,   621,  1341,     0,   623,   624,   625,   626,   627,   628,
       0,     0,   629,     0,     0,   630,   631,   632,   633,   634,
     635,   636,  1342,  1343,  1344,  1345,   641,  1346,  1347,  1348,
    1349,   646,   647,   648,   649,     0,  1350,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1351,  1352,
       0,     0,     0,   234,     0,  1270,   716,  1354,  1271,  1272,
    1273,   777,  1274,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243, -2268,
     244,   245,   246,     0,     0,     0, -2268,  1275,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1276,   260,  1277,  1278,     0,   263,   264,
     265,   266,   267,   268,   269,  1279,  1280,   270,   271,  1281,
    1282,   274,     0,   275,   276,   277,   278,  1283,     0,  1284,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
     298,   299,   300,   301,  1285,  1286,  1287,  1288,  1289,  1290,
    1291,   303,   304,   305,   306,   307,   308,  1292,  1293,   311,
    1294,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   886,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,     0,   337,   338,   339,   340,  1295,   342,   343,
     344,   345,  1296,  1297,   347,     0,   348,   349,   350,  1298,
     352,     0,   353,     0,   354,   355,   356,     0,   357,   358,
     359,   360,   361,     0,   362,  1299,     0,  1300,   365,   366,
       0,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,     0,   377,   378,   379,   380,   381,   382,   383,   384,
       0,   385,   386,   387,   388,   389,   390,   391,  1301,  1302,
       0,  1303,     0,   395,   396,   397,   398,   399,  1304,  1305,
    1306,  1307,  1308,  1309,  1310,  1311,  1312,   409,  1313,   411,
     412,   413,   414,   415,   416,   417,     0,     0,   418,  1314,
     420,   421,   422,     0,   423,   424,   425,  1315,  1316,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,  1317,
     437,   438,   439,   440,   441,   442,   443,   444,  1318,   446,
    1319,   448,   449,   450,   451,   452,   453,   454,   455,   456,
    1320,   458,  1321,   459,   460,   461,   462,  1322,  1323,   464,
    1324,   466,   467,   468,     0,   469,   470,   471,     0,     0,
    1325,   473,   474,     0,     0,   475,   476,   477,   478,   479,
     480,  1326,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,  1327,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,  1328,   515,   516,   517,
     518,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,   532,   533,   534,   535,
     536,   537,   538,   539,  1329,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     555,  1330,   556,   557,   558,   559,   560,   561,   562,   563,
    1331,   565, -2268,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,  1332,
     583,     0,   584,   585,  1333,     0,   586,   587,   588,   589,
     590,   591,   592,   593,     0,   594,  1334,  1335,     0,     0,
     597,   598,  1336,   600,  1337,  1338,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,  1339,   611,   612,   613,
     614,   615,  1340,     0,   616,   617,   618,   619,   620,   621,
    1341,     0,   623,   624,   625,   626,   627,   628,     0,     0,
     629,     0,     0,   630,   631,   632,   633,   634,   635,   636,
    1342,  1343,  1344,  1345,   641,  1346,  1347,  1348,  1349,   646,
     647,   648,   649,     0,  1350,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1351,  1352,     0,     0,
       0,   234,     0,  1270,   716,  1354,  1271,  1272,  1273,   777,
    1274,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243, -2266,   244,   245,
     246,     0,     0,     0, -2266,  1275,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
     258,  1276,   260,  1277,  1278,     0,   263,   264,   265,   266,
     267,   268,   269,  1279,  1280,   270,   271,  1281,  1282,   274,
       0,   275,   276,   277,   278,  1283,     0,  1284,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,   301,  1285,  1286,  1287,  1288,  1289,  1290,  1291,   303,
     304,   305,   306,   307,   308,  1292,  1293,   311,  1294,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   886,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
       0,   337,   338,   339,   340,  1295,   342,   343,   344,   345,
    1296,  1297,   347,     0,   348,   349,   350,  1298,   352,     0,
     353,     0,   354,   355,   356,     0,   357,   358,   359,   360,
     361,     0,   362,  1299,     0,  1300,   365,   366,     0,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,     0,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,  1301,  1302,     0,  1303,
       0,   395,   396,   397,   398,   399,  1304,  1305,  1306,  1307,
    1308,  1309,  1310,  1311,  1312,   409,  1313,   411,   412,   413,
     414,   415,   416,   417,     0,     0,   418,  1314,   420,   421,
     422,     0,   423,   424,   425,  1315,  1316,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,  1317,   437,   438,
     439,   440,   441,   442,   443,   444,  1318,   446,  1319,   448,
     449,   450,   451,   452,   453,   454,   455,   456,  1320,   458,
    1321,   459,   460,   461,   462,  1322,  1323,   464,  1324,   466,
     467,   468,     0,   469,   470,   471,     0,     0,  1325,   473,
     474,     0,     0,   475,   476,   477,   478,   479,   480,  1326,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,  1327,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,  1328,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,   534,   535,   536,   537,
     538,   539,  1329,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,  1330,
     556,   557,   558,   559,   560,   561,   562,   563,  1331,   565,
   -2266,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,  1332,   583,     0,
     584,   585,  1333,     0,   586,   587,   588,   589,   590,   591,
     592,   593,     0,   594,  1334,  1335,     0,     0,   597,   598,
    1336,   600,  1337,  1338,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,  1339,   611,   612,   613,   614,   615,
    1340,     0,   616,   617,   618,   619,   620,   621,  1341,     0,
     623,   624,   625,   626,   627,   628,     0,     0,   629,     0,
       0,   630,   631,   632,   633,   634,   635,   636,  1342,  1343,
    1344,  1345,   641,  1346,  1347,  1348,  1349,   646,   647,   648,
     649,     0,  1350,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1351,  1352,     0,     0,     0,   234,
       0,  1270,   716,  1354,  1271,  1272,  1273,   777,  1274,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,  1275,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,  1276,
     260,  1277,  1278,     0,   263,   264,   265,   266,   267,   268,
     269,  1279,  1280,   270,   271,  1281,  1282,   274,     0,   275,
     276,   277,   278,  1283,     0,  1284,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,   298,   299,   300,   301,
    1285,  1286,  1287,  1288,  1289,  1290,  1291,   303,   304,   305,
     306,   307,   308,  1292,  1293,   311,  1294,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   886,   327,   328,     0,   329,
     330,   331,   332,     0,   333,   334,   335,   336,     0,   337,
     338,   339,   340,  1295,   342,   343,   344,   345,  1296,  1297,
     347,     0,   348,   349,   350,  1298,   352,     0,   353,     0,
     354,   355,   356,     0,   357,   358,   359,   360,   361,     0,
     362,  1299,     0,  1300,   365,   366,     0,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,     0,   377,   378,
     379,   380,   381,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,  1301,  1302,     0,  1303,     0,   395,
     396,   397,   398,   399,  1304,  1305,  1306,  1307,  1308,  1309,
    1310,  1311,  1312,   409,  1313,   411,   412,   413,   414,   415,
     416,   417,     0,     0,   418,  1314,   420,   421,   422,     0,
     423,   424,   425,  1315,  1316,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,  1317,   437,   438,   439,   440,
     441,   442,   443,   444,  1318,   446,  1319,   448,   449,   450,
     451,   452,   453,   454,   455,   456,  1320,   458,  1321,   459,
     460,   461,   462,  1322,  1323,   464,  1324,   466,   467,   468,
       0,   469,   470,   471,     0,     0,  1325,   473,   474,     0,
       0,   475,   476,   477,   478,   479,   480,  1326,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,   494,   495,   496,  1327,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,  1328,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,   534,   535,   536,   537,   538,   539,
    1329,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,  1330,   556,   557,
     558,   559,   560,   561,   562,   563,  1331,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,  1332,   583,     0,   584,   585,
    1333,     0,   586,   587,   588,   589,   590,   591,   592,   593,
       0,   594,  1334,  1335,     0,     0,   597,   598,  1336,   600,
    1337,  1338,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,  1339,   611,   612,   613,   614,   615,  1340,     0,
     616,   617,   618,   619,   620,   621,  1341,     0,   623,   624,
     625,   626,   627,   628,     0,     0,   629,     0,     0,   630,
     631,   632,   633,   634,   635,   636,  1342,  1343,  1344,  1345,
     641,  1346,  1347,  1348,  1349,   646,   647,   648,   649,     0,
    1350,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1351,  1352,     0,     0,     0,     0,     0,  2051,
    3261,  1354,   234,     0,  1270,   716,     0,  1271,  1272,  1273,
     777,  1274,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,  1275,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,  1276,   260,  1277,  1278,     0,   263,   264,   265,
     266,   267,   268,   269,  1279,  1280,   270,   271,  1281,  1282,
     274,     0,   275,   276,   277,   278,  1283,     0,  1284,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,  1285,  1286,  1287,  1288,  1289,  1290,  1291,
     303,   304,   305,   306,   307,   308,  1292,  1293,   311,  1294,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   886,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,  1295,   342,   343,   344,
     345,  1296,  1297,   347,     0,   348,   349,   350,  1298,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,  1299,     0,  1300,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,  1301,  1302,     0,
    1303,     0,   395,   396,   397,   398,   399,  1304,  1305,  1306,
    1307,  1308,  1309,  1310,  1311,  1312,   409,  1313,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,  1314,   420,
     421,   422,     0,   423,   424,   425,  1315,  1316,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,  1317,   437,
     438,   439,   440,   441,   442,   443,   444,  1318,   446,  1319,
     448,   449,   450,   451,   452,   453,   454,   455,   456,  1320,
     458,  1321,   459,   460,   461,   462,  1322,  1323,   464,  1324,
     466,   467,   468,     0,   469,   470,   471,     0,     0,  1325,
     473,   474,     0,     0,   475,   476,   477,   478,   479,   480,
    1326,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,  1327,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,  1328,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,  1329,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
    1330,   556,   557,   558,   559,   560,   561,   562,   563,  1331,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,  1332,   583,
       0,   584,   585,  1333,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,  1334,  1335,     0,     0,   597,
     598,  1336,   600,  1337,  1338,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,  1339,   611,   612,   613,   614,
     615,  1340,     0,   616,   617,   618,   619,   620,   621,  1341,
       0,   623,   624,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,  1342,
    1343,  1344,  1345,   641,  1346,  1347,  1348,  1349,   646,   647,
     648,   649,     0,  1350,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1351,  1352,  1353,     0,     0,
     234,     0,  1270,   716,  1354,  1271,  1272,  1273,   777,  1274,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,  2696,   244,   245,   246,
       0,     0,     0,     0,  1275,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
    1276,   260,  1277,  1278,     0,   263,   264,   265,   266,   267,
     268,   269,  1279,  1280,   270,   271,  1281,  1282,   274,     0,
     275,   276,   277,   278,  1283,     0,  1284,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,   298,   299,   300,
     301,  1285,  1286,  1287,  1288,  1289,  1290,  1291,   303,   304,
     305,   306,   307,   308,  1292,  1293,   311,  1294,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   886,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,     0,
     337,   338,   339,   340,  1295,   342,   343,   344,   345,  1296,
    1297,   347,     0,   348,   349,   350,  1298,   352,     0,   353,
       0,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,  1299,     0,  1300,   365,   366,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,     0,   377,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,  1301,  1302,     0,  1303,     0,
     395,   396,   397,   398,   399,  1304,  1305,  1306,  1307,  1308,
    1309,  1310,  1311,  1312,   409,  1313,   411,   412,   413,   414,
     415,   416,   417,     0,     0,   418,  1314,   420,   421,   422,
       0,   423,   424,   425,  1315,  1316,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,  1317,   437,   438,   439,
     440,   441,   442,   443,   444,  1318,   446,  1319,   448,   449,
     450,   451,   452,   453,   454,   455,   456,  1320,   458,  1321,
     459,   460,   461,   462,  1322,  1323,   464,  1324,   466,   467,
     468,     0,   469,   470,   471,     0,     0,  1325,   473,   474,
       0,     0,   475,   476,   477,   478,   479,   480,  1326,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,   494,   495,   496,  1327,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,  1328,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,   534,   535,   536,   537,   538,
     539,  1329,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,  1330,   556,
     557,   558,   559,   560,   561,   562,   563,  1331,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,  1332,   583,     0,   584,
     585,  1333,     0,   586,   587,   588,   589,   590,   591,   592,
     593,     0,   594,  1334,  1335,     0,     0,   597,   598,  1336,
     600,  1337,  1338,   602,   603,   604,   605,   606,   607,   608,
     609,   610,     0,  1339,   611,   612,   613,   614,   615,  1340,
       0,   616,   617,   618,   619,   620,   621,  1341,     0,   623,
     624,   625,   626,   627,   628,     0,     0,   629,     0,     0,
     630,   631,   632,   633,   634,   635,   636,  1342,  1343,  1344,
    1345,   641,  1346,  1347,  1348,  1349,   646,   647,   648,   649,
       0,  1350,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1351,  1352,     0,     0,     0,   234,     0,
    1270,   716,  1354,  1271,  1272,  1273,   777,  1274,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,  1275,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,  1276,   260,
    1277,  1278,     0,   263,   264,   265,   266,   267,   268,   269,
    1279,  1280,   270,   271,  1281,  1282,   274,     0,   275,   276,
     277,   278,  1283,     0,  1284,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   301,  1285,
    1286,  1287,  1288,  1289,  1290,  1291,   303,   304,   305,   306,
     307,   308,  1292,  1293,   311,  1294,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   886,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,     0,   337,   338,
     339,   340,  1295,   342,   343,   344,   345,  1296,  1297,   347,
       0,   348,   349,   350,  1298,   352,     0,   353,     0,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
    1299,     0,  1300,   365,   366,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,     0,   377,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,  1301,  1302,     0,  1303,     0,   395,   396,
     397,   398,   399,  1304,  1305,  1306,  1307,  1308,  1309,  1310,
    1311,  1312,   409,  1313,   411,   412,   413,   414,   415,   416,
     417,     0,     0,   418,  1314,   420,   421,   422,     0,   423,
     424,   425,  1315,  1316,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,  1317,   437,   438,   439,   440,   441,
     442,   443,   444,  1318,   446,  1319,   448,   449,   450,   451,
     452,   453,   454,   455,   456,  1320,   458,  1321,   459,   460,
     461,   462,  1322,  1323,   464,  1324,   466,   467,   468,     0,
     469,   470,   471,     0,     0,  1325,   473,   474,     0,     0,
     475,   476,   477,   478,   479,   480,  1326,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
     494,   495,   496,  1327,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,  1328,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
    3287,   532,   533,   534,   535,   536,   537,   538,   539,  1329,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,  1330,   556,   557,   558,
     559,   560,   561,   562,   563,  1331,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,  1332,   583,     0,   584,   585,  1333,
       0,   586,   587,   588,   589,   590,   591,   592,   593,     0,
     594,  1334,  1335,     0,     0,   597,   598,  1336,   600,  1337,
    1338,   602,   603,   604,   605,   606,   607,   608,   609,   610,
       0,  1339,   611,   612,   613,   614,   615,  1340,     0,   616,
     617,   618,   619,   620,   621,  1341,     0,   623,   624,   625,
     626,   627,   628,     0,     0,   629,     0,     0,   630,   631,
     632,   633,   634,   635,   636,  1342,  1343,  1344,  1345,   641,
    1346,  1347,  1348,  1349,   646,   647,   648,   649,     0,  1350,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1351,  1352,     0,     0,     0,   234,     0,  1270,   716,
    1354,  1271,  1272,  1273,   777,  1274,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
    1275,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,  1276,   260,  1277,  1278,
       0,   263,   264,   265,   266,   267,   268,   269,  1279,  1280,
     270,   271,  1281,  1282,   274,     0,   275,   276,   277,   278,
    1283,     0,  1284,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,   301,  1285,  1286,  1287,
    1288,  1289,  1290,  1291,   303,   304,   305,   306,   307,   308,
    1292,  1293,   311,  1294,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   886,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,     0,   337,   338,   339,   340,
    1295,   342,   343,   344,   345,  1296,  1297,   347,     0,   348,
     349,   350,  1298,   352,     0,   353,     0,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,  1299,     0,
    1300,   365,   366,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,     0,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,  1301,  1302,     0,  1303,     0,   395,   396,   397,   398,
     399,  1304,  1305,  1306,  1307,  1308,  1309,  1310,  1311,  1312,
     409,  1313,   411,   412,   413,   414,   415,   416,   417,     0,
       0,   418,  1314,   420,   421,   422,     0,   423,   424,   425,
    1315,  1316,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,  1317,   437,   438,   439,   440,   441,   442,   443,
     444,  1318,   446,  1319,   448,   449,   450,   451,   452,   453,
     454,   455,   456,  1320,   458,  1321,   459,   460,   461,   462,
    1322,  1323,   464,  1324,   466,   467,   468,     0,   469,   470,
     471,     0,     0,  1325,   473,   474,     0,     0,   475,   476,
     477,   478,   479,   480,  1326,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,   494,   495,
     496,  1327,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,  1328,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,   534,   535,   536,   537,   538,   539,  1329,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,  1330,   556,   557,   558,   559,   560,
     561,   562,   563,  1331,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,  1332,   583,     0,   584,   585,  1333,     0,   586,
     587,   588,   589,   590,   591,   592,   593,     0,   594,  1334,
    1335,     0,     0,   597,   598,  1336,   600,  1337,  1338,   602,
     603,   604,   605,   606,   607,   608,   609,   610,     0,  1339,
     611,   612,   613,   614,   615,  1340,     0,   616,   617,   618,
     619,   620,   621,  1341,  3841,   623,   624,   625,   626,   627,
     628,     0,     0,   629,     0,     0,   630,   631,   632,   633,
     634,   635,   636,  1342,  1343,  1344,  1345,   641,  1346,  1347,
    1348,  1349,   646,   647,   648,   649,     0,  1350,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1351,
    1352,     0,     0,     0,   234,     0,  1270,   716,  1354,  1271,
    1272,  1273,   777,  1274,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,  1275,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,  1276,   260,  1277,  1278,     0,   263,
     264,   265,   266,   267,   268,   269,  1279,  1280,   270,   271,
    1281,  1282,   274,     0,   275,   276,   277,   278,  1283,     0,
    1284,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,   298,   299,   300,   301,  1285,  1286,  1287,  1288,  1289,
    1290,  1291,   303,   304,   305,   306,   307,   308,  1292,  1293,
     311,  1294,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     886,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,     0,   337,   338,   339,   340,  1295,   342,
     343,   344,   345,  1296,  1297,   347,     0,   348,   349,   350,
    1298,   352,     0,   353,     0,   354,   355,   356,  3333,   357,
     358,   359,   360,   361,     0,   362,  1299,     0,  1300,   365,
     366,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,     0,   377,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,  1301,
    1302,     0,  1303,     0,   395,   396,   397,   398,   399,  1304,
    1305,  1306,  1307,  1308,  1309,  1310,  1311,  1312,   409,  1313,
     411,   412,   413,   414,   415,   416,   417,     0,     0,   418,
    1314,   420,   421,   422,     0,   423,   424,   425,  1315,  1316,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
    1317,   437,   438,   439,   440,   441,   442,   443,   444,  1318,
     446,  1319,   448,   449,   450,   451,   452,   453,   454,   455,
     456,  1320,   458,  1321,   459,   460,   461,   462,  1322,  1323,
     464,  1324,   466,   467,   468,     0,   469,   470,   471,     0,
       0,  1325,   473,   474,     0,     0,   475,   476,   477,   478,
     479,   480,  1326,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,   494,   495,   496,  1327,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,  1328,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,   534,
     535,   536,   537,   538,   539,  1329,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,  1330,   556,   557,   558,   559,   560,   561,   562,
     563,  1331,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
    1332,   583,     0,   584,   585,  1333,     0,   586,   587,   588,
     589,   590,   591,   592,   593,     0,   594,  1334,  1335,     0,
       0,   597,   598,  1336,   600,  1337,  1338,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,  1339,   611,   612,
     613,   614,   615,  1340,     0,   616,   617,   618,   619,   620,
     621,  1341,     0,   623,   624,   625,   626,   627,   628,     0,
       0,   629,     0,     0,   630,   631,   632,   633,   634,   635,
     636,  1342,  1343,  1344,  1345,   641,  1346,  1347,  1348,  1349,
     646,   647,   648,   649,     0,  1350,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1351,  1352,     0,
       0,     0,   234,     0,  1270,   716,  1354,  1271,  1272,  1273,
     777,  1274,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,  1275,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,  1276,   260,  1277,  1278,     0,   263,   264,   265,
     266,   267,   268,   269,  1279,  1280,   270,   271,  1281,  1282,
     274,     0,   275,   276,   277,   278,  1283,     0,  1284,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,  1285,  1286,  1287,  1288,  1289,  1290,  1291,
     303,   304,   305,   306,   307,   308,  1292,  1293,   311,  1294,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   886,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,  1295,   342,   343,   344,
     345,  1296,  1297,   347,     0,   348,   349,   350,  1298,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,  1299,     0,  1300,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,  1301,  1302,     0,
    1303,     0,   395,   396,   397,   398,   399,  1304,  1305,  1306,
    1307,  1308,  1309,  1310,  1311,  1312,   409,  1313,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,  1314,   420,
     421,   422,     0,   423,   424,   425,  1315,  1316,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,  1317,   437,
     438,   439,   440,   441,   442,   443,   444,  1318,   446,  1319,
     448,   449,   450,   451,   452,   453,   454,   455,   456,  1320,
     458,  1321,   459,   460,   461,   462,  1322,  1323,   464,  1324,
     466,   467,   468,     0,   469,   470,   471,     0,     0,  1325,
     473,   474,     0,     0,   475,   476,   477,   478,   479,   480,
    1326,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,  1327,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,  1328,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,  1329,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
    1330,   556,   557,   558,   559,   560,   561,   562,   563,  1331,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,  1332,   583,
       0,   584,   585,  1333,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,  1334,  1335,  3390,     0,   597,
     598,  1336,   600,  1337,  1338,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,  1339,   611,   612,   613,   614,
     615,  1340,     0,   616,   617,   618,   619,   620,   621,  1341,
       0,   623,   624,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,  1342,
    1343,  1344,  1345,   641,  1346,  1347,  1348,  1349,   646,   647,
     648,   649,     0,  1350,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1351,  1352,     0,     0,     0,
     234,     0,  1270,   716,  1354,  1271,  1272,  1273,   777,  1274,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,  1275,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
    1276,   260,  1277,  1278,     0,   263,   264,   265,   266,   267,
     268,   269,  1279,  1280,   270,   271,  1281,  1282,   274,     0,
     275,   276,   277,   278,  1283,     0,  1284,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,   298,   299,   300,
     301,  1285,  1286,  1287,  1288,  1289,  1290,  1291,   303,   304,
     305,   306,   307,   308,  1292,  1293,   311,  1294,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   886,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,     0,
     337,   338,   339,   340,  1295,   342,   343,   344,   345,  1296,
    1297,   347,     0,   348,   349,   350,  1298,   352,     0,   353,
       0,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,  1299,     0,  1300,   365,   366,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,     0,   377,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,  1301,  1302,     0,  1303,     0,
     395,   396,   397,   398,   399,  1304,  1305,  1306,  1307,  1308,
    1309,  1310,  1311,  1312,   409,  1313,   411,   412,   413,   414,
     415,   416,   417,     0,     0,   418,  1314,   420,   421,   422,
       0,   423,   424,   425,  1315,  1316,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,  1317,   437,   438,   439,
     440,   441,   442,   443,   444,  1318,   446,  1319,   448,   449,
     450,   451,   452,   453,   454,   455,   456,  1320,   458,  1321,
     459,   460,   461,   462,  1322,  1323,   464,  1324,   466,   467,
     468,     0,   469,   470,   471,     0,     0,  1325,   473,   474,
       0,     0,   475,   476,   477,   478,   479,   480,  1326,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,   494,   495,   496,  1327,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,  1328,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,   534,   535,   536,   537,   538,
     539,  1329,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,  1330,   556,
     557,   558,   559,   560,   561,   562,   563,  1331,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,  1332,   583,     0,   584,
     585,  1333,     0,   586,   587,   588,   589,   590,   591,   592,
     593,     0,   594,  1334,  1335,     0,     0,   597,   598,  1336,
     600,  1337,  1338,   602,   603,   604,   605,   606,   607,   608,
     609,   610,     0,  1339,   611,   612,   613,   614,   615,  1340,
       0,   616,   617,   618,   619,   620,   621,  1341,     0,   623,
     624,   625,   626,   627,   628,     0,     0,   629,     0,     0,
     630,   631,   632,   633,   634,   635,   636,  1342,  1343,  1344,
    1345,   641,  1346,  1347,  1348,  1349,   646,   647,   648,   649,
       0,  1350,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1351,  1352,     0,     0,     0,   234,     0,
    1270,   716,  1354,  1271,  1272,  1273,   777,  1274,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,  1275,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,  1276,   260,
    1277,  1278,     0,   263,   264,   265,   266,   267,   268,   269,
    1279,  1280,   270,   271,  1281,  1282,   274,     0,   275,   276,
     277,   278,  1283,     0,  1284,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   301,  1285,
    1286,  1287,  1288,  1289,  1290,  1291,   303,   304,   305,   306,
     307,   308,  1292,  1293,   311,  1294,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   886,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,     0,   337,   338,
     339,   340,  1295,   342,   343,   344,   345,  1296,  1297,   347,
       0,   348,   349,   350,  1298,   352,     0,   353,     0,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
    1299,     0,  1300,   365,   366,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,     0,   377,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,  1301,  1302,     0,  1303,     0,   395,   396,
     397,   398,   399,  1304,  1305,  1306,  1307,  1308,  1309,  1310,
    1311,  1312,   409,  1313,   411,   412,   413,   414,   415,   416,
     417,     0,     0,   418,  1314,   420,   421,   422,     0,   423,
     424,   425,  1315,  1316,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,  1317,   437,   438,   439,   440,   441,
     442,   443,   444,  1318,   446,  1319,   448,   449,   450,   451,
     452,   453,   454,   455,   456,  1320,   458,  1321,   459,   460,
     461,   462,  1322,  1323,   464,  1324,   466,   467,   468,     0,
     469,   470,   471,     0,     0,  1325,   473,   474,     0,     0,
     475,   476,   477,   478,   479,   480,  1326,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
     494,   495,   496,  1327,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,  1328,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,   534,   535,   536,   537,   538,   539,  1329,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,  1330,   556,   557,   558,
     559,   560,   561,   562,   563,  1331,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,  1332,   583,     0,   584,   585,  1333,
       0,   586,   587,   588,   589,   590,   591,   592,   593,     0,
     594,  1334,  1335,     0,     0,   597,   598,  1336,   600,  1337,
    1338,   602,   603,   604,   605,   606,   607,   608,   609,   610,
       0,  1339,   611,   612,   613,   614,   615,  1340,     0,   616,
     617,   618,   619,   620,   621,  1341,     0,   623,   624,   625,
     626,   627,   628,     0,     0,   629,     0,     0,   630,   631,
     632,   633,   634,   635,   636,  1342,  1343,  1344,  1345,   641,
    1346,  1347,  1348,  1349,   646,   647,   648,   649,     0,  1350,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2699,  2700,     0,     0,     0,   234,     0,  3509,   716,
    1354,  1271,  1272,  1273,   777,  1274,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
    1275,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,  1276,   260,  1277,  1278,
       0,   263,   264,   265,   266,   267,   268,   269,  1279,  1280,
     270,   271,  1281,  1282,   274,     0,   275,   276,   277,   278,
    1283,     0,  1284,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,   301,  1285,  1286,  1287,
    1288,  1289,  1290,  1291,   303,   304,   305,   306,   307,   308,
    1292,  1293,   311,  1294,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   886,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,     0,   337,   338,   339,   340,
    1295,   342,   343,   344,   345,  1296,  1297,   347,     0,   348,
     349,   350,  1298,   352,     0,   353,     0,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,  1299,     0,
    1300,   365,   366,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,     0,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,  1301,  1302,     0,  1303,     0,   395,   396,   397,   398,
     399,  1304,  1305,  1306,  1307,  1308,  1309,  1310,  1311,  1312,
     409,  1313,   411,   412,   413,   414,   415,   416,   417,     0,
       0,   418,  1314,   420,   421,   422,     0,   423,   424,   425,
    1315,  1316,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,  1317,   437,   438,   439,   440,   441,   442,   443,
     444,  1318,   446,  1319,   448,   449,   450,   451,   452,   453,
     454,   455,   456,  1320,   458,  1321,   459,   460,   461,   462,
    1322,  1323,   464,  1324,   466,   467,   468,     0,   469,   470,
     471,     0,     0,  1325,   473,   474,     0,     0,   475,   476,
     477,   478,   479,   480,  1326,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,   494,   495,
     496,  1327,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,  1328,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,   534,   535,   536,   537,   538,   539,  1329,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,  1330,   556,   557,   558,   559,   560,
     561,   562,   563,  1331,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,  1332,   583,     0,   584,   585,  1333,     0,   586,
     587,   588,   589,   590,   591,   592,   593,     0,   594,  1334,
    1335,     0,     0,   597,   598,  1336,   600,  1337,  1338,   602,
     603,   604,   605,   606,   607,   608,   609,   610,     0,  1339,
     611,   612,   613,   614,   615,  1340,     0,   616,   617,   618,
     619,   620,   621,  1341,     0,   623,   624,   625,   626,   627,
     628,     0,     0,   629,     0,     0,   630,   631,   632,   633,
     634,   635,   636,  1342,  1343,  1344,  1345,   641,  1346,  1347,
    1348,  1349,   646,   647,   648,   649,     0,  1350,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1351,
    1352,     0,     0,     0,   234,     0,  1270,   716,  1354,  1271,
    1272,  1273,   777,  1274,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,  1275,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,  1276,   260,  1277,  1278,     0,   263,
     264,   265,   266,   267,   268,   269,  1279,  1280,   270,   271,
    1281,  1282,   274,     0,   275,   276,   277,   278,  1283,     0,
    1284,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,   298,   299,   300,  4864,  1285,  1286,  1287,  1288,  1289,
    1290,  1291,   303,   304,   305,   306,   307,   308,  1292,  1293,
     311,  1294,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     886,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,     0,   337,   338,   339,   340,  1295,   342,
     343,   344,   345,  1296,  1297,   347,     0,   348,   349,   350,
    1298,   352,     0,   353,     0,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,  1299,     0,  1300,   365,
     366,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,     0,   377,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,  1301,
    1302,     0,  1303,     0,   395,   396,   397,   398,   399,  1304,
    1305,  1306,  1307,  1308,  1309,  1310,  1311,  1312,   409,  1313,
     411,   412,   413,   414,   415,   416,   417,     0,     0,   418,
    1314,   420,   421,   422,     0,   423,   424,   425,  1315,  1316,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
    1317,   437,   438,   439,   440,   441,   442,   443,   444,  1318,
     446,  1319,   448,   449,   450,   451,   452,   453,   454,   455,
     456,  1320,   458,  1321,   459,   460,   461,   462,  1322,  1323,
     464,  1324,   466,   467,   468,     0,   469,   470,   471,     0,
       0,  1325,   473,   474,     0,     0,   475,   476,   477,   478,
     479,   480,  1326,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,   494,   495,   496,  1327,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,  1328,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,   534,
     535,   536,   537,   538,   539,  1329,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,  1330,   556,   557,   558,   559,   560,   561,   562,
     563,  1331,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
    1332,   583,     0,   584,   585,  1333,     0,   586,   587,   588,
     589,   590,   591,   592,   593,     0,   594,  1334,  1335,     0,
       0,   597,   598,  1336,   600,  1337,  1338,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,  1339,   611,   612,
     613,   614,   615,  1340,     0,   616,   617,   618,   619,   620,
     621,  1341,     0,   623,   624,   625,   626,   627,   628,     0,
       0,   629,     0,     0,   630,   631,   632,   633,   634,   635,
     636,  1342,  1343,  1344,  1345,   641,  1346,  1347,  1348,  1349,
     646,   647,   648,   649,     0,  1350,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1351,  1352,     0,
       0,     0,   234,     0,  1270,   716,  1354,  1271,  1272,  1273,
     777,  1274,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,  1275,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,  1276,   260,  1277,  1278,     0,   263,   264,   265,
     266,   267,   268,   269,  1279,  1280,   270,   271,  1281,  1282,
     274,     0,   275,   276,   277,   278,  1283,     0,  1284,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,  1285,  1286,  1287,  1288,  1289,  1290,  1291,
     303,   304,   305,   306,   307,   308,  1292,  1293,   311,  1294,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   886,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,  1295,   342,   343,   344,
     345,  1296,  1297,   347,     0,   348,   349,   350,  1298,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,  1299,     0,  1300,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,  1301,  1302,     0,
    1303,     0,   395,   396,   397,   398,   399,  1304,  1305,  1306,
    1307,  1308,  1309,  1310,  1311,  1312,   409,  1313,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,  1314,   420,
     421,   422,     0,   423,   424,   425,  1315,  1316,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,  1317,   437,
     438,   439,   440,   441,   442,   443,   444,  1318,   446,  1319,
     448,   449,   450,   451,   452,   453,   454,   455,   456,  1320,
     458,  1321,   459,   460,   461,   462,  1322,  1323,   464,  1324,
     466,   467,   468,     0,   469,   470,   471,     0,     0,  1325,
     473,   474,     0,     0,   475,   476,   477,   478,   479,   480,
    1326,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,  1327,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,  1328,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,  1329,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
    1330,   556,   557,   558,   559,   560,   561,   562,   563,  1331,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,  1332,   583,
       0,   584,   585,  1333,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,  1334,  1335,     0,     0,   597,
     598,  1336,   600,  1337,  1338,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,  1339,   611,   612,   613,   614,
     615,  1340,     0,   616,   617,   618,   619,   620,   621,  1341,
       0,   623,   624,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,  5248,  1342,
    1343,  1344,  1345,   641,  1346,  1347,  1348,  1349,   646,   647,
     648,   649,     0,  1350,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1351,  1352,     0,     0,     0,
     234,     0,  1270,   716,  1354,  1271,  1272,  1273,   777,  1274,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,  1275,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
    1276,   260,  1277,  1278,     0,   263,   264,   265,   266,   267,
     268,   269,  1279,  1280,   270,   271,  1281,  1282,   274,     0,
     275,   276,   277,   278,  1283,     0,  1284,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,   298,   299,   300,
     301,  1285,  1286,  1287,  1288,  1289,  1290,  1291,   303,   304,
     305,   306,   307,   308,  1292,  1293,   311,  1294,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   886,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,     0,
     337,   338,   339,   340,  1295,   342,   343,   344,   345,  1296,
    1297,   347,     0,   348,   349,   350,  1298,   352,     0,   353,
       0,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,  1299,     0,  1300,   365,   366,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,     0,   377,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,  1301,  1302,     0,  1303,     0,
     395,   396,   397,   398,   399,  1304,  1305,  1306,  1307,  1308,
    1309,  1310,  1311,  1312,   409,  1313,   411,   412,   413,   414,
     415,   416,   417,     0,     0,   418,  1314,   420,   421,   422,
       0,   423,   424,   425,  1315,  1316,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,  1317,   437,   438,   439,
     440,   441,   442,   443,   444,  1318,   446,  1319,   448,   449,
     450,   451,   452,   453,   454,  5260,   456,  1320,   458,  1321,
     459,   460,   461,   462,  1322,  1323,   464,  1324,   466,   467,
     468,     0,   469,   470,   471,     0,     0,  1325,   473,   474,
       0,     0,   475,   476,   477,   478,   479,   480,  1326,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,   494,   495,   496,  1327,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,  1328,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,   534,   535,   536,   537,   538,
     539,  1329,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,  1330,   556,
     557,   558,   559,   560,   561,   562,   563,  1331,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,  1332,   583,     0,   584,
     585,  1333,     0,   586,   587,   588,   589,   590,   591,   592,
     593,     0,   594,  1334,  1335,     0,     0,   597,   598,  1336,
     600,  1337,  1338,   602,   603,   604,   605,   606,   607,   608,
     609,   610,     0,  1339,   611,   612,   613,   614,   615,  1340,
       0,   616,   617,   618,   619,   620,   621,  1341,     0,   623,
     624,   625,   626,   627,   628,     0,     0,   629,     0,     0,
     630,   631,   632,   633,   634,   635,   636,  1342,  1343,  1344,
    1345,   641,  1346,  1347,  1348,  1349,   646,   647,   648,   649,
       0,  1350,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1351,  1352,     0,     0,     0,   234,     0,
    1270,   716,  1354,  1271,  1272,  1273,   777,  1274,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,  1275,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,  1276,   260,
    1277,  1278,     0,   263,   264,   265,   266,   267,   268,   269,
    1279,  1280,   270,   271,  1281,  1282,   274,     0,   275,   276,
     277,   278,  1283,     0,  1284,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,  5599,   301,  1285,
    1286,  1287,  1288,  1289,  1290,  1291,   303,   304,   305,   306,
     307,   308,  1292,  1293,   311,  1294,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   886,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,     0,   337,   338,
     339,   340,  1295,   342,   343,   344,   345,  1296,  1297,   347,
       0,   348,   349,   350,  1298,   352,     0,   353,     0,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
    1299,     0,  5600,   365,   366,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,     0,   377,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,  1301,  1302,     0,  1303,     0,   395,   396,
     397,   398,   399,  1304,  1305,  1306,  1307,  1308,  1309,  1310,
    1311,  1312,   409,  1313,   411,   412,   413,   414,   415,   416,
     417,     0,     0,   418,  1314,   420,   421,   422,     0,   423,
     424,   425,  1315,  1316,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,  1317,   437,   438,   439,   440,   441,
     442,   443,   444,  1318,   446,  1319,   448,   449,   450,   451,
     452,   453,   454,   455,   456,  1320,   458,  1321,   459,   460,
     461,   462,  1322,  1323,   464,  1324,   466,   467,   468,     0,
     469,   470,   471,     0,     0,  1325,   473,   474,     0,     0,
     475,   476,   477,   478,   479,   480,  1326,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
     494,   495,   496,  1327,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,  1328,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,   534,   535,   536,  5601,   538,   539,  1329,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,  1330,   556,   557,   558,
     559,   560,   561,   562,   563,  1331,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,  1332,   583,     0,   584,   585,  1333,
       0,   586,   587,   588,   589,   590,   591,   592,   593,     0,
     594,  1334,  1335,     0,     0,   597,   598,  1336,   600,  1337,
    1338,   602,   603,   604,   605,   606,   607,   608,   609,   610,
       0,  1339,   611,   612,   613,   614,   615,  1340,     0,   616,
     617,   618,   619,   620,   621,  1341,     0,   623,   624,   625,
     626,   627,   628,     0,     0,   629,     0,     0,   630,   631,
     632,   633,   634,   635,   636,  1342,  1343,  1344,  1345,   641,
    1346,  1347,  1348,  1349,   646,   647,   648,   649,     0,  1350,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1351,  1352,     0,     0,     0,   234,     0,  1270,   716,
    5602,  1271,  1272,  1273,   777,  1274,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
    1275,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,  6017,  1276,   260,  1277,  1278,
       0,   263,   264,   265,   266,   267,   268,   269,  1279,  1280,
     270,   271,  1281,  1282,   274,     0,   275,   276,   277,   278,
    1283,     0,  1284,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,  6018,  1285,  1286,  1287,
    1288,  1289,  1290,  1291,   303,   304,   305,   306,   307,   308,
    1292,  1293,   311,  1294,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   886,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,     0,   337,   338,   339,   340,
    1295,   342,   343,   344,   345,  1296,  1297,   347,     0,   348,
     349,   350,  1298,   352,     0,   353,     0,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,  1299,     0,
    1300,   365,   366,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,     0,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,  1301,  1302,     0,  1303,     0,   395,   396,   397,   398,
     399,  1304,  1305,  1306,  1307,  1308,  1309,  1310,  1311,  1312,
     409,  1313,   411,   412,   413,   414,   415,   416,   417,     0,
       0,   418,  1314,   420,   421,   422,     0,   423,   424,   425,
    1315,  1316,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,  1317,   437,   438,   439,   440,   441,   442,   443,
     444,  1318,   446,  1319,   448,   449,   450,   451,   452,   453,
     454,   455,   456,  1320,   458,  1321,   459,   460,   461,   462,
    1322,  1323,   464,  1324,   466,   467,   468,     0,   469,   470,
     471,     0,     0,  1325,   473,   474,     0,     0,   475,   476,
     477,   478,   479,   480,  1326,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,   494,   495,
     496,  1327,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,  1328,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,   534,   535,   536,   537,   538,   539,  1329,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,  1330,   556,   557,   558,   559,   560,
     561,   562,   563,  1331,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,  1332,   583,     0,   584,   585,  1333,     0,   586,
     587,   588,   589,   590,   591,   592,   593,     0,   594,  1334,
    1335,     0,     0,   597,   598,  1336,   600,  1337,  1338,   602,
     603,   604,   605,   606,  6019,   608,   609,   610,     0,  1339,
     611,   612,   613,   614,   615,  1340,     0,   616,   617,   618,
     619,   620,   621,  1341,     0,   623,   624,   625,   626,   627,
     628,     0,     0,   629,     0,     0,   630,   631,   632,   633,
     634,   635,   636,  1342,  1343,  1344,  1345,   641,  1346,  1347,
    1348,  1349,   646,   647,   648,   649,     0,  1350,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1351,
    1352,     0,     0,     0,   234,     0,  1270,   716,  1354,  1271,
    1272,  1273,   777,  1274,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,  1275,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,  1276,   260,  1277,  1278,     0,   263,
     264,   265,   266,   267,   268,   269,  1279,  1280,   270,   271,
    1281,  1282,   274,     0,   275,   276,   277,   278,  1283,     0,
    1284,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,   298,   299,   300,  6018,  1285,  1286,  1287,  1288,  1289,
    1290,  1291,   303,   304,   305,   306,   307,   308,  1292,  1293,
     311,  1294,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     886,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,     0,   337,   338,   339,   340,  1295,   342,
     343,   344,   345,  1296,  1297,   347,     0,   348,   349,   350,
    1298,   352,     0,   353,     0,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,  1299,     0,  1300,   365,
     366,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,     0,   377,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,  1301,
    1302,     0,  1303,     0,   395,   396,   397,   398,   399,  1304,
    1305,  1306,  1307,  1308,  1309,  1310,  1311,  1312,   409,  1313,
     411,   412,   413,   414,   415,   416,   417,     0,     0,   418,
    1314,   420,   421,   422,     0,   423,   424,   425,  1315,  1316,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
    1317,   437,   438,   439,   440,   441,   442,   443,   444,  1318,
     446,  1319,   448,   449,   450,   451,   452,   453,   454,   455,
     456,  1320,   458,  1321,   459,   460,   461,   462,  1322,  1323,
     464,  1324,   466,   467,   468,     0,   469,   470,   471,     0,
       0,  1325,   473,   474,     0,     0,   475,   476,   477,   478,
     479,   480,  1326,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,   494,   495,   496,  1327,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,  1328,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,   534,
     535,   536,   537,   538,   539,  1329,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,  1330,   556,   557,   558,   559,   560,   561,   562,
     563,  1331,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
    1332,   583,     0,   584,   585,  1333,     0,   586,   587,   588,
     589,   590,   591,   592,   593,     0,   594,  1334,  1335,     0,
       0,   597,   598,  1336,   600,  1337,  1338,   602,   603,   604,
     605,   606,  6019,   608,   609,   610,     0,  1339,   611,   612,
     613,   614,   615,  1340,     0,   616,   617,   618,   619,   620,
     621,  1341,     0,   623,   624,   625,   626,   627,   628,     0,
       0,   629,     0,     0,   630,   631,   632,   633,   634,   635,
     636,  1342,  1343,  1344,  1345,   641,  1346,  1347,  1348,  1349,
     646,   647,   648,   649,     0,  1350,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1351,  1352,     0,
       0,     0,   234,     0,  1270,   716,  1354,  1271,  1272,  1273,
     777,  1274,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,  1275,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,  1276,   260,  1277,  1278,     0,   263,   264,   265,
     266,   267,   268,   269,  1279,  1280,   270,   271,  1281,  1282,
     274,     0,   275,   276,   277,   278,  1283,     0,  1284,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,  1285,  1286,  1287,  1288,  1289,  1290,  1291,
     303,   304,   305,   306,   307,   308,  1292,  1293,   311,  5584,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   886,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,  1295,   342,   343,   344,
     345,  1296,  1297,   347,     0,   348,   349,   350,  1298,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,  1299,     0,  1300,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,  1301,  1302,     0,
    1303,     0,   395,   396,   397,   398,   399,  1304,  1305,  1306,
    1307,  1308,  1309,  1310,  1311,  1312,   409,  1313,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,  1314,   420,
     421,   422,     0,   423,   424,   425,  1315,  1316,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,  1317,   437,
     438,   439,   440,   441,   442,   443,   444,  1318,   446,  1319,
     448,   449,   450,   451,   452,   453,   454,   455,   456,  1320,
     458,     0,   459,   460,   461,   462,  1322,  1323,   464,  1324,
     466,   467,   468,     0,   469,   470,   471,     0,     0,  1325,
     473,   474,     0,     0,   475,   476,   477,   478,   479,   480,
    1326,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,  1327,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,  1328,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,  3318,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
    1330,   556,   557,   558,   559,   560,   561,   562,   563,  1331,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,  1332,   583,
       0,   584,   585,  1333,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,  1334,  1335,     0,     0,   597,
     598,  1336,   600,  1337,  1338,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,  1340,     0,   616,   617,   618,   619,   620,   621,  1341,
       0,   623,   624,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,  1342,
    1343,  1344,  1345,   641,  1346,  1347,  1348,  1349,   646,   647,
     648,   649,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3319,  3320,     0,     0,     0,
     234,     0,  1270,   716,  3321,  1271,  1272,  1273,   777,  1274,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,  1275,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257, -2993,
    1276,   260,  1277,  1278,     0,   263,   264,   265,   266,   267,
     268,   269,  1279,  1280,   270,   271,  1281,  1282,   274,     0,
     275,   276,   277,   278,  1283,     0,  1284,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,   298,   299,   300,
    6018,  1285,  1286,  1287,  1288,  1289,  1290,  1291,   303,   304,
     305,   306,   307,   308,  1292,  1293,   311,  1294,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   886,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,     0,
     337,   338,   339,   340,  1295,   342,   343,   344,   345,  1296,
    1297,   347,     0,   348,   349,   350,  1298,   352,     0,   353,
       0,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,  1299,     0,  1300,   365,   366,     0,   367,   368,
     369,   370,   371, -2993,   373,   374,   375,   376,     0,   377,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,  1301,  1302,     0,  1303,     0,
     395,     0,     0,   398,   399,  1304,  1305,  1306,  1307,  1308,
    1309,  1310,  1311,  1312,   409,  1313,   411,   412,   413,   414,
     415,   416,   417,     0,     0,   418,  1314,   420,   421, -2993,
       0,   423,   424,   425,  1315,  1316,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,  1317,   437,   438,   439,
     440,   441,   442,   443,   444,  1318,   446,  1319,   448,   449,
     450,   451,   452,   453,   454,   455,   456,  1320,   458,  1321,
     459,   460,     0,   462,  1322,  1323,   464,  1324,   466,   467,
     468,     0,   469,   470,   471,     0,     0,  1325,   473,   474,
       0,     0,   475,   476,   477,   478,   479,   480,  1326,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,   494,   495,   496,  1327,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,  1328,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,   534,   535,   536,   537,   538,
     539,  1329,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,  1330,   556,
     557,   558,   559,   560, -2993,   562,   563,  1331,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,  1332,   583,     0,   584,
     585,  1333,     0,   586,   587,   588,   589,   590,   591,   592,
     593,     0,   594,  1334,  1335,     0,     0,   597,   598,  1336,
     600,  1337,  1338,   602,   603,   604,   605,   606,  6019,   608,
     609,   610,     0,  1339,   611,   612,   613,   614,   615,  1340,
       0,   616,   617,   618,   619,   620,   621,  1341,     0,   623,
     624,   625,   626,   627,   628,     0,     0,   629,     0,     0,
     630,   631,   632,   633,   634,   635,   636,  1342,  1343,  1344,
    1345,   641,  1346,  1347,  1348,  1349,   646,   647,   648,   649,
       0, -2993,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1351,  1352,     0,     0,     0,   234,     0,
    1270,   716,  1354,  1271,  1272,  1273,   777,  1274,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,  1275,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,  1276,   260,
    1277,  1278,     0,   263,   264,   265,   266,   267,   268,   269,
    1279,  1280,   270,   271,  1281,  1282,   274,     0,   275,   276,
     277,   278,  1283,     0,  1284,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   301,  1285,
    1286,  1287,  1288,  1289,  1290,  1291,   303,   304,   305,   306,
     307,   308,  1292,  1293,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   886,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,     0,   337,   338,
     339,   340,  1295,   342,   343,   344,   345,  1296,  1297,   347,
       0,   348,   349,   350,  1298,   352,     0,   353,     0,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
    1299,     0,  1300,   365,   366,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,     0,   377,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,  1301,  1302,     0,  1303,     0,   395,   396,
     397,   398,   399,  1304,  1305,  1306,  1307,  1308,  1309,  1310,
    1311,  1312,   409,  1313,   411,   412,   413,   414,   415,   416,
     417,     0,     0,   418,  1314,   420,   421,   422,     0,   423,
     424,   425,  1315,  1316,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,  1317,   437,   438,   439,   440,   441,
     442,   443,   444,  1318,   446,  1319,   448,   449,   450,   451,
     452,   453,   454,   455,   456,  1320,   458,     0,   459,   460,
     461,   462,  1322,  1323,   464,  1324,   466,   467,   468,     0,
     469,   470,   471,     0,     0,  1325,   473,   474,     0,     0,
     475,   476,   477,   478,   479,   480,  1326,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
     494,   495,   496,  1327,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,  1328,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,   534,   535,   536,   537,   538,   539,  3318,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,  1330,   556,   557,   558,
     559,   560,   561,   562,   563,  1331,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,  1332,   583,     0,   584,   585,  1333,
       0,   586,   587,   588,   589,   590,   591,   592,   593,     0,
     594,  1334,  1335,     0,     0,   597,   598,  1336,   600,  1337,
    1338,   602,   603,   604,   605,   606,   607,   608,   609,   610,
       0,     0,   611,   612,   613,   614,   615,  1340,     0,   616,
     617,   618,   619,   620,   621,  1341,     0,   623,   624,   625,
     626,   627,   628,     0,     0,   629,     0,     0,   630,   631,
     632,   633,   634,   635,   636,  1342,  1343,  1344,  1345,   641,
    1346,  1347,  1348,  1349,   646,   647,   648,   649,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3319,  3320,   234,     0,  1270,   716,     0,  1271,  1272,
    3321,   777,  1274,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,  1275,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1276,   260,  1277,  1278,     0,   263,   264,
     265,   266,   267,   268,   269,  1279,  1280,   270,   271,  1281,
    1282,   274,     0,   275,   276,   277,   278,  1283,     0,  1284,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
     298,   299,   300,   301,  1285,  1286,  1287,  1288,  1289,  1290,
    1291,   303,   304,   305,   306,   307,   308,  1292,  1293,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   886,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,     0,   337,   338,   339,   340,  1295,   342,   343,
     344,   345,  1296,  1297,   347,     0,   348,   349,   350,  1298,
     352,     0,   353,     0,   354,   355,   356,     0,   357,   358,
     359,   360,   361,     0,   362,  1299,     0,  1300,   365,   366,
       0,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,     0,   377,   378,   379,   380,   381,   382,   383,   384,
       0,   385,   386,   387,   388,   389,   390,   391,  1301,  1302,
       0,  1303,     0,   395,   396,   397,   398,   399,  1304,  1305,
    1306,  1307,  1308,  1309,  1310,  1311,  1312,   409,  1313,   411,
     412,   413,   414,   415,   416,   417,     0,     0,   418,  1314,
     420,   421,   422,     0,   423,   424,   425,  1315,  1316,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,  1317,
     437,   438,   439,   440,   441,   442,   443,   444,  1318,   446,
    1319,   448,   449,   450,   451,   452,   453,   454,   455,   456,
    1320,   458,     0,   459,   460,   461,   462,  1322,  1323,   464,
    1324,   466,   467,   468,     0,   469,   470,   471,     0,     0,
     472,   473,   474,     0,     0,   475,   476,   477,   478,   479,
     480,  1326,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,  1327,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,  1328,   515,   516,   517,
     518,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,   532,   533,   534,   535,
     536,   537,   538,   539,  3498,  3499,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     555,  1330,   556,   557,   558,   559,   560,   561,   562,   563,
    1331,   565,     0,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,  1332,
     583,     0,   584,   585,  1333,     0,   586,   587,   588,   589,
     590,   591,   592,   593,     0,   594,  1334,  1335,     0,     0,
     597,   598,  1336,   600,  1337,  1338,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,     0,   611,   612,   613,
     614,   615,  1340,     0,   616,   617,   618,   619,   620,   621,
    1341,     0,   623,   624,   625,   626,   627,   628,     0,     0,
     629,     0,     0,   630,   631,   632,   633,   634,   635,   636,
    1342,  1343,  1344,  1345,   641,  1346,  1347,  1348,  1349,   646,
     647,   648,   649,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3500,  3501,   234,     0,
    1270,   716,     0,  1271,  1272,  3321,   777,  1274,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,  1275,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,  1276,   260,
    1277,  1278,     0,   263,   264,   265,   266,   267,   268,   269,
    1279,  1280,   270,   271,  1281,  1282,   274,     0,   275,   276,
     277,   278,  1283,     0,  1284,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   301,  1285,
    1286,  1287,  1288,  1289,  1290,  1291,   303,   304,   305,   306,
     307,   308,  1292,  1293,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   886,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,     0,   337,   338,
     339,   340,  1295,   342,   343,   344,   345,  1296,  1297,   347,
       0,   348,   349,   350,  1298,   352,     0,   353,     0,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
    1299,     0,  1300,   365,   366,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,     0,   377,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,  1301,  1302,     0,  1303,     0,   395,   396,
     397,   398,   399,  1304,  1305,  1306,  1307,  1308,  1309,  1310,
    1311,  1312,   409,  1313,   411,   412,   413,   414,   415,   416,
     417,     0,     0,   418,  1314,   420,   421,   422,     0,   423,
     424,   425,  1315,  1316,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,  1317,   437,   438,   439,   440,   441,
     442,   443,   444,  1318,   446,  1319,   448,   449,   450,   451,
     452,   453,   454,   455,   456,  1320,   458,     0,   459,   460,
     461,   462,  1322,  1323,   464,  1324,   466,   467,   468,     0,
     469,   470,   471,     0,     0,   472,   473,   474,     0,     0,
     475,   476,   477,   478,   479,   480,  1326,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
     494,   495,   496,  1327,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,  1328,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,   534,   535,   536,   537,   538,   539,  3318,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,  1330,   556,   557,   558,
     559,   560,   561,   562,   563,  1331,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,  1332,   583,     0,   584,   585,  1333,
       0,   586,   587,   588,   589,   590,   591,   592,   593,     0,
     594,  1334,  1335,     0,     0,   597,   598,  1336,   600,  1337,
    1338,   602,   603,   604,   605,   606,   607,   608,   609,   610,
       0,     0,   611,   612,   613,   614,   615,  1340,     0,   616,
     617,   618,   619,   620,   621,  1341,     0,   623,   624,   625,
     626,   627,   628,     0,     0,   629,     0,     0,   630,   631,
     632,   633,   634,   635,   636,  1342,  1343,  1344,  1345,   641,
    1346,  1347,  1348,  1349,   646,   647,   648,   649,     0,     0,
       0,     0,     0,     0,   234,     0,  1270,   716,     0,  1271,
    1272,     0,   777,  1274,     0,     0,     0,     0,     0,     0,
    3321,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,  1275,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,  1276,   260,  1277,  1278,     0,   263,
    4773,   265,   266,   267,   268,   269,  1279,  1280,   270,   271,
    1281,  1282,   274,     0,   275,   276,   277,   278,  1283,     0,
    1284,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,   298,   299,   300,   301,  1285,  1286,  1287,  1288,  1289,
    1290,  1291,   303,   304,   305,   306,   307,   308,  1292,  1293,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     886,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,     0,   337,   338,   339,   340,  1295,   342,
     343,   344,   345,  1296,  1297,   347,     0,   348,   349,   350,
    1298,   352,     0,   353,     0,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,  1299,     0,  1300,   365,
     366,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,     0,   377,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,  1301,
    1302,     0,  1303,     0,   395,   396,   397,   398,   399,  1304,
    1305,  1306,  1307,  1308,  1309,  1310,  1311,  1312,   409,  1313,
     411,   412,   413,   414,   415,   416,   417,     0,     0,   418,
    1314,   420,   421,   422,     0,   423,   424,   425,  1315,  1316,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
    1317,   437,   438,   439,   440,   441,   442,   443,   444,  1318,
     446,  1319,   448,   449,   450,   451,   452,   453,   454,   455,
     456,  1320,   458,     0,   459,   460,   461,   462,  1322,  1323,
     464,  1324,   466,   467,   468,     0,   469,   470,   471,     0,
       0,   472,   473,   474,     0,     0,   475,   476,   477,   478,
     479,   480,  1326,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,   494,   495,   496,  1327,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,  1328,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,   534,
     535,   536,   537,   538,   539,  3318,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,  1330,   556,   557,   558,   559,   560,   561,   562,
     563,  1331,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
    1332,   583,     0,   584,   585,  1333,     0,   586,   587,   588,
     589,   590,   591,   592,   593,     0,   594,  1334,  1335,     0,
       0,   597,   598,  1336,   600,  1337,  1338,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,     0,   611,   612,
     613,   614,   615,  1340,     0,   616,   617,   618,   619,   620,
     621,  1341,     0,   623,   624,   625,   626,   627,   628,     0,
       0,   629,     0,     0,   630,   631,   632,   633,   634,   635,
     636,  1342,  1343,  1344,  1345,   641,  1346,  1347,  1348,  1349,
     646,   647,   648,   649,     0,     0,     0,     0,     0,     0,
     234,     0,  1270,   716,     0,  1271,  1272,     0,   777,  1274,
       0,     0,     0,     0,     0,     0,  3321,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,  1275,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
    1276,   260,  1277,  1278,     0,   263,   264,   265,   266,   267,
     268,   269,  1279,  1280,   270,   271,  1281,  1282,   274,     0,
     275,   276,   277,   278,  1283,     0,  1284,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,   298,   299,   300,
     301,  1285,  1286,  1287,  1288,  1289,  1290,  1291,   303,   304,
     305,   306,   307,   308,  1292,  1293,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   886,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,     0,
     337,   338,   339,   340,  1295,   342,   343,   344,   345,  1296,
    1297,   347,     0,   348,   349,   350,  1298,   352,     0,   353,
       0,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,  1299,     0,  1300,   365,   366,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,     0,   377,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,  1301,  1302,     0,  1303,     0,
     395,   396,   397,   398,   399,  1304,  1305,  1306,  1307,  1308,
    1309,  1310,  1311,  1312,   409,  1313,   411,   412,   413,   414,
     415,   416,   417,     0,     0,   418,  1314,   420,   421,   422,
       0,   423,   424,   425,  1315,  1316,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,  1317,   437,   438,   439,
     440,   441,   442,   443,   444,  1318,   446,  1319,   448,   449,
     450,   451,   452,   453,   454,   455,   456,  1320,   458,     0,
     459,   460,   461,   462,  1322,  1323,   464,  1324,   466,   467,
     468,     0,   469,   470,   471,     0,     0,   472,   473,   474,
       0,     0,   475,   476,   477,   478,   479,   480,  1326,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,   494,   495,   496,  1327,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,  1328,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,   534,   535,   536,   537,   538,
     539,  3318,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,  1330,   556,
     557,   558,   559,   560,   561,   562,   563,  1331,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,  1332,   583,     0,   584,
     585,  1333,     0,   586,   587,   588,   589,   590,   591,   592,
     593,     0,   594,  1334,  1335,     0,     0,   597,   598,  1336,
     600,  1337,  1338,   602,   603,   604,   605,   606,   607,   608,
     609,   610,     0,     0,   611,   612,   613,   614,   615,  1340,
       0,   616,   617,   618,   619,   620,   621,  1341,     0,   623,
     624,   625,   626,   627,   628,     0,     0,   629,     0,     0,
     630,   631,   632,   633,   634,   635,   636,  1342,  1343,  1344,
    1345,  4833,  1346,  1347,  1348,  1349,   646,   647,   648,   649,
       0,     0,     0,     0,     0,     0,   234,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3321,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,  1280,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
    1283,     0,  1284,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,   301,  1285,  1286,  1287,
    1288,  1289,  1290,  1291,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,     0,   337,   338,   339,   340,
     341,   342,   343,   344,   345,  1296,     0,   347,     0,   348,
     349,   350,   351,   352,     0,   353,     0,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,  1299,     0,
     364,   365,   366,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,     0,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,     0,   395,   396,   397,   398,
     399,  3469,  1305,  1306,  1307,  1308,  1309,  1310,  1311,  1312,
    3470,  1313,   411,   412,   413,   414,   415,   416,   417,  3471,
       0,   418,  1314,   420,   421,   422,     0,   423,   424,   425,
    1315,  1316,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,  1317,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,  1320,   458,     0,   459,   460,   461,   462,
       0,  1323,   464,   465,   466,   467,   468,     0,   469,   470,
     471,     0,   861,   472,   473,   474,     0,     0,   475,   476,
     477,   478,   479,   480,  1326,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,   494,   495,
     496,  1327,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,   534,   535,   536,   537,   538,   539,   540,  3472,   542,
     543,   544,   545,   546,   547,   548,   549,   550,    40,   551,
     552,   553,   554,   555,  1330,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,  1332,   583,     0,   584,   585,  1333,    44,   586,
     587,   588,   589,   590,   591,   592,   593,     0,   594,   595,
     596,     0,     0,   597,   598,  1336,   600,  1337,     0,   602,
     603,   604,   605,   606,   607,   608,   609,   610,     0,     0,
     611,   612,   613,   614,   615,  1340,     0,   616,   617,   618,
     619,   620,  1205,   622,     0,   623,   624,   625,   626,   627,
     628,     0,     0,   629,     0,    49,   630,   631,   632,   633,
     634,   635,   636,  1342,  1343,  1344,  1345,   641,  1346,  1347,
    1348,  1349,  3473,   647,   648,   649,     0,     0,     0,    50,
       0,     0,   234,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3474,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,  1280,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,  1283,     0,  1284,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,  1285,  1286,  1287,  1288,  1289,  1290,  1291,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,  1296,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,  1299,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,   396,   397,   398,   399,  3469,  1305,  1306,
    1307,  1308,  1309,  1310,  1311,  1312,  3470,  1313,   411,   412,
     413,   414,   415,   416,   417,  3471,     0,   418,  1314,   420,
     421,   422,     0,   423,   424,   425,  1315,  1316,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,  1317,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,  1320,
     458,     0,   459,   460,   461,   462,     0,  1323,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,   861,   472,
     473,   474,     0,     0,   475,   476,   477,   478,   479,   480,
    1326,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,  1327,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,  3472,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
    1330,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,  1332,   583,
       0,   584,   585,  1333,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,  1336,   600,  1337,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,  1340,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,  1342,
    1343,  1344,  1345,   641,  1346,  1347,  1348,  1349,  3473,   647,
     648,   649,     0,     0,     0,     0,     0,     0,   234,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3474,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,  1280,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,  1283,     0,  1284,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   301,  1285,
    1286,  1287,  1288,  1289,  1290,  1291,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,     0,   337,   338,
     339,   340,   341,   342,   343,   344,   345,  1296,     0,   347,
       0,   348,   349,   350,   351,   352,     0,   353,     0,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
    1299,     0,   364,   365,   366,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,     0,   377,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,     0,   395,   396,
     397,   398,   399,  3469,  1305,  1306,  1307,  1308,  1309,  1310,
    1311,  1312,   409,  1313,   411,   412,   413,   414,   415,   416,
     417,     0,     0,   418,  1314,   420,   421,   422,     0,   423,
     424,   425,  1315,  1316,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,  1317,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,  1320,   458,     0,   459,   460,
     461,   462,     0,  1323,   464,   465,   466,   467,   468,     0,
     469,   470,   471,     0,     0,   472,   473,   474,     0,     0,
     475,   476,   477,   478,   479,   480,  1326,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
     494,   495,   496,  1327,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,  1330,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,  1332,   583,     0,   584,   585,  1333,
       0,   586,   587,   588,   589,   590,   591,   592,   593,     0,
     594,   595,   596,     0,     0,   597,   598,  1336,   600,  1337,
       0,   602,   603,   604,   605,   606,   607,   608,   609,   610,
       0,     0,   611,   612,   613,   614,   615,  1340,     0,   616,
     617,   618,   619,   620,   621,   622,     0,   623,   624,   625,
     626,   627,   628,     0,     0,   629,     0,     0,   630,   631,
     632,   633,   634,   635,   636,  1342,  1343,  1344,  1345,   641,
    1346,  1347,  1348,  1349,   646,   647,   648,   649,     0,     0,
       0,     0,     0,     0,   234,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3920,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,  1280,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,  1283,     0,
    1284,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,   298,   299,   300,   301,  1285,  1286,  1287,  1288,  1289,
    1290,  1291,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,     0,   337,   338,   339,   340,   341,   342,
     343,   344,   345,  1296,     0,   347,     0,   348,   349,   350,
     351,   352,     0,   353,     0,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,  1299,     0,   364,   365,
     366,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,     0,   377,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,     0,   395,   396,   397,   398,   399,  3469,
    1305,  1306,  1307,  1308,  1309,  1310,  1311,  1312,  3470,  1313,
     411,   412,   413,   414,   415,   416,   417,     0,     0,   418,
    1314,   420,   421,   422,     0,   423,   424,   425,  1315,  1316,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
    1317,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,  1320,   458,     0,   459,   460,   461,   462,     0,  1323,
     464,   465,   466,   467,   468,     0,   469,   470,   471,     0,
       0,   472,   473,   474,     0,     0,   475,   476,   477,   478,
     479,   480,  1326,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,   494,   495,   496,  1327,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,   534,
     535,   536,   537,   538,   539,   540,  3472,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,  1330,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
    1332,   583,     0,   584,   585,  1333,     0,   586,   587,   588,
     589,   590,   591,   592,   593,     0,   594,   595,   596,     0,
       0,   597,   598,  1336,   600,  1337,     0,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,     0,   611,   612,
     613,   614,   615,  1340,     0,   616,   617,   618,   619,   620,
     621,   622,     0,   623,   624,   625,   626,   627,   628,     0,
       0,   629,     0,     0,   630,   631,   632,   633,   634,   635,
     636,  1342,  1343,  1344,  1345,   641,  1346,  1347,  1348,  1349,
    3473,   647,   648,   649,     0,     0,     0,     0,     0,     0,
     234,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    56,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,  1280,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,  1283,     0,  1284,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,   298,   299,   300,
     301,  1285,  1286,  1287,  1288,  1289,  1290,  1291,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,     0,
     337,   338,   339,   340,   341,   342,   343,   344,   345,  1296,
       0,   347,     0,   348,   349,   350,   351,   352,     0,   353,
       0,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,  1299,     0,   364,   365,   366,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,     0,   377,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,     0,
     395,   396,   397,   398,   399,  3469,  1305,  1306,  1307,  1308,
    1309,  1310,  1311,  1312,   409,  1313,   411,   412,   413,   414,
     415,   416,   417,     0,     0,   418,  1314,   420,   421,   422,
       0,   423,   424,   425,  1315,  1316,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,  1317,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,  1320,   458,     0,
     459,   460,   461,   462,     0,  1323,   464,   465,   466,   467,
     468,     0,   469,   470,   471,     0,     0,   472,   473,   474,
       0,     0,   475,   476,   477,   478,   479,   480,  1326,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,   494,   495,   496,  1327,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,  1330,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,  1332,   583,     0,   584,
     585,  1333,     0,   586,   587,   588,   589,   590,   591,   592,
     593,     0,   594,   595,   596,     0,     0,   597,   598,  1336,
     600,  1337,     0,   602,   603,   604,   605,   606,   607,   608,
     609,   610,     0,     0,   611,   612,   613,   614,   615,  1340,
       0,   616,   617,   618,   619,   620,   621,   622,     0,   623,
     624,   625,   626,   627,   628,     0,     0,   629,     0,     0,
     630,   631,   632,   633,   634,   635,   636,  1342,  1343,  1344,
    1345,   641,  1346,  1347,  1348,  1349,   646,   647,   648,   649,
       0,     0,     0,     0,     0,     0,   234,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4919,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,  1280,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
    1283,     0,  1284,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,   301,  1285,  1286,  1287,
    1288,  1289,  1290,  1291,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,     0,   337,   338,   339,   340,
     341,   342,   343,   344,   345,  1296,     0,   347,     0,   348,
     349,   350,   351,   352,     0,   353,     0,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,  1299,     0,
     364,   365,   366,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,     0,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,     0,   395,   396,   397,   398,
     399,  3469,  1305,  1306,  1307,  1308,  1309,  1310,  1311,  1312,
     409,  1313,   411,   412,   413,   414,   415,   416,   417,     0,
       0,   418,  1314,   420,   421,   422,     0,   423,   424,   425,
    1315,  1316,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,  1317,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,  1320,   458,     0,   459,   460,   461,   462,
       0,  1323,   464,   465,   466,   467,   468,     0,   469,   470,
     471,     0,     0,   472,   473,   474,     0,     0,   475,   476,
     477,   478,   479,   480,  1326,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,   494,   495,
     496,  1327,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,  1330,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,  1332,   583,     0,   584,   585,  1333,     0,   586,
     587,   588,   589,   590,   591,   592,   593,     0,   594,   595,
     596,     0,     0,   597,   598,  1336,   600,  1337,     0,   602,
     603,   604,   605,   606,   607,   608,   609,   610,     0,     0,
     611,   612,   613,   614,   615,  1340,     0,   616,   617,   618,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,     0,     0,   629,     0,     0,   630,   631,   632,   633,
     634,   635,   636,  1342,  1343,  1344,  1345,   641,  1346,  1347,
    1348,  1349,   646,   647,   648,   649,     0,     0,     0,     0,
       0,     0,   966,     0,  1602,   716,     0,     0,     0,     0,
     777,     0,     0,     0,     0,     0,     0,     0,  6125,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,     0,   302,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,  5911,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,  1828,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,   420,
     421,   422,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,  1829,     0,   472,
     473,   474,     0,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,  1830,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,     0,     0,     0,     0,     0,     0,   966,     0,
       0,     0,     0,     0,     0,  1603,  1604,  5912,     0,     0,
       0,     0,     0,     0,  5913,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     3,     4,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,   280,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   301,     0,
       0,     0,   302,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,     0,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,     0,   347,
       0,   348,   349,   350,   351,   352,     0,   353,     0,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
     363,     0,   364,   365,   366,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,     0,   377,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,     0,     0,   418,   419,   420,   421,   422,     0,   423,
     424,   425,     0,     0,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,     0,   459,   460,
     461,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   470,   471,     0,     0,   472,   473,   474,     0,     0,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
      40,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,     0,   584,   585,     0,
      44,   586,   587,   588,   589,   590,   591,   592,   593,     0,
     594,   595,   596,     0,     0,   597,   598,   599,   600,   601,
       0,   602,   603,   604,   605,   606,   607,   608,   609,   610,
       0,     0,   611,   612,   613,   614,   615,     0,     0,   616,
     617,   618,   619,   620,  1205,   622,     0,   623,   624,   625,
     626,   627,   628,     0,     0,   629,     0,    49,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,  1045,     0,
       0,    50,     0,     0,   234,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      56,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
     280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,   298,   299,   300,   301,     0,     0,     0,   302,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,     0,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,     0,   347,     0,   348,   349,   350,
     351,   352,     0,   353,     0,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,   363,     0,   364,   365,
     366,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,     0,   377,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,     0,     0,   418,
     419,   420,   421,   422,     0,   423,   424,   425,     0,     0,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,     0,   459,   460,   461,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,   471,     0,
       0,   472,   473,   474,     0,     0,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,     0,   584,   585,     0,     0,   586,   587,   588,
     589,   590,   591,   592,   593,     0,   594,   595,   596,     0,
       0,   597,   598,   599,   600,   601,     0,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,     0,   611,   612,
     613,   614,   615,     0,     0,   616,   617,   618,   619,   620,
     621,   622,     0,   623,   624,   625,   626,   627,   628,     0,
       0,   629,     0,     0,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,     0,     0,     0,     0,     0,     0,
     657,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5656,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,     0,   299,   300,
     301,     0,     0,     0,     0,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,     0,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
       0,   347,     0,   348,   349,   350,   351,   352,     0,   353,
       0,   354,   355,     0,     0,     0,   358,   359,   360,   361,
       0,   362,   363,     0,   364,   365,   366,     0,   367,   368,
     369,   370,   371,     0,   373,   374,   375,   376,     0,   377,
     378,   379,   380,   381,   382,   383,   384,     0,   385,     0,
     387,   388,   389,   390,   391,   392,   393,     0,   394,     0,
     395,     0,     0,   398,     0,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,     0,     0,   418,   419,     0,   421,     0,
       0,   423,   424,   425,     0,     0,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,     0,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,     0,
     459,   460,     0,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,   471,     0,     0,   472,   473,   474,
       0,     0,   475,   476,   477,     0,   479,     0,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,    40,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,     0,   562,   563,   564,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,     0,   584,
     585,     0,    44,   586,     0,   588,   589,   590,   591,   592,
     593,     0,   594,   595,   596,     0,     0,   597,   598,   599,
     600,   601,     0,   602,   603,   604,   605,   606,   607,   608,
     609,   610,     0,     0,   611,   612,   613,   614,   615,     0,
       0,   616,   617,   618,   619,   620,  1205,   622,     0,   623,
       0,   625,   626,   627,   628,     0,     0,   629,     0,    49,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
       0,     0,     0,    50,     0,     0,   657,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    56,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
    2906,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,     0,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,     0,   347,     0,   348,
     349,   350,   351,   352,     0,   353,     0,   354,   355,     0,
       0,     0,   358,   359,   360,   361,     0,   362,   363,     0,
     364,   365,   366,     0,   367,   368,   369,   370,   371,     0,
     373,   374,   375,   376,     0,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,     0,   387,   388,   389,   390,
     391,   392,   393,     0,   394,     0,   395,     0,     0,   398,
       0,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,     0,
       0,   418,   419,     0,   421,     0,     0,   423,   424,   425,
       0,     0,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,     0,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,     0,   459,   460,     0,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
     471,     0,   861,   472,   473,   474,     0,     0,   475,   476,
     477,     0,   479,     0,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
       0,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,     0,   584,   585,     0,  2907,  2908,
       0,   588,   589,   590,   591,   592,   593,     0,   594,   595,
     596,     0,     0,   597,   598,   599,   600,   601,     0,   602,
     603,   604,   605,   606,   607,   608,   609,   610,     0,     0,
     611,   612,   613,   614,   615,     0,     0,   616,   617,   618,
     619,   620,   621,   622,     0,   623,     0,   625,   626,   627,
     628,     0,     0,   629,     0,     0,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,     0,     0,     0,     0,
       0,     0,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1862,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,     0,     0,     0,     0,     0,     0,   657,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1414,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,     0,
     261,   262,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,   278,   279,     0,     0,     0,   281,   282,   283,   284,
     285,   286,     0,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,     0,   299,   300,   301,     0,
       0,     0,     0,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,     0,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,     0,   347,
       0,   348,   349,   350,   351,   352,     0,   353,     0,   354,
     355,     0,     0,     0,   358,   359,   360,   361,     0,   362,
     363,     0,   364,   365,   366,     0,   367,   368,   369,   370,
     371,     0,   373,   374,   375,   376,     0,   377,   378,   379,
     380,   381,   382,   383,   384,     0,   385,     0,   387,   388,
     389,   390,   391,   392,   393,     0,   394,     0,   395,     0,
       0,   398,     0,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,     0,     0,   418,   419,     0,   421,     0,     0,   423,
     424,   425,     0,     0,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,     0,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,     0,   459,   460,
       0,   462,     0,   463,   464,   465,   466,   467,   468,     0,
     469,   470,   471,     0,     0,   472,   473,   474,     0,     0,
     475,   476,   477,     0,   479,     0,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,     0,   562,   563,   564,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,     0,   584,   585,     0,
       0,   586,     0,   588,   589,   590,   591,   592,   593,     0,
     594,   595,   596,     0,     0,   597,   598,   599,   600,   601,
       0,   602,   603,   604,   605,   606,   607,   608,   609,   610,
       0,     0,   611,   612,   613,   614,   615,     0,     0,   616,
     617,   618,   619,   620,   621,   622,     0,   623,     0,   625,
     626,   627,   628,     0,     0,   629,     0,     0,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,     0,     0,
       0,     0,     0,     0,   657,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3532,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,     0,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,     0,   347,     0,   348,   349,   350,
     351,   352,     0,   353,     0,   354,   355,     0,     0,     0,
     358,   359,   360,   361,     0,   362,   363,     0,   364,   365,
     366,     0,   367,   368,   369,   370,   371,     0,   373,   374,
     375,   376,     0,   377,   378,   379,   380,   381,   382,   383,
     384,     0,   385,     0,   387,   388,   389,   390,   391,   392,
     393,     0,   394,     0,   395,     0,     0,   398,     0,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,     0,     0,   418,
     419,     0,   421,     0,     0,   423,   424,   425,     0,     0,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
       0,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,     0,   459,   460,     0,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,   471,     0,
       0,   472,   473,   474,     0,     0,   475,   476,   477,     0,
     479,     0,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,     0,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,     0,   584,   585,     0,     0,   586,     0,   588,
     589,   590,   591,   592,   593,     0,   594,   595,   596,     0,
       0,   597,   598,   599,   600,   601,     0,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,     0,   611,   612,
     613,   614,   615,     0,     0,   616,   617,   618,   619,   620,
     621,   622,     0,   623,     0,   625,   626,   627,   628,     0,
       0,   629,     0,     0,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,     0,     0,     0,     0,     0,     0,
     657,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4208,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,     0,   299,   300,
     301,     0,     0,     0,     0,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,     0,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
       0,   347,     0,   348,   349,   350,   351,   352,     0,   353,
       0,   354,   355,     0,     0,     0,   358,   359,   360,   361,
       0,   362,   363,     0,   364,   365,   366,     0,   367,   368,
     369,   370,   371,     0,   373,   374,   375,   376,     0,   377,
     378,   379,   380,   381,   382,   383,   384,     0,   385,     0,
     387,   388,   389,   390,   391,   392,   393,     0,   394,     0,
     395,     0,     0,   398,     0,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,     0,     0,   418,   419,     0,   421,     0,
       0,   423,   424,   425,     0,     0,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,     0,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,     0,
     459,   460,     0,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,   471,     0,     0,   472,   473,   474,
       0,     0,   475,   476,   477,     0,   479,     0,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,     0,   562,   563,   564,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,     0,   584,
     585,     0,     0,   586,     0,   588,   589,   590,   591,   592,
     593,     0,   594,   595,   596,     0,     0,   597,   598,   599,
     600,   601,     0,   602,   603,   604,   605,   606,   607,   608,
     609,   610,     0,     0,   611,   612,   613,   614,   615,     0,
       0,   616,   617,   618,   619,   620,   621,   622,     0,   623,
       0,   625,   626,   627,   628,     0,     0,   629,     0,     0,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2109,
       0,     0,     0,     0,     0,     0,  2110,     0,     0,  2111,
       0,     0,  4850,  2112,  2113,  2114,  2115,  2116,  2117,  2118,
    2119,  2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,
    2129,  2130,  2131,     0,  2132,  2133,  2134,  2135,  2136,  2137,
    2138,  2139,  2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,
    2148,  2149,  2150,  2151,  2152,  2153,  2154,  2155,  2156,  2157,
    2158,  2159,  2160,  2161,  2162,     0,     0,  2163,  2164,  2165,
    2166,  2167,  2168,  2169,  2170,  2171,  2172,  2173,  2174,  2175,
    2176,  2177,  2178,  2179,  2180,  2181,  2182,  2183,  2184,  2185,
    2186,  2187,  2188,  2189,  2190,     0,  2191,  2192,  2193,  2194,
    2195,  2196,  2197,  2198,  2199,  2200,  2201,  2202,  2203,  2204,
    2205,     0,  2206,  2207,  2208,  2209,  2210,  2211,  2212,  2213,
    2214,  2215,  2216,  2217,  2218,  2219,  2220,  2221,  2222,  2223,
    2224,  2225,  2226,  2227,  2228,  2229,  2230,  2231,  2232,  2233,
    2234,  2235,  2236,  2237,  2238,  2239,  2240,  2241,     0,  2242,
    2243,  2244,  2245,  2246,  2247,  2248,  2249,  2250,  2251,  2252,
    2253,     0,     0,  2254,  2255,  2256,  2257,     0,  2258,  2259,
    2260,  2261,  2262,     0,  2263,  2264,  2265,  2266,  2267,     0,
    2268,  2269,     0,  2270,  2271,  2272,     0,  2273,  2274,     0,
    2275,  2276,  2277,  2278,  2279,  2280,  2281,  2282,  2283,  2284,
    2285,  2286,  2287,  2288,  2289,  2290,  2291,  2292,  2293,  2294,
    2295,  2296,  2297,  2298,  2299,  2300,     0,  2301,     0,  2302,
    2303,  2304,  2305,  2306,  2307,  2308,  2309,  2310,  2311,  2312,
    2313,  2314,  2315,  2316,  2317,  2318,  2319,  2320,  2321,  2322,
    2323,  2324,  2325,  2326,  2327,  2328,  2329,  2330,  2331,     0,
    2332,  2333,  2334,  2335,  2336,  2337,  2338,  2339,  2340,  2341,
    2342,  2343,  2344,  2345,  2346,  2347,  2348,     0,  2349,  2350,
       0,  2351,  2352,  2353,  2354,  2355,  2356,  2357,  2358,  2359,
    2360,  2361,  2362,  2363,  2364,  2365,  2366,  2367,  2368,  2369,
    2370,  2371,  2372,  2373,  2374,  2375,  2376,  2377,  2378,  2379,
       0,  2380,  2381,  2382,     0,  2383,  2384,  2385,  2386,  2387,
       0,  2388,  2389,  2390,  2391,     0,     0,  2392,  2393,  2394,
    2395,  2396,  2397,  2398,  2399,  2400,  2401,  2402,  2403,  2404,
    2405,  2406,  2407,  2408,  2409,  2410,     0,  2411,  2412,  2413,
    2414,  2415,  2416,  2417,  2418,  2419,  2420,  2421,  2422,  2423,
    2424,  2425,  2426,  2427,  2428,  2429,  2430,  2431,  2432,  2433,
    2434,  2435,  2436,  2437,  2438,  2439,  2440,  2441,  2442,  2443,
    2444,     0,  2445,  2446,  2447,  2448,  2449,  2450,  2451,  2452,
    2453,  2454,  2455,  2456,  2457,  2458,  2459,  2460,  2461,     0,
    2462,  2463,  2464,  2465,  2466,  2467,  2468,  2469,  2470,  2471,
    2472,  2473,  2474,  2475,  2476,  2477,  2478,  2479,  2480,  2481,
    2482,  2483,  2484,  2485,  2486,  2487,  2488,  2489,  2490,  2491,
    2492,  2493,  2494,  2495,  2496,  2497,  2498,  2499,  2500,  2501,
    2502,  2503,  2504,  2505,  2506,  2507,  2508,  2509,  2510,  2511,
    2512,  2513,  2514,  2515,     0,  2516,  2517,  2518,  2519,  2520,
    2521,  2522,  2523,  2524,  2525,  2526,  2527,  2528,  2529,  2530,
    2531,     0,  2532,  2533,  2534,  2535,  2536,  2537,  2538,  2539,
    2540,  2541,  2542,  2543,  2544,  2545,  2546,  2547,     0,  2548,
    2549,  2550,  2551,  2552,  2553,     0,  2554,     0,     0,     0,
       0,  2555,  2556,  2557,  2558,  2559,  2560,  2561,  2562,  2563,
    2564,  2565,  2566,  2567,  2568,  2569,     0,  2570,  2571,     0,
    2572,     0,     0,     0,     0,     0,     0,     0,     0,  2573,
    2574,  2575,  2576,  2577,  2578,  2579,  2580,  2581,   878,     0,
    1602,   716,     0,     0,     0,   981,   777,     0,     0,     0,
       0,     0,   982,   983,   984,   235,   236,   237,   238,   239,
     240,   241,   242,   243,  1740,   244,   245,   246,  1741,  1742,
    1743,  1744,  1745,  1746,  1747,   247,   248,   249,  1748,   250,
     251,   252,   253,   254,   255,   256,   257,     0,   879,   260,
     880,   881,  1749,   263,   264,   265,   266,   267,   268,   269,
    1750,  1751,   270,   271,   882,   883,   274,  1752,   275,   276,
     277,   278,     0,  1753,   280,  1754,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,  1755,   292,   293,
     294,   295,   296,   297,  1756,   298,   299,   300,   301,  1757,
    1758,  1759,   302,  1760,  1761,  1762,   303,   304,   305,   306,
     307,   308,   884,   885,   311,  1763,   312,  1764,   313,   314,
     315,   316,   317,   318,   319,  1765,   320,   321,   322,   323,
    1766,  1767,   324,   325,   886,   327,   328,  1768,   329,   330,
     331,   332,  1769,   333,   334,   335,   336,  1770,   337,   338,
     339,   340,     0,   342,   343,   344,   345,     0,  1771,   347,
    1772,   348,   349,   350,   887,   352,  1773,   353,  1774,   354,
     355,   356,  1775,   357,   358,   359,   360,   361,  1776,   362,
       0,  1777,     0,   365,   366,  1778,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,  1779,   377,   378,   379,
     380,   381,   382,   383,   384,  1780,   385,   386,     0,   388,
     389,   390,   391,   888,   889,  1781,   890,  1782,   395,   396,
     397,   398,   399,   891,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   411,   412,   413,   414,   415,   416,
     417,  1783,  1784,   418,     0,   420,   421,   422,  1785,   423,
     424,   425,  1786,  1787,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   437,   438,   439,   440,   441,
     442,   443,   444,   892,   446,   893,   448,   449,   450,   451,
     452,   453,   454,   455,  4533,     0,   458,  1788,   459,   460,
     461,   462,  1789,     0,   464,   894,   466,   467,   468,  1790,
     469,   470,   471,  1791,  1792,  4534,   473,   474,  1793,  1794,
     475,   476,     0,   478,   479,   480,     0,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,  1795,
     494,   495,   496,     0,   498,     0,   500,   501,   502,  1796,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   895,   515,   516,   517,   518,  1797,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
    1798,   532,   533,   534,   535,   536,   537,   538,   539,     0,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
    1799,   551,   552,   553,   554,   555,  1800,   556,   557,  2733,
     559,   560,   561,   562,   563,   897,   565,  1801,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,     0,   583,  1802,   584,   585,  1803,
    1804,   586,   587,   588,   589,   590,   591,   592,   593,  1805,
     594,   898,   899,  1806,  1807,   597,   598,     0,   600,     0,
    1808,   602,   603,   604,   605,   606,   607,   608,   609,   610,
    1809,  1810,   611,   612,   613,   614,   615,  1811,  1812,   616,
     617,   618,   619,   620,     0,   900,  1813,   623,   624,   625,
     626,   627,   628,  1814,  1815,   629,  1816,  1817,   630,   631,
     632,   633,   634,   635,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   647,   648,   649,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   987,   988,
     989,  4535,  4536,   992,   993,   994,   995,   878,     0,  1602,
     716,     0,     0,     0,   981,   777,     0,     0,     0,     0,
       0,   982,   983,   984,   235,   236,   237,   238,   239,   240,
     241,   242,   243,  1740,   244,   245,   246,  1741,  1742,  1743,
    1744,  1745,  1746,  1747,   247,   248,   249,  1748,   250,   251,
     252,   253,   254,   255,   256,   257,     0,   879,   260,   880,
     881,  1749,   263,   264,   265,   266,   267,   268,   269,  1750,
    1751,   270,   271,   882,   883,   274,  1752,   275,   276,   277,
     278,     0,  1753,   280,  1754,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,  1755,   292,   293,   294,
     295,   296,   297,  1756,   298,   299,   300,   301,  1757,  1758,
    1759,   302,  1760,  1761,  1762,   303,   304,   305,   306,   307,
     308,   884,   885,   311,  1763,   312,  1764,   313,   314,   315,
     316,   317,   318,   319,  1765,   320,   321,   322,   323,  1766,
    1767,   324,   325,   886,   327,   328,  1768,   329,   330,   331,
     332,  1769,   333,   334,   335,   336,  1770,   337,   338,   339,
     340,     0,   342,   343,   344,   345,     0,  1771,   347,  1772,
     348,   349,   350,   887,   352,  1773,   353,  1774,   354,   355,
     356,  1775,   357,   358,   359,   360,   361,  1776,   362,     0,
    1777,     0,   365,   366,  1778,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,  1779,   377,   378,   379,   380,
     381,   382,   383,   384,  1780,   385,   386,     0,   388,   389,
     390,   391,   888,   889,  1781,   890,  1782,   395,   396,   397,
     398,   399,   891,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   411,   412,   413,   414,   415,   416,   417,
    1783,  1784,   418,     0,   420,   421,   422,  1785,   423,   424,
     425,  1786,  1787,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   437,   438,   439,   440,   441,   442,
     443,   444,   892,   446,   893,   448,   449,   450,   451,   452,
     453,   454,   455,  4990,     0,   458,  1788,   459,   460,   461,
     462,  1789,     0,   464,   894,   466,   467,   468,  1790,   469,
     470,   471,  1791,  1792,  4534,   473,   474,  1793,  1794,   475,
     476,     0,   478,   479,   480,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,  1795,   494,
     495,   496,     0,   498,     0,   500,   501,   502,  1796,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     895,   515,   516,   517,   518,  1797,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,  1798,
     532,   533,   534,   535,   536,   537,   538,   539,     0,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,  1799,
     551,   552,   553,   554,   555,  1800,   556,   557,  2733,   559,
     560,   561,   562,   563,   897,   565,  1801,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,     0,   583,  1802,   584,   585,  1803,  1804,
     586,   587,   588,   589,   590,   591,   592,   593,  1805,   594,
     898,   899,  1806,  1807,   597,   598,     0,   600,     0,  1808,
     602,   603,   604,   605,   606,   607,   608,   609,   610,  1809,
    1810,   611,   612,   613,   614,   615,  1811,  1812,   616,   617,
     618,   619,   620,     0,   900,  1813,   623,   624,   625,   626,
     627,   628,  1814,  1815,   629,  1816,  1817,   630,   631,   632,
     633,   634,   635,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   647,   648,   649,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   987,   988,   989,
    4535,  4536,   992,   993,   994,   995,   657,     0,     0,     0,
       0,     0,     0,   981,     0,     0,     0,     0,     0,     0,
     982,   983,   984,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,   985,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
       0,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,     0,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,     0,   986,     0,   348,
     349,   350,   351,   352,     0,   353,     0,   354,   355,     0,
       0,     0,   358,   359,   360,   361,     0,   362,   363,     0,
     364,   365,   366,     0,   367,   368,   369,   370,   371,     0,
     373,   374,   375,   376,     0,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,     0,   387,   388,   389,   390,
     391,   392,   393,     0,   394,     0,   395,     0,     0,   398,
       0,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,     0,
       0,   418,   419,     0,   421,     0,     0,   423,   424,   425,
       0,     0,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,     0,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,     0,   459,   460,     0,   462,
       0,   463,   464,   465,   466,   467,   468,     0,   469,   470,
     471,     0,     0,   472,   473,   474,     0,     0,   475,   476,
     477,     0,   479,     0,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
       0,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,     0,   584,   585,     0,     0,   586,
       0,   588,   589,   590,   591,   592,   593,     0,   594,   595,
     596,     0,     0,   597,   598,   599,   600,   601,     0,   602,
     603,   604,   605,   606,   607,   608,   609,   610,     0,     0,
     611,   612,   613,   614,   615,     0,     0,   616,   617,   618,
     619,   620,   621,   622,     0,   623,     0,   625,   626,   627,
     628,     0,     0,   629,     0,     0,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   987,   988,   989,   990,
     991,   992,   993,   994,   995,   657,     0,     0,     0,     0,
       0,     0,   981,     0,     0,     0,     0,     0,     0,   982,
     983,   984,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,  1102,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,     0,   299,   300,   301,     0,     0,     0,     0,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,   332,     0,
     333,   334,   335,   336,     0,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,     0,  1103,     0,   348,   349,
     350,   351,   352,     0,   353,     0,   354,   355,     0,     0,
       0,   358,   359,   360,   361,     0,   362,   363,     0,   364,
     365,   366,     0,   367,   368,   369,   370,   371,     0,   373,
     374,   375,   376,     0,   377,   378,   379,   380,   381,   382,
     383,   384,     0,   385,     0,   387,   388,   389,   390,   391,
     392,   393,     0,   394,     0,   395,     0,     0,   398,     0,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,     0,     0,
     418,   419,     0,   421,     0,     0,   423,   424,   425,     0,
       0,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,     0,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,   462,     0,
     463,   464,   465,   466,   467,   468,     0,   469,   470,   471,
       0,     0,   472,   473,   474,     0,     0,   475,   476,   477,
       0,   479,     0,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,     0,
     562,   563,   564,   565,     0,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,     0,   584,   585,     0,     0,   586,     0,
     588,   589,   590,   591,   592,   593,     0,   594,   595,   596,
       0,     0,   597,   598,   599,   600,   601,     0,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,     0,   611,
     612,   613,   614,   615,     0,     0,   616,   617,   618,   619,
     620,   621,   622,     0,   623,     0,   625,   626,   627,   628,
       0,     0,   629,     0,     0,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   987,   988,   989,   990,   991,
     992,   993,   994,   995,   657,     0,     0,     0,     0,     0,
       0,   981,     0,     0,     0,     0,     0,     0,   982,   983,
     984,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,  1168,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,     0,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,     0,  1169,     0,   348,   349,   350,
     351,   352,     0,   353,     0,   354,   355,     0,     0,     0,
     358,   359,   360,   361,     0,   362,   363,     0,   364,   365,
     366,     0,   367,   368,   369,   370,  1170,     0,   373,   374,
     375,   376,     0,   377,   378,   379,   380,   381,   382,   383,
     384,     0,   385,     0,   387,   388,   389,   390,   391,   392,
     393,     0,   394,     0,   395,     0,     0,   398,     0,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,     0,     0,   418,
     419,     0,   421,     0,     0,   423,   424,   425,     0,     0,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
       0,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,     0,   459,   460,     0,   462,     0,   463,
     464,   465,   466,   467,   468,     0,   469,   470,   471,     0,
       0,   472,   473,   474,     0,     0,   475,   476,   477,     0,
     479,     0,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,     0,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,     0,   584,   585,     0,     0,   586,     0,   588,
     589,   590,   591,   592,   593,     0,   594,   595,   596,     0,
       0,   597,   598,   599,   600,   601,     0,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,     0,   611,   612,
     613,   614,   615,     0,     0,   616,   617,   618,   619,   620,
     621,   622,     0,   623,     0,   625,   626,   627,   628,     0,
       0,   629,     0,     0,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   657,     0,     0,     0,     0,     0,     0,
     981,     0,     0,     0,     0,     0,     0,   982,   983,   984,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,  1845,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
       0,   299,   300,   301,     0,     0,     0,     0,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,   332,     0,   333,   334,
     335,   336,     0,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,     0,  1846,     0,   348,   349,   350,   351,
     352,     0,   353,     0,   354,   355,     0,     0,     0,   358,
     359,   360,   361,     0,   362,   363,     0,   364,   365,   366,
       0,   367,   368,   369,   370,   371,     0,   373,   374,   375,
     376,     0,   377,   378,   379,   380,   381,   382,   383,   384,
       0,   385,     0,   387,   388,   389,   390,   391,   392,   393,
       0,   394,     0,   395,     0,     0,   398,     0,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,     0,     0,   418,   419,
       0,   421,     0,     0,   423,   424,   425,     0,     0,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,     0,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,     0,   459,   460,     0,   462,     0,   463,   464,
     465,   466,   467,   468,     0,   469,   470,   471,     0,     0,
     472,   473,   474,     0,     0,   475,   476,   477,     0,   479,
       0,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,   532,   533,     0,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,     0,   562,   563,
     564,   565,     0,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,     0,   584,   585,     0,     0,   586,     0,   588,   589,
     590,   591,   592,   593,     0,   594,   595,   596,     0,     0,
     597,   598,   599,   600,   601,     0,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,     0,   611,   612,   613,
     614,   615,     0,     0,   616,   617,   618,   619,   620,   621,
     622,     0,   623,     0,   625,   626,   627,   628,     0,     0,
     629,     0,     0,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   987,   988,   989,   990,   991,   992,   993,
     994,   995,   657,     0,     0,     0,     0,     0,     0,   981,
       0,     0,     0,     0,     0,     0,   982,   983,   984,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   987,   988,   989,   990,   991,   992,   993,   994,
     995,   657,     0,     0,     0,     0,     0,     0,   981,     0,
       0,     0,     0,     0,     0,   982,   983,   984,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,  3597,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,     0,   299,
     300,   301,     0,     0,     0,     0,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
       0,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,     0,  3598,     0,   348,   349,   350,   351,   352,     0,
     353,     0,   354,   355,     0,     0,     0,   358,   359,   360,
     361,     0,   362,   363,     0,   364,   365,   366,     0,   367,
     368,   369,   370,   371,     0,   373,   374,   375,   376,     0,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
       0,   387,   388,   389,   390,   391,   392,   393,     0,   394,
       0,   395,     0,     0,   398,     0,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,     0,     0,   418,   419,     0,   421,
       0,     0,   423,   424,   425,     0,     0,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,     0,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,     0,   462,     0,   463,   464,   465,   466,
     467,   468,     0,   469,   470,   471,     0,     0,   472,   473,
     474,     0,     0,   475,   476,   477,     0,   479,     0,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,     0,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,     0,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,     0,
     584,   585,     0,     0,   586,     0,   588,   589,   590,   591,
     592,   593,     0,   594,   595,   596,     0,     0,   597,   598,
     599,   600,   601,     0,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,     0,   611,   612,   613,   614,   615,
       0,     0,   616,   617,   618,   619,   620,   621,   622,     0,
     623,     0,   625,   626,   627,   628,     0,     0,   629,     0,
       0,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   987,   988,   989,   990,   991,   992,   993,   994,   995,
     657,     0,     0,     0,     0,     0,     0,   981,     0,     0,
       0,     0,     0,     0,   982,   983,   984,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,     0,   261,   262,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,   278,   279,     0,     0,     0,   281,   282,
     283,   284,   285,   286,     0,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,     0,   299,   300,
     301,     0,     0,     0,     0,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,     0,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
       0,   347,     0,   348,   349,   350,   351,   352,     0,   353,
       0,   354,   355,     0,     0,     0,   358,   359,   360,   361,
       0,   362,   363,     0,   364,   365,   366,     0,   367,   368,
     369,   370,   371,     0,   373,   374,   375,   376,     0,   377,
     378,   379,   380,   381,   382,   383,   384,     0,   385,     0,
     387,   388,   389,   390,   391,   392,   393,     0,   394,     0,
     395,     0,     0,   398,     0,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,     0,     0,   418,   419,     0,   421,     0,
       0,   423,   424,   425,     0,     0,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,     0,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,     0,
     459,   460,     0,   462,     0,   463,   464,   465,   466,   467,
     468,     0,   469,   470,   471,     0,     0,  5638,   473,   474,
       0,     0,   475,   476,   477,     0,   479,     0,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,     0,   562,   563,   564,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,     0,   584,
     585,     0,     0,   586,     0,   588,   589,   590,   591,   592,
     593,     0,   594,   595,   596,     0,     0,   597,   598,   599,
     600,   601,     0,   602,   603,   604,   605,   606,   607,   608,
     609,   610,     0,     0,   611,   612,   613,   614,   615,     0,
       0,   616,   617,   618,   619,   620,   621,   622,     0,   623,
       0,   625,   626,   627,   628,     0,     0,   629,     0,     0,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
       0,     0,  1739,     0,     0,     0,     0,     0,     0,     0,
     987,   988,   989,   990,   991,   992,   993,   994,   995,   235,
     236,   237,   238,   239,   240,   241,   242,   243,  1740,   244,
     245,   246,  1741,  1742,  1743,  1744,  1745,  1746,  1747,   247,
     248,   249,  1748,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,  1749,   263,   264,   265,
     266,   267,   268,   269,  1750,  1751,   270,   271,   272,   273,
     274,  1752,   275,   276,   277,   278,   279,  1753,   280,  1754,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,  1755,   292,   293,   294,   295,   296,   297,  1756,   298,
     299,   300,   301,  1757,  1758,  1759,   302,  1760,  1761,  1762,
     303,   304,   305,   306,   307,   308,   309,   310,   311,  1763,
     312,  1764,   313,   314,   315,   316,   317,   318,   319,  1765,
     320,   321,   322,   323,  1766,  1767,   324,   325,   326,   327,
     328,  1768,   329,   330,   331,   332,  1769,   333,   334,   335,
     336,  1770,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,  1771,   347,  1772,   348,   349,   350,   351,   352,
    1773,   353,  1774,   354,   355,   356,  1775,   357,   358,   359,
     360,   361,  1776,   362,   363,  1777,   364,   365,   366,  1778,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
    1779,   377,   378,   379,   380,   381,   382,   383,   384,  1780,
     385,   386,   387,   388,   389,   390,   391,   392,   393,  1781,
     394,  1782,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,  1783,  1784,   418,   419,   420,
     421,   422,  1785,   423,   424,   425,  1786,  1787,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,  1788,   459,   460,   461,   462,  1789,   463,   464,   465,
     466,   467,   468,  1790,   469,   470,   471,  1791,  1792,   472,
     473,   474,  1793,  1794,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,  1795,   494,   495,   496,   497,   498,   499,
     500,   501,   502,  1796,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
    1797,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,  1798,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,  1799,   551,   552,   553,   554,   555,
    1800,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,  1801,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
    1802,   584,   585,  1803,  1804,   586,   587,   588,   589,   590,
     591,   592,   593,  1805,   594,   595,   596,  1806,  1807,   597,
     598,   599,   600,   601,  1808,   602,   603,   604,   605,   606,
     607,   608,   609,   610,  1809,  1810,   611,   612,   613,   614,
     615,  1811,  1812,   616,   617,   618,   619,   620,   621,   622,
    1813,   623,   624,   625,   626,   627,   628,  1814,  1815,   629,
    1816,  1817,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1818,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   867,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  6093,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  6095,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   878,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  6222,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,     0,   879,   260,   880,   881,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   882,   883,
     274,     0,   275,   276,   277,   278,     0,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,     0,   302,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   884,   885,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   886,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,     0,   342,   343,   344,
     345,     0,     0,   347,     0,   348,   349,   350,   887,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,     0,     0,     0,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
    2729,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,  2730,   388,   389,   390,   391,   888,   889,     0,
     890,     0,   395,   396,   397,   398,   399,   891,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,     0,   420,
     421,   422,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   437,
     438,   439,   440,   441,   442,   443,   444,   892,   446,   893,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     458,     0,   459,   460,   461,   462,     0,     0,   464,   894,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,  2731,   475,   476,  2732,   478,   479,   480,
       0,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,     0,   498,     0,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   895,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,     0,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,  2733,   559,   560,   561,   562,   563,   897,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,     0,   583,
       0,   584,   585,     0,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,   898,   899,     0,     0,   597,
     598,     0,   600,     0,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,     0,   900,
    2734,   623,   624,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,     0,     0,
       0,  3957,     0,     0,     0,     0,     0,     0,     0,   647,
     648,   649,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,  2735,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
       0,   879,   260,   880,   881,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   882,   883,   274,
       0,   275,   276,   277,   278,     0,     0,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,   301,     0,     0,     0,   302,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   884,   885,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   886,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
       0,   337,   338,   339,   340,     0,   342,   343,   344,   345,
       0,     0,   347,     0,   348,   349,   350,   887,   352,     0,
     353,     0,   354,   355,   356,     0,   357,   358,   359,   360,
     361,     0,   362,     0,     0,     0,   365,   366,     0,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,  2729,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,  2730,   388,   389,   390,   391,   888,   889,     0,   890,
       0,   395,   396,   397,   398,   399,   891,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   411,   412,   413,
     414,   415,   416,   417,     0,     0,   418,     0,   420,   421,
     422,     0,   423,   424,   425,     0,     0,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,     0,   437,   438,
     439,   440,   441,   442,   443,   444,   892,   446,   893,   448,
     449,   450,   451,   452,   453,   454,   455,     0,     0,   458,
       0,   459,   460,   461,   462,     0,     0,   464,   894,   466,
     467,   468,     0,   469,   470,   471,     0,     0,   472,   473,
     474,     0,  2731,   475,   476,  2732,   478,   479,   480,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,     0,   498,     0,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   895,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,   534,   535,   536,   537,
     538,   539,     0,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,     0,
     556,   557,  2733,   559,   560,   561,   562,   563,   897,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,     0,   583,     0,
     584,   585,     0,     0,   586,   587,   588,   589,   590,   591,
     592,   593,     0,   594,   898,   899,     0,     0,   597,   598,
       0,   600,     0,     0,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,     0,   611,   612,   613,   614,   615,
       0,     0,   616,   617,   618,   619,   620,     0,   900,  2734,
     623,   624,   625,   626,   627,   628,     0,     0,   629,     0,
       0,   630,   631,   632,   633,   634,   635,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   647,   648,
     649,   966,     0,  1602,   716,     0,     0,     0,     0,   777,
       0,     0,     0,     0,     0,     0,  2735,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,   301,     0,     0,     0,   302,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,  2620,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
       0,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,  1828,   347,     0,   348,   349,   350,   351,   352,     0,
     353,     0,   354,   355,   356,     0,   357,   358,   359,   360,
     361,     0,   362,   363,     0,   364,   365,   366,     0,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,     0,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,   392,   393,     0,   394,
       0,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,     0,     0,   418,   419,   420,   421,
     422,     0,   423,   424,   425,     0,     0,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,     0,   463,   464,   465,   466,
     467,   468,     0,   469,   470,   471,  1829,     0,   472,   473,
     474,     0,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,     0,
     584,   585,     0,     0,   586,   587,   588,   589,   590,   591,
     592,   593,     0,   594,   595,   596,     0,     0,   597,   598,
     599,   600,   601,  1830,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,     0,   611,   612,   613,   614,   615,
       0,     0,   616,   617,   618,   619,   620,   621,   622,     0,
     623,   624,   625,   626,   627,   628,     0,     0,   629,     0,
       0,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   966,     0,  1602,   716,     0,     0,     0,     0,   777,
       0,     0,     0,     0,  1603,  1604,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,   301,     0,     0,     0,   302,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,  2625,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
       0,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,  1828,   347,     0,   348,   349,   350,   351,   352,     0,
     353,     0,   354,   355,   356,     0,   357,   358,   359,   360,
     361,     0,   362,   363,     0,   364,   365,   366,     0,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,     0,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,   392,   393,     0,   394,
       0,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,     0,     0,   418,   419,   420,   421,
     422,     0,   423,   424,   425,     0,     0,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,     0,   463,   464,   465,   466,
     467,   468,     0,   469,   470,   471,  1829,     0,   472,   473,
     474,     0,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,     0,
     584,   585,     0,     0,   586,   587,   588,   589,   590,   591,
     592,   593,     0,   594,   595,   596,     0,     0,   597,   598,
     599,   600,   601,  1830,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,     0,   611,   612,   613,   614,   615,
       0,     0,   616,   617,   618,   619,   620,   621,   622,     0,
     623,   624,   625,   626,   627,   628,     0,     0,   629,     0,
       0,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   966,     0,  1602,   716,     0,     0,     0,     0,   777,
       0,     0,     0,     0,  1603,  1604,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,   301,     0,     0,     0,   302,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,  3564,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
       0,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,  1828,   347,     0,   348,   349,   350,   351,   352,     0,
     353,     0,   354,   355,   356,     0,   357,   358,   359,   360,
     361,     0,   362,   363,     0,   364,   365,   366,     0,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,     0,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,   392,   393,     0,   394,
       0,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,     0,     0,   418,   419,   420,   421,
     422,     0,   423,   424,   425,     0,     0,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,     0,   463,   464,   465,   466,
     467,   468,     0,   469,   470,   471,  1829,     0,   472,   473,
     474,     0,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,     0,
     584,   585,     0,     0,   586,   587,   588,   589,   590,   591,
     592,   593,     0,   594,   595,   596,     0,     0,   597,   598,
     599,   600,   601,  1830,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,     0,   611,   612,   613,   614,   615,
       0,     0,   616,   617,   618,   619,   620,   621,   622,     0,
     623,   624,   625,   626,   627,   628,     0,     0,   629,     0,
       0,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   966,     0,  1602,   716,     0,     0,     0,     0,   777,
       0,     0,     0,     0,  1603,  1604,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,   301,     0,     0,     0,   302,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
       0,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,  1828,   347,     0,   348,   349,   350,   351,   352,     0,
     353,     0,   354,   355,   356,     0,   357,   358,   359,   360,
     361,     0,   362,   363,     0,   364,   365,   366,     0,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,     0,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,   392,   393,     0,   394,
       0,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,     0,     0,   418,   419,   420,   421,
     422,     0,   423,   424,   425,     0,     0,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,     0,   463,   464,   465,   466,
     467,   468,     0,   469,   470,   471,  1829,     0,   472,   473,
     474,     0,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,     0,
     584,   585,     0,     0,   586,   587,   588,   589,   590,   591,
     592,   593,     0,   594,   595,   596,     0,     0,   597,   598,
     599,   600,   601,  1830,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,     0,   611,   612,   613,   614,   615,
       0,     0,   616,   617,   618,   619,   620,   621,   622,     0,
     623,   624,   625,   626,   627,   628,     0,     0,   629,     0,
       0,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   657,     0,     0,     0,     0,     0,     0,     0,   777,
       0,     0,     0,     0,  1603,  1604,     0,     0,   235,   236,
     778,   238,   239,   240,   241,   242,   243,   779,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   780,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,     0,   299,
     300,   301,     0,     0,     0,     0,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
       0,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,     0,   347,     0,   348,   349,   781,   351,   352,     0,
     353,     0,   354,   782,     0,   783,     0,   358,   359,   360,
     361,     0,   362,   363,     0,   364,   365,   366,     0,   367,
     368,   369,   370,   371,     0,   373,   374,   375,   376,   784,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
       0,   387,   388,   389,   390,   391,   392,   393,     0,   394,
       0,   395,     0,     0,   398,     0,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   785,     0,     0,   418,   419,     0,   421,
       0,     0,   423,   424,   425,     0,     0,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,     0,   447,   448,
     449,   786,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,     0,   462,     0,   463,   464,   465,   466,
     467,   468,     0,   469,   470,   471,     0,     0,   472,   473,
     474,     0,     0,   475,   476,   477,     0,   479,     0,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   787,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   788,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,     0,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,     0,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,     0,
     584,   585,     0,     0,   586,     0,   588,   589,   590,   591,
     592,   593,     0,   594,   595,   596,     0,     0,   597,   598,
     599,   600,   601,     0,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,     0,   611,   612,   613,   614,   615,
       0,     0,   616,   617,   618,   619,   620,   621,   622,     0,
     623,     0,   625,   626,   627,   628,     0,     0,   629,     0,
       0,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   966,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   789,   790,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     3,     4,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,   301,     0,     0,     0,   302,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,   332,     0,   333,   334,   335,   336,
       0,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,     0,   347,     0,   348,   349,   350,   351,   352,     0,
     353,     0,   354,   355,   356,     0,   357,   358,   359,   360,
     361,     0,   362,   363,     0,   364,   365,   366,     0,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,     0,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,   392,   393,     0,   394,
       0,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,     0,     0,   418,   419,   420,   421,
     422,     0,   423,   424,   425,     0,     0,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   462,     0,   463,   464,   465,   466,
     467,   468,     0,   469,   470,   471,     0,     0,   472,   473,
     474,     0,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,     0,
     584,   585,     0,     0,   586,   587,   588,   589,   590,   591,
     592,   593,     0,   594,   595,   596,     0,     0,   597,   598,
     599,   600,   601,     0,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,     0,   611,   612,   613,   614,   615,
       0,     0,   616,   617,   618,   619,   620,   621,   622,     0,
     623,   624,   625,   626,   627,   628,     0,     0,   629,     0,
       0,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,  1045,  1739,     0,  6411,   716,     0,     0,     0,     0,
     777,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,  1740,   244,
     245,   246,  1741,  1742,  1743,  1744,  1745,  1746,  1747,   247,
     248,   249,  1748,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,  1749,   263,   264,   265,
     266,   267,   268,   269,  1750,  1751,   270,   271,   272,   273,
     274,  1752,   275,   276,   277,   278,   279,  1753,   280,  1754,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,  1755,   292,   293,   294,   295,   296,   297,  1756,   298,
     299,   300,   301,  1757,  1758,  1759,   302,  1760,  1761,  1762,
     303,   304,   305,   306,   307,   308,   309,   310,   311,  1763,
     312,  1764,   313,   314,   315,   316,   317,   318,   319,  1765,
     320,   321,   322,   323,  1766,  1767,   324,   325,   326,   327,
     328,  1768,   329,   330,   331,   332,  1769,   333,   334,   335,
     336,  1770,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,  1771,   347,  1772,   348,   349,   350,   351,   352,
    1773,   353,  1774,   354,   355,   356,  1775,   357,   358,   359,
     360,   361,  1776,   362,   363,  1777,   364,   365,   366,  1778,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
    1779,   377,   378,   379,   380,   381,   382,   383,   384,  1780,
     385,   386,   387,   388,   389,   390,   391,   392,   393,  1781,
     394,  1782,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,  1783,  1784,   418,   419,   420,
     421,   422,  1785,   423,   424,   425,  1786,  1787,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,  1788,   459,   460,   461,   462,  1789,   463,   464,   465,
     466,   467,   468,  1790,   469,   470,   471,  1791,  1792,   472,
     473,   474,  1793,  1794,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,  1795,   494,   495,   496,   497,   498,   499,
     500,   501,   502,  1796,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
    1797,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,  1798,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,  1799,   551,   552,   553,   554,   555,
    1800,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,  1801,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
    1802,   584,   585,  1803,  1804,   586,   587,   588,   589,   590,
     591,   592,   593,  1805,   594,   595,   596,  1806,  1807,   597,
     598,   599,   600,   601,  1808,   602,   603,   604,   605,   606,
     607,   608,   609,   610,  1809,  1810,   611,   612,   613,   614,
     615,  1811,  1812,   616,   617,   618,   619,   620,   621,   622,
    1813,   623,   624,   625,   626,   627,   628,  1814,  1815,   629,
    1816,  1817,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,  1739,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,  1740,   244,
     245,   246,  1741,  1742,  1743,  1744,  1745,  1746,  1747,   247,
     248,   249,  1748,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,  1749,   263,   264,   265,
     266,   267,   268,   269,  1750,  1751,   270,   271,   272,   273,
     274,  1752,   275,   276,   277,   278,   279,  1753,   280,  1754,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,  1755,   292,   293,   294,   295,   296,   297,  1756,   298,
     299,   300,   301,  1757,  1758,  1759,   302,  1760,  1761,  1762,
     303,   304,   305,   306,   307,   308,   309,   310,   311,  1763,
     312,  1764,   313,   314,   315,   316,   317,   318,   319,  1765,
     320,   321,   322,   323,  1766,  1767,   324,   325,   326,   327,
     328,  1768,   329,   330,   331,   332,  1769,   333,   334,   335,
     336,  1770,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,  1771,   347,  1772,   348,   349,   350,   351,   352,
    1773,   353,  1774,   354,   355,   356,  1775,   357,   358,   359,
     360,   361,  1776,   362,   363,  1777,   364,   365,   366,  1778,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
    1779,   377,   378,   379,   380,   381,   382,   383,   384,  1780,
     385,   386,   387,   388,   389,   390,   391,   392,   393,  1781,
     394,  1782,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,  1783,  1784,   418,   419,   420,
     421,   422,  1785,   423,   424,   425,  1786,  1787,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,  1788,   459,   460,   461,   462,  1789,   463,   464,   465,
     466,   467,   468,  1790,   469,   470,   471,  1791,  1792,   472,
     473,   474,  1793,  1794,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,  1795,   494,   495,   496,   497,   498,   499,
     500,   501,   502,  1796,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
    1797,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,  1798,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,  1799,   551,   552,   553,   554,   555,
    1800,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,  1801,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
    1802,   584,   585,  1803,  1804,   586,   587,   588,   589,   590,
     591,   592,   593,  1805,   594,   595,   596,  1806,  1807,   597,
     598,   599,   600,   601,  1808,   602,   603,   604,   605,   606,
     607,   608,   609,   610,  1809,  1810,   611,   612,   613,   614,
     615,  1811,  1812,   616,   617,   618,   619,   620,   621,   622,
    1813,   623,   624,   625,   626,   627,   628,  1814,  1815,   629,
    1816,  1817,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,  1739,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,  3672,   241,   242,   243,  1740,   244,
     245,   246,  1741,  1742,  1743,  1744,  1745,  1746,  1747,   247,
     248,   249,  1748,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,  1749,   263,   264,   265,
     266,   267,   268,   269,  1750,  1751,   270,   271,   272,   273,
     274,  1752,   275,   276,   277,   278,   279,  1753,   280,  1754,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,  1755,   292,   293,   294,   295,   296,   297,  1756,   298,
     299,   300,   301,  1757,  1758,  1759,   302,  1760,  1761,  1762,
     303,   304,   305,   306,   307,   308,   309,   310,   311,  1763,
     312,  1764,   313,   314,   315,   316,   317,   318,   319,  1765,
     320,   321,   322,   323,  1766,  1767,   324,   325,   326,  3673,
     328,  1768,   329,   330,   331,   332,  1769,   333,   334,   335,
     336,  1770,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,  1771,   347,  1772,   348,   349,   350,   351,   352,
    1773,   353,  1774,   354,   355,   356,  1775,   357,   358,   359,
     360,   361,  1776,   362,   363,  1777,   364,   365,   366,  1778,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
    1779,   377,   378,   379,   380,   381,   382,   383,   384,  1780,
     385,   386,   387,   388,   389,   390,   391,   392,   393,  1781,
     394,  1782,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,  1783,  1784,   418,   419,   420,
     421,   422,  1785,   423,   424,   425,  1786,  1787,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,  1788,   459,   460,   461,   462,  1789,   463,   464,   465,
     466,   467,   468,  1790,   469,   470,   471,  1791,  1792,   472,
     473,   474,  1793,  1794,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,  1795,   494,   495,   496,   497,   498,   499,
     500,   501,   502,  1796,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
    1797,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,  1798,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,  1799,   551,   552,   553,   554,   555,
    1800,  3674,   557,   558,   559,   560,   561,   562,   563,   564,
     565,  1801,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
    1802,   584,   585,  1803,  1804,   586,   587,   588,   589,   590,
     591,   592,   593,  1805,   594,   595,   596,  1806,  1807,   597,
     598,   599,   600,   601,  1808,   602,   603,   604,   605,   606,
     607,   608,   609,   610,  1809,  1810,   611,   612,   613,   614,
     615,  1811,  1812,   616,   617,   618,   619,   620,   621,   622,
    1813,   623,   624,   625,   626,   627,   628,  1814,  1815,   629,
    1816,  1817,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   234,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,  1280,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,  1283,     0,  1284,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,  1285,  1286,  1287,  1288,  1289,  1290,  1291,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,  1296,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,  1299,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,   396,   397,   398,   399,  3469,  1305,  1306,
    1307,  1308,  1309,  1310,  1311,  1312,   409,  1313,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,  1314,   420,
     421,   422,     0,   423,   424,   425,  1315,  1316,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,  1317,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,  1320,
     458,     0,   459,   460,   461,   462,     0,  1323,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,   478,   479,   480,
    1326,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,  1327,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
    1330,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,  1332,   583,
       0,   584,   585,  1333,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,  1336,   600,  1337,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,  1340,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,  1342,
    1343,  1344,  1345,   641,  1346,  1347,  1348,  1349,   646,   647,
     648,   649,   234,     0,  1270,   716,     0,  1271,  1272,     0,
     777,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,  1276,   260,  1277,  1278,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,  1281,  1282,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,     0,   302,     0,     0,     0,
     303,   304,   305,   306,   307,   308,  1292,  1293,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   886,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,  1297,   347,     0,   348,   349,   350,  1298,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,  1301,  1302,     0,
    1303,     0,   395,   396,   397,   398,   399,  6385,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,   420,
     421,   422,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,  1318,   446,  1319,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   462,  1322,   463,   464,  1324,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,  1328,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,  1331,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,  1334,  1335,     0,     0,   597,
     598,   599,   600,   601,  1338,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,  1341,
       0,   623,   624,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   966,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,  1005,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,   967,   302,     0,     0,   968,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,   420,
     421,   422,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
     969,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   966,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,  1026,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,   967,   302,     0,     0,   968,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,   420,
     421,   422,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,  1027,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
     969,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   966,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,   967,   302,     0,     0,   968,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,   420,
     421,   422,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
     969,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,  3002,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   966,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,   967,   302,     0,     0,   968,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,  4028,   364,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,   420,
     421,   422,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
     969,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   966,     0,     0,   716,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,     0,   302,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,  1828,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,   420,
     421,   422,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,  1829,     0,   472,
     473,   474,     0,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,  1830,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   966,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,   967,   302,     0,     0,   968,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,   420,
     421,   422,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
     969,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   966,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,   967,   302,     0,     0,   968,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,   420,
     421,   422,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,  1121,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
     969,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   966,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,   967,   302,     0,     0,   968,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  1163,   372,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,   420,
     421,   422,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
     969,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   966,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,   967,   302,     0,     0,   968,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  1176,   372,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,   420,
     421,   422,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
     969,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   966,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,   967,   302,     0,     0,   968,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  1188,   372,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,   420,
     421,   422,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,  1189,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
     969,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   966,     0,     0,   716,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,     0,   302,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,  2605,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,   420,
     421,   422,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   966,     0,     0,   716,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,     0,   302,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,   420,
     421,   422,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   234,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,     0,   302,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,   420,
     421,   422,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   234,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,     0,   302,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  1147,   372,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,   420,
     421,   422,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   234,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,     0,   302,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  1160,   372,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,   420,
     421,   422,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   234,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,     0,   302,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  1174,   372,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,   420,
     421,   422,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   234,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,     0,   302,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  1178,   372,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,   420,
     421,   422,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   966,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,     0,   302,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,   420,
     421,   422,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,  2834,   275,   276,   277,   278,   279,     0,     0,  2835,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,  2836,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,  2837,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,  2838,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  2839,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,  2840,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,  2841,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,  2834,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,  2836,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,  2837,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,  2838,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,  3891,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,  2840,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,  2841,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   796,   244,
     797,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   798,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,   829,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     799,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   800,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   796,   244,
     797,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   798,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,  3571,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     799,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   800,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,  2834,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,  2836,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,  2837,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,  2838,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,  2840,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,  2841,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   796,   244,
     797,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   798,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     799,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   800,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,  3078,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,  2906,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,   861,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,  2907,  2908,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,  2006,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,  2007,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,  2008,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,  2009,   354,   355,     0,     0,     0,  2010,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,  2011,  2012,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,  2013,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,  2014,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,  2015,   539,   540,   541,   542,   543,   544,  2016,   546,
     547,   548,   549,   550,     0,  2017,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,  2018,   586,     0,  2019,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,  2020,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     797,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,   798,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     799,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   800,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,  2906,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,   861,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,  2907,  2908,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,  1019,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  1020,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,   861,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,  3653,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,  3654,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,  3666,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,  3667,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   658,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   707,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   708,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   821,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   822,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   823,   596,     0,     0,   824,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   855,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   856,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   857,   596,     0,     0,   858,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,   861,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,   921,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   976,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   977,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,  1139,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,  1389,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,  1400,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   841,   271,   272,   273,
    1401,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   844,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   845,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   846,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,  1393,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   848,   596,     0,     0,   849,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   850,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  1546,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,   861,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,  1607,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  1608,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   821,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,  3418,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,  3419,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,  3420,   586,     0,   588,   589,  3421,
     591,  3422,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,  3423,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,   716,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
     777,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,  4246,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,  4260,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,  4406,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,  4931,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,  5004,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,  5365,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   813,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   819,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   841,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   842,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   843,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   844,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   845,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   846,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   847,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   848,   596,     0,     0,   849,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   850,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   873,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  1001,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  1011,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  1014,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  1030,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  1087,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  1092,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  1109,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  1112,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  1114,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  1152,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  1180,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  1182,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  1192,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  1195,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  1198,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   841,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   844,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   845,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   846,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,  1393,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   848,   596,     0,     0,   849,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   850,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  1871,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  1905,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  1907,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  1947,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  1949,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  1951,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,  2045,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,  2721,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,     0,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   841,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   844,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   845,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   846,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,  1393,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,  2755,   589,   590,
     591,   592,   593,     0,   594,   848,   596,     0,     0,   849,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   850,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   841,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   844,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   845,   536,
     537,   538,   539,   540,   541,   542,   543,   544,  2817,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,  2818,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   848,   596,     0,     0,  2819,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   850,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   841,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   844,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   845,   536,
     537,   538,   539,   540,   541,   542,   543,   544,  2903,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,  2818,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   848,   596,     0,     0,  2819,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   850,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   841,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   844,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   845,   536,
     537,   538,   539,   540,   541,   542,   543,   544,  2927,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,  2818,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   848,   596,     0,     0,  2819,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   850,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  3123,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  3127,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  3185,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  3576,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   841,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   844,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   845,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   846,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,  2818,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   848,   596,     0,     0,  2819,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   850,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  3634,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  3656,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  3658,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  3810,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,  3852,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,  5119,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,   365,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
    6350,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,     0,   348,   349,   350,   351,   352,
       0,   353,     0,   354,   355,     0,     0,     0,   358,   359,
     360,   361,     0,   362,   363,     0,   364,     0,   366,     0,
     367,   368,   369,   370,   371,     0,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,     0,   387,   388,   389,   390,   391,   392,   393,     0,
     394,     0,   395,     0,     0,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,   419,     0,
     421,     0,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,     0,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,     0,   459,   460,     0,   462,     0,   463,   464,   465,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,   477,     0,   479,     0,
     481,   482,   483,   484,   485,   486,   487,   488,     0,   490,
     491,   492,   493,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,     0,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,     0,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
       0,   584,   585,     0,     0,   586,     0,   588,   589,   590,
     591,   592,   593,     0,   594,   595,   596,     0,     0,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,   621,   622,
       0,   623,     0,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   878,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,     0,   879,   260,   880,   881,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   882,   883,
     274,     0,   275,   276,   277,   278,     0,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,     0,   302,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   884,   885,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   886,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,     0,   342,   343,   344,
     345,     0,     0,   347,     0,   348,   349,   350,   887,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,     0,     0,     0,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
    2729,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,  2730,   388,   389,   390,   391,   888,   889,     0,
     890,     0,   395,   396,   397,   398,   399,   891,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,     0,   420,
     421,   422,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   437,
     438,   439,   440,   441,   442,   443,   444,   892,   446,   893,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     458,     0,   459,   460,   461,   462,     0,     0,   464,   894,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,  2732,   478,   479,   480,
       0,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,     0,   498,     0,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   895,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,     0,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,  2733,   559,   560,   561,   562,   563,   897,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,     0,   583,
       0,   584,   585,     0,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,   898,   899,     0,     0,   597,
     598,     0,   600,     0,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,     0,   900,
    2734,   623,   624,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   878,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   647,
     648,   649,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,     0,   879,   260,
     880,   881,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   882,   883,   274,     0,   275,   276,
     277,   278,     0,     0,   280,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   301,     0,
       0,     0,   302,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   884,   885,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   886,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,     0,   337,   338,
     339,   340,     0,   342,   343,   344,   345,     0,     0,   347,
       0,   348,   349,   350,   887,   352,     0,   353,     0,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
       0,     0,     0,   365,   366,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,     0,   377,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,     0,   388,
     389,   390,   391,   888,   889,     0,   890,     0,   395,   396,
     397,   398,   399,   891,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   411,   412,   413,   414,   415,   416,
     417,     0,     0,   418,     0,   420,   421,   422,     0,   423,
     424,   425,     0,     0,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   437,   438,   439,   440,   441,
     442,   443,   444,   892,   446,   893,   448,   449,   450,   451,
     452,   453,   454,   455,     0,     0,   458,     0,   459,   460,
     461,   462,  2813,     0,   464,   894,   466,   467,   468,     0,
     469,   470,   471,     0,     0,   472,   473,   474,     0,     0,
     475,   476,     0,   478,   479,   480,     0,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
     494,   495,   496,     0,   498,     0,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   895,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,   534,   535,   536,   537,   538,   539,     0,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,     0,   556,   557,  2733,
     559,   560,   561,   562,   563,   897,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,     0,   583,     0,   584,   585,     0,
    4634,   586,   587,   588,   589,   590,   591,   592,   593,     0,
     594,   898,   899,     0,     0,   597,   598,     0,   600,     0,
       0,   602,   603,   604,   605,   606,   607,   608,   609,   610,
       0,     0,   611,   612,   613,   614,   615,     0,     0,   616,
     617,   618,   619,   620,     0,   900,     0,   623,   624,   625,
     626,   627,   628,     0,     0,   629,     0,     0,   630,   631,
     632,   633,   634,   635,   878,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   647,   648,   649,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,     0,   879,   260,   880,   881,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     882,   883,   274,     0,   275,   276,   277,   278,     0,     0,
     280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,   298,   299,   300,   301,     0,     0,     0,   302,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   884,   885,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     886,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,     0,   337,   338,   339,   340,     0,   342,
     343,   344,   345,     0,     0,   347,     0,   348,   349,   350,
     887,   352,     0,   353,     0,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,     0,     0,     0,   365,
     366,     0,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,     0,   377,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,     0,   388,   389,   390,   391,   888,
     889,     0,   890,     0,   395,   396,   397,   398,   399,   891,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     411,   412,   413,   414,   415,   416,   417,     0,     0,   418,
       0,   420,   421,   422,     0,   423,   424,   425,     0,     0,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   437,   438,   439,   440,   441,   442,   443,   444,   892,
     446,   893,   448,   449,   450,   451,   452,   453,   454,   455,
    2893,     0,   458,     0,   459,   460,   461,   462,     0,     0,
     464,   894,   466,   467,   468,     0,   469,   470,   471,     0,
       0,   472,   473,   474,     0,     0,   475,   476,     0,   478,
     479,   480,     0,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,   494,   495,   496,     0,
     498,     0,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   895,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,   534,
     535,   536,   537,   538,   539,     0,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   896,   559,   560,   561,   562,
     563,   897,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
       0,   583,     0,   584,   585,     0,     0,   586,   587,   588,
     589,   590,   591,   592,   593,     0,   594,   898,   899,     0,
       0,   597,   598,     0,   600,     0,     0,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,     0,   611,   612,
     613,   614,   615,     0,     0,   616,   617,   618,   619,   620,
       0,   900,     0,   623,   624,   625,   626,   627,   628,     0,
       0,   629,     0,     0,   630,   631,   632,   633,   634,   635,
     878,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   647,   648,   649,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,     0,
     879,   260,   880,   881,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   882,   883,   274,     0,
     275,   276,   277,   278,     0,     0,   280,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,   298,   299,   300,
     301,     0,     0,     0,   302,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   884,   885,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   886,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,     0,
     337,   338,   339,   340,     0,   342,   343,   344,   345,     0,
       0,   347,     0,   348,   349,   350,   887,   352,     0,   353,
       0,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,     0,     0,     0,   365,   366,     0,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,     0,   377,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
       0,   388,   389,   390,   391,   888,   889,     0,   890,     0,
     395,   396,   397,   398,   399,   891,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   411,   412,   413,   414,
     415,   416,   417,     0,     0,   418,     0,   420,   421,   422,
       0,   423,   424,   425,     0,     0,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   437,   438,   439,
     440,   441,   442,   443,   444,   892,   446,   893,   448,   449,
     450,   451,   452,   453,   454,   455,  4428,     0,   458,     0,
     459,   460,   461,   462,     0,     0,   464,   894,   466,   467,
     468,     0,   469,   470,   471,     0,     0,   472,   473,   474,
       0,     0,   475,   476,     0,   478,   479,   480,     0,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,   494,   495,   496,     0,   498,     0,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   895,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,   534,   535,   536,   537,   538,
     539,     0,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   896,   559,   560,   561,   562,   563,   897,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,     0,   583,     0,   584,
     585,     0,     0,   586,   587,   588,   589,   590,   591,   592,
     593,     0,   594,   898,   899,     0,     0,   597,   598,     0,
     600,     0,     0,   602,   603,   604,   605,   606,   607,   608,
     609,   610,     0,     0,   611,   612,   613,   614,   615,     0,
       0,   616,   617,   618,   619,   620,     0,   900,     0,   623,
     624,   625,   626,   627,   628,     0,     0,   629,     0,     0,
     630,   631,   632,   633,   634,   635,   878,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   647,   648,   649,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,     0,   879,   260,   880,   881,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   882,   883,   274,     0,   275,   276,   277,   278,
       0,     0,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,   301,     0,     0,     0,
     302,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     884,   885,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   886,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,     0,   337,   338,   339,   340,
       0,   342,   343,   344,   345,     0,     0,   347,     0,   348,
     349,   350,   887,   352,  6037,   353,     0,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,     0,     0,
       0,   365,   366,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,     0,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,     0,   388,   389,   390,
     391,   888,   889,     0,   890,     0,   395,   396,   397,   398,
     399,   891,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   411,   412,   413,   414,   415,   416,   417,     0,
       0,   418,     0,   420,   421,   422,     0,   423,   424,   425,
       0,     0,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   437,   438,   439,   440,   441,   442,   443,
     444,   892,   446,   893,   448,   449,   450,   451,   452,   453,
     454,   455,     0,     0,   458,     0,   459,   460,   461,   462,
       0,     0,   464,   894,   466,   467,   468,     0,   469,   470,
     471,     0,     0,   472,   473,   474,     0,     0,   475,   476,
       0,   478,   479,   480,     0,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,   494,   495,
     496,     0,   498,     0,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   895,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,   534,   535,   536,   537,   538,   539,     0,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   896,   559,   560,
     561,   562,   563,   897,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,     0,   583,     0,   584,   585,     0,     0,   586,
     587,   588,   589,   590,   591,   592,   593,     0,   594,   898,
     899,     0,     0,   597,   598,     0,   600,     0,     0,   602,
     603,   604,   605,   606,   607,   608,   609,   610,     0,     0,
     611,   612,   613,   614,   615,     0,     0,   616,   617,   618,
     619,   620,     0,   900,     0,   623,   624,   625,   626,   627,
     628,     0,     0,   629,     0,     0,   630,   631,   632,   633,
     634,   635,   878,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   647,   648,   649,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,     0,   879,   260,   880,   881,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   882,   883,
     274,     0,   275,   276,   277,   278,     0,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,     0,   302,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   884,   885,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   886,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,     0,   342,   343,   344,
     345,     0,     0,   347,     0,   348,   349,   350,   887,   352,
    6393,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,     0,     0,     0,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,     0,   388,   389,   390,   391,   888,   889,     0,
     890,     0,   395,   396,   397,   398,   399,   891,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,     0,   420,
     421,   422,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   437,
     438,   439,   440,   441,   442,   443,   444,   892,   446,   893,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     458,     0,   459,   460,   461,   462,     0,     0,   464,   894,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,     0,   478,   479,   480,
       0,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,     0,   498,     0,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   895,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,     0,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   896,   559,   560,   561,   562,   563,   897,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,     0,   583,
       0,   584,   585,     0,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,   898,   899,     0,     0,   597,
     598,     0,   600,     0,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,     0,   900,
       0,   623,   624,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   878,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   647,
     648,   649,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,     0,   879,   260,
     880,   881,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,   882,   883,   274,     0,   275,   276,
     277,   278,     0,     0,   280,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   301,     0,
       0,     0,   302,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   884,   885,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   886,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,     0,   337,   338,
     339,   340,     0,   342,   343,   344,   345,     0,     0,   347,
       0,   348,   349,   350,   887,   352,     0,   353,     0,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
       0,     0,     0,   365,   366,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,     0,   377,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,     0,   388,
     389,   390,   391,   888,   889,     0,   890,     0,   395,   396,
     397,   398,   399,   891,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   411,   412,   413,   414,   415,   416,
     417,     0,     0,   418,     0,   420,   421,   422,     0,   423,
     424,   425,     0,     0,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   437,   438,   439,   440,   441,
     442,   443,   444,   892,   446,   893,   448,   449,   450,   451,
     452,   453,   454,   455,     0,     0,   458,     0,   459,   460,
     461,   462,     0,     0,   464,   894,   466,   467,   468,     0,
     469,   470,   471,     0,     0,   472,   473,   474,     0,     0,
     475,   476,     0,   478,   479,   480,     0,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
     494,   495,   496,     0,   498,     0,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   895,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,   534,   535,   536,   537,   538,   539,     0,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   896,
     559,   560,   561,   562,   563,   897,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,     0,   583,     0,   584,   585,     0,
       0,   586,   587,   588,   589,   590,   591,   592,   593,     0,
     594,   898,   899,     0,     0,   597,   598,     0,   600,     0,
       0,   602,   603,   604,   605,   606,   607,   608,   609,   610,
       0,     0,   611,   612,   613,   614,   615,     0,     0,   616,
     617,   618,   619,   620,     0,   900,     0,   623,   624,   625,
     626,   627,   628,     0,     0,   629,     0,     0,   630,   631,
     632,   633,   634,   635,   878,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   647,   648,   649,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,     0,   879,   260,   880,   881,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     882,   883,   274,     0,   275,   276,   277,   278,     0,     0,
     280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,   298,   299,   300,   301,     0,     0,     0,   302,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   884,   885,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     886,   327,   328,     0,   329,   330,   331,   332,     0,   333,
     334,   335,   336,     0,   337,   338,   339,   340,     0,   342,
     343,   344,   345,     0,     0,   347,     0,   348,   349,   350,
     887,   352,     0,   353,     0,   354,   355,   356,     0,   357,
     358,   359,   360,   361,     0,   362,     0,     0,     0,   365,
     366,     0,   367,   368,   369,   370,  1154,   372,   373,   374,
     375,   376,     0,   377,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,     0,   388,   389,   390,   391,   888,
     889,     0,   890,     0,   395,   396,   397,   398,   399,   891,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     411,   412,   413,   414,   415,   416,   417,     0,     0,   418,
       0,   420,   421,   422,     0,   423,   424,   425,     0,     0,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   437,   438,   439,   440,   441,   442,   443,   444,   892,
     446,   893,   448,   449,   450,   451,   452,   453,   454,   455,
       0,     0,   458,     0,   459,   460,   461,   462,     0,     0,
     464,   894,   466,   467,   468,     0,   469,   470,   471,     0,
       0,   472,   473,   474,     0,     0,   475,   476,     0,   478,
     479,   480,     0,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,   494,   495,   496,     0,
     498,     0,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   895,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,   534,
     535,   536,   537,   538,   539,     0,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   896,   559,   560,   561,   562,
     563,   897,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
       0,   583,     0,   584,   585,     0,     0,   586,   587,   588,
     589,   590,   591,   592,   593,     0,   594,   898,   899,     0,
       0,   597,   598,     0,   600,     0,     0,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,     0,   611,   612,
     613,   614,   615,     0,     0,   616,   617,   618,   619,   620,
       0,   900,     0,   623,   624,   625,   626,   627,   628,     0,
       0,   629,     0,     0,   630,   631,   632,   633,   634,   635,
     878,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   647,   648,   649,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,     0,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,     0,
     879,   260,   880,   881,     0,   263,   264,   265,   266,   267,
     268,   269,     0,     0,   270,   271,   882,   883,   274,     0,
     275,   276,   277,   278,     0,     0,   280,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,   298,   299,   300,
     301,     0,     0,     0,   302,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   884,   885,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   886,   327,   328,     0,
     329,   330,   331,   332,     0,   333,   334,   335,   336,     0,
     337,   338,   339,   340,     0,   342,   343,   344,   345,     0,
       0,   347,     0,   348,   349,   350,   887,   352,     0,   353,
       0,   354,   355,   356,     0,   357,   358,   359,   360,   361,
       0,   362,     0,     0,     0,   365,   366,     0,   367,   368,
     369,   370,  1186,   372,   373,   374,   375,   376,     0,   377,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
       0,   388,   389,   390,   391,   888,   889,     0,   890,     0,
     395,   396,   397,   398,   399,   891,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   411,   412,   413,   414,
     415,   416,   417,     0,     0,   418,     0,   420,   421,   422,
       0,   423,   424,   425,     0,     0,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   437,   438,   439,
     440,   441,   442,   443,   444,   892,   446,   893,   448,   449,
     450,   451,   452,   453,   454,   455,     0,     0,   458,     0,
     459,   460,   461,   462,     0,     0,   464,   894,   466,   467,
     468,     0,   469,   470,   471,     0,     0,   472,   473,   474,
       0,     0,   475,   476,     0,   478,   479,   480,     0,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,   494,   495,   496,     0,   498,     0,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   895,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,   534,   535,   536,   537,   538,
     539,     0,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   896,   559,   560,   561,   562,   563,   897,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,     0,   583,     0,   584,
     585,     0,     0,   586,   587,   588,   589,   590,   591,   592,
     593,     0,   594,   898,   899,     0,     0,   597,   598,     0,
     600,     0,     0,   602,   603,   604,   605,   606,   607,   608,
     609,   610,     0,     0,   611,   612,   613,   614,   615,     0,
       0,   616,   617,   618,   619,   620,     0,   900,     0,   623,
     624,   625,   626,   627,   628,     0,     0,   629,     0,     0,
     630,   631,   632,   633,   634,   635,   878,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   647,   648,   649,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,     0,   879,   260,   880,   881,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   882,   883,   274,     0,   275,   276,   277,   278,
       0,     0,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,   301,     0,     0,     0,
     302,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     884,   885,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   886,   327,   328,     0,   329,   330,   331,   332,
       0,   333,   334,   335,   336,     0,   337,   338,   339,   340,
       0,   342,   343,   344,   345,     0,     0,   347,     0,   348,
     349,   350,   887,   352,     0,   353,     0,   354,   355,   356,
       0,   357,   358,   359,   360,   361,     0,   362,     0,     0,
       0,   365,   366,     0,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,     0,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,     0,   388,   389,   390,
     391,   888,   889,     0,   890,     0,   395,   396,   397,   398,
     399,   891,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   411,   412,   413,   414,   415,   416,   417,     0,
       0,   418,     0,   420,   421,   422,     0,   423,   424,   425,
       0,     0,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   437,   438,   439,   440,   441,   442,   443,
     444,   892,   446,   893,   448,   449,   450,   451,   452,   453,
     454,   455,     0,     0,   458,     0,   459,   460,   461,   462,
       0,     0,   464,   894,   466,   467,   468,     0,   469,   470,
     471,     0,     0,   472,   473,   474,     0,     0,   475,   476,
       0,   478,   479,   480,     0,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,   494,   495,
     496,     0,   498,     0,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   895,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,   534,   535,   536,   537,   538,   539,     0,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,     0,   556,   557,  2733,   559,   560,
     561,   562,   563,   897,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,     0,   583,     0,   584,   585,     0,     0,   586,
     587,   588,   589,   590,   591,   592,   593,     0,   594,   898,
     899,     0,     0,   597,   598,     0,   600,     0,     0,   602,
     603,   604,   605,   606,   607,   608,   609,   610,     0,     0,
     611,   612,   613,   614,   615,     0,     0,   616,   617,   618,
     619,   620,     0,   900,     0,   623,   624,   625,   626,   627,
     628,     0,     0,   629,     0,     0,   630,   631,   632,   633,
     634,   635,   878,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   647,   648,   649,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,     0,   879,   260,   880,   881,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   882,   883,
     274,     0,   275,   276,   277,   278,     0,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,     0,   302,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   884,   885,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   886,   327,
     328,     0,   329,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   337,   338,   339,   340,     0,   342,   343,   344,
     345,     0,     0,   347,     0,   348,   349,   350,   887,   352,
       0,   353,     0,   354,   355,   356,     0,   357,   358,   359,
     360,   361,     0,   362,     0,     0,     0,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
       0,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,     0,   388,   389,   390,   391,   888,   889,     0,
     890,     0,   395,   396,   397,   398,   399,   891,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   411,   412,
     413,   414,   415,   416,   417,     0,     0,   418,     0,   420,
     421,   422,     0,   423,   424,   425,     0,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   437,
     438,   439,   440,   441,   442,   443,   444,   892,   446,   893,
     448,   449,   450,   451,   452,   453,   454,   455,     0,     0,
     458,     0,   459,   460,   461,   462,     0,     0,   464,   894,
     466,   467,   468,     0,   469,   470,   471,     0,     0,   472,
     473,   474,     0,     0,   475,   476,     0,   478,   479,   480,
       0,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,   494,   495,   496,     0,   498,     0,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   895,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,     0,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,     0,   559,   560,   561,   562,   563,   897,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,     0,   583,
       0,   584,   585,     0,     0,   586,   587,   588,   589,   590,
     591,   592,   593,     0,   594,   898,   899,     0,     0,   597,
     598,     0,   600,     0,     0,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,     0,   611,   612,   613,   614,
     615,     0,     0,   616,   617,   618,   619,   620,     0,   900,
       0,   623,   624,   625,   626,   627,   628,     0,     0,   629,
       0,     0,   630,   631,   632,   633,   634,   635,   878,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   647,
     648,   649,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,     0,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,     0,     0,   260,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
       0,     0,   270,   271,     0,     0,   274,     0,   275,   276,
     277,   278,     0,     0,   280,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   301,     0,
       0,     0,   302,     0,     0,     0,   303,   304,   305,   306,
     307,   308,     0,     0,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,   332,     0,   333,   334,   335,   336,     0,   337,   338,
     339,   340,     0,   342,   343,   344,   345,     0,     0,   347,
       0,   348,   349,   350,     0,   352,     0,   353,     0,   354,
     355,   356,     0,   357,   358,   359,   360,   361,     0,   362,
       0,     0,     0,   365,   366,     0,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,     0,   377,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,     0,   388,
     389,   390,   391,     0,     0,     0,     0,     0,   395,   396,
     397,   398,   399,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   411,   412,   413,   414,   415,   416,
     417,     0,     0,   418,     0,   420,   421,   422,     0,   423,
     424,   425,     0,     0,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   437,   438,   439,   440,   441,
     442,   443,   444,     0,   446,     0,   448,   449,   450,   451,
     452,   453,   454,   455,     0,     0,   458,     0,   459,   460,
     461,   462,     0,     0,   464,     0,   466,   467,   468,     0,
     469,   470,   471,     0,     0,   472,   473,   474,     0,     0,
     475,   476,     0,   478,   479,   480,     0,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
     494,   495,   496,     0,   498,     0,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,     0,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,   534,   535,   536,   537,   538,   539,     0,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,     0,   556,   557,     0,
     559,   560,   561,   562,   563,     0,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,     0,   583,     0,   584,   585,     0,
       0,   586,   587,   588,   589,   590,   591,   592,   593,     0,
     594,     0,     0,     0,     0,   597,   598,     0,   600,     0,
       0,   602,   603,   604,   605,   606,   607,   608,   609,   610,
       0,     0,   611,   612,   613,   614,   615,     0,     0,   616,
     617,   618,   619,   620,     0,     0,     0,   623,   624,   625,
     626,   627,   628,     0,     0,   629,     0,     0,   630,   631,
     632,   633,   634,   635,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   647,   648,   649
};

static const yytype_int16 yycheck[] =
{
       6,     0,     0,     0,   664,     0,     0,     0,     0,    56,
       0,  1040,     0,     0,     0,   685,     0,    23,   941,    25,
       0,     0,     0,    29,   211,   798,   799,   800,    34,    35,
      36,   804,    38,   211,  1012,    41,    42,    21,    44,     8,
      46,  1049,    21,   842,  1166,  1659,    15,    53,    54,    55,
     839,     0,   758,  1594,    45,   189,   206,   717,     0,   832,
       0,     0,  1044,   896,   214,    36,    22,   217,   935,  2673,
     937,  2841,    28,  1038,   915,  1504,  1578,  3071,  1578,  2715,
    1227,  1013,  2716,   979,   866,  1571,  1901,  1115,  1261,   849,
     717,  3136,   884,   885,  2043,  3098,   216,   197,  1274,  3246,
     762,   872,   894,  1583,   764,  3427,   899,  3429,  3522,  2032,
     230,   740,   953,  1246,  3610,  3926,  3726,  1250,  2084,  3083,
    1253,  1254,  2070,  2051,    23,   754,  3953,  2965,     6,  3672,
    3942,  3674,  1729,  4275,  2989,  4359,  3878,    36,  3644,  2069,
    3646,  3975,  1571,  3474,  3480,   666,  1624,  1625,  4834,    44,
    1628,  3532,  4318,  1049,  2108,  1696,  1697,   817,  1973,   191,
    4297,  4599,   738,   191,  1029,   741,   763,  5229,  2065,  2066,
    2067,  2068,   175,  1461,  2071,  1561,  2073,  2074,  5157,   753,
    4605,  1914,  4622,  4610,  5320,   845,   865,   978,     2,  5360,
    4567,   197,   198,   199,  4404,  4736,   202,  4738,  5149,  3530,
     206,    50,   208,  5454,  3496,   211,  2632,  2700,   214,  1689,
     870,   217,  1003,  4850,   220,  4852,   222,  1008,   845,   225,
      35,  2702,  1104,   229,  1089,   231,  3542,    42,  1093,  2737,
    2738,  3289,  4609,  1098,  3940,  1621,  2595,  1717,  1120,  5100,
    2599,  3079,  3386,  1108,  5351,  5490,  3479,    41,  3481,  3482,
    3381,  5144,  1638,  2679,  1155,  4924,  5502,  1122,     6,     6,
    1161,   938,     0,   938,     6,     0,  5759,     0,    11,     6,
    1171,     0,   932,  1544,  1175,  1042,    21,    54,  1179,    38,
    1181,     6,   882,   883,    47,   964,  1187,  5148,  1153,  4774,
      15,    16,  1193,   893,  6010,  1196,     6,    37,   962,     6,
    5407,     6,     6,    21,  5743,  2038,    47,    63,    15,    16,
    1083,    15,    16,     6,     6,  1012,     6,     6,     6,     6,
       6,    37,     6,    78,  1021,   122,    25,    95,     3,  3036,
     225,  3038,  3039,    47,  1031,   148,  3043,  3044,  3045,  1003,
    3047,  3048,  3049,    13,  1008,    13,     6,   120,    43,   115,
     177,   177,     0,     6,  5418,  5419,     0,   122,    37,   142,
      37,    37,   171,    11,     6,   125,     5,    11,     3,    43,
       5,     6,    11,    92,  1053,    45,    11,     6,   127,   177,
      11,    29,     5,  4457,    21,    29,   177,    37,    11,  1049,
    6051,  1625,   308,    11,  1628,  5443,   178,   177,  5641,    63,
     179,   206,  1880,    85,    63,  6017,   314,    15,    78,   302,
     240,    88,   329,  4623,   314,     6,    91,  4700,  4701,  4702,
     346,  4704,  4705,  4706,  4707,  4708,   188,   193,    30,   226,
    1201,   314,   186,    80,    27,  1417,   329,   309,   299,   177,
    1405,   140,   177,  1105,   177,  1473,    63,   179,   177,   322,
     384,   389,    13,   389,   359,    35,   216,    50,   288,   360,
     271,    25,   359,   201,    29,   448,   201,   120,   201,    13,
     145,   403,   201,    29,  5367,    29,  5969,   402,   384,    29,
      36,   379,    36,  1465,    45,   120,   152,   375,    99,   120,
     367,    80,   386,   123,  3098,   292,   124,  4935,   685,   396,
    1292,  1293,   448,    92,  6397,   271,  6399,  1403,   274,    92,
      87,   154,  1408,  1409,   172,   120,  5761,    78,   371,  1883,
     371,  5960,    48,    29,   177,   125,  2664,  2665,  2666,   177,
      36,   310,  1324,   177,    63,   535,   136,   537,   435,  1903,
    5491,   354,  1335,    80,  1173,    71,   328,  5654,   735,   402,
     208,   402,   297,   201,   125,    92,   539,   201,   355,   453,
     203,   301,   177,   683,    13,   471,   171,   197,  6461,   689,
     135,   448,   183,  5451,   472,   405,   140,   478,   310,   297,
     485,   701,   393,  1354,   259,   135,   221,   253,   485,    80,
     167,  1573,   354,   539,    80,   223,    45,   535,    63,   535,
     488,   535,   178,   535,   372,  1234,   479,  1267,    80,   535,
    1207,   177,   473,    23,   539,   217,  1245,   373,   535,   535,
     492,   256,    80,   385,   217,   379,   408,   393,    13,    78,
     435,   539,    80,  1262,  5877,   395,   536,  6298,  6131,   539,
    1267,   471,   535,   177,   423,   216,  1880,   177,   388,   324,
     448,   301,   243,  1549,    63,   297,   539,   448,  5706,   665,
     297,  1432,  4404,  1559,  6276,   671,    10,   673,   297,   675,
    1462,  5308,   678,    17,    18,    19,  1355,   184,   201,   685,
     670,  1281,  1282,   184,   690,    63,   692,   184,    63,   194,
    4432,   670,   698,    10,  1461,   125,    13,   268,  1727,  1728,
      17,    18,    19,   402,  2673,   488,  1385,   448,   535,   373,
     475,   471,   177,   539,   373,   478,   722,   764,    35,  1319,
    1426,   670,   535,  5968,   473,   731,   535,  1498,   670,   735,
     670,   670,   738,  1665,   453,   741,   431,   478,   478,    29,
    1400,  4878,   539,  6459,   510,   482,  1628,  6240,  1408,  1409,
    1646,   757,   525,  1649,  1650,  6471,   373,   431,   535,   539,
    1725,   421,   422,   438,   478,   768,   441,  4578,   516,   517,
    5255,   539,   471,  1400,   516,   517,   535,  2048,   533,   120,
     496,   463,   537,   539,   763,   462,   533,   535,   535,  1654,
     537,   534,  1657,   535,   539,   448,  1678,  1679,   535,  6238,
     538,   448,  5753,   538,   810,   538,  4618,   941,  4619,   538,
     535,  1734,  1645,   819,  1491,  5676,  1491,   496,  1609,   496,
     496,   539,   778,   792,   780,   535,   782,  6320,   535,  4439,
     535,   535,   788,   839,   840,  4445,   842,   843,  1438,  1439,
    5904,   847,   535,   535,   373,   535,   535,   535,   535,   535,
    1547,   535,   262,  1975,  2001,   861,   412,  4363,   412,   448,
     866,   531,  4936,   531,  5757,   448,   872,  3471,   448,   492,
    3474,   471,   525,  4947,  6367,   539,  1063,  6122,   526,   527,
     539,  4623,   526,   527,   537,  1063,  2008,   526,   527,  6135,
     538,   526,   527,   516,   538,   526,   527,   929,  2020,  6150,
     471,   929,  4238,   526,   527,  1569,   412,   224,   526,   527,
    1060,   448,  1609,   919,  1064,   810,  1066,   525,  3522,  4250,
     535,     0,   539,  4254,   389,   533,  3530,   933,  5211,   537,
    3768,  3769,   931,   931,   931,  3773,   931,   931,   931,   931,
     946,   931,    21,   931,   931,   931,  1616,   931,  1844,  3913,
    6057,   931,   931,   931,  1054,   961,   955,   448,  1622,   535,
    4104,  4105,   448,  4669,   373,  5634,   310,   528,   529,   530,
     531,   866,  6079,   539,   980,  1639,   448,    56,   157,   985,
     986,   322,   931,  4114,   528,   529,   530,   531,  5967,   931,
     448,   931,   931,   310,  4310,   373,  5874,  6242,   373,  1881,
     448,  5879,  5880,    32,  4237,   539,  4239,  4240,  3501,   539,
     539,  1017,  1018,  5964,    29,  3441,   539,   184,    25,   484,
     103,  3502,  4528,  1544,   873,    23,   113,    23,   438,  4087,
     535,  4527,   539,  1524,  1040,  1041,  5474,  3545,   539,  3547,
    2069,   471,   539,    23,   156,  4189,   336,  1948,  1054,   843,
    1056,   946,     6,   847,  1060,  1956,   125,  1063,  1064,   469,
    1066,   222,    89,   120,   171,  1071,   961,    32,  2050,    51,
      76,   309,  3910,   288,  6319,  6246,  6247,   526,   527,   528,
     529,   530,   531,   329,   494,   155,  5947,    72,    52,  1095,
       3,   113,    21,    63,   179,  1862,  1102,  1103,  6160,    23,
      63,   155,  5963,   186,  5481,   132,  6213,   397,   311,   113,
     125,   171,   191,   113,   135,   177,   137,   135,  1124,  1125,
    1126,   178,  1128,  2105,  1130,   535,  1132,  1133,    23,  3098,
     539,   177,  5356,   140,  3612,   163,   125,  1910,   479,    35,
    4432,   526,   527,   528,   529,   530,   531,   216,   324,  3856,
     440,   140,   442,  6132,   333,   201,  6407,   314,  4654,    37,
    1166,   539,  1168,  1169,   539,  6301,   168,  1827,   153,   296,
       6,  5381,  6123,     6,  3533,   155,  4590,    68,    91,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   173,     3,
     448,    23,   205,   384,   535,  1201,   189,  5834,  6369,   114,
    1483,   216,  1017,  1018,   256,   288,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   440,   308,   442,  2017,  2018,
      28,  1227,   189,  1229,  6128,  6129,   402,  1233,  1207,  1235,
     308,    10,   196,   146,    13,   392,   293,   201,    17,    18,
      19,  1210,   120,  1212,   435,  1214,   125,  1216,   120,  1218,
    1219,  1220,   288,  1259,   492,  1261,  1225,   173,    23,  1265,
     156,    23,     3,   348,   262,     6,   262,   525,    23,  6248,
     309,   292,  1978,  1279,   292,   288,   302,     6,  2049,   537,
    2051,   283,   409,   311,    92,    23,  2057,    23,   252,   535,
    5831,   206,  2063,  2064,  6430,   208,   511,   535,  5725,   305,
     327,  2007,  5740,   329,  2075,  2011,   120,  1354,  2737,   369,
    2016,  5749,   399,  2019,  2085,  1321,  1945,   324,   288,  5146,
    2091,   288,  5133,  2803,  1138,   492,  5751,  5139,  5755,  6391,
    1959,  5771,   535,  2835,   513,   405,  5170,   216,   262,  6318,
     120,   370,    25,  1972,  1350,  1351,  1352,  5724,  1354,  3082,
    6329,   405,   341,  3319,  3320,   384,  4359,   386,  3324,   344,
     367,  5799,   445,    89,  1938,  2132,  1942,   262,   297,  1375,
    3878,   179,   539,  1864,   115,  3305,   488,  5754,   539,   333,
     395,  1957,  6444,  2671,  1960,   492,   448,  4893,  1985,  6368,
      89,   389,   374,   389,   446,   402,  1970,   288,     3,  3365,
    3366,    72,   471,   373,   384,   370,   132,  2887,  1414,  3887,
     373,  4917,  2082,   435,   441,   435,   473,  6321,  1421,   332,
     120,    26,  6401,  2102,   453,   405,  1432,   455,  3025,  1616,
     262,   435,   402,   132,  2010,   435,   314,  2823,  2014,  2015,
     438,   477,   438,   407,  1476,  1477,   492,  1479,  1476,  1477,
     322,  1479,   193,   492,  6433,   533,   471,   140,   115,   537,
    3968,   297,  5628,   525,   297,   389,    33,    34,   309,   476,
     351,   469,  1478,   469,   389,   537,  1482,  1483,   292,  3433,
      25,   466,    39,   297,   477,  5622,    91,  1493,  1494,  1495,
    1496,  6177,  1498,   402,   389,  4876,   494,   262,   494,  4835,
     262,  3115,  3471,   180,   293,  3474,   170,   262,  4839,   535,
     477,  5949,   292,  4844,   438,  1521,  4847,   152,   433,   333,
     435,   492,   473,   395,   262,   152,   262,  2048,   323,  6142,
     271,   310,    99,   274,    40,   165,   193,   535,   165,   535,
     348,   146,   302,   438,   171,   469,  5378,  1622,    54,   133,
    1556,   464,   119,  3522,  5097,  1561,    42,   389,  1564,   472,
     144,  3530,   475,   435,  1639,    25,   535,  2596,   539,   329,
     494,  1577,  1578,   130,   469,   189,    25,   456,   386,   156,
    1586,   309,    31,  1589,   535,   220,   302,   113,  4591,   156,
    4635,   670,   471,   220,  5426,   140,   201,   297,  1493,   494,
    1495,   327,    25,   208,   156,   111,   438,   479,    31,   389,
    1616,   535,  1618,   329,   271,  1621,  2598,   274,  1624,  1625,
     492,   292,  1628,   253,   389,   189,   253,   389,   327,   312,
     539,  1630,  1638,  5857,   389,  1641,  1635,   469,  1644,  5381,
     535,   201,  6255,   451,   516,   453,  4250,   525,  3134,   457,
    4254,   389,   393,   389,   535,   533,   497,   535,   536,   537,
    1666,   539,   494,   535,  5695,  5492,  5697,   402,  5480,   122,
    5701,  5702,   349,   438,   288,   339,   438,   304,  1684,   314,
     140,  6119,   471,   438,   763,   764,   122,   314,   371,   372,
      51,   140,  1698,  1699,  1700,  1701,  1702,    92,   312,   343,
     438,  3130,   438,   535,   469,  3134,   383,   469,   402,   215,
    1716,  6142,  1711,   199,   469,   441,  1715,   140,   180,   402,
     397,  1727,  1728,  1729,   288,   120,   266,   332,   136,   494,
    2631,   469,   494,   469,  5876,   324,   393,   242,   193,   494,
     324,    72,   441,  4598,   523,   524,   525,   526,   527,   528,
     529,   530,   531,  2761,  4592,  4359,   494,    72,   494,   436,
     324,    92,   288,  6376,   492,   171,  1953,  1954,   668,   510,
     535,   168,   124,   535,   379,   535,  1954,   183,   367,   324,
     535,    13,   288,   367,  4554,   402,  2069,  2070,    25,  1684,
     226,  6348,   450,  1943,    31,   201,   363,   535,  6236,   535,
     178,  2084,   323,   367,   539,   120,   450,   367,   216,  4516,
    2093,   371,    10,   402,  4521,    13,   271,   386,   395,   535,
    1826,   535,   367,   122,  6255,    64,   402,   432,   395,  4832,
     465,  1837,  1932,    72,   212,   483,   343,   473,   465,  1845,
    1846,   165,   402,   395,   297,   539,    78,    45,   245,   227,
     929,   495,   931,   510,    52,  1861,   292,   402,   435,   464,
     760,  6418,   288,   477,   324,  2761,   181,   472,   435,   448,
     475,   223,   250,  1879,  1880,   324,     0,  6315,   535,  2650,
      78,   402,  2923,   435,   453,   391,   122,   535,   323,  1895,
    1896,  1897,  1898,   323,   473,  2082,  4404,   292,  1904,   535,
    2733,   324,   479,   140,  2671,  1911,   533,   367,  1914,   536,
     537,   210,   479,   477,  2713,   492,   483,   182,   367,   355,
    6062,   383,   539,  1929,  4432,   492,  1932,   479,   390,   253,
     538,  5742,   492,  5760,   834,   397,  1942,  1943,   393,   516,
     492,   367,   402,   450,   367,  6376,   535,  1953,  1954,   516,
     312,  1957,   150,   402,  1960,  2933,   516,  5769,   535,  5990,
     165,   292,   324,   539,   516,  3006,   171,   402,   535,  1975,
    1976,   377,   402,  5304,   436,   411,  1982,   292,  1984,   402,
     304,  6391,   297,   535,   483,   389,  4590,  4591,   495,   288,
     226,   256,   112,   292,   433,  2001,  6446,   459,   196,    35,
     378,   266,  2008,   201,  2010,   367,  1985,  2013,  2014,  2015,
    6460,  2017,  2018,    32,  2020,   123,   420,   256,  1987,  2066,
    1989,  2027,  1991,  5519,  1993,   492,  1995,  6251,  2034,   344,
    1999,  2037,  2038,   472,  6444,  2041,   535,  3159,  2044,  2045,
      59,  2937,  2032,  2049,   123,  2051,   361,   120,   253,  2945,
    2056,  2057,  2948,  2032,   252,  5202,   292,  2063,  2064,  2065,
    2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,
    2041,   450,   539,  2079,   324,  2081,  2082,  2083,  2084,  2085,
    2086,  2087,  2088,  2032,  4033,  2091,   159,  2093,  2094,   197,
    2032,  2097,  2032,  2032,   143,   240,  3019,  3020,  3021,   304,
     149,  2761,  4051,  2985,  2871,  5099,  2112,  2113,  2114,   492,
     324,     3,   310,  3542,   152,  4623,   495,   367,   197,   355,
    5123,   194,   484,  3552,  2130,   764,  1630,   165,  1207,   489,
    2897,  1635,  2027,   171,    58,  5962,  2833,  3751,  2911,  4067,
    2913,  3627,   369,   288,  5138,  2044,  5980,   267,  6372,  5961,
     239,   466,   272,   367,  5118,  4103,   539,   371,  4088,  4125,
    4126,  4127,  4128,  4093,  2170,  4131,  4132,  4133,  4134,  4135,
    4136,  4137,  4138,  4139,  4140,   440,  3352,   442,   817,   539,
    5723,   534,   220,    94,    38,  5332,   539,  5334,   402,    27,
     355,  5513,   367,   177,  4009,  4092,  1275,  2988,  3627,    91,
    4097,  4098,  2831,   368,   469,   129,    60,  1711,   165,   407,
     355,  1715,    50,   324,   171,   253,  1295,   201,   307,   292,
    3102,  3103,  3104,  3105,   112,  3107,   137,   402,  4832,  4195,
    4196,   870,  2999,   398,  2913,  4839,  2933,   324,  3835,   122,
    4844,  6425,    72,  4847,  3841,   539,  3724,  3148,    78,  5087,
    3132,  5089,  3153,   145,  3155,  2961,   367,  2963,   112,   395,
     405,  2967,    92,  6447,  3165,   492,   304,  3168,  5774,  3170,
    3171,  2277,    13,  3174,  2971,  1354,   314,  3178,   292,  3180,
     367,  4250,  3183,   297,   172,  4254,  3151,   367,   171,   516,
     120,   402,   122,   932,   372,  3775,   253,  6124,  3065,   435,
    5796,   384,   293,   294,    45,  4228,    10,    80,   384,    13,
     386,  3008,   539,  3209,   536,    99,   514,   539,    38,    92,
     208,  5324,   402,   100,   402,  2331,   471,   210,   526,   527,
     528,   529,   530,   531,  5748,   119,   419,    78,   352,  4236,
     492,    45,   324,   479,  3824,   100,  3247,   304,    52,   266,
     204,   181,  3125,  5356,  5061,   179,  5063,  5064,  5065,    80,
    3536,    81,  4937,   533,   516,   535,   727,   259,   265,   324,
    4945,    92,   156,    92,    78,   292,    29,   453,   324,   267,
     210,  2387,  5704,   152,   272,   367,   492,   539,    25,   213,
    4359,   414,   753,   346,   359,   292,   165,  1476,  1477,   535,
    1479,   178,   171,   453,   395,   288,   534,  2690,  3949,   292,
     516,   539,   367,   267,  6241,   492,   439,   363,   272,   171,
     402,   367,  3084,   178,   171,  6457,   525,   465,   171,   535,
      83,   396,   324,    86,   288,   212,   301,   324,   537,   516,
      93,  6252,  6474,   195,   435,   485,   150,   402,   195,  6059,
     227,   220,   195,   308,    91,  3222,   402,   212,   313,   780,
     781,   782,   292,   182,   785,   786,   787,   297,   121,   323,
     435,   363,   227,   250,   795,   367,     5,   100,  1003,   371,
     367,   308,    11,  1008,   253,   492,   313,   206,   479,   282,
      19,   392,   196,   120,   533,   250,   133,   201,   537,  5502,
    3206,   492,   279,   140,  1007,  3428,   243,   144,    37,   516,
     402,   516,   517,   306,   344,   402,   143,   535,   372,  5123,
     485,   270,   149,  1026,   279,   516,  1029,  5656,   181,   535,
     535,   361,  5661,  5662,  5856,   304,   163,   256,  3434,   453,
     536,   194,   396,   539,   535,   314,   438,   392,   252,   441,
    3321,     5,   266,   308,   207,   178,   530,    11,  6064,  6065,
     369,   535,  3333,   537,   418,   516,   517,  2573,  2574,  2575,
    2576,  2577,  2578,  2579,  2580,  2581,  3343,  2583,  5581,   363,
    4546,   535,  3349,   537,   535,     5,     5,  2593,  2594,   212,
    2596,    11,    11,  6404,   313,   266,    22,  2603,  3369,    96,
     492,   378,    28,   206,   227,   528,   310,  2794,   395,  3288,
     533,   395,   535,   533,   537,   535,  2794,   537,   440,   270,
     442,  4590,  4591,   378,    69,    70,  2632,   250,  2634,   195,
     536,  2637,  2638,   539,   530,  2641,   466,  2643,   453,   535,
    2646,   537,  3413,  2793,  2650,  2795,  2796,  3780,   435,  2633,
    3332,   435,  3334,  3335,   536,    10,   279,   539,    13,   152,
    3453,  3454,    17,    18,    19,   536,   536,  2673,   539,   539,
     297,  3431,   165,  2679,  2680,    87,  3577,   536,   171,   485,
     539,  3613,   536,   536,  2690,   308,   539,   324,   536,   392,
    2790,   539,   479,  2699,  2700,   479,   465,   492,  1059,   494,
    5304,  6207,  3543,   407,   492,   492,   494,  2713,   492,  1070,
    2830,   284,   285,   286,   287,  2721,  3648,  2723,  3388,   536,
    5324,   440,   539,   442,  5431,  1086,   363,   220,    59,   516,
     367,  5776,   516,  4682,   453,   536,   536,   528,   539,   539,
     536,   243,   533,   539,   535,  3727,   537,   466,   535,  4698,
     469,   535,  5356,    15,    16,   378,  3657,  2763,  3659,  2765,
     253,  3553,  4376,   535,   533,   402,   536,   420,   537,   539,
     423,   322,   409,  2779,  3434,   483,   536,   536,  2718,   539,
     539,    11,   182,   536,  2790,  4600,   539,  2793,  2794,  2795,
    2796,  3938,  2763,  2799,  2765,  2673,  2802,  4727,  5636,   389,
     536,  6307,  2922,   539,  4734,  4735,  5644,  5645,  3487,    38,
     514,   304,   536,   536,   433,   539,   539,  2823,   440,   535,
     442,   314,   526,   527,   528,   529,   530,   531,   455,  2835,
     440,    60,   442,  4374,   536,  4376,   536,   539,   536,   539,
     467,   539,  2848,  2849,   395,   536,   201,   152,   539,  2855,
     473,   492,   536,   494,  5857,   539,   256,   308,  2864,  4361,
     165,  4341,   536,  4832,  3570,   539,   171,   539,   536,   224,
    4839,   539,  6194,  5381,   135,  4844,   137,  4050,  4847,   294,
    2886,  4310,  1243,   112,   435,  3005,   536,  1208,   535,   539,
    1211,  3919,  1213,   492,  1215,   494,  1217,   492,  5502,   494,
    1221,  2907,   536,    59,  3805,   539,  1985,  2802,   536,  6056,
    3811,   539,    33,    34,  2920,   220,   536,  3614,   536,   539,
     536,   539,   536,   539,   536,   539,    10,   539,   479,    13,
     485,  3591,  4412,    17,    18,    19,    48,  2943,  3567,  3568,
    2946,   492,   536,   536,   536,   539,   539,   539,   253,  3722,
     537,    35,   181,  2032,  3727,   310,   512,   536,   536,   359,
     539,   539,   226,  5966,  3591,   516,  2972,  2973,   536,  5363,
    5364,   539,   465,  2979,   536,   204,   538,  5581,   536,  5613,
     395,   539,  3781,  2989,   535,  2991,  2992,  2066,   536,   536,
     311,   539,   539,  3875,   536,   536,   538,  5505,   539,   304,
     536,   171,  3699,   539,  2960,   536,  5823,  5824,   539,   314,
     536,  2090,  2907,   539,   384,   385,  3881,  3023,  3024,  3025,
     435,   536,   308,  3029,   539,    10,   536,   536,    13,   539,
     539,  3037,    17,    18,    19,   308,  3319,  3320,   267,    38,
     440,  3324,   442,   272,  3050,  4219,   135,  4221,   137,   512,
    3056,  6373,  3058,   536,   536,   536,   539,   539,   539,   288,
      45,    60,   311,   536,   479,  3071,   539,    52,    48,   469,
    3076,  4612,   536,   512,   163,   539,  3082,   492,   536,  3085,
     226,   539,  3365,  3366,   528,   485,   536,  3716,  4255,   539,
    4257,  3097,  3098,    78,   323,  4821,  3997,  4823,  3999,   176,
    4001,   516,  3108,  3253,   539,  3255,  3256,  4607,   536,  3738,
    3877,   539,  3118,   112,  3120,   536,   384,   385,   539,  4295,
     535,   536,   536,   538,  6118,   539,   536,  6449,  1493,   539,
    1495,   135,  6135,   137,  3907,   536,   516,   517,   539,   228,
     224,   535,  4628,   372,  5748,   536,   536,   482,   539,   539,
    3250,   384,   385,  3159,  5123,  3161,   535,  3163,   536,   163,
     465,   539,  4058,   536,   384,   385,   539,   396,   523,   524,
     525,   526,   527,   528,   529,   530,   531,  3117,   536,   536,
     536,   539,   539,   539,    10,   536,  4168,    13,   539,   418,
    3196,    17,    18,    19,   535,   284,   285,   286,   287,  4628,
     340,  3388,   291,  2282,   536,   204,    37,   539,   297,    35,
    5285,   196,  5287,  4360,   536,  4362,   201,  5853,  4365,  3925,
    3098,  6023,  6024,  3883,   228,  3885,   310,   536,   536,   536,
     539,   539,   539,   536,   536,    10,   539,   539,    13,   224,
     225,   535,  6245,   536,  3250,  3251,   539,  3253,  6251,  3255,
    3256,  1612,  3258,  5857,   536,  4037,  3883,  4222,  3885,  3265,
     536,    59,   536,   539,  3270,   539,   177,   252,   267,  3898,
      45,  3900,   222,   272,  3321,  5241,   536,    52,   222,   539,
     284,   285,   286,   287,    54,    55,  4268,   291,   292,   288,
     537,   536,   536,   297,   539,   539,   536,   536,   536,   539,
     539,   539,   496,    78,  5234,  5235,   367,  3967,   536,  3496,
     295,   539,   535,  3319,  3320,  3321,  4022,   536,  3324,   535,
     539,   535,  3369,  4305,   323,   310,  3332,  3333,  3334,  3335,
     536,   536,   535,   539,   539,  5304,   536,   201,  4952,   539,
    3967,   536,  3348,   536,   539,  3351,   539,  3353,   536,  4120,
     536,   539,   157,   539,   536,  5324,   535,   539,   157,  3365,
    3366,    10,  5966,  3369,    13,   536,   455,  6137,   539,  6372,
     537,   536,   308,   372,   539,   150,   536,  6423,   467,   539,
    6426,   201,  3388,  4154,  3390,   367,  3392,  5356,  3394,  2095,
     308,   157,  2098,   157,  4161,   201,    45,   396,   224,   157,
     308,   367,   171,    52,   157,   251,   122,  3413,   473,   308,
    3416,   535,   301,   536,  3420,   171,  4918,    72,   292,   418,
     292,   196,   407,    38,  4053,   496,   201,  3474,   535,    78,
    3421,  3422,  3423,   308,  4205,  3441,    54,   292,    48,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   292,    48,
     458,   455,   292,    91,   324,   485,   485,    87,   453,   171,
     347,   157,    62,   467,   157,  3471,   535,   157,  3474,  3475,
     157,   496,   157,  3479,  3480,  3481,  3482,   252,  1839,  3526,
     157,   539,  3488,   101,   310,   157,   157,  3493,   157,  1850,
     157,     0,  4333,   157,   157,   171,   157,   157,    98,   157,
     157,   150,  3508,   157,  4651,  1866,   308,   435,   126,   535,
    4375,    38,   251,   308,   535,  4307,  3522,     6,   171,   171,
    3526,     6,   535,  3529,  3530,   535,  3532,   145,   171,   514,
     535,  6135,   150,  5502,    43,   310,  4432,   535,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   196,   535,   535,
       6,   535,   201,     6,   172,     6,   535,   535,   176,  1920,
    2639,   161,   535,   535,   535,   535,   535,  3573,   535,     6,
    4502,   535,   535,   191,  1935,   535,   535,  1938,  1939,  5528,
     535,   535,   535,   535,   535,   299,   535,  5553,   535,  4512,
      99,  3597,  3598,  3471,  2673,   535,  3474,   535,   198,   493,
    6370,   535,   535,   252,   535,   535,   535,   320,  1969,  1970,
     535,   535,  5581,   535,   535,   535,   166,   222,  5584,    38,
     539,   103,   539,   251,    38,   535,    37,  3633,   446,   446,
     533,   533,   407,   448,   448,   448,  4403,   535,  4405,  2718,
     448,  6245,   177,   152,  3522,   171,   539,  6251,   248,   171,
     402,    68,  3530,   304,   302,   448,   165,   448,   389,  4524,
     448,   310,   171,   484,  4431,   448,   389,   448,   177,   537,
     448,   389,   253,    79,   183,   448,   448,   186,   525,   297,
     448,   190,    92,   389,  3690,   157,   308,   394,   248,   448,
     297,  3878,   292,   448,   128,   472,   329,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   448,   308,  3714,   438,
     384,   220,   302,   222,   448,   448,   535,   194,  3724,   535,
      92,   128,   324,   201,   157,   325,   473,   539,   473,   448,
     128,   448,   114,   448,   352,   128,    59,   448,   448,   514,
    5169,    59,   276,   448,   253,   448,   448,   448,   448,   448,
    2111,   526,   527,   528,   529,   530,   531,   448,   407,   448,
     312,   329,   448,   351,  4665,   448,   351,  4668,  6372,   448,
     448,   371,   351,   373,   329,  3781,   376,   330,   329,  5748,
    4676,    47,   438,   448,   224,   385,   448,   536,   539,   448,
     540,   308,   224,   224,   394,   304,  4697,   224,   448,   308,
     224,   224,   402,   224,   224,   314,   224,   308,   224,   448,
     535,   458,    38,   157,   308,   157,   416,   292,   120,   157,
    4103,   157,   157,   259,   308,   425,   292,   473,   292,  3835,
     430,   292,    38,    38,   171,  3841,   157,   535,   535,   484,
     243,   535,  4125,  4126,  4127,  4128,  3852,   391,  4131,  4132,
    4133,  4134,  4135,  4136,  4137,  4138,  4139,  4140,   157,   473,
     157,   473,   157,   301,   448,   514,   375,   296,   177,   488,
     536,   276,   276,    13,   448,   186,  4159,   526,   527,   528,
     529,   530,   531,  3889,  3890,  3891,   450,   487,  5857,  4871,
     194,   535,   512,   319,   535,   535,   194,   539,   535,   512,
    3906,   536,   536,   539,   533,   536,   393,   274,   220,   536,
     536,   536,  4195,  4196,  3920,   539,   489,  4684,   240,   405,
     309,    38,   431,   539,   473,   473,   317,    59,   536,   389,
     484,   535,  3938,  3939,  3940,   297,   297,   297,  3944,   535,
     448,   448,   448,  4572,  4573,   297,   171,    48,   411,   308,
    3956,   308,   535,  4786,   240,   240,   465,   251,   292,  4242,
     251,  5108,   251,   270,  4670,  4671,  4672,  4673,  4674,   384,
     438,   128,   448,   539,   201,   308,   308,   308,   539,   308,
     489,   367,   491,   492,   195,   355,  5486,  4854,   492,   402,
     535,   399,    38,   448,   448,   314,   536,  5966,  4899,   473,
     224,  4772,    10,   473,   513,    13,  4012,   243,   157,    17,
      18,    19,  3952,   525,   302,   171,   485,    38,   173,   535,
    4026,  4027,   350,   399,   436,   351,   157,   536,   157,   538,
     539,  4037,   535,   157,   302,   492,   292,    38,  3117,   292,
      27,   308,   243,   473,  4050,   308,  4942,   302,  3988,   192,
     192,   171,    38,   172,  4955,  4956,   243,   171,   399,   308,
     292,  3956,   201,  4069,   201,   201,   201,   201,   539,  4203,
     537,   496,  4078,   448,   539,    59,   273,  4866,   177,   308,
     539,   539,   301,   535,   177,   513,  4092,   536,   536,   539,
    4096,  4097,  4098,   492,   536,   536,   314,  4103,   478,   375,
    4106,  5642,   135,  4109,   539,   320,   177,   291,   331,  4115,
     177,  4117,   266,   186,  4120,   512,   489,   539,   448,  4125,
    4126,  4127,  4128,   471,    59,  4131,  4132,  4133,  4134,  4135,
    4136,  4137,  4138,  4139,  4140,   536,   536,   539,  4144,  4145,
    4146,   536,  4037,   539,   536,   539,   536,   535,  4154,   536,
    5051,  5052,   536,  4159,  4201,   536,   535,  4163,   536,   536,
     308,     0,   536,   516,   535,  4171,  6135,   535,  4174,   535,
    4176,   534,   536,   261,   539,   515,   534,   157,   479,   535,
     535,   535,   525,   489,   311,   308,  4192,  4857,   448,  4195,
    4196,   448,   308,   297,  4200,  4201,   448,   214,   160,  4205,
     448,  4207,  4208,   292,  5069,   157,   206,   423,   535,   402,
    4216,  4217,  4218,   394,  6180,  6181,   224,  4404,  6184,   535,
    4211,  4212,  4213,  4214,   157,   535,   157,   394,   394,   251,
    4236,  4237,  4238,  4239,  4240,   206,  4242,  4243,  4228,   160,
    4246,   525,  3321,    10,  4250,  4432,    13,   308,  4254,  4228,
      17,    18,    19,   448,  4260,   160,   473,   253,   489,   389,
      99,   470,   332,  4546,   332,   160,   448,   420,    35,   448,
     448,   448,   222,   263,   263,   263,  6245,   448,   448,  4228,
    5181,  4287,  6251,  5184,  5185,  4914,  4228,   389,  4228,  4228,
    3369,    25,   389,   389,   389,   128,  4302,    31,  4304,   292,
     157,   448,   310,  5204,   448,    47,    47,   448,   402,   224,
     448,   224,    46,   152,  3393,  5088,   536,   189,   312,     3,
     448,   534,  5028,  5029,   536,  5031,   165,   448,   536,   536,
    3409,   171,   171,   448,   536,   448,   539,    48,   177,   113,
     458,   539,    76,   171,   183,   536,   535,   186,  5777,    38,
     536,   190,   157,  4359,  4360,  4361,  4362,  5280,   448,  4365,
     157,  4367,   525,   171,   302,   189,   535,   473,   473,   157,
     389,   389,  4250,   389,   389,   389,  4254,   539,   155,  4385,
     155,   220,   224,   224,   147,   228,   399,   224,  5017,   224,
     224,  5314,  3471,   224,   224,  3474,   308,   131,   224,   133,
     533,   224,   466,  6372,   466,   308,   140,    59,   308,   308,
     144,   536,    13,   539,   253,   484,   320,    10,   177,   315,
      13,   291,   534,   227,    17,    18,    19,   536,   536,   536,
     318,  2792,   227,   536,  4440,   437,  4623,  2798,   172,   539,
      59,   190,    35,  3522,   536,   536,   445,  3526,   375,   536,
     536,  3530,    45,   535,   478,   536,   535,   224,   535,    52,
     535,    90,   171,   458,    38,   304,   473,   473,   214,   308,
     243,   448,    59,   438,   208,   314,   157,    86,   420,   181,
     458,  4359,   473,   394,  2845,    78,  6100,  5116,   448,   160,
    4446,  4497,  4775,   448,   448,   389,   389,   448,   536,   448,
     536,  4457,   536,   367,   535,   535,    59,   492,   438,   479,
     535,   171,   308,    78,   157,   523,   524,   525,   526,   527,
     528,   529,   530,   531,  4530,    10,   458,   113,    13,   224,
     224,   536,   224,   224,   268,   240,   375,   535,  4544,   209,
    4546,   448,   308,   310,   536,    38,   329,  4553,   496,   305,
     308,     3,   535,  4559,   288,    44,   535,   539,   292,  5681,
      45,  5683,   535,   539,  4570,   539,   458,    52,   302,   448,
     536,   535,   399,   183,   113,   177,   184,   224,   312,  4585,
     536,   145,   241,   241,  4590,  4591,   177,   297,    59,   536,
     324,  5297,  4598,    78,   297,   536,   435,   297,   297,   536,
     536,  4607,  5308,   196,   490,   490,   320,   536,   201,   329,
     535,  4617,   536,   539,   536,   535,   539,   535,   491,   302,
     227,   177,   458,  4629,  4630,   445,   465,   525,   208,   448,
     492,   224,   225,   367,  4640,    78,   370,   371,   195,    38,
     195,   297,   297,   525,    59,  4651,  4652,   438,   539,   539,
     489,    72,   491,   492,   448,   448,   448,   329,   157,   252,
     222,   448,   160,  4669,  5463,   150,   224,   536,   402,  5436,
    4857,   127,    10,   179,   513,    13,  4616,   535,   120,   413,
      38,  5828,   201,   535,  5692,   302,   399,  5357,   473,    38,
     173,   399,   292,   492,   533,    59,  3057,   536,   537,   538,
      84,   438,   295,   302,  4710,    38,   492,    45,   177,   171,
     308,   196,  4590,  4591,    52,   211,   201,   310,   535,   311,
    4726,   539,   362,  5393,   536,   222,  5873,   536,  5629,   536,
     177,   478,   535,    59,   536,   417,    38,    81,  4744,   392,
      78,    92,   476,   136,   448,   535,   535,   308,   202,   361,
      38,   157,   536,  5382,   536,   157,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   535,  4772,   252,   448,  4775,
     535,   535,    38,   535,  5921,  5922,   171,  4783,  4784,   297,
     535,   535,   535,   473,  4790,  4791,  5687,   264,  5559,  4795,
     535,   535,   157,   536,  4800,   399,  5692,  4803,  4804,   113,
      38,   536,  5573,   312,  4810,   177,   536,   458,  4814,  4815,
    4816,  4817,   150,    10,   407,   171,    13,   539,   415,   415,
      17,    18,    19,    38,  5595,   310,  4832,   308,   205,  4835,
     536,  5602,   112,  4839,    38,   536,   478,   535,  4844,   535,
      35,  4847,  4848,   438,  4850,   473,  4852,   535,    45,  4855,
     535,  4857,   539,   539,   194,    52,   535,   438,   196,   171,
    4866,   288,   535,   201,  4870,   206,     6,   308,  4874,   536,
    4876,   164,   496,  3952,   535,   385,  3237,   385,    72,   311,
      72,    78,   136,   141,   538,  4891,  5592,   492,   477,   492,
     149,  3252,   308,   478,   488,   536,  3257,   536,   168,  5800,
     168,  5672,  5673,   331,   539,  5913,   265,   402,   535,  3988,
     535,   444,  4918,  4919,   252,   444,   177,   438,   358,   297,
    4891,   514,   407,   208,   438,   308,  3287,  4933,  4868,  4869,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   308,
     399,    38,    38,   311,   311,  6092,   202,   535,   179,   179,
     156,   535,   535,  5931,  4832,   496,   496,   353,  5241,   353,
     384,  4839,   153,    81,     0,    59,  4844,   207,    59,  4847,
     315,    38,   310,    59,    59,   448,   216,   368,   424,  5685,
    4936,   125,   536,   471,   536,     6,   399,   535,   141,   496,
     230,  4947,   496,  4999,   536,   308,    35,   308,   535,   196,
    5006,   297,   293,   535,   201,   402,   293,   535,    24,   384,
     308,  5294,   539,   539,  5674,   388,   316,   388,   384,    81,
     535,   479,   448,   177,  5030,  6172,  6173,   224,   225,   514,
     535,   156,  5692,   149,   426,  5802,   426,   539,     6,  5045,
     478,   526,   527,   528,   529,   530,   531,   120,   315,   479,
     536,   333,   415,   415,   473,   252,   492,   492,   179,   179,
     535,   478,   536,    99,    81,   535,   931,   535,  5512,   407,
    5076,  5838,  1018,  1017,   971,  5846,  3434,  5848,  2971,  5678,
    3648,  2880,  1714,  4403,  1409,  4378,  5092,  6083,  3000,  5439,
    3054,  3869,  5910,  5099,  6221,  4570,  5486,  4376,   295,  4376,
    5462,  5078,  5108,  3636,  3574,  5878,  3196,  6063,  5356,  6210,
    5941,  5940,  6104,   310,  6245,  5123,   152,  5123,  3641,  4617,
    4591,  4602,  4201,  5881,  4560,  3068,  3068,  4398,  5117,   165,
    5136,  3673,  5138,  3917,  4586,   171,  1013,  5469,  3961,  4653,
    5789,   177,  6330,  5910,  6463,  6438,  5453,   183,  4625,  4228,
     186,  5395,  3877,  6116,   190,  5659,  5891,  5398,  5164,    18,
      28,  1235,  4026,   666,  4681,  1874,  5627,  6326,  4684,  5175,
    5357,  4250,  1918,  2738,  3084,  4254,   514,  4628,  3552,  1915,
    3972,  1929,  5512,  5777,   220,   751,  1953,   718,   526,   527,
     528,   529,   530,   531,  5381,  5135,  3809,  2999,  4431,  6142,
    3724,     6,  4657,   860,  6376,  5875,  5393,  3030,  1528,  4659,
     407,  2680,  6303,  6221,  4870,  5393,  1827,   253,  4302,  5622,
    5625,  1425,  5228,    40,    40,  1386,  4726,  3493,  1486,  3508,
    2690,  1485,  5238,  3594,  6042,  5241,  5850,  1488,  5244,  5245,
    5246,  3602,  5392,  3474,  4238,  5123,    51,  4256,  5305,  5580,
    3471,  3471,  5581,  5913,  4303,  6354,  6036,  6185,  5837,  3471,
    6392,  5557,  1442,  5269,  5270,  4163,  5851,  5273,   304,  2588,
    5553,  3411,   308,  2589,  5852,  2086,  3393,  3266,   314,  3029,
    6394,  3391,  5801,  3381,  5290,  3302,  4095,   919,  5294,  2678,
    2594,  5441,    -1,    -1,  5300,    -1,    -1,    -1,  5304,    -1,
      -1,  5584,  5308,  6204,    -1,  5311,    -1,  5313,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   514,  5324,    -1,
      -1,  5327,    -1,    -1,    -1,    -1,   523,   524,   525,   526,
     527,   528,   529,   530,   531,    -1,    -1,    -1,    -1,   375,
      -1,    -1,    -1,    -1,    -1,  3706,    -1,  3708,  5317,    -1,
    5356,  5357,  5358,    -1,  5360,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5392,  5393,  6417,    -1,
      -1,    -1,   197,    -1,    -1,    -1,    -1,    -1,    -1,   435,
      -1,   206,   207,    -1,    -1,    -1,    -1,  5413,  5414,   214,
      -1,   216,   217,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6083,    10,   230,  5304,    13,    22,   465,
      -1,    17,    18,    19,    28,  5441,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   683,    -1,  3806,  5324,  5453,    -1,   689,
      -1,    10,  5458,   489,    13,   491,   492,  5463,    17,    18,
      19,   701,    -1,    -1,    -1,    -1,  5472,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5482,   513,  5356,    38,
    5486,    -1,    -1,  5489,    -1,    -1,    -1,    -1,    -1,  3850,
      -1,    -1,    -1,    -1,  5500,  5501,  5502,   533,    -1,    -1,
     536,   537,   538,    10,    -1,    -1,    13,    -1,    -1,    -1,
      -1,  4590,    -1,  5512,  5512,  5512,  6439,  5512,  5512,  5512,
    5512,    -1,  5512,    -1,  5512,  5512,  5512,  5467,  5512,    -1,
    5536,    -1,  5512,  5512,  5512,    -1,    -1,  4616,    45,  6310,
    6313,  6314,    -1,    -1,    -1,    52,    -1,  5553,    -1,    -1,
      -1,  5557,    -1,  5559,  5837,  5602,    -1,    -1,  5498,    -1,
      -1,  6221,    -1,  5512,    -1,    -1,    -1,  5573,    -1,    -1,
    5512,    78,  5512,  5512,    -1,  5581,    -1,    -1,  5584,    -1,
      -1,    -1,  5588,    10,    -1,  3946,    13,    -1,  6359,  5595,
      17,    18,    19,    -1,    -1,    -1,  5602,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5501,    -1,    35,    -1,
      -1,    -1,  6379,    -1,    -1,    -1,    -1,    -1,    45,    -1,
      -1,    -1,    -1,    -1,  5502,    52,    -1,    -1,    -1,  3990,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5643,   224,    -1,
      -1,    -1,    -1,    -1,  5650,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5666,    -1,    -1,    -1,    -1,   224,  5672,  5673,    -1,    -1,
      -1,  6438,    -1,    -1,    -1,  5681,  5682,  5683,  5684,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5875,   196,
      -1,    -1,    -1,    -1,   201,    -1,  6463,    -1,    -1,    -1,
      -1,    -1,    -1,  5581,    -1,    -1,  5712,    -1,    -1,    -1,
      -1,  4072,    -1,    10,  5720,    -1,    13,    -1,    -1,    -1,
      17,    18,    19,    -1,   310,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5745,
      -1,    -1,  5748,    -1,    -1,   252,    -1,    -1,    45,  6032,
      -1,   310,    -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,
    4839,    -1,    -1,  4124,    -1,  4844,    -1,  5773,  4847,   196,
      -1,    -1,    -1,    -1,   201,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    -1,    -1,    -1,    -1,    -1,    -1,  4149,  4868,
    4869,    -1,    -1,    -1,    -1,  5801,    -1,   224,   225,    -1,
      -1,    -1,    -1,   310,    -1,    -1,    -1,  5813,    -1,    -1,
    5750,    -1,    -1,    -1,    -1,    -1,  5822,  5823,  5824,    -1,
      -1,    -1,  5828,    -1,    -1,   252,    -1,    -1,  5834,    -1,
      -1,  5837,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5846,    -1,  5848,    -1,  5850,  5851,    -1,    -1,    -1,    -1,
      -1,  5857,    -1,    -1,    -1,    -1,    -1,    -1,  5864,   664,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5873,   295,  5875,
    5748,    -1,    -1,    -1,    -1,    -1,    -1,  5883,   683,    -1,
      -1,    -1,    -1,   310,   689,    -1,   313,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   701,  6180,  6181,   196,
     407,  6184,    -1,    -1,   201,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   717,    -1,  5854,  5921,  5922,   722,    -1,    -1,
    6070,    -1,   727,    -1,    -1,    -1,   731,   732,    -1,    -1,
      -1,    -1,    -1,   738,    -1,   740,   741,   523,   524,   525,
     526,   527,   528,   529,   530,   531,  5952,    -1,   753,   754,
      -1,    -1,    -1,    -1,    -1,   252,    -1,    -1,    -1,   764,
    5966,    -1,    -1,    -1,   523,   524,   525,   526,   527,   528,
     529,   530,   531,    -1,    -1,    -1,    -1,    -1,    -1,  5857,
     407,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6143,  6144,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   514,    -1,    -1,
      -1,  6017,   817,   310,    -1,    -1,    -1,    -1,    -1,   526,
     527,   528,   529,   530,   531,    -1,  6032,    -1,    -1,    -1,
    6036,    -1,    -1,    -1,   839,   840,  6042,    -1,    -1,    -1,
     845,    -1,    -1,    -1,    -1,  6051,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5135,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6070,   870,    -1,   872,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6085,
      -1,    -1,    -1,    -1,    -1,    -1,  6092,   514,  5966,    -1,
      -1,   896,    -1,    -1,    -1,    -1,   523,   524,   525,   526,
     527,   528,   529,   530,   531,    -1,    -1,    -1,    -1,    -1,
     407,    -1,  6118,   540,   919,    -1,    -1,    -1,    -1,  6125,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   932,    -1,  6135,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6143,  6144,  6145,
      -1,    -1,    -1,  6149,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6142,    -1,    -1,  6172,  6173,  6174,    -1,
      -1,    -1,    -1,    -1,  6180,  6181,    -1,  6117,  6184,    -1,
      -1,  6187,    -1,    -1,   778,    -1,   780,    -1,   782,    -1,
      -1,    -1,    -1,  6142,   788,   789,   790,    -1,    -1,    -1,
    6142,    -1,  6142,  6142,    -1,    -1,    -1,    -1,  6255,  6215,
      -1,    -1,    -1,    -1,    -1,  4576,    -1,   514,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5304,   523,   524,   525,   526,
     527,   528,   529,   530,   531,  1040,  1041,  1042,    -1,  6245,
    6246,  6247,    -1,    -1,  1049,  6251,    -1,    -1,    -1,  1054,
      -1,    -1,    -1,    -1,  1059,  1060,    -1,  6135,    -1,  1064,
      -1,  1066,    -1,  6269,    -1,  1070,    -1,    -1,    -1,    -1,
    6276,    -1,    -1,    -1,    -1,    -1,  6255,    -1,  6284,    -1,
      -1,  1086,    -1,    -1,    -1,    -1,  6292,    38,    -1,    -1,
      -1,    -1,  6298,    -1,    -1,    -1,    -1,  6303,    -1,    -1,
      -1,  6451,  6452,    -1,  6310,    -1,  6255,    -1,    -1,    -1,
      -1,    62,    -1,  6255,    -1,  6255,  6255,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1130,    -1,  1132,  1133,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6346,  6347,  6348,  6349,    -1,    -1,    -1,    98,  6354,    -1,
      -1,    -1,    -1,  6359,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6369,    -1,     6,  6372,  6245,  1173,    -1,
      -1,    -1,    -1,  6251,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   979,  6392,    -1,  5467,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1201,  6376,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     161,  6417,  6418,    -1,    -1,    -1,    -1,    -1,    -1,  5498,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6376,  6434,  1234,
      -1,    -1,    -1,  5512,  6376,    -1,  6376,  6376,  1243,    -1,
    1245,    -1,    -1,    -1,    -1,  6451,  6452,   198,    -1,  6455,
      -1,  6457,    -1,    -1,    -1,  1049,    -1,  1262,    -1,    -1,
      -1,    -1,  1267,    -1,    -1,    -1,    -1,    -1,  6474,    -1,
      -1,    -1,  1712,    -1,  1279,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    -1,    -1,    -1,    31,
      -1,    -1,   243,    -1,  6372,    -1,    -1,   248,    -1,    -1,
      -1,    -1,     0,    -1,    46,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1321,    -1,    -1,    -1,
      -1,    -1,    20,  5602,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    31,    76,    33,    34,    -1,    -1,    -1,
    4901,   292,    -1,    -1,    -1,  1350,  1351,  1352,    -1,  1354,
      -1,    -1,    -1,    51,    -1,    -1,   197,    -1,    -1,    -1,
      -1,    -1,    -1,    61,    -1,   206,    -1,    -1,    -1,    -1,
    1375,    -1,    -1,   214,   325,    73,   217,    75,    76,    -1,
      -1,    -1,    -1,    -1,    82,    -1,    84,    -1,    -1,   131,
      -1,   133,    -1,  4954,    -1,  1400,    -1,    -1,   140,    97,
      -1,    99,   144,  1408,  1409,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4976,    -1,    -1,   116,    -1,
     371,   119,    -1,    -1,    -1,   376,    -1,  1432,    -1,    -1,
     172,    -1,    -1,    -1,   385,    -1,   134,    -1,   136,    -1,
      -1,    -1,   140,   394,    -1,  1885,    -1,    -1,    -1,   147,
      -1,   402,    -1,  1893,    -1,    -1,  1461,    -1,   156,    -1,
     158,  1901,    -1,    -1,    -1,   416,   208,   165,    -1,  5748,
      -1,  5750,    -1,  1478,   425,    -1,    -1,  1482,  1483,   430,
      -1,    -1,    -1,    -1,    -1,   183,    -1,    -1,    -1,  5050,
      -1,    -1,    -1,  1498,    -1,    -1,    -1,    -1,    -1,  1504,
     451,    -1,   200,    -1,    -1,    -1,  1946,    -1,    25,    -1,
      -1,    -1,    10,    -1,    31,    13,    -1,    -1,    -1,    17,
      18,    19,    -1,    -1,    -1,    -1,   268,    -1,    -1,    46,
      -1,    -1,    -1,  1973,    -1,    -1,   487,    35,    -1,    -1,
     491,    -1,    -1,    -1,    -1,    -1,   288,    45,    -1,    -1,
     292,    -1,    -1,    -1,    52,    -1,   254,   255,    -1,    76,
     302,    -1,   260,    -1,    -1,    -1,  1571,    -1,    -1,    -1,
     312,    -1,    -1,    -1,    -1,  5854,    -1,   275,    -1,    -1,
      78,    -1,   324,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   294,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1612,    -1,  1403,
    5171,    -1,    -1,    -1,  1408,  1409,   133,    -1,    -1,    -1,
      -1,    -1,    -1,   140,    -1,   367,    -1,   144,   370,   371,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1645,    -1,  1436,    -1,   342,    -1,    -1,    -1,    -1,     0,
      -1,  1445,    -1,  1447,    -1,   172,    -1,  1451,    -1,   357,
     402,    -1,    -1,    -1,  1458,   363,   364,    -1,   366,    -1,
      -1,   413,    -1,   371,    -1,    -1,    -1,    -1,    -1,   377,
      -1,    -1,   380,    -1,    -1,    -1,    -1,    -1,    -1,   387,
      -1,   208,    -1,    -1,    -1,    -1,   394,   395,   196,    -1,
      -1,    -1,    -1,   201,   402,    -1,    -1,  1712,   406,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     418,    -1,  1727,  1728,  1729,    -1,   224,   225,    -1,    -1,
      -1,    -1,    -1,    -1,   476,    -1,    -1,   435,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    99,  5310,
      -1,    -1,    -1,    -1,   252,  1549,    -1,    -1,   456,    -1,
      -1,    -1,    -1,    -1,    -1,  1559,    -1,    -1,    -1,    -1,
     468,   288,    -1,    -1,    -1,   292,   474,    -1,    -1,    -1,
      -1,   479,    -1,    -1,    -1,   302,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   492,   312,    -1,   295,    -1,    -1,
      -1,   152,    -1,    -1,    -1,    -1,    -1,   324,    -1,  1603,
    1604,    -1,   310,    -1,   165,   313,    -1,    -1,   516,    -1,
     171,    -1,  1827,    -1,    -1,    -1,   177,    -1,    -1,    -1,
      -1,    -1,   183,    -1,  1839,   186,    -1,   535,  6117,   190,
     538,    -1,    -1,    -1,    -1,  1850,    -1,    -1,    -1,    -1,
     367,    -1,  1646,   370,   371,  1649,  1650,  1862,    -1,    -1,
      -1,  1866,    -1,  6142,    -1,    -1,    -1,    -1,    -1,   220,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1885,   722,    -1,    -1,    -1,   402,    -1,    -1,  1893,    -1,
     731,    -1,    25,    -1,    -1,    -1,  1901,   738,    31,    -1,
     741,    -1,   253,    -1,    -1,    -1,    -1,    -1,    -1,   407,
      -1,    -1,    -1,    -1,    -1,  1920,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1929,    -1,    -1,  1932,    -1,    -1,
    1935,    -1,    -1,  1938,  1939,    -1,    -1,  1942,  1943,    -1,
    1945,  1946,    -1,    76,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1957,   304,  1959,  1960,    -1,   308,    -1,   476,
      -1,    -1,    -1,   314,  1969,  1970,    -1,  1972,  1973,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6255,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     133,    -1,    -1,    -1,    -1,  2010,    -1,   140,    -1,  2014,
    2015,   144,    -1,    -1,    -1,    -1,   514,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   375,   523,   524,   525,   526,   527,
     528,   529,   530,   531,    -1,    -1,    -1,    -1,   536,   172,
      -1,   539,    -1,    -1,  2049,    -1,  2051,    -1,    -1,    -1,
    1844,  2056,  2057,    -1,    -1,    -1,    -1,    -1,  2063,  2064,
    2065,  2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,  2074,
    2075,    -1,    -1,    -1,  2079,   208,  2081,    -1,  2083,  2084,
    2085,  2086,  2087,  2088,   435,    -1,  2091,    -1,  2093,  2094,
      -1,    -1,  2097,    -1,    -1,  5656,    -1,  6376,    -1,    -1,
    5661,  5662,    -1,    17,    -1,    -1,  2111,  2112,  2113,  2114,
      -1,    -1,    26,    -1,   465,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2130,    -1,  2132,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,   489,    13,
     491,   492,    -1,    17,    18,    19,    -1,    -1,    25,    -1,
      -1,    -1,    -1,    -1,    31,   288,    -1,    -1,    -1,   292,
      -1,    35,   513,    -1,    -1,    -1,    -1,    -1,    -1,   302,
      -1,    45,    -1,    38,    -1,    -1,    -1,    -1,    52,   312,
      -1,    -1,   533,    -1,    -1,   536,   537,   538,    -1,    10,
      -1,   324,    13,    -1,    -1,    60,    17,    18,    19,    76,
      -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1054,    35,    -1,    -1,  5778,    -1,  1060,
      -1,    86,    -1,  1064,    45,  1066,    -1,    -1,    -1,    -1,
      -1,    52,    -1,    -1,   367,    -1,    -1,   370,   371,    25,
      -1,    -1,    -1,    -1,    -1,    31,    -1,   112,   113,    -1,
      -1,    -1,    -1,    -1,    -1,   120,   133,    78,    -1,    -1,
      -1,    -1,    -1,   140,    -1,  2059,  2060,   144,    -1,   402,
      -1,    -1,  2277,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5841,    -1,  2076,  2077,    -1,    -1,  2726,    -1,    -1,  1130,
      76,  1132,  1133,    -1,   159,   172,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2744,    -1,    -1,    -1,  2748,    -1,
      -1,    -1,  2752,  2107,    -1,    -1,   181,    -1,    -1,    -1,
      -1,    -1,   196,    -1,    -1,    -1,  2331,   201,    -1,    -1,
      -1,   208,    -1,    -1,    -1,    -1,  2776,    -1,    -1,   204,
      -1,    -1,    -1,   476,    -1,    -1,    -1,   133,    -1,    -1,
     224,   225,    -1,    -1,   140,    -1,    -1,    -1,   144,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2810,    -1,    -1,    -1,    -1,   196,    -1,    -1,   252,    -1,
     201,    -1,  2387,    -1,    -1,    -1,   172,    -1,    -1,    -1,
    2830,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      25,    -1,   267,   224,   225,    -1,    31,   272,    -1,    -1,
      -1,   288,    -1,    -1,    -1,   292,    -1,    -1,    -1,    -1,
      -1,   295,   208,   288,    -1,   302,    -1,   292,  2868,    -1,
      -1,   252,    -1,    -1,    -1,   312,   310,    -1,    -1,   313,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   324,    -1,    -1,
      -1,    76,    -1,    -1,    -1,  2895,    -1,    -1,   323,    -1,
      -1,  2901,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   295,  2915,    -1,    -1,    -1,    -1,
      -1,    -1,  2922,    -1,    -1,  2925,    -1,    -1,    -1,   310,
     367,  2931,   313,   370,   371,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   288,    -1,    -1,    -1,   292,   372,   133,    -1,
      -1,  2951,    -1,    -1,    -1,   140,   302,  2957,    -1,   144,
      -1,    -1,    -1,    -1,  2964,   402,   312,    -1,    -1,    -1,
      -1,   396,    -1,   407,    -1,    -1,    -1,    -1,   324,    -1,
    2980,    -1,    -1,    -1,    -1,    -1,    -1,   172,    -1,    -1,
      -1,    -1,    -1,   418,  2994,   420,    -1,    -1,   423,    -1,
      -1,    -1,    -1,    -1,    -1,  3005,    -1,    -1,  2573,  2574,
    2575,  2576,  2577,  2578,  2579,  2580,  2581,    -1,  2583,    -1,
      -1,   367,    -1,   208,   370,   371,   407,    -1,    -1,  2594,
      -1,  2596,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   476,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   402,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2634,
      -1,    -1,    -1,  2638,    -1,    -1,  2641,    -1,  2643,    -1,
     514,  2646,    -1,    -1,    -1,  2650,    -1,    -1,    -1,   523,
     524,   525,   526,   527,   528,   529,   530,   531,    -1,    -1,
      -1,    -1,    -1,   288,    -1,   539,  2671,   292,  2673,    -1,
     535,    -1,    -1,    -1,    -1,    -1,    -1,   302,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2690,    -1,   312,    -1,    -1,
     476,    -1,    -1,   514,  2699,  2700,    -1,    -1,    -1,   324,
      -1,    -1,   523,   524,   525,   526,   527,   528,   529,   530,
     531,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   539,    -1,
      -1,  2726,    -1,    -1,    -1,    -1,    -1,    -1,  2733,    -1,
      -1,    -1,  2737,  2738,    -1,    -1,    -1,    -1,    -1,  2744,
      -1,    -1,   367,  2748,    -1,   370,   371,  2752,    -1,    -1,
      -1,    -1,    -1,   667,    -1,    -1,  2761,    -1,    -1,    10,
      -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,
      -1,  2776,    -1,    -1,  2779,    -1,    -1,   402,    -1,    -1,
    3220,    -1,    -1,    -1,    35,  2790,    -1,  2792,  2793,    -1,
    2795,  2796,  6353,  2798,    45,    -1,    -1,    -1,    -1,  3239,
      -1,    52,    -1,   717,   718,  2810,  3246,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2830,  2831,    78,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2845,    -1,    -1,    25,    -1,    -1,    -1,    -1,    -1,    31,
      -1,   476,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2867,  2868,    -1,    -1,  2871,  2661,  2662,    -1,
      -1,    -1,    -1,  2667,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2895,    -1,  2897,    -1,    76,    -1,  2901,    -1,    -1,   813,
      -1,    -1,    -1,    -1,    -1,  2699,  2700,    -1,    -1,    -1,
    2915,    -1,    -1,    -1,    -1,    -1,    -1,  2922,    -1,   833,
    2925,    -1,    -1,    -1,    -1,    -1,  2931,   841,    -1,    -1,
     844,   845,   846,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   196,  2951,    -1,    -1,    -1,
     201,   133,  2957,    38,    -1,    -1,    -1,    -1,   140,  2964,
      -1,    10,   144,    -1,    13,    -1,    -1,  2761,    17,    18,
      19,    -1,    -1,   224,   225,  2980,    -1,    62,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,  2994,
     172,    -1,    -1,    -1,  2999,    -1,    45,    -1,    -1,    -1,
    3005,   252,    -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    98,    -1,    -1,    -1,    -1,  3023,  3024,
    3025,    -1,    -1,    -1,  3029,    -1,   208,    -1,    -1,    78,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,
      -1,    -1,    13,    -1,   295,    -1,    17,    18,    19,    -1,
      -1,  3056,  3057,    -1,  2848,    -1,    -1,    -1,    -1,   310,
    3065,    -1,   313,    -1,    35,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    45,    -1,   161,    -1,    -1,    -1,
      -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,  1929,    -1,
      -1,  1932,    -1,  3098,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1942,  1943,    -1,    -1,    -1,   288,    78,    -1,    -1,
     292,    -1,    -1,   198,    -1,    -1,  1957,    -1,    -1,  1960,
     302,    -1,    -1,    -1,    -1,  3130,    -1,    -1,    -1,  3134,
     312,    -1,    -1,    -1,    -1,  1049,    -1,    -1,    -1,    -1,
      -1,    -1,   324,  2937,    -1,    -1,    -1,   196,  3588,    -1,
      -1,  2945,   201,    -1,  2948,    -1,   407,    -1,   243,    -1,
      -1,    -1,    -1,   248,    -1,    -1,  2960,    -1,    -1,  2010,
      -1,    -1,    -1,  2014,  2015,   224,   225,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   367,    -1,    -1,   370,   371,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   252,    -1,    -1,    -1,   292,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3220,    -1,  3222,    -1,    -1,
     402,    -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,
     201,    -1,  3237,    -1,  3239,    -1,    -1,    -1,    -1,    -1,
     325,  3246,    -1,    -1,    -1,  3250,   295,  3252,  3253,    -1,
    3255,  3256,  3257,   224,   225,    -1,    -1,  3697,    -1,    -1,
    3265,   310,    -1,   514,   313,  3270,    -1,    -1,    -1,    -1,
      -1,    -1,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   252,  3287,    -1,    -1,   536,   371,    -1,    -1,    -1,
      -1,   376,    -1,    -1,   476,    -1,    -1,    -1,    -1,    -1,
     385,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   394,
      -1,    -1,    -1,    -1,  3319,  3320,  3321,   402,    -1,  3324,
      -1,    -1,    -1,    -1,   295,    -1,  1240,  3332,  3333,  3334,
    3335,   416,    -1,    -1,    -1,    -1,    -1,    -1,  3343,   310,
     425,    -1,   313,  3348,  3349,   430,  3351,    -1,  3353,    -1,
      -1,    -1,    -1,  1267,    -1,    -1,    -1,    -1,   407,    -1,
    3365,  3366,    -1,    -1,  3369,    -1,   451,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3390,    -1,  3392,    10,  3394,
    3830,    13,    -1,    -1,    -1,    17,    18,    19,    -1,    25,
      -1,    -1,   487,    -1,    -1,    31,   491,    -1,  3413,    -1,
      -1,    -1,    -1,    35,    -1,  3209,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,  3434,
      52,    -1,    -1,    -1,    -1,    -1,   407,    -1,    -1,    -1,
      -1,    -1,  1356,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      76,  1365,    -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   514,  3471,  1381,    -1,  3474,
      -1,    -1,    -1,    -1,   523,   524,   525,   526,   527,   528,
     529,   530,   531,  3488,    -1,    -1,  1400,   536,  3493,  1403,
    1404,    -1,    -1,    -1,  1408,  1409,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3508,    -1,    -1,    -1,   133,    -1,    -1,
      -1,    -1,    -1,    -1,   140,    -1,    -1,  3522,   144,    -1,
      -1,    -1,    -1,    -1,    -1,  3530,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3542,    -1,    -1,
    3545,    -1,  3547,   514,    -1,    -1,   172,  3552,    -1,    -1,
      -1,    -1,   523,   524,   525,   526,   527,   528,   529,   530,
     531,    -1,  3567,  3568,    -1,   536,    -1,    -1,  3573,  4009,
      -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,   201,
      -1,    -1,   208,  3588,    -1,    -1,  3591,    -1,  4028,  3594,
      -1,    -1,  4032,    -1,    -1,    -1,    -1,  3602,    -1,    -1,
      -1,    -1,   224,   225,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3627,    25,    -1,    -1,    -1,    -1,  3633,    31,
     252,    -1,    -1,    -1,    -1,    -1,    38,    -1,  3432,    -1,
    3434,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3450,    -1,    60,    -1,
      -1,    -1,   288,    -1,    -1,    -1,   292,  3672,  3673,  3674,
      -1,    -1,    -1,   295,    76,    -1,   302,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   312,    -1,   310,    -1,
      -1,   313,  3697,    -1,    -1,    -1,    -1,    -1,   324,    -1,
      -1,  3706,    -1,  3708,    -1,    -1,  3500,  3501,    -1,    -1,
     112,  3716,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   133,    -1,  3738,    -1,    -1,    -1,    -1,   140,    -1,
      -1,   367,   144,    -1,   370,   371,    -1,    -1,    -1,  1663,
      -1,    -1,    -1,    -1,    -1,    -1,    51,  1671,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     172,    -1,    -1,    -1,    -1,    10,   402,    -1,    13,    -1,
      -1,    -1,    17,    18,    19,   407,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,
      35,  3806,   204,    17,    18,    19,   208,    -1,    -1,    -1,
      45,    -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,
      -1,    35,    -1,    -1,    -1,  3830,    -1,    -1,    -1,    -1,
    3835,    45,  2673,    -1,    -1,    -1,  3841,    -1,    52,    -1,
      -1,    -1,    -1,    78,    -1,  3850,    -1,    -1,    -1,    -1,
     476,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    78,   267,    -1,    -1,    -1,    -1,
     272,    -1,  3877,  3878,    -1,    -1,    -1,    -1,  3883,    -1,
    3885,    -1,    -1,    -1,    -1,    -1,   288,    -1,    -1,    -1,
     292,    -1,   514,  3898,    -1,  3900,  4336,    -1,    -1,    -1,
     302,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     312,    -1,    -1,    -1,   536,  3920,    -1,    -1,    -1,    -1,
      -1,   323,   324,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3946,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2790,
      -1,    -1,  2793,    -1,  2795,  2796,    -1,    -1,    -1,    -1,
      -1,   196,  3967,  3968,    -1,   367,   201,    -1,   370,   371,
     372,    -1,    -1,    -1,  1888,    -1,    -1,    -1,  1892,    -1,
      -1,    -1,   196,    -1,    -1,  3990,    -1,   201,    -1,   224,
     225,    -1,    -1,    -1,   396,    -1,    -1,    -1,    -1,    -1,
     402,    -1,    -1,    -1,  4009,    -1,    -1,    -1,    -1,    -1,
     224,   225,    -1,    -1,    -1,    -1,   418,   252,    -1,    -1,
      -1,    -1,    -1,  4028,    -1,    -1,    -1,  4032,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   252,  4479,
      -1,    -1,  4482,    -1,    -1,    -1,    -1,    -1,  4053,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     295,    -1,    -1,    -1,  4069,    25,    -1,  4072,    -1,    -1,
      -1,    31,    -1,  4078,   476,   310,    -1,    -1,   313,    -1,
      -1,   295,    -1,    -1,  3878,    -1,    -1,  4092,    -1,    -1,
      -1,  4096,  4097,  4098,    -1,    -1,   310,    -1,  4103,   313,
      -1,  4106,    -1,    -1,  4109,    -1,    -1,  3901,    -1,    -1,
    4115,    -1,  4117,    -1,    -1,  4120,    76,    -1,    -1,  4124,
    4125,  4126,  4127,  4128,    -1,    -1,  4131,  4132,  4133,  4134,
    4135,  4136,  4137,  4138,  4139,  4140,    -1,    -1,    -1,  4144,
    4145,  4146,    -1,  4583,  4149,    -1,    -1,    -1,  2062,  4154,
      -1,    -1,    -1,    -1,  4159,    -1,  4161,    -1,  4163,    -1,
    4600,    -1,    -1,    -1,    -1,    -1,  4171,    -1,    -1,  4174,
      -1,  4176,   407,   133,    -1,    -1,    -1,    -1,    -1,    -1,
     140,    -1,    -1,    -1,   144,    -1,    -1,  4192,    -1,    -1,
    4195,  4196,    -1,   407,    -1,  4200,  4201,    -1,    -1,    -1,
    4205,    -1,  4207,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   172,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4236,    -1,    -1,    -1,    -1,    -1,  4242,    -1,    -1,
      -1,  4681,    -1,    -1,    -1,  4250,    -1,    -1,   208,  4254,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3098,    -1,    -1,
      -1,    -1,    -1,    -1,  4058,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   514,
      -1,    -1,  4287,    -1,    -1,    -1,    -1,    -1,   523,   524,
     525,   526,   527,   528,   529,   530,   531,    -1,    -1,  4304,
     514,   536,    -1,    -1,    -1,  4310,    -1,    -1,    -1,   523,
     524,   525,   526,   527,   528,   529,   530,   531,    -1,    -1,
      -1,    -1,   536,    -1,    -1,    -1,    -1,    -1,   288,    -1,
      -1,  4336,   292,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   302,    -1,    -1,    25,    -1,    -1,    -1,    -1,
      -1,    31,   312,    -1,  4359,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   324,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4398,    -1,    -1,    76,    -1,  4403,  4404,
    4405,    -1,    -1,    -1,    -1,    -1,    -1,   367,    -1,  3250,
     370,   371,  3253,    10,  3255,  3256,    13,    -1,    -1,    -1,
      17,    18,    19,    -1,    -1,    -1,  4431,  4432,    -1,    -1,
      -1,    -1,   727,    -1,    -1,    -1,    -1,    -1,    35,    -1,
      -1,    -1,   402,    10,    -1,    -1,    13,    -1,    45,    -1,
      17,    18,    19,   133,    -1,    52,    -1,    -1,   753,    -1,
     140,    -1,    -1,    -1,   144,    -1,    -1,    -1,    35,    -1,
      -1,    -1,    -1,    -1,  4479,    -1,    -1,  4482,    45,    -1,
      -1,    78,    -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,
      -1,    -1,   172,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    -1,    -1,    -1,    10,   476,    -1,    13,    -1,
      -1,    -1,    17,    18,    19,    -1,    -1,    -1,   208,    -1,
      -1,  4971,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      35,  4546,    -1,  4983,    -1,    10,    -1,    -1,    13,    -1,
      45,    -1,    17,    18,    19,    -1,    -1,    52,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4572,  4573,    -1,
      35,  4576,    -1,    -1,    -1,    -1,    -1,    -1,  4583,    -1,
      45,    -1,    -1,    78,    -1,  4590,  4591,    52,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4600,    -1,    -1,    -1,   196,
      -1,   896,    -1,    -1,   201,    -1,    -1,    -1,   288,    -1,
    4404,    -1,   292,    78,    -1,    -1,    -1,    -1,  4623,    -1,
      -1,    -1,   302,  4628,  4629,  4630,    -1,   224,   225,   196,
    3471,    -1,   312,  3474,   201,  4640,    -1,    -1,  4432,    -1,
      -1,    -1,    -1,    -1,   324,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4446,    -1,    -1,   252,    -1,   224,   225,    -1,
      -1,    -1,    -1,  4457,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4681,    -1,    -1,  4684,
      -1,  3522,    -1,    -1,    -1,   252,    -1,    -1,    -1,  3530,
     370,   371,    -1,    -1,    -1,    -1,    -1,    -1,   295,  2613,
      -1,   196,    -1,    -1,    -1,  4710,   201,    -1,    -1,    -1,
      -1,    -1,    -1,   310,    -1,    -1,   313,    -1,    -1,    -1,
      -1,  4726,   402,    -1,    -1,    -1,    -1,    -1,   295,   224,
     225,   196,    -1,    -1,    -1,    -1,   201,    -1,    -1,  4744,
      -1,  4535,  4536,   310,    -1,  1040,   313,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   252,    -1,   224,
     225,    -1,  5202,    -1,  1059,    -1,    -1,  4772,    -1,    -1,
    4775,    -1,    -1,    -1,    -1,  1070,    -1,    -1,  4783,  4784,
      -1,  4786,    -1,    -1,    -1,  4790,  4791,   252,    -1,    -1,
    4795,  1086,    -1,    -1,    -1,  4800,   476,    -1,  4803,  4804,
     295,    -1,    -1,    -1,    -1,  4810,    -1,    -1,    -1,    -1,
     407,    -1,    -1,    -1,    -1,   310,    -1,    -1,   313,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4832,    -1,  4623,
     295,    -1,    -1,    -1,  4839,    -1,    -1,    -1,    -1,  4844,
     407,    -1,  4847,  4848,    -1,   310,    -1,  2761,   313,    -1,
    4855,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4866,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4874,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4676,    -1,    62,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5332,    -1,  5334,    -1,  4901,    -1,    -1,    -1,
      -1,    -1,    -1,  2817,    -1,    -1,    -1,    -1,    -1,  4914,
      -1,    -1,   407,    -1,  4919,    -1,    -1,   514,    -1,    -1,
      98,    -1,    -1,    -1,    -1,    -1,   523,   524,   525,   526,
     527,   528,   529,   530,   531,    -1,    -1,    -1,    -1,   536,
      -1,    -1,   407,    -1,    -1,    -1,    -1,   514,  1243,  4954,
      -1,    -1,    -1,    -1,    -1,    -1,   523,   524,   525,   526,
     527,   528,   529,   530,   531,    -1,  4971,    -1,    -1,   536,
      -1,  4976,    -1,    -1,    -1,    -1,    -1,    -1,  4983,    -1,
      -1,    -1,    -1,   161,    -1,    -1,    -1,    -1,    -1,  2903,
      -1,    -1,    -1,    -1,  4999,    -1,    -1,    -1,    -1,    -1,
      -1,  5006,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5017,  2927,    -1,    -1,    62,    -1,    -1,   514,
     198,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   523,   524,
     525,   526,   527,   528,   529,   530,   531,    -1,    -1,    -1,
      -1,   536,    -1,    -1,    -1,  5050,    -1,    -1,    -1,   514,
      -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,   523,   524,
     525,   526,   527,   528,   529,   530,   531,    -1,    -1,   534,
     248,  5076,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2993,
      -1,    -1,    -1,  2997,    -1,    -1,    -1,  5092,    -1,    -1,
      -1,    -1,  5097,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     288,  5116,    -1,    -1,   292,   161,    -1,    -1,  5123,    -1,
    3034,    -1,  3036,    -1,  3038,  3039,    -1,    -1,    -1,  3043,
    3044,  3045,    -1,  3047,  3048,  3049,    -1,    -1,    -1,    -1,
      -1,    -1,  4936,    -1,    -1,    -1,   324,   325,  4942,    -1,
      -1,    -1,   198,  4947,    -1,    -1,    62,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5169,    -1,  5171,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,
    4974,  4975,    17,    18,    19,  4979,  4980,  3101,    -1,   367,
      -1,    -1,    98,   371,    -1,    -1,    -1,  5202,   376,    -1,
      35,    -1,   248,    -1,    -1,    -1,    -1,   385,    -1,  1504,
      45,    -1,  3126,    -1,    -1,    -1,   394,    52,    -1,    -1,
      -1,    -1,    -1,  5228,   402,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5238,    -1,    -1,  5241,    -1,   416,  5244,
    5245,  5246,   288,    78,    -1,    -1,   292,   425,    -1,    -1,
      -1,    -1,   430,    -1,    -1,   161,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5269,  5270,    10,    -1,  5273,    13,
      -1,    -1,    -1,    17,    18,    19,  1571,    -1,   324,   325,
      -1,    -1,    -1,    -1,    -1,  5290,    -1,    -1,    -1,  5294,
      -1,    35,   198,    -1,    -1,  5300,    -1,    -1,    -1,  5304,
      -1,    45,    -1,    -1,    -1,  5310,  5311,    -1,    52,   487,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1612,    -1,  5324,
      -1,   367,  5327,    -1,    -1,   371,    -1,  5332,    -1,  5334,
     376,    -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,   385,
      -1,    -1,   248,    -1,    -1,    -1,    -1,    -1,   394,    -1,
    1645,  5356,    -1,    -1,    -1,    -1,   402,    -1,    -1,    -1,
      -1,   196,    -1,    -1,    -1,    -1,   201,    -1,    -1,    -1,
     416,    -1,    -1,    -1,    -1,    -1,  5381,  5382,    -1,   425,
      -1,    -1,   288,    -1,   430,    -1,   292,  5392,    -1,   224,
     225,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4250,
      -1,    -1,    -1,  4254,    -1,    -1,    -1,   252,   324,   325,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5436,  1727,  1728,  1729,    -1,  5441,    -1,    -1,    -1,
      -1,   487,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   196,    -1,    -1,    -1,    -1,   201,    -1,    -1,
     295,   367,    -1,    -1,    -1,   371,    -1,    -1,    -1,    -1,
     376,    -1,    -1,    -1,    -1,   310,    -1,    -1,   313,   385,
     224,   225,    -1,    -1,    -1,    -1,    -1,    -1,   394,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   402,  5502,    -1,    -1,
    5505,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   252,    -1,
     416,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4359,   425,
    3434,    -1,    -1,    -1,   430,    -1,    -1,    -1,    -1,    -1,
      -1,  5536,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1839,    -1,    -1,    -1,  5553,    -1,
      -1,   295,  5557,    -1,  5559,  1850,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   310,    -1,  5573,   313,
      -1,  1866,   407,    -1,    -1,    -1,  5581,    -1,    -1,  5584,
      -1,   487,    -1,    -1,    -1,    -1,    -1,  5381,    -1,    -1,
    5595,    -1,    -1,    -1,    -1,    -1,    -1,  5602,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      51,    -1,    -1,    -1,    -1,    -1,  6056,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1920,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1935,    -1,    -1,  1938,  1939,  5650,    -1,    -1,    -1,    -1,
      -1,  5656,    -1,    -1,    -1,    -1,  5661,  5662,    -1,    -1,
      -1,  5666,    -1,   407,    -1,    -1,    -1,  5672,  5673,  5674,
      -1,    -1,    -1,    -1,  1969,  1970,    -1,  3591,    -1,   514,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5692,   523,   524,
     525,   526,   527,   528,   529,   530,   531,    -1,    -1,    -1,
      -1,   536,    -1,    -1,    -1,    -1,    -1,  5712,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5720,    -1,    -1,  5723,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5748,    -1,    -1,    -1,    -1,    -1,  4590,
    4591,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3678,    -1,    -1,    -1,    -1,    -1,
     514,    -1,  5777,  5778,  2069,    -1,    -1,    -1,    -1,   523,
     524,   525,   526,   527,   528,   529,   530,   531,  2083,    -1,
      -1,  2086,   536,    -1,    -1,    -1,  5801,  5802,    -1,    -1,
      -1,    -1,    -1,    -1,    10,    -1,    -1,    13,  5813,    -1,
      -1,    17,    18,    19,    -1,    -1,  2111,  5822,  5823,  5824,
      -1,    -1,  3736,    -1,    -1,    -1,    -1,    -1,    -1,    35,
      -1,    -1,  5837,  5838,    -1,    -1,  5841,    -1,    -1,    45,
      -1,  5846,    -1,  5848,    -1,  5850,    52,    51,    -1,    -1,
      -1,    -1,  5857,    -1,    -1,    -1,    -1,    -1,    -1,  5864,
      -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,    14,    15,
      -1,    -1,    78,    -1,    20,    -1,    22,    -1,  5883,    -1,
      -1,    -1,    28,    -1,    30,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3808,    -1,    -1,    -1,  5692,    -1,
      -1,    -1,    -1,    49,    50,  5910,    -1,    -1,  5913,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3856,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3868,  3869,    -1,    -1,    -1,    -1,
      -1,  5966,    -1,    -1,  3878,    -1,    -1,    -1,    -1,  3883,
      -1,  3885,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     196,  4832,    -1,    -1,    -1,   201,    -1,    -1,  4839,    -1,
      -1,    -1,    -1,  4844,    -1,    -1,  4847,  4848,    -1,    -1,
      -1,    -1,  6017,    -1,    -1,    -1,    -1,  3931,   224,   225,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6032,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6042,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   252,    -1,    -1,    -1,
      -1,  6056,  3966,  3967,   200,    -1,    -1,    -1,   204,    -1,
      -1,    -1,    -1,    -1,    -1,  6070,   212,    51,    -1,   215,
      -1,    -1,   218,   219,    -1,   221,    -1,   223,  6083,    -1,
     226,    -1,   228,    -1,    -1,    -1,    -1,    -1,    -1,   295,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   310,    -1,  5900,   313,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6125,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6143,  6144,
      -1,    -1,    -1,    -1,  6149,    -1,    -1,    -1,    -1,    -1,
      -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,    -1,  6180,  6181,    -1,    -1,  6184,
      -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    35,
      -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,    45,
      -1,   407,    51,    -1,    -1,    -1,    52,    -1,    -1,    35,
      -1,    -1,    -1,    -1,    -1,    -1,  6221,    -1,    -1,    45,
      -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,    -1,
      -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6245,    -1,    -1,    -1,    -1,    -1,  6251,    -1,    -1,    -1,
      -1,  5092,    78,    -1,    -1,    -1,  4170,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6269,    -1,    -1,    -1,    -1,    -1,
      -1,  6276,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5123,    -1,    -1,    -1,   727,  6292,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2596,    -1,    -1,    -1,  6310,    -1,    -1,   514,    -1,
      -1,    -1,   753,    -1,    -1,    -1,    -1,   523,   524,   525,
     526,   527,   528,   529,   530,   531,    -1,    -1,    -1,    -1,
     536,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6348,    -1,    -1,    -1,    -1,  6353,    -1,
     196,    -1,    -1,    -1,  6359,   201,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6372,    -1,    -1,
     196,    -1,    -1,    -1,  6379,   201,    -1,    -1,   224,   225,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,   225,
      -1,    -1,    -1,    -1,    -1,    -1,   252,    -1,    -1,    -1,
      -1,    -1,  6417,  6418,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   252,    -1,    -1,  6434,
      -1,    -1,    -1,  6438,    -1,    -1,    -1,    -1,  2733,    -1,
      -1,    -1,  2737,  2738,    -1,    -1,  6451,  6452,    -1,   295,
      -1,    -1,    -1,    -1,    -1,   896,    -1,    -1,  6463,    -1,
      -1,    -1,    -1,  5304,   310,    -1,    -1,   313,    -1,   295,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5324,   310,    -1,    -1,   313,    -1,    -1,
    4404,    -1,    -1,    -1,    -1,    -1,    -1,  2792,    -1,    -1,
      -1,    -1,    -1,  2798,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5356,    -1,    -1,  4432,   665,
      -1,    -1,    -1,   727,    -1,    -1,    -1,    -1,    -1,    -1,
     676,    -1,    -1,  4447,   680,    -1,  4450,    -1,  4452,    -1,
      -1,   687,   688,    -1,    -1,   691,    -1,   693,   694,   753,
    2845,  5392,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   407,   708,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     726,   407,    -1,    -1,    -1,  6379,  4500,    -1,    -1,    -1,
      10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,
    5441,   747,  4516,   749,    -1,    -1,    -1,  4521,    -1,    -1,
      -1,    -1,    -1,   759,    -1,    35,    -1,    -1,  1059,    -1,
      -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,  1070,
      -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6438,  1086,   792,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    -1,
      -1,  5502,    -1,    -1,    -1,    -1,    -1,    -1,   514,  6463,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   523,   524,   525,
     526,   527,   528,   529,   530,   531,    -1,    -1,   514,    -1,
     536,    -1,   896,    -1,    -1,    -1,    -1,   523,   524,   525,
     526,   527,   528,   529,   530,   531,  4620,    -1,    -1,  4623,
     536,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   873,    -1,    -1,
    3025,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5581,    -1,    -1,   727,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3057,    -1,    -1,    -1,    -1,    -1,    -1,   753,
      -1,    -1,    -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,
      -1,   201,    -1,    -1,    -1,  4699,  4700,  4701,  4702,    -1,
    4704,  4705,  4706,  4707,  4708,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1243,    -1,   224,   225,    -1,    -1,    -1,    -1,
      -1,    -1,   958,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   727,    -1,    -1,
      -1,    -1,   252,    -1,    -1,  3130,    -1,    -1,    10,  3134,
      -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,
      -1,    -1,    -1,   753,    -1,  1059,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    35,    -1,    -1,  1070,    -1,    -1,    -1,
      -1,    -1,    -1,    45,    -1,   295,    -1,    -1,   727,  5720,
      52,    -1,  1086,    -1,    -1,    -1,  1032,    -1,    -1,    -1,
     310,    -1,    -1,   313,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   753,    -1,    78,  5748,  4822,    -1,
    4824,  1057,   896,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1072,    -1,  1074,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1084,    -1,
      10,    -1,  3237,    13,    -1,  1091,    -1,    17,    18,    19,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3252,    -1,    -1,
      -1,    -1,  3257,    -1,    -1,    35,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,
      -1,    -1,    52,    -1,    -1,    -1,    -1,   407,  1134,    -1,
    1136,    -1,  3287,    -1,    -1,    -1,   896,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5857,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,   201,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1243,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   896,    -1,    -1,
      -1,    -1,   224,   225,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1504,  1210,    -1,  1212,    -1,  1214,    -1,
    1216,    -1,  1218,  1219,  1220,  1059,    -1,    -1,    -1,  1225,
     252,    -1,    -1,    -1,    -1,    -1,  1070,    -1,    -1,    -1,
      -1,  1237,    -1,    -1,   514,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1086,   523,   524,   525,   526,   527,   528,   529,
     530,   531,    -1,    -1,    -1,    -1,   536,    -1,    -1,    -1,
      -1,    -1,    -1,   295,    -1,  5966,   196,    -1,    -1,    -1,
    1571,   201,    -1,    -1,  5048,  5049,    -1,    -1,   310,    -1,
      -1,   313,    -1,    -1,    -1,    -1,    -1,  5061,    -1,  5063,
    5064,  5065,    -1,    -1,   224,   225,    -1,    -1,    -1,  1059,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1070,  1612,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   252,    -1,    -1,    -1,  1086,    -1,    10,    -1,
      -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,  1403,
      -1,    -1,    -1,    -1,  1645,    -1,    -1,    -1,    -1,    -1,
    1059,    -1,    -1,    35,    -1,  5129,    -1,    -1,    -1,    -1,
      -1,  1070,    -1,    45,    -1,   295,    -1,    -1,    -1,  6070,
      52,    -1,    -1,    -1,    -1,   407,    -1,  1086,    -1,    -1,
     310,    -1,    -1,   313,    -1,    -1,    -1,  3542,    -1,    -1,
    3545,    -1,  3547,    -1,  5168,    -1,    78,  3552,    -1,  1243,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1425,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6135,    -1,    -1,  5211,    -1,  3594,
    1504,    -1,  6143,  6144,    -1,    -1,    -1,  3602,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3627,    -1,    -1,    -1,    -1,   407,    -1,    -1,
      -1,    -1,   514,  1243,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   523,   524,   525,   526,   527,   528,   529,   530,   531,
      -1,    -1,    -1,    -1,   536,    -1,    -1,  1571,    -1,    -1,
      -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,   201,
      -1,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,
      18,    19,    -1,    -1,  1243,    -1,    -1,    -1,  1839,  1545,
      -1,    -1,   224,   225,  6245,    -1,    -1,    35,  1612,  1850,
    6251,  3706,    -1,  3708,    -1,    -1,    -1,    45,    -1,    -1,
      -1,    -1,    -1,    -1,    52,  1866,    -1,    -1,  6269,    -1,
     252,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1645,    -1,    -1,   514,    -1,    -1,    -1,    -1,    -1,
      78,    -1,    -1,   523,   524,   525,   526,   527,   528,   529,
     530,   531,    -1,    -1,    -1,    -1,   536,  5381,    -1,    -1,
      -1,  1617,    -1,   295,    -1,    -1,    -1,    -1,    -1,  1920,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   310,    -1,
      -1,   313,    -1,    -1,  1935,    -1,    -1,  1938,  1939,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6348,    -1,    -1,
      -1,  3806,    -1,    -1,    -1,    -1,    -1,  5431,    -1,    -1,
    1504,    -1,    -1,    -1,    -1,    -1,  5440,    -1,  1969,  1970,
      -1,  6372,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3835,    -1,    -1,    -1,    -1,    -1,  3841,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3850,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   196,    -1,
      -1,    -1,    -1,   201,    -1,    -1,    -1,  6418,    -1,    -1,
      -1,    -1,    -1,  3878,    -1,   407,    -1,  1571,    -1,    -1,
      -1,    -1,    -1,  6434,    -1,    -1,   224,   225,    -1,    -1,
      -1,    -1,    -1,    -1,  1504,    -1,    -1,    -1,    -1,    -1,
    6451,  6452,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   252,    -1,    -1,    -1,  1612,    -1,
      -1,    -1,    -1,    -1,    -1,  1839,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1850,    -1,    -1,    -1,
      -1,  3946,    -1,    -1,    -1,  1504,    -1,    -1,    -1,    -1,
      -1,  1645,  1866,    -1,    -1,    -1,    -1,   295,    -1,    -1,
    2111,  1571,    -1,  3968,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   310,    -1,    -1,   313,    -1,    -1,    -1,  1835,
      -1,    -1,   514,    -1,    -1,  3990,    -1,    -1,    -1,    -1,
      -1,   523,   524,   525,   526,   527,   528,   529,   530,   531,
      -1,    -1,  1612,    -1,   536,    -1,  1920,    -1,    -1,    -1,
      -1,    -1,  1571,    -1,  1870,    -1,    -1,    -1,    -1,    -1,
      -1,  1935,    -1,    -1,  1938,  1939,    -1,    23,    -1,    -1,
      -1,    -1,    28,    -1,    -1,  1645,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1612,    -1,  1969,  1970,    -1,    -1,    -1,
    1916,    -1,    -1,    -1,    -1,    -1,    -1,  4072,  5692,   407,
      66,    -1,  5696,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1936,    -1,    -1,    79,    80,    -1,  1645,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    92,    -1,    -1,    -1,
      96,    -1,    -1,    -1,    -1,    -1,  1962,    -1,  1964,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,  4124,
      -1,    -1,    -1,  1979,    -1,  1981,    -1,    -1,    -1,    -1,
      -1,  1987,    -1,  1989,    -1,  1991,    -1,  1993,    -1,  1995,
      -1,    -1,   138,  1999,  4149,  1839,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   151,  1850,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   160,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1866,    -1,    -1,    -1,   514,   173,    -1,    -1,
    2036,    -1,    -1,   179,    -1,   523,   524,   525,   526,   527,
     528,   529,   530,   531,    -1,    -1,    -1,  2111,   536,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     206,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1920,    -1,    -1,  1839,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1850,  1935,    -1,    -1,  1938,  1939,    -1,    -1,   244,    -1,
      -1,     0,    -1,    -1,    -1,    -1,  1866,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     266,    20,    -1,    -1,    -1,  1969,  1970,    -1,    -1,    -1,
    1839,    -1,    31,    -1,    33,    34,    -1,    -1,    -1,  5913,
      -1,  1850,    -1,  5917,    -1,  5919,    -1,    -1,    -1,  5923,
    5924,    -1,    51,    -1,    -1,  4310,    -1,  1866,    -1,    -1,
    1920,    -1,    61,    -1,   310,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    73,  1935,    75,    76,  1938,  1939,
      -1,    -1,    -1,    82,    -1,    84,    -1,    -1,    -1,    -1,
      -1,   337,    -1,    -1,    -1,    -1,    -1,    -1,    97,    -1,
      99,   347,   348,    -1,    -1,   351,    -1,    -1,    -1,  1969,
    1970,  1920,    -1,    -1,    -1,    -1,    -1,   116,    -1,    -1,
     119,    -1,    -1,    -1,    -1,    -1,  1935,    -1,    -1,  1938,
    1939,    -1,    -1,   379,    -1,   134,   382,   136,    -1,    -1,
     386,   140,    -1,   389,    -1,    -1,    -1,    -1,   147,  4404,
     396,    -1,    -1,   399,    -1,    -1,    -1,   156,    -1,   158,
    1969,  1970,    -1,    -1,    -1,    -1,   165,  2111,    -1,    -1,
      -1,    -1,    -1,    -1,   420,    -1,    -1,  4432,    -1,    -1,
      -1,    -1,   428,    -1,   183,    -1,    -1,    -1,    -1,   435,
      -1,    -1,   438,    -1,    -1,    -1,    -1,   443,    -1,    -1,
      -1,   200,    -1,    -1,    -1,   451,    -1,   453,    -1,    -1,
      -1,    -1,   458,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   485,
      -1,    -1,    23,    -1,    -1,    -1,    -1,    28,    -1,    -1,
      -1,  2111,    -1,    -1,    -1,   254,   255,    -1,    -1,    -1,
      -1,   260,    10,    -1,    -1,    13,    -1,    51,    -1,    17,
      18,    19,    -1,    -1,    -1,    -1,   275,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    66,    -1,    35,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   294,    -1,    45,    79,    -1,
      -1,    -1,  2111,    -1,    52,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,
      -1,  4576,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    -1,  2733,   114,    -1,    -1,  2737,  2738,    -1,    -1,
      -1,    -1,    -1,   342,    -1,    -1,    -1,  6221,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,   357,    -1,
      -1,    -1,    -1,    -1,   363,   364,    -1,   366,  4623,    -1,
     151,    -1,   371,  4628,    -1,    -1,    -1,    -1,   377,   160,
      -1,   380,    -1,    -1,    -1,    -1,    -1,    -1,   387,    -1,
      -1,  2792,   173,    -1,    -1,   394,   395,  2798,   179,    -1,
      -1,    -1,    -1,   402,    -1,    -1,    -1,   406,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   418,
      -1,    -1,    -1,    -1,    -1,   206,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   435,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2845,    -1,    -1,    -1,   196,    -1,
      -1,    -1,    -1,   201,    -1,    -1,    -1,   456,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   468,
      -1,    -1,    -1,    -1,    -1,   474,   224,   225,    -1,    -1,
     479,    -1,    -1,    -1,    -1,   266,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   492,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   252,  6379,    -1,    -1,    -1,    -1,
      -1,    -1,  6386,    -1,    -1,    -1,  6390,   516,    -1,   518,
     519,   520,   521,   522,    -1,    -1,    -1,    -1,    -1,   310,
      -1,  4786,    -1,    -1,    -1,    -1,   535,    -1,    -1,   538,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   295,    -1,    -1,
    6424,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   310,    -1,  6438,   313,   347,   348,    -1,  2733,
     351,    -1,    -1,  2737,  2738,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6463,
      -1,    -1,  6466,    -1,    -1,    -1,    -1,    -1,   379,    -1,
      -1,   382,    -1,    -1,    -1,    -1,    -1,    -1,   389,    -1,
      -1,    -1,    -1,    -1,    -1,   396,    -1,    -1,   399,    -1,
      -1,  2727,  2728,    -1,    -1,    -1,    -1,    -1,  2792,    -1,
      -1,    -1,    -1,    -1,  2798,    -1,    -1,    -1,    -1,   420,
    2746,  2747,    -1,  2749,  2750,    -1,  4901,   428,  2754,  2755,
      -1,    -1,    -1,    -1,   435,    -1,  3057,   438,    51,   407,
      -1,    -1,   443,  2769,    -1,    -1,    -1,  2773,    -1,    -1,
     451,  2777,  2778,    -1,    -1,  2781,  2782,   458,    -1,    -1,
      -1,  2845,  2788,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2800,    -1,    -1,    -1,    -1,  4954,
      -1,    -1,    -1,    -1,   485,    -1,  2812,    -1,    -1,    -1,
      -1,  2817,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4976,    -1,    -1,    -1,    -1,  2832,    -1,    -1,  3130,
    2836,    -1,    -1,  3134,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2847,    -1,    -1,  2850,    -1,  2852,  2853,  2854,    -1,
      -1,    -1,    -1,  2859,  2860,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2869,    -1,    -1,   514,    -1,    -1,  2875,
      -1,    -1,    -1,  2879,    -1,   523,   524,   525,   526,   527,
     528,   529,   530,   531,    -1,  2891,  2892,    -1,   536,  2733,
    2896,    -1,    -1,  2737,  2738,  5050,  2902,  2903,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2916,    -1,    -1,  2919,    -1,    -1,    -1,    -1,    -1,    -1,
    2926,  2927,    -1,    -1,    -1,    -1,  2932,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3237,    -1,  2944,    -1,
      -1,  2947,    -1,    -1,    -1,    -1,  2952,    -1,  2792,    -1,
      -1,  3252,  2958,  2959,  2798,    -1,  3257,    -1,    -1,    -1,
    2966,    -1,    -1,    -1,  2970,    -1,    -1,    -1,    -1,  2975,
    2976,  2977,  2978,  2733,    -1,  2981,    -1,  2737,  2738,    -1,
      -1,    -1,    -1,    -1,    -1,    25,  3287,    -1,    -1,  2995,
    2996,    31,  2998,  3057,    -1,    -1,    -1,    -1,    38,    -1,
      -1,  2845,    -1,  3009,  3010,  3011,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5169,    -1,  5171,    -1,    -1,    -1,
      60,    -1,    -1,    -1,  2733,    -1,    -1,    -1,  2737,  2738,
      -1,    -1,  2792,    -1,    -1,    -1,    76,    -1,  2798,    -1,
      -1,    -1,    -1,   727,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3066,    -1,    -1,    -1,    -1,    -1,  3130,    -1,  3074,   753,
    3134,    -1,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2792,    -1,  2845,    -1,  3093,    -1,  2798,
      -1,    -1,    -1,   133,    -1,    -1,    -1,    -1,    -1,    -1,
     140,    -1,    -1,    -1,   144,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   172,    -1,    -1,    -1,  2845,  3143,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5310,  3162,    -1,  3164,    -1,
      -1,    -1,    -1,    -1,   204,    -1,    -1,    -1,   208,    -1,
      -1,    -1,    -1,  3237,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3252,    -1,
      -1,    -1,    -1,  3257,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,
      -1,    13,   896,  3057,    -1,    17,    18,    19,    -1,    -1,
      -1,    -1,    -1,  3287,    -1,    51,  5381,   267,    -1,    -1,
      -1,    -1,   272,    35,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3542,    -1,    45,  3545,    -1,  3547,    -1,   288,    -1,
      52,  3552,   292,  3259,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   302,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   312,    -1,    -1,    -1,    78,    -1,    -1,    -1,
      -1,    -1,    -1,   323,   324,    -1,  3130,    -1,    -1,    -1,
    3134,    -1,    -1,  3594,    -1,    -1,    -1,  3057,    -1,    -1,
      -1,  3602,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3627,   367,    -1,    -1,
     370,   371,   372,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3057,    -1,
    5505,    -1,    -1,    -1,    -1,    -1,   396,    -1,    -1,    -1,
      -1,    -1,   402,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3130,    -1,    -1,    -1,  3134,  1059,    -1,    -1,   418,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1070,    -1,    -1,    -1,
      -1,    -1,    -1,  3237,   196,    -1,    -1,    -1,    -1,   201,
      -1,    -1,  1086,    -1,    -1,  3706,    -1,  3708,  3252,    -1,
      -1,    -1,    -1,  3257,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3130,   224,   225,    -1,  3134,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   727,    -1,   476,    -1,    -1,    -1,
      -1,    -1,    -1,  3287,    -1,    -1,    -1,    -1,    -1,    -1,
     252,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     753,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3237,  3542,    -1,
      -1,  3545,    -1,  3547,    -1,    -1,    -1,    -1,  3552,    -1,
      -1,    -1,  3252,   295,    -1,    -1,    -1,  3257,    -1,    -1,
      -1,  5656,    -1,    -1,    -1,  3806,  5661,  5662,   310,    -1,
      -1,   313,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3287,  3237,    -1,
    3594,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3602,    -1,
      -1,    -1,    -1,  3252,    -1,    -1,    -1,    -1,  3257,  3850,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1243,
      -1,    -1,    -1,  3627,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3878,  3287,    -1,
      -1,    -1,    -1,  3589,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3606,    -1,    -1,   896,  3610,   407,    -1,    -1,    -1,  3615,
    3616,  3617,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5777,  5778,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3637,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3706,    -1,  3708,  3946,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3660,  3661,  3662,  3663,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3968,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,
      -1,    -1,    17,    18,    19,    -1,  5841,    -1,    -1,  3990,
      -1,    -1,  3698,    -1,  3700,  3701,  3702,    -1,  3542,    -1,
      35,  3545,    -1,  3547,    -1,    -1,    -1,    -1,  3552,    -1,
      45,    -1,   514,    -1,    -1,    -1,    -1,    52,    -1,    -1,
      -1,   523,   524,   525,   526,   527,   528,   529,   530,   531,
      -1,    -1,    -1,    -1,   536,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3806,    78,    -1,    -1,    -1,    -1,    -1,    -1,
    3594,    -1,    -1,    10,    -1,    -1,    13,    -1,  3602,    -1,
      17,    18,    19,    -1,    -1,    -1,  1059,    -1,    -1,    -1,
      -1,  4072,    -1,    -1,    -1,    -1,    -1,  1070,    35,    -1,
      -1,    -1,  3542,  3627,    -1,  3545,  3850,  3547,    45,    -1,
      -1,    -1,  3552,  1086,    -1,    52,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3878,    -1,  3822,    -1,    -1,    -1,
    1504,    78,    -1,  4124,    -1,  3831,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3542,  3594,    -1,  3545,    -1,  3547,    -1,
      -1,    -1,  3602,  3552,    -1,    -1,    -1,    -1,  4149,    -1,
      -1,  3857,  3858,    -1,    -1,    -1,  3862,    -1,    -1,    -1,
      -1,   196,  3706,    -1,  3708,    -1,   201,  3627,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3884,    -1,
      -1,    -1,  3946,    -1,    -1,  3594,    -1,  1571,    -1,   224,
     225,    -1,    -1,  3602,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   727,    -1,    -1,  3968,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   252,  3627,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3990,   753,  1612,    -1,
    3936,    -1,    -1,    -1,    -1,  3941,    -1,    -1,    -1,   196,
      -1,  3947,    -1,    -1,   201,    -1,  3706,    -1,  3708,    -1,
    1243,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     295,  1645,  3806,    -1,    -1,    -1,    -1,   224,   225,    -1,
      -1,  3977,    -1,    -1,    -1,   310,    -1,    -1,   313,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   252,    -1,  3706,    -1,  3708,
    4006,    -1,  4008,    -1,    -1,    -1,  3850,    -1,  4072,  4310,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3878,    -1,    -1,    -1,   295,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3806,    -1,    -1,    -1,
      -1,    -1,    -1,   310,    -1,    -1,   313,    -1,    -1,    -1,
    4124,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     896,    -1,   407,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4149,    -1,    -1,    -1,    -1,
    3850,    -1,    -1,    -1,    -1,    -1,    -1,  3806,    -1,    -1,
      -1,    -1,  3946,  4404,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3878,    -1,
      -1,    -1,    -1,    -1,  3968,    -1,    -1,    -1,    -1,    -1,
      -1,  4432,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3850,    -1,    -1,    -1,    -1,  3990,    -1,    -1,    -1,
     407,    -1,    -1,    -1,    -1,  1839,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1850,    -1,    -1,  3878,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   514,
      -1,    -1,  1866,    -1,    -1,    -1,  3946,    -1,   523,   524,
     525,   526,   527,   528,   529,   530,   531,    -1,  6353,    -1,
      -1,   536,    -1,    -1,    -1,    -1,    -1,    -1,  3968,    -1,
      -1,  1504,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4072,    -1,
    3990,    -1,    -1,  1059,    -1,    -1,  1920,  3946,    -1,    -1,
      -1,    -1,    -1,    -1,  1070,    -1,  4310,    -1,    -1,    -1,
      -1,  1935,    -1,    -1,  1938,  1939,    -1,   514,    -1,  3968,
    1086,    -1,  6417,    -1,    -1,    -1,   523,   524,   525,   526,
     527,   528,   529,   530,   531,  4576,    -1,    -1,  1571,   536,
    4124,  3990,    -1,    -1,    -1,  1969,  1970,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4149,    -1,    -1,    -1,    -1,
      -1,    -1,  4072,    -1,    -1,    -1,  4322,    -1,  4324,  1612,
      -1,    -1,  4623,    -1,    -1,    -1,    -1,  4628,    -1,    -1,
      -1,  4337,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4404,    -1,    -1,  4349,    -1,    -1,    -1,  4353,    -1,    -1,
      -1,    -1,  1645,    -1,    -1,    -1,    -1,    -1,  4364,    -1,
      -1,    -1,    10,  4072,  4124,    13,    -1,    -1,  4432,    17,
      18,    19,    -1,    -1,    -1,    -1,    -1,  4383,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,  4149,
      -1,    -1,    -1,    -1,    -1,  4401,    -1,    45,    -1,    -1,
      -1,    -1,    -1,  4409,    52,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4124,    -1,  1243,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2111,  4434,    -1,
      78,    -1,  4438,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4149,    -1,    -1,    -1,    -1,    -1,    -1,  4453,  4454,  4455,
    4456,    -1,    -1,    -1,    -1,    -1,    -1,  4463,  4464,  4465,
    4466,    -1,    -1,    -1,    -1,    -1,  4310,  4473,  4474,    -1,
      -1,    -1,    -1,    -1,  4480,  4481,    -1,  4483,  4484,  4485,
    4486,  4487,  4488,  4489,    -1,  4786,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4499,    -1,    -1,    -1,  4503,  4504,  4505,
    4506,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,
      18,    19,  4576,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4527,    -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,
      -1,    39,    -1,    -1,    -1,    -1,    -1,    45,    -1,  4545,
      -1,    -1,    -1,    -1,    52,    -1,  1839,    -1,   196,    -1,
    4310,    -1,    -1,   201,    -1,    -1,    -1,  1850,    -1,  4623,
    4404,    -1,    -1,    -1,  4628,    -1,    -1,    -1,    -1,    -1,
      78,    -1,    -1,  1866,    -1,    -1,   224,   225,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4432,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4901,  4310,    -1,    -1,   252,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4621,    -1,    -1,    -1,    -1,
      -1,    -1,   130,    -1,    -1,    -1,    -1,  1920,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1935,    -1,  4404,  1938,  1939,   295,  4654,    -1,
      -1,    -1,    -1,  4954,    -1,  4661,    -1,  4663,    -1,    -1,
      -1,    -1,   310,    -1,    -1,   313,    -1,    -1,    -1,    -1,
      -1,    -1,  4432,    -1,    -1,  4976,  1969,  1970,  1504,    -1,
      -1,    -1,    -1,    -1,    -1,  4691,    -1,    -1,   196,    -1,
      -1,    -1,    -1,   201,    -1,  4404,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   224,   225,    -1,    -1,
      -1,    -1,  4786,  4432,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4576,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   252,  1571,    -1,    -1,    -1,  5050,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   407,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4623,
      -1,    -1,    -1,    -1,  4628,    -1,  1612,   295,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   206,
     207,    -1,   310,    -1,    -1,   313,    -1,   214,    -1,   216,
     217,    -1,    -1,    -1,    -1,    -1,  4576,    -1,  2111,  1645,
      -1,    -1,    -1,   230,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4901,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4623,    -1,    -1,   514,  4576,  4628,    -1,
    5171,    -1,    -1,    -1,    -1,   523,   524,   525,   526,   527,
     528,   529,   530,   531,    -1,    -1,    -1,    -1,   536,    -1,
    4954,    -1,    -1,    -1,    -1,    -1,  4902,  4903,  4904,   407,
      -1,    -1,  4908,  4909,  4910,  4911,    -1,    -1,    -1,  4915,
      -1,    -1,  4976,    -1,  4623,    10,    -1,    -1,    13,  4628,
      -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      35,    -1,  4786,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      45,    -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,
    4966,  4967,  4968,  4969,  4970,   473,  4972,  4973,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4984,  4985,
      -1,    -1,    -1,    78,    -1,    -1,  5050,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   514,    -1,    -1,  5310,
      -1,    -1,  5018,  1839,    -1,   523,   524,   525,   526,   527,
     528,   529,   530,   531,  1850,    -1,  4786,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1866,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2733,
      -1,    -1,    -1,  2737,  2738,    -1,    -1,  4901,    -1,    -1,
      -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,
      17,    18,    19,    -1,    -1,    -1,   171,  4786,    -1,    -1,
    5381,    -1,   177,    -1,    -1,    -1,    -1,    -1,    35,    -1,
      -1,    -1,    -1,    -1,  1920,    -1,    -1,    -1,    45,    -1,
      -1,   196,    -1,    -1,    -1,    52,   201,  5171,  2792,  1935,
    4954,    -1,  1938,  1939,  2798,    -1,  5122,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,
     225,    78,  4976,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4901,    -1,  1969,  1970,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   252,    -1,    -1,
      -1,  2845,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5187,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4901,    -1,  4954,    -1,    -1,    -1,    -1,    -1,
     295,    -1,    -1,    -1,  5505,    -1,  5050,    -1,    -1,    -1,
      -1,    -1,    -1,  5219,    -1,   310,  4976,    -1,   313,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4954,  5310,    -1,    -1,   196,
      -1,    -1,    -1,    -1,   201,    -1,    -1,   664,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4976,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   683,   224,   225,    -1,
      -1,    -1,   689,    -1,    -1,  2111,    -1,    -1,    -1,    -1,
    5050,    -1,    -1,    -1,   701,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   252,    -1,    -1,    -1,    -1,
     717,  5317,   407,    -1,    -1,    -1,    -1,  5381,    -1,    -1,
      -1,    -1,    -1,    -1,   731,   732,    -1,  5171,    -1,    10,
      -1,   738,    13,   740,   741,    -1,    17,    18,    19,    -1,
      -1,  5050,    -1,    -1,    -1,    -1,    -1,   754,   295,    -1,
      -1,    -1,    -1,    -1,    35,  5656,    -1,   764,    -1,    -1,
    5661,  5662,    -1,   310,    45,    -1,   313,    -1,    -1,    -1,
      -1,    52,    -1,  3057,    -1,    -1,    -1,  5383,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   341,    -1,  5402,    78,    -1,    -1,
      -1,    -1,  5408,  5409,    -1,    -1,    -1,    -1,    -1,    -1,
     817,  5171,    -1,    -1,    -1,    -1,  5422,    -1,    -1,   514,
      -1,    -1,    -1,  5429,    -1,    -1,    -1,    -1,   523,   524,
     525,   526,   527,   528,   529,   530,   531,    -1,   845,    -1,
    2733,  5505,    -1,    -1,  2737,  2738,  3130,    -1,    -1,    -1,
    3134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5464,  5465,
     407,    -1,  5171,   870,    -1,    -1,  5310,    -1,    -1,    -1,
      -1,  5477,    -1,  5479,    -1,    -1,    -1,  5778,    -1,    -1,
     427,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5494,   170,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2792,
      -1,    -1,    -1,    -1,    -1,  2798,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5519,    -1,   196,    -1,    -1,    -1,    -1,
     201,  5527,    -1,    -1,    -1,   932,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5381,    -1,    -1,
    5841,    -1,    -1,   224,   225,    -1,    -1,    -1,    -1,    -1,
    5310,    -1,  2845,  3237,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   514,  3252,    -1,
      -1,   252,    -1,  3257,    -1,    -1,   523,   524,   525,   526,
     527,   528,   529,   530,   531,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5656,    -1,    -1,    -1,    -1,  5661,  5662,    -1,
      -1,  5310,    -1,  3287,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5617,    -1,    -1,   295,    -1,    -1,    -1,    -1,    -1,
      -1,  5381,    -1,    -1,    -1,  5631,    -1,    -1,    -1,   310,
      -1,    -1,   313,    -1,    -1,  1042,    -1,    -1,    -1,    -1,
      -1,    -1,  1049,    -1,    -1,    -1,    -1,    -1,    -1,  5655,
      -1,    -1,    -1,  1060,    -1,    -1,    -1,  1064,   339,  1066,
      -1,  5505,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5381,    -1,    -1,    -1,    -1,   207,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   216,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     230,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5778,    -1,    -1,    -1,    -1,    -1,
    5726,    -1,    -1,    -1,    -1,    -1,   407,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5505,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3057,    -1,  1173,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5841,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5796,    -1,    -1,    -1,    -1,    -1,  5505,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5656,    -1,    -1,    -1,    -1,  5661,  5662,    -1,
      -1,    -1,    -1,    -1,  5830,    -1,    -1,  1234,    -1,    -1,
      -1,    -1,    -1,   514,    -1,    -1,    -1,  3130,  1245,    -1,
      -1,  3134,   523,   524,   525,   526,   527,   528,   529,   530,
     531,    -1,    -1,    -1,    -1,  1262,    -1,    -1,  3542,    -1,
    1267,  3545,    -1,  3547,    -1,  5871,    -1,    -1,  3552,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5895,
      -1,    -1,    -1,    -1,    -1,    -1,  5656,    -1,    -1,    -1,
      -1,  5661,  5662,    -1,    -1,    -1,    -1,  2733,    -1,    -1,
    3594,  2737,  2738,    -1,    -1,    -1,    -1,    -1,  3602,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    10,    -1,  5778,    13,    -1,    -1,    -1,    17,
      18,    19,    -1,  3627,  3237,    -1,    -1,  5656,    -1,    -1,
      -1,  5957,  5661,  5662,    -1,    -1,    -1,    35,    -1,  3252,
      38,    -1,    -1,    -1,  3257,    -1,  2792,    45,    -1,    -1,
      -1,    -1,  2798,    -1,    52,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1400,  3287,    -1,    -1,  5841,    -1,    -1,
      78,  1408,  1409,    -1,   198,   199,    -1,    -1,   202,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5778,  2845,
      -1,    -1,  3706,    -1,  3708,    -1,    -1,    -1,   222,    -1,
      -1,    -1,    -1,    -1,    -1,   229,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6353,    -1,  1461,    -1,    -1,    10,    -1,    -1,
      13,    -1,    -1,  6069,    17,    18,    19,    -1,    -1,  5778,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5841,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    45,    -1,    -1,    -1,  6102,    -1,    -1,    52,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6113,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   196,    -1,
      -1,    -1,  3806,   201,    -1,    78,    -1,    -1,    -1,    -1,
      -1,    -1,  5841,    -1,   664,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   224,   225,    -1,    -1,
      -1,    -1,    -1,   683,    -1,    -1,    -1,    -1,    -1,   689,
      -1,    -1,    -1,    -1,    -1,    -1,  3850,    -1,    -1,    -1,
      -1,   701,    10,    -1,   252,    13,    -1,    -1,    -1,    17,
      18,    19,    -1,    -1,    -1,    -1,    -1,   717,    -1,    -1,
      -1,    -1,    -1,    -1,  3878,    -1,    -1,    35,    -1,    -1,
      -1,    -1,   732,    -1,    -1,    -1,    -1,    45,    -1,    -1,
     740,    -1,    -1,    -1,    52,    -1,    -1,   295,    -1,    -1,
      -1,    -1,    -1,    -1,   754,    -1,    -1,    -1,    -1,  6235,
      -1,  3057,   310,    -1,   764,   313,    -1,    -1,    -1,    -1,
      78,    -1,    -1,   196,    -1,    -1,    -1,    -1,   201,  3542,
      -1,    -1,  3545,    -1,  3547,    -1,    -1,    -1,    -1,  3552,
      -1,    -1,  3946,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   224,   225,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3968,    -1,    -1,   817,    -1,  6353,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   252,
      -1,  3594,    -1,    -1,  3130,  1712,  3990,    -1,  3134,  3602,
      -1,    -1,    -1,    -1,    -1,   845,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   407,
      -1,    -1,    -1,    -1,  3627,    -1,    -1,    -1,    -1,    -1,
     870,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   310,   196,    -1,
     313,    -1,    -1,   201,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   224,   225,  4072,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   932,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3237,    -1,  3706,   252,  3708,    -1,    -1,    -1,    -1,
    1827,    -1,    -1,    -1,    -1,    -1,  3252,    -1,    -1,    -1,
      -1,  3257,    -1,    -1,    -1,  6441,   514,    -1,    -1,    -1,
    4124,    -1,    -1,    -1,    -1,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   407,  1862,    -1,   295,    -1,    -1,
      -1,  3287,    -1,    -1,    -1,  4149,    -1,    -1,    -1,    -1,
      -1,    -1,   310,    -1,    -1,   313,    -1,    -1,  1885,   673,
      -1,   675,    -1,    -1,   678,    -1,  1893,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1901,    -1,   334,    -1,   692,    -1,
      -1,    -1,    -1,    -1,   698,    -1,    -1,    -1,    -1,  6353,
      -1,    -1,  1042,  3806,    -1,    -1,    -1,    -1,    -1,  1049,
      -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,    -1,    -1,    -1,  1942,  1943,    -1,  1945,  1946,
      -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,    38,
    1957,    -1,  1959,  1960,    -1,    -1,    45,  3850,    -1,    -1,
     513,   514,    -1,    52,    -1,  1972,  1973,    -1,    -1,   407,
     523,   524,   525,   526,   527,   528,   529,   530,   531,    -1,
      -1,    -1,    -1,    -1,    -1,  3878,    -1,    -1,    -1,    78,
      -1,    -1,    -1,  6353,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2010,    -1,    -1,    -1,  2014,  2015,    -1,
      -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,
      17,    18,    19,    -1,    -1,    -1,  4310,    -1,    -1,    -1,
      -1,    -1,    10,    -1,    -1,    13,    -1,    -1,    35,    17,
      18,    19,    -1,  1173,  6353,    -1,    -1,    -1,    45,    -1,
      -1,    -1,    -1,  3946,    -1,    52,    -1,    35,    -1,    -1,
      38,    -1,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,
      -1,    -1,    -1,    -1,    52,  3968,   514,    -1,    -1,    -1,
      -1,    78,    -1,    -1,    -1,   523,   524,   525,   526,   527,
     528,   529,   530,   531,    -1,    -1,    -1,  3990,    -1,    -1,
      78,    -1,    -1,    -1,  1234,    -1,    -1,   196,    -1,    -1,
      -1,    -1,   201,    -1,    -1,  1245,  3542,    -1,    -1,  3545,
    4404,  3547,    -1,    -1,    -1,  2132,  3552,    -1,    -1,    -1,
      -1,    -1,  1262,    -1,    -1,   224,   225,  1267,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4432,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   252,    -1,    -1,    -1,    -1,  3594,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3602,    -1,    -1,  4072,
     177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   985,   986,    -1,    -1,    -1,    -1,    -1,    -1,   196,
      -1,  3627,    -1,    -1,   201,    -1,   295,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   196,    -1,
      -1,   310,    -1,   201,   313,    -1,    -1,   224,   225,    -1,
      -1,  4124,    23,    -1,    -1,    -1,    -1,    28,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   224,   225,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   252,  4149,    -1,    -1,    -1,
      -1,    -1,  1056,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1400,    -1,    -1,    -1,   252,    -1,    -1,  1071,  1408,  1409,
    3706,    -1,  3708,    -1,    -1,    -1,    -1,    -1,    79,    80,
      -1,    -1,  4576,    -1,    -1,    -1,    -1,    -1,   295,    -1,
      -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,  1102,  1103,
      -1,    -1,    -1,   310,    -1,    -1,   313,   295,   407,    -1,
      -1,    -1,    -1,   114,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1461,   310,    -1,  1128,   313,    -1,    -1,    -1,  4623,
      -1,    -1,    -1,    -1,  4628,    -1,    -1,   138,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     151,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   160,
      -1,    -1,    -1,    -1,  1168,  1169,    -1,    -1,    -1,    -1,
    3806,    -1,   173,    -1,    -1,    -1,    -1,    -1,   179,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     407,    -1,    -1,    -1,    -1,   206,    -1,  4310,    -1,    -1,
      -1,    -1,    -1,    -1,  3850,   514,    -1,    -1,    -1,   407,
      -1,    -1,    -1,    -1,   523,   524,   525,   526,   527,   528,
     529,   530,   531,    -1,    -1,    -1,    -1,    -1,    10,    -1,
      -1,    13,  3878,   244,    -1,    17,    18,    19,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    35,    -1,   266,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,
      52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4786,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4404,    -1,    -1,    -1,    -1,    78,   514,    -1,    -1,
    3946,    -1,    -1,    -1,    -1,    -1,   523,   524,   525,   526,
     527,   528,   529,   530,   531,    -1,   514,    -1,    -1,  4432,
      -1,    -1,  3968,    -1,    -1,   523,   524,   525,   526,   527,
     528,   529,   530,   531,    -1,    -1,   347,   348,    -1,    -1,
     351,    -1,    -1,    -1,  3990,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1712,    -1,    -1,    -1,    -1,    -1,   379,    -1,
      -1,   382,    -1,    -1,    -1,    -1,    -1,    -1,   389,    -1,
      -1,    -1,    -1,    -1,    -1,   396,    -1,    -1,   399,    -1,
      -1,    -1,    -1,    10,    -1,    -1,    13,  4901,    -1,    -1,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,   420,
      -1,    -1,    -1,    -1,   196,    -1,    -1,   428,    35,   201,
      -1,    38,    -1,    -1,   435,    -1,  4072,   438,    45,    -1,
      -1,    -1,   443,    -1,    -1,    52,    -1,    -1,    -1,    -1,
      -1,    -1,   224,   225,  2671,    -1,    -1,   458,    -1,    -1,
    4954,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    -1,  4576,    -1,    -1,    -1,    -1,    -1,    -1,
     252,    -1,  4976,    -1,   485,    -1,    -1,  1827,  4124,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2726,
      -1,    -1,    -1,  4149,    -1,    -1,    -1,    -1,    -1,    -1,
    4623,    -1,  1862,   295,    -1,  4628,    -1,  2744,    -1,    -1,
      -1,  2748,    -1,    -1,    -1,  2752,    -1,    -1,   310,    -1,
      -1,   313,    -1,    -1,  2761,  1885,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1893,    -1,    -1,  5050,    -1,    -1,  2776,
    1564,  1901,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2793,    -1,  2795,  2796,
      -1,    -1,    -1,    -1,    -1,  1589,    -1,    -1,    -1,   196,
      -1,    -1,    -1,  2810,   201,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1945,  1946,    -1,    -1,    -1,
      -1,    -1,    -1,  2830,  2831,    -1,    -1,   224,   225,  1959,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1972,  1973,    -1,   407,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   252,    -1,    -1,    -1,    -1,
    2867,  2868,    -1,    -1,  2871,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1666,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   444,    -1,  4310,    -1,    -1,  5171,  2895,    -1,
    2897,    -1,    -1,  4786,  2901,    -1,    -1,    -1,   295,    -1,
      -1,    -1,    -1,    -1,  1698,  1699,  1700,  1701,  2915,    -1,
      -1,    -1,    -1,   310,    -1,  2922,   313,    -1,  2925,    -1,
      -1,    -1,    -1,    -1,  2931,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2951,    -1,    -1,    -1,    -1,    -1,
    2957,    10,   514,    -1,    13,    -1,    -1,  2964,    17,    18,
      19,   523,   524,   525,   526,   527,   528,   529,   530,   531,
      -1,    -1,    -1,  2980,    -1,    -1,    35,    -1,  4404,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    45,  2994,    -1,    -1,
      -1,    -1,  2999,    52,    -1,    -1,    -1,    -1,  3005,    -1,
      -1,    -1,  2132,    -1,    -1,    -1,  4432,    -1,  4901,    -1,
     407,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      -1,    -1,    -1,    -1,    -1,    -1,  5310,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   839,   840,    -1,    -1,    -1,    -1,    -1,
      -1,  1845,  1846,    -1,    -1,    -1,    -1,    -1,  3065,    -1,
      -1,  4954,    -1,    -1,    -1,    -1,    -1,  1861,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4976,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5381,    -1,    -1,
      -1,  1895,  1896,  1897,  1898,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   514,    -1,    -1,
      -1,    -1,    -1,   919,    -1,    -1,   523,   524,   525,   526,
     527,   528,   529,   530,   531,    -1,    -1,   196,    10,    -1,
      -1,    13,   201,    -1,    -1,    17,    18,    19,    -1,    -1,
    4576,    -1,    -1,    -1,    -1,    -1,    -1,  5050,    -1,    -1,
      -1,    -1,    -1,    35,    -1,   224,   225,    -1,    -1,    -1,
      -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,
      52,    -1,  1976,    -1,    -1,    -1,    -1,    -1,  1982,    -1,
      -1,    -1,    -1,   252,    -1,    -1,    -1,  4623,    -1,    -1,
      -1,    -1,  4628,    -1,    -1,    -1,    78,    -1,    -1,    -1,
      -1,    -1,    -1,  3220,    -1,  3222,    -1,    -1,    -1,    -1,
      -1,  5505,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3239,    -1,    -1,    -1,   295,    -1,    -1,  3246,
      -1,    -1,    -1,    -1,  1040,  1041,  3253,    -1,  3255,  3256,
      -1,   310,    -1,    -1,   313,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   331,    -1,    -1,    -1,    -1,    -1,  5171,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,
      -1,    -1,    17,    18,    19,   177,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      35,    -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,   201,
      45,    -1,    -1,    -1,    -1,    -1,  3343,    52,    -1,    -1,
      -1,    -1,  3349,    -1,    -1,    -1,    -1,    -1,   407,    -1,
      -1,    -1,   224,   225,    -1,    -1,    -1,    -1,    -1,    -1,
    4786,    -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5656,    -1,    -1,    -1,  2170,  5661,  5662,   208,
     252,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5310,    -1,    -1,
      -1,    -1,    -1,   295,    -1,    -1,    -1,  3434,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   310,    -1,
      -1,   313,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,
      -1,    -1,    13,    -1,    -1,   514,    17,    18,    19,    -1,
      -1,    -1,   177,    -1,   523,   524,   525,   526,   527,   528,
     529,   530,   531,    -1,    35,  4901,    -1,    -1,    -1,    -1,
      -1,   196,    -1,  1279,    45,    -1,   201,    -1,  5381,    -1,
      -1,    52,    -1,    -1,  5778,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,
     225,    -1,    -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1321,    -1,    -1,  4954,    -1,
      -1,    -1,    -1,    -1,    -1,   407,    -1,   252,    -1,    -1,
      -1,  2671,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4976,    -1,    -1,    -1,  1350,  1351,  1352,  5841,  1354,    -1,
    3567,  3568,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1375,
     295,  3588,    -1,    -1,  3591,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   310,  2726,    -1,   313,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     171,    -1,  5505,    -1,  2744,    -1,    -1,    -1,  2748,    -1,
      -1,    -1,  2752,    -1,  5050,    -1,    -1,    -1,    -1,    -1,
      -1,  2761,    -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,
     201,    -1,   514,    -1,    -1,    -1,  2776,    -1,    -1,    -1,
      -1,   523,   524,   525,   526,   527,   528,   529,   530,   531,
      -1,    -1,    -1,   224,   225,  3672,  3673,  3674,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2810,    -1,  1478,    -1,    -1,    -1,  1482,  1483,    -1,    -1,
    3697,   252,   407,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2830,  2831,    -1,    -1,    -1,    -1,    -1,    -1,    10,  3716,
      -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3738,    -1,    35,   295,    -1,    -1,  2867,  2868,    -1,
      -1,  2871,    -1,    45,    -1,  5171,    -1,    -1,    -1,   310,
      52,    -1,   313,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5656,    -1,  2895,    -1,  2897,  5661,  5662,
      -1,  2901,    -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2915,    -1,    -1,    -1,    -1,
      -1,    -1,  2922,    -1,    -1,  2925,    -1,    -1,    -1,   514,
      -1,  2931,    -1,    -1,    -1,    -1,    -1,    -1,   523,   524,
     525,   526,   527,   528,   529,   530,   531,    -1,    -1,    -1,
      -1,  2951,    -1,  3830,    -1,    -1,    -1,  2957,    -1,    -1,
      -1,    -1,    -1,    -1,  2964,    -1,   665,    -1,    -1,    -1,
      -1,    -1,   671,  2637,    -1,    -1,   407,    -1,   150,    -1,
    2980,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2994,    -1,    -1,    -1,    -1,  2999,
    3877,    -1,    -1,    -1,    -1,  3005,  3883,    -1,  3885,    -1,
      -1,    -1,    -1,    -1,  5310,  5778,    -1,    -1,    -1,    -1,
      -1,  3898,    -1,  3900,   196,    -1,    -1,    -1,    -1,   201,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   224,   225,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1727,  1728,  1729,    -1,  3065,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5841,    -1,
     252,    -1,    -1,   514,    -1,  5381,    -1,    -1,    -1,    -1,
    3967,    -1,   523,   524,   525,   526,   527,   528,   529,   530,
     531,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4009,    -1,    -1,  2799,    -1,    -1,   310,    -1,
      -1,   313,    -1,   842,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4028,    -1,    -1,    -1,  4032,    -1,    -1,    -1,    -1,
      -1,    -1,   861,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4053,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6353,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5505,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3220,    -1,  3222,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   933,   407,    -1,    -1,    -1,  3239,
      -1,    -1,    -1,    -1,    -1,    -1,  3246,    -1,    -1,    -1,
      -1,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,
      18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,  2943,
      -1,   980,  2946,    -1,  4161,    -1,    -1,    45,    -1,    -1,
      -1,    -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    45,
      -1,    -1,   514,  3343,    -1,    -1,    52,    -1,    -1,  3349,
      -1,   523,   524,   525,   526,   527,   528,   529,   530,   531,
    5656,    -1,    -1,    -1,    -1,  5661,  5662,    -1,    -1,    -1,
      -1,    -1,    78,  3037,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3050,    -1,    -1,    -1,
    2056,    -1,    -1,    -1,  3058,    -1,  1095,    -1,    -1,  2065,
    2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,  2074,    -1,
      -1,    -1,    -1,  2079,    -1,  2081,    -1,  2083,    -1,    -1,
    2086,  2087,  2088,    -1,    -1,  1124,  1125,  1126,  2094,    -1,
      -1,  2097,    -1,  3097,  3434,    -1,    -1,    -1,   196,    -1,
      -1,    -1,    -1,   201,    -1,    -1,  2112,  2113,  2114,    -1,
      -1,    -1,    -1,    -1,  3118,    -1,    -1,    -1,    -1,  4336,
      -1,    -1,    -1,    -1,  2130,   171,   224,   225,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5778,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     196,    -1,    -1,    -1,   252,   201,    -1,  3161,    -1,  3163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,   225,
      -1,  4398,    -1,    -1,    -1,    -1,  4403,    -1,  4405,    -1,
      -1,    -1,    -1,    -1,  1233,    -1,    -1,   295,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5841,   252,    -1,    -1,    -1,
      -1,    -1,   310,    -1,  4431,   313,    -1,    -1,    -1,    -1,
      -1,    -1,  1261,    -1,    -1,    -1,    -1,  3567,  3568,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3251,  3588,   295,
    6353,  3591,    -1,    -1,  3258,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4479,    -1,   310,  4482,    -1,   313,    -1,    -1,
      -1,  2277,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   407,
      10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,
      -1,    -1,    -1,    -1,    -1,  2331,    -1,    -1,    -1,    -1,
      -1,    -1,  3672,  3673,  3674,    35,    -1,    -1,    38,    -1,
      -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,
      -1,    -1,    52,    -1,    -1,  4572,  4573,  3697,    -1,    -1,
      -1,   407,    -1,    -1,    -1,    -1,  4583,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1414,  3716,    -1,    78,    -1,
      -1,  2387,    -1,  4600,    -1,    -1,    -1,    -1,    -1,    -1,
     488,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3738,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   514,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   523,   524,   525,   526,   527,
     528,   529,   530,   531,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1494,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4681,    -1,    -1,  4684,   514,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   523,   524,   525,
     526,   527,   528,   529,   530,   531,    -1,    -1,    -1,    -1,
    3830,    -1,    -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,
      -1,   201,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   224,   225,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    28,    -1,    -1,    -1,  3877,  1577,    -1,
      -1,    -1,    -1,  3883,    -1,  3885,    -1,  1586,    -1,    -1,
      -1,    -1,   252,    -1,    -1,    -1,    -1,    -1,  3898,    -1,
    3900,    -1,    -1,    -1,    -1,    -1,    -1,  2573,  2574,  2575,
    2576,  2577,  2578,  2579,  2580,  2581,    -1,  2583,    -1,  1618,
      -1,    -1,    -1,    -1,    79,  1624,  1625,    -1,  2594,  1628,
    2596,    -1,    -1,  3597,  3598,   295,    -1,    -1,    -1,    -1,
      -1,    96,  1641,    -1,    -1,  1644,    -1,    -1,    -1,    -1,
     310,    -1,    -1,   313,    -1,    -1,    -1,    -1,    -1,   114,
      -1,    -1,    -1,    -1,    -1,   120,    -1,  3967,  2634,    -1,
      -1,    -1,  2638,    -1,    -1,  2641,    -1,  2643,    -1,    -1,
    2646,    -1,    -1,   138,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,    -1,
      -1,    -1,    -1,  1702,    10,   160,    -1,    13,    -1,  4009,
      -1,    17,    18,    19,    -1,    -1,    -1,  1716,   173,    -1,
      -1,    -1,    -1,    -1,   179,    -1,    -1,    -1,  4028,    35,
      -1,   186,  4032,  2699,  2700,    -1,    -1,  4914,    -1,    45,
      -1,    -1,    -1,    -1,    -1,    -1,    52,   407,    -1,    -1,
      -1,   206,    -1,  4053,    -1,    -1,    -1,  6353,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   244,
      -1,    -1,    -1,    -1,  4971,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4983,    -1,    -1,    -1,
      -1,   266,    -1,  2779,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1826,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1837,    -1,
    5017,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   514,   310,    -1,    -1,    -1,    -1,
      -1,  4161,    -1,   523,   524,   525,   526,   527,   528,   529,
     530,   531,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1879,  1880,   337,    -1,    -1,    -1,    -1,    -1,  3852,    -1,
     196,    -1,   347,   348,    -1,   201,   351,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1904,    -1,    -1,    -1,    -1,
      -1,    -1,  1911,    -1,    -1,    -1,    -1,    -1,   224,   225,
    5097,    -1,    -1,    -1,   379,    -1,    -1,   382,    -1,    -1,
      -1,   386,    -1,    -1,   389,    -1,    -1,    -1,    -1,  5116,
      -1,   396,    -1,    -1,   399,    -1,   252,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   420,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   428,    -1,    -1,    -1,    -1,   433,    -1,
     435,    -1,    -1,   438,    -1,  1984,    -1,    -1,   443,   295,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   453,    -1,
      -1,    -1,    -1,   458,   310,    -1,    -1,   313,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   472,  2017,  2018,
      -1,    -1,    -1,    -1,    -1,  5202,    -1,    -1,    -1,    -1,
     485,    -1,    -1,    -1,    -1,  2034,  4336,    -1,  2037,    -1,
      -1,    -1,    -1,    23,    -1,    -1,    -1,    -1,  4012,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3023,  3024,  3025,
      -1,    41,    -1,  3029,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    66,    -1,    -1,    -1,
    3056,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4398,    79,
      -1,   407,    -1,  4403,    -1,  4405,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,
      -1,  1367,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4431,    -1,    -1,   114,    -1,    -1,    -1,    -1,    -1,
     120,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5332,    -1,  5334,   138,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   151,    -1,    -1,    -1,    -1,  1422,    -1,    -1,  4479,
     160,    -1,  4482,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   173,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   182,    -1,    -1,  5382,   186,    -1,   514,    -1,
      -1,    -1,    -1,    -1,    -1,  5392,    -1,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   206,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5436,
      -1,    -1,    -1,    -1,  5441,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4572,  4573,    -1,    -1,   256,    -1,    -1,    -1,
      -1,    -1,    -1,  4583,    20,    -1,   266,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    31,    -1,    33,    34,  3265,
    4600,    -1,    -1,    -1,  3270,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    61,    -1,    -1,    -1,    -1,
     310,    -1,    -1,   313,    -1,    -1,    -1,    73,    -1,    75,
      76,    -1,    -1,    -1,    -1,    -1,    82,    -1,    84,    -1,
      -1,    -1,    -1,    -1,    -1,  3321,    -1,   337,    -1,    -1,
      -1,    97,    -1,    99,    -1,    -1,  3332,    -1,  3334,  3335,
      -1,   351,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   359,
     116,  4681,  3348,   119,  4684,  3351,    -1,  3353,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   134,   379,
     136,    -1,    -1,    -1,   140,    -1,    -1,    -1,    -1,   389,
      -1,   147,    -1,    -1,    -1,    -1,   396,    -1,    -1,   399,
     156,    -1,   158,    -1,  3390,    -1,  3392,    -1,  3394,   165,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     420,    -1,    -1,    -1,    -1,    -1,    -1,   183,   428,    -1,
      -1,    -1,    -1,    -1,    -1,   435,    -1,    -1,   438,    -1,
     440,    -1,   442,   443,   200,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   458,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   466,  1733,    -1,   469,
      -1,  1737,   472,    -1,    -1,    -1,    -1,  5674,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   485,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5692,    -1,    -1,   254,   255,
      -1,    -1,  3488,    -1,   260,    -1,    -1,  3493,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    23,    -1,    -1,    -1,   275,
      28,    -1,  3508,    -1,    -1,    -1,  5723,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   294,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4530,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,    -1,
    4544,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    -1,    -1,  2593,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2603,    -1,   342,  3573,    96,    -1,
      -1,    -1,    -1,    -1,  4914,    -1,    -1,    -1,    -1,    -1,
      -1,   357,    -1,    -1,    -1,  5802,   114,   363,   364,    -1,
     366,    -1,    -1,  2632,    -1,   371,    -1,    -1,   374,    -1,
      -1,   377,    -1,    -1,   380,    -1,    -1,    -1,    -1,    -1,
     138,   387,    -1,    -1,    -1,    -1,    -1,    -1,   394,   395,
      -1,  5838,    -1,   151,    -1,    -1,   402,  3633,    -1,    -1,
     406,  4971,   160,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2679,  2680,   418,  4983,    -1,   173,    -1,    -1,    -1,    -1,
      -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,   186,   435,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2713,    -1,    -1,  5017,   206,    -1,
     456,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   468,  5910,    -1,    -1,  5913,    -1,   474,    -1,
      -1,    -1,    -1,   479,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   492,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   266,    -1,
     516,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5097,    -1,   535,
      -1,    -1,   538,    -1,    -1,    -1,    -1,    -1,  2054,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5116,    -1,    -1,    -1,
      -1,    -1,   310,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2080,   323,    -1,    -1,  2084,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   337,
    2849,    -1,    -1,  2099,  2100,  2101,    -1,  2103,    -1,   347,
     348,    -1,    -1,   351,    -1,  2864,    -1,    -1,    -1,  3835,
      -1,    -1,    -1,    -1,    -1,  3841,    -1,    -1,    -1,  6056,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2886,    -1,    -1,
      -1,   379,    -1,  6070,   382,    -1,    -1,    -1,   386,    -1,
      -1,   389,  5202,    -1,    -1,    -1,  6083,    -1,   396,    -1,
      -1,   399,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   420,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     428,    -1,    -1,    -1,    -1,    -1,    -1,   435,    -1,    -1,
     438,    -1,    -1,    -1,  3920,   443,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   451,    -1,   453,  6143,  6144,    -1,    -1,
     458,    -1,    -1,  2972,  2973,    -1,    -1,    -1,    -1,    -1,
    2979,    -1,    -1,    -1,   472,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   485,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5332,    -1,  5334,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6221,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5030,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3076,    -1,    -1,
      -1,  5045,  5382,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4069,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4078,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4092,    -1,    -1,    -1,
    4096,  4097,  4098,    -1,    -1,    -1,  5436,  4103,    -1,    -1,
    4106,    -1,    -1,  4109,    -1,    -1,    -1,    -1,    -1,  4115,
      -1,  4117,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5136,    -1,    -1,    -1,    -1,    -1,  4144,  4145,
    4146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4163,    -1,    -1,
      -1,    -1,  6379,    -1,    -1,  4171,    -1,    -1,  4174,    -1,
    4176,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4192,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4200,  4201,    -1,    -1,    -1,    -1,
      -1,  4207,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6438,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4236,    -1,    -1,    -1,  6451,  6452,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6463,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4287,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4304,    -1,
      -1,    -1,    -1,    -1,  2590,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5674,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5692,    -1,  5358,    -1,  5360,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3420,    -1,  5723,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2686,    -1,  3441,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2698,    -1,    -1,    -1,    -1,  2703,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5802,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5500,    -1,  5838,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5910,    -1,    -1,  5913,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4629,  4630,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4640,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3714,    -1,    -1,  5682,    -1,
    5684,    -1,    -1,    -1,    -1,  3724,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4710,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6056,    -1,    -1,    -1,
    4726,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4744,    -1,
      -1,    -1,  3781,  6083,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4783,  4784,    -1,
      -1,    -1,    -1,    -1,  4790,  4791,    -1,    -1,    -1,  4795,
      -1,    -1,    -1,    -1,  4800,    -1,    -1,  4803,  4804,    -1,
      -1,    -1,    -1,    -1,  4810,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4855,
    3889,  3890,  3891,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4866,    -1,    -1,    -1,    -1,    -1,    -1,  3906,  4874,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6221,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3939,  3940,    -1,    -1,    -1,  3944,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4919,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5952,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3268,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4999,    -1,    -1,    -1,    -1,    -1,  3285,
    5006,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3295,
      -1,  4050,    -1,    -1,    -1,  3301,    -1,    -1,  3304,    -1,
      -1,    -1,    -1,    -1,    -1,  3311,  3312,    -1,  3314,    -1,
      -1,    -1,    -1,  3319,  3320,    -1,  3322,    -1,  3324,  6379,
      -1,    -1,  3328,    -1,    -1,  3331,    -1,    -1,    -1,    -1,
    3336,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3345,
      -1,    -1,    -1,    -1,  3350,    -1,    -1,    -1,    -1,    -1,
    5076,  3357,  3358,  3359,  3360,    -1,    -1,    -1,    -1,  3365,
    3366,  6085,  3368,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6438,    -1,
      -1,  3387,    -1,  3389,    -1,    -1,    -1,    -1,    -1,    -1,
    3396,  3397,  3398,  3399,  3400,  3401,  3402,  3403,  3404,  3405,
      -1,    -1,    -1,  6463,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3442,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4216,  4217,  4218,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6215,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5238,    -1,    -1,    -1,    -1,    -1,  5244,  5245,
    5246,    -1,  6246,  6247,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5269,  5270,    -1,    -1,  5273,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5290,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5300,    -1,  3582,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5311,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5327,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6369,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4553,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5536,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4585,    -1,    -1,    -1,
      -1,  5557,    -1,  3839,  3840,    -1,    -1,    -1,  3844,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4617,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3873,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5602,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4652,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4669,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5650,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5666,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5712,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4814,  4815,  4816,  4817,    -1,
      -1,    -1,  4068,    -1,    -1,    -1,    -1,    -1,  4074,    -1,
      -1,    -1,    -1,    -1,    -1,  5801,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5813,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5822,  5823,  5824,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4121,  4122,    -1,    -1,  4125,
    4126,  4127,  4128,    -1,  5850,  4131,  4132,  4133,  4134,  4135,
    4136,  4137,  4138,  4139,  4140,  4141,    -1,    -1,  5864,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5883,  4164,    -1,
      -1,  4167,    -1,  4169,    -1,    -1,  4172,  4173,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4194,  4195,
    4196,  4197,    -1,  4199,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4269,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6017,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4319,    -1,    -1,  6042,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4354,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6125,
      -1,    -1,    -1,    -1,    -1,  5164,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5175,    -1,    -1,    -1,
      -1,    -1,    -1,  6149,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4546,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6276,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6292,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4589,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5413,  5414,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6417,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5458,
      -1,    -1,    -1,    -1,  5463,  4711,    -1,    -1,    -1,  4715,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4728,  5482,    -1,    -1,    -1,    -1,    -1,    -1,
    4736,    -1,  4738,    -1,  4740,  4741,    -1,    -1,    -1,    -1,
    4746,  4747,  4748,  4749,    -1,    -1,    -1,  4753,  4754,  4755,
    4756,  4757,  4758,  4759,  4760,  4761,  4762,  4763,  4764,  4765,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4789,    -1,    -1,  4792,    -1,  4794,    -1,
      -1,    -1,  4798,    -1,    -1,  4801,  4802,    -1,    -1,  4805,
    4806,    -1,    -1,    -1,    -1,  4811,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4865,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4879,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5643,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5745,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5773,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5079,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5166,  5167,    -1,    -1,    -1,    -1,    -1,    -1,  5174,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5217,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5240,  5241,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5259,    -1,  5261,    -1,    -1,    -1,  5265,
    5266,  5267,  5268,    -1,    -1,  5271,  5272,    -1,    -1,    -1,
      -1,  5277,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5294,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5312,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5326,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5354,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5403,    -1,  5405,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5444,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5550,    -1,  5552,  5553,  5554,  5555,
    5556,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5569,  5570,  5571,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5579,    -1,    -1,    -1,    -1,  5584,    -1,
      -1,  5587,    -1,    -1,    -1,  5591,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5609,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5626,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5803,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5814,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5835,
      -1,  5837,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5882,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5894,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5933,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6013,    -1,    -1,
      -1,    -1,    -1,    -1,  6020,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6053,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6068,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6180,  6181,    -1,    -1,  6184,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6243,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6268,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6286,  6287,    -1,  6289,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,     5,     6,    -1,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    37,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,  6355,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,   135,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,    -1,
     248,   249,   250,   251,   252,    -1,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,    -1,   432,   433,   434,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,   445,   446,   447,
      -1,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,    -1,   466,   467,
     468,   469,   470,   471,   472,    -1,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
      -1,    -1,   490,    -1,    -1,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,    -1,   514,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   526,   527,
     528,    -1,    -1,    -1,    -1,    -1,    -1,   535,   536,     3,
      -1,     5,     6,    -1,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,   250,   251,   252,    -1,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,   445,   446,   447,    -1,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,    -1,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,    -1,   482,   483,
     484,   485,   486,   487,    -1,    -1,   490,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,    -1,
     514,    -1,   516,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   526,   527,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   535,   536,     3,    -1,     5,     6,    -1,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
      -1,   221,    -1,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,   249,
     250,   251,   252,    -1,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,    -1,
     310,   311,   312,    -1,    -1,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,    -1,   432,   433,   434,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,   445,   446,   447,    -1,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,    -1,   466,   467,   468,   469,
     470,   471,   472,    -1,   474,   475,   476,   477,   478,   479,
     480,    -1,   482,   483,   484,   485,   486,   487,    -1,    -1,
     490,    -1,    -1,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,    -1,   514,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   526,   527,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   535,   536,     3,    -1,     5,
       6,    -1,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,   249,   250,   251,   252,    -1,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,   434,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,   445,
     446,   447,    -1,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,    -1,
     466,   467,   468,   469,   470,   471,   472,    -1,   474,   475,
     476,   477,   478,   479,   480,    -1,   482,   483,   484,   485,
     486,   487,    -1,    -1,   490,    -1,    -1,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,    -1,   514,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     526,   527,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   535,
     536,     3,    -1,     5,     6,    -1,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,   250,   251,
     252,    -1,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,    -1,
     432,   433,   434,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,   445,   446,   447,    -1,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,    -1,   466,   467,   468,   469,   470,   471,
     472,    -1,   474,   475,   476,   477,   478,   479,   480,    -1,
     482,   483,   484,   485,   486,   487,    -1,    -1,   490,    -1,
      -1,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,    -1,   514,    -1,    -1,    -1,    -1,    -1,     3,    -1,
      -1,    -1,    -1,    -1,   526,   527,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   535,   536,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    38,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,    -1,    -1,   178,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,    -1,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,   250,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,   296,    -1,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,    -1,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,    -1,   402,   403,   404,
     405,   406,    -1,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,    -1,
      -1,   436,    -1,   438,   439,   440,   441,   442,   443,    -1,
     445,   446,   447,    -1,    -1,   450,   451,   452,   453,   454,
      -1,   456,   457,   458,   459,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,    -1,    -1,   474,
     475,   476,   477,   478,   479,   480,    -1,   482,    -1,   484,
     485,   486,   487,    -1,    -1,   490,    -1,    -1,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   536,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    -1,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,    -1,    -1,    -1,   107,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,    -1,
     158,   159,   160,   161,    -1,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,    -1,   184,    -1,    -1,    -1,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   239,   240,   241,   242,   243,   244,   245,    -1,    -1,
     248,    -1,   250,   251,   252,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,    -1,    -1,   291,    -1,   293,   294,   295,   296,    -1,
      -1,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,    -1,   335,   336,   337,
      -1,   339,    -1,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,    -1,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,    -1,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,   445,   446,   447,
      -1,    -1,   450,   451,    -1,   453,    -1,    -1,   456,   457,
     458,   459,   460,   461,   462,   463,   464,    -1,    -1,   467,
     468,   469,   470,   471,    -1,    -1,   474,   475,   476,   477,
     478,    -1,   480,   481,   482,   483,   484,   485,   486,   487,
      -1,    -1,   490,    -1,    -1,   493,   494,   495,   496,   497,
     498,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   510,   511,   512,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,   536,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,    -1,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,    -1,    -1,    -1,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,    -1,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,    -1,    -1,
     291,    -1,   293,   294,   295,   296,    -1,    -1,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
      -1,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,    -1,   339,    -1,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,    -1,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,    -1,   430,
      -1,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,    -1,   453,    -1,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,    -1,   480,
     481,   482,   483,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,    -1,     3,
      -1,     5,     6,    -1,     8,     9,    10,    11,    12,   510,
     511,   512,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    37,    -1,   536,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,   250,   251,   252,    -1,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,   445,   446,   447,    -1,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,    -1,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,    -1,   482,   483,
     484,   485,   486,   487,    -1,    -1,   490,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,    -1,
     514,    -1,   516,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   526,   527,    -1,    -1,    -1,     3,    -1,     5,
       6,   535,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,   249,   250,   251,   252,    -1,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,   445,
     446,   447,    -1,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,    -1,
     466,   467,   468,   469,   470,   471,   472,    -1,   474,   475,
     476,   477,   478,   479,   480,    -1,   482,   483,   484,   485,
     486,   487,    -1,    -1,   490,    -1,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,    -1,   514,    -1,
     516,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     526,   527,    -1,    -1,    -1,     3,    -1,     5,     6,   535,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,   176,   177,
     178,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,   250,   251,   252,    -1,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,    -1,   432,   433,   434,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,   445,   446,   447,
      -1,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,    -1,   466,   467,
     468,   469,   470,   471,   472,    -1,   474,   475,   476,   477,
     478,   479,   480,    -1,   482,   483,   484,   485,   486,   487,
      -1,    -1,   490,    -1,    -1,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,    -1,   514,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   526,   527,
      -1,    -1,    -1,     3,    -1,     5,     6,   535,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    36,    37,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
      -1,   221,    -1,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,   249,
     250,   251,   252,    -1,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,    -1,
     310,   311,   312,    -1,    -1,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,    -1,   432,   433,   434,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,   445,   446,   447,    -1,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,    -1,   466,   467,   468,   469,
     470,   471,   472,    -1,   474,   475,   476,   477,   478,   479,
     480,    -1,   482,   483,   484,   485,   486,   487,    -1,    -1,
     490,    -1,    -1,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,    -1,   514,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   526,   527,    -1,    -1,
      -1,     3,    -1,     5,     6,   535,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    36,    37,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,   250,   251,
     252,    -1,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,    -1,
     432,   433,   434,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,   445,   446,   447,    -1,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,    -1,   466,   467,   468,   469,   470,   471,
     472,    -1,   474,   475,   476,   477,   478,   479,   480,    -1,
     482,   483,   484,   485,   486,   487,    -1,    -1,   490,    -1,
      -1,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,    -1,   514,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   526,   527,    -1,    -1,    -1,     3,
      -1,     5,     6,   535,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,   250,   251,   252,    -1,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
     434,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,   445,   446,   447,    -1,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,    -1,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,    -1,   482,   483,
     484,   485,   486,   487,    -1,    -1,   490,    -1,    -1,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,    -1,
     514,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   526,   527,    -1,    -1,    -1,    -1,    -1,   533,
     534,   535,     3,    -1,     5,     6,    -1,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,   434,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,   466,   467,   468,   469,   470,
     471,   472,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,   483,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,    -1,   514,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   526,   527,   528,    -1,    -1,
       3,    -1,     5,     6,   535,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,   250,   251,   252,
      -1,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,    -1,   432,
     433,   434,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,   445,   446,   447,    -1,    -1,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,    -1,   466,   467,   468,   469,   470,   471,   472,
      -1,   474,   475,   476,   477,   478,   479,   480,    -1,   482,
     483,   484,   485,   486,   487,    -1,    -1,   490,    -1,    -1,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
      -1,   514,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   526,   527,    -1,    -1,    -1,     3,    -1,
       5,     6,   535,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,   250,   251,   252,    -1,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,   434,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
     445,   446,   447,    -1,    -1,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
      -1,   466,   467,   468,   469,   470,   471,   472,    -1,   474,
     475,   476,   477,   478,   479,   480,    -1,   482,   483,   484,
     485,   486,   487,    -1,    -1,   490,    -1,    -1,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,    -1,   514,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   526,   527,    -1,    -1,    -1,     3,    -1,     5,     6,
     535,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      37,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,   250,   251,   252,    -1,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,    -1,   432,   433,   434,    -1,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,   445,   446,
     447,    -1,    -1,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,    -1,   466,
     467,   468,   469,   470,   471,   472,    -1,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,    -1,    -1,   490,    -1,    -1,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,    -1,   514,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   526,
     527,    -1,    -1,    -1,     3,    -1,     5,     6,   535,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,   177,   178,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,   250,   251,   252,    -1,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,   434,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,   466,   467,   468,
     469,   470,   471,   472,    -1,   474,   475,   476,   477,   478,
     479,   480,    -1,   482,   483,   484,   485,   486,   487,    -1,
      -1,   490,    -1,    -1,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,    -1,   514,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   526,   527,    -1,
      -1,    -1,     3,    -1,     5,     6,   535,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,   434,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,   448,    -1,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,   466,   467,   468,   469,   470,
     471,   472,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,   483,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,    -1,   514,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   526,   527,    -1,    -1,    -1,
       3,    -1,     5,     6,   535,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,   250,   251,   252,
      -1,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,    -1,   432,
     433,   434,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,   445,   446,   447,    -1,    -1,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,    -1,   466,   467,   468,   469,   470,   471,   472,
      -1,   474,   475,   476,   477,   478,   479,   480,    -1,   482,
     483,   484,   485,   486,   487,    -1,    -1,   490,    -1,    -1,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
      -1,   514,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   526,   527,    -1,    -1,    -1,     3,    -1,
       5,     6,   535,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,   250,   251,   252,    -1,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,   434,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
     445,   446,   447,    -1,    -1,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
      -1,   466,   467,   468,   469,   470,   471,   472,    -1,   474,
     475,   476,   477,   478,   479,   480,    -1,   482,   483,   484,
     485,   486,   487,    -1,    -1,   490,    -1,    -1,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,    -1,   514,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   526,   527,    -1,    -1,    -1,     3,    -1,     5,     6,
     535,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      37,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,   250,   251,   252,    -1,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,    -1,   432,   433,   434,    -1,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,   445,   446,
     447,    -1,    -1,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,    -1,   466,
     467,   468,   469,   470,   471,   472,    -1,   474,   475,   476,
     477,   478,   479,   480,    -1,   482,   483,   484,   485,   486,
     487,    -1,    -1,   490,    -1,    -1,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,    -1,   514,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   526,
     527,    -1,    -1,    -1,     3,    -1,     5,     6,   535,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,   250,   251,   252,    -1,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,   434,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,   466,   467,   468,
     469,   470,   471,   472,    -1,   474,   475,   476,   477,   478,
     479,   480,    -1,   482,   483,   484,   485,   486,   487,    -1,
      -1,   490,    -1,    -1,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,    -1,   514,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   526,   527,    -1,
      -1,    -1,     3,    -1,     5,     6,   535,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,   434,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,   466,   467,   468,   469,   470,
     471,   472,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,   483,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,    -1,   514,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   526,   527,    -1,    -1,    -1,
       3,    -1,     5,     6,   535,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,   250,   251,   252,
      -1,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,    -1,   432,
     433,   434,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,   445,   446,   447,    -1,    -1,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,    -1,   466,   467,   468,   469,   470,   471,   472,
      -1,   474,   475,   476,   477,   478,   479,   480,    -1,   482,
     483,   484,   485,   486,   487,    -1,    -1,   490,    -1,    -1,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
      -1,   514,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   526,   527,    -1,    -1,    -1,     3,    -1,
       5,     6,   535,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,   250,   251,   252,    -1,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,   434,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
     445,   446,   447,    -1,    -1,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
      -1,   466,   467,   468,   469,   470,   471,   472,    -1,   474,
     475,   476,   477,   478,   479,   480,    -1,   482,   483,   484,
     485,   486,   487,    -1,    -1,   490,    -1,    -1,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,    -1,   514,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   526,   527,    -1,    -1,    -1,     3,    -1,     5,     6,
     535,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      37,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,   250,   251,   252,    -1,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,    -1,   432,   433,   434,    -1,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,   445,   446,
     447,    -1,    -1,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,    -1,   466,
     467,   468,   469,   470,   471,   472,    -1,   474,   475,   476,
     477,   478,   479,   480,    -1,   482,   483,   484,   485,   486,
     487,    -1,    -1,   490,    -1,    -1,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,    -1,   514,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   526,
     527,    -1,    -1,    -1,     3,    -1,     5,     6,   535,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,   250,   251,   252,    -1,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,   434,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,   466,   467,   468,
     469,   470,   471,   472,    -1,   474,   475,   476,   477,   478,
     479,   480,    -1,   482,   483,   484,   485,   486,   487,    -1,
      -1,   490,    -1,    -1,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,    -1,   514,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   526,   527,    -1,
      -1,    -1,     3,    -1,     5,     6,   535,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,   434,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,   472,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,   483,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   526,   527,    -1,    -1,    -1,
       3,    -1,     5,     6,   535,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,    -1,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,   250,   251,   252,
      -1,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,    -1,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,    -1,   432,
     433,   434,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,   445,   446,   447,    -1,    -1,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,    -1,   466,   467,   468,   469,   470,   471,   472,
      -1,   474,   475,   476,   477,   478,   479,   480,    -1,   482,
     483,   484,   485,   486,   487,    -1,    -1,   490,    -1,    -1,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
      -1,   514,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   526,   527,    -1,    -1,    -1,     3,    -1,
       5,     6,   535,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,   250,   251,   252,    -1,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,   434,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
     445,   446,   447,    -1,    -1,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,   472,    -1,   474,
     475,   476,   477,   478,   479,   480,    -1,   482,   483,   484,
     485,   486,   487,    -1,    -1,   490,    -1,    -1,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   526,   527,     3,    -1,     5,     6,    -1,     8,     9,
     535,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
      -1,   221,    -1,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,   249,
     250,   251,   252,    -1,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,    -1,
     310,   311,   312,    -1,    -1,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,    -1,   432,   433,   434,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,   445,   446,   447,    -1,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,    -1,    -1,   467,   468,   469,
     470,   471,   472,    -1,   474,   475,   476,   477,   478,   479,
     480,    -1,   482,   483,   484,   485,   486,   487,    -1,    -1,
     490,    -1,    -1,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   526,   527,     3,    -1,
       5,     6,    -1,     8,     9,   535,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,   250,   251,   252,    -1,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,   434,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
     445,   446,   447,    -1,    -1,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,   472,    -1,   474,
     475,   476,   477,   478,   479,   480,    -1,   482,   483,   484,
     485,   486,   487,    -1,    -1,   490,    -1,    -1,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,     5,     6,    -1,     8,
       9,    -1,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
     535,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,   250,   251,   252,    -1,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,   434,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,   472,    -1,   474,   475,   476,   477,   478,
     479,   480,    -1,   482,   483,   484,   485,   486,   487,    -1,
      -1,   490,    -1,    -1,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,    -1,    -1,    -1,    -1,    -1,    -1,
       3,    -1,     5,     6,    -1,     8,     9,    -1,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,   535,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,   250,   251,   252,
      -1,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,    -1,   432,
     433,   434,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,   445,   446,   447,    -1,    -1,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,   472,
      -1,   474,   475,   476,   477,   478,   479,   480,    -1,   482,
     483,   484,   485,   486,   487,    -1,    -1,   490,    -1,    -1,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
      -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   535,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    66,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,    -1,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,   309,   310,   311,   312,    -1,    -1,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,    -1,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,   445,   446,
     447,    -1,    -1,   450,   451,   452,   453,   454,    -1,   456,
     457,   458,   459,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,   472,    -1,   474,   475,   476,
     477,   478,   479,   480,    -1,   482,   483,   484,   485,   486,
     487,    -1,    -1,   490,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,    -1,    -1,    -1,   516,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   535,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    66,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,   309,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,   434,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,   472,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,   483,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   535,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    66,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,   250,   251,   252,    -1,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,   434,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
     445,   446,   447,    -1,    -1,   450,   451,   452,   453,   454,
      -1,   456,   457,   458,   459,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,   472,    -1,   474,
     475,   476,   477,   478,   479,   480,    -1,   482,   483,   484,
     485,   486,   487,    -1,    -1,   490,    -1,    -1,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     535,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,   250,   251,   252,    -1,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,   434,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,   452,   453,   454,    -1,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,   472,    -1,   474,   475,   476,   477,   478,
     479,   480,    -1,   482,   483,   484,   485,   486,   487,    -1,
      -1,   490,    -1,    -1,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,    -1,    -1,    -1,    -1,    -1,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   535,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    66,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,   250,   251,   252,
      -1,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,    -1,   432,
     433,   434,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,   445,   446,   447,    -1,    -1,   450,   451,   452,
     453,   454,    -1,   456,   457,   458,   459,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,   472,
      -1,   474,   475,   476,   477,   478,   479,   480,    -1,   482,
     483,   484,   485,   486,   487,    -1,    -1,   490,    -1,    -1,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
      -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   535,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    66,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,   250,   251,   252,    -1,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,    -1,   432,   433,   434,    -1,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,   445,   446,
     447,    -1,    -1,   450,   451,   452,   453,   454,    -1,   456,
     457,   458,   459,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,   472,    -1,   474,   475,   476,
     477,   478,   479,   480,    -1,   482,   483,   484,   485,   486,
     487,    -1,    -1,   490,    -1,    -1,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,    -1,    -1,    -1,    -1,
      -1,    -1,     3,    -1,     5,     6,    -1,    -1,    -1,    -1,
      11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   535,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,   483,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,   526,   527,   528,    -1,    -1,
      -1,    -1,    -1,    -1,   535,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    33,    34,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,    -1,
      -1,    -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,   250,   251,   252,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,    -1,
     435,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
     445,   446,   447,    -1,    -1,   450,   451,   452,   453,   454,
      -1,   456,   457,   458,   459,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,    -1,    -1,   474,
     475,   476,   477,   478,   479,   480,    -1,   482,   483,   484,
     485,   486,   487,    -1,    -1,   490,    -1,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,    -1,
      -1,   516,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     535,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,    -1,    -1,    -1,   107,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,   250,   251,   252,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,    -1,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,    -1,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,   452,   453,   454,    -1,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,    -1,    -1,   474,   475,   476,   477,   478,
     479,   480,    -1,   482,   483,   484,   485,   486,   487,    -1,
      -1,   490,    -1,    -1,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,    -1,    -1,    -1,    -1,    -1,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   535,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,    -1,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,    -1,    -1,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,   296,    -1,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,    -1,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,    -1,   402,
     403,   404,   405,   406,    -1,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,    -1,   432,
     433,    -1,   435,   436,    -1,   438,   439,   440,   441,   442,
     443,    -1,   445,   446,   447,    -1,    -1,   450,   451,   452,
     453,   454,    -1,   456,   457,   458,   459,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,    -1,
      -1,   474,   475,   476,   477,   478,   479,   480,    -1,   482,
      -1,   484,   485,   486,   487,    -1,    -1,   490,    -1,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
      -1,    -1,    -1,   516,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   535,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
     107,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,   309,   310,   311,   312,    -1,    -1,   315,   316,
     317,    -1,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,    -1,   402,   403,   404,   405,   406,
      -1,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,    -1,   432,   433,    -1,   435,   436,
      -1,   438,   439,   440,   441,   442,   443,    -1,   445,   446,
     447,    -1,    -1,   450,   451,   452,   453,   454,    -1,   456,
     457,   458,   459,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,    -1,    -1,   474,   475,   476,
     477,   478,   479,   480,    -1,   482,    -1,   484,   485,   486,
     487,    -1,    -1,   490,    -1,    -1,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,    -1,    -1,    -1,    -1,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   535,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   535,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,    -1,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,    -1,
      -1,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,   296,    -1,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,    -1,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,    -1,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,    -1,   402,   403,   404,
     405,   406,    -1,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,    -1,   432,   433,    -1,
      -1,   436,    -1,   438,   439,   440,   441,   442,   443,    -1,
     445,   446,   447,    -1,    -1,   450,   451,   452,   453,   454,
      -1,   456,   457,   458,   459,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,    -1,    -1,   474,
     475,   476,   477,   478,   479,   480,    -1,   482,    -1,   484,
     485,   486,   487,    -1,    -1,   490,    -1,    -1,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     535,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,    -1,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,    -1,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,    -1,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,    -1,   402,   403,   404,   405,   406,    -1,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,    -1,    -1,   436,    -1,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,   452,   453,   454,    -1,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,    -1,    -1,   474,   475,   476,   477,   478,
     479,   480,    -1,   482,    -1,   484,   485,   486,   487,    -1,
      -1,   490,    -1,    -1,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,    -1,    -1,    -1,    -1,    -1,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   535,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,    -1,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,    -1,    -1,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,   296,    -1,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,    -1,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,    -1,   402,
     403,   404,   405,   406,    -1,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,    -1,   432,
     433,    -1,    -1,   436,    -1,   438,   439,   440,   441,   442,
     443,    -1,   445,   446,   447,    -1,    -1,   450,   451,   452,
     453,   454,    -1,   456,   457,   458,   459,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,    -1,
      -1,   474,   475,   476,   477,   478,   479,   480,    -1,   482,
      -1,   484,   485,   486,   487,    -1,    -1,   490,    -1,    -1,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,
      -1,    -1,   535,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    -1,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    -1,    -1,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,    -1,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,    -1,    -1,   167,   168,   169,   170,    -1,   172,   173,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,    -1,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,    -1,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
      -1,   315,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,    -1,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,    -1,   483,
     484,   485,   486,   487,   488,    -1,   490,    -1,    -1,    -1,
      -1,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,    -1,   511,   512,    -1,
     514,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     3,    -1,
       5,     6,    -1,    -1,    -1,    10,    11,    -1,    -1,    -1,
      -1,    -1,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    -1,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,    -1,   158,   159,   160,   161,    -1,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
      -1,   186,    -1,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,    -1,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,    -1,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,    -1,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,    -1,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,    -1,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,    -1,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,    -1,   453,    -1,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,    -1,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   510,   511,   512,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     3,    -1,     5,
       6,    -1,    -1,    -1,    10,    11,    -1,    -1,    -1,    -1,
      -1,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,    -1,   158,   159,   160,   161,    -1,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,    -1,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,    -1,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,    -1,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,    -1,   453,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,    -1,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   510,   511,   512,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,    -1,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,    -1,   402,   403,   404,   405,   406,
      -1,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,    -1,   432,   433,    -1,    -1,   436,
      -1,   438,   439,   440,   441,   442,   443,    -1,   445,   446,
     447,    -1,    -1,   450,   451,   452,   453,   454,    -1,   456,
     457,   458,   459,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,    -1,    -1,   474,   475,   476,
     477,   478,   479,   480,    -1,   482,    -1,   484,   485,   486,
     487,    -1,    -1,   490,    -1,    -1,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,
      -1,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,    -1,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,    -1,
     248,   249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,   296,    -1,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,   317,
      -1,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,    -1,   402,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,    -1,   432,   433,    -1,    -1,   436,    -1,
     438,   439,   440,   441,   442,   443,    -1,   445,   446,   447,
      -1,    -1,   450,   451,   452,   453,   454,    -1,   456,   457,
     458,   459,   460,   461,   462,   463,   464,    -1,    -1,   467,
     468,   469,   470,   471,    -1,    -1,   474,   475,   476,   477,
     478,   479,   480,    -1,   482,    -1,   484,   485,   486,   487,
      -1,    -1,   490,    -1,    -1,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,    -1,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,    -1,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,    -1,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,    -1,   402,   403,   404,   405,   406,    -1,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,    -1,    -1,   436,    -1,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,   452,   453,   454,    -1,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,    -1,    -1,   474,   475,   476,   477,   478,
     479,   480,    -1,   482,    -1,   484,   485,   486,   487,    -1,
      -1,   490,    -1,    -1,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,   211,    -1,   213,   214,   215,   216,   217,   218,   219,
      -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,   249,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,   296,    -1,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,    -1,
     310,   311,   312,    -1,    -1,   315,   316,   317,    -1,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,    -1,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,    -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,
     440,   441,   442,   443,    -1,   445,   446,   447,    -1,    -1,
     450,   451,   452,   453,   454,    -1,   456,   457,   458,   459,
     460,   461,   462,   463,   464,    -1,    -1,   467,   468,   469,
     470,   471,    -1,    -1,   474,   475,   476,   477,   478,   479,
     480,    -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,
     490,    -1,    -1,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     3,    -1,    -1,    -1,    -1,    -1,    -1,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     3,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,
      -1,    -1,    -1,    -1,    -1,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,    -1,
     432,   433,    -1,    -1,   436,    -1,   438,   439,   440,   441,
     442,   443,    -1,   445,   446,   447,    -1,    -1,   450,   451,
     452,   453,   454,    -1,   456,   457,   458,   459,   460,   461,
     462,   463,   464,    -1,    -1,   467,   468,   469,   470,   471,
      -1,    -1,   474,   475,   476,   477,   478,   479,   480,    -1,
     482,    -1,   484,   485,   486,   487,    -1,    -1,   490,    -1,
      -1,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,    -1,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,    -1,    -1,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,   296,    -1,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,    -1,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,    -1,   402,
     403,   404,   405,   406,    -1,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,    -1,   432,
     433,    -1,    -1,   436,    -1,   438,   439,   440,   441,   442,
     443,    -1,   445,   446,   447,    -1,    -1,   450,   451,   452,
     453,   454,    -1,   456,   457,   458,   459,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,    -1,
      -1,   474,   475,   476,   477,   478,   479,   480,    -1,   482,
      -1,   484,   485,   486,   487,    -1,    -1,   490,    -1,    -1,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     523,   524,   525,   526,   527,   528,   529,   530,   531,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   528,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   528,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   528,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   528,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   528,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,    -1,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,    -1,    -1,    -1,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,    -1,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,    -1,    -1,
     291,    -1,   293,   294,   295,   296,    -1,    -1,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,   314,   315,   316,   317,   318,   319,   320,
      -1,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,    -1,   339,    -1,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,    -1,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,    -1,   430,
      -1,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,    -1,   453,    -1,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,    -1,   480,
     481,   482,   483,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   510,
     511,   512,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,   528,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,    -1,   158,   159,   160,   161,
      -1,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,    -1,   184,    -1,    -1,    -1,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,   224,   225,   226,   227,   228,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,    -1,   250,   251,
     252,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,    -1,    -1,   291,
      -1,   293,   294,   295,   296,    -1,    -1,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,    -1,   335,   336,   337,    -1,   339,    -1,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,    -1,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,    -1,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,   445,   446,   447,    -1,    -1,   450,   451,
      -1,   453,    -1,    -1,   456,   457,   458,   459,   460,   461,
     462,   463,   464,    -1,    -1,   467,   468,   469,   470,   471,
      -1,    -1,   474,   475,   476,   477,   478,    -1,   480,   481,
     482,   483,   484,   485,   486,   487,    -1,    -1,   490,    -1,
      -1,   493,   494,   495,   496,   497,   498,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   510,   511,
     512,     3,    -1,     5,     6,    -1,    -1,    -1,    -1,    11,
      -1,    -1,    -1,    -1,    -1,    -1,   528,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,   250,   251,
     252,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,    -1,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,   445,   446,   447,    -1,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,    -1,    -1,   467,   468,   469,   470,   471,
      -1,    -1,   474,   475,   476,   477,   478,   479,   480,    -1,
     482,   483,   484,   485,   486,   487,    -1,    -1,   490,    -1,
      -1,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,     3,    -1,     5,     6,    -1,    -1,    -1,    -1,    11,
      -1,    -1,    -1,    -1,   526,   527,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,   250,   251,
     252,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,    -1,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,   445,   446,   447,    -1,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,    -1,    -1,   467,   468,   469,   470,   471,
      -1,    -1,   474,   475,   476,   477,   478,   479,   480,    -1,
     482,   483,   484,   485,   486,   487,    -1,    -1,   490,    -1,
      -1,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,     3,    -1,     5,     6,    -1,    -1,    -1,    -1,    11,
      -1,    -1,    -1,    -1,   526,   527,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,   250,   251,
     252,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,    -1,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,   445,   446,   447,    -1,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,    -1,    -1,   467,   468,   469,   470,   471,
      -1,    -1,   474,   475,   476,   477,   478,   479,   480,    -1,
     482,   483,   484,   485,   486,   487,    -1,    -1,   490,    -1,
      -1,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,     3,    -1,     5,     6,    -1,    -1,    -1,    -1,    11,
      -1,    -1,    -1,    -1,   526,   527,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,   250,   251,
     252,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,    -1,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,   445,   446,   447,    -1,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,    -1,    -1,   467,   468,   469,   470,   471,
      -1,    -1,   474,   475,   476,   477,   478,   479,   480,    -1,
     482,   483,   484,   485,   486,   487,    -1,    -1,   490,    -1,
      -1,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    11,
      -1,    -1,    -1,    -1,   526,   527,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,    -1,   177,    -1,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,    -1,
     432,   433,    -1,    -1,   436,    -1,   438,   439,   440,   441,
     442,   443,    -1,   445,   446,   447,    -1,    -1,   450,   451,
     452,   453,   454,    -1,   456,   457,   458,   459,   460,   461,
     462,   463,   464,    -1,    -1,   467,   468,   469,   470,   471,
      -1,    -1,   474,   475,   476,   477,   478,   479,   480,    -1,
     482,    -1,   484,   485,   486,   487,    -1,    -1,   490,    -1,
      -1,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   526,   527,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    33,    34,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,   250,   251,
     252,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,    -1,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,   445,   446,   447,    -1,    -1,   450,   451,
     452,   453,   454,    -1,   456,   457,   458,   459,   460,   461,
     462,   463,   464,    -1,    -1,   467,   468,   469,   470,   471,
      -1,    -1,   474,   475,   476,   477,   478,   479,   480,    -1,
     482,   483,   484,   485,   486,   487,    -1,    -1,   490,    -1,
      -1,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,     3,    -1,     5,     6,    -1,    -1,    -1,    -1,
      11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    66,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,   434,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,   472,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,   483,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,     5,     6,    -1,     8,     9,    -1,
      11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,   483,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,   106,   107,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,   483,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,   106,   107,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,   483,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,   106,   107,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,   472,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,   483,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,   106,   107,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,   186,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,   483,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,     6,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,   483,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,   106,   107,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,   483,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,   106,   107,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,   483,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,   106,   107,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,   483,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,   106,   107,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,   483,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,   106,   107,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,   483,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,     6,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,   483,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,     6,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,   483,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,   483,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,   483,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,   483,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,   483,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,   483,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,   483,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    -1,    -1,    80,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,   173,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,   466,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,   173,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,   466,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    99,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,   183,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    99,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,   183,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,   173,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,   466,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    99,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,   309,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,   435,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,   173,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,   435,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    99,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,   309,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,   435,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,   309,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,   472,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,   472,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,   309,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,   309,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,   435,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,     6,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    38,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    38,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    38,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,    -1,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,    -1,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,    -1,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,    -1,    -1,   436,    -1,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,   452,   453,   454,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,   479,   480,
      -1,   482,    -1,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,    -1,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,    -1,    -1,    -1,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,    -1,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,    -1,    -1,
     291,    -1,   293,   294,   295,   296,    -1,    -1,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
      -1,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,    -1,   339,    -1,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,    -1,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,    -1,   430,
      -1,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,    -1,   453,    -1,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,    -1,   480,
     481,   482,   483,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   510,
     511,   512,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    -1,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    -1,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,    -1,
      -1,    -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,    -1,   158,   159,   160,   161,    -1,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,    -1,   184,
      -1,    -1,    -1,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,   212,    -1,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,   224,
     225,   226,   227,   228,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,    -1,   250,   251,   252,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,    -1,    -1,   291,    -1,   293,   294,
     295,   296,   297,    -1,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,    -1,   318,   319,   320,    -1,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,   336,   337,    -1,   339,    -1,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,   383,    -1,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,    -1,   430,    -1,   432,   433,    -1,
     435,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
     445,   446,   447,    -1,    -1,   450,   451,    -1,   453,    -1,
      -1,   456,   457,   458,   459,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,    -1,    -1,   474,
     475,   476,   477,   478,    -1,   480,    -1,   482,   483,   484,
     485,   486,   487,    -1,    -1,   490,    -1,    -1,   493,   494,
     495,   496,   497,   498,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   510,   511,   512,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    -1,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    -1,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,    -1,    -1,    -1,   107,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,    -1,   158,
     159,   160,   161,    -1,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,    -1,    -1,    -1,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,   212,    -1,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,   224,   225,   226,   227,   228,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
      -1,   250,   251,   252,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,    -1,   293,   294,   295,   296,    -1,    -1,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,    -1,   318,
     319,   320,    -1,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,    -1,   335,   336,   337,    -1,
     339,    -1,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,    -1,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,    -1,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
      -1,   430,    -1,   432,   433,    -1,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,    -1,   453,    -1,    -1,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,    -1,    -1,   474,   475,   476,   477,   478,
      -1,   480,    -1,   482,   483,   484,   485,   486,   487,    -1,
      -1,   490,    -1,    -1,   493,   494,   495,   496,   497,   498,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   510,   511,   512,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    -1,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    -1,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,    -1,    -1,    -1,   107,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,    -1,   158,   159,   160,   161,    -1,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
      -1,   184,    -1,    -1,    -1,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,   224,   225,   226,   227,   228,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,    -1,   250,   251,   252,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,    -1,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,    -1,
     293,   294,   295,   296,    -1,    -1,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,    -1,   318,   319,   320,    -1,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,    -1,   335,   336,   337,    -1,   339,    -1,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,    -1,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,    -1,   430,    -1,   432,
     433,    -1,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,   445,   446,   447,    -1,    -1,   450,   451,    -1,
     453,    -1,    -1,   456,   457,   458,   459,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,    -1,
      -1,   474,   475,   476,   477,   478,    -1,   480,    -1,   482,
     483,   484,   485,   486,   487,    -1,    -1,   490,    -1,    -1,
     493,   494,   495,   496,   497,   498,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   510,   511,   512,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    -1,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      -1,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,    -1,    -1,    -1,
     107,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
      -1,   158,   159,   160,   161,    -1,    -1,   164,    -1,   166,
     167,   168,   169,   170,   171,   172,    -1,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,    -1,   184,    -1,    -1,
      -1,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,   212,    -1,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,   224,   225,   226,
     227,   228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,    -1,   250,   251,   252,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,    -1,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,    -1,    -1,   291,    -1,   293,   294,   295,   296,
      -1,    -1,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
      -1,   318,   319,   320,    -1,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,    -1,   335,   336,
     337,    -1,   339,    -1,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,    -1,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,    -1,   430,    -1,   432,   433,    -1,    -1,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,   445,   446,
     447,    -1,    -1,   450,   451,    -1,   453,    -1,    -1,   456,
     457,   458,   459,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,    -1,    -1,   474,   475,   476,
     477,   478,    -1,   480,    -1,   482,   483,   484,   485,   486,
     487,    -1,    -1,   490,    -1,    -1,   493,   494,   495,   496,
     497,   498,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   510,   511,   512,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,    -1,    -1,   164,    -1,   166,   167,   168,   169,   170,
     171,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,    -1,    -1,    -1,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,    -1,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,    -1,    -1,
     291,    -1,   293,   294,   295,   296,    -1,    -1,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,    -1,   318,   319,   320,
      -1,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,    -1,   339,    -1,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,    -1,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,    -1,   430,
      -1,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,    -1,   453,    -1,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,    -1,   480,
      -1,   482,   483,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   510,
     511,   512,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    -1,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    -1,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,    -1,
      -1,    -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,    -1,   158,   159,   160,   161,    -1,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,    -1,   184,
      -1,    -1,    -1,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,   212,    -1,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,   224,
     225,   226,   227,   228,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,    -1,   250,   251,   252,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,    -1,    -1,   291,    -1,   293,   294,
     295,   296,    -1,    -1,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,    -1,   318,   319,   320,    -1,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,   336,   337,    -1,   339,    -1,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,   383,    -1,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,    -1,   430,    -1,   432,   433,    -1,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
     445,   446,   447,    -1,    -1,   450,   451,    -1,   453,    -1,
      -1,   456,   457,   458,   459,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,    -1,    -1,   474,
     475,   476,   477,   478,    -1,   480,    -1,   482,   483,   484,
     485,   486,   487,    -1,    -1,   490,    -1,    -1,   493,   494,
     495,   496,   497,   498,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   510,   511,   512,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    -1,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    -1,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,    -1,    -1,    -1,   107,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,    -1,   158,
     159,   160,   161,    -1,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,    -1,    -1,    -1,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,   212,    -1,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,   224,   225,   226,   227,   228,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
      -1,   250,   251,   252,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
      -1,    -1,   291,    -1,   293,   294,   295,   296,    -1,    -1,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,    -1,   318,
     319,   320,    -1,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,    -1,   335,   336,   337,    -1,
     339,    -1,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,    -1,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,    -1,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
      -1,   430,    -1,   432,   433,    -1,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,    -1,
      -1,   450,   451,    -1,   453,    -1,    -1,   456,   457,   458,
     459,   460,   461,   462,   463,   464,    -1,    -1,   467,   468,
     469,   470,   471,    -1,    -1,   474,   475,   476,   477,   478,
      -1,   480,    -1,   482,   483,   484,   485,   486,   487,    -1,
      -1,   490,    -1,    -1,   493,   494,   495,   496,   497,   498,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   510,   511,   512,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    -1,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    -1,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,    -1,    -1,    -1,   107,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,    -1,   158,   159,   160,   161,    -1,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
      -1,   184,    -1,    -1,    -1,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,   224,   225,   226,   227,   228,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,    -1,   250,   251,   252,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,    -1,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,    -1,    -1,   291,    -1,
     293,   294,   295,   296,    -1,    -1,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,    -1,   318,   319,   320,    -1,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,    -1,   335,   336,   337,    -1,   339,    -1,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,    -1,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,    -1,   430,    -1,   432,
     433,    -1,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,   445,   446,   447,    -1,    -1,   450,   451,    -1,
     453,    -1,    -1,   456,   457,   458,   459,   460,   461,   462,
     463,   464,    -1,    -1,   467,   468,   469,   470,   471,    -1,
      -1,   474,   475,   476,   477,   478,    -1,   480,    -1,   482,
     483,   484,   485,   486,   487,    -1,    -1,   490,    -1,    -1,
     493,   494,   495,   496,   497,   498,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   510,   511,   512,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    -1,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      -1,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,    -1,    -1,    -1,
     107,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
      -1,   158,   159,   160,   161,    -1,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,    -1,   184,    -1,    -1,
      -1,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,   212,    -1,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,   224,   225,   226,
     227,   228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,    -1,   250,   251,   252,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,    -1,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,    -1,    -1,   291,    -1,   293,   294,   295,   296,
      -1,    -1,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
      -1,   318,   319,   320,    -1,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,    -1,   335,   336,
     337,    -1,   339,    -1,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,    -1,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,    -1,   430,    -1,   432,   433,    -1,    -1,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,   445,   446,
     447,    -1,    -1,   450,   451,    -1,   453,    -1,    -1,   456,
     457,   458,   459,   460,   461,   462,   463,   464,    -1,    -1,
     467,   468,   469,   470,   471,    -1,    -1,   474,   475,   476,
     477,   478,    -1,   480,    -1,   482,   483,   484,   485,   486,
     487,    -1,    -1,   490,    -1,    -1,   493,   494,   495,   496,
     497,   498,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   510,   511,   512,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,    -1,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,    -1,    -1,    -1,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,    -1,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,    -1,    -1,
     291,    -1,   293,   294,   295,   296,    -1,    -1,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,    -1,   318,   319,   320,
      -1,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,    -1,   335,   336,   337,    -1,   339,    -1,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,    -1,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,    -1,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,    -1,   430,
      -1,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,    -1,    -1,   450,
     451,    -1,   453,    -1,    -1,   456,   457,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,   468,   469,   470,
     471,    -1,    -1,   474,   475,   476,   477,   478,    -1,   480,
      -1,   482,   483,   484,   485,   486,   487,    -1,    -1,   490,
      -1,    -1,   493,   494,   495,   496,   497,   498,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   510,
     511,   512,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    -1,    -1,    54,
      -1,    -1,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    -1,    -1,    71,    -1,    73,    74,
      75,    76,    -1,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,    -1,
      -1,    -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,    -1,    -1,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,    -1,   158,   159,   160,   161,    -1,    -1,   164,
      -1,   166,   167,   168,    -1,   170,    -1,   172,    -1,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,    -1,   184,
      -1,    -1,    -1,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,   212,    -1,   214,
     215,   216,   217,    -1,    -1,    -1,    -1,    -1,   223,   224,
     225,   226,   227,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,    -1,   250,   251,   252,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,    -1,   281,   282,   283,   284,
     285,   286,   287,   288,    -1,    -1,   291,    -1,   293,   294,
     295,   296,    -1,    -1,   299,    -1,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,    -1,   318,   319,   320,    -1,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,    -1,
     335,   336,   337,    -1,   339,    -1,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,   383,    -1,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,    -1,   402,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,    -1,   430,    -1,   432,   433,    -1,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
     445,    -1,    -1,    -1,    -1,   450,   451,    -1,   453,    -1,
      -1,   456,   457,   458,   459,   460,   461,   462,   463,   464,
      -1,    -1,   467,   468,   469,   470,   471,    -1,    -1,   474,
     475,   476,   477,   478,    -1,    -1,    -1,   482,   483,   484,
     485,   486,   487,    -1,    -1,   490,    -1,    -1,   493,   494,
     495,   496,   497,   498,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   510,   511,   512
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    20,    31,    33,    34,    51,    61,    73,    75,    76,
      82,    84,    97,    99,   116,   119,   134,   136,   140,   147,
     156,   158,   165,   183,   200,   254,   255,   260,   275,   294,
     342,   357,   363,   364,   366,   371,   377,   380,   387,   394,
     395,   402,   406,   418,   435,   456,   468,   474,   479,   492,
     516,   518,   519,   520,   521,   522,   535,   542,   543,   544,
     545,   550,   551,   557,   558,   560,   561,   562,   563,   565,
     568,   580,   585,   586,   589,   590,   591,   613,   616,   617,
     632,   683,   686,   687,   690,   693,   694,   695,   703,   710,
     712,   713,   716,   719,   720,   724,   733,   737,   738,   739,
     742,   744,   745,   746,   747,   755,   757,   777,   781,   783,
     784,   794,   796,   803,   804,   807,   808,   809,   810,   811,
     820,   822,   824,   827,   831,   832,   842,   843,   848,   853,
     864,   896,   899,   900,   901,   906,   909,   911,   913,   915,
     916,   920,   921,   924,   926,   927,   931,   932,   933,   936,
     937,   938,   939,   940,   947,   949,   950,   951,   952,   958,
     960,   961,   967,   968,   969,   972,   973,   974,   975,   977,
     978,   980,   981,   983,   984,   986,   998,  1000,  1003,  1005,
    1006,  1015,  1017,  1022,  1027,  1037,  1041,  1042,  1043,  1044,
    1045,  1046,  1052,  1088,   450,   495,   953,    28,    79,    96,
     114,   120,   138,   151,   160,   173,   179,   186,   206,   244,
     266,   310,   337,   347,   348,   351,   379,   382,   386,   389,
     396,   399,   420,   428,   433,   435,   438,   443,   453,   458,
     472,   485,   709,   953,     3,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    30,    31,    32,    40,    41,    42,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    58,    59,    60,    61,    62,    63,    64,
      67,    68,    69,    70,    71,    73,    74,    75,    76,    77,
      79,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    93,    94,    95,    96,    97,    98,   100,   101,
     102,   103,   107,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   121,   123,   124,   125,   126,   127,   128,   129,
     131,   132,   133,   134,   137,   138,   139,   140,   141,   143,
     144,   145,   146,   148,   149,   150,   151,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   164,   166,   167,
     168,   169,   170,   172,   174,   175,   176,   178,   179,   180,
     181,   182,   184,   185,   187,   188,   189,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   202,   203,   204,
     205,   206,   207,   208,   209,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   221,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   248,   249,
     250,   251,   252,   254,   255,   256,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   293,
     294,   295,   296,   298,   299,   300,   301,   302,   303,   305,
     306,   307,   310,   311,   312,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   396,   397,   398,   399,   400,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   432,   433,   436,   437,   438,   439,
     440,   441,   442,   443,   445,   446,   447,   450,   451,   452,
     453,   454,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   467,   468,   469,   470,   471,   474,   475,   476,   477,
     478,   479,   480,   482,   483,   484,   485,   486,   487,   490,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
    1156,  1249,  1261,  1262,  1266,  1267,  1268,     3,    29,  1038,
    1246,  1261,  1266,   483,   535,   991,   308,   343,   953,    54,
     535,   624,    23,    41,    66,    79,   114,   120,   138,   151,
     160,   173,   182,   186,   256,   310,   313,   337,   351,   379,
     389,   399,   420,   428,   438,   440,   442,   443,   458,   466,
     469,   472,   633,   692,   799,   854,   865,    29,   342,  1246,
    1038,    29,   336,   397,   440,   442,     6,   243,   907,   908,
    1252,    23,    28,    66,    79,    96,   114,   138,   151,   160,
     173,   179,   186,   206,   266,   310,   323,   337,   348,   351,
     379,   382,   386,   389,   396,   399,   420,   428,   435,   438,
     443,   451,   453,   458,   472,   485,   709,   812,   814,   815,
     953,  1246,    99,   483,   535,   687,   690,   693,   986,   999,
    1003,  1006,  1015,  1022,  1027,  1037,  1041,    11,    22,    29,
      49,   168,   175,   177,   201,   245,   283,   345,   365,   526,
     527,   828,   829,  1038,  1251,  1253,    29,    31,    99,   361,
     395,   833,   834,   835,  1261,   173,  1261,  1248,  1252,   435,
    1055,   828,  1261,   450,  1246,   323,   266,   535,   919,   387,
    1261,    29,   400,   446,   450,   572,   581,   582,  1261,   183,
     833,   834,  1261,   343,   953,  1261,   242,    29,   135,  1057,
    1058,    67,    93,   256,   277,   379,   389,   400,   446,   450,
     498,   569,   570,   571,   572,    29,   400,   446,   450,   572,
     450,   309,  1100,  1101,  1244,  1261,  1055,   528,  1261,   178,
     535,   992,   535,   359,  1047,  1048,  1246,  1047,     3,    53,
      55,    56,    69,    70,   117,   118,   139,   169,   218,   219,
     221,   228,   278,   280,   300,   356,   404,   410,   446,   447,
     480,  1129,  1131,  1133,  1135,  1137,  1139,  1140,  1141,  1143,
    1144,  1145,  1147,  1148,  1152,  1262,  1266,  1057,  1058,  1059,
    1257,    12,  1258,  1259,  1261,  1258,  1258,  1042,  1043,  1046,
       0,   538,   535,   991,   152,   220,   314,   465,  1060,  1061,
    1042,  1044,  1045,   125,   216,   268,   471,   539,    35,   957,
     881,  1249,   817,  1261,   817,  1246,   346,   817,   453,  1246,
     113,   435,   869,  1249,  1261,  1268,     3,   106,   110,   401,
    1254,  1255,  1263,  1266,  1267,  1268,    29,   195,  1244,   301,
     485,    10,    17,    18,    19,    74,   164,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   903,   905,  1187,  1188,
    1261,   195,  1246,   869,  1246,    29,  1254,  1255,   869,  1246,
    1246,   195,  1244,  1246,   195,   817,  1246,   371,   402,    29,
     195,  1100,  1246,   392,  1246,   817,    29,   263,  1254,  1255,
     195,  1244,   243,   122,   226,   292,   355,   954,   955,   956,
     535,   533,   537,  1213,  1215,   513,   985,   986,   987,   988,
    1263,  1244,  1246,  1261,    28,    66,    80,    92,   114,   138,
     179,   206,   244,   310,   348,   379,   382,   428,   438,   451,
     458,   812,   813,   814,   815,  1252,   957,  1002,  1006,  1015,
    1022,  1027,  1041,  1244,   270,   817,   535,   195,   817,  1246,
     817,   453,   195,  1246,   113,   435,   440,   442,  1254,  1255,
     440,   442,    74,   164,   903,   369,  1246,  1246,  1254,   195,
     546,  1261,   195,  1246,   195,   547,   817,  1246,  1246,   392,
     817,   263,  1254,   359,   396,   435,   485,   266,    96,   206,
      28,    92,   179,   348,   386,   451,   453,   457,   704,    29,
    1246,  1039,   579,  1252,  1263,   908,   270,   195,   881,   882,
     195,   912,   195,  1246,   195,   819,  1129,   453,   113,   435,
     195,   868,   869,   195,  1255,  1256,    87,   485,    74,   164,
     195,   904,   905,    59,   195,   868,   195,  1256,   195,   868,
     195,  1246,   195,  1246,   392,   912,   195,   819,   195,   263,
    1256,   243,   195,   816,   817,   195,  1245,  1246,   195,  1246,
     957,   535,  1004,   633,   999,   479,   985,   991,  1253,   829,
     830,    29,   830,  1253,   830,    29,   830,  1253,   830,   830,
     830,  1253,  1251,  1251,  1038,   830,   346,   535,   433,   535,
     660,   660,   660,   308,   448,   539,   660,   389,  1100,  1102,
     539,   948,  1252,   535,  1001,    59,   485,   985,   114,   206,
     389,   433,   435,   917,   918,  1261,    48,   512,   226,   537,
     311,   308,   177,   311,  1252,   448,   957,   171,   825,   308,
       5,     8,     9,    10,    12,    37,    53,    55,    56,    65,
      66,    69,    70,    77,    79,   104,   105,   106,   107,   108,
     109,   110,   117,   118,   120,   157,   162,   163,   169,   185,
     187,   218,   219,   221,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   238,   249,   257,   258,   269,   278,   280,
     290,   292,   297,   298,   300,   310,   321,   338,   356,   384,
     401,   410,   429,   434,   446,   447,   452,   454,   455,   466,
     472,   480,   500,   501,   502,   503,   505,   506,   507,   508,
     514,   526,   527,   528,   535,  1042,  1132,  1135,  1138,  1139,
    1140,  1142,  1143,  1144,  1147,  1148,  1152,  1153,  1155,  1156,
    1157,  1159,  1183,  1184,  1185,  1189,  1207,  1212,  1238,  1241,
    1242,  1249,  1250,  1251,  1252,  1261,  1240,  1241,  1252,    29,
     587,  1243,  1244,   400,   569,   120,   578,  1252,   579,  1252,
      48,    71,   569,   512,   411,   955,   311,   177,   448,   525,
      48,   512,   226,   956,   535,  1244,   528,  1215,  1102,   985,
     176,   993,  1153,  1192,  1047,   539,   535,   994,   482,  1146,
    1146,  1146,   535,  1134,  1134,   340,   535,  1136,    69,    70,
    1146,  1134,  1131,   516,   517,   535,  1149,   535,  1149,    37,
    1130,   535,   115,   193,   271,   274,   393,   510,   535,  1150,
    1151,   537,   818,  1134,  1240,  1216,   536,   536,   544,   985,
     995,   996,   997,  1244,    29,   135,  1056,  1056,    59,  1056,
     165,   171,   253,   304,  1064,  1066,  1067,  1082,  1084,  1085,
    1086,  1060,  1061,   177,   222,   222,  1100,  1103,   535,    68,
     288,   324,   367,   402,   535,   879,   324,   363,   367,   402,
     818,   324,   367,   402,     3,    91,   145,   259,   324,   363,
     367,   402,   438,   441,   492,   580,   583,   962,   963,   964,
     965,   849,    25,   140,   324,   367,   402,   476,   598,  1246,
      25,   140,   402,   471,   564,   496,   195,  1100,    62,    98,
     161,   198,   248,   288,   292,   324,   325,   367,   376,   385,
     394,   402,   416,   425,   430,   487,   580,   584,   885,   897,
     925,   535,   866,  1215,   367,   564,   201,   157,    25,    31,
      46,    76,   133,   140,   144,   172,   208,   288,   292,   302,
     312,   324,   367,   370,   371,   402,   476,   592,   596,   597,
     727,   925,     5,   526,   527,   701,  1253,    29,   195,  1244,
     817,   817,   535,   902,   324,   402,   537,   157,   308,   324,
     367,   402,   897,   925,    25,   140,   324,   367,   402,   201,
     559,   367,   492,   516,   552,   559,   324,   367,   402,   897,
     925,   308,   324,   367,   157,    38,    60,   112,   204,   267,
     272,   288,   323,   367,   372,   396,   402,   418,   592,   698,
     699,   324,   367,   484,   727,   735,   157,   324,   367,   402,
      25,    91,   133,   140,   144,   324,   363,   367,   402,   409,
     582,   570,   572,   201,   157,    46,   131,   268,   288,   367,
     402,   413,   592,   595,   324,   367,   371,   402,    89,   132,
     327,   441,   308,    25,    31,   140,   324,   367,   402,   614,
     615,   559,   171,   367,   552,   559,   157,   367,   402,   592,
    1246,   251,   122,   309,   497,   539,   954,    29,   135,   481,
     528,   536,   874,  1153,  1193,  1194,  1262,  1153,  1214,     3,
      29,    33,    34,    35,    36,    37,    38,    39,    43,    57,
      65,    66,    72,    78,    80,    92,    99,   104,   105,   106,
     108,   109,   110,   120,   122,   130,   135,   136,   142,   147,
     152,   163,   165,   171,   173,   177,   183,   186,   190,   201,
     210,   220,   222,   246,   247,   253,   257,   258,   292,   297,
     304,   308,   309,   313,   314,   334,   344,   361,   375,   395,
     401,   412,   431,   434,   435,   444,   448,   449,   455,   465,
     466,   472,   473,   481,   488,   489,   491,   492,   528,  1247,
    1264,  1266,  1267,  1268,  1269,  1213,   536,   539,   163,   308,
     455,   576,   579,   701,   989,   473,   982,   308,   881,   535,
     817,  1246,  1129,   869,   301,    74,   164,   905,   869,   869,
     171,  1129,   817,  1246,  1246,   536,   660,  1246,    72,  1129,
     292,   177,   535,   785,   552,    38,   976,  1246,   292,   552,
     496,   195,  1244,   552,   817,   817,   785,   469,   633,   308,
     171,   492,   893,   552,   292,    48,   566,   292,   458,   734,
     292,   994,    91,   324,   711,    89,   132,   327,   441,    38,
     785,   171,   195,   552,   485,   195,  1244,   195,   688,  1244,
    1244,   485,   817,    87,   548,  1249,   453,  1249,  1249,  1246,
     171,  1246,   709,    40,    54,   111,   215,   288,   391,   157,
      63,   373,   539,   549,   157,   535,   157,   552,   157,   539,
     549,   496,   157,   539,   549,   157,   539,   195,   816,   195,
     817,   195,   817,   157,   539,   549,  1256,   157,   549,   157,
     157,   549,   157,   549,   157,    89,   132,   327,   441,   171,
     157,   549,   157,   171,   195,   157,   539,   549,   157,   539,
     549,   157,   308,  1192,   435,   536,   999,   830,  1038,   830,
    1038,   830,  1038,   830,  1038,   830,  1038,  1038,  1038,   830,
    1038,   535,   661,   662,  1261,   661,    29,   114,   138,   173,
     179,   243,   244,   326,   348,   382,   389,   396,   435,   438,
     458,   838,  1243,  1256,   835,  1246,   201,   539,  1018,  1252,
    1129,  1196,    38,  1256,   548,   536,   548,   548,   548,   251,
    1261,   171,   838,  1256,   171,   387,  1261,   579,   308,   535,
    1216,   533,  1042,  1197,  1153,  1211,   535,   535,   171,   535,
     535,  1042,   535,   535,   535,   535,   535,   535,   535,   535,
     535,   535,   535,   535,   535,   535,   535,   535,   535,   535,
    1153,   535,   535,   535,   535,   535,   535,   535,   535,   299,
     649,   535,   535,   535,   535,   535,   535,   535,   535,  1153,
    1153,  1153,  1042,  1153,  1192,  1215,  1252,   535,  1252,     3,
      10,    13,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   167,   168,   169,   170,   172,   173,
     174,   175,   176,   178,   179,   180,   181,   182,   184,   185,
     187,   188,   189,   191,   192,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   221,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   272,
     273,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     305,   306,   307,   309,   310,   311,   312,   313,   315,   316,
     317,   318,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   483,   484,
     485,   486,   487,   488,   490,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     511,   512,   514,   523,   524,   525,   526,   527,   528,   529,
     530,   531,  1187,  1189,  1191,  1265,  1270,   493,  1170,   320,
    1153,   166,  1171,   222,   539,  1053,   535,  1252,  1215,  1053,
     123,   197,   588,   539,    71,   120,   579,    38,     3,   120,
     256,   577,   701,  1148,  1252,  1252,    94,   137,  1165,   103,
     120,   573,   574,   576,   701,   120,   573,   251,  1244,    95,
     372,   821,   536,   991,    35,    45,    52,    78,   196,   201,
     224,   252,   310,   313,   407,   536,   539,  1048,  1245,    38,
     535,  1192,  1251,  1146,  1146,    37,  1130,   446,   446,  1251,
    1251,   533,   533,  1251,   448,   448,   448,   535,   448,  1251,
    1247,   537,  1134,   177,  1089,    15,   525,  1213,  1260,   536,
     539,   994,  1044,  1044,  1062,  1063,  1153,  1044,   168,   283,
    1073,   240,   288,   355,   405,   471,    29,  1068,  1153,   526,
     527,  1069,  1070,  1153,  1155,  1082,  1083,  1067,  1066,  1064,
    1065,   171,  1085,   302,  1087,  1064,  1082,  1103,  1007,  1244,
    1103,    38,  1261,   402,  1192,    68,   448,   448,   389,   201,
     213,   314,   317,   404,   481,   528,   872,   873,   874,   876,
     878,   880,  1129,  1262,   448,   484,   448,   389,   448,   448,
     389,   253,   448,    79,   448,   438,   569,   324,   962,   964,
     525,   966,   171,   183,   201,   377,   850,   851,    72,    92,
     292,   657,   658,    92,   120,   292,   448,    92,   448,   120,
     292,   389,    92,   133,   144,   324,   367,   782,   389,   717,
      28,    66,   138,   179,   310,   348,   382,   451,   458,   812,
     813,  1246,   157,   367,   402,   592,   308,   701,   394,   248,
     448,  1261,   448,   297,   701,   124,   223,   389,   400,   450,
     571,   817,   373,   402,   885,   898,   128,   536,   867,   872,
     448,   472,   438,  1244,    72,    80,    92,   153,   173,   195,
     344,   466,   640,   655,   656,  1261,    80,    92,   922,   329,
     308,   384,   386,   453,    92,   922,    32,   370,   384,   386,
     453,   384,  1244,   172,   208,   302,   817,   535,   448,   448,
     194,   535,   602,    23,   262,   438,   469,   494,   602,    92,
     539,   128,     5,     5,   324,   201,   157,   367,   402,   592,
     925,   473,   473,   289,  1129,   448,   389,   535,   903,  1246,
    1244,   448,   448,   389,   898,   128,   107,   435,   436,   934,
     935,  1101,  1244,  1261,   935,   448,   448,   785,   935,   114,
     402,   583,   448,   554,   583,   448,   448,   389,   898,   128,
    1244,   448,   448,  1244,  1131,   701,    59,   700,   701,   701,
     112,   267,   272,    59,   448,   552,   276,   389,   552,   288,
     699,   448,   448,   297,  1252,   727,   817,   448,   448,   389,
     420,   351,  1252,   351,   448,   351,   448,   351,   785,   785,
     438,  1100,   329,   329,   330,    92,   448,   922,   389,   329,
     448,   448,   602,   602,   817,   817,   817,   817,  1244,    47,
     478,    47,    47,   478,   448,    47,   448,   478,   389,   535,
     539,   583,   472,   743,  1255,   448,   554,   583,  1244,   448,
     922,   389,   324,   367,   355,   368,   398,   575,   954,  1193,
    1193,  1194,   536,    15,    16,   539,  1060,  1061,   534,   540,
    1244,   987,  1246,  1244,   224,  1129,   224,   308,   224,   224,
     701,   817,   817,   224,   224,   224,  1129,   224,   224,   224,
     308,   448,   177,   448,   618,   458,   535,    38,   157,   817,
     786,   787,  1264,   962,  1129,   308,   157,   714,  1246,   292,
     329,   535,   553,   799,   473,   359,   485,  1244,    29,   935,
     785,   553,   157,  1255,    99,   183,   567,   632,   694,   757,
     831,   853,   958,   157,  1252,   735,   736,   157,   308,  1252,
    1255,   259,   817,   817,   817,   817,   148,   354,   535,   743,
     292,   553,  1244,   292,   696,   698,   292,    38,   302,   329,
     535,   660,   660,   195,   691,  1244,   171,   195,   546,  1261,
     535,   789,   879,  1246,   535,   870,   870,    38,  1129,    27,
      50,   217,   758,   243,   492,   494,  1040,   391,   882,   881,
    1129,  1246,   535,   819,  1129,   868,   869,  1256,  1255,   157,
     549,   157,   473,   157,   473,   904,   905,   549,   868,  1256,
     868,  1246,  1246,  1129,   819,  1256,   743,   157,   816,   817,
    1245,  1246,  1246,   817,   536,   195,  1244,   999,  1038,  1038,
    1038,  1038,  1038,  1038,   661,   536,   539,   536,   180,   349,
     383,   397,   436,  1245,   816,   113,   399,   868,  1245,   301,
     836,   837,  1261,   868,   868,  1245,  1243,  1243,  1245,   816,
     448,   184,   492,   847,   152,   253,   740,   741,    23,   155,
     384,   405,  1019,  1100,   296,  1020,   536,   539,  1002,   448,
    1244,  1246,  1244,   546,   833,   834,   177,   847,   834,  1261,
      28,    80,   138,   179,   244,   348,   382,   458,   812,   813,
    1192,   534,  1192,  1197,  1198,   488,  1208,  1209,  1153,  1192,
     535,  1251,  1251,     3,   115,   193,   271,   274,   393,   510,
    1199,  1200,  1252,  1192,  1192,  1153,  1226,   375,  1042,  1043,
    1226,  1230,  1237,  1226,  1226,  1153,  1155,  1193,  1230,  1233,
    1234,  1153,  1234,  1226,  1153,  1226,  1226,  1192,  1251,  1251,
     536,  1153,  1153,   903,  1153,  1193,  1195,  1202,   384,   526,
     527,   535,  1154,  1155,  1189,  1203,   536,  1192,  1153,  1195,
    1204,  1153,    57,   177,   247,   449,  1153,  1192,  1205,   135,
     292,  1042,  1192,   276,  1155,  1153,  1163,  1164,  1165,   276,
    1153,  1165,   536,   539,  1251,  1150,  1129,  1153,  1153,  1153,
    1153,  1264,   256,   446,    43,   431,  1217,   817,  1153,   535,
    1042,  1206,   135,   137,   163,   228,   284,   285,   286,   287,
     291,   292,   297,   455,   467,  1201,  1231,  1153,   535,  1153,
     448,    52,   196,   201,   252,   407,  1153,  1153,  1153,  1153,
    1153,  1153,  1153,  1153,  1153,  1153,    29,    36,   412,  1186,
     186,  1171,   384,   535,  1183,   535,   319,  1175,   182,   256,
     435,   440,   442,   469,  1054,  1244,  1242,  1089,  1193,  1089,
    1244,   450,   535,  1252,   539,   536,   194,   194,   549,   997,
     986,   990,  1153,   536,   266,   292,  1049,  1192,   536,   536,
     533,   512,   512,   536,   536,  1251,   534,  1251,   536,   193,
     271,  1151,   271,  1151,  1151,  1251,   274,   536,  1247,   228,
     237,   246,   385,   509,   535,  1042,  1090,  1091,  1092,  1100,
    1106,  1116,  1123,  1156,  1158,  1159,  1238,  1261,   489,  1111,
    1257,   997,   995,   539,    39,   130,   473,   862,   384,   385,
     526,   527,  1070,  1072,  1155,   405,   240,   309,   539,     5,
    1071,  1251,  1071,   384,   385,  1072,  1243,   296,   409,  1021,
    1083,  1065,   473,  1016,   120,   322,   535,  1008,  1041,    38,
     473,  1261,   535,  1023,  1024,  1025,  1261,   536,  1255,  1246,
    1246,   317,    59,  1262,   536,   874,   876,   873,   876,  1262,
     314,   536,   539,   818,  1255,  1246,  1246,  1255,  1246,  1246,
    1255,   484,  1246,  1246,   120,   576,   701,   379,   472,   833,
     389,   183,   833,   535,  1246,   297,   195,  1246,   297,  1255,
    1246,  1246,  1153,   297,  1246,  1246,    32,   370,   448,   448,
    1246,   448,   718,   881,   535,  1129,   869,    74,   164,   905,
     869,   869,   171,  1129,   817,  1246,   189,   288,   324,   367,
     477,   721,   722,   723,  1100,   448,   922,   389,   297,   124,
     223,  1255,  1246,   308,  1246,   308,   536,   539,  1254,  1256,
    1246,   367,   592,   535,   195,   640,  1246,   473,   855,   240,
     292,   240,   473,   649,   682,  1129,  1246,  1251,  1261,  1244,
    1246,   251,  1246,    29,   472,  1246,   195,  1246,   195,  1261,
     386,   453,   386,   453,   251,  1246,    29,   472,  1246,   251,
     384,  1244,    25,   140,   402,   728,   729,   730,   731,  1264,
    1255,  1246,   120,   178,   293,   473,   601,   604,   605,  1264,
     270,  1246,    76,   305,  1246,   597,   308,   448,   438,  1244,
     448,   922,   389,   128,  1246,  1246,   539,   536,   539,  1255,
    1246,   928,   929,  1264,   308,   367,   448,   751,  1255,  1246,
    1246,   308,  1100,   201,   539,   660,   660,  1215,  1255,  1246,
    1246,  1254,     3,    91,   146,   208,   332,   464,   472,   475,
     555,  1255,  1246,  1246,   308,   367,  1255,  1246,   367,   402,
     592,   698,   701,   817,  1246,   701,   817,  1246,   701,  1255,
    1246,   402,  1255,  1246,  1246,   120,   608,  1253,  1245,  1245,
    1255,   893,  1246,  1245,  1246,   367,   402,   592,   595,  1244,
    1244,   535,  1246,  1246,  1246,  1246,  1244,  1255,  1246,    25,
      31,   140,   324,   367,   402,   324,   367,   402,   785,   367,
     402,   367,   402,   367,   925,  1115,  1261,   195,   795,  1261,
     195,  1261,  1252,  1255,  1246,  1246,  1252,  1246,   928,    25,
     140,   615,   399,  1254,   367,   402,   592,  1246,  1246,  1246,
     448,   448,    85,   463,   355,   539,  1060,  1060,  1060,  1153,
    1153,   481,  1194,   536,  1153,  1214,   982,   297,   823,  1252,
      38,   823,   138,   817,   823,   823,   224,   473,   473,   823,
     823,   823,   243,   823,   823,   823,   817,   350,   619,   619,
     206,   435,   756,  1153,  1129,   817,   536,   539,   525,   646,
    1264,  1246,    63,   177,   389,   484,   715,   722,   723,   157,
     302,   252,   634,   636,   638,   640,   652,   655,    26,   201,
     379,   432,   555,   556,   171,  1246,   485,  1244,    38,   752,
     436,   893,   546,  1261,   566,   633,   865,  1246,   173,   817,
     535,   684,   685,  1158,  1261,   351,  1252,   785,   785,   785,
     785,   535,   785,  1113,  1114,  1115,   399,   157,   535,   157,
     157,   156,  1041,   817,   302,   634,  1261,   473,   677,   492,
     603,   292,    38,   660,  1252,   292,   308,     3,   790,   791,
     785,    27,   536,   871,   872,   877,    38,   243,   376,   451,
     491,   883,   884,   885,   886,   883,   308,   243,   302,   125,
     216,   456,   471,   759,   760,  1246,   192,   192,   171,   549,
      38,   552,   172,   970,   971,   549,   549,   816,   817,  1246,
     817,  1246,   549,   549,   549,   549,   243,   549,   399,   171,
     549,   549,   308,   549,   292,   536,   662,   201,   201,   201,
     201,   201,   496,  1245,   701,   702,   539,   537,   186,   839,
     840,  1255,    59,   844,   845,  1264,   448,   535,   177,   155,
     405,   155,   405,   384,   471,   273,  1129,  1255,   492,   689,
     308,   839,   549,   177,   881,   817,  1129,   869,   301,   869,
     869,  1129,   817,  1246,   536,   534,   534,   539,  1153,   142,
    1209,  1210,    38,   536,  1153,   536,   536,   536,   177,   536,
     536,   513,  1227,  1228,   492,   494,  1232,  1129,  1228,   536,
      21,   297,   539,  1236,   314,  1239,   539,   540,   478,   536,
     536,    21,   297,   539,  1235,  1235,   539,   536,  1230,   539,
     536,   536,   536,   536,   539,   539,   536,   334,   536,   536,
     535,  1154,  1154,  1192,    13,    17,    18,    19,   201,   224,
     310,   523,   524,   525,   526,   527,   528,   529,   530,   531,
    1189,  1154,   536,   536,   171,   177,   407,   536,   536,    38,
    1205,  1192,  1205,  1205,   177,   536,   135,   536,  1264,   331,
    1168,    38,   536,   539,  1153,  1264,   539,  1153,  1216,  1153,
     536,   512,  1154,  1154,   150,  1192,   177,    37,   301,   388,
     478,   135,   137,   163,   291,   297,   455,   467,  1201,  1231,
     291,  1232,   150,   903,  1153,   431,  1217,  1153,  1206,  1153,
     448,   535,  1042,   535,  1175,   535,  1192,   489,   535,  1176,
    1261,   440,   442,   440,   442,  1244,  1055,  1055,  1055,  1111,
    1060,  1111,   955,  1251,  1150,   574,   997,   266,   535,   536,
    1251,  1149,  1149,   534,   534,   536,   535,  1042,  1106,  1116,
    1123,   177,   535,  1042,  1091,  1092,    38,  1093,  1094,  1261,
     539,   100,   178,   212,   227,   250,   279,   378,  1097,  1094,
      38,  1093,  1096,  1261,  1094,  1094,   516,  1110,  1215,  1153,
     186,  1074,  1063,   310,  1187,  1190,   515,   863,     5,  1251,
    1072,   309,   492,   471,  1069,   261,  1090,   489,  1112,   479,
     433,   472,  1009,  1010,  1011,  1261,   308,  1012,  1261,  1091,
    1025,  1026,   539,  1089,   525,  1216,   880,   818,   876,   876,
      59,   878,   530,  1256,  1256,   308,  1245,   311,   308,  1153,
     658,   775,   157,   549,   448,  1255,  1246,   579,  1129,   817,
     817,  1129,   705,  1246,   189,   477,   448,   448,   705,   721,
     727,   367,   402,   592,  1246,  1246,  1246,   214,   297,   160,
     872,   323,   402,   448,  1153,   292,   153,   656,  1246,   535,
     535,   157,   535,   682,   206,   535,   775,   423,   644,   645,
     775,   402,    25,   140,   371,   372,   402,   598,   606,   607,
     727,   923,   394,   157,   549,   157,   549,  1246,  1246,  1246,
    1246,   394,   394,   251,   730,   731,   730,   536,   539,   732,
    1252,   206,   536,   539,   525,   537,   120,   609,  1261,   160,
    1255,  1246,   367,   402,   592,  1246,  1246,  1246,   308,   324,
     367,   402,    25,   140,   324,   367,   402,  1129,   289,  1129,
     536,   539,   525,  1244,   448,  1256,   473,   748,   160,   660,
     389,   934,   489,   667,   667,   660,   253,   332,   297,  1252,
     332,  1256,   470,   160,   448,   448,   389,   420,   893,   893,
     893,   323,   402,    92,   448,   922,   389,   120,   171,   610,
     167,   548,  1243,   448,   448,   222,   263,   263,   263,   448,
     448,   389,   448,   448,   389,   448,   389,   448,   389,   448,
     128,   549,  1129,   292,  1252,   402,   923,   157,   549,   448,
     448,   536,  1246,   448,   922,   389,   448,  1255,  1246,   536,
     536,   536,  1194,   534,  1129,   817,   224,   823,  1246,  1246,
    1246,   224,   421,   422,   620,  1252,   620,   189,   536,   536,
     177,   785,   787,   289,   310,   526,   527,   701,   788,   876,
    1190,  1252,  1269,    72,    78,    92,   120,   122,   181,   210,
     292,   297,   344,   361,   466,   647,   648,   651,   156,   488,
     552,   579,  1246,   579,   312,   725,  1244,  1244,  1244,   536,
     539,  1256,   186,   379,  1256,  1251,   458,  1244,   660,     3,
     171,   753,   893,    48,   566,   435,   734,   113,   994,  1153,
     177,   539,  1245,   603,   792,   793,  1252,   536,   539,  1246,
     171,   661,  1244,   688,  1244,  1246,   689,   535,   635,  1244,
     536,  1246,   492,   494,   678,   602,    38,   157,  1041,   677,
     448,   157,  1100,   525,   536,   539,   759,   536,   539,   120,
     525,   887,  1252,   579,   435,   875,   876,   171,   892,    51,
     374,   888,   889,   886,   889,   125,   216,   395,   471,   945,
    1246,   302,   308,   313,   189,  1041,  1129,   535,   536,   539,
     549,   473,   549,   473,   549,  1246,  1246,   743,   817,   157,
     389,   389,   389,   389,   389,  1245,   539,   837,  1261,  1255,
     492,   539,   841,  1255,   539,   847,   163,   311,   455,   846,
    1102,   399,   155,   155,   113,   288,   838,   847,  1256,   224,
     224,   224,   224,   701,   224,   224,   224,   224,   224,  1197,
     444,  1153,   147,  1129,   536,  1153,   228,   466,   466,   536,
    1228,  1230,   308,   308,  1226,  1230,    59,  1236,  1153,  1226,
    1226,   308,   308,  1234,  1232,  1232,  1153,   536,  1153,  1201,
    1153,  1153,   536,  1192,   539,  1129,  1154,  1154,  1154,  1154,
     135,   137,   292,  1154,  1154,  1154,  1154,  1154,  1154,  1154,
    1154,  1154,  1154,  1153,  1153,  1153,  1129,   536,   536,   536,
    1192,   536,   539,    59,  1155,  1169,   536,  1264,  1164,   341,
     427,  1167,   536,   539,   484,  1160,    38,   536,  1252,  1153,
      35,    35,  1153,   536,  1153,   177,   291,  1232,  1153,   536,
     150,  1154,  1154,   150,   150,  1153,  1153,  1061,   536,  1192,
     539,  1153,  1177,  1261,  1055,  1055,  1055,  1055,  1244,  1244,
    1244,  1074,   536,  1074,   536,  1002,   534,  1226,  1094,  1096,
    1094,  1094,   535,   504,  1155,   536,  1261,   535,  1091,   227,
     318,  1098,  1091,  1098,   227,  1097,  1098,   227,   437,  1104,
     535,  1261,   535,   315,    59,   190,  1081,   535,   863,   168,
     245,   309,   492,   445,   103,  1153,   375,  1014,   478,   536,
     539,  1216,    90,  1014,   308,   536,   539,  1024,  1112,  1153,
     536,   530,   880,   458,   180,   383,   390,   397,   436,   459,
     852,   171,   852,   536,   122,   210,   288,   292,   776,  1246,
    1246,    38,   473,   473,   243,   818,  1255,  1246,   448,   922,
     389,   448,   214,  1246,    59,   438,  1246,   536,   157,   535,
     665,   666,   858,  1158,  1261,   661,   640,   661,   775,  1246,
     661,   120,  1261,    86,   642,   643,   420,   181,   159,   194,
     292,   602,   552,   113,   159,   181,   292,   420,   602,   642,
     644,   699,   402,   607,   458,  1246,  1261,   394,   729,  1246,
     605,   788,  1264,  1246,   323,   402,   448,   922,   389,   448,
     160,   448,   448,   389,   179,   310,   423,   797,   798,   179,
     310,   805,   806,   448,   448,   389,   536,   536,   536,   929,
     289,   701,   876,   930,  1190,  1252,  1269,   367,  1246,   535,
     492,   749,  1246,   667,   107,  1261,   535,   667,  1253,  1252,
    1252,  1252,  1246,  1246,  1246,  1246,   608,    59,   438,  1246,
    1246,  1246,  1246,   479,   536,  1246,  1246,   535,   171,   171,
     369,   171,   195,  1255,  1246,  1246,  1255,  1246,  1246,  1246,
    1246,  1246,  1246,  1246,   308,    78,   599,   157,    27,    50,
     458,  1261,  1246,  1252,   727,  1246,  1246,  1246,  1246,  1060,
     536,   224,   823,   224,   224,   224,   823,   552,   473,   625,
     626,   705,   775,   492,   494,   817,   535,   817,  1246,  1154,
      32,    59,   650,   123,   197,   122,   297,   240,  1244,   649,
     179,   348,   771,   778,   779,  1261,   714,   535,   329,   535,
     635,   653,   209,   672,   638,  1256,  1256,  1129,   535,   603,
      29,   125,   216,   395,   471,   754,   448,   750,  1255,   195,
    1244,   736,   496,   308,   536,  1090,   685,   893,   536,   539,
    1115,   725,   743,   536,   696,    38,   302,   329,   535,  1004,
     637,   639,   641,   655,  1261,   329,   673,   674,   635,   672,
     602,   305,   308,   679,  1041,   691,   689,   603,  1252,  1246,
     855,   788,     3,   791,   308,   877,  1153,  1153,   539,   535,
     883,   458,   539,    44,  1153,   448,   535,   661,  1244,   760,
     705,   536,   970,   971,  1246,  1246,   549,   399,   549,  1245,
    1245,  1245,  1245,  1245,   701,   183,   840,   847,   845,   536,
    1246,   113,   177,   549,   847,   297,   826,  1252,   826,   826,
     826,   224,   826,   826,   826,   826,   826,  1153,   536,   145,
     241,   241,   536,   297,   297,   536,  1062,  1230,   331,  1218,
     297,   297,  1230,  1230,  1218,  1218,   536,   536,   177,   536,
    1153,   177,   135,   137,   177,   171,   150,   536,   499,  1162,
    1192,   360,   478,    59,  1169,  1155,   490,   490,   536,  1153,
     288,  1153,   539,  1161,  1131,  1153,  1153,  1153,  1153,    35,
      35,  1153,  1153,   150,   536,   536,   536,  1153,   536,   329,
    1178,  1244,  1244,  1244,  1244,  1081,  1252,  1081,  1252,   536,
     539,  1107,  1108,  1158,   535,  1168,  1093,   535,  1245,  1091,
     308,   473,  1099,  1091,   227,  1091,  1249,  1114,   535,  1114,
    1261,  1056,  1153,   491,  1172,   903,   445,   302,  1241,  1041,
     322,  1041,  1011,   308,   535,  1013,  1153,   525,  1025,  1014,
     458,   536,   448,   833,   177,   775,   123,   197,   208,   122,
     475,   549,  1129,  1246,  1246,  1246,  1246,  1246,  1246,  1246,
    1256,  1246,   775,   640,  1153,   536,   539,   492,    78,   857,
     861,   857,   536,   536,   536,   120,  1261,   725,   608,   650,
     195,   195,   297,   701,    38,   650,   297,   608,  1129,   549,
     549,   525,    59,   438,  1246,  1246,  1246,  1246,  1246,  1255,
    1246,  1246,  1251,  1251,  1129,   539,  1251,  1251,   539,  1255,
    1246,  1246,   448,  1153,    72,  1153,  1256,  1246,   448,   448,
     177,   201,   492,   222,   329,   593,   594,  1245,  1245,   817,
    1245,   157,   160,   817,  1252,  1252,  1129,   549,   549,   448,
     536,   224,   823,   823,   823,   823,   535,   621,   622,   552,
     127,   179,   213,   179,  1153,   292,   648,   120,    38,   893,
     660,   893,  1249,    35,   156,   201,   726,   730,   302,   634,
     610,   154,   203,   535,   399,   473,   661,    38,  1256,   748,
     566,   292,   535,   173,  1246,   684,  1252,   399,   603,   156,
    1041,   817,   302,   634,   689,   536,   539,   492,   646,    59,
     677,   610,   673,    84,   438,   680,   492,   959,    38,   680,
     177,   308,   535,  1244,  1252,   874,   894,   895,  1262,   889,
    1129,   171,   890,  1244,   177,   448,   914,   362,   761,   211,
     706,   549,   536,   549,   549,  1246,   311,   222,   839,   549,
     826,  1246,   536,  1219,  1220,  1226,   120,   143,   149,   163,
     297,   455,   467,  1222,  1223,  1225,   536,   536,  1230,  1230,
    1153,   536,  1154,   177,  1153,  1153,  1153,   535,   536,   539,
     536,  1169,   536,   478,   417,   536,   205,   288,  1166,  1153,
    1153,  1153,   536,    59,  1060,  1172,  1172,   392,  1050,  1153,
     536,   539,    38,  1109,   120,  1121,  1122,  1154,    81,  1245,
     536,  1153,   535,  1091,  1099,   535,   536,  1114,   536,   102,
     187,   381,   535,  1075,  1076,  1077,  1078,  1079,  1080,  1153,
    1173,  1174,  1261,  1060,   536,  1038,  1009,    92,   856,   858,
     136,   488,  1028,  1029,  1030,  1031,  1153,   839,   308,   839,
     536,   448,   402,  1020,   536,   202,   663,   666,   310,   903,
     817,   547,   817,   361,   663,   663,   646,    38,   157,   157,
     535,   599,   788,  1256,  1246,   448,   535,   869,   903,   905,
     798,   535,   535,   806,  1246,   536,   535,   536,   402,  1020,
    1246,  1246,   535,   535,   535,  1244,  1244,   536,   539,   492,
     516,   979,   369,   979,   979,   171,  1246,   599,  1246,   823,
     627,   628,  1264,    54,   101,   126,   145,   150,   172,   176,
     191,   297,   352,   623,   621,  1252,   869,    38,   910,   910,
     536,   194,   535,   473,   681,   264,   664,   681,   535,   779,
     771,   535,   536,   539,  1244,   536,   399,    29,    83,    86,
      93,   121,   181,   194,   207,   420,   423,   654,   654,  1243,
    1246,  1246,   536,  1041,   749,   157,   113,   725,   177,  1246,
      38,  1246,   689,   635,  1244,   536,   639,   312,  1261,   678,
     673,   677,   125,   140,   341,  1246,    64,    72,   256,  1041,
     817,  1100,   856,   177,   774,   876,   536,   539,   458,   147,
     545,   888,   891,  1111,   415,   415,   536,   282,   306,   762,
     763,   764,   171,   767,   705,   288,   477,   707,   708,  1246,
     847,   539,    38,  1153,    37,   301,   308,   536,   492,   494,
    1221,  1222,  1224,   171,  1154,  1163,  1192,   288,   511,   205,
     536,  1192,   188,   354,   385,  1179,    58,   129,   112,  1051,
      38,  1124,  1110,  1107,   535,  1154,   536,   539,    38,  1117,
    1118,  1261,   536,  1245,  1192,   536,   535,   403,   535,   536,
     539,   539,    38,  1065,   478,  1246,   536,   539,   293,   471,
     265,   292,  1014,  1029,    35,  1032,  1032,   841,   852,   549,
    1246,   438,   857,   535,   893,   535,   862,   602,  1244,   893,
     893,   194,  1153,   473,   600,   402,  1020,  1246,  1196,   171,
     801,   801,  1196,  1196,  1153,   438,  1192,  1192,   611,   612,
    1263,   610,   594,   816,   817,   816,   817,  1245,   549,   536,
     539,   120,   528,   535,   576,   629,   701,   976,  1252,   976,
     292,   297,   352,   976,   976,  1111,   910,    42,   199,   288,
     659,   535,   697,  1153,   206,   178,   328,   408,   308,   668,
     669,   670,   536,  1249,     6,   780,   730,   635,   672,  1246,
     536,   725,   164,   800,   603,   959,  1244,   496,  1090,   725,
    1041,  1004,   673,   635,   672,   646,   535,   679,   677,   678,
     385,   385,    72,   311,    72,   689,   855,   536,  1244,   775,
     883,   894,  1129,   538,   136,   492,   492,   763,   384,   435,
     765,   141,   768,   488,   770,   477,   705,   725,   549,  1220,
    1264,   149,    37,    88,   462,   496,    37,   496,   239,   307,
    1229,   308,   536,  1153,   536,   536,   478,    52,   103,   461,
    1153,  1180,  1181,  1180,  1180,   536,   168,   168,   661,  1246,
    1218,  1114,   539,  1122,  1264,   536,   539,   171,  1129,   536,
     536,  1192,   535,  1192,  1076,  1174,  1176,  1083,  1041,  1111,
     858,   402,   265,  1153,   444,   444,   177,  1246,   661,   681,
     903,   863,   862,   660,   681,   681,   697,   536,  1153,   438,
     536,   314,   392,   358,   802,   802,   536,   536,   536,  1246,
     536,   536,   536,   539,  1251,   979,   628,   576,   630,   631,
    1252,  1252,   297,   528,   661,   528,   661,  1252,  1252,   208,
     698,   536,   438,   125,   471,   308,   670,   308,   669,   535,
     536,   539,   610,   399,   725,   817,    38,    38,   535,  1246,
     959,   689,   677,   610,   673,   535,   675,   676,  1158,  1261,
     680,   678,   679,   311,   311,   535,   202,   859,   171,   889,
      30,   217,   946,   179,   179,   976,   384,   419,   769,   535,
     156,   496,    37,   496,    37,   496,   496,   353,   353,  1224,
     143,   149,  1181,   384,   170,   339,   170,   339,   153,  1182,
    1182,  1182,    59,    59,   402,    81,   536,  1155,  1118,   315,
       3,   120,   292,   297,   333,  1119,  1120,    38,  1095,   368,
    1105,   536,  1075,   536,  1023,    59,   125,   136,   471,  1033,
    1034,   136,   216,  1035,   839,  1020,   536,   667,   536,   863,
     664,   775,   775,  1246,   869,    59,  1020,   448,   611,   817,
     536,   539,   528,   661,   536,   424,  1246,    63,   288,   373,
     402,   671,   671,   536,     6,   399,  1246,   797,  1041,   725,
     678,   673,   677,  1153,   536,   539,   861,   861,   679,   680,
     856,   535,   649,   141,   293,   535,   941,   943,   947,  1006,
    1015,  1022,  1041,  1052,   869,   869,   766,  1261,  1153,   771,
     496,   496,   308,   308,   536,  1222,    35,   103,   186,   288,
     445,   661,   661,  1261,   535,  1168,  1154,  1154,   297,  1154,
    1120,  1261,   535,   536,  1111,   414,   439,   293,   402,   293,
     120,   322,   479,   535,  1036,   549,   775,   668,  1020,   817,
     535,   631,    24,   120,   297,  1246,   725,   959,   679,   677,
     678,   536,   676,   547,   547,   680,   536,   858,   860,   603,
     384,   942,   943,   944,  1042,  1043,   539,   539,   536,  1249,
     388,   388,   308,  1181,   384,   316,   402,   402,   448,   473,
     281,  1125,  1126,  1261,    81,  1153,  1023,   479,  1009,   535,
    1010,   775,  1192,   660,   660,   725,   680,   678,   679,   861,
     859,   536,   539,   680,   770,   536,   538,   448,   177,   535,
     426,   426,   149,  1261,  1261,   228,  1249,  1250,  1261,   333,
    1127,   536,   539,   171,  1129,  1117,   536,   478,  1192,   536,
     536,   679,   680,   547,   649,   858,  1111,   156,   944,   415,
     415,     5,   772,   773,  1251,  1252,  1264,   535,   120,  1252,
    1225,  1126,   315,   157,   333,  1128,  1227,   536,  1036,   536,
     322,  1036,   680,   603,   771,   492,   492,   536,   539,  1193,
    1250,    38,    81,   536,  1128,  1252,  1221,  1128,  1009,   680,
    1249,   179,   179,   773,  1060,   473,  1246,   535,  1225,  1229,
    1221,   478,  1111,   535,   869,   869,   536,  1261,    81,  1125,
    1224,  1229,  1036,   772,   535,   536,  1224,   536,  1125,   536
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   541,   542,   542,   542,   542,   542,   542,   543,   543,
     544,   544,   545,   545,   545,   545,   545,   545,   545,   545,
     545,   545,   545,   545,   545,   545,   545,   545,   545,   545,
     545,   545,   545,   545,   545,   545,   545,   545,   545,   545,
     545,   545,   545,   545,   545,   545,   545,   545,   545,   545,
     545,   545,   545,   545,   545,   545,   545,   545,   545,   545,
     545,   545,   545,   545,   545,   545,   545,   545,   545,   545,
     545,   545,   545,   545,   545,   545,   545,   545,   545,   545,
     545,   545,   545,   545,   545,   545,   545,   545,   545,   545,
     545,   545,   545,   545,   545,   545,   545,   545,   545,   545,
     545,   545,   545,   545,   545,   545,   545,   545,   545,   545,
     545,   545,   545,   545,   545,   545,   545,   545,   545,   545,
     545,   545,   545,   545,   545,   545,   545,   545,   545,   545,
     545,   545,   545,   545,   545,   545,   545,   546,   546,   547,
     547,   548,   548,   549,   549,   549,   550,   551,   552,   552,
     552,   553,   553,   554,   554,   555,   555,   555,   555,   555,
     555,   555,   555,   555,   556,   556,   556,   556,   556,   556,
     557,   558,   558,   559,   559,   560,   560,   560,   560,   561,
     561,   561,   561,   561,   561,   562,   563,   564,   564,   565,
     565,   565,   565,   566,   566,   567,   567,   567,   567,   567,
     567,   568,   568,   568,   569,   569,   569,   570,   570,   570,
     570,   571,   571,   571,   571,   571,   571,   571,   571,   571,
     571,   571,   572,   572,   573,   573,   574,   574,   575,   575,
     575,   575,   576,   576,   576,   576,   577,   577,   577,   577,
     577,   577,   577,   578,   578,   578,   579,   579,   580,   581,
     581,   581,   581,   582,   582,   583,   583,   584,   584,   585,
     585,   585,   585,   585,   586,   587,   587,   588,   588,   589,
     590,   590,   590,   590,   590,   591,   591,   591,   591,   591,
     591,   591,   591,   591,   591,   591,   591,   591,   591,   591,
     591,   591,   591,   591,   591,   591,   592,   592,   593,   593,
     594,   595,   595,   595,   595,   595,   596,   597,   597,   597,
     597,   597,   597,   597,   597,   597,   597,   597,   597,   597,
     597,   597,   597,   597,   597,   597,   597,   597,   597,   597,
     597,   597,   597,   597,   597,   597,   597,   597,   597,   597,
     597,   597,   597,   597,   597,   597,   597,   597,   597,   597,
     597,   597,   597,   597,   597,   597,   597,   597,   597,   597,
     597,   597,   597,   597,   597,   597,   597,   597,   598,   598,
     599,   599,   600,   600,   601,   601,   601,   601,   602,   603,
     603,   604,   604,   605,   605,   605,   605,   606,   606,   607,
     607,   607,   607,   608,   608,   609,   609,   610,   610,   610,
     610,   611,   612,   612,   613,   614,   614,   615,   615,   615,
     615,   616,   616,   617,   617,   618,   618,   619,   619,   620,
     620,   620,   621,   621,   622,   622,   623,   623,   623,   623,
     623,   623,   623,   623,   623,   623,   623,   623,   623,   623,
     623,   624,   624,   625,   625,   626,   626,   627,   627,   628,
     629,   629,   629,   629,   629,   629,   630,   630,   631,   632,
     632,   632,   632,   632,   632,   633,   633,   633,   633,   633,
     633,   633,   633,   634,   634,   635,   635,   636,   636,   637,
     637,   638,   638,   638,   639,   639,   640,   641,   641,   642,
     642,   643,   643,   644,   644,   645,   645,   646,   646,   647,
     647,   647,   647,   648,   648,   648,   648,   648,   648,   648,
     648,   648,   649,   649,   649,   650,   650,   651,   651,   651,
     651,   652,   653,   653,   653,   654,   654,   654,   654,   654,
     654,   654,   654,   654,   654,   655,   655,   656,   656,   656,
     656,   656,   656,   656,   657,   657,   658,   658,   659,   659,
     660,   660,   661,   661,   662,   663,   663,   664,   664,   664,
     664,   665,   665,   666,   666,   667,   667,   668,   668,   668,
     668,   668,   669,   670,   671,   671,   671,   671,   671,   672,
     672,   673,   673,   674,   675,   675,   676,   676,   676,   677,
     677,   678,   678,   678,   679,   679,   679,   679,   680,   680,
     681,   681,   682,   683,   683,   684,   684,   685,   685,   685,
     686,   686,   687,   687,   688,   689,   689,   689,   690,   690,
     691,   692,   692,   693,   694,   694,   695,   695,   696,   696,
     697,   697,   698,   698,   699,   699,   699,   699,   699,   699,
     699,   699,   699,   699,   699,   699,   699,   699,   700,   700,
     701,   701,   701,   701,   702,   702,   703,   703,   704,   704,
     705,   705,   706,   706,   707,   707,   708,   708,   709,   709,
     710,   711,   711,   712,   712,   713,   713,   714,   714,   715,
     715,   715,   715,   716,   717,   717,   718,   719,   719,   719,
     719,   719,   719,   719,   719,   719,   719,   719,   719,   719,
     720,   721,   721,   721,   721,   722,   722,   723,   723,   724,
     724,   725,   725,   726,   726,   727,   728,   728,   729,   729,
     729,   729,   730,   731,   732,   733,   733,   734,   734,   735,
     735,   736,   736,   737,   737,   737,   738,   738,   738,   738,
     739,   740,   740,   741,   741,   742,   742,   743,   743,   744,
     744,   745,   746,   747,   748,   748,   749,   749,   750,   750,
     751,   751,   752,   752,   753,   753,   754,   754,   754,   754,
     754,   755,   756,   756,   757,   757,   758,   758,   758,   759,
     759,   760,   760,   760,   760,   760,   761,   761,   762,   762,
     763,   764,   764,   765,   765,   766,   767,   767,   768,   768,
     769,   769,   770,   770,   771,   771,   772,   772,   772,   773,
     773,   773,   773,   774,   774,   775,   775,   776,   776,   776,
     776,   776,   776,   777,   777,   778,   778,   779,   780,   780,
     781,   782,   782,   782,   782,   783,   784,   784,   784,   784,
     784,   784,   784,   784,   784,   784,   784,   784,   784,   784,
     784,   784,   785,   786,   786,   787,   787,   788,   788,   788,
     788,   788,   788,   789,   790,   790,   791,   792,   792,   793,
     793,   794,   794,   794,   794,   794,   795,   795,   796,   797,
     797,   798,   798,   798,   798,   798,   799,   799,   800,   800,
     801,   801,   801,   802,   802,   803,   804,   804,   805,   805,
     806,   806,   807,   807,   808,   808,   809,   810,   811,   811,
     811,   811,   811,   811,   811,   811,   811,   811,   811,   811,
     812,   812,   812,   812,   812,   812,   812,   812,   812,   812,
     812,   812,   812,   813,   813,   813,   813,   813,   814,   814,
     814,   814,   814,   814,   814,   814,   815,   815,   815,   816,
     816,   817,   817,   818,   818,   819,   819,   820,   821,   821,
     821,   822,   822,   822,   822,   822,   822,   822,   822,   822,
     822,   822,   822,   822,   822,   822,   822,   822,   822,   823,
     823,   824,   824,   824,   824,   824,   824,   824,   824,   824,
     824,   825,   825,   826,   826,   827,   827,   828,   828,   828,
     828,   828,   828,   828,   828,   828,   828,   828,   828,   828,
     828,   828,   828,   829,   829,   830,   830,   831,   832,   832,
     833,   833,   833,   833,   833,   834,   834,   835,   835,   835,
     835,   835,   836,   836,   837,   837,   838,   838,   838,   838,
     838,   838,   838,   838,   838,   838,   838,   838,   838,   838,
     838,   838,   838,   838,   838,   838,   838,   839,   839,   840,
     840,   841,   841,   842,   842,   843,   843,   844,   844,   845,
     846,   846,   846,   847,   847,   848,   849,   849,   850,   850,
     850,   851,   851,   851,   852,   852,   852,   852,   852,   852,
     853,   853,   854,   854,   855,   855,   856,   856,   857,   857,
     858,   858,   858,   859,   859,   860,   860,   861,   861,   862,
     862,   862,   863,   863,   863,   864,   864,   864,   864,   865,
     865,   866,   866,   867,   867,   868,   868,   869,   869,   869,
     869,   870,   870,   871,   871,   872,   872,   872,   872,   872,
     873,   873,   873,   873,   873,   874,   875,   876,   876,   876,
     877,   877,   877,   878,   879,   879,   879,   879,   880,   880,
     881,   882,   882,   883,   883,   884,   884,   885,   885,   885,
     885,   885,   885,   885,   885,   885,   885,   885,   885,   885,
     885,   885,   885,   885,   886,   886,   886,   886,   886,   887,
     887,   888,   889,   889,   889,   890,   890,   891,   891,   892,
     892,   893,   893,   894,   895,   895,   896,   896,   896,   897,
     897,   898,   898,   899,   899,   899,   899,   899,   899,   900,
     900,   901,   901,   902,   902,   902,   902,   903,   903,   904,
     904,   905,   906,   907,   907,   908,   908,   909,   909,   909,
     910,   910,   910,   911,   912,   912,   913,   914,   914,   914,
     914,   915,   916,   916,   916,   917,   917,   918,   918,   919,
     919,   920,   920,   921,   921,   921,   921,   921,   921,   921,
     921,   921,   921,   921,   921,   921,   921,   921,   921,   921,
     921,   921,   921,   921,   921,   921,   921,   921,   921,   921,
     921,   921,   921,   921,   921,   921,   921,   921,   921,   921,
     921,   921,   921,   921,   921,   921,   921,   921,   921,   921,
     921,   921,   921,   921,   921,   921,   921,   921,   922,   922,
     923,   923,   924,   924,   924,   924,   924,   924,   925,   925,
     926,   926,   926,   926,   926,   926,   926,   926,   926,   926,
     926,   926,   926,   926,   926,   926,   926,   926,   926,   926,
     926,   926,   926,   926,   926,   926,   926,   927,   928,   928,
     929,   929,   929,   930,   930,   930,   930,   930,   931,   932,
     932,   932,   932,   932,   932,   932,   932,   932,   932,   932,
     932,   932,   932,   932,   932,   932,   932,   932,   932,   932,
     932,   932,   932,   933,   933,   933,   934,   934,   934,   934,
     934,   934,   934,   935,   935,   936,   936,   936,   936,   937,
     938,   938,   938,   938,   938,   938,   938,   938,   938,   939,
     939,   940,   941,   941,   941,   942,   942,   943,   943,   943,
     943,   943,   944,   944,   945,   945,   945,   945,   946,   946,
     946,   947,   948,   948,   949,   950,   950,   951,   951,   951,
     951,   951,   951,   951,   951,   951,   951,   951,   951,   952,
     952,   953,   953,   953,   954,   954,   954,   954,   954,   955,
     955,   955,   956,   956,   957,   957,   957,   958,   958,   958,
     958,   959,   959,   959,   959,   960,   961,   962,   962,   963,
     963,   964,   964,   964,   965,   965,   965,   965,   965,   965,
     965,   966,   966,   967,   967,   967,   967,   968,   969,   969,
     969,   969,   970,   970,   971,   972,   973,   973,   974,   975,
     975,   975,   975,   975,   975,   975,   976,   976,   977,   978,
     978,   978,   978,   978,   978,   979,   979,   980,   981,   981,
     981,   981,   981,   982,   982,   983,   983,   984,   984,   985,
     985,   986,   986,   987,   988,   988,   988,   989,   989,   989,
     990,   990,   991,   991,   992,   992,   993,   993,   994,   994,
     995,   996,   996,   997,   997,   998,   998,   998,   998,   999,
     999,   999,   999,   999,   999,   999,   999,   999,   999,  1000,
    1001,  1001,  1002,  1002,  1002,  1002,  1002,  1003,  1003,  1003,
    1004,  1004,  1005,  1005,  1005,  1005,  1006,  1007,  1007,  1008,
    1008,  1008,  1008,  1008,  1009,  1009,  1010,  1010,  1011,  1012,
    1012,  1012,  1013,  1013,  1013,  1014,  1014,  1015,  1016,  1016,
    1017,  1018,  1018,  1019,  1019,  1019,  1019,  1019,  1019,  1019,
    1019,  1020,  1020,  1021,  1021,  1021,  1022,  1023,  1023,  1024,
    1024,  1025,  1026,  1026,  1027,  1028,  1028,  1029,  1029,  1029,
    1029,  1029,  1030,  1030,  1031,  1031,  1032,  1032,  1033,  1034,
    1035,  1035,  1035,  1035,  1035,  1036,  1037,  1038,  1039,  1039,
    1039,  1039,  1039,  1039,  1040,  1040,  1040,  1041,  1041,  1042,
    1042,  1043,  1043,  1043,  1043,  1043,  1043,  1043,  1043,  1044,
    1044,  1045,  1045,  1045,  1045,  1045,  1045,  1045,  1046,  1046,
    1046,  1047,  1047,  1048,  1049,  1049,  1049,  1050,  1050,  1050,
    1051,  1051,  1051,  1052,  1052,  1053,  1053,  1054,  1054,  1054,
    1054,  1054,  1054,  1054,  1054,  1054,  1055,  1055,  1056,  1056,
    1056,  1057,  1057,  1058,  1058,  1059,  1059,  1060,  1060,  1061,
    1062,  1062,  1063,  1063,  1064,  1064,  1064,  1064,  1065,  1065,
    1066,  1066,  1066,  1066,  1066,  1066,  1067,  1067,  1068,  1068,
    1069,  1070,  1070,  1070,  1071,  1071,  1072,  1072,  1073,  1073,
    1074,  1074,  1075,  1075,  1076,  1076,  1076,  1076,  1076,  1077,
    1078,  1079,  1080,  1081,  1081,  1082,  1082,  1083,  1083,  1084,
    1084,  1085,  1086,  1086,  1086,  1086,  1087,  1087,  1088,  1088,
    1089,  1089,  1090,  1090,  1091,  1091,  1091,  1091,  1091,  1091,
    1091,  1091,  1091,  1091,  1091,  1091,  1092,  1092,  1092,  1092,
    1092,  1092,  1093,  1093,  1093,  1093,  1094,  1094,  1095,  1095,
    1096,  1096,  1096,  1096,  1096,  1097,  1097,  1097,  1097,  1098,
    1098,  1099,  1099,  1100,  1100,  1101,  1101,  1101,  1102,  1102,
    1103,  1103,  1103,  1104,  1105,  1105,  1106,  1106,  1107,  1108,
    1108,  1109,  1109,  1110,  1110,  1111,  1111,  1112,  1112,  1112,
    1113,  1113,  1114,  1114,  1115,  1116,  1116,  1117,  1117,  1118,
    1118,  1118,  1119,  1119,  1120,  1120,  1120,  1120,  1120,  1121,
    1121,  1122,  1122,  1123,  1124,  1124,  1125,  1125,  1126,  1126,
    1126,  1126,  1126,  1126,  1127,  1127,  1128,  1128,  1129,  1129,
    1129,  1129,  1129,  1129,  1130,  1130,  1130,  1131,  1131,  1131,
    1131,  1131,  1131,  1131,  1131,  1132,  1132,  1132,  1132,  1132,
    1133,  1133,  1134,  1134,  1135,  1135,  1135,  1135,  1135,  1135,
    1135,  1135,  1135,  1135,  1135,  1136,  1136,  1137,  1137,  1138,
    1138,  1139,  1140,  1141,  1141,  1142,  1142,  1143,  1144,  1145,
    1145,  1145,  1145,  1145,  1145,  1146,  1146,  1147,  1147,  1147,
    1147,  1148,  1149,  1149,  1149,  1150,  1150,  1150,  1150,  1150,
    1150,  1150,  1150,  1150,  1150,  1150,  1150,  1150,  1150,  1151,
    1151,  1152,  1153,  1153,  1153,  1153,  1153,  1153,  1153,  1153,
    1153,  1153,  1153,  1153,  1153,  1153,  1153,  1153,  1153,  1153,
    1153,  1153,  1153,  1153,  1153,  1153,  1153,  1153,  1153,  1153,
    1153,  1153,  1153,  1153,  1153,  1153,  1153,  1153,  1153,  1153,
    1153,  1153,  1153,  1153,  1153,  1153,  1153,  1153,  1153,  1153,
    1153,  1153,  1153,  1153,  1153,  1153,  1153,  1153,  1153,  1153,
    1153,  1153,  1153,  1153,  1153,  1153,  1153,  1153,  1153,  1153,
    1154,  1154,  1154,  1154,  1154,  1154,  1154,  1154,  1154,  1154,
    1154,  1154,  1154,  1154,  1154,  1154,  1154,  1154,  1154,  1154,
    1154,  1154,  1155,  1155,  1155,  1155,  1155,  1155,  1155,  1155,
    1155,  1155,  1155,  1155,  1155,  1155,  1156,  1156,  1156,  1156,
    1156,  1156,  1156,  1157,  1157,  1157,  1158,  1158,  1158,  1159,
    1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,
    1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,
    1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,
    1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,
    1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,
    1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,  1160,
    1160,  1161,  1161,  1161,  1161,  1162,  1163,  1163,  1164,  1164,
    1165,  1165,  1166,  1166,  1166,  1167,  1167,  1167,  1168,  1168,
    1168,  1168,  1169,  1169,  1170,  1170,  1171,  1171,  1172,  1172,
    1173,  1173,  1174,  1175,  1175,  1175,  1176,  1177,  1177,  1178,
    1178,  1179,  1179,  1179,  1179,  1180,  1180,  1181,  1181,  1181,
    1181,  1181,  1182,  1182,  1182,  1182,  1182,  1183,  1183,  1183,
    1184,  1184,  1185,  1186,  1186,  1186,  1187,  1187,  1188,  1188,
    1188,  1188,  1188,  1188,  1188,  1188,  1188,  1188,  1188,  1188,
    1189,  1189,  1190,  1190,  1191,  1191,  1191,  1191,  1191,  1191,
    1192,  1192,  1193,  1193,  1194,  1194,  1194,  1195,  1195,  1196,
    1196,  1197,  1197,  1197,  1198,  1198,  1199,  1200,  1200,  1200,
    1200,  1200,  1200,  1200,  1200,  1201,  1201,  1201,  1201,  1202,
    1202,  1203,  1204,  1204,  1204,  1204,  1204,  1205,  1205,  1205,
    1206,  1206,  1207,  1208,  1208,  1209,  1210,  1210,  1211,  1211,
    1212,  1212,  1213,  1213,  1213,  1213,  1214,  1214,  1215,  1215,
    1216,  1216,  1217,  1217,  1218,  1218,  1219,  1219,  1220,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1222,  1222,
    1223,  1223,  1223,  1223,  1223,  1223,  1223,  1223,  1224,  1224,
    1224,  1224,  1225,  1225,  1226,  1227,  1227,  1228,  1228,  1229,
    1229,  1229,  1229,  1229,  1230,  1230,  1231,  1231,  1231,  1231,
    1231,  1232,  1232,  1232,  1232,  1232,  1233,  1233,  1234,  1234,
    1235,  1235,  1235,  1236,  1236,  1236,  1237,  1237,  1238,  1238,
    1239,  1239,  1240,  1240,  1241,  1241,  1242,  1242,  1242,  1242,
    1243,  1243,  1244,  1244,  1245,  1245,  1246,  1247,  1248,  1249,
    1249,  1250,  1250,  1250,  1250,  1250,  1250,  1250,  1250,  1250,
    1250,  1250,  1250,  1250,  1251,  1252,  1253,  1253,  1253,  1254,
    1255,  1255,  1255,  1255,  1256,  1256,  1257,  1258,  1259,  1259,
    1260,  1260,  1261,  1261,  1261,  1262,  1262,  1262,  1263,  1263,
    1263,  1263,  1264,  1264,  1264,  1264,  1264,  1265,  1265,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1268,  1268,  1268,  1268,  1268,  1268,  1268,  1268,  1268,
    1268,  1268,  1268,  1268,  1268,  1268,  1268,  1268,  1268,  1268,
    1268,  1268,  1268,  1268,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,  1270,
    1270,  1270,  1270,  1270,  1270,  1270
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     2,     2,     2,     2,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     1,     0,     1,
       0,     1,     0,     1,     1,     0,     2,     5,     1,     1,
       0,     2,     0,     2,     0,     2,     2,     3,     3,     1,
       3,     3,     2,     1,     1,     2,     2,     2,     3,     3,
       5,     5,     5,     0,     3,     5,     5,     5,     5,     3,
       5,     3,     5,     3,     5,     5,     6,     1,     1,     6,
       4,     9,     7,     2,     0,     1,     1,     1,     1,     1,
       1,     2,     3,     3,     2,     5,     1,     3,     3,     3,
       3,     1,     3,     3,     2,     2,     2,     2,     3,     3,
       3,     3,     1,     3,     1,     3,     1,     1,     2,     2,
       2,     1,     1,     1,     1,     1,     1,     1,     3,     5,
       1,     1,     1,     1,     1,     0,     1,     1,     2,     1,
       2,     3,     2,     1,     1,     2,     1,     2,     1,     2,
       3,     4,     3,     2,     4,     1,     1,     1,     1,     1,
       2,     2,     2,     2,     2,     4,     6,     4,     6,    10,
      13,     4,     6,     4,    10,    13,     4,     6,     4,     6,
       5,     7,    11,    14,     5,     7,     1,     3,     1,     3,
       3,     4,     4,     4,     7,     7,     3,     2,     5,     3,
       6,     4,     6,     6,     9,     5,     7,     6,     6,     5,
       5,     5,     5,     9,     4,     5,     7,     6,     4,     8,
       4,     2,     4,     3,     6,     4,     3,     3,     3,     2,
       2,     3,     4,     4,     3,     3,     3,     3,     3,     3,
       4,     4,     3,     2,     3,     2,     2,     3,     4,     3,
       2,     2,     3,     4,     4,     4,     5,     1,     3,     2,
       2,     0,     2,     0,     1,     1,     1,     3,     3,     2,
       0,     1,     3,     3,     1,     5,     3,     1,     2,     1,
       3,     2,     3,     1,     1,     1,     1,     6,     6,    10,
       1,     2,     1,     3,     4,     1,     3,     4,     6,     4,
       8,     2,     2,    11,     9,     1,     1,     1,     0,     1,
       1,     1,     1,     3,     2,     0,     1,     1,     3,     3,
       1,     1,     3,     3,     3,     3,     4,     4,     3,     3,
       2,     1,     0,     3,     0,     1,     0,     1,     3,     2,
       1,     1,     1,     1,     3,     0,     1,     3,     1,    13,
      16,    12,    15,    14,    17,     1,     1,     2,     2,     2,
       2,     1,     0,     1,     0,     3,     0,     1,     3,     1,
       3,     1,     1,     1,     1,     1,     6,     2,     4,     2,
       2,     1,     0,     2,     2,     1,     0,     2,     0,     3,
       1,     1,     2,     2,     1,     4,     4,     5,     2,     5,
       7,     5,     2,     3,     0,     1,     2,     1,     2,     2,
       2,     3,     3,     3,     0,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     5,     9,     3,
       9,     4,    10,    11,     3,     1,     5,     3,     2,     0,
       3,     0,     1,     3,     1,     4,     0,     2,     2,     2,
       0,     1,     3,     3,     6,     4,     0,     1,     1,     2,
       2,     0,     3,     3,     2,     1,     1,     3,     3,     4,
       0,     1,     0,     6,     1,     3,     3,     3,     5,     2,
       0,     2,     2,     0,     3,     4,     4,     0,     2,     0,
       4,     0,     3,     8,    11,     1,     3,     1,     1,     3,
       6,     8,     7,    10,     6,     2,     3,     0,     8,    11,
       5,     1,     0,     6,     5,     8,     4,     6,     1,     0,
       3,     0,     1,     2,     2,     2,     1,     2,     3,     2,
       2,     2,     2,     3,     3,     3,     1,     3,     1,     0,
       1,     2,     2,     1,     1,     3,     6,    10,     1,     0,
       1,     2,     2,     0,     2,     2,     1,     0,     1,     0,
       7,     2,     0,     3,     5,     5,     8,     2,     0,     2,
       2,     2,     1,     5,     2,     0,     2,     6,     6,     6,
      10,     6,     6,     6,     9,     9,     6,     6,     9,     6,
       7,     2,     2,     2,     2,     1,     2,     1,     0,     7,
       6,     4,     0,     1,     3,     4,     1,     3,     1,     2,
       2,     2,     2,     1,     1,    10,    13,     2,     0,     2,
       2,     1,     0,     5,     4,     4,    11,    14,    12,    15,
      11,     2,     1,     4,     0,     8,    11,     1,     1,     7,
       9,     8,    10,     8,     4,     0,     5,     0,     2,     0,
       2,     0,     2,     0,     2,     0,     1,     1,     1,     1,
       1,     8,     1,     1,    17,    21,     1,     1,     2,     1,
       3,     1,     1,     1,     3,     1,     2,     0,     1,     2,
       4,     1,     1,     1,     1,     1,     3,     0,     1,     0,
       1,     1,     4,     0,     1,     1,     1,     3,     0,     1,
       1,     1,     1,     2,     0,     0,     2,     2,     1,     2,
       2,     2,     2,    11,    13,     1,     3,     5,     1,     3,
       5,     1,     2,     2,     1,     8,     6,     5,     4,     4,
       3,     7,     8,     6,     6,     6,     6,     6,     4,     7,
       5,     8,     3,     1,     3,     3,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     3,     3,     1,     0,     1,
       3,     7,     9,     9,     8,     6,     3,     0,    13,     1,
       3,     5,     5,     3,     6,     2,     1,     0,     2,     0,
       2,     4,     0,     1,     0,     6,     8,     8,     1,     3,
       5,     5,     7,     9,     7,     9,     5,     6,     6,     4,
       6,     4,     6,     8,     4,     6,     4,     6,     5,     7,
       1,     1,     1,     2,     1,     2,     1,     1,     1,     3,
       3,     3,     3,     1,     1,     1,     1,     1,     2,     2,
       1,     3,     2,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     2,     2,     3,     1,     3,     5,     2,     2,
       0,     6,     6,     6,     6,     6,     6,     6,     6,     8,
       9,     8,     6,     6,     9,     9,     9,     7,    10,     1,
       1,     8,     8,     8,     8,     8,     8,     8,     9,     8,
       8,     2,     0,     1,     1,     2,     2,     1,     2,     3,
       3,     3,     3,     4,     4,     3,     3,     3,     4,     4,
       3,     4,     4,     1,     1,     1,     0,     8,     8,    11,
       1,     1,     2,     4,     5,     1,     3,     2,     2,     2,
       2,     2,     1,     3,     1,     3,     1,     2,     2,     4,
       3,     2,     2,     2,     2,     2,     2,     3,     2,     2,
       2,     2,     5,     5,     5,     5,     5,     1,     3,     1,
       2,     3,     0,     5,     7,     6,     9,     3,     1,     2,
       1,     1,     1,     3,     0,     5,     2,     0,     3,     3,
       3,     7,     7,    10,     1,     1,     1,     1,     1,     1,
      16,    19,     1,     0,     2,     0,     1,     3,     4,     5,
       2,     2,     4,     4,     0,     1,     3,     2,     0,     1,
       1,     0,     2,     2,     0,     9,    12,     7,     7,     2,
       0,     3,     2,     1,     3,     1,     3,     2,     1,     1,
       2,     3,     2,     1,     3,     3,     3,     2,     2,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     4,     5,
       1,     3,     3,     1,     3,     3,     5,     6,     1,     3,
       2,     1,     3,     1,     0,     1,     2,     4,     5,     1,
       1,     1,     1,     3,     3,     2,     2,     1,     2,     2,
       2,     2,     1,     2,     2,     2,     2,     1,     1,     1,
       3,     2,     1,     4,     0,     3,     0,     1,     1,     3,
       5,     2,     0,     2,     1,     3,     5,     5,     5,     1,
       2,     1,     0,     4,     6,     4,     6,     4,     6,     4,
       6,     4,     6,     3,     5,     5,     5,     1,     3,     1,
       3,     2,     2,     1,     2,     1,     2,    11,    10,    10,
       2,     2,     0,     9,     2,     0,    10,    11,    11,     5,
       5,     8,     5,     5,     5,     1,     1,     1,     1,     3,
       0,     5,     5,     6,     6,     6,     6,     6,     8,     8,
       6,     6,     7,     9,     9,     8,    10,     6,     6,     6,
       6,     6,     6,     6,     8,     6,     8,     6,     8,     7,
       9,     6,     8,     7,     9,     8,    10,     8,    10,     9,
      11,     8,    10,     9,    11,     8,     8,     7,     6,     6,
       6,     6,     8,     8,     8,     8,     6,     9,     1,     0,
       2,     0,     8,     8,     8,    10,     9,     8,     1,     0,
       6,     6,     6,     6,     6,     6,     6,     9,     9,     6,
       6,     6,     8,     6,     8,     8,     8,     8,     6,     8,
       6,     8,     7,     9,     7,     9,     6,     7,     1,     3,
       3,     3,     1,     1,     1,     1,     1,     1,     7,     6,
       6,     6,     6,     6,     6,     7,     7,     6,     9,     9,
       6,     6,     6,     6,     6,     6,     8,     8,     8,     6,
       7,     6,     6,     4,     7,     6,     4,     4,     4,     3,
       4,     3,     1,     1,     3,     5,     5,     5,     5,     8,
       5,     5,     6,     7,     7,     7,     4,     4,     5,     4,
       6,    13,     1,     1,     3,     3,     1,     1,     1,     1,
       1,     1,     1,     0,     1,     1,     1,     1,     1,     1,
       0,     3,     2,     0,     2,     2,     2,     3,     3,     3,
       3,     2,     3,     2,     5,     4,     3,     3,     3,     3,
       3,     1,     1,     0,     3,     2,     2,     1,     2,     1,
       3,     2,     1,     0,     2,     3,     0,     9,    11,    12,
      14,     3,     4,     4,     0,     2,     5,     1,     0,     1,
       2,     3,     3,     3,     1,     2,     1,     1,     1,     1,
       1,     1,     0,     5,     4,     6,     6,     4,     3,     5,
       7,     9,     1,     3,     1,     5,     4,     4,     6,     4,
       6,     6,     5,     7,     9,     6,     1,     0,     6,    11,
      11,    11,    13,     9,    11,     1,     1,    10,     6,     4,
       4,     2,     5,     2,     0,     6,     5,     3,     5,     1,
       3,     1,     1,     2,     1,     1,     1,     1,     1,     0,
       1,     0,     1,     0,     1,     0,     1,     0,     3,     0,
       2,     1,     3,     1,     0,     2,     4,     3,     5,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     5,
       3,     0,     1,     1,     1,     1,     1,     3,     9,    12,
       3,     0,     2,     3,     2,     3,     7,     1,     3,     1,
       4,     4,     7,     2,     1,     1,     1,     3,     2,     8,
       5,     0,     4,     3,     0,     2,     0,     7,     2,     0,
       5,     3,     0,     2,     2,     2,     3,     1,     3,     1,
       2,     1,     0,     1,     2,     0,     8,     1,     3,     3,
       5,     2,     1,     3,    10,     1,     2,     4,     4,     4,
       5,     5,     2,     5,     3,     5,     2,     0,     3,     1,
       2,     5,     5,     8,     3,     4,     7,     1,     0,     3,
       2,     2,     2,     2,     0,     2,     2,     1,     1,     3,
       3,     1,     2,     4,     4,     2,     3,     5,     5,     1,
       1,     9,     9,     1,     2,     4,     4,     4,     2,     2,
       3,     1,     3,     9,     1,     2,     0,     7,     7,     0,
      10,     6,     0,     1,     0,     2,     0,     3,     3,     4,
       4,     4,     4,     3,     2,     1,     1,     0,     1,     1,
       0,     1,     5,     1,     0,     1,     1,     1,     0,     3,
       1,     3,     4,     3,     2,     2,     1,     1,     1,     0,
       2,     4,     5,     6,     4,     5,     2,     3,     1,     1,
       1,     1,     2,     2,     1,     1,     1,     1,     1,     1,
       4,     0,     1,     3,     1,     1,     1,     1,     1,     2,
       4,     4,     5,     2,     0,     1,     3,     1,     0,     1,
       2,     3,     2,     4,     2,     3,     2,     0,     4,     5,
       2,     0,     1,     3,     2,     3,     2,     3,     2,     3,
       2,     3,     1,     4,     2,     3,     3,     4,     5,     4,
       5,     4,     5,     2,     4,     1,     1,     0,     2,     0,
       1,     4,     5,     4,     0,     2,     2,     2,     1,     1,
       0,     5,     2,     1,     1,     2,     2,     4,     1,     3,
       1,     2,     3,     6,     4,     0,     2,     6,     2,     1,
       3,     4,     0,     2,     0,     2,     0,     2,     4,     0,
       1,     0,     1,     3,     3,     7,    12,     1,     3,     2,
       3,     3,     1,     2,     2,     2,     2,     1,     2,     1,
       3,     3,     2,    13,     2,     0,     1,     3,     3,     6,
       7,     5,     7,     9,     1,     0,     2,     0,     2,     3,
       5,     6,     2,     3,     3,     4,     0,     1,     1,     1,
       1,     1,     2,     4,     1,     1,     1,     1,     1,     1,
       2,     3,     3,     0,     1,     1,     1,     1,     1,     2,
       2,     2,     2,     2,     1,     3,     0,     1,     1,     1,
       1,     5,     2,     1,     1,     1,     1,     4,     1,     2,
       2,     1,     3,     3,     2,     1,     0,     5,     2,     5,
       2,     1,     3,     3,     0,     1,     1,     1,     1,     1,
       1,     3,     3,     3,     3,     3,     3,     3,     0,     1,
       4,     1,     1,     3,     3,     5,     3,     2,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     3,     3,     2,     2,     3,     5,     4,
       6,     3,     5,     4,     6,     4,     6,     5,     7,     3,
       2,     4,     2,     3,     3,     4,     3,     4,     3,     4,
       5,     6,     6,     7,     6,     7,     3,     4,     4,     6,
       3,     3,     4,     3,     4,     4,     5,     4,     5,     1,
       1,     3,     2,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     5,     6,
       3,     4,     1,     1,     2,     4,     1,     1,     1,     2,
       2,     2,     2,     1,     1,     4,     3,     5,     6,     8,
       6,     6,     4,     4,     3,     1,     1,     1,     1,     5,
       1,     1,     4,     1,     4,     1,     4,     1,     4,     1,
       1,     1,     1,     1,     1,     1,     6,     4,     4,     6,
       4,     4,     4,     4,     4,     6,     5,     5,     5,     4,
       6,     4,     4,     4,     4,     5,     7,     7,     9,     5,
       4,     6,     5,     7,     7,     8,     4,     7,     4,     6,
       6,     4,     5,     4,     5,     3,    11,     8,     9,     2,
       3,     3,     3,     4,     0,     4,     1,     3,     3,     1,
       1,     1,     1,     2,     0,     2,     2,     0,     2,     3,
       3,     4,     2,     2,     5,     0,     5,     0,     2,     0,
       1,     3,     3,     2,     2,     0,     6,     1,     0,     3,
       0,     3,     3,     3,     0,     1,     4,     2,     2,     2,
       2,     2,     3,     2,     2,     3,     0,     4,     3,     5,
       4,     3,     5,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     4,     1,     4,     1,     4,     1,     2,     1,     2,
       1,     3,     1,     3,     1,     3,     3,     1,     0,     1,
       3,     3,     3,     2,     1,     3,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     7,
       5,     3,     5,     5,     3,     3,     5,     3,     2,     1,
       1,     3,     5,     1,     2,     4,     2,     0,     1,     0,
       1,     2,     2,     2,     3,     5,     1,     0,     1,     2,
       0,     2,     1,     0,     2,     0,     1,     3,     3,     2,
       3,     2,     3,     4,     4,     3,     3,     0,     2,     1,
       1,     1,     1,     1,     1,     2,     2,     1,     3,     3,
       6,     0,     3,     0,     2,     4,     2,     1,     0,     5,
       2,     5,     2,     0,     3,     0,     1,     2,     2,     2,
       2,     3,     2,     3,     2,     0,     1,     3,     3,     3,
       3,     3,     0,     3,     3,     0,     1,     3,     7,     7,
       3,     0,     1,     0,     1,     3,     3,     2,     1,     1,
       1,     3,     1,     2,     1,     3,     1,     1,     1,     1,
       2,     1,     1,     1,     1,     1,     2,     6,     2,     3,
       5,     1,     1,     1,     1,     1,     1,     2,     2,     1,
       1,     1,     1,     1,     1,     3,    10,     4,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, core_yyscan_t yyscanner)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       , yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, yyscanner); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, core_yyscan_t yyscanner)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (core_yyscan_t yyscanner)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, &yylloc, yyscanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 924 "gram.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree = (yyvsp[0].list);
				(void) yynerrs;		/* suppress compiler warning */
			}
#line 30316 "gram.c" /* yacc.c:1646  */
    break;

  case 3:
#line 929 "gram.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree = list_make1((yyvsp[0].typnam));
			}
#line 30324 "gram.c" /* yacc.c:1646  */
    break;

  case 4:
#line 933 "gram.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((yyvsp[0].node), 0));
			}
#line 30333 "gram.c" /* yacc.c:1646  */
    break;

  case 5:
#line 938 "gram.y" /* yacc.c:1646  */
    {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);

				n->nnames = 1;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, 0));
			}
#line 30345 "gram.c" /* yacc.c:1646  */
    break;

  case 6:
#line 946 "gram.y" /* yacc.c:1646  */
    {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);

				n->nnames = 2;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, 0));
			}
#line 30357 "gram.c" /* yacc.c:1646  */
    break;

  case 7:
#line 954 "gram.y" /* yacc.c:1646  */
    {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);

				n->nnames = 3;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, 0));
			}
#line 30369 "gram.c" /* yacc.c:1646  */
    break;

  case 8:
#line 974 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-2].list) != NIL)
					{
						/* update length of previous stmt */
						updateRawStmtEnd(llast_node(RawStmt, (yyvsp[-2].list)), (yylsp[-1]));
					}
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), makeRawStmt((yyvsp[0].node), (yylsp[-1]) + 1));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 30385 "gram.c" /* yacc.c:1646  */
    break;

  case 9:
#line 986 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = list_make1(makeRawStmt((yyvsp[0].node), 0));
					else
						(yyval.list) = NIL;
				}
#line 30396 "gram.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1129 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 30402 "gram.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1136 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 30408 "gram.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1137 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 30414 "gram.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1141 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 30420 "gram.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1142 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30426 "gram.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1146 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 30432 "gram.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1147 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 30438 "gram.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1151 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_CASCADE; }
#line 30444 "gram.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1152 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; }
#line 30450 "gram.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1153 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; /* default */ }
#line 30456 "gram.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1163 "gram.y" /* yacc.c:1646  */
    {
					CallStmt   *n = makeNode(CallStmt);

					n->funccall = castNode(FuncCall, (yyvsp[0].node));
					(yyval.node) = (Node *) n;
				}
#line 30467 "gram.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1179 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);

					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30480 "gram.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1201 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 30486 "gram.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1202 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30492 "gram.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1206 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 30498 "gram.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1207 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30504 "gram.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1212 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password",
									 (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 30513 "gram.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1217 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password", NULL, (yylsp[-1]));
				}
#line 30521 "gram.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1221 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * These days, passwords are always stored in encrypted
					 * form, so there is no difference between PASSWORD and
					 * ENCRYPTED PASSWORD.
					 */
					(yyval.defelt) = makeDefElem("password",
									 (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 30535 "gram.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1231 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNENCRYPTED PASSWORD is no longer supported"),
							 errhint("Remove UNENCRYPTED to store the password in encrypted form instead."),
							 parser_errposition((yylsp[-2]))));
				}
#line 30547 "gram.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1239 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 30555 "gram.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1243 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 30563 "gram.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1247 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("validUntil", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 30571 "gram.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1252 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 30579 "gram.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1256 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We handle identifiers that aren't parser keywords with
					 * the following special-case codes, to avoid bloating the
					 * size of the main parser.
					 */
					if (strcmp((yyvsp[0].str), "superuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nosuperuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "createrole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nocreaterole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "replication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "noreplication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "createdb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nocreatedb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "login") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nologin") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "bypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nobypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "noinherit") == 0)
					{
						/*
						 * Note that INHERIT is a keyword, so it's handled by main parser, but
						 * NOINHERIT is handled here.
						 */
						(yyval.defelt) = makeDefElem("inherit", (Node *) makeBoolean(false), (yylsp[0]));
					}
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized role option \"%s\"", (yyvsp[0].str)),
									 parser_errposition((yylsp[0]))));
				}
#line 30628 "gram.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1303 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = (yyvsp[0].defelt); }
#line 30634 "gram.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1306 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("sysid", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-1]));
				}
#line 30642 "gram.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1310 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 30650 "gram.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1314 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 30658 "gram.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1318 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 30666 "gram.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1322 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 30674 "gram.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1336 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);

					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30687 "gram.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1355 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);

					n->role = (yyvsp[-2].rolespec);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 30700 "gram.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1364 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);

					n->role = (yyvsp[-2].rolespec);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 30713 "gram.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1375 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 30719 "gram.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1376 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 30725 "gram.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1381 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = (yyvsp[-2].rolespec);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 30738 "gram.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1390 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 30751 "gram.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1399 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = (yyvsp[-2].rolespec);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 30764 "gram.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1408 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 30777 "gram.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1430 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30789 "gram.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1438 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = true;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30801 "gram.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1446 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30813 "gram.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1454 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->roles = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30825 "gram.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1462 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30837 "gram.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1470 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = true;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30849 "gram.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1488 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);

					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30862 "gram.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1507 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);

					n->role = (yyvsp[-3].rolespec);
					n->action = (yyvsp[-2].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *) (yyvsp[0].list), (yylsp[0])));
					(yyval.node) = (Node *) n;
				}
#line 30876 "gram.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1518 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = +1; }
#line 30882 "gram.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1519 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = -1; }
#line 30888 "gram.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1531 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* One can omit the schema name or the authorization id. */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].rolespec);
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 30903 "gram.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1542 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* ...but not both */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 30918 "gram.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1553 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* schema name can be omitted here, too */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].rolespec);
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 30938 "gram.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1569 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* ...but not here */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 30958 "gram.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1588 "gram.y" /* yacc.c:1646  */
    {
					if ((yyloc) < 0)			/* see comments for YYLLOC_DEFAULT */
						(yyloc) = (yylsp[0]);
					(yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node));
				}
#line 30968 "gram.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1594 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30974 "gram.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1622 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);

					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 30985 "gram.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1629 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);

					n->is_local = true;
					(yyval.node) = (Node *) n;
				}
#line 30996 "gram.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1636 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);

					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 31007 "gram.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1646 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 31020 "gram.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1655 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 31033 "gram.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1668 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 31046 "gram.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1677 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 31059 "gram.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1686 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 31071 "gram.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1694 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 31083 "gram.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1704 "gram.y" /* yacc.c:1646  */
    {(yyval.vsetstmt) = (yyvsp[0].vsetstmt);}
#line 31089 "gram.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1706 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 31101 "gram.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1715 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[0].node) != NULL)
						n->args = list_make1((yyvsp[0].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 31117 "gram.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1727 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 parser_errposition((yylsp[0]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				}
#line 31129 "gram.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1735 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 31142 "gram.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1744 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[0].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 31158 "gram.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1756 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 31171 "gram.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1765 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 31184 "gram.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1774 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 31196 "gram.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1782 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[0].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 31209 "gram.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1792 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION SNAPSHOT";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 31222 "gram.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1802 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31228 "gram.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1804 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = psprintf("%s.%s", (yyvsp[-2].str), (yyvsp[0].str)); }
#line 31234 "gram.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1807 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 31240 "gram.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1808 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 31246 "gram.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1812 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0])); }
#line 31252 "gram.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1814 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].node), (yylsp[0])); }
#line 31258 "gram.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1817 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "read uncommitted"; }
#line 31264 "gram.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1818 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "read committed"; }
#line 31270 "gram.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1819 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "repeatable read"; }
#line 31276 "gram.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1820 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "serializable"; }
#line 31282 "gram.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1824 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "true"; }
#line 31288 "gram.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1825 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "false"; }
#line 31294 "gram.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1826 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "on"; }
#line 31300 "gram.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1832 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31306 "gram.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1845 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 31314 "gram.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1849 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 31322 "gram.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1853 "gram.y" /* yacc.c:1646  */
    {
					TypeName   *t = (yyvsp[-2].typnam);

					if ((yyvsp[0].list) != NIL)
					{
						A_Const	   *n = (A_Const *) linitial((yyvsp[0].list));

						if ((n->val.ival.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[0]))));
					}
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 31343 "gram.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1870 "gram.y" /* yacc.c:1646  */
    {
					TypeName   *t = (yyvsp[-4].typnam);

					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 31355 "gram.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1877 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].node), (yylsp[0])); }
#line 31361 "gram.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1878 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 31367 "gram.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1879 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 31373 "gram.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1883 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31379 "gram.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1884 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 31385 "gram.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1885 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 31391 "gram.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1889 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31397 "gram.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1890 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31403 "gram.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1894 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].vsetstmt); }
#line 31409 "gram.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1898 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 31415 "gram.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1900 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.vsetstmt) = n;
				}
#line 31427 "gram.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1908 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.vsetstmt) = n;
				}
#line 31439 "gram.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1916 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 31451 "gram.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1927 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = (yyvsp[0].str);
					(yyval.vsetstmt) = n;
				}
#line 31463 "gram.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1935 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET_ALL;
					(yyval.vsetstmt) = n;
				}
#line 31474 "gram.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1945 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 31480 "gram.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1946 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 31486 "gram.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1951 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 31492 "gram.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1952 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 31498 "gram.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1958 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31509 "gram.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1965 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
#line 31520 "gram.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1972 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
#line 31531 "gram.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1979 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
#line 31542 "gram.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1986 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "all";
					(yyval.node) = (Node *) n;
				}
#line 31553 "gram.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1997 "gram.y" /* yacc.c:1646  */
    {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);

					n->constraints = (yyvsp[-1].list);
					n->deferred = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 31565 "gram.c" /* yacc.c:1646  */
    break;

  case 265:
#line 2007 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31571 "gram.c" /* yacc.c:1646  */
    break;

  case 266:
#line 2008 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31577 "gram.c" /* yacc.c:1646  */
    break;

  case 267:
#line 2012 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 31583 "gram.c" /* yacc.c:1646  */
    break;

  case 268:
#line 2013 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 31589 "gram.c" /* yacc.c:1646  */
    break;

  case 269:
#line 2022 "gram.y" /* yacc.c:1646  */
    {
					CheckPointStmt *n = makeNode(CheckPointStmt);

					(yyval.node) = (Node *) n;
				}
#line 31599 "gram.c" /* yacc.c:1646  */
    break;

  case 270:
#line 2038 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				}
#line 31610 "gram.c" /* yacc.c:1646  */
    break;

  case 271:
#line 2045 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 31621 "gram.c" /* yacc.c:1646  */
    break;

  case 272:
#line 2052 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 31632 "gram.c" /* yacc.c:1646  */
    break;

  case 273:
#line 2059 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				}
#line 31643 "gram.c" /* yacc.c:1646  */
    break;

  case 274:
#line 2066 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_SEQUENCES;
					(yyval.node) = (Node *) n;
				}
#line 31654 "gram.c" /* yacc.c:1646  */
    break;

  case 275:
#line 2086 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 31668 "gram.c" /* yacc.c:1646  */
    break;

  case 276:
#line 2096 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31682 "gram.c" /* yacc.c:1646  */
    break;

  case 277:
#line 2106 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 31696 "gram.c" /* yacc.c:1646  */
    break;

  case 278:
#line 2116 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31710 "gram.c" /* yacc.c:1646  */
    break;

  case 279:
#line 2126 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_TABLE;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 31726 "gram.c" /* yacc.c:1646  */
    break;

  case 280:
#line 2138 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_TABLE;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 31742 "gram.c" /* yacc.c:1646  */
    break;

  case 281:
#line 2150 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 31756 "gram.c" /* yacc.c:1646  */
    break;

  case 282:
#line 2160 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_INDEX;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31770 "gram.c" /* yacc.c:1646  */
    break;

  case 283:
#line 2170 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 31784 "gram.c" /* yacc.c:1646  */
    break;

  case 284:
#line 2180 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_INDEX;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 31800 "gram.c" /* yacc.c:1646  */
    break;

  case 285:
#line 2192 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_INDEX;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 31816 "gram.c" /* yacc.c:1646  */
    break;

  case 286:
#line 2204 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_SEQUENCE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 31830 "gram.c" /* yacc.c:1646  */
    break;

  case 287:
#line 2214 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_SEQUENCE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31844 "gram.c" /* yacc.c:1646  */
    break;

  case 288:
#line 2224 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_VIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 31858 "gram.c" /* yacc.c:1646  */
    break;

  case 289:
#line 2234 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_VIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31872 "gram.c" /* yacc.c:1646  */
    break;

  case 290:
#line 2244 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_MATVIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 31886 "gram.c" /* yacc.c:1646  */
    break;

  case 291:
#line 2254 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_MATVIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31900 "gram.c" /* yacc.c:1646  */
    break;

  case 292:
#line 2264 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 31916 "gram.c" /* yacc.c:1646  */
    break;

  case 293:
#line 2276 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 31932 "gram.c" /* yacc.c:1646  */
    break;

  case 294:
#line 2288 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 31946 "gram.c" /* yacc.c:1646  */
    break;

  case 295:
#line 2298 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31960 "gram.c" /* yacc.c:1646  */
    break;

  case 296:
#line 2310 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 31966 "gram.c" /* yacc.c:1646  */
    break;

  case 297:
#line 2311 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 31972 "gram.c" /* yacc.c:1646  */
    break;

  case 298:
#line 2315 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].singlepartspec)); }
#line 31978 "gram.c" /* yacc.c:1646  */
    break;

  case 299:
#line 2316 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].singlepartspec)); }
#line 31984 "gram.c" /* yacc.c:1646  */
    break;

  case 300:
#line 2321 "gram.y" /* yacc.c:1646  */
    {
					SinglePartitionSpec *n = makeNode(SinglePartitionSpec);

					n->name = (yyvsp[-1].range);
					n->bound = (yyvsp[0].partboundspec);

					(yyval.singlepartspec) = n;
				}
#line 31997 "gram.c" /* yacc.c:1646  */
    break;

  case 301:
#line 2334 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_AttachPartition;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = (yyvsp[0].partboundspec);
					cmd->partlist = NULL;
					cmd->concurrent = false;
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 32015 "gram.c" /* yacc.c:1646  */
    break;

  case 302:
#line 2349 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_DetachPartition;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = NULL;
					cmd->partlist = NULL;
					cmd->concurrent = (yyvsp[0].boolean);
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 32033 "gram.c" /* yacc.c:1646  */
    break;

  case 303:
#line 2363 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_DetachPartitionFinalize;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = NULL;
					cmd->partlist = NULL;
					cmd->concurrent = false;
					n->def = (Node *) cmd;
					(yyval.node) = (Node *) n;
				}
#line 32050 "gram.c" /* yacc.c:1646  */
    break;

  case 304:
#line 2377 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_SplitPartition;
					cmd->name = (yyvsp[-4].range);
					cmd->bound = NULL;
					cmd->partlist = (yyvsp[-1].list);
					cmd->concurrent = false;
					n->def = (Node *) cmd;
					(yyval.node) = (Node *) n;
				}
#line 32067 "gram.c" /* yacc.c:1646  */
    break;

  case 305:
#line 2391 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_MergePartitions;
					cmd->name = (yyvsp[0].range);
					cmd->bound = NULL;
					cmd->partlist = (yyvsp[-3].list);
					cmd->concurrent = false;
					n->def = (Node *) cmd;
					(yyval.node) = (Node *) n;
				}
#line 32084 "gram.c" /* yacc.c:1646  */
    break;

  case 306:
#line 2408 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_AttachPartition;
					cmd->name = (yyvsp[0].range);
					cmd->bound = NULL;
					cmd->partlist = NULL;
					cmd->concurrent = false;
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 32102 "gram.c" /* yacc.c:1646  */
    break;

  case 307:
#line 2426 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32115 "gram.c" /* yacc.c:1646  */
    break;

  case 308:
#line 2436 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32128 "gram.c" /* yacc.c:1646  */
    break;

  case 309:
#line 2446 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32141 "gram.c" /* yacc.c:1646  */
    break;

  case 310:
#line 2456 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32154 "gram.c" /* yacc.c:1646  */
    break;

  case 311:
#line 2466 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[-1].str);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 32167 "gram.c" /* yacc.c:1646  */
    break;

  case 312:
#line 2476 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *) n;
				}
#line 32179 "gram.c" /* yacc.c:1646  */
    break;

  case 313:
#line 2485 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *) n;
				}
#line 32191 "gram.c" /* yacc.c:1646  */
    break;

  case 314:
#line 2494 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetExpression;
					n->name = (yyvsp[-6].str);
					n->def = (yyvsp[-1].node);
					(yyval.node) = (Node *) n;
				}
#line 32204 "gram.c" /* yacc.c:1646  */
    break;

  case 315:
#line 2504 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropExpression;
					n->name = (yyvsp[-2].str);
					(yyval.node) = (Node *) n;
				}
#line 32216 "gram.c" /* yacc.c:1646  */
    break;

  case 316:
#line 2513 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropExpression;
					n->name = (yyvsp[-4].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32229 "gram.c" /* yacc.c:1646  */
    break;

  case 317:
#line 2523 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[-3].str);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 32242 "gram.c" /* yacc.c:1646  */
    break;

  case 318:
#line 2533 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					if ((yyvsp[-3].ival) <= 0 || (yyvsp[-3].ival) > PG_INT16_MAX)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("column number must be in range from 1 to %d", PG_INT16_MAX),
								 parser_errposition((yylsp[-3]))));

					n->subtype = AT_SetStatistics;
					n->num = (int16) (yyvsp[-3].ival);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 32261 "gram.c" /* yacc.c:1646  */
    break;

  case 319:
#line 2549 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32274 "gram.c" /* yacc.c:1646  */
    break;

  case 320:
#line 2559 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ResetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32287 "gram.c" /* yacc.c:1646  */
    break;

  case 321:
#line 2569 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetStorage;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *) n;
				}
#line 32300 "gram.c" /* yacc.c:1646  */
    break;

  case 322:
#line 2579 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetCompression;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *) n;
				}
#line 32313 "gram.c" /* yacc.c:1646  */
    break;

  case 323:
#line 2589 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);

					c->contype = CONSTR_IDENTITY;
					c->generated_when = (yyvsp[-3].ival);
					c->options = (yyvsp[0].list);
					c->location = (yylsp[-4]);

					n->subtype = AT_AddIdentity;
					n->name = (yyvsp[-6].str);
					n->def = (Node *) c;

					(yyval.node) = (Node *) n;
				}
#line 32333 "gram.c" /* yacc.c:1646  */
    break;

  case 324:
#line 2606 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetIdentity;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32346 "gram.c" /* yacc.c:1646  */
    break;

  case 325:
#line 2616 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropIdentity;
					n->name = (yyvsp[-2].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32359 "gram.c" /* yacc.c:1646  */
    break;

  case 326:
#line 2626 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropIdentity;
					n->name = (yyvsp[-4].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32372 "gram.c" /* yacc.c:1646  */
    break;

  case 327:
#line 2636 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32386 "gram.c" /* yacc.c:1646  */
    break;

  case 328:
#line 2647 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32400 "gram.c" /* yacc.c:1646  */
    break;

  case 329:
#line 2661 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);

					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = (yyvsp[0].node);
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 32419 "gram.c" /* yacc.c:1646  */
    break;

  case 330:
#line 2677 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AlterColumnGenericOptions;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32432 "gram.c" /* yacc.c:1646  */
    break;

  case 331:
#line 2687 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 32444 "gram.c" /* yacc.c:1646  */
    break;

  case 332:
#line 2696 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);

					n->subtype = AT_AlterConstraint;
					n->def = (Node *) c;
					c->contype = CONSTR_FOREIGN; /* others not supported, yet */
					c->conname = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "ALTER CONSTRAINT statement",
									&c->deferrable,
									&c->initdeferred,
									NULL, NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 32463 "gram.c" /* yacc.c:1646  */
    break;

  case 333:
#line 2712 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ValidateConstraint;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32475 "gram.c" /* yacc.c:1646  */
    break;

  case 334:
#line 2721 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32489 "gram.c" /* yacc.c:1646  */
    break;

  case 335:
#line 2732 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32503 "gram.c" /* yacc.c:1646  */
    break;

  case 336:
#line 2743 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropOids;
					(yyval.node) = (Node *) n;
				}
#line 32514 "gram.c" /* yacc.c:1646  */
    break;

  case 337:
#line 2751 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32526 "gram.c" /* yacc.c:1646  */
    break;

  case 338:
#line 2760 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 32538 "gram.c" /* yacc.c:1646  */
    break;

  case 339:
#line 2769 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetLogged;
					(yyval.node) = (Node *) n;
				}
#line 32549 "gram.c" /* yacc.c:1646  */
    break;

  case 340:
#line 2777 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetUnLogged;
					(yyval.node) = (Node *) n;
				}
#line 32560 "gram.c" /* yacc.c:1646  */
    break;

  case 341:
#line 2785 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32572 "gram.c" /* yacc.c:1646  */
    break;

  case 342:
#line 2794 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32584 "gram.c" /* yacc.c:1646  */
    break;

  case 343:
#line 2803 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32596 "gram.c" /* yacc.c:1646  */
    break;

  case 344:
#line 2812 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *) n;
				}
#line 32607 "gram.c" /* yacc.c:1646  */
    break;

  case 345:
#line 2820 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *) n;
				}
#line 32618 "gram.c" /* yacc.c:1646  */
    break;

  case 346:
#line 2828 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32630 "gram.c" /* yacc.c:1646  */
    break;

  case 347:
#line 2837 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *) n;
				}
#line 32641 "gram.c" /* yacc.c:1646  */
    break;

  case 348:
#line 2845 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *) n;
				}
#line 32652 "gram.c" /* yacc.c:1646  */
    break;

  case 349:
#line 2853 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32664 "gram.c" /* yacc.c:1646  */
    break;

  case 350:
#line 2862 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32676 "gram.c" /* yacc.c:1646  */
    break;

  case 351:
#line 2871 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32688 "gram.c" /* yacc.c:1646  */
    break;

  case 352:
#line 2880 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32700 "gram.c" /* yacc.c:1646  */
    break;

  case 353:
#line 2889 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *) n;
				}
#line 32712 "gram.c" /* yacc.c:1646  */
    break;

  case 354:
#line 2898 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *) n;
				}
#line 32724 "gram.c" /* yacc.c:1646  */
    break;

  case 355:
#line 2907 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					TypeName   *def = makeTypeNameFromNameList((yyvsp[0].list));

					def->location = (yylsp[0]);
					n->subtype = AT_AddOf;
					n->def = (Node *) def;
					(yyval.node) = (Node *) n;
				}
#line 32738 "gram.c" /* yacc.c:1646  */
    break;

  case 356:
#line 2918 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropOf;
					(yyval.node) = (Node *) n;
				}
#line 32749 "gram.c" /* yacc.c:1646  */
    break;

  case 357:
#line 2926 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ChangeOwner;
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 32761 "gram.c" /* yacc.c:1646  */
    break;

  case 358:
#line 2935 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetAccessMethod;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32773 "gram.c" /* yacc.c:1646  */
    break;

  case 359:
#line 2944 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32785 "gram.c" /* yacc.c:1646  */
    break;

  case 360:
#line 2953 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetRelOptions;
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32797 "gram.c" /* yacc.c:1646  */
    break;

  case 361:
#line 2962 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ResetRelOptions;
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32809 "gram.c" /* yacc.c:1646  */
    break;

  case 362:
#line 2971 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ReplicaIdentity;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 32821 "gram.c" /* yacc.c:1646  */
    break;

  case 363:
#line 2980 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 32832 "gram.c" /* yacc.c:1646  */
    break;

  case 364:
#line 2988 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 32843 "gram.c" /* yacc.c:1646  */
    break;

  case 365:
#line 2996 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ForceRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 32854 "gram.c" /* yacc.c:1646  */
    break;

  case 366:
#line 3004 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_NoForceRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 32865 "gram.c" /* yacc.c:1646  */
    break;

  case 367:
#line 3011 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_GenericOptions;
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32877 "gram.c" /* yacc.c:1646  */
    break;

  case 368:
#line 3021 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32883 "gram.c" /* yacc.c:1646  */
    break;

  case 369:
#line 3022 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 32889 "gram.c" /* yacc.c:1646  */
    break;

  case 370:
#line 3027 "gram.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);

					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 32902 "gram.c" /* yacc.c:1646  */
    break;

  case 371:
#line 3035 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 32908 "gram.c" /* yacc.c:1646  */
    break;

  case 372:
#line 3039 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32914 "gram.c" /* yacc.c:1646  */
    break;

  case 373:
#line 3040 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 32920 "gram.c" /* yacc.c:1646  */
    break;

  case 374:
#line 3045 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_NOTHING;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 32932 "gram.c" /* yacc.c:1646  */
    break;

  case 375:
#line 3053 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_FULL;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 32944 "gram.c" /* yacc.c:1646  */
    break;

  case 376:
#line 3061 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_DEFAULT;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 32956 "gram.c" /* yacc.c:1646  */
    break;

  case 377:
#line 3069 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_INDEX;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32968 "gram.c" /* yacc.c:1646  */
    break;

  case 378:
#line 3079 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 32974 "gram.c" /* yacc.c:1646  */
    break;

  case 379:
#line 3082 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32980 "gram.c" /* yacc.c:1646  */
    break;

  case 380:
#line 3083 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32986 "gram.c" /* yacc.c:1646  */
    break;

  case 381:
#line 3087 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 32992 "gram.c" /* yacc.c:1646  */
    break;

  case 382:
#line 3088 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 32998 "gram.c" /* yacc.c:1646  */
    break;

  case 383:
#line 3094 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 33006 "gram.c" /* yacc.c:1646  */
    break;

  case 384:
#line 3098 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0]));
				}
#line 33014 "gram.c" /* yacc.c:1646  */
    break;

  case 385:
#line 3102 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-4].str), (yyvsp[-2].str), (Node *) (yyvsp[0].node),
											 DEFELEM_UNSPEC, (yylsp[-4]));
				}
#line 33023 "gram.c" /* yacc.c:1646  */
    break;

  case 386:
#line 3107 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-2].str), (yyvsp[0].str), NULL, DEFELEM_UNSPEC, (yylsp[-2]));
				}
#line 33031 "gram.c" /* yacc.c:1646  */
    break;

  case 387:
#line 3114 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 33037 "gram.c" /* yacc.c:1646  */
    break;

  case 388:
#line 3116 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 33043 "gram.c" /* yacc.c:1646  */
    break;

  case 389:
#line 3121 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", NULL, (yylsp[0]));
				}
#line 33051 "gram.c" /* yacc.c:1646  */
    break;

  case 390:
#line 3125 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 33059 "gram.c" /* yacc.c:1646  */
    break;

  case 391:
#line 3129 "gram.y" /* yacc.c:1646  */
    {
					if (strcmp((yyvsp[0].defelt)->defname, "as") == 0 ||
						strcmp((yyvsp[0].defelt)->defname, "restart") == 0 ||
						strcmp((yyvsp[0].defelt)->defname, "owned_by") == 0)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("sequence option \"%s\" not supported here", (yyvsp[0].defelt)->defname),
								 parser_errposition((yylsp[0]))));
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 33074 "gram.c" /* yacc.c:1646  */
    break;

  case 392:
#line 3140 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("generated", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 33082 "gram.c" /* yacc.c:1646  */
    break;

  case 393:
#line 3146 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeInteger((yyvsp[0].ival)); }
#line 33088 "gram.c" /* yacc.c:1646  */
    break;

  case 394:
#line 3147 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 33094 "gram.c" /* yacc.c:1646  */
    break;

  case 395:
#line 3151 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33100 "gram.c" /* yacc.c:1646  */
    break;

  case 396:
#line 3152 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 33106 "gram.c" /* yacc.c:1646  */
    break;

  case 397:
#line 3158 "gram.y" /* yacc.c:1646  */
    {
					ListCell   *lc;
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_HASH;
					n->modulus = n->remainder = -1;

					foreach (lc, (yyvsp[-1].list))
					{
						DefElem    *opt = lfirst_node(DefElem, lc);

						if (strcmp(opt->defname, "modulus") == 0)
						{
							if (n->modulus != -1)
								ereport(ERROR,
										(errcode(ERRCODE_DUPLICATE_OBJECT),
										 errmsg("modulus for hash partition provided more than once"),
										 parser_errposition(opt->location)));
							n->modulus = defGetInt32(opt);
						}
						else if (strcmp(opt->defname, "remainder") == 0)
						{
							if (n->remainder != -1)
								ereport(ERROR,
										(errcode(ERRCODE_DUPLICATE_OBJECT),
										 errmsg("remainder for hash partition provided more than once"),
										 parser_errposition(opt->location)));
							n->remainder = defGetInt32(opt);
						}
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("unrecognized hash partition bound specification \"%s\"",
											opt->defname),
									 parser_errposition(opt->location)));
					}

					if (n->modulus == -1)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("modulus for hash partition must be specified")));
					if (n->remainder == -1)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("remainder for hash partition must be specified")));

					n->location = (yylsp[-3]);

					(yyval.partboundspec) = n;
				}
#line 33161 "gram.c" /* yacc.c:1646  */
    break;

  case 398:
#line 3211 "gram.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_LIST;
					n->is_default = false;
					n->listdatums = (yyvsp[-1].list);
					n->location = (yylsp[-3]);

					(yyval.partboundspec) = n;
				}
#line 33176 "gram.c" /* yacc.c:1646  */
    break;

  case 399:
#line 3224 "gram.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_RANGE;
					n->is_default = false;
					n->lowerdatums = (yyvsp[-5].list);
					n->upperdatums = (yyvsp[-1].list);
					n->location = (yylsp[-7]);

					(yyval.partboundspec) = n;
				}
#line 33192 "gram.c" /* yacc.c:1646  */
    break;

  case 400:
#line 3238 "gram.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->is_default = true;
					n->location = (yylsp[0]);

					(yyval.partboundspec) = n;
				}
#line 33205 "gram.c" /* yacc.c:1646  */
    break;

  case 401:
#line 3250 "gram.y" /* yacc.c:1646  */
    {
				(yyval.defelt) = makeDefElem((yyvsp[-1].str), (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-1]));
			}
#line 33213 "gram.c" /* yacc.c:1646  */
    break;

  case 402:
#line 3257 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make1((yyvsp[0].defelt));
			}
#line 33221 "gram.c" /* yacc.c:1646  */
    break;

  case 403:
#line 3261 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
			}
#line 33229 "gram.c" /* yacc.c:1646  */
    break;

  case 404:
#line 3275 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					/* can't use qualified_name, sigh */
					n->relation = makeRangeVarFromAnyName((yyvsp[-1].list), (yylsp[-1]), yyscanner);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TYPE;
					(yyval.node) = (Node *) n;
				}
#line 33243 "gram.c" /* yacc.c:1646  */
    break;

  case 405:
#line 3287 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 33249 "gram.c" /* yacc.c:1646  */
    break;

  case 406:
#line 3288 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 33255 "gram.c" /* yacc.c:1646  */
    break;

  case 407:
#line 3294 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[-1].node);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 33268 "gram.c" /* yacc.c:1646  */
    break;

  case 408:
#line 3304 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 33282 "gram.c" /* yacc.c:1646  */
    break;

  case 409:
#line 3315 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 33296 "gram.c" /* yacc.c:1646  */
    break;

  case 410:
#line 3326 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);

					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					n->behavior = (yyvsp[0].dbehavior);
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = NULL;
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 33316 "gram.c" /* yacc.c:1646  */
    break;

  case 411:
#line 3353 "gram.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);

					n->portalname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33327 "gram.c" /* yacc.c:1646  */
    break;

  case 412:
#line 3360 "gram.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);

					n->portalname = NULL;
					(yyval.node) = (Node *) n;
				}
#line 33338 "gram.c" /* yacc.c:1646  */
    break;

  case 413:
#line 3396 "gram.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);

					n->relation = (yyvsp[-8].range);
					n->query = NULL;
					n->attlist = (yyvsp[-7].list);
					n->is_from = (yyvsp[-6].boolean);
					n->is_program = (yyvsp[-5].boolean);
					n->filename = (yyvsp[-4].str);
					n->whereClause = (yyvsp[0].node);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-3]))));

					if (!n->is_from && n->whereClause != NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("WHERE clause not allowed with COPY TO"),
								 parser_errposition((yylsp[0]))));

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[-9].defelt))
						n->options = lappend(n->options, (yyvsp[-9].defelt));
					if ((yyvsp[-3].defelt))
						n->options = lappend(n->options, (yyvsp[-3].defelt));
					if ((yyvsp[-1].list))
						n->options = list_concat(n->options, (yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 33376 "gram.c" /* yacc.c:1646  */
    break;

  case 414:
#line 3430 "gram.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);

					n->relation = NULL;
					n->query = (yyvsp[-6].node);
					n->attlist = NIL;
					n->is_from = false;
					n->is_program = (yyvsp[-3].boolean);
					n->filename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-4]))));

					(yyval.node) = (Node *) n;
				}
#line 33400 "gram.c" /* yacc.c:1646  */
    break;

  case 415:
#line 3452 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 33406 "gram.c" /* yacc.c:1646  */
    break;

  case 416:
#line 3453 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 33412 "gram.c" /* yacc.c:1646  */
    break;

  case 417:
#line 3457 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 33418 "gram.c" /* yacc.c:1646  */
    break;

  case 418:
#line 3458 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 33424 "gram.c" /* yacc.c:1646  */
    break;

  case 419:
#line 3467 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33430 "gram.c" /* yacc.c:1646  */
    break;

  case 420:
#line 3468 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 33436 "gram.c" /* yacc.c:1646  */
    break;

  case 421:
#line 3469 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 33442 "gram.c" /* yacc.c:1646  */
    break;

  case 422:
#line 3472 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33448 "gram.c" /* yacc.c:1646  */
    break;

  case 423:
#line 3473 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 33454 "gram.c" /* yacc.c:1646  */
    break;

  case 424:
#line 3478 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 33460 "gram.c" /* yacc.c:1646  */
    break;

  case 425:
#line 3479 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33466 "gram.c" /* yacc.c:1646  */
    break;

  case 426:
#line 3484 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *) makeString("binary"), (yylsp[0]));
				}
#line 33474 "gram.c" /* yacc.c:1646  */
    break;

  case 427:
#line 3488 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("freeze", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 33482 "gram.c" /* yacc.c:1646  */
    break;

  case 428:
#line 3492 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 33490 "gram.c" /* yacc.c:1646  */
    break;

  case 429:
#line 3496 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("null", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 33498 "gram.c" /* yacc.c:1646  */
    break;

  case 430:
#line 3500 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *) makeString("csv"), (yylsp[0]));
				}
#line 33506 "gram.c" /* yacc.c:1646  */
    break;

  case 431:
#line 3504 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("header", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 33514 "gram.c" /* yacc.c:1646  */
    break;

  case 432:
#line 3508 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("quote", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 33522 "gram.c" /* yacc.c:1646  */
    break;

  case 433:
#line 3512 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("escape", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 33530 "gram.c" /* yacc.c:1646  */
    break;

  case 434:
#line 3516 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 33538 "gram.c" /* yacc.c:1646  */
    break;

  case 435:
#line 3520 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *) makeNode(A_Star), (yylsp[-2]));
				}
#line 33546 "gram.c" /* yacc.c:1646  */
    break;

  case 436:
#line 3524 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *) (yyvsp[0].list), (yylsp[-3]));
				}
#line 33554 "gram.c" /* yacc.c:1646  */
    break;

  case 437:
#line 3528 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *) makeNode(A_Star), (yylsp[-3]));
				}
#line 33562 "gram.c" /* yacc.c:1646  */
    break;

  case 438:
#line 3532 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_null", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 33570 "gram.c" /* yacc.c:1646  */
    break;

  case 439:
#line 3536 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_null", (Node *) makeNode(A_Star), (yylsp[-2]));
				}
#line 33578 "gram.c" /* yacc.c:1646  */
    break;

  case 440:
#line 3540 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 33586 "gram.c" /* yacc.c:1646  */
    break;

  case 441:
#line 3549 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *) makeString("binary"), (yylsp[0]));
				}
#line 33594 "gram.c" /* yacc.c:1646  */
    break;

  case 442:
#line 3552 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 33600 "gram.c" /* yacc.c:1646  */
    break;

  case 443:
#line 3557 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 33608 "gram.c" /* yacc.c:1646  */
    break;

  case 444:
#line 3560 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 33614 "gram.c" /* yacc.c:1646  */
    break;

  case 447:
#line 3571 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 33622 "gram.c" /* yacc.c:1646  */
    break;

  case 448:
#line 3575 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 33630 "gram.c" /* yacc.c:1646  */
    break;

  case 449:
#line 3582 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 33638 "gram.c" /* yacc.c:1646  */
    break;

  case 450:
#line 3588 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 33644 "gram.c" /* yacc.c:1646  */
    break;

  case 451:
#line 3589 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 33650 "gram.c" /* yacc.c:1646  */
    break;

  case 452:
#line 3590 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeNode(A_Star); }
#line 33656 "gram.c" /* yacc.c:1646  */
    break;

  case 453:
#line 3591 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString("default"); }
#line 33662 "gram.c" /* yacc.c:1646  */
    break;

  case 454:
#line 3592 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 33668 "gram.c" /* yacc.c:1646  */
    break;

  case 455:
#line 3593 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 33674 "gram.c" /* yacc.c:1646  */
    break;

  case 456:
#line 3598 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 33682 "gram.c" /* yacc.c:1646  */
    break;

  case 457:
#line 3602 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 33690 "gram.c" /* yacc.c:1646  */
    break;

  case 458:
#line 3609 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 33696 "gram.c" /* yacc.c:1646  */
    break;

  case 459:
#line 3623 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-9].range)->relpersistence = (yyvsp[-11].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-7].list);
					n->inhRelations = (yyvsp[-5].list);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 33718 "gram.c" /* yacc.c:1646  */
    break;

  case 460:
#line 3643 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-9].range)->relpersistence = (yyvsp[-14].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-7].list);
					n->inhRelations = (yyvsp[-5].list);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 33740 "gram.c" /* yacc.c:1646  */
    break;

  case 461:
#line 3663 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-8].range)->relpersistence = (yyvsp[-10].ival);
					n->relation = (yyvsp[-8].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = NIL;
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-6].list));
					n->ofTypename->location = (yylsp[-6]);
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 33763 "gram.c" /* yacc.c:1646  */
    break;

  case 462:
#line 3684 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-8].range)->relpersistence = (yyvsp[-13].ival);
					n->relation = (yyvsp[-8].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = NIL;
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-6].list));
					n->ofTypename->location = (yylsp[-6]);
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 33786 "gram.c" /* yacc.c:1646  */
    break;

  case 463:
#line 3705 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-10].range)->relpersistence = (yyvsp[-12].ival);
					n->relation = (yyvsp[-10].range);
					n->tableElts = (yyvsp[-6].list);
					n->inhRelations = list_make1((yyvsp[-7].range));
					n->partbound = (yyvsp[-5].partboundspec);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 33809 "gram.c" /* yacc.c:1646  */
    break;

  case 464:
#line 3726 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-10].range)->relpersistence = (yyvsp[-15].ival);
					n->relation = (yyvsp[-10].range);
					n->tableElts = (yyvsp[-6].list);
					n->inhRelations = list_make1((yyvsp[-7].range));
					n->partbound = (yyvsp[-5].partboundspec);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 33832 "gram.c" /* yacc.c:1646  */
    break;

  case 465:
#line 3757 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 33838 "gram.c" /* yacc.c:1646  */
    break;

  case 466:
#line 3758 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 33844 "gram.c" /* yacc.c:1646  */
    break;

  case 467:
#line 3759 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 33850 "gram.c" /* yacc.c:1646  */
    break;

  case 468:
#line 3760 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 33856 "gram.c" /* yacc.c:1646  */
    break;

  case 469:
#line 3762 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 33867 "gram.c" /* yacc.c:1646  */
    break;

  case 470:
#line 3769 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 33878 "gram.c" /* yacc.c:1646  */
    break;

  case 471:
#line 3775 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 33884 "gram.c" /* yacc.c:1646  */
    break;

  case 472:
#line 3776 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 33890 "gram.c" /* yacc.c:1646  */
    break;

  case 473:
#line 3780 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33896 "gram.c" /* yacc.c:1646  */
    break;

  case 474:
#line 3781 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33902 "gram.c" /* yacc.c:1646  */
    break;

  case 475:
#line 3785 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 33908 "gram.c" /* yacc.c:1646  */
    break;

  case 476:
#line 3786 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33914 "gram.c" /* yacc.c:1646  */
    break;

  case 477:
#line 3791 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 33922 "gram.c" /* yacc.c:1646  */
    break;

  case 478:
#line 3795 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 33930 "gram.c" /* yacc.c:1646  */
    break;

  case 479:
#line 3802 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 33938 "gram.c" /* yacc.c:1646  */
    break;

  case 480:
#line 3806 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 33946 "gram.c" /* yacc.c:1646  */
    break;

  case 481:
#line 3812 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 33952 "gram.c" /* yacc.c:1646  */
    break;

  case 482:
#line 3813 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 33958 "gram.c" /* yacc.c:1646  */
    break;

  case 483:
#line 3814 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 33964 "gram.c" /* yacc.c:1646  */
    break;

  case 484:
#line 3818 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 33970 "gram.c" /* yacc.c:1646  */
    break;

  case 485:
#line 3819 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 33976 "gram.c" /* yacc.c:1646  */
    break;

  case 486:
#line 3823 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-5].str);
					n->typeName = (yyvsp[-4].typnam);
					n->storage_name = (yyvsp[-3].str);
					n->compression = (yyvsp[-2].str);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					n->fdwoptions = (yyvsp[-1].list);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 34002 "gram.c" /* yacc.c:1646  */
    break;

  case 487:
#line 3847 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-1].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 34025 "gram.c" /* yacc.c:1646  */
    break;

  case 488:
#line 3866 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-3].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 34048 "gram.c" /* yacc.c:1646  */
    break;

  case 489:
#line 3887 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34054 "gram.c" /* yacc.c:1646  */
    break;

  case 490:
#line 3888 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup("default"); }
#line 34060 "gram.c" /* yacc.c:1646  */
    break;

  case 491:
#line 3892 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34066 "gram.c" /* yacc.c:1646  */
    break;

  case 492:
#line 3893 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 34072 "gram.c" /* yacc.c:1646  */
    break;

  case 493:
#line 3897 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34078 "gram.c" /* yacc.c:1646  */
    break;

  case 494:
#line 3898 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup("default"); }
#line 34084 "gram.c" /* yacc.c:1646  */
    break;

  case 495:
#line 3902 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34090 "gram.c" /* yacc.c:1646  */
    break;

  case 496:
#line 3903 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 34096 "gram.c" /* yacc.c:1646  */
    break;

  case 497:
#line 3907 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 34102 "gram.c" /* yacc.c:1646  */
    break;

  case 498:
#line 3908 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34108 "gram.c" /* yacc.c:1646  */
    break;

  case 499:
#line 3913 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));

					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 34120 "gram.c" /* yacc.c:1646  */
    break;

  case 500:
#line 3920 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34126 "gram.c" /* yacc.c:1646  */
    break;

  case 501:
#line 3921 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34132 "gram.c" /* yacc.c:1646  */
    break;

  case 502:
#line 3923 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Note: the CollateClause is momentarily included in
					 * the list built by ColQualList, but we split it out
					 * again in SplitColQualList.
					 */
					CollateClause *n = makeNode(CollateClause);

					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 34150 "gram.c" /* yacc.c:1646  */
    break;

  case 503:
#line 3955 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 34162 "gram.c" /* yacc.c:1646  */
    break;

  case 504:
#line 3963 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 34174 "gram.c" /* yacc.c:1646  */
    break;

  case 505:
#line 3971 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-3]);
					n->nulls_not_distinct = !(yyvsp[-2].boolean);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34191 "gram.c" /* yacc.c:1646  */
    break;

  case 506:
#line 3984 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34207 "gram.c" /* yacc.c:1646  */
    break;

  case 507:
#line 3996 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->is_no_inherit = (yyvsp[0].boolean);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *) n;
				}
#line 34224 "gram.c" /* yacc.c:1646  */
    break;

  case 508:
#line 4009 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_DEFAULT;
					n->location = (yylsp[-1]);
					n->raw_expr = (yyvsp[0].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *) n;
				}
#line 34238 "gram.c" /* yacc.c:1646  */
    break;

  case 509:
#line 4019 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_IDENTITY;
					n->generated_when = (yyvsp[-3].ival);
					n->options = (yyvsp[0].list);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 34252 "gram.c" /* yacc.c:1646  */
    break;

  case 510:
#line 4029 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_GENERATED;
					n->generated_when = (yyvsp[-5].ival);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					n->location = (yylsp[-6]);

					/*
					 * Can't do this in the grammar because of shift/reduce
					 * conflicts.  (IDENTITY allows both ALWAYS and BY
					 * DEFAULT, but generated columns only allow ALWAYS.)  We
					 * can also give a more useful error message and location.
					 */
					if ((yyvsp[-5].ival) != ATTRIBUTE_IDENTITY_ALWAYS)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("for a generated column, GENERATED ALWAYS must be specified"),
								 parser_errposition((yylsp[-5]))));

					(yyval.node) = (Node *) n;
				}
#line 34280 "gram.c" /* yacc.c:1646  */
    break;

  case 511:
#line 4053 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-4]);
					n->pktable = (yyvsp[-3].range);
					n->fk_attrs = NIL;
					n->pk_attrs = (yyvsp[-2].list);
					n->fk_matchtype = (yyvsp[-1].ival);
					n->fk_upd_action = ((yyvsp[0].keyactions))->updateAction->action;
					n->fk_del_action = ((yyvsp[0].keyactions))->deleteAction->action;
					n->fk_del_set_cols = ((yyvsp[0].keyactions))->deleteAction->cols;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *) n;
				}
#line 34301 "gram.c" /* yacc.c:1646  */
    break;

  case 512:
#line 4072 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 34307 "gram.c" /* yacc.c:1646  */
    break;

  case 513:
#line 4073 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 34313 "gram.c" /* yacc.c:1646  */
    break;

  case 514:
#line 4074 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 34319 "gram.c" /* yacc.c:1646  */
    break;

  case 515:
#line 4078 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ATTRIBUTE_IDENTITY_ALWAYS; }
#line 34325 "gram.c" /* yacc.c:1646  */
    break;

  case 516:
#line 4079 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ATTRIBUTE_IDENTITY_BY_DEFAULT; }
#line 34331 "gram.c" /* yacc.c:1646  */
    break;

  case 517:
#line 4099 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_DEFERRABLE;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 34343 "gram.c" /* yacc.c:1646  */
    break;

  case 518:
#line 4107 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 34355 "gram.c" /* yacc.c:1646  */
    break;

  case 519:
#line 4115 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_DEFERRED;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 34367 "gram.c" /* yacc.c:1646  */
    break;

  case 520:
#line 4123 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_IMMEDIATE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 34379 "gram.c" /* yacc.c:1646  */
    break;

  case 521:
#line 4135 "gram.y" /* yacc.c:1646  */
    {
					TableLikeClause *n = makeNode(TableLikeClause);

					n->relation = (yyvsp[-1].range);
					n->options = (yyvsp[0].ival);
					n->relationOid = InvalidOid;
					(yyval.node) = (Node *) n;
				}
#line 34392 "gram.c" /* yacc.c:1646  */
    break;

  case 522:
#line 4146 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 34398 "gram.c" /* yacc.c:1646  */
    break;

  case 523:
#line 4147 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) & ~(yyvsp[0].ival); }
#line 34404 "gram.c" /* yacc.c:1646  */
    break;

  case 524:
#line 4148 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 34410 "gram.c" /* yacc.c:1646  */
    break;

  case 525:
#line 4152 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_COMMENTS; }
#line 34416 "gram.c" /* yacc.c:1646  */
    break;

  case 526:
#line 4153 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_COMPRESSION; }
#line 34422 "gram.c" /* yacc.c:1646  */
    break;

  case 527:
#line 4154 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_CONSTRAINTS; }
#line 34428 "gram.c" /* yacc.c:1646  */
    break;

  case 528:
#line 4155 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_DEFAULTS; }
#line 34434 "gram.c" /* yacc.c:1646  */
    break;

  case 529:
#line 4156 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_IDENTITY; }
#line 34440 "gram.c" /* yacc.c:1646  */
    break;

  case 530:
#line 4157 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_GENERATED; }
#line 34446 "gram.c" /* yacc.c:1646  */
    break;

  case 531:
#line 4158 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_INDEXES; }
#line 34452 "gram.c" /* yacc.c:1646  */
    break;

  case 532:
#line 4159 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_STATISTICS; }
#line 34458 "gram.c" /* yacc.c:1646  */
    break;

  case 533:
#line 4160 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_STORAGE; }
#line 34464 "gram.c" /* yacc.c:1646  */
    break;

  case 534:
#line 4161 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_ALL; }
#line 34470 "gram.c" /* yacc.c:1646  */
    break;

  case 535:
#line 4171 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));

					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 34482 "gram.c" /* yacc.c:1646  */
    break;

  case 536:
#line 4178 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34488 "gram.c" /* yacc.c:1646  */
    break;

  case 537:
#line 4183 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "CHECK",
								   NULL, NULL, &n->skip_validation,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *) n;
				}
#line 34506 "gram.c" /* yacc.c:1646  */
    break;

  case 538:
#line 4198 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-8]);
					n->nulls_not_distinct = !(yyvsp[-7].boolean);
					n->keys = (yyvsp[-5].list);
					n->including = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 34527 "gram.c" /* yacc.c:1646  */
    break;

  case 539:
#line 4215 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NIL;
					n->including = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 34547 "gram.c" /* yacc.c:1646  */
    break;

  case 540:
#line 4232 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-8]);
					n->keys = (yyvsp[-5].list);
					n->including = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 34567 "gram.c" /* yacc.c:1646  */
    break;

  case 541:
#line 4248 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NIL;
					n->including = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 34587 "gram.c" /* yacc.c:1646  */
    break;

  case 542:
#line 4266 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_EXCLUSION;
					n->location = (yylsp[-9]);
					n->access_method = (yyvsp[-8].str);
					n->exclusions = (yyvsp[-6].list);
					n->including = (yyvsp[-4].list);
					n->options = (yyvsp[-3].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-2].str);
					n->where_clause = (yyvsp[-1].node);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "EXCLUDE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 34609 "gram.c" /* yacc.c:1646  */
    break;

  case 543:
#line 4285 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-10]);
					n->pktable = (yyvsp[-4].range);
					n->fk_attrs = (yyvsp[-7].list);
					n->pk_attrs = (yyvsp[-3].list);
					n->fk_matchtype = (yyvsp[-2].ival);
					n->fk_upd_action = ((yyvsp[-1].keyactions))->updateAction->action;
					n->fk_del_action = ((yyvsp[-1].keyactions))->deleteAction->action;
					n->fk_del_set_cols = ((yyvsp[-1].keyactions))->deleteAction->cols;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "FOREIGN KEY",
								   &n->deferrable, &n->initdeferred,
								   &n->skip_validation, NULL,
								   yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *) n;
				}
#line 34633 "gram.c" /* yacc.c:1646  */
    break;

  case 544:
#line 4319 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));

					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 34645 "gram.c" /* yacc.c:1646  */
    break;

  case 545:
#line 4326 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34651 "gram.c" /* yacc.c:1646  */
    break;

  case 546:
#line 4331 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "CHECK",
								   NULL, NULL, &n->skip_validation,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *) n;
				}
#line 34669 "gram.c" /* yacc.c:1646  */
    break;

  case 547:
#line 4345 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[-2]);
					n->keys = list_make1(makeString("value"));
					/* no NOT VALID support yet */
					processCASbits((yyvsp[0].ival), (yylsp[0]), "NOT NULL",
								   NULL, NULL, NULL,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = true;
					(yyval.node) = (Node *) n;
				}
#line 34687 "gram.c" /* yacc.c:1646  */
    break;

  case 548:
#line 4360 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = true; }
#line 34693 "gram.c" /* yacc.c:1646  */
    break;

  case 549:
#line 4361 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = false; }
#line 34699 "gram.c" /* yacc.c:1646  */
    break;

  case 550:
#line 4365 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 34705 "gram.c" /* yacc.c:1646  */
    break;

  case 551:
#line 4366 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34711 "gram.c" /* yacc.c:1646  */
    break;

  case 552:
#line 4370 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 34717 "gram.c" /* yacc.c:1646  */
    break;

  case 553:
#line 4371 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 34723 "gram.c" /* yacc.c:1646  */
    break;

  case 554:
#line 4375 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 34731 "gram.c" /* yacc.c:1646  */
    break;

  case 555:
#line 4380 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 34737 "gram.c" /* yacc.c:1646  */
    break;

  case 556:
#line 4381 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34743 "gram.c" /* yacc.c:1646  */
    break;

  case 557:
#line 4385 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			}
#line 34751 "gram.c" /* yacc.c:1646  */
    break;

  case 558:
#line 4389 "gram.y" /* yacc.c:1646  */
    {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 parser_errposition((yylsp[-1]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			}
#line 34763 "gram.c" /* yacc.c:1646  */
    break;

  case 559:
#line 4397 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 34771 "gram.c" /* yacc.c:1646  */
    break;

  case 560:
#line 4401 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 34779 "gram.c" /* yacc.c:1646  */
    break;

  case 561:
#line 4407 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 34785 "gram.c" /* yacc.c:1646  */
    break;

  case 562:
#line 4409 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 34791 "gram.c" /* yacc.c:1646  */
    break;

  case 563:
#line 4413 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-2].ielem), (yyvsp[0].list));
			}
#line 34799 "gram.c" /* yacc.c:1646  */
    break;

  case 564:
#line 4418 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-5].ielem), (yyvsp[-1].list));
			}
#line 34807 "gram.c" /* yacc.c:1646  */
    break;

  case 565:
#line 4424 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 34813 "gram.c" /* yacc.c:1646  */
    break;

  case 566:
#line 4425 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 34819 "gram.c" /* yacc.c:1646  */
    break;

  case 567:
#line 4430 "gram.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = (yyvsp[0].keyaction);
					n->deleteAction = palloc(sizeof(KeyAction));
					n->deleteAction->action = FKCONSTR_ACTION_NOACTION;
					n->deleteAction->cols = NIL;
					(yyval.keyactions) = n;
				}
#line 34833 "gram.c" /* yacc.c:1646  */
    break;

  case 568:
#line 4440 "gram.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = palloc(sizeof(KeyAction));
					n->updateAction->action = FKCONSTR_ACTION_NOACTION;
					n->updateAction->cols = NIL;
					n->deleteAction = (yyvsp[0].keyaction);
					(yyval.keyactions) = n;
				}
#line 34847 "gram.c" /* yacc.c:1646  */
    break;

  case 569:
#line 4450 "gram.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = (yyvsp[-1].keyaction);
					n->deleteAction = (yyvsp[0].keyaction);
					(yyval.keyactions) = n;
				}
#line 34859 "gram.c" /* yacc.c:1646  */
    break;

  case 570:
#line 4458 "gram.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = (yyvsp[0].keyaction);
					n->deleteAction = (yyvsp[-1].keyaction);
					(yyval.keyactions) = n;
				}
#line 34871 "gram.c" /* yacc.c:1646  */
    break;

  case 571:
#line 4466 "gram.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = palloc(sizeof(KeyAction));
					n->updateAction->action = FKCONSTR_ACTION_NOACTION;
					n->updateAction->cols = NIL;
					n->deleteAction = palloc(sizeof(KeyAction));
					n->deleteAction->action = FKCONSTR_ACTION_NOACTION;
					n->deleteAction->cols = NIL;
					(yyval.keyactions) = n;
				}
#line 34887 "gram.c" /* yacc.c:1646  */
    break;

  case 572:
#line 4480 "gram.y" /* yacc.c:1646  */
    {
					if (((yyvsp[0].keyaction))->cols)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("a column list with %s is only supported for ON DELETE actions",
										((yyvsp[0].keyaction))->action == FKCONSTR_ACTION_SETNULL ? "SET NULL" : "SET DEFAULT"),
								 parser_errposition((yylsp[-2]))));
					(yyval.keyaction) = (yyvsp[0].keyaction);
				}
#line 34901 "gram.c" /* yacc.c:1646  */
    break;

  case 573:
#line 4492 "gram.y" /* yacc.c:1646  */
    {
					(yyval.keyaction) = (yyvsp[0].keyaction);
				}
#line 34909 "gram.c" /* yacc.c:1646  */
    break;

  case 574:
#line 4499 "gram.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_NOACTION;
					n->cols = NIL;
					(yyval.keyaction) = n;
				}
#line 34921 "gram.c" /* yacc.c:1646  */
    break;

  case 575:
#line 4507 "gram.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_RESTRICT;
					n->cols = NIL;
					(yyval.keyaction) = n;
				}
#line 34933 "gram.c" /* yacc.c:1646  */
    break;

  case 576:
#line 4515 "gram.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_CASCADE;
					n->cols = NIL;
					(yyval.keyaction) = n;
				}
#line 34945 "gram.c" /* yacc.c:1646  */
    break;

  case 577:
#line 4523 "gram.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_SETNULL;
					n->cols = (yyvsp[0].list);
					(yyval.keyaction) = n;
				}
#line 34957 "gram.c" /* yacc.c:1646  */
    break;

  case 578:
#line 4531 "gram.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_SETDEFAULT;
					n->cols = (yyvsp[0].list);
					(yyval.keyaction) = n;
				}
#line 34969 "gram.c" /* yacc.c:1646  */
    break;

  case 579:
#line 4540 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 34975 "gram.c" /* yacc.c:1646  */
    break;

  case 580:
#line 4541 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34981 "gram.c" /* yacc.c:1646  */
    break;

  case 581:
#line 4545 "gram.y" /* yacc.c:1646  */
    { (yyval.partspec) = (yyvsp[0].partspec); }
#line 34987 "gram.c" /* yacc.c:1646  */
    break;

  case 582:
#line 4546 "gram.y" /* yacc.c:1646  */
    { (yyval.partspec) = NULL; }
#line 34993 "gram.c" /* yacc.c:1646  */
    break;

  case 583:
#line 4550 "gram.y" /* yacc.c:1646  */
    {
					PartitionSpec *n = makeNode(PartitionSpec);

					n->strategy = parsePartitionStrategy((yyvsp[-3].str));
					n->partParams = (yyvsp[-1].list);
					n->location = (yylsp[-5]);

					(yyval.partspec) = n;
				}
#line 35007 "gram.c" /* yacc.c:1646  */
    break;

  case 584:
#line 4561 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].partelem)); }
#line 35013 "gram.c" /* yacc.c:1646  */
    break;

  case 585:
#line 4562 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].partelem)); }
#line 35019 "gram.c" /* yacc.c:1646  */
    break;

  case 586:
#line 4566 "gram.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = (yyvsp[-2].str);
					n->expr = NULL;
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-2]);
					(yyval.partelem) = n;
				}
#line 35034 "gram.c" /* yacc.c:1646  */
    break;

  case 587:
#line 4577 "gram.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = NULL;
					n->expr = (yyvsp[-2].node);
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-2]);
					(yyval.partelem) = n;
				}
#line 35049 "gram.c" /* yacc.c:1646  */
    break;

  case 588:
#line 4588 "gram.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = NULL;
					n->expr = (yyvsp[-3].node);
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-4]);
					(yyval.partelem) = n;
				}
#line 35064 "gram.c" /* yacc.c:1646  */
    break;

  case 589:
#line 4601 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35070 "gram.c" /* yacc.c:1646  */
    break;

  case 590:
#line 4602 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 35076 "gram.c" /* yacc.c:1646  */
    break;

  case 591:
#line 4607 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35082 "gram.c" /* yacc.c:1646  */
    break;

  case 592:
#line 4608 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35088 "gram.c" /* yacc.c:1646  */
    break;

  case 593:
#line 4609 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35094 "gram.c" /* yacc.c:1646  */
    break;

  case 594:
#line 4612 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DROP; }
#line 35100 "gram.c" /* yacc.c:1646  */
    break;

  case 595:
#line 4613 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; }
#line 35106 "gram.c" /* yacc.c:1646  */
    break;

  case 596:
#line 4614 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; }
#line 35112 "gram.c" /* yacc.c:1646  */
    break;

  case 597:
#line 4615 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_NOOP; }
#line 35118 "gram.c" /* yacc.c:1646  */
    break;

  case 598:
#line 4618 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35124 "gram.c" /* yacc.c:1646  */
    break;

  case 599:
#line 4619 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 35130 "gram.c" /* yacc.c:1646  */
    break;

  case 600:
#line 4622 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35136 "gram.c" /* yacc.c:1646  */
    break;

  case 601:
#line 4623 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 35142 "gram.c" /* yacc.c:1646  */
    break;

  case 602:
#line 4626 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35148 "gram.c" /* yacc.c:1646  */
    break;

  case 603:
#line 4648 "gram.y" /* yacc.c:1646  */
    {
					CreateStatsStmt *n = makeNode(CreateStatsStmt);

					n->defnames = (yyvsp[-5].list);
					n->stat_types = (yyvsp[-4].list);
					n->exprs = (yyvsp[-2].list);
					n->relations = (yyvsp[0].list);
					n->stxcomment = NULL;
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 35164 "gram.c" /* yacc.c:1646  */
    break;

  case 604:
#line 4661 "gram.y" /* yacc.c:1646  */
    {
					CreateStatsStmt *n = makeNode(CreateStatsStmt);

					n->defnames = (yyvsp[-5].list);
					n->stat_types = (yyvsp[-4].list);
					n->exprs = (yyvsp[-2].list);
					n->relations = (yyvsp[0].list);
					n->stxcomment = NULL;
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 35180 "gram.c" /* yacc.c:1646  */
    break;

  case 605:
#line 4681 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].selem)); }
#line 35186 "gram.c" /* yacc.c:1646  */
    break;

  case 606:
#line 4682 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].selem)); }
#line 35192 "gram.c" /* yacc.c:1646  */
    break;

  case 607:
#line 4686 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = (yyvsp[0].str);
					(yyval.selem)->expr = NULL;
				}
#line 35202 "gram.c" /* yacc.c:1646  */
    break;

  case 608:
#line 4692 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = NULL;
					(yyval.selem)->expr = (yyvsp[0].node);
				}
#line 35212 "gram.c" /* yacc.c:1646  */
    break;

  case 609:
#line 4698 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = NULL;
					(yyval.selem)->expr = (yyvsp[-1].node);
				}
#line 35222 "gram.c" /* yacc.c:1646  */
    break;

  case 610:
#line 4715 "gram.y" /* yacc.c:1646  */
    {
					AlterStatsStmt *n = makeNode(AlterStatsStmt);

					n->defnames = (yyvsp[-3].list);
					n->missing_ok = false;
					n->stxstattarget = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 35235 "gram.c" /* yacc.c:1646  */
    break;

  case 611:
#line 4724 "gram.y" /* yacc.c:1646  */
    {
					AlterStatsStmt *n = makeNode(AlterStatsStmt);

					n->defnames = (yyvsp[-3].list);
					n->missing_ok = true;
					n->stxstattarget = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 35248 "gram.c" /* yacc.c:1646  */
    break;

  case 612:
#line 4746 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-5].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 35266 "gram.c" /* yacc.c:1646  */
    break;

  case 613:
#line 4760 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-8].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 35284 "gram.c" /* yacc.c:1646  */
    break;

  case 614:
#line 4778 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-5].range);
					(yyval.into)->colNames = (yyvsp[-4].list);
					(yyval.into)->accessMethod = (yyvsp[-3].str);
					(yyval.into)->options = (yyvsp[-2].list);
					(yyval.into)->onCommit = (yyvsp[-1].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 35300 "gram.c" /* yacc.c:1646  */
    break;

  case 615:
#line 4792 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 35306 "gram.c" /* yacc.c:1646  */
    break;

  case 616:
#line 4793 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 35312 "gram.c" /* yacc.c:1646  */
    break;

  case 617:
#line 4794 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 35318 "gram.c" /* yacc.c:1646  */
    break;

  case 618:
#line 4807 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-6].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 35336 "gram.c" /* yacc.c:1646  */
    break;

  case 619:
#line 4821 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-9].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 35354 "gram.c" /* yacc.c:1646  */
    break;

  case 620:
#line 4838 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-4].range);
					(yyval.into)->colNames = (yyvsp[-3].list);
					(yyval.into)->accessMethod = (yyvsp[-2].str);
					(yyval.into)->options = (yyvsp[-1].list);
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;		/* filled at analysis time */
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 35370 "gram.c" /* yacc.c:1646  */
    break;

  case 621:
#line 4851 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 35376 "gram.c" /* yacc.c:1646  */
    break;

  case 622:
#line 4852 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 35382 "gram.c" /* yacc.c:1646  */
    break;

  case 623:
#line 4865 "gram.y" /* yacc.c:1646  */
    {
					RefreshMatViewStmt *n = makeNode(RefreshMatViewStmt);

					n->concurrent = (yyvsp[-2].boolean);
					n->relation = (yyvsp[-1].range);
					n->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) n;
				}
#line 35395 "gram.c" /* yacc.c:1646  */
    break;

  case 624:
#line 4886 "gram.y" /* yacc.c:1646  */
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);

					(yyvsp[-1].range)->relpersistence = (yyvsp[-3].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 35410 "gram.c" /* yacc.c:1646  */
    break;

  case 625:
#line 4897 "gram.y" /* yacc.c:1646  */
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);

					(yyvsp[-1].range)->relpersistence = (yyvsp[-6].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 35425 "gram.c" /* yacc.c:1646  */
    break;

  case 626:
#line 4911 "gram.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);

					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 35438 "gram.c" /* yacc.c:1646  */
    break;

  case 627:
#line 4920 "gram.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);

					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 35451 "gram.c" /* yacc.c:1646  */
    break;

  case 628:
#line 4931 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35457 "gram.c" /* yacc.c:1646  */
    break;

  case 629:
#line 4932 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35463 "gram.c" /* yacc.c:1646  */
    break;

  case 630:
#line 4935 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35469 "gram.c" /* yacc.c:1646  */
    break;

  case 631:
#line 4936 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35475 "gram.c" /* yacc.c:1646  */
    break;

  case 632:
#line 4939 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 35481 "gram.c" /* yacc.c:1646  */
    break;

  case 633:
#line 4940 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 35487 "gram.c" /* yacc.c:1646  */
    break;

  case 634:
#line 4944 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *) (yyvsp[0].typnam), (yylsp[-1]));
				}
#line 35495 "gram.c" /* yacc.c:1646  */
    break;

  case 635:
#line 4948 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cache", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 35503 "gram.c" /* yacc.c:1646  */
    break;

  case 636:
#line 4952 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 35511 "gram.c" /* yacc.c:1646  */
    break;

  case 637:
#line 4956 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *) makeBoolean(false), (yylsp[-1]));
				}
#line 35519 "gram.c" /* yacc.c:1646  */
    break;

  case 638:
#line 4960 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("increment", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 35527 "gram.c" /* yacc.c:1646  */
    break;

  case 639:
#line 4964 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 35535 "gram.c" /* yacc.c:1646  */
    break;

  case 640:
#line 4968 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 35543 "gram.c" /* yacc.c:1646  */
    break;

  case 641:
#line 4972 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", NULL, (yylsp[-1]));
				}
#line 35551 "gram.c" /* yacc.c:1646  */
    break;

  case 642:
#line 4976 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", NULL, (yylsp[-1]));
				}
#line 35559 "gram.c" /* yacc.c:1646  */
    break;

  case 643:
#line 4980 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("owned_by", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 35567 "gram.c" /* yacc.c:1646  */
    break;

  case 644:
#line 4984 "gram.y" /* yacc.c:1646  */
    {
					/* not documented, only used by pg_dump */
					(yyval.defelt) = makeDefElem("sequence_name", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 35576 "gram.c" /* yacc.c:1646  */
    break;

  case 645:
#line 4989 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("start", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 35584 "gram.c" /* yacc.c:1646  */
    break;

  case 646:
#line 4993 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", NULL, (yylsp[0]));
				}
#line 35592 "gram.c" /* yacc.c:1646  */
    break;

  case 647:
#line 4997 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 35600 "gram.c" /* yacc.c:1646  */
    break;

  case 650:
#line 5007 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeFloat((yyvsp[0].str)); }
#line 35606 "gram.c" /* yacc.c:1646  */
    break;

  case 651:
#line 5008 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeFloat((yyvsp[0].str)); }
#line 35612 "gram.c" /* yacc.c:1646  */
    break;

  case 652:
#line 5010 "gram.y" /* yacc.c:1646  */
    {
					Float	   *f = makeFloat((yyvsp[0].str));

					doNegateFloat(f);
					(yyval.node) = (Node *) f;
				}
#line 35623 "gram.c" /* yacc.c:1646  */
    break;

  case 653:
#line 5016 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeInteger((yyvsp[0].ival)); }
#line 35629 "gram.c" /* yacc.c:1646  */
    break;

  case 654:
#line 5019 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 35635 "gram.c" /* yacc.c:1646  */
    break;

  case 655:
#line 5020 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 35641 "gram.c" /* yacc.c:1646  */
    break;

  case 656:
#line 5033 "gram.y" /* yacc.c:1646  */
    {
				/*
				 * We now interpret parameterless CREATE LANGUAGE as
				 * CREATE EXTENSION.  "OR REPLACE" is silently translated
				 * to "IF NOT EXISTS", which isn't quite the same, but
				 * seems more useful than throwing an error.  We just
				 * ignore TRUSTED, as the previous code would have too.
				 */
				CreateExtensionStmt *n = makeNode(CreateExtensionStmt);

				n->if_not_exists = (yyvsp[-4].boolean);
				n->extname = (yyvsp[0].str);
				n->options = NIL;
				(yyval.node) = (Node *) n;
			}
#line 35661 "gram.c" /* yacc.c:1646  */
    break;

  case 657:
#line 5050 "gram.y" /* yacc.c:1646  */
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);

				n->replace = (yyvsp[-8].boolean);
				n->plname = (yyvsp[-4].str);
				n->plhandler = (yyvsp[-2].list);
				n->plinline = (yyvsp[-1].list);
				n->plvalidator = (yyvsp[0].list);
				n->pltrusted = (yyvsp[-7].boolean);
				(yyval.node) = (Node *) n;
			}
#line 35677 "gram.c" /* yacc.c:1646  */
    break;

  case 658:
#line 5064 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 35683 "gram.c" /* yacc.c:1646  */
    break;

  case 659:
#line 5065 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 35689 "gram.c" /* yacc.c:1646  */
    break;

  case 660:
#line 5073 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 35695 "gram.c" /* yacc.c:1646  */
    break;

  case 661:
#line 5074 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 35701 "gram.c" /* yacc.c:1646  */
    break;

  case 662:
#line 5078 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35707 "gram.c" /* yacc.c:1646  */
    break;

  case 663:
#line 5079 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35713 "gram.c" /* yacc.c:1646  */
    break;

  case 664:
#line 5083 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35719 "gram.c" /* yacc.c:1646  */
    break;

  case 665:
#line 5084 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35725 "gram.c" /* yacc.c:1646  */
    break;

  case 666:
#line 5088 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35731 "gram.c" /* yacc.c:1646  */
    break;

  case 667:
#line 5089 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35737 "gram.c" /* yacc.c:1646  */
    break;

  case 670:
#line 5105 "gram.y" /* yacc.c:1646  */
    {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);

					n->tablespacename = (yyvsp[-4].str);
					n->owner = (yyvsp[-3].rolespec);
					n->location = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35751 "gram.c" /* yacc.c:1646  */
    break;

  case 671:
#line 5116 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 35757 "gram.c" /* yacc.c:1646  */
    break;

  case 672:
#line 5117 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = NULL; }
#line 35763 "gram.c" /* yacc.c:1646  */
    break;

  case 673:
#line 5131 "gram.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);

					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 35775 "gram.c" /* yacc.c:1646  */
    break;

  case 674:
#line 5139 "gram.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);

					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 35787 "gram.c" /* yacc.c:1646  */
    break;

  case 675:
#line 5157 "gram.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);

					n->extname = (yyvsp[-2].str);
					n->if_not_exists = false;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35800 "gram.c" /* yacc.c:1646  */
    break;

  case 676:
#line 5166 "gram.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);

					n->extname = (yyvsp[-2].str);
					n->if_not_exists = true;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35813 "gram.c" /* yacc.c:1646  */
    break;

  case 677:
#line 5178 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 35819 "gram.c" /* yacc.c:1646  */
    break;

  case 678:
#line 5180 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35825 "gram.c" /* yacc.c:1646  */
    break;

  case 679:
#line 5185 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schema", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 35833 "gram.c" /* yacc.c:1646  */
    break;

  case 680:
#line 5189 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 35841 "gram.c" /* yacc.c:1646  */
    break;

  case 681:
#line 5193 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE EXTENSION ... FROM is no longer supported"),
							 parser_errposition((yylsp[-1]))));
				}
#line 35852 "gram.c" /* yacc.c:1646  */
    break;

  case 682:
#line 5200 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cascade", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 35860 "gram.c" /* yacc.c:1646  */
    break;

  case 683:
#line 5212 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionStmt *n = makeNode(AlterExtensionStmt);

					n->extname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35872 "gram.c" /* yacc.c:1646  */
    break;

  case 684:
#line 5223 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 35878 "gram.c" /* yacc.c:1646  */
    break;

  case 685:
#line 5225 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35884 "gram.c" /* yacc.c:1646  */
    break;

  case 686:
#line 5230 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 35892 "gram.c" /* yacc.c:1646  */
    break;

  case 687:
#line 5243 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = (yyvsp[-1].objtype);
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *) n;
				}
#line 35906 "gram.c" /* yacc.c:1646  */
    break;

  case 688:
#line 5253 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = (yyvsp[-1].objtype);
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35920 "gram.c" /* yacc.c:1646  */
    break;

  case 689:
#line 5263 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 35934 "gram.c" /* yacc.c:1646  */
    break;

  case 690:
#line 5273 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-7].str);
					n->action = (yyvsp[-6].ival);
					n->objtype = OBJECT_CAST;
					n->object = (Node *) list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam));
					(yyval.node) = (Node *) n;
				}
#line 35948 "gram.c" /* yacc.c:1646  */
    break;

  case 691:
#line 5283 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 35962 "gram.c" /* yacc.c:1646  */
    break;

  case 692:
#line 5293 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 35976 "gram.c" /* yacc.c:1646  */
    break;

  case 693:
#line 5303 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 35990 "gram.c" /* yacc.c:1646  */
    break;

  case 694:
#line 5313 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *) n;
				}
#line 36004 "gram.c" /* yacc.c:1646  */
    break;

  case 695:
#line 5323 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *) n;
				}
#line 36018 "gram.c" /* yacc.c:1646  */
    break;

  case 696:
#line 5333 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 36032 "gram.c" /* yacc.c:1646  */
    break;

  case 697:
#line 5343 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 36046 "gram.c" /* yacc.c:1646  */
    break;

  case 698:
#line 5353 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_TRANSFORM;
					n->object = (Node *) list_make2((yyvsp[-2].typnam), makeString((yyvsp[0].str)));
					(yyval.node) = (Node *) n;
				}
#line 36060 "gram.c" /* yacc.c:1646  */
    break;

  case 699:
#line 5363 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 36074 "gram.c" /* yacc.c:1646  */
    break;

  case 700:
#line 5382 "gram.y" /* yacc.c:1646  */
    {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);

					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36087 "gram.c" /* yacc.c:1646  */
    break;

  case 701:
#line 5393 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", (Node *) (yyvsp[0].list), (yylsp[-1])); }
#line 36093 "gram.c" /* yacc.c:1646  */
    break;

  case 702:
#line 5394 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", NULL, (yylsp[-1])); }
#line 36099 "gram.c" /* yacc.c:1646  */
    break;

  case 703:
#line 5395 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", (Node *) (yyvsp[0].list), (yylsp[-1])); }
#line 36105 "gram.c" /* yacc.c:1646  */
    break;

  case 704:
#line 5396 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", NULL, (yylsp[-1])); }
#line 36111 "gram.c" /* yacc.c:1646  */
    break;

  case 705:
#line 5400 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 36117 "gram.c" /* yacc.c:1646  */
    break;

  case 706:
#line 5401 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 36123 "gram.c" /* yacc.c:1646  */
    break;

  case 707:
#line 5405 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36129 "gram.c" /* yacc.c:1646  */
    break;

  case 708:
#line 5406 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36135 "gram.c" /* yacc.c:1646  */
    break;

  case 709:
#line 5417 "gram.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);

					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36148 "gram.c" /* yacc.c:1646  */
    break;

  case 710:
#line 5426 "gram.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);

					n->fdwname = (yyvsp[-1].str);
					n->func_options = (yyvsp[0].list);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 36161 "gram.c" /* yacc.c:1646  */
    break;

  case 711:
#line 5438 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 36167 "gram.c" /* yacc.c:1646  */
    break;

  case 712:
#line 5439 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36173 "gram.c" /* yacc.c:1646  */
    break;

  case 713:
#line 5444 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 36181 "gram.c" /* yacc.c:1646  */
    break;

  case 714:
#line 5448 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 36189 "gram.c" /* yacc.c:1646  */
    break;

  case 715:
#line 5455 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 36195 "gram.c" /* yacc.c:1646  */
    break;

  case 716:
#line 5460 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 36203 "gram.c" /* yacc.c:1646  */
    break;

  case 717:
#line 5464 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 36211 "gram.c" /* yacc.c:1646  */
    break;

  case 718:
#line 5471 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 36219 "gram.c" /* yacc.c:1646  */
    break;

  case 719:
#line 5475 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				}
#line 36228 "gram.c" /* yacc.c:1646  */
    break;

  case 720:
#line 5480 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				}
#line 36237 "gram.c" /* yacc.c:1646  */
    break;

  case 721:
#line 5485 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[0].str), NULL, DEFELEM_DROP, (yylsp[0]));
				}
#line 36245 "gram.c" /* yacc.c:1646  */
    break;

  case 722:
#line 5492 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 36253 "gram.c" /* yacc.c:1646  */
    break;

  case 723:
#line 5498 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36259 "gram.c" /* yacc.c:1646  */
    break;

  case 724:
#line 5503 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 36265 "gram.c" /* yacc.c:1646  */
    break;

  case 725:
#line 5515 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);

					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 36281 "gram.c" /* yacc.c:1646  */
    break;

  case 726:
#line 5528 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);

					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 36297 "gram.c" /* yacc.c:1646  */
    break;

  case 727:
#line 5542 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36303 "gram.c" /* yacc.c:1646  */
    break;

  case 728:
#line 5543 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 36309 "gram.c" /* yacc.c:1646  */
    break;

  case 729:
#line 5548 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36315 "gram.c" /* yacc.c:1646  */
    break;

  case 730:
#line 5549 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 36321 "gram.c" /* yacc.c:1646  */
    break;

  case 731:
#line 5553 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36327 "gram.c" /* yacc.c:1646  */
    break;

  case 732:
#line 5554 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 36333 "gram.c" /* yacc.c:1646  */
    break;

  case 733:
#line 5565 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);

					n->servername = (yyvsp[-2].str);
					n->version = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 36347 "gram.c" /* yacc.c:1646  */
    break;

  case 734:
#line 5575 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);

					n->servername = (yyvsp[-1].str);
					n->version = (yyvsp[0].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 36360 "gram.c" /* yacc.c:1646  */
    break;

  case 735:
#line 5584 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);

					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36372 "gram.c" /* yacc.c:1646  */
    break;

  case 736:
#line 5604 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36395 "gram.c" /* yacc.c:1646  */
    break;

  case 737:
#line 5625 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36418 "gram.c" /* yacc.c:1646  */
    break;

  case 738:
#line 5646 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-8].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-8].range);
					n->base.inhRelations = list_make1((yyvsp[-5].range));
					n->base.tableElts = (yyvsp[-4].list);
					n->base.partbound = (yyvsp[-3].partboundspec);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36442 "gram.c" /* yacc.c:1646  */
    break;

  case 739:
#line 5668 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-8].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-8].range);
					n->base.inhRelations = list_make1((yyvsp[-5].range));
					n->base.tableElts = (yyvsp[-4].list);
					n->base.partbound = (yyvsp[-3].partboundspec);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36466 "gram.c" /* yacc.c:1646  */
    break;

  case 740:
#line 5701 "gram.y" /* yacc.c:1646  */
    {
				ImportForeignSchemaStmt *n = makeNode(ImportForeignSchemaStmt);

				n->server_name = (yyvsp[-3].str);
				n->remote_schema = (yyvsp[-7].str);
				n->local_schema = (yyvsp[-1].str);
				n->list_type = (yyvsp[-6].importqual)->type;
				n->table_list = (yyvsp[-6].importqual)->table_names;
				n->options = (yyvsp[0].list);
				(yyval.node) = (Node *) n;
			}
#line 36482 "gram.c" /* yacc.c:1646  */
    break;

  case 741:
#line 5715 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FDW_IMPORT_SCHEMA_LIMIT_TO; }
#line 36488 "gram.c" /* yacc.c:1646  */
    break;

  case 742:
#line 5716 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FDW_IMPORT_SCHEMA_EXCEPT; }
#line 36494 "gram.c" /* yacc.c:1646  */
    break;

  case 743:
#line 5721 "gram.y" /* yacc.c:1646  */
    {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));

				n->type = (yyvsp[-3].ival);
				n->table_names = (yyvsp[-1].list);
				(yyval.importqual) = n;
			}
#line 36506 "gram.c" /* yacc.c:1646  */
    break;

  case 744:
#line 5729 "gram.y" /* yacc.c:1646  */
    {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));
				n->type = FDW_IMPORT_SCHEMA_ALL;
				n->table_names = NIL;
				(yyval.importqual) = n;
			}
#line 36517 "gram.c" /* yacc.c:1646  */
    break;

  case 745:
#line 5745 "gram.y" /* yacc.c:1646  */
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);

					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 36531 "gram.c" /* yacc.c:1646  */
    break;

  case 746:
#line 5755 "gram.y" /* yacc.c:1646  */
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);

					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 36545 "gram.c" /* yacc.c:1646  */
    break;

  case 747:
#line 5767 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 36551 "gram.c" /* yacc.c:1646  */
    break;

  case 748:
#line 5768 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0])); }
#line 36557 "gram.c" /* yacc.c:1646  */
    break;

  case 749:
#line 5781 "gram.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);

					n->user = (yyvsp[-2].rolespec);
					n->servername = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 36570 "gram.c" /* yacc.c:1646  */
    break;

  case 750:
#line 5790 "gram.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);

					n->user = (yyvsp[-2].rolespec);
					n->servername = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 36583 "gram.c" /* yacc.c:1646  */
    break;

  case 751:
#line 5808 "gram.y" /* yacc.c:1646  */
    {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);

					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36596 "gram.c" /* yacc.c:1646  */
    break;

  case 752:
#line 5835 "gram.y" /* yacc.c:1646  */
    {
					CreatePolicyStmt *n = makeNode(CreatePolicyStmt);

					n->policy_name = (yyvsp[-7].str);
					n->table = (yyvsp[-5].range);
					n->permissive = (yyvsp[-4].boolean);
					n->cmd_name = (yyvsp[-3].str);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 36613 "gram.c" /* yacc.c:1646  */
    break;

  case 753:
#line 5852 "gram.y" /* yacc.c:1646  */
    {
					AlterPolicyStmt *n = makeNode(AlterPolicyStmt);

					n->policy_name = (yyvsp[-5].str);
					n->table = (yyvsp[-3].range);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 36628 "gram.c" /* yacc.c:1646  */
    break;

  case 754:
#line 5865 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 36634 "gram.c" /* yacc.c:1646  */
    break;

  case 755:
#line 5866 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 36640 "gram.c" /* yacc.c:1646  */
    break;

  case 756:
#line 5870 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 36646 "gram.c" /* yacc.c:1646  */
    break;

  case 757:
#line 5871 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 36652 "gram.c" /* yacc.c:1646  */
    break;

  case 758:
#line 5875 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36658 "gram.c" /* yacc.c:1646  */
    break;

  case 759:
#line 5876 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeRoleSpec(ROLESPEC_PUBLIC, -1)); }
#line 36664 "gram.c" /* yacc.c:1646  */
    break;

  case 760:
#line 5880 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36670 "gram.c" /* yacc.c:1646  */
    break;

  case 761:
#line 5881 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NULL; }
#line 36676 "gram.c" /* yacc.c:1646  */
    break;

  case 762:
#line 5886 "gram.y" /* yacc.c:1646  */
    {
					if (strcmp((yyvsp[0].str), "permissive") == 0)
						(yyval.boolean) = true;
					else if (strcmp((yyvsp[0].str), "restrictive") == 0)
						(yyval.boolean) = false;
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized row security option \"%s\"", (yyvsp[0].str)),
								 errhint("Only PERMISSIVE or RESTRICTIVE policies are supported currently."),
								 parser_errposition((yylsp[0]))));

				}
#line 36694 "gram.c" /* yacc.c:1646  */
    break;

  case 763:
#line 5899 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 36700 "gram.c" /* yacc.c:1646  */
    break;

  case 764:
#line 5903 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36706 "gram.c" /* yacc.c:1646  */
    break;

  case 765:
#line 5904 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "all"; }
#line 36712 "gram.c" /* yacc.c:1646  */
    break;

  case 766:
#line 5908 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "all"; }
#line 36718 "gram.c" /* yacc.c:1646  */
    break;

  case 767:
#line 5909 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "select"; }
#line 36724 "gram.c" /* yacc.c:1646  */
    break;

  case 768:
#line 5910 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "insert"; }
#line 36730 "gram.c" /* yacc.c:1646  */
    break;

  case 769:
#line 5911 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "update"; }
#line 36736 "gram.c" /* yacc.c:1646  */
    break;

  case 770:
#line 5912 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "delete"; }
#line 36742 "gram.c" /* yacc.c:1646  */
    break;

  case 771:
#line 5923 "gram.y" /* yacc.c:1646  */
    {
					CreateAmStmt *n = makeNode(CreateAmStmt);

					n->amname = (yyvsp[-4].str);
					n->handler_name = (yyvsp[0].list);
					n->amtype = (yyvsp[-2].chr);
					(yyval.node) = (Node *) n;
				}
#line 36755 "gram.c" /* yacc.c:1646  */
    break;

  case 772:
#line 5934 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = AMTYPE_INDEX; }
#line 36761 "gram.c" /* yacc.c:1646  */
    break;

  case 773:
#line 5935 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = AMTYPE_TABLE; }
#line 36767 "gram.c" /* yacc.c:1646  */
    break;

  case 774:
#line 5949 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);

					n->replace = (yyvsp[-15].boolean);
					n->isconstraint = false;
					n->trigname = (yyvsp[-13].str);
					n->relation = (yyvsp[-9].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = (yyvsp[-7].boolean);
					n->timing = (yyvsp[-12].ival);
					n->events = intVal(linitial((yyvsp[-11].list)));
					n->columns = (List *) lsecond((yyvsp[-11].list));
					n->whenClause = (yyvsp[-6].node);
					n->transitionRels = (yyvsp[-8].list);
					n->deferrable = false;
					n->initdeferred = false;
					n->constrrel = NULL;
					(yyval.node) = (Node *) n;
				}
#line 36792 "gram.c" /* yacc.c:1646  */
    break;

  case 775:
#line 5973 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);

					n->replace = (yyvsp[-19].boolean);
					if (n->replace) /* not supported, see CreateTrigger */
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE OR REPLACE CONSTRAINT TRIGGER is not supported")));
					n->isconstraint = true;
					n->trigname = (yyvsp[-16].str);
					n->relation = (yyvsp[-12].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = true;
					n->timing = TRIGGER_TYPE_AFTER;
					n->events = intVal(linitial((yyvsp[-14].list)));
					n->columns = (List *) lsecond((yyvsp[-14].list));
					n->whenClause = (yyvsp[-6].node);
					n->transitionRels = NIL;
					processCASbits((yyvsp[-10].ival), (yylsp[-10]), "TRIGGER",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					n->constrrel = (yyvsp[-11].range);
					(yyval.node) = (Node *) n;
				}
#line 36822 "gram.c" /* yacc.c:1646  */
    break;

  case 776:
#line 6001 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_BEFORE; }
#line 36828 "gram.c" /* yacc.c:1646  */
    break;

  case 777:
#line 6002 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_AFTER; }
#line 36834 "gram.c" /* yacc.c:1646  */
    break;

  case 778:
#line 6003 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_INSTEAD; }
#line 36840 "gram.c" /* yacc.c:1646  */
    break;

  case 779:
#line 6008 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36846 "gram.c" /* yacc.c:1646  */
    break;

  case 780:
#line 6010 "gram.y" /* yacc.c:1646  */
    {
					int			events1 = intVal(linitial((yyvsp[-2].list)));
					int			events2 = intVal(linitial((yyvsp[0].list)));
					List	   *columns1 = (List *) lsecond((yyvsp[-2].list));
					List	   *columns2 = (List *) lsecond((yyvsp[0].list));

					if (events1 & events2)
						parser_yyerror("duplicate trigger events specified");
					/*
					 * concat'ing the columns lists loses information about
					 * which columns went with which event, but so long as
					 * only UPDATE carries columns and we disallow multiple
					 * UPDATE items, it doesn't matter.  Command execution
					 * should just ignore the columns for non-UPDATE events.
					 */
					(yyval.list) = list_make2(makeInteger(events1 | events2),
									list_concat(columns1, columns2));
				}
#line 36869 "gram.c" /* yacc.c:1646  */
    break;

  case 781:
#line 6032 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_INSERT), NIL); }
#line 36875 "gram.c" /* yacc.c:1646  */
    break;

  case 782:
#line 6034 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_DELETE), NIL); }
#line 36881 "gram.c" /* yacc.c:1646  */
    break;

  case 783:
#line 6036 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), NIL); }
#line 36887 "gram.c" /* yacc.c:1646  */
    break;

  case 784:
#line 6038 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), (yyvsp[0].list)); }
#line 36893 "gram.c" /* yacc.c:1646  */
    break;

  case 785:
#line 6040 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_TRUNCATE), NIL); }
#line 36899 "gram.c" /* yacc.c:1646  */
    break;

  case 786:
#line 6044 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36905 "gram.c" /* yacc.c:1646  */
    break;

  case 787:
#line 6045 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36911 "gram.c" /* yacc.c:1646  */
    break;

  case 788:
#line 6049 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 36917 "gram.c" /* yacc.c:1646  */
    break;

  case 789:
#line 6050 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 36923 "gram.c" /* yacc.c:1646  */
    break;

  case 790:
#line 6055 "gram.y" /* yacc.c:1646  */
    {
					TriggerTransition *n = makeNode(TriggerTransition);

					n->name = (yyvsp[0].str);
					n->isNew = (yyvsp[-3].boolean);
					n->isTable = (yyvsp[-2].boolean);
					(yyval.node) = (Node *) n;
				}
#line 36936 "gram.c" /* yacc.c:1646  */
    break;

  case 791:
#line 6066 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 36942 "gram.c" /* yacc.c:1646  */
    break;

  case 792:
#line 6067 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 36948 "gram.c" /* yacc.c:1646  */
    break;

  case 793:
#line 6071 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 36954 "gram.c" /* yacc.c:1646  */
    break;

  case 794:
#line 6080 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 36960 "gram.c" /* yacc.c:1646  */
    break;

  case 795:
#line 6084 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36966 "gram.c" /* yacc.c:1646  */
    break;

  case 796:
#line 6089 "gram.y" /* yacc.c:1646  */
    {
					(yyval.boolean) = (yyvsp[0].boolean);
				}
#line 36974 "gram.c" /* yacc.c:1646  */
    break;

  case 797:
#line 6093 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = false;
				}
#line 36986 "gram.c" /* yacc.c:1646  */
    break;

  case 800:
#line 6108 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 36992 "gram.c" /* yacc.c:1646  */
    break;

  case 801:
#line 6109 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 36998 "gram.c" /* yacc.c:1646  */
    break;

  case 802:
#line 6113 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 37004 "gram.c" /* yacc.c:1646  */
    break;

  case 803:
#line 6114 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 37010 "gram.c" /* yacc.c:1646  */
    break;

  case 806:
#line 6123 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 37016 "gram.c" /* yacc.c:1646  */
    break;

  case 807:
#line 6124 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 37022 "gram.c" /* yacc.c:1646  */
    break;

  case 808:
#line 6125 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37028 "gram.c" /* yacc.c:1646  */
    break;

  case 809:
#line 6130 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString(psprintf("%d", (yyvsp[0].ival)));
				}
#line 37036 "gram.c" /* yacc.c:1646  */
    break;

  case 810:
#line 6133 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 37042 "gram.c" /* yacc.c:1646  */
    break;

  case 811:
#line 6134 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 37048 "gram.c" /* yacc.c:1646  */
    break;

  case 812:
#line 6135 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 37054 "gram.c" /* yacc.c:1646  */
    break;

  case 813:
#line 6139 "gram.y" /* yacc.c:1646  */
    { (yyval.range) = (yyvsp[0].range); }
#line 37060 "gram.c" /* yacc.c:1646  */
    break;

  case 814:
#line 6140 "gram.y" /* yacc.c:1646  */
    { (yyval.range) = NULL; }
#line 37066 "gram.c" /* yacc.c:1646  */
    break;

  case 815:
#line 6145 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 37072 "gram.c" /* yacc.c:1646  */
    break;

  case 816:
#line 6147 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We must complain about conflicting options.
					 * We could, but choose not to, complain about redundant
					 * options (ie, where $2's bit is already set in $1).
					 */
					int		newspec = (yyvsp[-1].ival) | (yyvsp[0].ival);

					/* special message for this case */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED)) == (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[0]))));
					/* generic message for other conflicts */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE)) == (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE) ||
						(newspec & (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED)) == (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("conflicting constraint properties"),
								 parser_errposition((yylsp[0]))));
					(yyval.ival) = newspec;
				}
#line 37100 "gram.c" /* yacc.c:1646  */
    break;

  case 817:
#line 6173 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_DEFERRABLE; }
#line 37106 "gram.c" /* yacc.c:1646  */
    break;

  case 818:
#line 6174 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_DEFERRABLE; }
#line 37112 "gram.c" /* yacc.c:1646  */
    break;

  case 819:
#line 6175 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_IMMEDIATE; }
#line 37118 "gram.c" /* yacc.c:1646  */
    break;

  case 820:
#line 6176 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_DEFERRED; }
#line 37124 "gram.c" /* yacc.c:1646  */
    break;

  case 821:
#line 6177 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_VALID; }
#line 37130 "gram.c" /* yacc.c:1646  */
    break;

  case 822:
#line 6178 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NO_INHERIT; }
#line 37136 "gram.c" /* yacc.c:1646  */
    break;

  case 823:
#line 6193 "gram.y" /* yacc.c:1646  */
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);

					n->trigname = (yyvsp[-7].str);
					n->eventname = (yyvsp[-5].str);
					n->whenclause = NULL;
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 37150 "gram.c" /* yacc.c:1646  */
    break;

  case 824:
#line 6205 "gram.y" /* yacc.c:1646  */
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);

					n->trigname = (yyvsp[-9].str);
					n->eventname = (yyvsp[-7].str);
					n->whenclause = (yyvsp[-5].list);
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 37164 "gram.c" /* yacc.c:1646  */
    break;

  case 825:
#line 6218 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 37170 "gram.c" /* yacc.c:1646  */
    break;

  case 826:
#line 6220 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 37176 "gram.c" /* yacc.c:1646  */
    break;

  case 827:
#line 6225 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-4].str), (Node *) (yyvsp[-1].list), (yylsp[-4])); }
#line 37182 "gram.c" /* yacc.c:1646  */
    break;

  case 828:
#line 6230 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 37188 "gram.c" /* yacc.c:1646  */
    break;

  case 829:
#line 6232 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 37194 "gram.c" /* yacc.c:1646  */
    break;

  case 830:
#line 6237 "gram.y" /* yacc.c:1646  */
    {
					AlterEventTrigStmt *n = makeNode(AlterEventTrigStmt);

					n->trigname = (yyvsp[-1].str);
					n->tgenabled = (yyvsp[0].chr);
					(yyval.node) = (Node *) n;
				}
#line 37206 "gram.c" /* yacc.c:1646  */
    break;

  case 831:
#line 6247 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ON_ORIGIN; }
#line 37212 "gram.c" /* yacc.c:1646  */
    break;

  case 832:
#line 6248 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ON_REPLICA; }
#line 37218 "gram.c" /* yacc.c:1646  */
    break;

  case 833:
#line 6249 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ALWAYS; }
#line 37224 "gram.c" /* yacc.c:1646  */
    break;

  case 834:
#line 6250 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_DISABLED; }
#line 37230 "gram.c" /* yacc.c:1646  */
    break;

  case 835:
#line 6262 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = NULL;
				}
#line 37242 "gram.c" /* yacc.c:1646  */
    break;

  case 836:
#line 6281 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->replace = (yyvsp[-4].boolean);
					n->defnames = (yyvsp[-2].list);
					n->args = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37258 "gram.c" /* yacc.c:1646  */
    break;

  case 837:
#line 6293 "gram.y" /* yacc.c:1646  */
    {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->replace = (yyvsp[-3].boolean);
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37275 "gram.c" /* yacc.c:1646  */
    break;

  case 838:
#line 6306 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37290 "gram.c" /* yacc.c:1646  */
    break;

  case 839:
#line 6317 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37305 "gram.c" /* yacc.c:1646  */
    break;

  case 840:
#line 6328 "gram.y" /* yacc.c:1646  */
    {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[0].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *) n;
				}
#line 37321 "gram.c" /* yacc.c:1646  */
    break;

  case 841:
#line 6340 "gram.y" /* yacc.c:1646  */
    {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);

					/* can't use qualified_name, sigh */
					n->typevar = makeRangeVarFromAnyName((yyvsp[-4].list), (yylsp[-4]), yyscanner);
					n->coldeflist = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 37334 "gram.c" /* yacc.c:1646  */
    break;

  case 842:
#line 6349 "gram.y" /* yacc.c:1646  */
    {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);

					n->typeName = (yyvsp[-5].list);
					n->vals = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 37346 "gram.c" /* yacc.c:1646  */
    break;

  case 843:
#line 6357 "gram.y" /* yacc.c:1646  */
    {
					CreateRangeStmt *n = makeNode(CreateRangeStmt);

					n->typeName = (yyvsp[-3].list);
					n->params = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37358 "gram.c" /* yacc.c:1646  */
    break;

  case 844:
#line 6365 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37372 "gram.c" /* yacc.c:1646  */
    break;

  case 845:
#line 6375 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37386 "gram.c" /* yacc.c:1646  */
    break;

  case 846:
#line 6385 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37400 "gram.c" /* yacc.c:1646  */
    break;

  case 847:
#line 6395 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37414 "gram.c" /* yacc.c:1646  */
    break;

  case 848:
#line 6405 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37428 "gram.c" /* yacc.c:1646  */
    break;

  case 849:
#line 6415 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 37443 "gram.c" /* yacc.c:1646  */
    break;

  case 850:
#line 6426 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list), (yylsp[0])));
					(yyval.node) = (Node *) n;
				}
#line 37457 "gram.c" /* yacc.c:1646  */
    break;

  case 851:
#line 6436 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list), (yylsp[0])));
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 37472 "gram.c" /* yacc.c:1646  */
    break;

  case 852:
#line 6448 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 37478 "gram.c" /* yacc.c:1646  */
    break;

  case 853:
#line 6451 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 37484 "gram.c" /* yacc.c:1646  */
    break;

  case 854:
#line 6452 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 37490 "gram.c" /* yacc.c:1646  */
    break;

  case 855:
#line 6456 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 37498 "gram.c" /* yacc.c:1646  */
    break;

  case 856:
#line 6460 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0]));
				}
#line 37506 "gram.c" /* yacc.c:1646  */
    break;

  case 857:
#line 6466 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].typnam); }
#line 37512 "gram.c" /* yacc.c:1646  */
    break;

  case 858:
#line 6467 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString(pstrdup((yyvsp[0].keyword))); }
#line 37518 "gram.c" /* yacc.c:1646  */
    break;

  case 859:
#line 6468 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].list); }
#line 37524 "gram.c" /* yacc.c:1646  */
    break;

  case 860:
#line 6469 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 37530 "gram.c" /* yacc.c:1646  */
    break;

  case 861:
#line 6470 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 37536 "gram.c" /* yacc.c:1646  */
    break;

  case 862:
#line 6471 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString(pstrdup((yyvsp[0].keyword))); }
#line 37542 "gram.c" /* yacc.c:1646  */
    break;

  case 863:
#line 6474 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 37548 "gram.c" /* yacc.c:1646  */
    break;

  case 864:
#line 6477 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 37554 "gram.c" /* yacc.c:1646  */
    break;

  case 865:
#line 6478 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 37560 "gram.c" /* yacc.c:1646  */
    break;

  case 866:
#line 6487 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 37568 "gram.c" /* yacc.c:1646  */
    break;

  case 867:
#line 6493 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 37574 "gram.c" /* yacc.c:1646  */
    break;

  case 868:
#line 6494 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37580 "gram.c" /* yacc.c:1646  */
    break;

  case 869:
#line 6498 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 37586 "gram.c" /* yacc.c:1646  */
    break;

  case 870:
#line 6500 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 37592 "gram.c" /* yacc.c:1646  */
    break;

  case 871:
#line 6511 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-4].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = true;
				n->skipIfNewValExists = (yyvsp[-1].boolean);
				(yyval.node) = (Node *) n;
			}
#line 37608 "gram.c" /* yacc.c:1646  */
    break;

  case 872:
#line 6523 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-6].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = false;
				n->skipIfNewValExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 37624 "gram.c" /* yacc.c:1646  */
    break;

  case 873:
#line 6535 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-6].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = true;
				n->skipIfNewValExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 37640 "gram.c" /* yacc.c:1646  */
    break;

  case 874:
#line 6547 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-5].list);
				n->oldVal = (yyvsp[-2].str);
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = false;
				n->skipIfNewValExists = false;
				(yyval.node) = (Node *) n;
			}
#line 37656 "gram.c" /* yacc.c:1646  */
    break;

  case 875:
#line 6559 "gram.y" /* yacc.c:1646  */
    {
				/*
				 * The following problems must be solved before this can be
				 * implemented:
				 *
				 * - There must be no instance of the target value in
				 *   any table.
				 *
				 * - The value must not appear in any catalog metadata,
				 *   such as stored view expressions or column defaults.
				 *
				 * - The value must not appear in any non-leaf page of a
				 *   btree (and similar issues with other index types).
				 *   This is problematic because a value could persist
				 *   there long after it's gone from user-visible data.
				 *
				 * - Concurrent sessions must not be able to insert the
				 *   value while the preceding conditions are being checked.
				 *
				 * - Possibly more...
				 */
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("dropping an enum value is not implemented"),
						 parser_errposition((yylsp[-2]))));
			}
#line 37687 "gram.c" /* yacc.c:1646  */
    break;

  case 876:
#line 6587 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 37693 "gram.c" /* yacc.c:1646  */
    break;

  case 877:
#line 6588 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 37699 "gram.c" /* yacc.c:1646  */
    break;

  case 878:
#line 6606 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);

					n->opclassname = (yyvsp[-9].list);
					n->isDefault = (yyvsp[-8].boolean);
					n->datatype = (yyvsp[-5].typnam);
					n->amname = (yyvsp[-3].str);
					n->opfamilyname = (yyvsp[-2].list);
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37715 "gram.c" /* yacc.c:1646  */
    break;

  case 879:
#line 6620 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 37721 "gram.c" /* yacc.c:1646  */
    break;

  case 880:
#line 6621 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 37727 "gram.c" /* yacc.c:1646  */
    break;

  case 881:
#line 6626 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					ObjectWithArgs *owa = makeNode(ObjectWithArgs);

					owa->objname = (yyvsp[-2].list);
					owa->objargs = NIL;
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = owa;
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 37744 "gram.c" /* yacc.c:1646  */
    break;

  case 882:
#line 6640 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[-2].objwithargs);
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 37758 "gram.c" /* yacc.c:1646  */
    break;

  case 883:
#line 6650 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[0].objwithargs);
					n->number = (yyvsp[-1].ival);
					(yyval.node) = (Node *) n;
				}
#line 37771 "gram.c" /* yacc.c:1646  */
    break;

  case 884:
#line 6659 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[0].objwithargs);
					n->number = (yyvsp[-4].ival);
					n->class_args = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 37785 "gram.c" /* yacc.c:1646  */
    break;

  case 885:
#line 6669 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 37797 "gram.c" /* yacc.c:1646  */
    break;

  case 886:
#line 6678 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 37803 "gram.c" /* yacc.c:1646  */
    break;

  case 887:
#line 6679 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 37809 "gram.c" /* yacc.c:1646  */
    break;

  case 888:
#line 6682 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 37815 "gram.c" /* yacc.c:1646  */
    break;

  case 889:
#line 6683 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37821 "gram.c" /* yacc.c:1646  */
    break;

  case 890:
#line 6686 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37827 "gram.c" /* yacc.c:1646  */
    break;

  case 891:
#line 6687 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 37833 "gram.c" /* yacc.c:1646  */
    break;

  case 892:
#line 6688 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37839 "gram.c" /* yacc.c:1646  */
    break;

  case 893:
#line 6692 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 parser_errposition((yylsp[0]))));
					(yyval.boolean) = true;
				}
#line 37857 "gram.c" /* yacc.c:1646  */
    break;

  case 894:
#line 6705 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 37863 "gram.c" /* yacc.c:1646  */
    break;

  case 895:
#line 6711 "gram.y" /* yacc.c:1646  */
    {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);

					n->opfamilyname = (yyvsp[-2].list);
					n->amname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37875 "gram.c" /* yacc.c:1646  */
    break;

  case 896:
#line 6722 "gram.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);

					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = false;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37889 "gram.c" /* yacc.c:1646  */
    break;

  case 897:
#line 6732 "gram.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);

					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = true;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37903 "gram.c" /* yacc.c:1646  */
    break;

  case 898:
#line 6744 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 37909 "gram.c" /* yacc.c:1646  */
    break;

  case 899:
#line 6745 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 37915 "gram.c" /* yacc.c:1646  */
    break;

  case 900:
#line 6750 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[-3].ival);
					n->class_args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 37928 "gram.c" /* yacc.c:1646  */
    break;

  case 901:
#line 6759 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[-3].ival);
					n->class_args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 37941 "gram.c" /* yacc.c:1646  */
    break;

  case 902:
#line 6772 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 37956 "gram.c" /* yacc.c:1646  */
    break;

  case 903:
#line 6783 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 37971 "gram.c" /* yacc.c:1646  */
    break;

  case 904:
#line 6797 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 37986 "gram.c" /* yacc.c:1646  */
    break;

  case 905:
#line 6808 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38001 "gram.c" /* yacc.c:1646  */
    break;

  case 906:
#line 6831 "gram.y" /* yacc.c:1646  */
    {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);

					n->roles = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 38013 "gram.c" /* yacc.c:1646  */
    break;

  case 907:
#line 6842 "gram.y" /* yacc.c:1646  */
    {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);

					n->roles = (yyvsp[-2].list);
					n->newrole = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 38025 "gram.c" /* yacc.c:1646  */
    break;

  case 908:
#line 6861 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38040 "gram.c" /* yacc.c:1646  */
    break;

  case 909:
#line 6872 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38055 "gram.c" /* yacc.c:1646  */
    break;

  case 910:
#line 6883 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38070 "gram.c" /* yacc.c:1646  */
    break;

  case 911:
#line 6894 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38085 "gram.c" /* yacc.c:1646  */
    break;

  case 912:
#line 6905 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-4].objtype);
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38100 "gram.c" /* yacc.c:1646  */
    break;

  case 913:
#line 6916 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-6].objtype);
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38115 "gram.c" /* yacc.c:1646  */
    break;

  case 914:
#line 6927 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_TYPE;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38130 "gram.c" /* yacc.c:1646  */
    break;

  case 915:
#line 6938 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_TYPE;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38145 "gram.c" /* yacc.c:1646  */
    break;

  case 916:
#line 6949 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38160 "gram.c" /* yacc.c:1646  */
    break;

  case 917:
#line 6960 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38175 "gram.c" /* yacc.c:1646  */
    break;

  case 918:
#line 6971 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_INDEX;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *) n;
				}
#line 38190 "gram.c" /* yacc.c:1646  */
    break;

  case 919:
#line 6982 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_INDEX;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *) n;
				}
#line 38205 "gram.c" /* yacc.c:1646  */
    break;

  case 920:
#line 6996 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 38211 "gram.c" /* yacc.c:1646  */
    break;

  case 921:
#line 6997 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 38217 "gram.c" /* yacc.c:1646  */
    break;

  case 922:
#line 6998 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 38223 "gram.c" /* yacc.c:1646  */
    break;

  case 923:
#line 6999 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_MATVIEW; }
#line 38229 "gram.c" /* yacc.c:1646  */
    break;

  case 924:
#line 7000 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_INDEX; }
#line 38235 "gram.c" /* yacc.c:1646  */
    break;

  case 925:
#line 7001 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 38241 "gram.c" /* yacc.c:1646  */
    break;

  case 926:
#line 7002 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLLATION; }
#line 38247 "gram.c" /* yacc.c:1646  */
    break;

  case 927:
#line 7003 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_CONVERSION; }
#line 38253 "gram.c" /* yacc.c:1646  */
    break;

  case 928:
#line 7004 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_STATISTIC_EXT; }
#line 38259 "gram.c" /* yacc.c:1646  */
    break;

  case 929:
#line 7005 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSPARSER; }
#line 38265 "gram.c" /* yacc.c:1646  */
    break;

  case 930:
#line 7006 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
#line 38271 "gram.c" /* yacc.c:1646  */
    break;

  case 931:
#line 7007 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
#line 38277 "gram.c" /* yacc.c:1646  */
    break;

  case 932:
#line 7008 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
#line 38283 "gram.c" /* yacc.c:1646  */
    break;

  case 933:
#line 7018 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = (yyvsp[0].objtype); }
#line 38289 "gram.c" /* yacc.c:1646  */
    break;

  case 934:
#line 7019 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DATABASE; }
#line 38295 "gram.c" /* yacc.c:1646  */
    break;

  case 935:
#line 7020 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ROLE; }
#line 38301 "gram.c" /* yacc.c:1646  */
    break;

  case 936:
#line 7021 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SUBSCRIPTION; }
#line 38307 "gram.c" /* yacc.c:1646  */
    break;

  case 937:
#line 7022 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 38313 "gram.c" /* yacc.c:1646  */
    break;

  case 938:
#line 7026 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ACCESS_METHOD; }
#line 38319 "gram.c" /* yacc.c:1646  */
    break;

  case 939:
#line 7027 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 38325 "gram.c" /* yacc.c:1646  */
    break;

  case 940:
#line 7028 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EXTENSION; }
#line 38331 "gram.c" /* yacc.c:1646  */
    break;

  case 941:
#line 7029 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FDW; }
#line 38337 "gram.c" /* yacc.c:1646  */
    break;

  case 942:
#line 7030 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_LANGUAGE; }
#line 38343 "gram.c" /* yacc.c:1646  */
    break;

  case 943:
#line 7031 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_PUBLICATION; }
#line 38349 "gram.c" /* yacc.c:1646  */
    break;

  case 944:
#line 7032 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 38355 "gram.c" /* yacc.c:1646  */
    break;

  case 945:
#line 7033 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_SERVER; }
#line 38361 "gram.c" /* yacc.c:1646  */
    break;

  case 946:
#line 7038 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_POLICY; }
#line 38367 "gram.c" /* yacc.c:1646  */
    break;

  case 947:
#line 7039 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_RULE; }
#line 38373 "gram.c" /* yacc.c:1646  */
    break;

  case 948:
#line 7040 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TRIGGER; }
#line 38379 "gram.c" /* yacc.c:1646  */
    break;

  case 949:
#line 7044 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 38385 "gram.c" /* yacc.c:1646  */
    break;

  case 950:
#line 7045 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 38391 "gram.c" /* yacc.c:1646  */
    break;

  case 951:
#line 7048 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 38397 "gram.c" /* yacc.c:1646  */
    break;

  case 952:
#line 7049 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 38403 "gram.c" /* yacc.c:1646  */
    break;

  case 953:
#line 7053 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 38409 "gram.c" /* yacc.c:1646  */
    break;

  case 954:
#line 7055 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 38415 "gram.c" /* yacc.c:1646  */
    break;

  case 955:
#line 7059 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 38421 "gram.c" /* yacc.c:1646  */
    break;

  case 956:
#line 7060 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 38427 "gram.c" /* yacc.c:1646  */
    break;

  case 957:
#line 7072 "gram.y" /* yacc.c:1646  */
    {
					TruncateStmt *n = makeNode(TruncateStmt);

					n->relations = (yyvsp[-2].list);
					n->restart_seqs = (yyvsp[-1].boolean);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 38440 "gram.c" /* yacc.c:1646  */
    break;

  case 958:
#line 7083 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 38446 "gram.c" /* yacc.c:1646  */
    break;

  case 959:
#line 7084 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 38452 "gram.c" /* yacc.c:1646  */
    break;

  case 960:
#line 7085 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 38458 "gram.c" /* yacc.c:1646  */
    break;

  case 961:
#line 7096 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38471 "gram.c" /* yacc.c:1646  */
    break;

  case 962:
#line 7105 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_COLUMN;
					n->object = (Node *) (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38484 "gram.c" /* yacc.c:1646  */
    break;

  case 963:
#line 7114 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) makeString((yyvsp[-2].str));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38497 "gram.c" /* yacc.c:1646  */
    break;

  case 964:
#line 7123 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38510 "gram.c" /* yacc.c:1646  */
    break;

  case 965:
#line 7132 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38523 "gram.c" /* yacc.c:1646  */
    break;

  case 966:
#line 7141 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38536 "gram.c" /* yacc.c:1646  */
    break;

  case 967:
#line 7150 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38549 "gram.c" /* yacc.c:1646  */
    break;

  case 968:
#line 7159 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38562 "gram.c" /* yacc.c:1646  */
    break;

  case 969:
#line 7168 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_TABCONSTRAINT;
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38575 "gram.c" /* yacc.c:1646  */
    break;

  case 970:
#line 7177 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_DOMCONSTRAINT;
					/*
					 * should use Typename not any_name in the production, but
					 * there's a shift/reduce conflict if we do that, so fix it
					 * up here.
					 */
					n->object = (Node *) list_make2(makeTypeNameFromNameList((yyvsp[-2].list)), makeString((yyvsp[-5].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38593 "gram.c" /* yacc.c:1646  */
    break;

  case 971:
#line 7191 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = (yyvsp[-5].objtype);
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38606 "gram.c" /* yacc.c:1646  */
    break;

  case 972:
#line 7200 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38619 "gram.c" /* yacc.c:1646  */
    break;

  case 973:
#line 7209 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38632 "gram.c" /* yacc.c:1646  */
    break;

  case 974:
#line 7218 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_TRANSFORM;
					n->object = (Node *) list_make2((yyvsp[-4].typnam), makeString((yyvsp[-2].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38645 "gram.c" /* yacc.c:1646  */
    break;

  case 975:
#line 7227 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38658 "gram.c" /* yacc.c:1646  */
    break;

  case 976:
#line 7236 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38671 "gram.c" /* yacc.c:1646  */
    break;

  case 977:
#line 7245 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-2].node);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38684 "gram.c" /* yacc.c:1646  */
    break;

  case 978:
#line 7254 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_CAST;
					n->object = (Node *) list_make2((yyvsp[-5].typnam), (yyvsp[-3].typnam));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38697 "gram.c" /* yacc.c:1646  */
    break;

  case 979:
#line 7265 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 38703 "gram.c" /* yacc.c:1646  */
    break;

  case 980:
#line 7266 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 38709 "gram.c" /* yacc.c:1646  */
    break;

  case 981:
#line 7282 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) (yyvsp[-2].list);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38723 "gram.c" /* yacc.c:1646  */
    break;

  case 982:
#line 7293 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_COLUMN;
					n->object = (Node *) (yyvsp[-2].list);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38737 "gram.c" /* yacc.c:1646  */
    break;

  case 983:
#line 7304 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) makeString((yyvsp[-2].str));
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38751 "gram.c" /* yacc.c:1646  */
    break;

  case 984:
#line 7315 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38765 "gram.c" /* yacc.c:1646  */
    break;

  case 985:
#line 7326 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38779 "gram.c" /* yacc.c:1646  */
    break;

  case 986:
#line 7337 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38793 "gram.c" /* yacc.c:1646  */
    break;

  case 987:
#line 7348 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38807 "gram.c" /* yacc.c:1646  */
    break;

  case 988:
#line 7359 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-2].node);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38821 "gram.c" /* yacc.c:1646  */
    break;

  case 989:
#line 7370 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38835 "gram.c" /* yacc.c:1646  */
    break;

  case 990:
#line 7381 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38849 "gram.c" /* yacc.c:1646  */
    break;

  case 991:
#line 7392 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 38855 "gram.c" /* yacc.c:1646  */
    break;

  case 992:
#line 7393 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 38861 "gram.c" /* yacc.c:1646  */
    break;

  case 993:
#line 7396 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 38867 "gram.c" /* yacc.c:1646  */
    break;

  case 994:
#line 7397 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 38873 "gram.c" /* yacc.c:1646  */
    break;

  case 995:
#line 7408 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);

					n->ismove = false;
					(yyval.node) = (Node *) n;
				}
#line 38884 "gram.c" /* yacc.c:1646  */
    break;

  case 996:
#line 7415 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);

					n->ismove = true;
					(yyval.node) = (Node *) n;
				}
#line 38895 "gram.c" /* yacc.c:1646  */
    break;

  case 997:
#line 7424 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 38908 "gram.c" /* yacc.c:1646  */
    break;

  case 998:
#line 7433 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 38921 "gram.c" /* yacc.c:1646  */
    break;

  case 999:
#line 7442 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 38934 "gram.c" /* yacc.c:1646  */
    break;

  case 1000:
#line 7451 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 38947 "gram.c" /* yacc.c:1646  */
    break;

  case 1001:
#line 7460 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 38960 "gram.c" /* yacc.c:1646  */
    break;

  case 1002:
#line 7469 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *) n;
				}
#line 38973 "gram.c" /* yacc.c:1646  */
    break;

  case 1003:
#line 7478 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 38986 "gram.c" /* yacc.c:1646  */
    break;

  case 1004:
#line 7487 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 38999 "gram.c" /* yacc.c:1646  */
    break;

  case 1005:
#line 7496 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 39012 "gram.c" /* yacc.c:1646  */
    break;

  case 1006:
#line 7505 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *) n;
				}
#line 39025 "gram.c" /* yacc.c:1646  */
    break;

  case 1007:
#line 7514 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 39038 "gram.c" /* yacc.c:1646  */
    break;

  case 1008:
#line 7523 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 39051 "gram.c" /* yacc.c:1646  */
    break;

  case 1009:
#line 7532 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *) n;
				}
#line 39064 "gram.c" /* yacc.c:1646  */
    break;

  case 1010:
#line 7541 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 39077 "gram.c" /* yacc.c:1646  */
    break;

  case 1011:
#line 7550 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 39090 "gram.c" /* yacc.c:1646  */
    break;

  case 1012:
#line 7559 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *) n;
				}
#line 39103 "gram.c" /* yacc.c:1646  */
    break;

  case 1017:
#line 7586 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = true;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grant_option = (yyvsp[-1].boolean);
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 39121 "gram.c" /* yacc.c:1646  */
    break;

  case 1018:
#line 7604 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 39140 "gram.c" /* yacc.c:1646  */
    break;

  case 1019:
#line 7620 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 39159 "gram.c" /* yacc.c:1646  */
    break;

  case 1020:
#line 7647 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 39165 "gram.c" /* yacc.c:1646  */
    break;

  case 1021:
#line 7649 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 39171 "gram.c" /* yacc.c:1646  */
    break;

  case 1022:
#line 7651 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 39177 "gram.c" /* yacc.c:1646  */
    break;

  case 1023:
#line 7653 "gram.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);

					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 39189 "gram.c" /* yacc.c:1646  */
    break;

  case 1024:
#line 7661 "gram.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);

					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 39201 "gram.c" /* yacc.c:1646  */
    break;

  case 1025:
#line 7670 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].accesspriv)); }
#line 39207 "gram.c" /* yacc.c:1646  */
    break;

  case 1026:
#line 7671 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].accesspriv)); }
#line 39213 "gram.c" /* yacc.c:1646  */
    break;

  case 1027:
#line 7675 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 39225 "gram.c" /* yacc.c:1646  */
    break;

  case 1028:
#line 7683 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 39237 "gram.c" /* yacc.c:1646  */
    break;

  case 1029:
#line 7691 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 39249 "gram.c" /* yacc.c:1646  */
    break;

  case 1030:
#line 7699 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup("alter system");
				n->cols = NIL;
				(yyval.accesspriv) = n;
			}
#line 39260 "gram.c" /* yacc.c:1646  */
    break;

  case 1031:
#line 7706 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = (yyvsp[-1].str);
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 39272 "gram.c" /* yacc.c:1646  */
    break;

  case 1032:
#line 7717 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make1(makeString((yyvsp[0].str)));
			}
#line 39280 "gram.c" /* yacc.c:1646  */
    break;

  case 1033:
#line 7721 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str)));
			}
#line 39288 "gram.c" /* yacc.c:1646  */
    break;

  case 1034:
#line 7728 "gram.y" /* yacc.c:1646  */
    {
				(yyval.str) = (yyvsp[0].str);
			}
#line 39296 "gram.c" /* yacc.c:1646  */
    break;

  case 1035:
#line 7732 "gram.y" /* yacc.c:1646  */
    {
				(yyval.str) = psprintf("%s.%s", (yyvsp[-2].str), (yyvsp[0].str));
			}
#line 39304 "gram.c" /* yacc.c:1646  */
    break;

  case 1036:
#line 7743 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39317 "gram.c" /* yacc.c:1646  */
    break;

  case 1037:
#line 7752 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39330 "gram.c" /* yacc.c:1646  */
    break;

  case 1038:
#line 7761 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39343 "gram.c" /* yacc.c:1646  */
    break;

  case 1039:
#line 7770 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FDW;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39356 "gram.c" /* yacc.c:1646  */
    break;

  case 1040:
#line 7779 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39369 "gram.c" /* yacc.c:1646  */
    break;

  case 1041:
#line 7788 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39382 "gram.c" /* yacc.c:1646  */
    break;

  case 1042:
#line 7797 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_PROCEDURE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39395 "gram.c" /* yacc.c:1646  */
    break;

  case 1043:
#line 7806 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_ROUTINE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39408 "gram.c" /* yacc.c:1646  */
    break;

  case 1044:
#line 7815 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_DATABASE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39421 "gram.c" /* yacc.c:1646  */
    break;

  case 1045:
#line 7824 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_DOMAIN;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39434 "gram.c" /* yacc.c:1646  */
    break;

  case 1046:
#line 7833 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_LANGUAGE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39447 "gram.c" /* yacc.c:1646  */
    break;

  case 1047:
#line 7842 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39460 "gram.c" /* yacc.c:1646  */
    break;

  case 1048:
#line 7851 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_PARAMETER_ACL;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39472 "gram.c" /* yacc.c:1646  */
    break;

  case 1049:
#line 7859 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_SCHEMA;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39485 "gram.c" /* yacc.c:1646  */
    break;

  case 1050:
#line 7868 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLESPACE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39498 "gram.c" /* yacc.c:1646  */
    break;

  case 1051:
#line 7877 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TYPE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39511 "gram.c" /* yacc.c:1646  */
    break;

  case 1052:
#line 7886 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39524 "gram.c" /* yacc.c:1646  */
    break;

  case 1053:
#line 7895 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39537 "gram.c" /* yacc.c:1646  */
    break;

  case 1054:
#line 7904 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39550 "gram.c" /* yacc.c:1646  */
    break;

  case 1055:
#line 7913 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_PROCEDURE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39563 "gram.c" /* yacc.c:1646  */
    break;

  case 1056:
#line 7922 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_ROUTINE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39576 "gram.c" /* yacc.c:1646  */
    break;

  case 1057:
#line 7934 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].rolespec)); }
#line 39582 "gram.c" /* yacc.c:1646  */
    break;

  case 1058:
#line 7935 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].rolespec)); }
#line 39588 "gram.c" /* yacc.c:1646  */
    break;

  case 1059:
#line 7939 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 39594 "gram.c" /* yacc.c:1646  */
    break;

  case 1060:
#line 7940 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 39600 "gram.c" /* yacc.c:1646  */
    break;

  case 1061:
#line 7945 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 39606 "gram.c" /* yacc.c:1646  */
    break;

  case 1062:
#line 7946 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 39612 "gram.c" /* yacc.c:1646  */
    break;

  case 1063:
#line 7957 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);

					n->is_grant = true;
					n->granted_roles = (yyvsp[-3].list);
					n->grantee_roles = (yyvsp[-1].list);
					n->opt = NIL;
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 39627 "gram.c" /* yacc.c:1646  */
    break;

  case 1064:
#line 7968 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);

					n->is_grant = true;
					n->granted_roles = (yyvsp[-5].list);
					n->grantee_roles = (yyvsp[-3].list);
					n->opt = (yyvsp[-1].list);
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 39642 "gram.c" /* yacc.c:1646  */
    break;

  case 1065:
#line 7982 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);

					n->is_grant = false;
					n->opt = NIL;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 39658 "gram.c" /* yacc.c:1646  */
    break;

  case 1066:
#line 7994 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					DefElem *opt;

					opt = makeDefElem(pstrdup((yyvsp[-7].str)),
									  (Node *) makeBoolean(false), (yylsp[-7]));
					n->is_grant = false;
					n->opt = list_make1(opt);
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 39677 "gram.c" /* yacc.c:1646  */
    break;

  case 1067:
#line 8011 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 39683 "gram.c" /* yacc.c:1646  */
    break;

  case 1068:
#line 8012 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 39689 "gram.c" /* yacc.c:1646  */
    break;

  case 1069:
#line 8017 "gram.y" /* yacc.c:1646  */
    {
				(yyval.defelt) = makeDefElem(pstrdup((yyvsp[-1].str)), (yyvsp[0].node), (yylsp[-1]));
			}
#line 39697 "gram.c" /* yacc.c:1646  */
    break;

  case 1070:
#line 8023 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeBoolean(true); }
#line 39703 "gram.c" /* yacc.c:1646  */
    break;

  case 1071:
#line 8024 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeBoolean(true); }
#line 39709 "gram.c" /* yacc.c:1646  */
    break;

  case 1072:
#line 8025 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeBoolean(false); }
#line 39715 "gram.c" /* yacc.c:1646  */
    break;

  case 1073:
#line 8028 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 39721 "gram.c" /* yacc.c:1646  */
    break;

  case 1074:
#line 8029 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = NULL; }
#line 39727 "gram.c" /* yacc.c:1646  */
    break;

  case 1075:
#line 8040 "gram.y" /* yacc.c:1646  */
    {
					AlterDefaultPrivilegesStmt *n = makeNode(AlterDefaultPrivilegesStmt);

					n->options = (yyvsp[-1].list);
					n->action = (GrantStmt *) (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 39739 "gram.c" /* yacc.c:1646  */
    break;

  case 1076:
#line 8050 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 39745 "gram.c" /* yacc.c:1646  */
    break;

  case 1077:
#line 8051 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 39751 "gram.c" /* yacc.c:1646  */
    break;

  case 1078:
#line 8056 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schemas", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 39759 "gram.c" /* yacc.c:1646  */
    break;

  case 1079:
#line 8060 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 39767 "gram.c" /* yacc.c:1646  */
    break;

  case 1080:
#line 8064 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 39775 "gram.c" /* yacc.c:1646  */
    break;

  case 1081:
#line 8076 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 39792 "gram.c" /* yacc.c:1646  */
    break;

  case 1082:
#line 8090 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 39810 "gram.c" /* yacc.c:1646  */
    break;

  case 1083:
#line 8105 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 39828 "gram.c" /* yacc.c:1646  */
    break;

  case 1084:
#line 8121 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_TABLE; }
#line 39834 "gram.c" /* yacc.c:1646  */
    break;

  case 1085:
#line 8122 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_FUNCTION; }
#line 39840 "gram.c" /* yacc.c:1646  */
    break;

  case 1086:
#line 8123 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_FUNCTION; }
#line 39846 "gram.c" /* yacc.c:1646  */
    break;

  case 1087:
#line 8124 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_SEQUENCE; }
#line 39852 "gram.c" /* yacc.c:1646  */
    break;

  case 1088:
#line 8125 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_TYPE; }
#line 39858 "gram.c" /* yacc.c:1646  */
    break;

  case 1089:
#line 8126 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_SCHEMA; }
#line 39864 "gram.c" /* yacc.c:1646  */
    break;

  case 1090:
#line 8141 "gram.y" /* yacc.c:1646  */
    {
					IndexStmt *n = makeNode(IndexStmt);

					n->unique = (yyvsp[-14].boolean);
					n->concurrent = (yyvsp[-12].boolean);
					n->idxname = (yyvsp[-11].str);
					n->relation = (yyvsp[-9].range);
					n->accessMethod = (yyvsp[-8].str);
					n->indexParams = (yyvsp[-6].list);
					n->indexIncludingParams = (yyvsp[-4].list);
					n->nulls_not_distinct = !(yyvsp[-3].boolean);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNumber = InvalidRelFileNumber;
					n->oldCreateSubid = InvalidSubTransactionId;
					n->oldFirstRelfilelocatorSubid = InvalidSubTransactionId;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = false;
					n->reset_default_tblspc = false;
					(yyval.node) = (Node *) n;
				}
#line 39898 "gram.c" /* yacc.c:1646  */
    break;

  case 1091:
#line 8173 "gram.y" /* yacc.c:1646  */
    {
					IndexStmt *n = makeNode(IndexStmt);

					n->unique = (yyvsp[-17].boolean);
					n->concurrent = (yyvsp[-15].boolean);
					n->idxname = (yyvsp[-11].str);
					n->relation = (yyvsp[-9].range);
					n->accessMethod = (yyvsp[-8].str);
					n->indexParams = (yyvsp[-6].list);
					n->indexIncludingParams = (yyvsp[-4].list);
					n->nulls_not_distinct = !(yyvsp[-3].boolean);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNumber = InvalidRelFileNumber;
					n->oldCreateSubid = InvalidSubTransactionId;
					n->oldFirstRelfilelocatorSubid = InvalidSubTransactionId;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = true;
					n->reset_default_tblspc = false;
					(yyval.node) = (Node *) n;
				}
#line 39932 "gram.c" /* yacc.c:1646  */
    break;

  case 1092:
#line 8205 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 39938 "gram.c" /* yacc.c:1646  */
    break;

  case 1093:
#line 8206 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 39944 "gram.c" /* yacc.c:1646  */
    break;

  case 1094:
#line 8210 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 39950 "gram.c" /* yacc.c:1646  */
    break;

  case 1095:
#line 8211 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = DEFAULT_INDEX_TYPE; }
#line 39956 "gram.c" /* yacc.c:1646  */
    break;

  case 1096:
#line 8214 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 39962 "gram.c" /* yacc.c:1646  */
    break;

  case 1097:
#line 8215 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 39968 "gram.c" /* yacc.c:1646  */
    break;

  case 1098:
#line 8221 "gram.y" /* yacc.c:1646  */
    {
			(yyval.ielem) = makeNode(IndexElem);
			(yyval.ielem)->name = NULL;
			(yyval.ielem)->expr = NULL;
			(yyval.ielem)->indexcolname = NULL;
			(yyval.ielem)->collation = (yyvsp[-3].list);
			(yyval.ielem)->opclass = (yyvsp[-2].list);
			(yyval.ielem)->opclassopts = NIL;
			(yyval.ielem)->ordering = (yyvsp[-1].ival);
			(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
		}
#line 39984 "gram.c" /* yacc.c:1646  */
    break;

  case 1099:
#line 8233 "gram.y" /* yacc.c:1646  */
    {
			(yyval.ielem) = makeNode(IndexElem);
			(yyval.ielem)->name = NULL;
			(yyval.ielem)->expr = NULL;
			(yyval.ielem)->indexcolname = NULL;
			(yyval.ielem)->collation = (yyvsp[-4].list);
			(yyval.ielem)->opclass = (yyvsp[-3].list);
			(yyval.ielem)->opclassopts = (yyvsp[-2].list);
			(yyval.ielem)->ordering = (yyvsp[-1].ival);
			(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
		}
#line 40000 "gram.c" /* yacc.c:1646  */
    break;

  case 1100:
#line 8252 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->name = (yyvsp[-1].str);
				}
#line 40009 "gram.c" /* yacc.c:1646  */
    break;

  case 1101:
#line 8257 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->expr = (yyvsp[-1].node);
				}
#line 40018 "gram.c" /* yacc.c:1646  */
    break;

  case 1102:
#line 8262 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->expr = (yyvsp[-2].node);
				}
#line 40027 "gram.c" /* yacc.c:1646  */
    break;

  case 1103:
#line 8268 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 40033 "gram.c" /* yacc.c:1646  */
    break;

  case 1104:
#line 8269 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40039 "gram.c" /* yacc.c:1646  */
    break;

  case 1105:
#line 8272 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 40045 "gram.c" /* yacc.c:1646  */
    break;

  case 1106:
#line 8273 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 40051 "gram.c" /* yacc.c:1646  */
    break;

  case 1107:
#line 8276 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 40057 "gram.c" /* yacc.c:1646  */
    break;

  case 1108:
#line 8277 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40063 "gram.c" /* yacc.c:1646  */
    break;

  case 1109:
#line 8281 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_ASC; }
#line 40069 "gram.c" /* yacc.c:1646  */
    break;

  case 1110:
#line 8282 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DESC; }
#line 40075 "gram.c" /* yacc.c:1646  */
    break;

  case 1111:
#line 8283 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DEFAULT; }
#line 40081 "gram.c" /* yacc.c:1646  */
    break;

  case 1112:
#line 8286 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_FIRST; }
#line 40087 "gram.c" /* yacc.c:1646  */
    break;

  case 1113:
#line 8287 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_LAST; }
#line 40093 "gram.c" /* yacc.c:1646  */
    break;

  case 1114:
#line 8288 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_DEFAULT; }
#line 40099 "gram.c" /* yacc.c:1646  */
    break;

  case 1115:
#line 8306 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = false;
					n->replace = (yyvsp[-7].boolean);
					n->funcname = (yyvsp[-5].list);
					n->parameters = (yyvsp[-4].list);
					n->returnType = (yyvsp[-2].typnam);
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 40116 "gram.c" /* yacc.c:1646  */
    break;

  case 1116:
#line 8320 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = false;
					n->replace = (yyvsp[-10].boolean);
					n->funcname = (yyvsp[-8].list);
					n->parameters = mergeTableFuncParameters((yyvsp[-7].list), (yyvsp[-3].list));
					n->returnType = TableFuncTypeName((yyvsp[-3].list));
					n->returnType->location = (yylsp[-5]);
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 40134 "gram.c" /* yacc.c:1646  */
    break;

  case 1117:
#line 8335 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = false;
					n->replace = (yyvsp[-5].boolean);
					n->funcname = (yyvsp[-3].list);
					n->parameters = (yyvsp[-2].list);
					n->returnType = NULL;
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 40151 "gram.c" /* yacc.c:1646  */
    break;

  case 1118:
#line 8349 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = true;
					n->replace = (yyvsp[-5].boolean);
					n->funcname = (yyvsp[-3].list);
					n->parameters = (yyvsp[-2].list);
					n->returnType = NULL;
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 40168 "gram.c" /* yacc.c:1646  */
    break;

  case 1119:
#line 8364 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 40174 "gram.c" /* yacc.c:1646  */
    break;

  case 1120:
#line 8365 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 40180 "gram.c" /* yacc.c:1646  */
    break;

  case 1121:
#line 8368 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 40186 "gram.c" /* yacc.c:1646  */
    break;

  case 1122:
#line 8369 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40192 "gram.c" /* yacc.c:1646  */
    break;

  case 1123:
#line 8373 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 40198 "gram.c" /* yacc.c:1646  */
    break;

  case 1124:
#line 8374 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 40204 "gram.c" /* yacc.c:1646  */
    break;

  case 1125:
#line 8378 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 40210 "gram.c" /* yacc.c:1646  */
    break;

  case 1126:
#line 8380 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 40216 "gram.c" /* yacc.c:1646  */
    break;

  case 1127:
#line 8385 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = (yyvsp[-1].list);
					n->objargs = extractArgTypes((yyvsp[0].list));
					n->objfuncargs = (yyvsp[0].list);
					(yyval.objwithargs) = n;
				}
#line 40229 "gram.c" /* yacc.c:1646  */
    break;

  case 1128:
#line 8399 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = list_make1(makeString(pstrdup((yyvsp[0].keyword))));
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 40241 "gram.c" /* yacc.c:1646  */
    break;

  case 1129:
#line 8407 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = list_make1(makeString((yyvsp[0].str)));
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 40253 "gram.c" /* yacc.c:1646  */
    break;

  case 1130:
#line 8415 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
												  yyscanner);
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 40266 "gram.c" /* yacc.c:1646  */
    break;

  case 1131:
#line 8430 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 40272 "gram.c" /* yacc.c:1646  */
    break;

  case 1132:
#line 8431 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40278 "gram.c" /* yacc.c:1646  */
    break;

  case 1133:
#line 8435 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 40284 "gram.c" /* yacc.c:1646  */
    break;

  case 1134:
#line 8437 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 40290 "gram.c" /* yacc.c:1646  */
    break;

  case 1135:
#line 8452 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-2].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 40304 "gram.c" /* yacc.c:1646  */
    break;

  case 1136:
#line 8462 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-2].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 40318 "gram.c" /* yacc.c:1646  */
    break;

  case 1137:
#line 8472 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_DEFAULT;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 40332 "gram.c" /* yacc.c:1646  */
    break;

  case 1138:
#line 8482 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 40346 "gram.c" /* yacc.c:1646  */
    break;

  case 1139:
#line 8492 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_DEFAULT;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 40360 "gram.c" /* yacc.c:1646  */
    break;

  case 1140:
#line 8504 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_IN; }
#line 40366 "gram.c" /* yacc.c:1646  */
    break;

  case 1141:
#line 8505 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_OUT; }
#line 40372 "gram.c" /* yacc.c:1646  */
    break;

  case 1142:
#line 8506 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 40378 "gram.c" /* yacc.c:1646  */
    break;

  case 1143:
#line 8507 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 40384 "gram.c" /* yacc.c:1646  */
    break;

  case 1144:
#line 8508 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; }
#line 40390 "gram.c" /* yacc.c:1646  */
    break;

  case 1146:
#line 8519 "gram.y" /* yacc.c:1646  */
    {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 40402 "gram.c" /* yacc.c:1646  */
    break;

  case 1147:
#line 8533 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 40408 "gram.c" /* yacc.c:1646  */
    break;

  case 1148:
#line 8535 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 40418 "gram.c" /* yacc.c:1646  */
    break;

  case 1149:
#line 8541 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 40429 "gram.c" /* yacc.c:1646  */
    break;

  case 1150:
#line 8551 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 40437 "gram.c" /* yacc.c:1646  */
    break;

  case 1151:
#line 8555 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 40446 "gram.c" /* yacc.c:1646  */
    break;

  case 1152:
#line 8560 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 40455 "gram.c" /* yacc.c:1646  */
    break;

  case 1153:
#line 8568 "gram.y" /* yacc.c:1646  */
    {
					if (!((yyvsp[0].fun_param)->mode == FUNC_PARAM_DEFAULT ||
						  (yyvsp[0].fun_param)->mode == FUNC_PARAM_IN ||
						  (yyvsp[0].fun_param)->mode == FUNC_PARAM_VARIADIC))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("aggregates cannot have output arguments"),
								 parser_errposition((yylsp[0]))));
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 40470 "gram.c" /* yacc.c:1646  */
    break;

  case 1154:
#line 8610 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NIL, makeInteger(-1));
				}
#line 40478 "gram.c" /* yacc.c:1646  */
    break;

  case 1155:
#line 8614 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(-1));
				}
#line 40486 "gram.c" /* yacc.c:1646  */
    break;

  case 1156:
#line 8618 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(0));
				}
#line 40494 "gram.c" /* yacc.c:1646  */
    break;

  case 1157:
#line 8622 "gram.y" /* yacc.c:1646  */
    {
					/* this is the only case requiring consistency checking */
					(yyval.list) = makeOrderedSetArgs((yyvsp[-4].list), (yyvsp[-1].list), yyscanner);
				}
#line 40503 "gram.c" /* yacc.c:1646  */
    break;

  case 1158:
#line 8629 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 40509 "gram.c" /* yacc.c:1646  */
    break;

  case 1159:
#line 8630 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 40515 "gram.c" /* yacc.c:1646  */
    break;

  case 1160:
#line 8635 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = (yyvsp[-1].list);
					n->objargs = extractAggrArgTypes((yyvsp[0].list));
					n->objfuncargs = (List *) linitial((yyvsp[0].list));
					(yyval.objwithargs) = n;
				}
#line 40528 "gram.c" /* yacc.c:1646  */
    break;

  case 1161:
#line 8646 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 40534 "gram.c" /* yacc.c:1646  */
    break;

  case 1162:
#line 8648 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 40540 "gram.c" /* yacc.c:1646  */
    break;

  case 1164:
#line 8653 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40546 "gram.c" /* yacc.c:1646  */
    break;

  case 1165:
#line 8658 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 40552 "gram.c" /* yacc.c:1646  */
    break;

  case 1166:
#line 8659 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 40558 "gram.c" /* yacc.c:1646  */
    break;

  case 1167:
#line 8667 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *) makeBoolean(false), (yylsp[-3]));
				}
#line 40566 "gram.c" /* yacc.c:1646  */
    break;

  case 1168:
#line 8671 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *) makeBoolean(true), (yylsp[-4]));
				}
#line 40574 "gram.c" /* yacc.c:1646  */
    break;

  case 1169:
#line 8675 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 40582 "gram.c" /* yacc.c:1646  */
    break;

  case 1170:
#line 8679 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *) makeString("immutable"), (yylsp[0]));
				}
#line 40590 "gram.c" /* yacc.c:1646  */
    break;

  case 1171:
#line 8683 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *) makeString("stable"), (yylsp[0]));
				}
#line 40598 "gram.c" /* yacc.c:1646  */
    break;

  case 1172:
#line 8687 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *) makeString("volatile"), (yylsp[0]));
				}
#line 40606 "gram.c" /* yacc.c:1646  */
    break;

  case 1173:
#line 8691 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(true), (yylsp[-2]));
				}
#line 40614 "gram.c" /* yacc.c:1646  */
    break;

  case 1174:
#line 8695 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(false), (yylsp[-2]));
				}
#line 40622 "gram.c" /* yacc.c:1646  */
    break;

  case 1175:
#line 8699 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(true), (yylsp[-1]));
				}
#line 40630 "gram.c" /* yacc.c:1646  */
    break;

  case 1176:
#line 8703 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(false), (yylsp[-1]));
				}
#line 40638 "gram.c" /* yacc.c:1646  */
    break;

  case 1177:
#line 8707 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 40646 "gram.c" /* yacc.c:1646  */
    break;

  case 1178:
#line 8711 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *) makeBoolean(false), (yylsp[-1]));
				}
#line 40654 "gram.c" /* yacc.c:1646  */
    break;

  case 1179:
#line 8715 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cost", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 40662 "gram.c" /* yacc.c:1646  */
    break;

  case 1180:
#line 8719 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rows", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 40670 "gram.c" /* yacc.c:1646  */
    break;

  case 1181:
#line 8723 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("support", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 40678 "gram.c" /* yacc.c:1646  */
    break;

  case 1182:
#line 8727 "gram.y" /* yacc.c:1646  */
    {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *) (yyvsp[0].vsetstmt), (yylsp[0]));
				}
#line 40687 "gram.c" /* yacc.c:1646  */
    break;

  case 1183:
#line 8732 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("parallel", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 40695 "gram.c" /* yacc.c:1646  */
    break;

  case 1184:
#line 8739 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 40703 "gram.c" /* yacc.c:1646  */
    break;

  case 1185:
#line 8743 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 40711 "gram.c" /* yacc.c:1646  */
    break;

  case 1186:
#line 8747 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("transform", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 40719 "gram.c" /* yacc.c:1646  */
    break;

  case 1187:
#line 8751 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("window", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 40727 "gram.c" /* yacc.c:1646  */
    break;

  case 1188:
#line 8755 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 40735 "gram.c" /* yacc.c:1646  */
    break;

  case 1189:
#line 8760 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 40741 "gram.c" /* yacc.c:1646  */
    break;

  case 1190:
#line 8762 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeString((yyvsp[-2].str)), makeString((yyvsp[0].str)));
				}
#line 40749 "gram.c" /* yacc.c:1646  */
    break;

  case 1191:
#line 8768 "gram.y" /* yacc.c:1646  */
    {
					ReturnStmt *r = makeNode(ReturnStmt);

					r->returnval = (Node *) (yyvsp[0].node);
					(yyval.node) = (Node *) r;
				}
#line 40760 "gram.c" /* yacc.c:1646  */
    break;

  case 1192:
#line 8778 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 40768 "gram.c" /* yacc.c:1646  */
    break;

  case 1193:
#line 8782 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * A compound statement is stored as a single-item list
					 * containing the list of statements as its member.  That
					 * way, the parse analysis code can tell apart an empty
					 * body from no body at all.
					 */
					(yyval.node) = (Node *) list_make1((yyvsp[-1].list));
				}
#line 40782 "gram.c" /* yacc.c:1646  */
    break;

  case 1194:
#line 8792 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = NULL;
				}
#line 40790 "gram.c" /* yacc.c:1646  */
    break;

  case 1195:
#line 8799 "gram.y" /* yacc.c:1646  */
    {
					/* As in stmtmulti, discard empty statements */
					if ((yyvsp[-1].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[-1].node));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 40802 "gram.c" /* yacc.c:1646  */
    break;

  case 1196:
#line 8807 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = NIL;
				}
#line 40810 "gram.c" /* yacc.c:1646  */
    break;

  case 1199:
#line 8818 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 40816 "gram.c" /* yacc.c:1646  */
    break;

  case 1200:
#line 8819 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-4].list), (yyvsp[0].typnam)); }
#line 40822 "gram.c" /* yacc.c:1646  */
    break;

  case 1201:
#line 8823 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 40828 "gram.c" /* yacc.c:1646  */
    break;

  case 1202:
#line 8824 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40834 "gram.c" /* yacc.c:1646  */
    break;

  case 1203:
#line 8828 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 40848 "gram.c" /* yacc.c:1646  */
    break;

  case 1204:
#line 8841 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].fun_param));
				}
#line 40856 "gram.c" /* yacc.c:1646  */
    break;

  case 1205:
#line 8845 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param));
				}
#line 40864 "gram.c" /* yacc.c:1646  */
    break;

  case 1206:
#line 8860 "gram.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);

					n->objtype = OBJECT_FUNCTION;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 40877 "gram.c" /* yacc.c:1646  */
    break;

  case 1207:
#line 8869 "gram.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);

					n->objtype = OBJECT_PROCEDURE;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 40890 "gram.c" /* yacc.c:1646  */
    break;

  case 1208:
#line 8878 "gram.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);

					n->objtype = OBJECT_ROUTINE;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 40903 "gram.c" /* yacc.c:1646  */
    break;

  case 1209:
#line 8890 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 40909 "gram.c" /* yacc.c:1646  */
    break;

  case 1210:
#line 8891 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 40915 "gram.c" /* yacc.c:1646  */
    break;

  case 1213:
#line 8915 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_FUNCTION;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 40930 "gram.c" /* yacc.c:1646  */
    break;

  case 1214:
#line 8926 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_FUNCTION;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 40945 "gram.c" /* yacc.c:1646  */
    break;

  case 1215:
#line 8937 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_PROCEDURE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 40960 "gram.c" /* yacc.c:1646  */
    break;

  case 1216:
#line 8948 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_PROCEDURE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 40975 "gram.c" /* yacc.c:1646  */
    break;

  case 1217:
#line 8959 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_ROUTINE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 40990 "gram.c" /* yacc.c:1646  */
    break;

  case 1218:
#line 8970 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_ROUTINE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41005 "gram.c" /* yacc.c:1646  */
    break;

  case 1219:
#line 8984 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_AGGREGATE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41020 "gram.c" /* yacc.c:1646  */
    break;

  case 1220:
#line 8995 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_AGGREGATE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41035 "gram.c" /* yacc.c:1646  */
    break;

  case 1221:
#line 9009 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_OPERATOR;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41050 "gram.c" /* yacc.c:1646  */
    break;

  case 1222:
#line 9020 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_OPERATOR;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41065 "gram.c" /* yacc.c:1646  */
    break;

  case 1223:
#line 9034 "gram.y" /* yacc.c:1646  */
    {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							parser_errposition((yylsp[0]))));
				}
#line 41077 "gram.c" /* yacc.c:1646  */
    break;

  case 1224:
#line 9042 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam)); }
#line 41083 "gram.c" /* yacc.c:1646  */
    break;

  case 1225:
#line 9044 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL, (yyvsp[-1].typnam)); }
#line 41089 "gram.c" /* yacc.c:1646  */
    break;

  case 1226:
#line 9046 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), NULL); }
#line 41095 "gram.c" /* yacc.c:1646  */
    break;

  case 1227:
#line 9051 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 41101 "gram.c" /* yacc.c:1646  */
    break;

  case 1228:
#line 9053 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-2].str)), (yyvsp[0].list)); }
#line 41107 "gram.c" /* yacc.c:1646  */
    break;

  case 1229:
#line 9057 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 41113 "gram.c" /* yacc.c:1646  */
    break;

  case 1230:
#line 9059 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 41119 "gram.c" /* yacc.c:1646  */
    break;

  case 1231:
#line 9064 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = (yyvsp[-1].list);
					n->objargs = (yyvsp[0].list);
					(yyval.objwithargs) = n;
				}
#line 41131 "gram.c" /* yacc.c:1646  */
    break;

  case 1232:
#line 9083 "gram.y" /* yacc.c:1646  */
    {
					DoStmt *n = makeNode(DoStmt);

					n->args = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41142 "gram.c" /* yacc.c:1646  */
    break;

  case 1233:
#line 9092 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 41148 "gram.c" /* yacc.c:1646  */
    break;

  case 1234:
#line 9093 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 41154 "gram.c" /* yacc.c:1646  */
    break;

  case 1235:
#line 9098 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *) makeString((yyvsp[0].str)), (yylsp[0]));
				}
#line 41162 "gram.c" /* yacc.c:1646  */
    break;

  case 1236:
#line 9102 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 41170 "gram.c" /* yacc.c:1646  */
    break;

  case 1237:
#line 9115 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);

					n->sourcetype = (yyvsp[-7].typnam);
					n->targettype = (yyvsp[-5].typnam);
					n->func = (yyvsp[-1].objwithargs);
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *) n;
				}
#line 41185 "gram.c" /* yacc.c:1646  */
    break;

  case 1238:
#line 9127 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);

					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *) n;
				}
#line 41200 "gram.c" /* yacc.c:1646  */
    break;

  case 1239:
#line 9139 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);

					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = true;
					(yyval.node) = (Node *) n;
				}
#line 41215 "gram.c" /* yacc.c:1646  */
    break;

  case 1240:
#line 9151 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_IMPLICIT; }
#line 41221 "gram.c" /* yacc.c:1646  */
    break;

  case 1241:
#line 9152 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_ASSIGNMENT; }
#line 41227 "gram.c" /* yacc.c:1646  */
    break;

  case 1242:
#line 9153 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_EXPLICIT; }
#line 41233 "gram.c" /* yacc.c:1646  */
    break;

  case 1243:
#line 9158 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_CAST;
					n->objects = list_make1(list_make2((yyvsp[-4].typnam), (yyvsp[-2].typnam)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-6].boolean);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41248 "gram.c" /* yacc.c:1646  */
    break;

  case 1244:
#line 9170 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 41254 "gram.c" /* yacc.c:1646  */
    break;

  case 1245:
#line 9171 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 41260 "gram.c" /* yacc.c:1646  */
    break;

  case 1246:
#line 9182 "gram.y" /* yacc.c:1646  */
    {
					CreateTransformStmt *n = makeNode(CreateTransformStmt);

					n->replace = (yyvsp[-8].boolean);
					n->type_name = (yyvsp[-5].typnam);
					n->lang = (yyvsp[-3].str);
					n->fromsql = linitial((yyvsp[-1].list));
					n->tosql = lsecond((yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 41275 "gram.c" /* yacc.c:1646  */
    break;

  case 1247:
#line 9195 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-6].objwithargs), (yyvsp[0].objwithargs));
				}
#line 41283 "gram.c" /* yacc.c:1646  */
    break;

  case 1248:
#line 9199 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].objwithargs), (yyvsp[-6].objwithargs));
				}
#line 41291 "gram.c" /* yacc.c:1646  */
    break;

  case 1249:
#line 9203 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].objwithargs), NULL);
				}
#line 41299 "gram.c" /* yacc.c:1646  */
    break;

  case 1250:
#line 9207 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, (yyvsp[0].objwithargs));
				}
#line 41307 "gram.c" /* yacc.c:1646  */
    break;

  case 1251:
#line 9214 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_TRANSFORM;
					n->objects = list_make1(list_make2((yyvsp[-3].typnam), makeString((yyvsp[-1].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-5].boolean);
					(yyval.node) = (Node *) n;
				}
#line 41321 "gram.c" /* yacc.c:1646  */
    break;

  case 1252:
#line 9236 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);

					n->kind = (yyvsp[-2].ival);
					n->relation = (yyvsp[0].range);
					n->name = NULL;
					n->params = (yyvsp[-3].list);
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
											makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 41338 "gram.c" /* yacc.c:1646  */
    break;

  case 1253:
#line 9249 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);

					n->kind = REINDEX_OBJECT_SCHEMA;
					n->relation = NULL;
					n->name = (yyvsp[0].str);
					n->params = (yyvsp[-3].list);
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
											makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 41355 "gram.c" /* yacc.c:1646  */
    break;

  case 1254:
#line 9262 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);

					n->kind = (yyvsp[-2].ival);
					n->relation = NULL;
					n->name = (yyvsp[0].str);
					n->params = (yyvsp[-3].list);
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
											makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 41372 "gram.c" /* yacc.c:1646  */
    break;

  case 1255:
#line 9276 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_INDEX; }
#line 41378 "gram.c" /* yacc.c:1646  */
    break;

  case 1256:
#line 9277 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_TABLE; }
#line 41384 "gram.c" /* yacc.c:1646  */
    break;

  case 1257:
#line 9280 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_SYSTEM; }
#line 41390 "gram.c" /* yacc.c:1646  */
    break;

  case 1258:
#line 9281 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_DATABASE; }
#line 41396 "gram.c" /* yacc.c:1646  */
    break;

  case 1259:
#line 9284 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 41402 "gram.c" /* yacc.c:1646  */
    break;

  case 1260:
#line 9285 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NULL; }
#line 41408 "gram.c" /* yacc.c:1646  */
    break;

  case 1261:
#line 9296 "gram.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);

					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = false;
					(yyval.node) = (Node *) n;
				}
#line 41422 "gram.c" /* yacc.c:1646  */
    break;

  case 1262:
#line 9306 "gram.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);

					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = true;
					(yyval.node) = (Node *) n;
				}
#line 41436 "gram.c" /* yacc.c:1646  */
    break;

  case 1263:
#line 9324 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41450 "gram.c" /* yacc.c:1646  */
    break;

  case 1264:
#line 9334 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41464 "gram.c" /* yacc.c:1646  */
    break;

  case 1265:
#line 9344 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41478 "gram.c" /* yacc.c:1646  */
    break;

  case 1266:
#line 9354 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41492 "gram.c" /* yacc.c:1646  */
    break;

  case 1267:
#line 9364 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41506 "gram.c" /* yacc.c:1646  */
    break;

  case 1268:
#line 9374 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_DOMCONSTRAINT;
					n->object = (Node *) (yyvsp[-5].list);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 41520 "gram.c" /* yacc.c:1646  */
    break;

  case 1269:
#line 9384 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41534 "gram.c" /* yacc.c:1646  */
    break;

  case 1270:
#line 9394 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41548 "gram.c" /* yacc.c:1646  */
    break;

  case 1271:
#line 9404 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41562 "gram.c" /* yacc.c:1646  */
    break;

  case 1272:
#line 9414 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41576 "gram.c" /* yacc.c:1646  */
    break;

  case 1273:
#line 9424 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41590 "gram.c" /* yacc.c:1646  */
    break;

  case 1274:
#line 9434 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41604 "gram.c" /* yacc.c:1646  */
    break;

  case 1275:
#line 9444 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41619 "gram.c" /* yacc.c:1646  */
    break;

  case 1276:
#line 9455 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41634 "gram.c" /* yacc.c:1646  */
    break;

  case 1277:
#line 9466 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41648 "gram.c" /* yacc.c:1646  */
    break;

  case 1278:
#line 9476 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_PUBLICATION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41662 "gram.c" /* yacc.c:1646  */
    break;

  case 1279:
#line 9486 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41676 "gram.c" /* yacc.c:1646  */
    break;

  case 1280:
#line 9496 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41690 "gram.c" /* yacc.c:1646  */
    break;

  case 1281:
#line 9506 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41704 "gram.c" /* yacc.c:1646  */
    break;

  case 1282:
#line 9516 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SUBSCRIPTION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41718 "gram.c" /* yacc.c:1646  */
    break;

  case 1283:
#line 9526 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41733 "gram.c" /* yacc.c:1646  */
    break;

  case 1284:
#line 9537 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41748 "gram.c" /* yacc.c:1646  */
    break;

  case 1285:
#line 9548 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41763 "gram.c" /* yacc.c:1646  */
    break;

  case 1286:
#line 9559 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41778 "gram.c" /* yacc.c:1646  */
    break;

  case 1287:
#line 9570 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41793 "gram.c" /* yacc.c:1646  */
    break;

  case 1288:
#line 9581 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41808 "gram.c" /* yacc.c:1646  */
    break;

  case 1289:
#line 9592 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41823 "gram.c" /* yacc.c:1646  */
    break;

  case 1290:
#line 9603 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41838 "gram.c" /* yacc.c:1646  */
    break;

  case 1291:
#line 9614 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41853 "gram.c" /* yacc.c:1646  */
    break;

  case 1292:
#line 9625 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41868 "gram.c" /* yacc.c:1646  */
    break;

  case 1293:
#line 9636 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41883 "gram.c" /* yacc.c:1646  */
    break;

  case 1294:
#line 9647 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41898 "gram.c" /* yacc.c:1646  */
    break;

  case 1295:
#line 9658 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41914 "gram.c" /* yacc.c:1646  */
    break;

  case 1296:
#line 9670 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41930 "gram.c" /* yacc.c:1646  */
    break;

  case 1297:
#line 9682 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_VIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41946 "gram.c" /* yacc.c:1646  */
    break;

  case 1298:
#line 9694 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_VIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41962 "gram.c" /* yacc.c:1646  */
    break;

  case 1299:
#line 9706 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41978 "gram.c" /* yacc.c:1646  */
    break;

  case 1300:
#line 9718 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41994 "gram.c" /* yacc.c:1646  */
    break;

  case 1301:
#line 9730 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42009 "gram.c" /* yacc.c:1646  */
    break;

  case 1302:
#line 9741 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42024 "gram.c" /* yacc.c:1646  */
    break;

  case 1303:
#line 9752 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42040 "gram.c" /* yacc.c:1646  */
    break;

  case 1304:
#line 9764 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42056 "gram.c" /* yacc.c:1646  */
    break;

  case 1305:
#line 9776 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_RULE;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42071 "gram.c" /* yacc.c:1646  */
    break;

  case 1306:
#line 9787 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42086 "gram.c" /* yacc.c:1646  */
    break;

  case 1307:
#line 9798 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42099 "gram.c" /* yacc.c:1646  */
    break;

  case 1308:
#line 9807 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42113 "gram.c" /* yacc.c:1646  */
    break;

  case 1309:
#line 9817 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42127 "gram.c" /* yacc.c:1646  */
    break;

  case 1310:
#line 9827 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42141 "gram.c" /* yacc.c:1646  */
    break;

  case 1311:
#line 9837 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42155 "gram.c" /* yacc.c:1646  */
    break;

  case 1312:
#line 9847 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42169 "gram.c" /* yacc.c:1646  */
    break;

  case 1313:
#line 9857 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42183 "gram.c" /* yacc.c:1646  */
    break;

  case 1314:
#line 9867 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42197 "gram.c" /* yacc.c:1646  */
    break;

  case 1315:
#line 9877 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42211 "gram.c" /* yacc.c:1646  */
    break;

  case 1316:
#line 9887 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42225 "gram.c" /* yacc.c:1646  */
    break;

  case 1317:
#line 9897 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ATTRIBUTE;
					n->relationType = OBJECT_TYPE;
					n->relation = makeRangeVarFromAnyName((yyvsp[-6].list), (yylsp[-6]), yyscanner);
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42242 "gram.c" /* yacc.c:1646  */
    break;

  case 1320:
#line 9915 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 1; }
#line 42248 "gram.c" /* yacc.c:1646  */
    break;

  case 1321:
#line 9916 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 42254 "gram.c" /* yacc.c:1646  */
    break;

  case 1322:
#line 9927 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 42268 "gram.c" /* yacc.c:1646  */
    break;

  case 1323:
#line 9937 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 42282 "gram.c" /* yacc.c:1646  */
    break;

  case 1324:
#line 9947 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 42296 "gram.c" /* yacc.c:1646  */
    break;

  case 1325:
#line 9957 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-5].range);
					n->object = (Node *) list_make1(makeString((yyvsp[-7].str)));
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 42311 "gram.c" /* yacc.c:1646  */
    break;

  case 1326:
#line 9968 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 42325 "gram.c" /* yacc.c:1646  */
    break;

  case 1327:
#line 9978 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_INDEX;
					n->relation = (yyvsp[-5].range);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 42339 "gram.c" /* yacc.c:1646  */
    break;

  case 1328:
#line 9989 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 42345 "gram.c" /* yacc.c:1646  */
    break;

  case 1329:
#line 9990 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false;	}
#line 42351 "gram.c" /* yacc.c:1646  */
    break;

  case 1330:
#line 10001 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42365 "gram.c" /* yacc.c:1646  */
    break;

  case 1331:
#line 10011 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42379 "gram.c" /* yacc.c:1646  */
    break;

  case 1332:
#line 10021 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42393 "gram.c" /* yacc.c:1646  */
    break;

  case 1333:
#line 10031 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42407 "gram.c" /* yacc.c:1646  */
    break;

  case 1334:
#line 10041 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_EXTENSION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42421 "gram.c" /* yacc.c:1646  */
    break;

  case 1335:
#line 10051 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42435 "gram.c" /* yacc.c:1646  */
    break;

  case 1336:
#line 10061 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42449 "gram.c" /* yacc.c:1646  */
    break;

  case 1337:
#line 10071 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42463 "gram.c" /* yacc.c:1646  */
    break;

  case 1338:
#line 10081 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42477 "gram.c" /* yacc.c:1646  */
    break;

  case 1339:
#line 10091 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42491 "gram.c" /* yacc.c:1646  */
    break;

  case 1340:
#line 10101 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42505 "gram.c" /* yacc.c:1646  */
    break;

  case 1341:
#line 10111 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42519 "gram.c" /* yacc.c:1646  */
    break;

  case 1342:
#line 10121 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42533 "gram.c" /* yacc.c:1646  */
    break;

  case 1343:
#line 10131 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42547 "gram.c" /* yacc.c:1646  */
    break;

  case 1344:
#line 10141 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42561 "gram.c" /* yacc.c:1646  */
    break;

  case 1345:
#line 10151 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42575 "gram.c" /* yacc.c:1646  */
    break;

  case 1346:
#line 10161 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42589 "gram.c" /* yacc.c:1646  */
    break;

  case 1347:
#line 10171 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42603 "gram.c" /* yacc.c:1646  */
    break;

  case 1348:
#line 10181 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42617 "gram.c" /* yacc.c:1646  */
    break;

  case 1349:
#line 10191 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42631 "gram.c" /* yacc.c:1646  */
    break;

  case 1350:
#line 10201 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42645 "gram.c" /* yacc.c:1646  */
    break;

  case 1351:
#line 10211 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42659 "gram.c" /* yacc.c:1646  */
    break;

  case 1352:
#line 10221 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42673 "gram.c" /* yacc.c:1646  */
    break;

  case 1353:
#line 10231 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42687 "gram.c" /* yacc.c:1646  */
    break;

  case 1354:
#line 10241 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42701 "gram.c" /* yacc.c:1646  */
    break;

  case 1355:
#line 10251 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42715 "gram.c" /* yacc.c:1646  */
    break;

  case 1356:
#line 10261 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42729 "gram.c" /* yacc.c:1646  */
    break;

  case 1357:
#line 10280 "gram.y" /* yacc.c:1646  */
    {
					AlterOperatorStmt *n = makeNode(AlterOperatorStmt);

					n->opername = (yyvsp[-4].objwithargs);
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 42741 "gram.c" /* yacc.c:1646  */
    break;

  case 1358:
#line 10289 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 42747 "gram.c" /* yacc.c:1646  */
    break;

  case 1359:
#line 10290 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 42753 "gram.c" /* yacc.c:1646  */
    break;

  case 1360:
#line 10294 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL, (yylsp[-2])); }
#line 42759 "gram.c" /* yacc.c:1646  */
    break;

  case 1361:
#line 10296 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2])); }
#line 42765 "gram.c" /* yacc.c:1646  */
    break;

  case 1362:
#line 10298 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0])); }
#line 42771 "gram.c" /* yacc.c:1646  */
    break;

  case 1363:
#line 10303 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].typnam); }
#line 42777 "gram.c" /* yacc.c:1646  */
    break;

  case 1364:
#line 10304 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString(pstrdup((yyvsp[0].keyword))); }
#line 42783 "gram.c" /* yacc.c:1646  */
    break;

  case 1365:
#line 10305 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].list); }
#line 42789 "gram.c" /* yacc.c:1646  */
    break;

  case 1366:
#line 10306 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 42795 "gram.c" /* yacc.c:1646  */
    break;

  case 1367:
#line 10307 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 42801 "gram.c" /* yacc.c:1646  */
    break;

  case 1368:
#line 10320 "gram.y" /* yacc.c:1646  */
    {
					AlterTypeStmt *n = makeNode(AlterTypeStmt);

					n->typeName = (yyvsp[-4].list);
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 42813 "gram.c" /* yacc.c:1646  */
    break;

  case 1369:
#line 10336 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42826 "gram.c" /* yacc.c:1646  */
    break;

  case 1370:
#line 10345 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42839 "gram.c" /* yacc.c:1646  */
    break;

  case 1371:
#line 10354 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42852 "gram.c" /* yacc.c:1646  */
    break;

  case 1372:
#line 10363 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_DATABASE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42865 "gram.c" /* yacc.c:1646  */
    break;

  case 1373:
#line 10372 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42878 "gram.c" /* yacc.c:1646  */
    break;

  case 1374:
#line 10381 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42891 "gram.c" /* yacc.c:1646  */
    break;

  case 1375:
#line 10390 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42904 "gram.c" /* yacc.c:1646  */
    break;

  case 1376:
#line 10399 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-3].node);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42917 "gram.c" /* yacc.c:1646  */
    break;

  case 1377:
#line 10408 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42930 "gram.c" /* yacc.c:1646  */
    break;

  case 1378:
#line 10417 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42943 "gram.c" /* yacc.c:1646  */
    break;

  case 1379:
#line 10426 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42956 "gram.c" /* yacc.c:1646  */
    break;

  case 1380:
#line 10435 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42969 "gram.c" /* yacc.c:1646  */
    break;

  case 1381:
#line 10444 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42982 "gram.c" /* yacc.c:1646  */
    break;

  case 1382:
#line 10453 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_SCHEMA;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 42995 "gram.c" /* yacc.c:1646  */
    break;

  case 1383:
#line 10462 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43008 "gram.c" /* yacc.c:1646  */
    break;

  case 1384:
#line 10471 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TABLESPACE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43021 "gram.c" /* yacc.c:1646  */
    break;

  case 1385:
#line 10480 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43034 "gram.c" /* yacc.c:1646  */
    break;

  case 1386:
#line 10489 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43047 "gram.c" /* yacc.c:1646  */
    break;

  case 1387:
#line 10498 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43060 "gram.c" /* yacc.c:1646  */
    break;

  case 1388:
#line 10507 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43073 "gram.c" /* yacc.c:1646  */
    break;

  case 1389:
#line 10516 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43086 "gram.c" /* yacc.c:1646  */
    break;

  case 1390:
#line 10525 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43099 "gram.c" /* yacc.c:1646  */
    break;

  case 1391:
#line 10534 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_PUBLICATION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43112 "gram.c" /* yacc.c:1646  */
    break;

  case 1392:
#line 10543 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_SUBSCRIPTION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43125 "gram.c" /* yacc.c:1646  */
    break;

  case 1393:
#line 10571 "gram.y" /* yacc.c:1646  */
    {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);

					n->pubname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43137 "gram.c" /* yacc.c:1646  */
    break;

  case 1394:
#line 10579 "gram.y" /* yacc.c:1646  */
    {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);

					n->pubname = (yyvsp[-4].str);
					n->options = (yyvsp[0].list);
					n->for_all_tables = true;
					(yyval.node) = (Node *) n;
				}
#line 43150 "gram.c" /* yacc.c:1646  */
    break;

  case 1395:
#line 10588 "gram.y" /* yacc.c:1646  */
    {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);

					n->pubname = (yyvsp[-3].str);
					n->options = (yyvsp[0].list);
					n->pubobjects = (List *) (yyvsp[-1].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 43164 "gram.c" /* yacc.c:1646  */
    break;

  case 1396:
#line 10614 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_TABLE;
					(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
					(yyval.publicationobjectspec)->pubtable->relation = (yyvsp[-2].range);
					(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
					(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
				}
#line 43177 "gram.c" /* yacc.c:1646  */
    break;

  case 1397:
#line 10623 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_TABLES_IN_SCHEMA;
					(yyval.publicationobjectspec)->name = (yyvsp[0].str);
					(yyval.publicationobjectspec)->location = (yylsp[0]);
				}
#line 43188 "gram.c" /* yacc.c:1646  */
    break;

  case 1398:
#line 10630 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_TABLES_IN_CUR_SCHEMA;
					(yyval.publicationobjectspec)->location = (yylsp[0]);
				}
#line 43198 "gram.c" /* yacc.c:1646  */
    break;

  case 1399:
#line 10636 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					/*
					 * If either a row filter or column list is specified, create
					 * a PublicationTable object.
					 */
					if ((yyvsp[-1].list) || (yyvsp[0].node))
					{
						/*
						 * The OptWhereClause must be stored here but it is
						 * valid only for tables. For non-table objects, an
						 * error will be thrown later via
						 * preprocess_pubobj_list().
						 */
						(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
						(yyval.publicationobjectspec)->pubtable->relation = makeRangeVar(NULL, (yyvsp[-2].str), (yylsp[-2]));
						(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
						(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
					}
					else
					{
						(yyval.publicationobjectspec)->name = (yyvsp[-2].str);
					}
					(yyval.publicationobjectspec)->location = (yylsp[-2]);
				}
#line 43229 "gram.c" /* yacc.c:1646  */
    break;

  case 1400:
#line 10663 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
					(yyval.publicationobjectspec)->pubtable->relation = makeRangeVarFromQualifiedName((yyvsp[-3].str), (yyvsp[-2].list), (yylsp[-3]), yyscanner);
					(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
					(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
					(yyval.publicationobjectspec)->location = (yylsp[-3]);
				}
#line 43243 "gram.c" /* yacc.c:1646  */
    break;

  case 1401:
#line 10674 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
					(yyval.publicationobjectspec)->pubtable->relation = (yyvsp[-2].range);
					(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
					(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
				}
#line 43256 "gram.c" /* yacc.c:1646  */
    break;

  case 1402:
#line 10683 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					(yyval.publicationobjectspec)->location = (yylsp[0]);
				}
#line 43266 "gram.c" /* yacc.c:1646  */
    break;

  case 1403:
#line 10691 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].publicationobjectspec)); }
#line 43272 "gram.c" /* yacc.c:1646  */
    break;

  case 1404:
#line 10693 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].publicationobjectspec)); }
#line 43278 "gram.c" /* yacc.c:1646  */
    break;

  case 1405:
#line 10715 "gram.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43290 "gram.c" /* yacc.c:1646  */
    break;

  case 1406:
#line 10723 "gram.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->pubobjects = (yyvsp[0].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					n->action = AP_AddObjects;
					(yyval.node) = (Node *) n;
				}
#line 43304 "gram.c" /* yacc.c:1646  */
    break;

  case 1407:
#line 10733 "gram.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->pubobjects = (yyvsp[0].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					n->action = AP_SetObjects;
					(yyval.node) = (Node *) n;
				}
#line 43318 "gram.c" /* yacc.c:1646  */
    break;

  case 1408:
#line 10743 "gram.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->pubobjects = (yyvsp[0].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					n->action = AP_DropObjects;
					(yyval.node) = (Node *) n;
				}
#line 43332 "gram.c" /* yacc.c:1646  */
    break;

  case 1409:
#line 10762 "gram.y" /* yacc.c:1646  */
    {
					CreateSubscriptionStmt *n =
						makeNode(CreateSubscriptionStmt);
					n->subname = (yyvsp[-5].str);
					n->conninfo = (yyvsp[-3].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43346 "gram.c" /* yacc.c:1646  */
    break;

  case 1410:
#line 10781 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_OPTIONS;
					n->subname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43360 "gram.c" /* yacc.c:1646  */
    break;

  case 1411:
#line 10791 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_CONNECTION;
					n->subname = (yyvsp[-2].str);
					n->conninfo = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 43374 "gram.c" /* yacc.c:1646  */
    break;

  case 1412:
#line 10801 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_REFRESH;
					n->subname = (yyvsp[-3].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43388 "gram.c" /* yacc.c:1646  */
    break;

  case 1413:
#line 10811 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_ADD_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43403 "gram.c" /* yacc.c:1646  */
    break;

  case 1414:
#line 10822 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_DROP_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43418 "gram.c" /* yacc.c:1646  */
    break;

  case 1415:
#line 10833 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_SET_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43433 "gram.c" /* yacc.c:1646  */
    break;

  case 1416:
#line 10844 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_ENABLED;
					n->subname = (yyvsp[-1].str);
					n->options = list_make1(makeDefElem("enabled",
											(Node *) makeBoolean(true), (yylsp[-3])));
					(yyval.node) = (Node *) n;
				}
#line 43448 "gram.c" /* yacc.c:1646  */
    break;

  case 1417:
#line 10855 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_ENABLED;
					n->subname = (yyvsp[-1].str);
					n->options = list_make1(makeDefElem("enabled",
											(Node *) makeBoolean(false), (yylsp[-3])));
					(yyval.node) = (Node *) n;
				}
#line 43463 "gram.c" /* yacc.c:1646  */
    break;

  case 1418:
#line 10866 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_SKIP;
					n->subname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43477 "gram.c" /* yacc.c:1646  */
    break;

  case 1419:
#line 10884 "gram.y" /* yacc.c:1646  */
    {
					DropSubscriptionStmt *n = makeNode(DropSubscriptionStmt);

					n->subname = (yyvsp[-1].str);
					n->missing_ok = false;
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 43490 "gram.c" /* yacc.c:1646  */
    break;

  case 1420:
#line 10893 "gram.y" /* yacc.c:1646  */
    {
					DropSubscriptionStmt *n = makeNode(DropSubscriptionStmt);

					n->subname = (yyvsp[-1].str);
					n->missing_ok = true;
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 43503 "gram.c" /* yacc.c:1646  */
    break;

  case 1421:
#line 10912 "gram.y" /* yacc.c:1646  */
    {
					RuleStmt   *n = makeNode(RuleStmt);

					n->replace = (yyvsp[-11].boolean);
					n->relation = (yyvsp[-4].range);
					n->rulename = (yyvsp[-9].str);
					n->whereClause = (yyvsp[-3].node);
					n->event = (yyvsp[-6].ival);
					n->instead = (yyvsp[-1].boolean);
					n->actions = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43520 "gram.c" /* yacc.c:1646  */
    break;

  case 1422:
#line 10927 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 43526 "gram.c" /* yacc.c:1646  */
    break;

  case 1423:
#line 10928 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 43532 "gram.c" /* yacc.c:1646  */
    break;

  case 1424:
#line 10929 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 43538 "gram.c" /* yacc.c:1646  */
    break;

  case 1425:
#line 10935 "gram.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				  else
					(yyval.list) = (yyvsp[-2].list);
				}
#line 43548 "gram.c" /* yacc.c:1646  */
    break;

  case 1426:
#line 10941 "gram.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = list_make1((yyvsp[0].node));
				  else
					(yyval.list) = NIL;
				}
#line 43558 "gram.c" /* yacc.c:1646  */
    break;

  case 1432:
#line 10957 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 43564 "gram.c" /* yacc.c:1646  */
    break;

  case 1433:
#line 10958 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 43570 "gram.c" /* yacc.c:1646  */
    break;

  case 1434:
#line 10961 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_SELECT; }
#line 43576 "gram.c" /* yacc.c:1646  */
    break;

  case 1435:
#line 10962 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_UPDATE; }
#line 43582 "gram.c" /* yacc.c:1646  */
    break;

  case 1436:
#line 10963 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_DELETE; }
#line 43588 "gram.c" /* yacc.c:1646  */
    break;

  case 1437:
#line 10964 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_INSERT; }
#line 43594 "gram.c" /* yacc.c:1646  */
    break;

  case 1438:
#line 10968 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 43600 "gram.c" /* yacc.c:1646  */
    break;

  case 1439:
#line 10969 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 43606 "gram.c" /* yacc.c:1646  */
    break;

  case 1440:
#line 10970 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 43612 "gram.c" /* yacc.c:1646  */
    break;

  case 1441:
#line 10983 "gram.y" /* yacc.c:1646  */
    {
					NotifyStmt *n = makeNode(NotifyStmt);

					n->conditionname = (yyvsp[-1].str);
					n->payload = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 43624 "gram.c" /* yacc.c:1646  */
    break;

  case 1442:
#line 10993 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 43630 "gram.c" /* yacc.c:1646  */
    break;

  case 1443:
#line 10994 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 43636 "gram.c" /* yacc.c:1646  */
    break;

  case 1444:
#line 10998 "gram.y" /* yacc.c:1646  */
    {
					ListenStmt *n = makeNode(ListenStmt);

					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 43647 "gram.c" /* yacc.c:1646  */
    break;

  case 1445:
#line 11008 "gram.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);

					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 43658 "gram.c" /* yacc.c:1646  */
    break;

  case 1446:
#line 11015 "gram.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);

					n->conditionname = NULL;
					(yyval.node) = (Node *) n;
				}
#line 43669 "gram.c" /* yacc.c:1646  */
    break;

  case 1447:
#line 11035 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					n->location = -1;
					(yyval.node) = (Node *) n;
				}
#line 43683 "gram.c" /* yacc.c:1646  */
    break;

  case 1448:
#line 11045 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[0].list);
					n->location = -1;
					(yyval.node) = (Node *) n;
				}
#line 43696 "gram.c" /* yacc.c:1646  */
    break;

  case 1449:
#line 11054 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					n->location = -1;
					(yyval.node) = (Node *) n;
				}
#line 43710 "gram.c" /* yacc.c:1646  */
    break;

  case 1450:
#line 11064 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					n->location = -1;
					(yyval.node) = (Node *) n;
				}
#line 43724 "gram.c" /* yacc.c:1646  */
    break;

  case 1451:
#line 11074 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_SAVEPOINT;
					n->savepoint_name = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 43737 "gram.c" /* yacc.c:1646  */
    break;

  case 1452:
#line 11083 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_RELEASE;
					n->savepoint_name = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 43750 "gram.c" /* yacc.c:1646  */
    break;

  case 1453:
#line 11092 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_RELEASE;
					n->savepoint_name = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 43763 "gram.c" /* yacc.c:1646  */
    break;

  case 1454:
#line 11101 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->savepoint_name = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 43776 "gram.c" /* yacc.c:1646  */
    break;

  case 1455:
#line 11110 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->savepoint_name = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 43789 "gram.c" /* yacc.c:1646  */
    break;

  case 1456:
#line 11119 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 43802 "gram.c" /* yacc.c:1646  */
    break;

  case 1457:
#line 11128 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 43815 "gram.c" /* yacc.c:1646  */
    break;

  case 1458:
#line 11137 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 43828 "gram.c" /* yacc.c:1646  */
    break;

  case 1459:
#line 11149 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[0].list);
					n->location = -1;
					(yyval.node) = (Node *) n;
				}
#line 43841 "gram.c" /* yacc.c:1646  */
    break;

  case 1460:
#line 11158 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					n->location = -1;
					(yyval.node) = (Node *) n;
				}
#line 43855 "gram.c" /* yacc.c:1646  */
    break;

  case 1464:
#line 11176 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[0].str), (yylsp[0])), (yylsp[-2])); }
#line 43862 "gram.c" /* yacc.c:1646  */
    break;

  case 1465:
#line 11179 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(true, (yylsp[-1])), (yylsp[-1])); }
#line 43869 "gram.c" /* yacc.c:1646  */
    break;

  case 1466:
#line 11182 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(false, (yylsp[-1])), (yylsp[-1])); }
#line 43876 "gram.c" /* yacc.c:1646  */
    break;

  case 1467:
#line 11185 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(true, (yylsp[0])), (yylsp[0])); }
#line 43883 "gram.c" /* yacc.c:1646  */
    break;

  case 1468:
#line 11188 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(false, (yylsp[-1])), (yylsp[-1])); }
#line 43890 "gram.c" /* yacc.c:1646  */
    break;

  case 1469:
#line 11195 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 43896 "gram.c" /* yacc.c:1646  */
    break;

  case 1470:
#line 11197 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 43902 "gram.c" /* yacc.c:1646  */
    break;

  case 1471:
#line 11199 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 43908 "gram.c" /* yacc.c:1646  */
    break;

  case 1473:
#line 11205 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 43914 "gram.c" /* yacc.c:1646  */
    break;

  case 1474:
#line 11209 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 43920 "gram.c" /* yacc.c:1646  */
    break;

  case 1475:
#line 11210 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 43926 "gram.c" /* yacc.c:1646  */
    break;

  case 1476:
#line 11211 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 43932 "gram.c" /* yacc.c:1646  */
    break;

  case 1477:
#line 11225 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 43949 "gram.c" /* yacc.c:1646  */
    break;

  case 1478:
#line 11239 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 43966 "gram.c" /* yacc.c:1646  */
    break;

  case 1479:
#line 11253 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 43988 "gram.c" /* yacc.c:1646  */
    break;

  case 1480:
#line 11272 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 44010 "gram.c" /* yacc.c:1646  */
    break;

  case 1481:
#line 11292 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 44016 "gram.c" /* yacc.c:1646  */
    break;

  case 1482:
#line 11293 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 44022 "gram.c" /* yacc.c:1646  */
    break;

  case 1483:
#line 11294 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LOCAL_CHECK_OPTION; }
#line 44028 "gram.c" /* yacc.c:1646  */
    break;

  case 1484:
#line 11295 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = NO_CHECK_OPTION; }
#line 44034 "gram.c" /* yacc.c:1646  */
    break;

  case 1485:
#line 11306 "gram.y" /* yacc.c:1646  */
    {
					LoadStmt   *n = makeNode(LoadStmt);

					n->filename = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 44045 "gram.c" /* yacc.c:1646  */
    break;

  case 1486:
#line 11323 "gram.y" /* yacc.c:1646  */
    {
					CreatedbStmt *n = makeNode(CreatedbStmt);

					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 44057 "gram.c" /* yacc.c:1646  */
    break;

  case 1487:
#line 11333 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 44063 "gram.c" /* yacc.c:1646  */
    break;

  case 1488:
#line 11334 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 44069 "gram.c" /* yacc.c:1646  */
    break;

  case 1489:
#line 11338 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 44075 "gram.c" /* yacc.c:1646  */
    break;

  case 1490:
#line 11339 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 44081 "gram.c" /* yacc.c:1646  */
    break;

  case 1491:
#line 11344 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (yyvsp[0].node), (yylsp[-2]));
				}
#line 44089 "gram.c" /* yacc.c:1646  */
    break;

  case 1492:
#line 11348 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 44097 "gram.c" /* yacc.c:1646  */
    break;

  case 1493:
#line 11352 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL, (yylsp[-2]));
				}
#line 44105 "gram.c" /* yacc.c:1646  */
    break;

  case 1494:
#line 11369 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 44111 "gram.c" /* yacc.c:1646  */
    break;

  case 1495:
#line 11370 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup("connection_limit"); }
#line 44117 "gram.c" /* yacc.c:1646  */
    break;

  case 1496:
#line 11371 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 44123 "gram.c" /* yacc.c:1646  */
    break;

  case 1497:
#line 11372 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 44129 "gram.c" /* yacc.c:1646  */
    break;

  case 1498:
#line 11373 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 44135 "gram.c" /* yacc.c:1646  */
    break;

  case 1499:
#line 11374 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 44141 "gram.c" /* yacc.c:1646  */
    break;

  case 1500:
#line 11375 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 44147 "gram.c" /* yacc.c:1646  */
    break;

  case 1503:
#line 11395 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);

					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 44159 "gram.c" /* yacc.c:1646  */
    break;

  case 1504:
#line 11403 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);

					n->dbname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 44171 "gram.c" /* yacc.c:1646  */
    break;

  case 1505:
#line 11411 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);

					n->dbname = (yyvsp[-3].str);
					n->options = list_make1(makeDefElem("tablespace",
														(Node *) makeString((yyvsp[0].str)), (yylsp[0])));
					(yyval.node) = (Node *) n;
				 }
#line 44184 "gram.c" /* yacc.c:1646  */
    break;

  case 1506:
#line 11420 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseRefreshCollStmt *n = makeNode(AlterDatabaseRefreshCollStmt);

					n->dbname = (yyvsp[-3].str);
					(yyval.node) = (Node *) n;
				 }
#line 44195 "gram.c" /* yacc.c:1646  */
    break;

  case 1507:
#line 11430 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);

					n->dbname = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 44207 "gram.c" /* yacc.c:1646  */
    break;

  case 1508:
#line 11448 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[0].str);
					n->missing_ok = false;
					n->options = NULL;
					(yyval.node) = (Node *) n;
				}
#line 44220 "gram.c" /* yacc.c:1646  */
    break;

  case 1509:
#line 11457 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[0].str);
					n->missing_ok = true;
					n->options = NULL;
					(yyval.node) = (Node *) n;
				}
#line 44233 "gram.c" /* yacc.c:1646  */
    break;

  case 1510:
#line 11466 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[-4].str);
					n->missing_ok = false;
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 44246 "gram.c" /* yacc.c:1646  */
    break;

  case 1511:
#line 11475 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[-4].str);
					n->missing_ok = true;
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 44259 "gram.c" /* yacc.c:1646  */
    break;

  case 1512:
#line 11487 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((Node *) (yyvsp[0].defelt));
				}
#line 44267 "gram.c" /* yacc.c:1646  */
    break;

  case 1513:
#line 11491 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (Node *) (yyvsp[0].defelt));
				}
#line 44275 "gram.c" /* yacc.c:1646  */
    break;

  case 1514:
#line 11502 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force", NULL, (yylsp[0]));
				}
#line 44283 "gram.c" /* yacc.c:1646  */
    break;

  case 1515:
#line 11514 "gram.y" /* yacc.c:1646  */
    {
					AlterCollationStmt *n = makeNode(AlterCollationStmt);

					n->collname = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 44294 "gram.c" /* yacc.c:1646  */
    break;

  case 1516:
#line 11532 "gram.y" /* yacc.c:1646  */
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);

					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 44305 "gram.c" /* yacc.c:1646  */
    break;

  case 1517:
#line 11539 "gram.y" /* yacc.c:1646  */
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);

					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 44316 "gram.c" /* yacc.c:1646  */
    break;

  case 1518:
#line 11556 "gram.y" /* yacc.c:1646  */
    {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);

					n->domainname = (yyvsp[-3].list);
					n->typeName = (yyvsp[-1].typnam);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 44330 "gram.c" /* yacc.c:1646  */
    break;

  case 1519:
#line 11570 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'T';
					n->typeName = (yyvsp[-1].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 44343 "gram.c" /* yacc.c:1646  */
    break;

  case 1520:
#line 11580 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'N';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 44355 "gram.c" /* yacc.c:1646  */
    break;

  case 1521:
#line 11589 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'O';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 44367 "gram.c" /* yacc.c:1646  */
    break;

  case 1522:
#line 11598 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'C';
					n->typeName = (yyvsp[-2].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 44380 "gram.c" /* yacc.c:1646  */
    break;

  case 1523:
#line 11608 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'X';
					n->typeName = (yyvsp[-4].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 44395 "gram.c" /* yacc.c:1646  */
    break;

  case 1524:
#line 11620 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'X';
					n->typeName = (yyvsp[-6].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 44410 "gram.c" /* yacc.c:1646  */
    break;

  case 1525:
#line 11632 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'V';
					n->typeName = (yyvsp[-3].list);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 44423 "gram.c" /* yacc.c:1646  */
    break;

  case 1528:
#line 11655 "gram.y" /* yacc.c:1646  */
    {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);

					n->dictname = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 44435 "gram.c" /* yacc.c:1646  */
    break;

  case 1529:
#line 11666 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_ADD_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node *) n;
				}
#line 44451 "gram.c" /* yacc.c:1646  */
    break;

  case 1530:
#line 11678 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_ALTER_MAPPING_FOR_TOKEN;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node *) n;
				}
#line 44467 "gram.c" /* yacc.c:1646  */
    break;

  case 1531:
#line 11690 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_REPLACE_DICT;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node *) n;
				}
#line 44483 "gram.c" /* yacc.c:1646  */
    break;

  case 1532:
#line 11702 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_REPLACE_DICT_FOR_TOKEN;
					n->cfgname = (yyvsp[-8].list);
					n->tokentype = (yyvsp[-4].list);
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node *) n;
				}
#line 44499 "gram.c" /* yacc.c:1646  */
    break;

  case 1533:
#line 11714 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-4].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 44513 "gram.c" /* yacc.c:1646  */
    break;

  case 1534:
#line 11724 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 44527 "gram.c" /* yacc.c:1646  */
    break;

  case 1537:
#line 11753 "gram.y" /* yacc.c:1646  */
    {
				CreateConversionStmt *n = makeNode(CreateConversionStmt);

				n->conversion_name = (yyvsp[-6].list);
				n->for_encoding_name = (yyvsp[-4].str);
				n->to_encoding_name = (yyvsp[-2].str);
				n->func_name = (yyvsp[0].list);
				n->def = (yyvsp[-8].boolean);
				(yyval.node) = (Node *) n;
			}
#line 44542 "gram.c" /* yacc.c:1646  */
    break;

  case 1538:
#line 11776 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->params = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 44555 "gram.c" /* yacc.c:1646  */
    break;

  case 1539:
#line 11785 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = NULL;
					n->indexname = NULL;
					n->params = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 44568 "gram.c" /* yacc.c:1646  */
    break;

  case 1540:
#line 11795 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->params = NIL;
					if ((yyvsp[-2].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[-2])));
					(yyval.node) = (Node *) n;
				}
#line 44583 "gram.c" /* yacc.c:1646  */
    break;

  case 1541:
#line 11807 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = NULL;
					n->indexname = NULL;
					n->params = NIL;
					if ((yyvsp[0].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[0])));
					(yyval.node) = (Node *) n;
				}
#line 44598 "gram.c" /* yacc.c:1646  */
    break;

  case 1542:
#line 11819 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = (yyvsp[0].range);
					n->indexname = (yyvsp[-2].str);
					n->params = NIL;
					if ((yyvsp[-3].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[-3])));
					(yyval.node) = (Node *) n;
				}
#line 44613 "gram.c" /* yacc.c:1646  */
    break;

  case 1543:
#line 11832 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 44619 "gram.c" /* yacc.c:1646  */
    break;

  case 1544:
#line 11833 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 44625 "gram.c" /* yacc.c:1646  */
    break;

  case 1545:
#line 11846 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = NIL;
					if ((yyvsp[-4].boolean))
						n->options = lappend(n->options,
											 makeDefElem("full", NULL, (yylsp[-4])));
					if ((yyvsp[-3].boolean))
						n->options = lappend(n->options,
											 makeDefElem("freeze", NULL, (yylsp[-3])));
					if ((yyvsp[-2].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-2])));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("analyze", NULL, (yylsp[-1])));
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = true;
					(yyval.node) = (Node *) n;
				}
#line 44650 "gram.c" /* yacc.c:1646  */
    break;

  case 1546:
#line 11867 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = (yyvsp[-2].list);
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = true;
					(yyval.node) = (Node *) n;
				}
#line 44663 "gram.c" /* yacc.c:1646  */
    break;

  case 1547:
#line 11878 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = NIL;
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-1])));
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = false;
					(yyval.node) = (Node *) n;
				}
#line 44679 "gram.c" /* yacc.c:1646  */
    break;

  case 1548:
#line 11890 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = (yyvsp[-2].list);
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = false;
					(yyval.node) = (Node *) n;
				}
#line 44692 "gram.c" /* yacc.c:1646  */
    break;

  case 1549:
#line 11902 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 44700 "gram.c" /* yacc.c:1646  */
    break;

  case 1550:
#line 11906 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 44708 "gram.c" /* yacc.c:1646  */
    break;

  case 1553:
#line 11918 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 44716 "gram.c" /* yacc.c:1646  */
    break;

  case 1554:
#line 11924 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 44722 "gram.c" /* yacc.c:1646  */
    break;

  case 1555:
#line 11925 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "analyze"; }
#line 44728 "gram.c" /* yacc.c:1646  */
    break;

  case 1556:
#line 11926 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "format"; }
#line 44734 "gram.c" /* yacc.c:1646  */
    break;

  case 1557:
#line 11930 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 44740 "gram.c" /* yacc.c:1646  */
    break;

  case 1558:
#line 11931 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 44746 "gram.c" /* yacc.c:1646  */
    break;

  case 1559:
#line 11932 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 44752 "gram.c" /* yacc.c:1646  */
    break;

  case 1560:
#line 11936 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 44758 "gram.c" /* yacc.c:1646  */
    break;

  case 1561:
#line 11937 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 44764 "gram.c" /* yacc.c:1646  */
    break;

  case 1562:
#line 11941 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 44770 "gram.c" /* yacc.c:1646  */
    break;

  case 1563:
#line 11942 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 44776 "gram.c" /* yacc.c:1646  */
    break;

  case 1564:
#line 11945 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 44782 "gram.c" /* yacc.c:1646  */
    break;

  case 1565:
#line 11946 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 44788 "gram.c" /* yacc.c:1646  */
    break;

  case 1566:
#line 11949 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 44794 "gram.c" /* yacc.c:1646  */
    break;

  case 1567:
#line 11950 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 44800 "gram.c" /* yacc.c:1646  */
    break;

  case 1568:
#line 11954 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 44806 "gram.c" /* yacc.c:1646  */
    break;

  case 1569:
#line 11955 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 44812 "gram.c" /* yacc.c:1646  */
    break;

  case 1570:
#line 11960 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeVacuumRelation((yyvsp[-1].range), InvalidOid, (yyvsp[0].list));
				}
#line 44820 "gram.c" /* yacc.c:1646  */
    break;

  case 1571:
#line 11967 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 44826 "gram.c" /* yacc.c:1646  */
    break;

  case 1572:
#line 11969 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 44832 "gram.c" /* yacc.c:1646  */
    break;

  case 1573:
#line 11973 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 44838 "gram.c" /* yacc.c:1646  */
    break;

  case 1574:
#line 11974 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 44844 "gram.c" /* yacc.c:1646  */
    break;

  case 1575:
#line 11988 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 44856 "gram.c" /* yacc.c:1646  */
    break;

  case 1576:
#line 11996 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("analyze", NULL, (yylsp[-2])));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 44871 "gram.c" /* yacc.c:1646  */
    break;

  case 1577:
#line 12007 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("verbose", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 44883 "gram.c" /* yacc.c:1646  */
    break;

  case 1578:
#line 12015 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 44895 "gram.c" /* yacc.c:1646  */
    break;

  case 1589:
#line 12045 "gram.y" /* yacc.c:1646  */
    {
					PrepareStmt *n = makeNode(PrepareStmt);

					n->name = (yyvsp[-3].str);
					n->argtypes = (yyvsp[-2].list);
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 44908 "gram.c" /* yacc.c:1646  */
    break;

  case 1590:
#line 12055 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 44914 "gram.c" /* yacc.c:1646  */
    break;

  case 1591:
#line 12056 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 44920 "gram.c" /* yacc.c:1646  */
    break;

  case 1597:
#line 12075 "gram.y" /* yacc.c:1646  */
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);

					n->name = (yyvsp[-1].str);
					n->params = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 44932 "gram.c" /* yacc.c:1646  */
    break;

  case 1598:
#line 12084 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);

					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-7].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 44953 "gram.c" /* yacc.c:1646  */
    break;

  case 1599:
#line 12102 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);

					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-10].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 44974 "gram.c" /* yacc.c:1646  */
    break;

  case 1600:
#line 12120 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 44980 "gram.c" /* yacc.c:1646  */
    break;

  case 1601:
#line 12121 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 44986 "gram.c" /* yacc.c:1646  */
    break;

  case 1602:
#line 12132 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = (yyvsp[0].str);
						n->isall = false;
						n->location = (yylsp[0]);
						(yyval.node) = (Node *) n;
					}
#line 44999 "gram.c" /* yacc.c:1646  */
    break;

  case 1603:
#line 12141 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = (yyvsp[0].str);
						n->isall = false;
						n->location = (yylsp[0]);
						(yyval.node) = (Node *) n;
					}
#line 45012 "gram.c" /* yacc.c:1646  */
    break;

  case 1604:
#line 12150 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = NULL;
						n->isall = true;
						n->location = -1;
						(yyval.node) = (Node *) n;
					}
#line 45025 "gram.c" /* yacc.c:1646  */
    break;

  case 1605:
#line 12159 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = NULL;
						n->isall = true;
						n->location = -1;
						(yyval.node) = (Node *) n;
					}
#line 45038 "gram.c" /* yacc.c:1646  */
    break;

  case 1606:
#line 12179 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].istmt)->relation = (yyvsp[-3].range);
					(yyvsp[-2].istmt)->onConflictClause = (yyvsp[-1].onconflict);
					(yyvsp[-2].istmt)->returningList = (yyvsp[0].list);
					(yyvsp[-2].istmt)->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *) (yyvsp[-2].istmt);
				}
#line 45050 "gram.c" /* yacc.c:1646  */
    break;

  case 1607:
#line 12196 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 45058 "gram.c" /* yacc.c:1646  */
    break;

  case 1608:
#line 12200 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].range)->alias = makeAlias((yyvsp[0].str), NIL);
					(yyval.range) = (yyvsp[-2].range);
				}
#line 45067 "gram.c" /* yacc.c:1646  */
    break;

  case 1609:
#line 12208 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 45077 "gram.c" /* yacc.c:1646  */
    break;

  case 1610:
#line 12214 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->override = (yyvsp[-2].ival);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 45088 "gram.c" /* yacc.c:1646  */
    break;

  case 1611:
#line 12221 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-2].list);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 45098 "gram.c" /* yacc.c:1646  */
    break;

  case 1612:
#line 12227 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-5].list);
					(yyval.istmt)->override = (yyvsp[-2].ival);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 45109 "gram.c" /* yacc.c:1646  */
    break;

  case 1613:
#line 12234 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				}
#line 45119 "gram.c" /* yacc.c:1646  */
    break;

  case 1614:
#line 12242 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OVERRIDING_USER_VALUE; }
#line 45125 "gram.c" /* yacc.c:1646  */
    break;

  case 1615:
#line 12243 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OVERRIDING_SYSTEM_VALUE; }
#line 45131 "gram.c" /* yacc.c:1646  */
    break;

  case 1616:
#line 12248 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 45137 "gram.c" /* yacc.c:1646  */
    break;

  case 1617:
#line 12250 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 45143 "gram.c" /* yacc.c:1646  */
    break;

  case 1618:
#line 12255 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[-1]);
				}
#line 45155 "gram.c" /* yacc.c:1646  */
    break;

  case 1619:
#line 12266 "gram.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_UPDATE;
					(yyval.onconflict)->infer = (yyvsp[-5].infer);
					(yyval.onconflict)->targetList = (yyvsp[-1].list);
					(yyval.onconflict)->whereClause = (yyvsp[0].node);
					(yyval.onconflict)->location = (yylsp[-7]);
				}
#line 45168 "gram.c" /* yacc.c:1646  */
    break;

  case 1620:
#line 12276 "gram.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_NOTHING;
					(yyval.onconflict)->infer = (yyvsp[-2].infer);
					(yyval.onconflict)->targetList = NIL;
					(yyval.onconflict)->whereClause = NULL;
					(yyval.onconflict)->location = (yylsp[-4]);
				}
#line 45181 "gram.c" /* yacc.c:1646  */
    break;

  case 1621:
#line 12285 "gram.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = NULL;
				}
#line 45189 "gram.c" /* yacc.c:1646  */
    break;

  case 1622:
#line 12292 "gram.y" /* yacc.c:1646  */
    {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = (yyvsp[-2].list);
					(yyval.infer)->whereClause = (yyvsp[0].node);
					(yyval.infer)->conname = NULL;
					(yyval.infer)->location = (yylsp[-3]);
				}
#line 45201 "gram.c" /* yacc.c:1646  */
    break;

  case 1623:
#line 12301 "gram.y" /* yacc.c:1646  */
    {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = NIL;
					(yyval.infer)->whereClause = NULL;
					(yyval.infer)->conname = (yyvsp[0].str);
					(yyval.infer)->location = (yylsp[-2]);
				}
#line 45213 "gram.c" /* yacc.c:1646  */
    break;

  case 1624:
#line 12309 "gram.y" /* yacc.c:1646  */
    {
					(yyval.infer) = NULL;
				}
#line 45221 "gram.c" /* yacc.c:1646  */
    break;

  case 1625:
#line 12315 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45227 "gram.c" /* yacc.c:1646  */
    break;

  case 1626:
#line 12316 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45233 "gram.c" /* yacc.c:1646  */
    break;

  case 1627:
#line 12329 "gram.y" /* yacc.c:1646  */
    {
					DeleteStmt *n = makeNode(DeleteStmt);

					n->relation = (yyvsp[-3].range);
					n->usingClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *) n;
				}
#line 45248 "gram.c" /* yacc.c:1646  */
    break;

  case 1628:
#line 12342 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45254 "gram.c" /* yacc.c:1646  */
    break;

  case 1629:
#line 12343 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45260 "gram.c" /* yacc.c:1646  */
    break;

  case 1630:
#line 12355 "gram.y" /* yacc.c:1646  */
    {
					LockStmt   *n = makeNode(LockStmt);

					n->relations = (yyvsp[-2].list);
					n->mode = (yyvsp[-1].ival);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 45273 "gram.c" /* yacc.c:1646  */
    break;

  case 1631:
#line 12365 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival); }
#line 45279 "gram.c" /* yacc.c:1646  */
    break;

  case 1632:
#line 12366 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 45285 "gram.c" /* yacc.c:1646  */
    break;

  case 1633:
#line 12369 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessShareLock; }
#line 45291 "gram.c" /* yacc.c:1646  */
    break;

  case 1634:
#line 12370 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RowShareLock; }
#line 45297 "gram.c" /* yacc.c:1646  */
    break;

  case 1635:
#line 12371 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RowExclusiveLock; }
#line 45303 "gram.c" /* yacc.c:1646  */
    break;

  case 1636:
#line 12372 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareUpdateExclusiveLock; }
#line 45309 "gram.c" /* yacc.c:1646  */
    break;

  case 1637:
#line 12373 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareLock; }
#line 45315 "gram.c" /* yacc.c:1646  */
    break;

  case 1638:
#line 12374 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareRowExclusiveLock; }
#line 45321 "gram.c" /* yacc.c:1646  */
    break;

  case 1639:
#line 12375 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ExclusiveLock; }
#line 45327 "gram.c" /* yacc.c:1646  */
    break;

  case 1640:
#line 12376 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 45333 "gram.c" /* yacc.c:1646  */
    break;

  case 1641:
#line 12379 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 45339 "gram.c" /* yacc.c:1646  */
    break;

  case 1642:
#line 12380 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 45345 "gram.c" /* yacc.c:1646  */
    break;

  case 1643:
#line 12384 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitError; }
#line 45351 "gram.c" /* yacc.c:1646  */
    break;

  case 1644:
#line 12385 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitSkip; }
#line 45357 "gram.c" /* yacc.c:1646  */
    break;

  case 1645:
#line 12386 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitBlock; }
#line 45363 "gram.c" /* yacc.c:1646  */
    break;

  case 1646:
#line 12402 "gram.y" /* yacc.c:1646  */
    {
					UpdateStmt *n = makeNode(UpdateStmt);

					n->relation = (yyvsp[-5].range);
					n->targetList = (yyvsp[-3].list);
					n->fromClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-7].with);
					(yyval.node) = (Node *) n;
				}
#line 45379 "gram.c" /* yacc.c:1646  */
    break;

  case 1647:
#line 12416 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45385 "gram.c" /* yacc.c:1646  */
    break;

  case 1648:
#line 12417 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_concat((yyvsp[-2].list),(yyvsp[0].list)); }
#line 45391 "gram.c" /* yacc.c:1646  */
    break;

  case 1649:
#line 12422 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].target)->val = (Node *) (yyvsp[0].node);
					(yyval.list) = list_make1((yyvsp[-2].target));
				}
#line 45400 "gram.c" /* yacc.c:1646  */
    break;

  case 1650:
#line 12427 "gram.y" /* yacc.c:1646  */
    {
					int			ncolumns = list_length((yyvsp[-3].list));
					int			i = 1;
					ListCell   *col_cell;

					/* Create a MultiAssignRef source for each target */
					foreach(col_cell, (yyvsp[-3].list))
					{
						ResTarget  *res_col = (ResTarget *) lfirst(col_cell);
						MultiAssignRef *r = makeNode(MultiAssignRef);

						r->source = (Node *) (yyvsp[0].node);
						r->colno = i;
						r->ncolumns = ncolumns;
						res_col->val = (Node *) r;
						i++;
					}

					(yyval.list) = (yyvsp[-3].list);
				}
#line 45425 "gram.c" /* yacc.c:1646  */
    break;

  case 1651:
#line 12451 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[-1]);
				}
#line 45437 "gram.c" /* yacc.c:1646  */
    break;

  case 1652:
#line 12461 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 45443 "gram.c" /* yacc.c:1646  */
    break;

  case 1653:
#line 12462 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].target)); }
#line 45449 "gram.c" /* yacc.c:1646  */
    break;

  case 1654:
#line 12479 "gram.y" /* yacc.c:1646  */
    {
					MergeStmt  *m = makeNode(MergeStmt);

					m->withClause = (yyvsp[-9].with);
					m->relation = (yyvsp[-6].range);
					m->sourceRelation = (yyvsp[-4].node);
					m->joinCondition = (yyvsp[-2].node);
					m->mergeWhenClauses = (yyvsp[-1].list);
					m->returningList = (yyvsp[0].list);

					(yyval.node) = (Node *) m;
				}
#line 45466 "gram.c" /* yacc.c:1646  */
    break;

  case 1655:
#line 12494 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 45472 "gram.c" /* yacc.c:1646  */
    break;

  case 1656:
#line 12495 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list),(yyvsp[0].node)); }
#line 45478 "gram.c" /* yacc.c:1646  */
    break;

  case 1657:
#line 12506 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[0].mergewhen)->matchKind = (yyvsp[-3].mergematch);
					(yyvsp[0].mergewhen)->condition = (yyvsp[-2].node);

					(yyval.node) = (Node *) (yyvsp[0].mergewhen);
				}
#line 45489 "gram.c" /* yacc.c:1646  */
    break;

  case 1658:
#line 12513 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[0].mergewhen)->matchKind = (yyvsp[-3].mergematch);
					(yyvsp[0].mergewhen)->condition = (yyvsp[-2].node);

					(yyval.node) = (Node *) (yyvsp[0].mergewhen);
				}
#line 45500 "gram.c" /* yacc.c:1646  */
    break;

  case 1659:
#line 12520 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[0].mergewhen)->matchKind = (yyvsp[-3].mergematch);
					(yyvsp[0].mergewhen)->condition = (yyvsp[-2].node);

					(yyval.node) = (Node *) (yyvsp[0].mergewhen);
				}
#line 45511 "gram.c" /* yacc.c:1646  */
    break;

  case 1660:
#line 12527 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *m = makeNode(MergeWhenClause);

					m->matchKind = (yyvsp[-4].mergematch);
					m->commandType = CMD_NOTHING;
					m->condition = (yyvsp[-3].node);

					(yyval.node) = (Node *) m;
				}
#line 45525 "gram.c" /* yacc.c:1646  */
    break;

  case 1661:
#line 12537 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *m = makeNode(MergeWhenClause);

					m->matchKind = (yyvsp[-4].mergematch);
					m->commandType = CMD_NOTHING;
					m->condition = (yyvsp[-3].node);

					(yyval.node) = (Node *) m;
				}
#line 45539 "gram.c" /* yacc.c:1646  */
    break;

  case 1662:
#line 12549 "gram.y" /* yacc.c:1646  */
    { (yyval.mergematch) = MERGE_WHEN_MATCHED; }
#line 45545 "gram.c" /* yacc.c:1646  */
    break;

  case 1663:
#line 12550 "gram.y" /* yacc.c:1646  */
    { (yyval.mergematch) = MERGE_WHEN_NOT_MATCHED_BY_SOURCE; }
#line 45551 "gram.c" /* yacc.c:1646  */
    break;

  case 1664:
#line 12554 "gram.y" /* yacc.c:1646  */
    { (yyval.mergematch) = MERGE_WHEN_NOT_MATCHED_BY_TARGET; }
#line 45557 "gram.c" /* yacc.c:1646  */
    break;

  case 1665:
#line 12555 "gram.y" /* yacc.c:1646  */
    { (yyval.mergematch) = MERGE_WHEN_NOT_MATCHED_BY_TARGET; }
#line 45563 "gram.c" /* yacc.c:1646  */
    break;

  case 1666:
#line 12559 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45569 "gram.c" /* yacc.c:1646  */
    break;

  case 1667:
#line 12560 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 45575 "gram.c" /* yacc.c:1646  */
    break;

  case 1668:
#line 12565 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_UPDATE;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = (yyvsp[0].list);
					n->values = NIL;

					(yyval.mergewhen) = n;
				}
#line 45589 "gram.c" /* yacc.c:1646  */
    break;

  case 1669:
#line 12578 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_DELETE;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = NIL;
					n->values = NIL;

					(yyval.mergewhen) = n;
				}
#line 45603 "gram.c" /* yacc.c:1646  */
    break;

  case 1670:
#line 12591 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = NIL;
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 45616 "gram.c" /* yacc.c:1646  */
    break;

  case 1671:
#line 12600 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = (yyvsp[-2].ival);
					n->targetList = NIL;
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 45629 "gram.c" /* yacc.c:1646  */
    break;

  case 1672:
#line 12609 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = (yyvsp[-2].list);
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 45642 "gram.c" /* yacc.c:1646  */
    break;

  case 1673:
#line 12618 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = (yyvsp[-2].ival);
					n->targetList = (yyvsp[-5].list);
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 45655 "gram.c" /* yacc.c:1646  */
    break;

  case 1674:
#line 12627 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = NIL;
					n->values = NIL;
					(yyval.mergewhen) = n;
				}
#line 45668 "gram.c" /* yacc.c:1646  */
    break;

  case 1675:
#line 12639 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[-1].list);
				}
#line 45676 "gram.c" /* yacc.c:1646  */
    break;

  case 1676:
#line 12651 "gram.y" /* yacc.c:1646  */
    {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);

					n->portalname = (yyvsp[-5].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[-4].ival) | (yyvsp[-2].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 45690 "gram.c" /* yacc.c:1646  */
    break;

  case 1677:
#line 12662 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 45696 "gram.c" /* yacc.c:1646  */
    break;

  case 1678:
#line 12665 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 45702 "gram.c" /* yacc.c:1646  */
    break;

  case 1679:
#line 12666 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | CURSOR_OPT_NO_SCROLL; }
#line 45708 "gram.c" /* yacc.c:1646  */
    break;

  case 1680:
#line 12667 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_SCROLL; }
#line 45714 "gram.c" /* yacc.c:1646  */
    break;

  case 1681:
#line 12668 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_BINARY; }
#line 45720 "gram.c" /* yacc.c:1646  */
    break;

  case 1682:
#line 12669 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_ASENSITIVE; }
#line 45726 "gram.c" /* yacc.c:1646  */
    break;

  case 1683:
#line 12670 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_INSENSITIVE; }
#line 45732 "gram.c" /* yacc.c:1646  */
    break;

  case 1684:
#line 12673 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 45738 "gram.c" /* yacc.c:1646  */
    break;

  case 1685:
#line 12674 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CURSOR_OPT_HOLD; }
#line 45744 "gram.c" /* yacc.c:1646  */
    break;

  case 1686:
#line 12675 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 45750 "gram.c" /* yacc.c:1646  */
    break;

  case 1689:
#line 12728 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 45756 "gram.c" /* yacc.c:1646  */
    break;

  case 1690:
#line 12729 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 45762 "gram.c" /* yacc.c:1646  */
    break;

  case 1691:
#line 12744 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45768 "gram.c" /* yacc.c:1646  */
    break;

  case 1692:
#line 12746 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL, NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 45779 "gram.c" /* yacc.c:1646  */
    break;

  case 1693:
#line 12753 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										(yyvsp[0].selectlimit),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 45791 "gram.c" /* yacc.c:1646  */
    break;

  case 1694:
#line 12761 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										(yyvsp[-1].selectlimit),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 45803 "gram.c" /* yacc.c:1646  */
    break;

  case 1695:
#line 12769 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[0].node), NULL, NIL,
										NULL,
										(yyvsp[-1].with),
										yyscanner);
					(yyval.node) = (yyvsp[0].node);
				}
#line 45815 "gram.c" /* yacc.c:1646  */
    break;

  case 1696:
#line 12777 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL,
										(yyvsp[-2].with),
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 45827 "gram.c" /* yacc.c:1646  */
    break;

  case 1697:
#line 12785 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										(yyvsp[0].selectlimit),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 45839 "gram.c" /* yacc.c:1646  */
    break;

  case 1698:
#line 12793 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										(yyvsp[-1].selectlimit),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 45851 "gram.c" /* yacc.c:1646  */
    break;

  case 1699:
#line 12803 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45857 "gram.c" /* yacc.c:1646  */
    break;

  case 1700:
#line 12804 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45863 "gram.c" /* yacc.c:1646  */
    break;

  case 1701:
#line 12839 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);

					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = ((yyvsp[-2].groupclause))->list;
					n->groupDistinct = ((yyvsp[-2].groupclause))->distinct;
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 45881 "gram.c" /* yacc.c:1646  */
    break;

  case 1702:
#line 12855 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);

					n->distinctClause = (yyvsp[-7].list);
					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = ((yyvsp[-2].groupclause))->list;
					n->groupDistinct = ((yyvsp[-2].groupclause))->distinct;
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 45900 "gram.c" /* yacc.c:1646  */
    break;

  case 1703:
#line 12869 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45906 "gram.c" /* yacc.c:1646  */
    break;

  case 1704:
#line 12871 "gram.y" /* yacc.c:1646  */
    {
					/* same as SELECT * FROM relation_expr */
					ColumnRef  *cr = makeNode(ColumnRef);
					ResTarget  *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *) cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[0].range));
					(yyval.node) = (Node *) n;
				}
#line 45929 "gram.c" /* yacc.c:1646  */
    break;

  case 1705:
#line 12890 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 45937 "gram.c" /* yacc.c:1646  */
    break;

  case 1706:
#line 12894 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 45945 "gram.c" /* yacc.c:1646  */
    break;

  case 1707:
#line 12898 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 45953 "gram.c" /* yacc.c:1646  */
    break;

  case 1708:
#line 12913 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 45964 "gram.c" /* yacc.c:1646  */
    break;

  case 1709:
#line 12920 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 45975 "gram.c" /* yacc.c:1646  */
    break;

  case 1710:
#line 12927 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[-2]);
			}
#line 45986 "gram.c" /* yacc.c:1646  */
    break;

  case 1711:
#line 12936 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 45992 "gram.c" /* yacc.c:1646  */
    break;

  case 1712:
#line 12937 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 45998 "gram.c" /* yacc.c:1646  */
    break;

  case 1713:
#line 12941 "gram.y" /* yacc.c:1646  */
    {
				CommonTableExpr *n = makeNode(CommonTableExpr);

				n->ctename = (yyvsp[-8].str);
				n->aliascolnames = (yyvsp[-7].list);
				n->ctematerialized = (yyvsp[-5].ival);
				n->ctequery = (yyvsp[-3].node);
				n->search_clause = castNode(CTESearchClause, (yyvsp[-1].node));
				n->cycle_clause = castNode(CTECycleClause, (yyvsp[0].node));
				n->location = (yylsp[-8]);
				(yyval.node) = (Node *) n;
			}
#line 46015 "gram.c" /* yacc.c:1646  */
    break;

  case 1714:
#line 12956 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeAlways; }
#line 46021 "gram.c" /* yacc.c:1646  */
    break;

  case 1715:
#line 12957 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeNever; }
#line 46027 "gram.c" /* yacc.c:1646  */
    break;

  case 1716:
#line 12958 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeDefault; }
#line 46033 "gram.c" /* yacc.c:1646  */
    break;

  case 1717:
#line 12963 "gram.y" /* yacc.c:1646  */
    {
				CTESearchClause *n = makeNode(CTESearchClause);

				n->search_col_list = (yyvsp[-2].list);
				n->search_breadth_first = false;
				n->search_seq_column = (yyvsp[0].str);
				n->location = (yylsp[-6]);
				(yyval.node) = (Node *) n;
			}
#line 46047 "gram.c" /* yacc.c:1646  */
    break;

  case 1718:
#line 12973 "gram.y" /* yacc.c:1646  */
    {
				CTESearchClause *n = makeNode(CTESearchClause);

				n->search_col_list = (yyvsp[-2].list);
				n->search_breadth_first = true;
				n->search_seq_column = (yyvsp[0].str);
				n->location = (yylsp[-6]);
				(yyval.node) = (Node *) n;
			}
#line 46061 "gram.c" /* yacc.c:1646  */
    break;

  case 1719:
#line 12983 "gram.y" /* yacc.c:1646  */
    {
				(yyval.node) = NULL;
			}
#line 46069 "gram.c" /* yacc.c:1646  */
    break;

  case 1720:
#line 12990 "gram.y" /* yacc.c:1646  */
    {
				CTECycleClause *n = makeNode(CTECycleClause);

				n->cycle_col_list = (yyvsp[-8].list);
				n->cycle_mark_column = (yyvsp[-6].str);
				n->cycle_mark_value = (yyvsp[-4].node);
				n->cycle_mark_default = (yyvsp[-2].node);
				n->cycle_path_column = (yyvsp[0].str);
				n->location = (yylsp[-9]);
				(yyval.node) = (Node *) n;
			}
#line 46085 "gram.c" /* yacc.c:1646  */
    break;

  case 1721:
#line 13002 "gram.y" /* yacc.c:1646  */
    {
				CTECycleClause *n = makeNode(CTECycleClause);

				n->cycle_col_list = (yyvsp[-4].list);
				n->cycle_mark_column = (yyvsp[-2].str);
				n->cycle_mark_value = makeBoolAConst(true, -1);
				n->cycle_mark_default = makeBoolAConst(false, -1);
				n->cycle_path_column = (yyvsp[0].str);
				n->location = (yylsp[-5]);
				(yyval.node) = (Node *) n;
			}
#line 46101 "gram.c" /* yacc.c:1646  */
    break;

  case 1722:
#line 13014 "gram.y" /* yacc.c:1646  */
    {
				(yyval.node) = NULL;
			}
#line 46109 "gram.c" /* yacc.c:1646  */
    break;

  case 1723:
#line 13020 "gram.y" /* yacc.c:1646  */
    { (yyval.with) = (yyvsp[0].with); }
#line 46115 "gram.c" /* yacc.c:1646  */
    break;

  case 1724:
#line 13021 "gram.y" /* yacc.c:1646  */
    { (yyval.with) = NULL; }
#line 46121 "gram.c" /* yacc.c:1646  */
    break;

  case 1725:
#line 13026 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[0].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;
				}
#line 46136 "gram.c" /* yacc.c:1646  */
    break;

  case 1726:
#line 13037 "gram.y" /* yacc.c:1646  */
    { (yyval.into) = NULL; }
#line 46142 "gram.c" /* yacc.c:1646  */
    break;

  case 1727:
#line 13046 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 46151 "gram.c" /* yacc.c:1646  */
    break;

  case 1728:
#line 13051 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 46160 "gram.c" /* yacc.c:1646  */
    break;

  case 1729:
#line 13056 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 46169 "gram.c" /* yacc.c:1646  */
    break;

  case 1730:
#line 13061 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 46178 "gram.c" /* yacc.c:1646  */
    break;

  case 1731:
#line 13066 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 46190 "gram.c" /* yacc.c:1646  */
    break;

  case 1732:
#line 13074 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 46202 "gram.c" /* yacc.c:1646  */
    break;

  case 1733:
#line 13082 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_UNLOGGED;
				}
#line 46211 "gram.c" /* yacc.c:1646  */
    break;

  case 1734:
#line 13087 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 46220 "gram.c" /* yacc.c:1646  */
    break;

  case 1735:
#line 13092 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 46229 "gram.c" /* yacc.c:1646  */
    break;

  case 1738:
#line 13103 "gram.y" /* yacc.c:1646  */
    { (yyval.setquantifier) = SET_QUANTIFIER_ALL; }
#line 46235 "gram.c" /* yacc.c:1646  */
    break;

  case 1739:
#line 13104 "gram.y" /* yacc.c:1646  */
    { (yyval.setquantifier) = SET_QUANTIFIER_DISTINCT; }
#line 46241 "gram.c" /* yacc.c:1646  */
    break;

  case 1740:
#line 13105 "gram.y" /* yacc.c:1646  */
    { (yyval.setquantifier) = SET_QUANTIFIER_DEFAULT; }
#line 46247 "gram.c" /* yacc.c:1646  */
    break;

  case 1741:
#line 13112 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(NIL); }
#line 46253 "gram.c" /* yacc.c:1646  */
    break;

  case 1742:
#line 13113 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 46259 "gram.c" /* yacc.c:1646  */
    break;

  case 1745:
#line 13122 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 46265 "gram.c" /* yacc.c:1646  */
    break;

  case 1746:
#line 13123 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46271 "gram.c" /* yacc.c:1646  */
    break;

  case 1747:
#line 13127 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 46277 "gram.c" /* yacc.c:1646  */
    break;

  case 1748:
#line 13128 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46283 "gram.c" /* yacc.c:1646  */
    break;

  case 1749:
#line 13132 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 46289 "gram.c" /* yacc.c:1646  */
    break;

  case 1750:
#line 13136 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].sortby)); }
#line 46295 "gram.c" /* yacc.c:1646  */
    break;

  case 1751:
#line 13137 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].sortby)); }
#line 46301 "gram.c" /* yacc.c:1646  */
    break;

  case 1752:
#line 13141 "gram.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-3].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = (yyvsp[-1].list);
					(yyval.sortby)->location = (yylsp[-1]);
				}
#line 46314 "gram.c" /* yacc.c:1646  */
    break;

  case 1753:
#line 13150 "gram.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-2].node);
					(yyval.sortby)->sortby_dir = (yyvsp[-1].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				}
#line 46327 "gram.c" /* yacc.c:1646  */
    break;

  case 1754:
#line 13163 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selectlimit) = (yyvsp[-1].selectlimit);
					((yyval.selectlimit))->limitOffset = (yyvsp[0].node);
				}
#line 46336 "gram.c" /* yacc.c:1646  */
    break;

  case 1755:
#line 13168 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selectlimit) = (yyvsp[0].selectlimit);
					((yyval.selectlimit))->limitOffset = (yyvsp[-1].node);
				}
#line 46345 "gram.c" /* yacc.c:1646  */
    break;

  case 1756:
#line 13173 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selectlimit) = (yyvsp[0].selectlimit);
				}
#line 46353 "gram.c" /* yacc.c:1646  */
    break;

  case 1757:
#line 13177 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = (yyvsp[0].node);
					n->limitCount = NULL;
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 46366 "gram.c" /* yacc.c:1646  */
    break;

  case 1758:
#line 13188 "gram.y" /* yacc.c:1646  */
    { (yyval.selectlimit) = (yyvsp[0].selectlimit); }
#line 46372 "gram.c" /* yacc.c:1646  */
    break;

  case 1759:
#line 13189 "gram.y" /* yacc.c:1646  */
    { (yyval.selectlimit) = NULL; }
#line 46378 "gram.c" /* yacc.c:1646  */
    break;

  case 1760:
#line 13194 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = (yyvsp[0].node);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 46391 "gram.c" /* yacc.c:1646  */
    break;

  case 1761:
#line 13203 "gram.y" /* yacc.c:1646  */
    {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 parser_errposition((yylsp[-3]))));
				}
#line 46404 "gram.c" /* yacc.c:1646  */
    break;

  case 1762:
#line 13219 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = (yyvsp[-2].node);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 46417 "gram.c" /* yacc.c:1646  */
    break;

  case 1763:
#line 13228 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = (yyvsp[-3].node);
					n->limitOption = LIMIT_OPTION_WITH_TIES;
					(yyval.selectlimit) = n;
				}
#line 46430 "gram.c" /* yacc.c:1646  */
    break;

  case 1764:
#line 13237 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = makeIntConst(1, -1);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 46443 "gram.c" /* yacc.c:1646  */
    break;

  case 1765:
#line 13246 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = makeIntConst(1, -1);
					n->limitOption = LIMIT_OPTION_WITH_TIES;
					(yyval.selectlimit) = n;
				}
#line 46456 "gram.c" /* yacc.c:1646  */
    break;

  case 1766:
#line 13258 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46462 "gram.c" /* yacc.c:1646  */
    break;

  case 1767:
#line 13261 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 46468 "gram.c" /* yacc.c:1646  */
    break;

  case 1768:
#line 13265 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46474 "gram.c" /* yacc.c:1646  */
    break;

  case 1769:
#line 13267 "gram.y" /* yacc.c:1646  */
    {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 46483 "gram.c" /* yacc.c:1646  */
    break;

  case 1770:
#line 13274 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46489 "gram.c" /* yacc.c:1646  */
    break;

  case 1771:
#line 13294 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46495 "gram.c" /* yacc.c:1646  */
    break;

  case 1772:
#line 13296 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 46501 "gram.c" /* yacc.c:1646  */
    break;

  case 1773:
#line 13298 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 46507 "gram.c" /* yacc.c:1646  */
    break;

  case 1774:
#line 13302 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst((yyvsp[0].ival),(yylsp[0])); }
#line 46513 "gram.c" /* yacc.c:1646  */
    break;

  case 1775:
#line 13303 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeFloatConst((yyvsp[0].str),(yylsp[0])); }
#line 46519 "gram.c" /* yacc.c:1646  */
    break;

  case 1776:
#line 13307 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 46525 "gram.c" /* yacc.c:1646  */
    break;

  case 1777:
#line 13308 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 46531 "gram.c" /* yacc.c:1646  */
    break;

  case 1778:
#line 13311 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 46537 "gram.c" /* yacc.c:1646  */
    break;

  case 1779:
#line 13312 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 46543 "gram.c" /* yacc.c:1646  */
    break;

  case 1780:
#line 13338 "gram.y" /* yacc.c:1646  */
    {
					GroupClause *n = (GroupClause *) palloc(sizeof(GroupClause));

					n->distinct = (yyvsp[-1].setquantifier) == SET_QUANTIFIER_DISTINCT;
					n->list = (yyvsp[0].list);
					(yyval.groupclause) = n;
				}
#line 46555 "gram.c" /* yacc.c:1646  */
    break;

  case 1781:
#line 13346 "gram.y" /* yacc.c:1646  */
    {
					GroupClause *n = (GroupClause *) palloc(sizeof(GroupClause));

					n->distinct = false;
					n->list = NIL;
					(yyval.groupclause) = n;
				}
#line 46567 "gram.c" /* yacc.c:1646  */
    break;

  case 1782:
#line 13356 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 46573 "gram.c" /* yacc.c:1646  */
    break;

  case 1783:
#line 13357 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].node)); }
#line 46579 "gram.c" /* yacc.c:1646  */
    break;

  case 1784:
#line 13361 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46585 "gram.c" /* yacc.c:1646  */
    break;

  case 1785:
#line 13362 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46591 "gram.c" /* yacc.c:1646  */
    break;

  case 1786:
#line 13363 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46597 "gram.c" /* yacc.c:1646  */
    break;

  case 1787:
#line 13364 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46603 "gram.c" /* yacc.c:1646  */
    break;

  case 1788:
#line 13365 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46609 "gram.c" /* yacc.c:1646  */
    break;

  case 1789:
#line 13370 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_EMPTY, NIL, (yylsp[-1]));
				}
#line 46617 "gram.c" /* yacc.c:1646  */
    break;

  case 1790:
#line 13383 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_ROLLUP, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 46625 "gram.c" /* yacc.c:1646  */
    break;

  case 1791:
#line 13390 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_CUBE, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 46633 "gram.c" /* yacc.c:1646  */
    break;

  case 1792:
#line 13397 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_SETS, (yyvsp[-1].list), (yylsp[-4]));
				}
#line 46641 "gram.c" /* yacc.c:1646  */
    break;

  case 1793:
#line 13403 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46647 "gram.c" /* yacc.c:1646  */
    break;

  case 1794:
#line 13404 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 46653 "gram.c" /* yacc.c:1646  */
    break;

  case 1795:
#line 13408 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 46659 "gram.c" /* yacc.c:1646  */
    break;

  case 1796:
#line 13409 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46665 "gram.c" /* yacc.c:1646  */
    break;

  case 1797:
#line 13413 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 46671 "gram.c" /* yacc.c:1646  */
    break;

  case 1798:
#line 13414 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46677 "gram.c" /* yacc.c:1646  */
    break;

  case 1799:
#line 13418 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 46683 "gram.c" /* yacc.c:1646  */
    break;

  case 1800:
#line 13419 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 46689 "gram.c" /* yacc.c:1646  */
    break;

  case 1801:
#line 13424 "gram.y" /* yacc.c:1646  */
    {
					LockingClause *n = makeNode(LockingClause);

					n->lockedRels = (yyvsp[-1].list);
					n->strength = (yyvsp[-2].ival);
					n->waitPolicy = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 46702 "gram.c" /* yacc.c:1646  */
    break;

  case 1802:
#line 13435 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORUPDATE; }
#line 46708 "gram.c" /* yacc.c:1646  */
    break;

  case 1803:
#line 13436 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORNOKEYUPDATE; }
#line 46714 "gram.c" /* yacc.c:1646  */
    break;

  case 1804:
#line 13437 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORSHARE; }
#line 46720 "gram.c" /* yacc.c:1646  */
    break;

  case 1805:
#line 13438 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORKEYSHARE; }
#line 46726 "gram.c" /* yacc.c:1646  */
    break;

  case 1806:
#line 13442 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 46732 "gram.c" /* yacc.c:1646  */
    break;

  case 1807:
#line 13443 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46738 "gram.c" /* yacc.c:1646  */
    break;

  case 1808:
#line 13454 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);

					n->valuesLists = list_make1((yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 46749 "gram.c" /* yacc.c:1646  */
    break;

  case 1809:
#line 13461 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = (SelectStmt *) (yyvsp[-4].node);

					n->valuesLists = lappend(n->valuesLists, (yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 46760 "gram.c" /* yacc.c:1646  */
    break;

  case 1810:
#line 13479 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 46766 "gram.c" /* yacc.c:1646  */
    break;

  case 1811:
#line 13480 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46772 "gram.c" /* yacc.c:1646  */
    break;

  case 1812:
#line 13484 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 46778 "gram.c" /* yacc.c:1646  */
    break;

  case 1813:
#line 13485 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 46784 "gram.c" /* yacc.c:1646  */
    break;

  case 1814:
#line 13492 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-1].range)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-1].range);
				}
#line 46793 "gram.c" /* yacc.c:1646  */
    break;

  case 1815:
#line 13497 "gram.y" /* yacc.c:1646  */
    {
					RangeTableSample *n = (RangeTableSample *) (yyvsp[0].node);

					(yyvsp[-2].range)->alias = (yyvsp[-1].alias);
					/* relation_expr goes inside the RangeTableSample node */
					n->relation = (Node *) (yyvsp[-2].range);
					(yyval.node) = (Node *) n;
				}
#line 46806 "gram.c" /* yacc.c:1646  */
    break;

  case 1816:
#line 13506 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);

					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 46818 "gram.c" /* yacc.c:1646  */
    break;

  case 1817:
#line 13514 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);

					n->lateral = true;
					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 46831 "gram.c" /* yacc.c:1646  */
    break;

  case 1818:
#line 13523 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = (RangeTableFunc *) (yyvsp[-1].node);

					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 46842 "gram.c" /* yacc.c:1646  */
    break;

  case 1819:
#line 13530 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = (RangeTableFunc *) (yyvsp[-1].node);

					n->lateral = true;
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 46854 "gram.c" /* yacc.c:1646  */
    break;

  case 1820:
#line 13538 "gram.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);

					n->lateral = false;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 46867 "gram.c" /* yacc.c:1646  */
    break;

  case 1821:
#line 13547 "gram.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);

					n->lateral = true;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 46880 "gram.c" /* yacc.c:1646  */
    break;

  case 1822:
#line 13556 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) (yyvsp[0].jexpr);
				}
#line 46888 "gram.c" /* yacc.c:1646  */
    break;

  case 1823:
#line 13560 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].jexpr)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-2].jexpr);
				}
#line 46897 "gram.c" /* yacc.c:1646  */
    break;

  case 1824:
#line 13565 "gram.y" /* yacc.c:1646  */
    {
					JsonTable  *jt = castNode(JsonTable, (yyvsp[-1].node));

					jt->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) jt;
				}
#line 46908 "gram.c" /* yacc.c:1646  */
    break;

  case 1825:
#line 13572 "gram.y" /* yacc.c:1646  */
    {
					JsonTable  *jt = castNode(JsonTable, (yyvsp[-1].node));

					jt->alias = (yyvsp[0].alias);
					jt->lateral = true;
					(yyval.node) = (Node *) jt;
				}
#line 46920 "gram.c" /* yacc.c:1646  */
    break;

  case 1826:
#line 13601 "gram.y" /* yacc.c:1646  */
    {
					(yyval.jexpr) = (yyvsp[-1].jexpr);
				}
#line 46928 "gram.c" /* yacc.c:1646  */
    break;

  case 1827:
#line 13605 "gram.y" /* yacc.c:1646  */
    {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = JOIN_INNER;
					n->isNatural = false;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL;
					n->join_using_alias = NULL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				}
#line 46946 "gram.c" /* yacc.c:1646  */
    break;

  case 1828:
#line 13619 "gram.y" /* yacc.c:1646  */
    {
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = (yyvsp[-3].jtype);
					n->isNatural = false;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
					{
						 /* USING clause */
						n->usingClause = linitial_node(List, castNode(List, (yyvsp[0].node)));
						n->join_using_alias = lsecond_node(Alias, castNode(List, (yyvsp[0].node)));
					}
					else
					{
						/* ON clause */
						n->quals = (yyvsp[0].node);
					}
					(yyval.jexpr) = n;
				}
#line 46971 "gram.c" /* yacc.c:1646  */
    break;

  case 1829:
#line 13640 "gram.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = JOIN_INNER;
					n->isNatural = false;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
					{
						/* USING clause */
						n->usingClause = linitial_node(List, castNode(List, (yyvsp[0].node)));
						n->join_using_alias = lsecond_node(Alias, castNode(List, (yyvsp[0].node)));
					}
					else
					{
						/* ON clause */
						n->quals = (yyvsp[0].node);
					}
					(yyval.jexpr) = n;
				}
#line 46997 "gram.c" /* yacc.c:1646  */
    break;

  case 1830:
#line 13662 "gram.y" /* yacc.c:1646  */
    {
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = (yyvsp[-2].jtype);
					n->isNatural = true;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->join_using_alias = NULL;
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 47014 "gram.c" /* yacc.c:1646  */
    break;

  case 1831:
#line 13675 "gram.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = JOIN_INNER;
					n->isNatural = true;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->join_using_alias = NULL;
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 47032 "gram.c" /* yacc.c:1646  */
    break;

  case 1832:
#line 13692 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 47042 "gram.c" /* yacc.c:1646  */
    break;

  case 1833:
#line 13698 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 47051 "gram.c" /* yacc.c:1646  */
    break;

  case 1834:
#line 13703 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 47061 "gram.c" /* yacc.c:1646  */
    break;

  case 1835:
#line 13709 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 47070 "gram.c" /* yacc.c:1646  */
    break;

  case 1836:
#line 13715 "gram.y" /* yacc.c:1646  */
    { (yyval.alias) = (yyvsp[0].alias); }
#line 47076 "gram.c" /* yacc.c:1646  */
    break;

  case 1837:
#line 13716 "gram.y" /* yacc.c:1646  */
    { (yyval.alias) = NULL; }
#line 47082 "gram.c" /* yacc.c:1646  */
    break;

  case 1838:
#line 13727 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
					/* the column name list will be inserted later */
				}
#line 47092 "gram.c" /* yacc.c:1646  */
    break;

  case 1839:
#line 13732 "gram.y" /* yacc.c:1646  */
    { (yyval.alias) = NULL; }
#line 47098 "gram.c" /* yacc.c:1646  */
    break;

  case 1840:
#line 13741 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].alias), NIL);
				}
#line 47106 "gram.c" /* yacc.c:1646  */
    break;

  case 1841:
#line 13745 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, (yyvsp[-1].list));
				}
#line 47114 "gram.c" /* yacc.c:1646  */
    break;

  case 1842:
#line 13749 "gram.y" /* yacc.c:1646  */
    {
					Alias	   *a = makeNode(Alias);

					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 47125 "gram.c" /* yacc.c:1646  */
    break;

  case 1843:
#line 13756 "gram.y" /* yacc.c:1646  */
    {
					Alias	   *a = makeNode(Alias);

					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 47136 "gram.c" /* yacc.c:1646  */
    break;

  case 1844:
#line 13763 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, NIL);
				}
#line 47144 "gram.c" /* yacc.c:1646  */
    break;

  case 1845:
#line 13768 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_FULL; }
#line 47150 "gram.c" /* yacc.c:1646  */
    break;

  case 1846:
#line 13769 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_LEFT; }
#line 47156 "gram.c" /* yacc.c:1646  */
    break;

  case 1847:
#line 13770 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_RIGHT; }
#line 47162 "gram.c" /* yacc.c:1646  */
    break;

  case 1848:
#line 13771 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_INNER; }
#line 47168 "gram.c" /* yacc.c:1646  */
    break;

  case 1851:
#line 13792 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) list_make2((yyvsp[-2].list), (yyvsp[0].alias));
				}
#line 47176 "gram.c" /* yacc.c:1646  */
    break;

  case 1852:
#line 13796 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 47184 "gram.c" /* yacc.c:1646  */
    break;

  case 1853:
#line 13804 "gram.y" /* yacc.c:1646  */
    {
					/* inheritance query, implicitly */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inh = true;
					(yyval.range)->alias = NULL;
				}
#line 47195 "gram.c" /* yacc.c:1646  */
    break;

  case 1854:
#line 13811 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 47203 "gram.c" /* yacc.c:1646  */
    break;

  case 1855:
#line 13818 "gram.y" /* yacc.c:1646  */
    {
					/* inheritance query, explicitly */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inh = true;
					(yyval.range)->alias = NULL;
				}
#line 47214 "gram.c" /* yacc.c:1646  */
    break;

  case 1856:
#line 13825 "gram.y" /* yacc.c:1646  */
    {
					/* no inheritance */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inh = false;
					(yyval.range)->alias = NULL;
				}
#line 47225 "gram.c" /* yacc.c:1646  */
    break;

  case 1857:
#line 13832 "gram.y" /* yacc.c:1646  */
    {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inh = false;
					(yyval.range)->alias = NULL;
				}
#line 47236 "gram.c" /* yacc.c:1646  */
    break;

  case 1858:
#line 13842 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 47242 "gram.c" /* yacc.c:1646  */
    break;

  case 1859:
#line 13843 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 47248 "gram.c" /* yacc.c:1646  */
    break;

  case 1860:
#line 13857 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 47256 "gram.c" /* yacc.c:1646  */
    break;

  case 1861:
#line 13861 "gram.y" /* yacc.c:1646  */
    {
					Alias	   *alias = makeNode(Alias);

					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-1].range)->alias = alias;
					(yyval.range) = (yyvsp[-1].range);
				}
#line 47268 "gram.c" /* yacc.c:1646  */
    break;

  case 1862:
#line 13869 "gram.y" /* yacc.c:1646  */
    {
					Alias	   *alias = makeNode(Alias);

					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-2].range)->alias = alias;
					(yyval.range) = (yyvsp[-2].range);
				}
#line 47280 "gram.c" /* yacc.c:1646  */
    break;

  case 1863:
#line 13883 "gram.y" /* yacc.c:1646  */
    {
					RangeTableSample *n = makeNode(RangeTableSample);

					/* n->relation will be filled in later */
					n->method = (yyvsp[-4].list);
					n->args = (yyvsp[-2].list);
					n->repeatable = (yyvsp[0].node);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 47295 "gram.c" /* yacc.c:1646  */
    break;

  case 1864:
#line 13896 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].node); }
#line 47301 "gram.c" /* yacc.c:1646  */
    break;

  case 1865:
#line 13897 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 47307 "gram.c" /* yacc.c:1646  */
    break;

  case 1866:
#line 13913 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);

					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = false;
					n->functions = list_make1(list_make2((yyvsp[-1].node), NIL));
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 47322 "gram.c" /* yacc.c:1646  */
    break;

  case 1867:
#line 13924 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);

					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = true;
					n->functions = (yyvsp[-2].list);
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 47337 "gram.c" /* yacc.c:1646  */
    break;

  case 1868:
#line 13937 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].list)); }
#line 47343 "gram.c" /* yacc.c:1646  */
    break;

  case 1869:
#line 13941 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 47349 "gram.c" /* yacc.c:1646  */
    break;

  case 1870:
#line 13942 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 47355 "gram.c" /* yacc.c:1646  */
    break;

  case 1871:
#line 13945 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 47361 "gram.c" /* yacc.c:1646  */
    break;

  case 1872:
#line 13946 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 47367 "gram.c" /* yacc.c:1646  */
    break;

  case 1873:
#line 13949 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 47373 "gram.c" /* yacc.c:1646  */
    break;

  case 1874:
#line 13950 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 47379 "gram.c" /* yacc.c:1646  */
    break;

  case 1875:
#line 13955 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47385 "gram.c" /* yacc.c:1646  */
    break;

  case 1876:
#line 13956 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 47391 "gram.c" /* yacc.c:1646  */
    break;

  case 1877:
#line 13961 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47397 "gram.c" /* yacc.c:1646  */
    break;

  case 1878:
#line 13963 "gram.y" /* yacc.c:1646  */
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);

					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[0].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				}
#line 47410 "gram.c" /* yacc.c:1646  */
    break;

  case 1879:
#line 13971 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 47416 "gram.c" /* yacc.c:1646  */
    break;

  case 1880:
#line 13976 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 47422 "gram.c" /* yacc.c:1646  */
    break;

  case 1881:
#line 13977 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 47428 "gram.c" /* yacc.c:1646  */
    break;

  case 1882:
#line 13982 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 47436 "gram.c" /* yacc.c:1646  */
    break;

  case 1883:
#line 13986 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 47444 "gram.c" /* yacc.c:1646  */
    break;

  case 1884:
#line 13992 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-2].str);
					n->typeName = (yyvsp[-1].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collClause = (CollateClause *) (yyvsp[0].node);
					n->collOid = InvalidOid;
					n->constraints = NIL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 47467 "gram.c" /* yacc.c:1646  */
    break;

  case 1885:
#line 14017 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = makeNode(RangeTableFunc);

					n->rowexpr = (yyvsp[-4].node);
					n->docexpr = (yyvsp[-3].node);
					n->columns = (yyvsp[-1].list);
					n->namespaces = NIL;
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 47482 "gram.c" /* yacc.c:1646  */
    break;

  case 1886:
#line 14029 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = makeNode(RangeTableFunc);

					n->rowexpr = (yyvsp[-4].node);
					n->docexpr = (yyvsp[-3].node);
					n->columns = (yyvsp[-1].list);
					n->namespaces = (yyvsp[-7].list);
					n->location = (yylsp[-11]);
					(yyval.node) = (Node *) n;
				}
#line 47497 "gram.c" /* yacc.c:1646  */
    break;

  case 1887:
#line 14041 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 47503 "gram.c" /* yacc.c:1646  */
    break;

  case 1888:
#line 14042 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 47509 "gram.c" /* yacc.c:1646  */
    break;

  case 1889:
#line 14047 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol *fc = makeNode(RangeTableFuncCol);

					fc->colname = (yyvsp[-1].str);
					fc->for_ordinality = false;
					fc->typeName = (yyvsp[0].typnam);
					fc->is_not_null = false;
					fc->colexpr = NULL;
					fc->coldefexpr = NULL;
					fc->location = (yylsp[-1]);

					(yyval.node) = (Node *) fc;
				}
#line 47527 "gram.c" /* yacc.c:1646  */
    break;

  case 1890:
#line 14061 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol *fc = makeNode(RangeTableFuncCol);
					ListCell   *option;
					bool		nullability_seen = false;

					fc->colname = (yyvsp[-2].str);
					fc->typeName = (yyvsp[-1].typnam);
					fc->for_ordinality = false;
					fc->is_not_null = false;
					fc->colexpr = NULL;
					fc->coldefexpr = NULL;
					fc->location = (yylsp[-2]);

					foreach(option, (yyvsp[0].list))
					{
						DefElem   *defel = (DefElem *) lfirst(option);

						if (strcmp(defel->defname, "default") == 0)
						{
							if (fc->coldefexpr != NULL)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("only one DEFAULT value is allowed"),
										 parser_errposition(defel->location)));
							fc->coldefexpr = defel->arg;
						}
						else if (strcmp(defel->defname, "path") == 0)
						{
							if (fc->colexpr != NULL)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("only one PATH value per column is allowed"),
										 parser_errposition(defel->location)));
							fc->colexpr = defel->arg;
						}
						else if (strcmp(defel->defname, "is_not_null") == 0)
						{
							if (nullability_seen)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("conflicting or redundant NULL / NOT NULL declarations for column \"%s\"", fc->colname),
										 parser_errposition(defel->location)));
							fc->is_not_null = boolVal(defel->arg);
							nullability_seen = true;
						}
						else
						{
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("unrecognized column option \"%s\"",
											defel->defname),
									 parser_errposition(defel->location)));
						}
					}
					(yyval.node) = (Node *) fc;
				}
#line 47588 "gram.c" /* yacc.c:1646  */
    break;

  case 1891:
#line 14118 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol *fc = makeNode(RangeTableFuncCol);

					fc->colname = (yyvsp[-2].str);
					fc->for_ordinality = true;
					/* other fields are ignored, initialized by makeNode */
					fc->location = (yylsp[-2]);

					(yyval.node) = (Node *) fc;
				}
#line 47603 "gram.c" /* yacc.c:1646  */
    break;

  case 1892:
#line 14132 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 47609 "gram.c" /* yacc.c:1646  */
    break;

  case 1893:
#line 14134 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 47615 "gram.c" /* yacc.c:1646  */
    break;

  case 1894:
#line 14139 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1])); }
#line 47621 "gram.c" /* yacc.c:1646  */
    break;

  case 1895:
#line 14141 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("default", (yyvsp[0].node), (yylsp[-1])); }
#line 47627 "gram.c" /* yacc.c:1646  */
    break;

  case 1896:
#line 14143 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("is_not_null", (Node *) makeBoolean(true), (yylsp[-1])); }
#line 47633 "gram.c" /* yacc.c:1646  */
    break;

  case 1897:
#line 14145 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("is_not_null", (Node *) makeBoolean(false), (yylsp[0])); }
#line 47639 "gram.c" /* yacc.c:1646  */
    break;

  case 1898:
#line 14147 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("path", (yyvsp[0].node), (yylsp[-1])); }
#line 47645 "gram.c" /* yacc.c:1646  */
    break;

  case 1899:
#line 14152 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 47651 "gram.c" /* yacc.c:1646  */
    break;

  case 1900:
#line 14154 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 47657 "gram.c" /* yacc.c:1646  */
    break;

  case 1901:
#line 14159 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 47669 "gram.c" /* yacc.c:1646  */
    break;

  case 1902:
#line 14167 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (yyvsp[0].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 47681 "gram.c" /* yacc.c:1646  */
    break;

  case 1903:
#line 14183 "gram.y" /* yacc.c:1646  */
    {
					JsonTable *n = makeNode(JsonTable);
					char	  *pathstring;

					n->context_item = (JsonValueExpr *) (yyvsp[-10].node);
					if (!IsA((yyvsp[-8].node), A_Const) ||
						castNode(A_Const, (yyvsp[-8].node))->val.node.type != T_String)
						ereport(ERROR,
								errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								errmsg("only string constants are supported in JSON_TABLE path specification"),
								parser_errposition((yylsp[-8])));
					pathstring = castNode(A_Const, (yyvsp[-8].node))->val.sval.sval;
					n->pathspec = makeJsonTablePathSpec(pathstring, (yyvsp[-7].str), (yylsp[-8]), (yylsp[-7]));
					n->passing = (yyvsp[-6].list);
					n->columns = (yyvsp[-3].list);
					n->on_error = (JsonBehavior *) (yyvsp[-1].node);
					n->location = (yylsp[-12]);
					(yyval.node) = (Node *) n;
				}
#line 47705 "gram.c" /* yacc.c:1646  */
    break;

  case 1904:
#line 14205 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 47711 "gram.c" /* yacc.c:1646  */
    break;

  case 1905:
#line 14206 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 47717 "gram.c" /* yacc.c:1646  */
    break;

  case 1906:
#line 14211 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 47723 "gram.c" /* yacc.c:1646  */
    break;

  case 1907:
#line 14213 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 47729 "gram.c" /* yacc.c:1646  */
    break;

  case 1908:
#line 14218 "gram.y" /* yacc.c:1646  */
    {
					JsonTableColumn *n = makeNode(JsonTableColumn);

					n->coltype = JTC_FOR_ORDINALITY;
					n->name = (yyvsp[-2].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 47742 "gram.c" /* yacc.c:1646  */
    break;

  case 1909:
#line 14231 "gram.y" /* yacc.c:1646  */
    {
					JsonTableColumn *n = makeNode(JsonTableColumn);

					n->coltype = JTC_REGULAR;
					n->name = (yyvsp[-5].str);
					n->typeName = (yyvsp[-4].typnam);
					n->format = makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);
					n->pathspec = (JsonTablePathSpec *) (yyvsp[-3].node);
					n->wrapper = (yyvsp[-2].ival);
					n->quotes = (yyvsp[-1].ival);
					n->on_empty = (JsonBehavior *) linitial((yyvsp[0].list));
					n->on_error = (JsonBehavior *) lsecond((yyvsp[0].list));
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 47762 "gram.c" /* yacc.c:1646  */
    break;

  case 1910:
#line 14251 "gram.y" /* yacc.c:1646  */
    {
					JsonTableColumn *n = makeNode(JsonTableColumn);

					n->coltype = JTC_FORMATTED;
					n->name = (yyvsp[-6].str);
					n->typeName = (yyvsp[-5].typnam);
					n->format = (JsonFormat *) (yyvsp[-4].node);
					n->pathspec = (JsonTablePathSpec *) (yyvsp[-3].node);
					n->wrapper = (yyvsp[-2].ival);
					n->quotes = (yyvsp[-1].ival);
					n->on_empty = (JsonBehavior *) linitial((yyvsp[0].list));
					n->on_error = (JsonBehavior *) lsecond((yyvsp[0].list));
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 47782 "gram.c" /* yacc.c:1646  */
    break;

  case 1911:
#line 14269 "gram.y" /* yacc.c:1646  */
    {
					JsonTableColumn *n = makeNode(JsonTableColumn);

					n->coltype = JTC_EXISTS;
					n->name = (yyvsp[-4].str);
					n->typeName = (yyvsp[-3].typnam);
					n->format = makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);
					n->wrapper = JSW_NONE;
					n->quotes = JS_QUOTES_UNSPEC;
					n->pathspec = (JsonTablePathSpec *) (yyvsp[-1].node);
					n->on_empty = NULL;
					n->on_error = (JsonBehavior *) (yyvsp[0].node);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 47802 "gram.c" /* yacc.c:1646  */
    break;

  case 1912:
#line 14286 "gram.y" /* yacc.c:1646  */
    {
					JsonTableColumn *n = makeNode(JsonTableColumn);

					n->coltype = JTC_NESTED;
					n->pathspec = (JsonTablePathSpec *)
						makeJsonTablePathSpec((yyvsp[-4].str), NULL, (yylsp[-4]), -1);
					n->columns = (yyvsp[-1].list);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 47817 "gram.c" /* yacc.c:1646  */
    break;

  case 1913:
#line 14298 "gram.y" /* yacc.c:1646  */
    {
					JsonTableColumn *n = makeNode(JsonTableColumn);

					n->coltype = JTC_NESTED;
					n->pathspec = (JsonTablePathSpec *)
						makeJsonTablePathSpec((yyvsp[-6].str), (yyvsp[-4].str), (yylsp[-6]), (yylsp[-4]));
					n->columns = (yyvsp[-1].list);
					n->location = (yylsp[-8]);
					(yyval.node) = (Node *) n;
				}
#line 47832 "gram.c" /* yacc.c:1646  */
    break;

  case 1916:
#line 14317 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeJsonTablePathSpec((yyvsp[0].str), NULL, (yylsp[0]), -1); }
#line 47838 "gram.c" /* yacc.c:1646  */
    break;

  case 1917:
#line 14319 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 47844 "gram.c" /* yacc.c:1646  */
    break;

  case 1918:
#line 14333 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
				}
#line 47853 "gram.c" /* yacc.c:1646  */
    break;

  case 1919:
#line 14338 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
					(yyval.typnam)->setof = true;
				}
#line 47863 "gram.c" /* yacc.c:1646  */
    break;

  case 1920:
#line 14345 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
				}
#line 47872 "gram.c" /* yacc.c:1646  */
    break;

  case 1921:
#line 14350 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
					(yyval.typnam)->setof = true;
				}
#line 47882 "gram.c" /* yacc.c:1646  */
    break;

  case 1922:
#line 14356 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				}
#line 47891 "gram.c" /* yacc.c:1646  */
    break;

  case 1923:
#line 14361 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = true;
				}
#line 47901 "gram.c" /* yacc.c:1646  */
    break;

  case 1924:
#line 14370 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-2].list), makeInteger(-1)); }
#line 47907 "gram.c" /* yacc.c:1646  */
    break;

  case 1925:
#line 14372 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-3].list), makeInteger((yyvsp[-1].ival))); }
#line 47913 "gram.c" /* yacc.c:1646  */
    break;

  case 1926:
#line 14374 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = NIL; }
#line 47919 "gram.c" /* yacc.c:1646  */
    break;

  case 1927:
#line 14378 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 47925 "gram.c" /* yacc.c:1646  */
    break;

  case 1928:
#line 14379 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 47931 "gram.c" /* yacc.c:1646  */
    break;

  case 1929:
#line 14380 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 47937 "gram.c" /* yacc.c:1646  */
    break;

  case 1930:
#line 14381 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 47943 "gram.c" /* yacc.c:1646  */
    break;

  case 1931:
#line 14382 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 47949 "gram.c" /* yacc.c:1646  */
    break;

  case 1932:
#line 14384 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->typmods = (yyvsp[0].list);
				}
#line 47958 "gram.c" /* yacc.c:1646  */
    break;

  case 1933:
#line 14389 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-3].typnam);
					(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											 makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 47968 "gram.c" /* yacc.c:1646  */
    break;

  case 1934:
#line 14394 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 47974 "gram.c" /* yacc.c:1646  */
    break;

  case 1935:
#line 14409 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 47980 "gram.c" /* yacc.c:1646  */
    break;

  case 1936:
#line 14410 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 47986 "gram.c" /* yacc.c:1646  */
    break;

  case 1937:
#line 14411 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 47992 "gram.c" /* yacc.c:1646  */
    break;

  case 1938:
#line 14412 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 47998 "gram.c" /* yacc.c:1646  */
    break;

  case 1939:
#line 14413 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 48004 "gram.c" /* yacc.c:1646  */
    break;

  case 1940:
#line 14425 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeName((yyvsp[-1].str));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 48014 "gram.c" /* yacc.c:1646  */
    break;

  case 1941:
#line 14431 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-2].str)), (yyvsp[-1].list)));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-2]);
				}
#line 48024 "gram.c" /* yacc.c:1646  */
    break;

  case 1942:
#line 14438 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 48030 "gram.c" /* yacc.c:1646  */
    break;

  case 1943:
#line 14439 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 48036 "gram.c" /* yacc.c:1646  */
    break;

  case 1944:
#line 14446 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 48045 "gram.c" /* yacc.c:1646  */
    break;

  case 1945:
#line 14451 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 48054 "gram.c" /* yacc.c:1646  */
    break;

  case 1946:
#line 14456 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 48063 "gram.c" /* yacc.c:1646  */
    break;

  case 1947:
#line 14461 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 48072 "gram.c" /* yacc.c:1646  */
    break;

  case 1948:
#line 14466 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 48081 "gram.c" /* yacc.c:1646  */
    break;

  case 1949:
#line 14471 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 48090 "gram.c" /* yacc.c:1646  */
    break;

  case 1950:
#line 14476 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 48099 "gram.c" /* yacc.c:1646  */
    break;

  case 1951:
#line 14481 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 48109 "gram.c" /* yacc.c:1646  */
    break;

  case 1952:
#line 14487 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 48119 "gram.c" /* yacc.c:1646  */
    break;

  case 1953:
#line 14493 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 48129 "gram.c" /* yacc.c:1646  */
    break;

  case 1954:
#line 14499 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 48138 "gram.c" /* yacc.c:1646  */
    break;

  case 1955:
#line 14506 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[-1].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 parser_errposition((yylsp[-1]))));
					else if ((yyvsp[-1].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[-1].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 parser_errposition((yylsp[-1]))));
				}
#line 48163 "gram.c" /* yacc.c:1646  */
    break;

  case 1956:
#line 14527 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
				}
#line 48171 "gram.c" /* yacc.c:1646  */
    break;

  case 1957:
#line 14537 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 48179 "gram.c" /* yacc.c:1646  */
    break;

  case 1958:
#line 14541 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 48187 "gram.c" /* yacc.c:1646  */
    break;

  case 1959:
#line 14549 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 48195 "gram.c" /* yacc.c:1646  */
    break;

  case 1960:
#line 14553 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 48204 "gram.c" /* yacc.c:1646  */
    break;

  case 1961:
#line 14561 "gram.y" /* yacc.c:1646  */
    {
					char *typname;

					typname = (yyvsp[-3].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[-1].list);
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 48217 "gram.c" /* yacc.c:1646  */
    break;

  case 1962:
#line 14573 "gram.y" /* yacc.c:1646  */
    {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[0].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 48235 "gram.c" /* yacc.c:1646  */
    break;

  case 1963:
#line 14594 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 48243 "gram.c" /* yacc.c:1646  */
    break;

  case 1964:
#line 14598 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 48251 "gram.c" /* yacc.c:1646  */
    break;

  case 1965:
#line 14604 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 48259 "gram.c" /* yacc.c:1646  */
    break;

  case 1966:
#line 14608 "gram.y" /* yacc.c:1646  */
    {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 48274 "gram.c" /* yacc.c:1646  */
    break;

  case 1967:
#line 14621 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName((yyvsp[-3].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 48284 "gram.c" /* yacc.c:1646  */
    break;

  case 1968:
#line 14629 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName((yyvsp[0].str));
					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[0].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 48296 "gram.c" /* yacc.c:1646  */
    break;

  case 1969:
#line 14639 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 48302 "gram.c" /* yacc.c:1646  */
    break;

  case 1970:
#line 14641 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 48308 "gram.c" /* yacc.c:1646  */
    break;

  case 1971:
#line 14643 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "varchar"; }
#line 48314 "gram.c" /* yacc.c:1646  */
    break;

  case 1972:
#line 14645 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 48320 "gram.c" /* yacc.c:1646  */
    break;

  case 1973:
#line 14647 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 48326 "gram.c" /* yacc.c:1646  */
    break;

  case 1974:
#line 14649 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 48332 "gram.c" /* yacc.c:1646  */
    break;

  case 1975:
#line 14653 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 48338 "gram.c" /* yacc.c:1646  */
    break;

  case 1976:
#line 14654 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 48344 "gram.c" /* yacc.c:1646  */
    break;

  case 1977:
#line 14662 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 48357 "gram.c" /* yacc.c:1646  */
    break;

  case 1978:
#line 14671 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 48369 "gram.c" /* yacc.c:1646  */
    break;

  case 1979:
#line 14679 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 48382 "gram.c" /* yacc.c:1646  */
    break;

  case 1980:
#line 14688 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 48394 "gram.c" /* yacc.c:1646  */
    break;

  case 1981:
#line 14699 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 48403 "gram.c" /* yacc.c:1646  */
    break;

  case 1982:
#line 14706 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 48409 "gram.c" /* yacc.c:1646  */
    break;

  case 1983:
#line 14707 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 48415 "gram.c" /* yacc.c:1646  */
    break;

  case 1984:
#line 14708 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 48421 "gram.c" /* yacc.c:1646  */
    break;

  case 1985:
#line 14713 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[0]))); }
#line 48427 "gram.c" /* yacc.c:1646  */
    break;

  case 1986:
#line 14715 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[0]))); }
#line 48433 "gram.c" /* yacc.c:1646  */
    break;

  case 1987:
#line 14717 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[0]))); }
#line 48439 "gram.c" /* yacc.c:1646  */
    break;

  case 1988:
#line 14719 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[0]))); }
#line 48445 "gram.c" /* yacc.c:1646  */
    break;

  case 1989:
#line 14721 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[0]))); }
#line 48451 "gram.c" /* yacc.c:1646  */
    break;

  case 1990:
#line 14723 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 48457 "gram.c" /* yacc.c:1646  */
    break;

  case 1991:
#line 14725 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[-2])));
				}
#line 48466 "gram.c" /* yacc.c:1646  */
    break;

  case 1992:
#line 14730 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[-2])));
				}
#line 48475 "gram.c" /* yacc.c:1646  */
    break;

  case 1993:
#line 14735 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 48485 "gram.c" /* yacc.c:1646  */
    break;

  case 1994:
#line 14741 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 48497 "gram.c" /* yacc.c:1646  */
    break;

  case 1995:
#line 14749 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 48506 "gram.c" /* yacc.c:1646  */
    break;

  case 1996:
#line 14754 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 48517 "gram.c" /* yacc.c:1646  */
    break;

  case 1997:
#line 14761 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 48527 "gram.c" /* yacc.c:1646  */
    break;

  case 1998:
#line 14767 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 48533 "gram.c" /* yacc.c:1646  */
    break;

  case 1999:
#line 14772 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[0])));
				}
#line 48541 "gram.c" /* yacc.c:1646  */
    break;

  case 2000:
#line 14776 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[-3])),
									makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 48550 "gram.c" /* yacc.c:1646  */
    break;

  case 2001:
#line 14784 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("json");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 48559 "gram.c" /* yacc.c:1646  */
    break;

  case 2002:
#line 14818 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 48565 "gram.c" /* yacc.c:1646  */
    break;

  case 2003:
#line 14820 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 48571 "gram.c" /* yacc.c:1646  */
    break;

  case 2004:
#line 14822 "gram.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);

					n->arg = (yyvsp[-2].node);
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 48584 "gram.c" /* yacc.c:1646  */
    break;

  case 2005:
#line 14831 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("timezone"),
											   list_make2((yyvsp[0].node), (yyvsp[-4].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 48595 "gram.c" /* yacc.c:1646  */
    break;

  case 2006:
#line 14838 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("timezone"),
											   list_make1((yyvsp[-2].node)),
											   COERCE_SQL_SYNTAX,
											   -1);
				}
#line 48606 "gram.c" /* yacc.c:1646  */
    break;

  case 2007:
#line 14854 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 48612 "gram.c" /* yacc.c:1646  */
    break;

  case 2008:
#line 14856 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 48618 "gram.c" /* yacc.c:1646  */
    break;

  case 2009:
#line 14858 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 48624 "gram.c" /* yacc.c:1646  */
    break;

  case 2010:
#line 14860 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 48630 "gram.c" /* yacc.c:1646  */
    break;

  case 2011:
#line 14862 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 48636 "gram.c" /* yacc.c:1646  */
    break;

  case 2012:
#line 14864 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 48642 "gram.c" /* yacc.c:1646  */
    break;

  case 2013:
#line 14866 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 48648 "gram.c" /* yacc.c:1646  */
    break;

  case 2014:
#line 14868 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 48654 "gram.c" /* yacc.c:1646  */
    break;

  case 2015:
#line 14870 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 48660 "gram.c" /* yacc.c:1646  */
    break;

  case 2016:
#line 14872 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 48666 "gram.c" /* yacc.c:1646  */
    break;

  case 2017:
#line 14874 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 48672 "gram.c" /* yacc.c:1646  */
    break;

  case 2018:
#line 14876 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 48678 "gram.c" /* yacc.c:1646  */
    break;

  case 2019:
#line 14878 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 48684 "gram.c" /* yacc.c:1646  */
    break;

  case 2020:
#line 14880 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 48690 "gram.c" /* yacc.c:1646  */
    break;

  case 2021:
#line 14883 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 48696 "gram.c" /* yacc.c:1646  */
    break;

  case 2022:
#line 14885 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 48702 "gram.c" /* yacc.c:1646  */
    break;

  case 2023:
#line 14888 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAndExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 48708 "gram.c" /* yacc.c:1646  */
    break;

  case 2024:
#line 14890 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeOrExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 48714 "gram.c" /* yacc.c:1646  */
    break;

  case 2025:
#line 14892 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 48720 "gram.c" /* yacc.c:1646  */
    break;

  case 2026:
#line 14894 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 48726 "gram.c" /* yacc.c:1646  */
    break;

  case 2027:
#line 14897 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 48735 "gram.c" /* yacc.c:1646  */
    break;

  case 2028:
#line 14902 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 48748 "gram.c" /* yacc.c:1646  */
    break;

  case 2029:
#line 14911 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 48757 "gram.c" /* yacc.c:1646  */
    break;

  case 2030:
#line 14916 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 48770 "gram.c" /* yacc.c:1646  */
    break;

  case 2031:
#line 14925 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 48779 "gram.c" /* yacc.c:1646  */
    break;

  case 2032:
#line 14930 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 48792 "gram.c" /* yacc.c:1646  */
    break;

  case 2033:
#line 14939 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 48801 "gram.c" /* yacc.c:1646  */
    break;

  case 2034:
#line 14944 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 48814 "gram.c" /* yacc.c:1646  */
    break;

  case 2035:
#line 14954 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make1((yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-2]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-3].node), (Node *) n, (yylsp[-2]));
				}
#line 48827 "gram.c" /* yacc.c:1646  */
    break;

  case 2036:
#line 14963 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 48840 "gram.c" /* yacc.c:1646  */
    break;

  case 2037:
#line 14972 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make1((yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 48853 "gram.c" /* yacc.c:1646  */
    break;

  case 2038:
#line 14981 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-6].node), (Node *) n, (yylsp[-5]));
				}
#line 48866 "gram.c" /* yacc.c:1646  */
    break;

  case 2039:
#line 15000 "gram.y" /* yacc.c:1646  */
    {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-2].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 48879 "gram.c" /* yacc.c:1646  */
    break;

  case 2040:
#line 15009 "gram.y" /* yacc.c:1646  */
    {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 48892 "gram.c" /* yacc.c:1646  */
    break;

  case 2041:
#line 15018 "gram.y" /* yacc.c:1646  */
    {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-3].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 48905 "gram.c" /* yacc.c:1646  */
    break;

  case 2042:
#line 15027 "gram.y" /* yacc.c:1646  */
    {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 48918 "gram.c" /* yacc.c:1646  */
    break;

  case 2043:
#line 15036 "gram.y" /* yacc.c:1646  */
    {
					if (list_length((yyvsp[-2].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
								 parser_errposition((yylsp[-2]))));
					if (list_length((yyvsp[0].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlaps"),
											   list_concat((yyvsp[-2].list), (yyvsp[0].list)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-1]));
				}
#line 48939 "gram.c" /* yacc.c:1646  */
    break;

  case 2044:
#line 15053 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_TRUE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *) b;
				}
#line 48952 "gram.c" /* yacc.c:1646  */
    break;

  case 2045:
#line 15062 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_TRUE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *) b;
				}
#line 48965 "gram.c" /* yacc.c:1646  */
    break;

  case 2046:
#line 15071 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_FALSE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *) b;
				}
#line 48978 "gram.c" /* yacc.c:1646  */
    break;

  case 2047:
#line 15080 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_FALSE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *) b;
				}
#line 48991 "gram.c" /* yacc.c:1646  */
    break;

  case 2048:
#line 15089 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_UNKNOWN;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *) b;
				}
#line 49004 "gram.c" /* yacc.c:1646  */
    break;

  case 2049:
#line 15098 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *) b;
				}
#line 49017 "gram.c" /* yacc.c:1646  */
    break;

  case 2050:
#line 15107 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 49025 "gram.c" /* yacc.c:1646  */
    break;

  case 2051:
#line 15111 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 49033 "gram.c" /* yacc.c:1646  */
    break;

  case 2052:
#line 15115 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN,
												   "BETWEEN",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 49045 "gram.c" /* yacc.c:1646  */
    break;

  case 2053:
#line 15123 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN,
												   "NOT BETWEEN",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 49057 "gram.c" /* yacc.c:1646  */
    break;

  case 2054:
#line 15131 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN_SYM,
												   "BETWEEN SYMMETRIC",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 49069 "gram.c" /* yacc.c:1646  */
    break;

  case 2055:
#line 15139 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN_SYM,
												   "NOT BETWEEN SYMMETRIC",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 49081 "gram.c" /* yacc.c:1646  */
    break;

  case 2056:
#line 15147 "gram.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink	   *n = (SubLink *) (yyvsp[0].node);

						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-2].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-1]);
						(yyval.node) = (Node *) n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
					}
				}
#line 49106 "gram.c" /* yacc.c:1646  */
    break;

  case 2057:
#line 15168 "gram.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink	   *n = (SubLink *) (yyvsp[0].node);

						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-3].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-2]);
						/* Stick a NOT on top; must have same parse location */
						(yyval.node) = makeNotExpr((Node *) n, (yylsp[-2]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
					}
				}
#line 49133 "gram.c" /* yacc.c:1646  */
    break;

  case 2058:
#line 15191 "gram.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = (yyvsp[-1].ival);
					n->subLinkId = 0;
					n->testexpr = (yyvsp[-3].node);
					n->operName = (yyvsp[-2].list);
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 49149 "gram.c" /* yacc.c:1646  */
    break;

  case 2059:
#line 15203 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-3].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
				}
#line 49160 "gram.c" /* yacc.c:1646  */
    break;

  case 2060:
#line 15210 "gram.y" /* yacc.c:1646  */
    {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 parser_errposition((yylsp[-2]))));
				}
#line 49180 "gram.c" /* yacc.c:1646  */
    break;

  case 2061:
#line 15226 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 49189 "gram.c" /* yacc.c:1646  */
    break;

  case 2062:
#line 15231 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 49199 "gram.c" /* yacc.c:1646  */
    break;

  case 2063:
#line 15237 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("is_normalized"),
											   list_make1((yyvsp[-2].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-1]));
				}
#line 49210 "gram.c" /* yacc.c:1646  */
    break;

  case 2064:
#line 15244 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("is_normalized"),
											   list_make2((yyvsp[-3].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-2]));
				}
#line 49221 "gram.c" /* yacc.c:1646  */
    break;

  case 2065:
#line 15251 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr((Node *) makeFuncCall(SystemFuncName("is_normalized"),
														   list_make1((yyvsp[-3].node)),
														   COERCE_SQL_SYNTAX,
														   (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 49233 "gram.c" /* yacc.c:1646  */
    break;

  case 2066:
#line 15259 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr((Node *) makeFuncCall(SystemFuncName("is_normalized"),
														   list_make2((yyvsp[-4].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
														   COERCE_SQL_SYNTAX,
														   (yylsp[-3])),
									 (yylsp[-3]));
				}
#line 49245 "gram.c" /* yacc.c:1646  */
    break;

  case 2067:
#line 15268 "gram.y" /* yacc.c:1646  */
    {
					JsonFormat *format = makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);

					(yyval.node) = makeJsonIsPredicate((yyvsp[-3].node), format, (yyvsp[-1].ival), (yyvsp[0].boolean), (yylsp[-3]));
				}
#line 49255 "gram.c" /* yacc.c:1646  */
    break;

  case 2068:
#line 15286 "gram.y" /* yacc.c:1646  */
    {
					JsonFormat *format = makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);

					(yyval.node) = makeNotExpr(makeJsonIsPredicate((yyvsp[-4].node), format, (yyvsp[-1].ival), (yyvsp[0].boolean), (yylsp[-4])), (yylsp[-4]));
				}
#line 49265 "gram.c" /* yacc.c:1646  */
    break;

  case 2069:
#line 15303 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * The SQL spec only allows DEFAULT in "contextually typed
					 * expressions", but for us, it's easier to allow it in
					 * any a_expr and then throw error during parse analysis
					 * if it's in an inappropriate context.  This way also
					 * lets us say something smarter than "syntax error".
					 */
					SetToDefault *n = makeNode(SetToDefault);

					/* parse analysis will fill in the rest */
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 49284 "gram.c" /* yacc.c:1646  */
    break;

  case 2070:
#line 15329 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 49290 "gram.c" /* yacc.c:1646  */
    break;

  case 2071:
#line 15331 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 49296 "gram.c" /* yacc.c:1646  */
    break;

  case 2072:
#line 15333 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 49302 "gram.c" /* yacc.c:1646  */
    break;

  case 2073:
#line 15335 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 49308 "gram.c" /* yacc.c:1646  */
    break;

  case 2074:
#line 15337 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49314 "gram.c" /* yacc.c:1646  */
    break;

  case 2075:
#line 15339 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49320 "gram.c" /* yacc.c:1646  */
    break;

  case 2076:
#line 15341 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49326 "gram.c" /* yacc.c:1646  */
    break;

  case 2077:
#line 15343 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49332 "gram.c" /* yacc.c:1646  */
    break;

  case 2078:
#line 15345 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49338 "gram.c" /* yacc.c:1646  */
    break;

  case 2079:
#line 15347 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49344 "gram.c" /* yacc.c:1646  */
    break;

  case 2080:
#line 15349 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49350 "gram.c" /* yacc.c:1646  */
    break;

  case 2081:
#line 15351 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49356 "gram.c" /* yacc.c:1646  */
    break;

  case 2082:
#line 15353 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49362 "gram.c" /* yacc.c:1646  */
    break;

  case 2083:
#line 15355 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49368 "gram.c" /* yacc.c:1646  */
    break;

  case 2084:
#line 15357 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49374 "gram.c" /* yacc.c:1646  */
    break;

  case 2085:
#line 15359 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49380 "gram.c" /* yacc.c:1646  */
    break;

  case 2086:
#line 15361 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49386 "gram.c" /* yacc.c:1646  */
    break;

  case 2087:
#line 15363 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 49392 "gram.c" /* yacc.c:1646  */
    break;

  case 2088:
#line 15365 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 49400 "gram.c" /* yacc.c:1646  */
    break;

  case 2089:
#line 15369 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 49408 "gram.c" /* yacc.c:1646  */
    break;

  case 2090:
#line 15373 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 49417 "gram.c" /* yacc.c:1646  */
    break;

  case 2091:
#line 15378 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 49427 "gram.c" /* yacc.c:1646  */
    break;

  case 2092:
#line 15393 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 49433 "gram.c" /* yacc.c:1646  */
    break;

  case 2093:
#line 15394 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 49439 "gram.c" /* yacc.c:1646  */
    break;

  case 2094:
#line 15396 "gram.y" /* yacc.c:1646  */
    {
					ParamRef   *p = makeNode(ParamRef);

					p->number = (yyvsp[-1].ival);
					p->location = (yylsp[-1]);
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);

						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				}
#line 49460 "gram.c" /* yacc.c:1646  */
    break;

  case 2095:
#line 15413 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);

						n->arg = (yyvsp[-2].node);
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (yyvsp[-2].node);
				}
#line 49477 "gram.c" /* yacc.c:1646  */
    break;

  case 2096:
#line 15426 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 49483 "gram.c" /* yacc.c:1646  */
    break;

  case 2097:
#line 15428 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 49489 "gram.c" /* yacc.c:1646  */
    break;

  case 2098:
#line 15430 "gram.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 49505 "gram.c" /* yacc.c:1646  */
    break;

  case 2099:
#line 15442 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Because the select_with_parens nonterminal is designed
					 * to "eat" as many levels of parens as possible, the
					 * '(' a_expr ')' opt_indirection production above will
					 * fail to match a sub-SELECT with indirection decoration;
					 * the sub-SELECT won't be regarded as an a_expr as long
					 * as there are parens around it.  To support applying
					 * subscripting or field selection to a sub-SELECT result,
					 * we need this redundant-looking production.
					 */
					SubLink	   *n = makeNode(SubLink);
					A_Indirection *a = makeNode(A_Indirection);

					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[-1].node);
					n->location = (yylsp[-1]);
					a->arg = (Node *) n;
					a->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.node) = (Node *) a;
				}
#line 49534 "gram.c" /* yacc.c:1646  */
    break;

  case 2100:
#line 15467 "gram.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = EXISTS_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 49550 "gram.c" /* yacc.c:1646  */
    break;

  case 2101:
#line 15479 "gram.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = ARRAY_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 49566 "gram.c" /* yacc.c:1646  */
    break;

  case 2102:
#line 15491 "gram.y" /* yacc.c:1646  */
    {
					A_ArrayExpr *n = castNode(A_ArrayExpr, (yyvsp[0].node));

					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 49578 "gram.c" /* yacc.c:1646  */
    break;

  case 2103:
#line 15499 "gram.y" /* yacc.c:1646  */
    {
					RowExpr	   *r = makeNode(RowExpr);

					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_EXPLICIT_CALL; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *) r;
				}
#line 49593 "gram.c" /* yacc.c:1646  */
    break;

  case 2104:
#line 15510 "gram.y" /* yacc.c:1646  */
    {
					RowExpr	   *r = makeNode(RowExpr);

					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_IMPLICIT_CAST; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *) r;
				}
#line 49608 "gram.c" /* yacc.c:1646  */
    break;

  case 2105:
#line 15521 "gram.y" /* yacc.c:1646  */
    {
				  GroupingFunc *g = makeNode(GroupingFunc);

				  g->args = (yyvsp[-1].list);
				  g->location = (yylsp[-3]);
				  (yyval.node) = (Node *) g;
			  }
#line 49620 "gram.c" /* yacc.c:1646  */
    break;

  case 2106:
#line 15531 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall((yyvsp[-2].list), NIL,
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-2]));
				}
#line 49630 "gram.c" /* yacc.c:1646  */
    break;

  case 2107:
#line 15537 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-4].list), (yyvsp[-2].list),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));

					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 49643 "gram.c" /* yacc.c:1646  */
    break;

  case 2108:
#line 15546 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-5].list), list_make1((yyvsp[-2].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));

					n->func_variadic = true;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 49657 "gram.c" /* yacc.c:1646  */
    break;

  case 2109:
#line 15556 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-7].list), lappend((yyvsp[-5].list), (yyvsp[-2].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-7]));

					n->func_variadic = true;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 49671 "gram.c" /* yacc.c:1646  */
    break;

  case 2110:
#line 15566 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));

					n->agg_order = (yyvsp[-1].list);
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					(yyval.node) = (Node *) n;
				}
#line 49688 "gram.c" /* yacc.c:1646  */
    break;

  case 2111:
#line 15579 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));

					n->agg_order = (yyvsp[-1].list);
					n->agg_distinct = true;
					(yyval.node) = (Node *) n;
				}
#line 49702 "gram.c" /* yacc.c:1646  */
    break;

  case 2112:
#line 15589 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall   *n = makeFuncCall((yyvsp[-3].list), NIL,
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));

					n->agg_star = true;
					(yyval.node) = (Node *) n;
				}
#line 49725 "gram.c" /* yacc.c:1646  */
    break;

  case 2113:
#line 15620 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = (FuncCall *) (yyvsp[-3].node);

					/*
					 * The order clause for WITHIN GROUP and the one for
					 * plain-aggregate ORDER BY share a field, so we have to
					 * check here that at most one is present.  We also check
					 * for DISTINCT and VARIADIC here to give a better error
					 * location.  Other consistency checks are deferred to
					 * parse analysis.
					 */
					if ((yyvsp[-2].list) != NIL)
					{
						if (n->agg_order != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use multiple ORDER BY clauses with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->agg_distinct)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use DISTINCT with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->func_variadic)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use VARIADIC with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						n->agg_order = (yyvsp[-2].list);
						n->agg_within_group = true;
					}
					n->agg_filter = (yyvsp[-1].node);
					n->over = (yyvsp[0].windef);
					(yyval.node) = (Node *) n;
				}
#line 49765 "gram.c" /* yacc.c:1646  */
    break;

  case 2114:
#line 15656 "gram.y" /* yacc.c:1646  */
    {
					JsonAggConstructor *n = IsA((yyvsp[-2].node), JsonObjectAgg) ?
						((JsonObjectAgg *) (yyvsp[-2].node))->constructor :
						((JsonArrayAgg *) (yyvsp[-2].node))->constructor;

					n->agg_filter = (yyvsp[-1].node);
					n->over = (yyvsp[0].windef);
					(yyval.node) = (Node *) (yyvsp[-2].node);
				}
#line 49779 "gram.c" /* yacc.c:1646  */
    break;

  case 2115:
#line 15666 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 49785 "gram.c" /* yacc.c:1646  */
    break;

  case 2116:
#line 15676 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 49791 "gram.c" /* yacc.c:1646  */
    break;

  case 2117:
#line 15677 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 49797 "gram.c" /* yacc.c:1646  */
    break;

  case 2118:
#line 15678 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 49803 "gram.c" /* yacc.c:1646  */
    break;

  case 2119:
#line 15686 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("pg_collation_for"),
											   list_make1((yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 49814 "gram.c" /* yacc.c:1646  */
    break;

  case 2120:
#line 15693 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_DATE, -1, (yylsp[0]));
				}
#line 49822 "gram.c" /* yacc.c:1646  */
    break;

  case 2121:
#line 15697 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIME, -1, (yylsp[0]));
				}
#line 49830 "gram.c" /* yacc.c:1646  */
    break;

  case 2122:
#line 15701 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIME_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 49838 "gram.c" /* yacc.c:1646  */
    break;

  case 2123:
#line 15705 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIMESTAMP, -1, (yylsp[0]));
				}
#line 49846 "gram.c" /* yacc.c:1646  */
    break;

  case 2124:
#line 15709 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIMESTAMP_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 49854 "gram.c" /* yacc.c:1646  */
    break;

  case 2125:
#line 15713 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIME, -1, (yylsp[0]));
				}
#line 49862 "gram.c" /* yacc.c:1646  */
    break;

  case 2126:
#line 15717 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIME_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 49870 "gram.c" /* yacc.c:1646  */
    break;

  case 2127:
#line 15721 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIMESTAMP, -1, (yylsp[0]));
				}
#line 49878 "gram.c" /* yacc.c:1646  */
    break;

  case 2128:
#line 15725 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIMESTAMP_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 49886 "gram.c" /* yacc.c:1646  */
    break;

  case 2129:
#line 15729 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_ROLE, -1, (yylsp[0]));
				}
#line 49894 "gram.c" /* yacc.c:1646  */
    break;

  case 2130:
#line 15733 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_USER, -1, (yylsp[0]));
				}
#line 49902 "gram.c" /* yacc.c:1646  */
    break;

  case 2131:
#line 15737 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_SESSION_USER, -1, (yylsp[0]));
				}
#line 49910 "gram.c" /* yacc.c:1646  */
    break;

  case 2132:
#line 15741 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("system_user"),
											   NIL,
											   COERCE_SQL_SYNTAX,
											   (yylsp[0]));
				}
#line 49921 "gram.c" /* yacc.c:1646  */
    break;

  case 2133:
#line 15748 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_USER, -1, (yylsp[0]));
				}
#line 49929 "gram.c" /* yacc.c:1646  */
    break;

  case 2134:
#line 15752 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_CATALOG, -1, (yylsp[0]));
				}
#line 49937 "gram.c" /* yacc.c:1646  */
    break;

  case 2135:
#line 15756 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_SCHEMA, -1, (yylsp[0]));
				}
#line 49945 "gram.c" /* yacc.c:1646  */
    break;

  case 2136:
#line 15760 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-3].node), (yyvsp[-1].typnam), (yylsp[-5])); }
#line 49951 "gram.c" /* yacc.c:1646  */
    break;

  case 2137:
#line 15762 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("extract"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 49962 "gram.c" /* yacc.c:1646  */
    break;

  case 2138:
#line 15769 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("normalize"),
											   list_make1((yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 49973 "gram.c" /* yacc.c:1646  */
    break;

  case 2139:
#line 15776 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("normalize"),
											   list_make2((yyvsp[-3].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-5]));
				}
#line 49984 "gram.c" /* yacc.c:1646  */
    break;

  case 2140:
#line 15783 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlay"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 49995 "gram.c" /* yacc.c:1646  */
    break;

  case 2141:
#line 15790 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * allow functions named overlay() to be called without
					 * special syntax
					 */
					(yyval.node) = (Node *) makeFuncCall(list_make1(makeString("overlay")),
											   (yyvsp[-1].list),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-3]));
				}
#line 50010 "gram.c" /* yacc.c:1646  */
    break;

  case 2142:
#line 15801 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * position(A in B) is converted to position(B, A)
					 *
					 * We deliberately don't offer a "plain syntax" option
					 * for position(), because the reversal of the arguments
					 * creates too much risk of confusion.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("position"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 50028 "gram.c" /* yacc.c:1646  */
    break;

  case 2143:
#line 15815 "gram.y" /* yacc.c:1646  */
    {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("substring"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 50042 "gram.c" /* yacc.c:1646  */
    break;

  case 2144:
#line 15825 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * allow functions named substring() to be called without
					 * special syntax
					 */
					(yyval.node) = (Node *) makeFuncCall(list_make1(makeString("substring")),
											   (yyvsp[-1].list),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-3]));
				}
#line 50057 "gram.c" /* yacc.c:1646  */
    break;

  case 2145:
#line 15836 "gram.y" /* yacc.c:1646  */
    {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 *
					 * Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName(strVal(llast((yyvsp[-1].typnam)->names))),
											   list_make1((yyvsp[-3].node)),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-5]));
				}
#line 50077 "gram.c" /* yacc.c:1646  */
    break;

  case 2146:
#line 15852 "gram.y" /* yacc.c:1646  */
    {
					/* various trim expressions are defined in SQL
					 * - thomas 1997-07-19
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 50091 "gram.c" /* yacc.c:1646  */
    break;

  case 2147:
#line 15862 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("ltrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 50102 "gram.c" /* yacc.c:1646  */
    break;

  case 2148:
#line 15869 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("rtrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 50113 "gram.c" /* yacc.c:1646  */
    break;

  case 2149:
#line 15876 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 50124 "gram.c" /* yacc.c:1646  */
    break;

  case 2150:
#line 15883 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[-3].node), (yyvsp[-1].node), (yylsp[-5]));
				}
#line 50132 "gram.c" /* yacc.c:1646  */
    break;

  case 2151:
#line 15887 "gram.y" /* yacc.c:1646  */
    {
					CoalesceExpr *c = makeNode(CoalesceExpr);

					c->args = (yyvsp[-1].list);
					c->location = (yylsp[-3]);
					(yyval.node) = (Node *) c;
				}
#line 50144 "gram.c" /* yacc.c:1646  */
    break;

  case 2152:
#line 15895 "gram.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);

					v->args = (yyvsp[-1].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *) v;
				}
#line 50157 "gram.c" /* yacc.c:1646  */
    break;

  case 2153:
#line 15904 "gram.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);

					v->args = (yyvsp[-1].list);
					v->op = IS_LEAST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *) v;
				}
#line 50170 "gram.c" /* yacc.c:1646  */
    break;

  case 2154:
#line 15913 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 50178 "gram.c" /* yacc.c:1646  */
    break;

  case 2155:
#line 15917 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-1].str), NIL, NIL, (yylsp[-4]));
				}
#line 50186 "gram.c" /* yacc.c:1646  */
    break;

  case 2156:
#line 15921 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), (yyvsp[-1].list), NIL, (yylsp[-6]));
				}
#line 50194 "gram.c" /* yacc.c:1646  */
    break;

  case 2157:
#line 15925 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), NIL, (yyvsp[-1].list), (yylsp[-6]));
				}
#line 50202 "gram.c" /* yacc.c:1646  */
    break;

  case 2158:
#line 15929 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-5].str), (yyvsp[-3].list), (yyvsp[-1].list), (yylsp[-8]));
				}
#line 50210 "gram.c" /* yacc.c:1646  */
    break;

  case 2159:
#line 15933 "gram.y" /* yacc.c:1646  */
    {
					/* xmlexists(A PASSING [BY REF] B [BY REF]) is
					 * converted to xmlexists(A, B)*/
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("xmlexists"),
											   list_make2((yyvsp[-2].node), (yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 50223 "gram.c" /* yacc.c:1646  */
    break;

  case 2160:
#line 15942 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[-1].list), NIL, (yylsp[-3]));
				}
#line 50231 "gram.c" /* yacc.c:1646  */
    break;

  case 2161:
#line 15946 "gram.y" /* yacc.c:1646  */
    {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[-2].node), makeBoolAConst((yyvsp[-1].boolean), -1)),
									(yylsp[-5]));

					x->xmloption = (yyvsp[-3].ival);
					(yyval.node) = (Node *) x;
				}
#line 50245 "gram.c" /* yacc.c:1646  */
    break;

  case 2162:
#line 15956 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-1].str), NULL, NIL, (yylsp[-4]));
				}
#line 50253 "gram.c" /* yacc.c:1646  */
    break;

  case 2163:
#line 15960 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-3].str), NULL, list_make1((yyvsp[-1].node)), (yylsp[-6]));
				}
#line 50261 "gram.c" /* yacc.c:1646  */
    break;

  case 2164:
#line 15964 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[-1].node)), (yylsp[-6]));
				}
#line 50270 "gram.c" /* yacc.c:1646  */
    break;

  case 2165:
#line 15969 "gram.y" /* yacc.c:1646  */
    {
					XmlSerialize *n = makeNode(XmlSerialize);

					n->xmloption = (yyvsp[-5].ival);
					n->expr = (yyvsp[-4].node);
					n->typeName = (yyvsp[-2].typnam);
					n->indent = (yyvsp[-1].boolean);
					n->location = (yylsp[-7]);
					(yyval.node) = (Node *) n;
				}
#line 50285 "gram.c" /* yacc.c:1646  */
    break;

  case 2166:
#line 15980 "gram.y" /* yacc.c:1646  */
    {
					/* Support for legacy (non-standard) json_object() */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("json_object"),
											   (yyvsp[-1].list), COERCE_EXPLICIT_CALL, (yylsp[-3]));
				}
#line 50295 "gram.c" /* yacc.c:1646  */
    break;

  case 2167:
#line 15989 "gram.y" /* yacc.c:1646  */
    {
					JsonObjectConstructor *n = makeNode(JsonObjectConstructor);

					n->exprs = (yyvsp[-4].list);
					n->absent_on_null = (yyvsp[-3].boolean);
					n->unique = (yyvsp[-2].boolean);
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 50310 "gram.c" /* yacc.c:1646  */
    break;

  case 2168:
#line 16000 "gram.y" /* yacc.c:1646  */
    {
					JsonObjectConstructor *n = makeNode(JsonObjectConstructor);

					n->exprs = NULL;
					n->absent_on_null = false;
					n->unique = false;
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 50325 "gram.c" /* yacc.c:1646  */
    break;

  case 2169:
#line 16015 "gram.y" /* yacc.c:1646  */
    {
					JsonArrayConstructor *n = makeNode(JsonArrayConstructor);

					n->exprs = (yyvsp[-3].list);
					n->absent_on_null = (yyvsp[-2].boolean);
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 50339 "gram.c" /* yacc.c:1646  */
    break;

  case 2170:
#line 16030 "gram.y" /* yacc.c:1646  */
    {
					JsonArrayQueryConstructor *n = makeNode(JsonArrayQueryConstructor);

					n->query = (yyvsp[-3].node);
					n->format = (JsonFormat *) (yyvsp[-2].node);
					n->absent_on_null = true;	/* XXX */
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 50354 "gram.c" /* yacc.c:1646  */
    break;

  case 2171:
#line 16043 "gram.y" /* yacc.c:1646  */
    {
					JsonArrayConstructor *n = makeNode(JsonArrayConstructor);

					n->exprs = NIL;
					n->absent_on_null = true;
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 50368 "gram.c" /* yacc.c:1646  */
    break;

  case 2172:
#line 16053 "gram.y" /* yacc.c:1646  */
    {
					JsonParseExpr *n = makeNode(JsonParseExpr);

					n->expr = (JsonValueExpr *) (yyvsp[-2].node);
					n->unique_keys = (yyvsp[-1].boolean);
					n->output = NULL;
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 50382 "gram.c" /* yacc.c:1646  */
    break;

  case 2173:
#line 16063 "gram.y" /* yacc.c:1646  */
    {
					JsonScalarExpr *n = makeNode(JsonScalarExpr);

					n->expr = (Expr *) (yyvsp[-1].node);
					n->output = NULL;
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 50395 "gram.c" /* yacc.c:1646  */
    break;

  case 2174:
#line 16072 "gram.y" /* yacc.c:1646  */
    {
					JsonSerializeExpr *n = makeNode(JsonSerializeExpr);

					n->expr = (JsonValueExpr *) (yyvsp[-2].node);
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 50408 "gram.c" /* yacc.c:1646  */
    break;

  case 2175:
#line 16081 "gram.y" /* yacc.c:1646  */
    {
					MergeSupportFunc *m = makeNode(MergeSupportFunc);

					m->msftype = TEXTOID;
					m->location = (yylsp[-2]);
					(yyval.node) = (Node *) m;
				}
#line 50420 "gram.c" /* yacc.c:1646  */
    break;

  case 2176:
#line 16095 "gram.y" /* yacc.c:1646  */
    {
					JsonFuncExpr *n = makeNode(JsonFuncExpr);

					n->op = JSON_QUERY_OP;
					n->context_item = (JsonValueExpr *) (yyvsp[-8].node);
					n->pathspec = (yyvsp[-6].node);
					n->passing = (yyvsp[-5].list);
					n->output = (JsonOutput *) (yyvsp[-4].node);
					n->wrapper = (yyvsp[-3].ival);
					n->quotes = (yyvsp[-2].ival);
					n->on_empty = (JsonBehavior *) linitial((yyvsp[-1].list));
					n->on_error = (JsonBehavior *) lsecond((yyvsp[-1].list));
					n->location = (yylsp[-10]);
					(yyval.node) = (Node *) n;
				}
#line 50440 "gram.c" /* yacc.c:1646  */
    break;

  case 2177:
#line 16114 "gram.y" /* yacc.c:1646  */
    {
					JsonFuncExpr *n = makeNode(JsonFuncExpr);

					n->op = JSON_EXISTS_OP;
					n->context_item = (JsonValueExpr *) (yyvsp[-5].node);
					n->pathspec = (yyvsp[-3].node);
					n->passing = (yyvsp[-2].list);
					n->output = NULL;
					n->on_error = (JsonBehavior *) (yyvsp[-1].node);
					n->location = (yylsp[-7]);
					(yyval.node) = (Node *) n;
				}
#line 50457 "gram.c" /* yacc.c:1646  */
    break;

  case 2178:
#line 16131 "gram.y" /* yacc.c:1646  */
    {
					JsonFuncExpr *n = makeNode(JsonFuncExpr);

					n->op = JSON_VALUE_OP;
					n->context_item = (JsonValueExpr *) (yyvsp[-6].node);
					n->pathspec = (yyvsp[-4].node);
					n->passing = (yyvsp[-3].list);
					n->output = (JsonOutput *) (yyvsp[-2].node);
					n->on_empty = (JsonBehavior *) linitial((yyvsp[-1].list));
					n->on_error = (JsonBehavior *) lsecond((yyvsp[-1].list));
					n->location = (yylsp[-8]);
					(yyval.node) = (Node *) n;
				}
#line 50475 "gram.c" /* yacc.c:1646  */
    break;

  case 2179:
#line 16151 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 50481 "gram.c" /* yacc.c:1646  */
    break;

  case 2180:
#line 16153 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNullAConst(-1); }
#line 50487 "gram.c" /* yacc.c:1646  */
    break;

  case 2181:
#line 16157 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); }
#line 50493 "gram.c" /* yacc.c:1646  */
    break;

  case 2182:
#line 16159 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); }
#line 50499 "gram.c" /* yacc.c:1646  */
    break;

  case 2183:
#line 16161 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); }
#line 50505 "gram.c" /* yacc.c:1646  */
    break;

  case 2184:
#line 16163 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); }
#line 50511 "gram.c" /* yacc.c:1646  */
    break;

  case 2185:
#line 16166 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 50517 "gram.c" /* yacc.c:1646  */
    break;

  case 2186:
#line 16169 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 50523 "gram.c" /* yacc.c:1646  */
    break;

  case 2187:
#line 16170 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 50529 "gram.c" /* yacc.c:1646  */
    break;

  case 2188:
#line 16174 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 50541 "gram.c" /* yacc.c:1646  */
    break;

  case 2189:
#line 16182 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 50553 "gram.c" /* yacc.c:1646  */
    break;

  case 2190:
#line 16191 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_DOCUMENT; }
#line 50559 "gram.c" /* yacc.c:1646  */
    break;

  case 2191:
#line 16192 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_CONTENT; }
#line 50565 "gram.c" /* yacc.c:1646  */
    break;

  case 2192:
#line 16195 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 50571 "gram.c" /* yacc.c:1646  */
    break;

  case 2193:
#line 16196 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 50577 "gram.c" /* yacc.c:1646  */
    break;

  case 2194:
#line 16197 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 50583 "gram.c" /* yacc.c:1646  */
    break;

  case 2195:
#line 16200 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 50589 "gram.c" /* yacc.c:1646  */
    break;

  case 2196:
#line 16201 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 50595 "gram.c" /* yacc.c:1646  */
    break;

  case 2197:
#line 16202 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 50601 "gram.c" /* yacc.c:1646  */
    break;

  case 2198:
#line 16208 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 50609 "gram.c" /* yacc.c:1646  */
    break;

  case 2199:
#line 16212 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-1].node);
				}
#line 50617 "gram.c" /* yacc.c:1646  */
    break;

  case 2200:
#line 16216 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 50625 "gram.c" /* yacc.c:1646  */
    break;

  case 2201:
#line 16220 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-1].node);
				}
#line 50633 "gram.c" /* yacc.c:1646  */
    break;

  case 2204:
#line 16235 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 50639 "gram.c" /* yacc.c:1646  */
    break;

  case 2205:
#line 16236 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 50645 "gram.c" /* yacc.c:1646  */
    break;

  case 2206:
#line 16240 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 50651 "gram.c" /* yacc.c:1646  */
    break;

  case 2207:
#line 16241 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 50657 "gram.c" /* yacc.c:1646  */
    break;

  case 2208:
#line 16249 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 50663 "gram.c" /* yacc.c:1646  */
    break;

  case 2209:
#line 16250 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 50669 "gram.c" /* yacc.c:1646  */
    break;

  case 2210:
#line 16254 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].windef)); }
#line 50675 "gram.c" /* yacc.c:1646  */
    break;

  case 2211:
#line 16256 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].windef)); }
#line 50681 "gram.c" /* yacc.c:1646  */
    break;

  case 2212:
#line 16261 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[0].windef);

					n->name = (yyvsp[-2].str);
					(yyval.windef) = n;
				}
#line 50692 "gram.c" /* yacc.c:1646  */
    break;

  case 2213:
#line 16270 "gram.y" /* yacc.c:1646  */
    { (yyval.windef) = (yyvsp[0].windef); }
#line 50698 "gram.c" /* yacc.c:1646  */
    break;

  case 2214:
#line 16272 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->name = (yyvsp[0].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					n->location = (yylsp[0]);
					(yyval.windef) = n;
				}
#line 50716 "gram.c" /* yacc.c:1646  */
    break;

  case 2215:
#line 16286 "gram.y" /* yacc.c:1646  */
    { (yyval.windef) = NULL; }
#line 50722 "gram.c" /* yacc.c:1646  */
    break;

  case 2216:
#line 16291 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->name = NULL;
					n->refname = (yyvsp[-4].str);
					n->partitionClause = (yyvsp[-3].list);
					n->orderClause = (yyvsp[-2].list);
					/* copy relevant fields of opt_frame_clause */
					n->frameOptions = (yyvsp[-1].windef)->frameOptions;
					n->startOffset = (yyvsp[-1].windef)->startOffset;
					n->endOffset = (yyvsp[-1].windef)->endOffset;
					n->location = (yylsp[-5]);
					(yyval.windef) = n;
				}
#line 50741 "gram.c" /* yacc.c:1646  */
    break;

  case 2217:
#line 16317 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 50747 "gram.c" /* yacc.c:1646  */
    break;

  case 2218:
#line 16318 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 50753 "gram.c" /* yacc.c:1646  */
    break;

  case 2219:
#line 16321 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 50759 "gram.c" /* yacc.c:1646  */
    break;

  case 2220:
#line 16322 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 50765 "gram.c" /* yacc.c:1646  */
    break;

  case 2221:
#line 16331 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[-1].windef);

					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 50777 "gram.c" /* yacc.c:1646  */
    break;

  case 2222:
#line 16339 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[-1].windef);

					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 50789 "gram.c" /* yacc.c:1646  */
    break;

  case 2223:
#line 16347 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[-1].windef);

					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_GROUPS;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 50801 "gram.c" /* yacc.c:1646  */
    break;

  case 2224:
#line 16355 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 50814 "gram.c" /* yacc.c:1646  */
    break;

  case 2225:
#line 16366 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[0].windef);

					/* reject invalid cases */
					if (n->frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[0]))));
					if (n->frameOptions & FRAMEOPTION_START_OFFSET_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot end with current row"),
								 parser_errposition((yylsp[0]))));
					n->frameOptions |= FRAMEOPTION_END_CURRENT_ROW;
					(yyval.windef) = n;
				}
#line 50836 "gram.c" /* yacc.c:1646  */
    break;

  case 2226:
#line 16384 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n1 = (yyvsp[-2].windef);
					WindowDef  *n2 = (yyvsp[0].windef);

					/* form merged options */
					int		frameOptions = n1->frameOptions;
					/* shift converts START_ options to END_ options */
					frameOptions |= n2->frameOptions << 1;
					frameOptions |= FRAMEOPTION_BETWEEN;
					/* reject invalid cases */
					if (frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[-2]))));
					if (frameOptions & FRAMEOPTION_END_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_CURRENT_ROW) &&
						(frameOptions & FRAMEOPTION_END_OFFSET_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from current row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_OFFSET_FOLLOWING) &&
						(frameOptions & (FRAMEOPTION_END_OFFSET_PRECEDING |
										 FRAMEOPTION_END_CURRENT_ROW)))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					n1->frameOptions = frameOptions;
					n1->endOffset = n2->startOffset;
					(yyval.windef) = n1;
				}
#line 50878 "gram.c" /* yacc.c:1646  */
    break;

  case 2227:
#line 16430 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 50891 "gram.c" /* yacc.c:1646  */
    break;

  case 2228:
#line 16439 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 50904 "gram.c" /* yacc.c:1646  */
    break;

  case 2229:
#line 16448 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_CURRENT_ROW;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 50917 "gram.c" /* yacc.c:1646  */
    break;

  case 2230:
#line 16457 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_OFFSET_PRECEDING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 50930 "gram.c" /* yacc.c:1646  */
    break;

  case 2231:
#line 16466 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_OFFSET_FOLLOWING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 50943 "gram.c" /* yacc.c:1646  */
    break;

  case 2232:
#line 16477 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FRAMEOPTION_EXCLUDE_CURRENT_ROW; }
#line 50949 "gram.c" /* yacc.c:1646  */
    break;

  case 2233:
#line 16478 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FRAMEOPTION_EXCLUDE_GROUP; }
#line 50955 "gram.c" /* yacc.c:1646  */
    break;

  case 2234:
#line 16479 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FRAMEOPTION_EXCLUDE_TIES; }
#line 50961 "gram.c" /* yacc.c:1646  */
    break;

  case 2235:
#line 16480 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 50967 "gram.c" /* yacc.c:1646  */
    break;

  case 2236:
#line 16481 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 50973 "gram.c" /* yacc.c:1646  */
    break;

  case 2237:
#line 16495 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 50979 "gram.c" /* yacc.c:1646  */
    break;

  case 2238:
#line 16496 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 50985 "gram.c" /* yacc.c:1646  */
    break;

  case 2239:
#line 16497 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 50991 "gram.c" /* yacc.c:1646  */
    break;

  case 2240:
#line 16500 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 50997 "gram.c" /* yacc.c:1646  */
    break;

  case 2241:
#line 16501 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 51003 "gram.c" /* yacc.c:1646  */
    break;

  case 2242:
#line 16504 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 51009 "gram.c" /* yacc.c:1646  */
    break;

  case 2243:
#line 16507 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 51015 "gram.c" /* yacc.c:1646  */
    break;

  case 2244:
#line 16508 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 51021 "gram.c" /* yacc.c:1646  */
    break;

  case 2245:
#line 16509 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ALL_SUBLINK; }
#line 51027 "gram.c" /* yacc.c:1646  */
    break;

  case 2246:
#line 16512 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 51033 "gram.c" /* yacc.c:1646  */
    break;

  case 2247:
#line 16513 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 51039 "gram.c" /* yacc.c:1646  */
    break;

  case 2248:
#line 16516 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "+"; }
#line 51045 "gram.c" /* yacc.c:1646  */
    break;

  case 2249:
#line 16517 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "-"; }
#line 51051 "gram.c" /* yacc.c:1646  */
    break;

  case 2250:
#line 16518 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "*"; }
#line 51057 "gram.c" /* yacc.c:1646  */
    break;

  case 2251:
#line 16519 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "/"; }
#line 51063 "gram.c" /* yacc.c:1646  */
    break;

  case 2252:
#line 16520 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "%"; }
#line 51069 "gram.c" /* yacc.c:1646  */
    break;

  case 2253:
#line 16521 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "^"; }
#line 51075 "gram.c" /* yacc.c:1646  */
    break;

  case 2254:
#line 16522 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<"; }
#line 51081 "gram.c" /* yacc.c:1646  */
    break;

  case 2255:
#line 16523 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = ">"; }
#line 51087 "gram.c" /* yacc.c:1646  */
    break;

  case 2256:
#line 16524 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "="; }
#line 51093 "gram.c" /* yacc.c:1646  */
    break;

  case 2257:
#line 16525 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<="; }
#line 51099 "gram.c" /* yacc.c:1646  */
    break;

  case 2258:
#line 16526 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = ">="; }
#line 51105 "gram.c" /* yacc.c:1646  */
    break;

  case 2259:
#line 16527 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<>"; }
#line 51111 "gram.c" /* yacc.c:1646  */
    break;

  case 2260:
#line 16531 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 51117 "gram.c" /* yacc.c:1646  */
    break;

  case 2261:
#line 16533 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 51123 "gram.c" /* yacc.c:1646  */
    break;

  case 2262:
#line 16538 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 51129 "gram.c" /* yacc.c:1646  */
    break;

  case 2263:
#line 16540 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 51135 "gram.c" /* yacc.c:1646  */
    break;

  case 2264:
#line 16545 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 51141 "gram.c" /* yacc.c:1646  */
    break;

  case 2265:
#line 16547 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 51147 "gram.c" /* yacc.c:1646  */
    break;

  case 2266:
#line 16549 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~")); }
#line 51153 "gram.c" /* yacc.c:1646  */
    break;

  case 2267:
#line 16551 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~")); }
#line 51159 "gram.c" /* yacc.c:1646  */
    break;

  case 2268:
#line 16553 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~*")); }
#line 51165 "gram.c" /* yacc.c:1646  */
    break;

  case 2269:
#line 16555 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~*")); }
#line 51171 "gram.c" /* yacc.c:1646  */
    break;

  case 2270:
#line 16567 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 51179 "gram.c" /* yacc.c:1646  */
    break;

  case 2271:
#line 16571 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 51187 "gram.c" /* yacc.c:1646  */
    break;

  case 2272:
#line 16578 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 51195 "gram.c" /* yacc.c:1646  */
    break;

  case 2273:
#line 16582 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 51203 "gram.c" /* yacc.c:1646  */
    break;

  case 2274:
#line 16588 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 51211 "gram.c" /* yacc.c:1646  */
    break;

  case 2275:
#line 16592 "gram.y" /* yacc.c:1646  */
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);

					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 51225 "gram.c" /* yacc.c:1646  */
    break;

  case 2276:
#line 16602 "gram.y" /* yacc.c:1646  */
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);

					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 51239 "gram.c" /* yacc.c:1646  */
    break;

  case 2277:
#line 16613 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 51245 "gram.c" /* yacc.c:1646  */
    break;

  case 2278:
#line 16614 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 51251 "gram.c" /* yacc.c:1646  */
    break;

  case 2279:
#line 16617 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 51257 "gram.c" /* yacc.c:1646  */
    break;

  case 2280:
#line 16618 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 51263 "gram.c" /* yacc.c:1646  */
    break;

  case 2281:
#line 16622 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 51271 "gram.c" /* yacc.c:1646  */
    break;

  case 2282:
#line 16626 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 51279 "gram.c" /* yacc.c:1646  */
    break;

  case 2283:
#line 16630 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[-1]));
				}
#line 51287 "gram.c" /* yacc.c:1646  */
    break;

  case 2284:
#line 16635 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 51293 "gram.c" /* yacc.c:1646  */
    break;

  case 2285:
#line 16636 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 51299 "gram.c" /* yacc.c:1646  */
    break;

  case 2286:
#line 16642 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeStringConst((yyvsp[-2].str), (yylsp[-2])), (yyvsp[0].node));
				}
#line 51307 "gram.c" /* yacc.c:1646  */
    break;

  case 2287:
#line 16651 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 51313 "gram.c" /* yacc.c:1646  */
    break;

  case 2288:
#line 16652 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "year"; }
#line 51319 "gram.c" /* yacc.c:1646  */
    break;

  case 2289:
#line 16653 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "month"; }
#line 51325 "gram.c" /* yacc.c:1646  */
    break;

  case 2290:
#line 16654 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "day"; }
#line 51331 "gram.c" /* yacc.c:1646  */
    break;

  case 2291:
#line 16655 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "hour"; }
#line 51337 "gram.c" /* yacc.c:1646  */
    break;

  case 2292:
#line 16656 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "minute"; }
#line 51343 "gram.c" /* yacc.c:1646  */
    break;

  case 2293:
#line 16657 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "second"; }
#line 51349 "gram.c" /* yacc.c:1646  */
    break;

  case 2294:
#line 16658 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 51355 "gram.c" /* yacc.c:1646  */
    break;

  case 2295:
#line 16662 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "NFC"; }
#line 51361 "gram.c" /* yacc.c:1646  */
    break;

  case 2296:
#line 16663 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "NFD"; }
#line 51367 "gram.c" /* yacc.c:1646  */
    break;

  case 2297:
#line 16664 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "NFKC"; }
#line 51373 "gram.c" /* yacc.c:1646  */
    break;

  case 2298:
#line 16665 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "NFKD"; }
#line 51379 "gram.c" /* yacc.c:1646  */
    break;

  case 2299:
#line 16671 "gram.y" /* yacc.c:1646  */
    {
					/* overlay(A PLACING B FROM C FOR D) is converted to overlay(A, B, C, D) */
					(yyval.list) = list_make4((yyvsp[-6].node), (yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 51388 "gram.c" /* yacc.c:1646  */
    break;

  case 2300:
#line 16676 "gram.y" /* yacc.c:1646  */
    {
					/* overlay(A PLACING B FROM C) is converted to overlay(A, B, C) */
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 51397 "gram.c" /* yacc.c:1646  */
    break;

  case 2301:
#line 16684 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), (yyvsp[-2].node)); }
#line 51403 "gram.c" /* yacc.c:1646  */
    break;

  case 2302:
#line 16706 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 51411 "gram.c" /* yacc.c:1646  */
    break;

  case 2303:
#line 16710 "gram.y" /* yacc.c:1646  */
    {
					/* not legal per SQL, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[0].node), (yyvsp[-2].node));
				}
#line 51420 "gram.c" /* yacc.c:1646  */
    break;

  case 2304:
#line 16715 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Because we aren't restricting data types here, this
					 * syntax can end up resolving to textregexsubstr().
					 * We've historically allowed that to happen, so continue
					 * to accept it.  However, ruleutils.c will reverse-list
					 * such a call in regular function call syntax.
					 */
					(yyval.list) = list_make2((yyvsp[-2].node), (yyvsp[0].node));
				}
#line 51435 "gram.c" /* yacc.c:1646  */
    break;

  case 2305:
#line 16726 "gram.y" /* yacc.c:1646  */
    {
					/* not legal per SQL */

					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[-2].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[0].node),
												 SystemTypeName("int4"), -1));
				}
#line 51456 "gram.c" /* yacc.c:1646  */
    break;

  case 2306:
#line 16743 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 51464 "gram.c" /* yacc.c:1646  */
    break;

  case 2307:
#line 16748 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[0].list), (yyvsp[-2].node)); }
#line 51470 "gram.c" /* yacc.c:1646  */
    break;

  case 2308:
#line 16749 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 51476 "gram.c" /* yacc.c:1646  */
    break;

  case 2309:
#line 16750 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 51482 "gram.c" /* yacc.c:1646  */
    break;

  case 2310:
#line 16754 "gram.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subselect = (yyvsp[0].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *) n;
				}
#line 51494 "gram.c" /* yacc.c:1646  */
    break;

  case 2311:
#line 16761 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 51500 "gram.c" /* yacc.c:1646  */
    break;

  case 2312:
#line 16772 "gram.y" /* yacc.c:1646  */
    {
					CaseExpr   *c = makeNode(CaseExpr);

					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[-3].node);
					c->args = (yyvsp[-2].list);
					c->defresult = (Expr *) (yyvsp[-1].node);
					c->location = (yylsp[-4]);
					(yyval.node) = (Node *) c;
				}
#line 51515 "gram.c" /* yacc.c:1646  */
    break;

  case 2313:
#line 16786 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 51521 "gram.c" /* yacc.c:1646  */
    break;

  case 2314:
#line 16787 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 51527 "gram.c" /* yacc.c:1646  */
    break;

  case 2315:
#line 16792 "gram.y" /* yacc.c:1646  */
    {
					CaseWhen   *w = makeNode(CaseWhen);

					w->expr = (Expr *) (yyvsp[-2].node);
					w->result = (Expr *) (yyvsp[0].node);
					w->location = (yylsp[-3]);
					(yyval.node) = (Node *) w;
				}
#line 51540 "gram.c" /* yacc.c:1646  */
    break;

  case 2316:
#line 16803 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 51546 "gram.c" /* yacc.c:1646  */
    break;

  case 2317:
#line 16804 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 51552 "gram.c" /* yacc.c:1646  */
    break;

  case 2318:
#line 16807 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 51558 "gram.c" /* yacc.c:1646  */
    break;

  case 2319:
#line 16808 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 51564 "gram.c" /* yacc.c:1646  */
    break;

  case 2320:
#line 16812 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[0].str), NIL, (yylsp[0]), yyscanner);
				}
#line 51572 "gram.c" /* yacc.c:1646  */
    break;

  case 2321:
#line 16816 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[-1].str), (yyvsp[0].list), (yylsp[-1]), yyscanner);
				}
#line 51580 "gram.c" /* yacc.c:1646  */
    break;

  case 2322:
#line 16823 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 51588 "gram.c" /* yacc.c:1646  */
    break;

  case 2323:
#line 16827 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeNode(A_Star);
				}
#line 51596 "gram.c" /* yacc.c:1646  */
    break;

  case 2324:
#line 16831 "gram.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);

					ai->is_slice = false;
					ai->lidx = NULL;
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 51609 "gram.c" /* yacc.c:1646  */
    break;

  case 2325:
#line 16840 "gram.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);

					ai->is_slice = true;
					ai->lidx = (yyvsp[-3].node);
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 51622 "gram.c" /* yacc.c:1646  */
    break;

  case 2326:
#line 16851 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 51628 "gram.c" /* yacc.c:1646  */
    break;

  case 2327:
#line 16852 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 51634 "gram.c" /* yacc.c:1646  */
    break;

  case 2328:
#line 16856 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 51640 "gram.c" /* yacc.c:1646  */
    break;

  case 2329:
#line 16857 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 51646 "gram.c" /* yacc.c:1646  */
    break;

  case 2330:
#line 16861 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 51652 "gram.c" /* yacc.c:1646  */
    break;

  case 2331:
#line 16862 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 51658 "gram.c" /* yacc.c:1646  */
    break;

  case 2334:
#line 16871 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 51664 "gram.c" /* yacc.c:1646  */
    break;

  case 2335:
#line 16872 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 51670 "gram.c" /* yacc.c:1646  */
    break;

  case 2336:
#line 16876 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 51676 "gram.c" /* yacc.c:1646  */
    break;

  case 2337:
#line 16877 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 51682 "gram.c" /* yacc.c:1646  */
    break;

  case 2338:
#line 16882 "gram.y" /* yacc.c:1646  */
    {
				JsonArgument *n = makeNode(JsonArgument);

				n->val = (JsonValueExpr *) (yyvsp[-2].node);
				n->name = (yyvsp[0].str);
				(yyval.node) = (Node *) n;
			}
#line 51694 "gram.c" /* yacc.c:1646  */
    break;

  case 2339:
#line 16893 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JSW_NONE; }
#line 51700 "gram.c" /* yacc.c:1646  */
    break;

  case 2340:
#line 16894 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JSW_NONE; }
#line 51706 "gram.c" /* yacc.c:1646  */
    break;

  case 2341:
#line 16895 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JSW_UNCONDITIONAL; }
#line 51712 "gram.c" /* yacc.c:1646  */
    break;

  case 2342:
#line 16896 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JSW_UNCONDITIONAL; }
#line 51718 "gram.c" /* yacc.c:1646  */
    break;

  case 2343:
#line 16897 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JSW_CONDITIONAL; }
#line 51724 "gram.c" /* yacc.c:1646  */
    break;

  case 2344:
#line 16898 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JSW_UNCONDITIONAL; }
#line 51730 "gram.c" /* yacc.c:1646  */
    break;

  case 2345:
#line 16899 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JSW_CONDITIONAL; }
#line 51736 "gram.c" /* yacc.c:1646  */
    break;

  case 2346:
#line 16900 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JSW_UNCONDITIONAL; }
#line 51742 "gram.c" /* yacc.c:1646  */
    break;

  case 2347:
#line 16901 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JSW_UNSPEC; }
#line 51748 "gram.c" /* yacc.c:1646  */
    break;

  case 2348:
#line 16906 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeJsonBehavior(JSON_BEHAVIOR_DEFAULT, (yyvsp[0].node), (yylsp[-1])); }
#line 51754 "gram.c" /* yacc.c:1646  */
    break;

  case 2349:
#line 16908 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeJsonBehavior((yyvsp[0].ival), NULL, (yylsp[0])); }
#line 51760 "gram.c" /* yacc.c:1646  */
    break;

  case 2350:
#line 16912 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JSON_BEHAVIOR_ERROR; }
#line 51766 "gram.c" /* yacc.c:1646  */
    break;

  case 2351:
#line 16913 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JSON_BEHAVIOR_NULL; }
#line 51772 "gram.c" /* yacc.c:1646  */
    break;

  case 2352:
#line 16914 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JSON_BEHAVIOR_TRUE; }
#line 51778 "gram.c" /* yacc.c:1646  */
    break;

  case 2353:
#line 16915 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JSON_BEHAVIOR_FALSE; }
#line 51784 "gram.c" /* yacc.c:1646  */
    break;

  case 2354:
#line 16916 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JSON_BEHAVIOR_UNKNOWN; }
#line 51790 "gram.c" /* yacc.c:1646  */
    break;

  case 2355:
#line 16917 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JSON_BEHAVIOR_EMPTY_ARRAY; }
#line 51796 "gram.c" /* yacc.c:1646  */
    break;

  case 2356:
#line 16918 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JSON_BEHAVIOR_EMPTY_OBJECT; }
#line 51802 "gram.c" /* yacc.c:1646  */
    break;

  case 2357:
#line 16920 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JSON_BEHAVIOR_EMPTY_ARRAY; }
#line 51808 "gram.c" /* yacc.c:1646  */
    break;

  case 2358:
#line 16925 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-2].node), NULL); }
#line 51814 "gram.c" /* yacc.c:1646  */
    break;

  case 2359:
#line 16927 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL, (yyvsp[-2].node)); }
#line 51820 "gram.c" /* yacc.c:1646  */
    break;

  case 2360:
#line 16929 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-5].node), (yyvsp[-2].node)); }
#line 51826 "gram.c" /* yacc.c:1646  */
    break;

  case 2361:
#line 16931 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL, NULL); }
#line 51832 "gram.c" /* yacc.c:1646  */
    break;

  case 2362:
#line 16936 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-2].node); }
#line 51838 "gram.c" /* yacc.c:1646  */
    break;

  case 2363:
#line 16938 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 51844 "gram.c" /* yacc.c:1646  */
    break;

  case 2364:
#line 16943 "gram.y" /* yacc.c:1646  */
    {
				/* formatted_expr will be set during parse-analysis. */
				(yyval.node) = (Node *) makeJsonValueExpr((Expr *) (yyvsp[-1].node), NULL,
												castNode(JsonFormat, (yyvsp[0].node)));
			}
#line 51854 "gram.c" /* yacc.c:1646  */
    break;

  case 2365:
#line 16952 "gram.y" /* yacc.c:1646  */
    {
					int		encoding;

					if (!pg_strcasecmp((yyvsp[0].str), "utf8"))
						encoding = JS_ENC_UTF8;
					else if (!pg_strcasecmp((yyvsp[0].str), "utf16"))
						encoding = JS_ENC_UTF16;
					else if (!pg_strcasecmp((yyvsp[0].str), "utf32"))
						encoding = JS_ENC_UTF32;
					else
						ereport(ERROR,
								errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								errmsg("unrecognized JSON encoding: %s", (yyvsp[0].str)));

					(yyval.node) = (Node *) makeJsonFormat(JS_FORMAT_JSON, encoding, (yylsp[-3]));
				}
#line 51875 "gram.c" /* yacc.c:1646  */
    break;

  case 2366:
#line 16969 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeJsonFormat(JS_FORMAT_JSON, JS_ENC_DEFAULT, (yylsp[-1]));
				}
#line 51883 "gram.c" /* yacc.c:1646  */
    break;

  case 2367:
#line 16976 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 51891 "gram.c" /* yacc.c:1646  */
    break;

  case 2368:
#line 16980 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);
				}
#line 51899 "gram.c" /* yacc.c:1646  */
    break;

  case 2369:
#line 16986 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_QUOTES_KEEP; }
#line 51905 "gram.c" /* yacc.c:1646  */
    break;

  case 2370:
#line 16987 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_QUOTES_KEEP; }
#line 51911 "gram.c" /* yacc.c:1646  */
    break;

  case 2371:
#line 16988 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_QUOTES_OMIT; }
#line 51917 "gram.c" /* yacc.c:1646  */
    break;

  case 2372:
#line 16989 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_QUOTES_OMIT; }
#line 51923 "gram.c" /* yacc.c:1646  */
    break;

  case 2373:
#line 16990 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_QUOTES_UNSPEC; }
#line 51929 "gram.c" /* yacc.c:1646  */
    break;

  case 2374:
#line 16995 "gram.y" /* yacc.c:1646  */
    {
					JsonOutput *n = makeNode(JsonOutput);

					n->typeName = (yyvsp[-1].typnam);
					n->returning = makeNode(JsonReturning);
					n->returning->format = (JsonFormat *) (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 51942 "gram.c" /* yacc.c:1646  */
    break;

  case 2375:
#line 17003 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 51948 "gram.c" /* yacc.c:1646  */
    break;

  case 2376:
#line 17017 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_TYPE_ANY; }
#line 51954 "gram.c" /* yacc.c:1646  */
    break;

  case 2377:
#line 17018 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_TYPE_ANY; }
#line 51960 "gram.c" /* yacc.c:1646  */
    break;

  case 2378:
#line 17019 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_TYPE_ARRAY; }
#line 51966 "gram.c" /* yacc.c:1646  */
    break;

  case 2379:
#line 17020 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_TYPE_OBJECT; }
#line 51972 "gram.c" /* yacc.c:1646  */
    break;

  case 2380:
#line 17021 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_TYPE_SCALAR; }
#line 51978 "gram.c" /* yacc.c:1646  */
    break;

  case 2381:
#line 17030 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 51984 "gram.c" /* yacc.c:1646  */
    break;

  case 2382:
#line 17031 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 51990 "gram.c" /* yacc.c:1646  */
    break;

  case 2383:
#line 17032 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 51996 "gram.c" /* yacc.c:1646  */
    break;

  case 2384:
#line 17033 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 52002 "gram.c" /* yacc.c:1646  */
    break;

  case 2385:
#line 17034 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 52008 "gram.c" /* yacc.c:1646  */
    break;

  case 2386:
#line 17039 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 52014 "gram.c" /* yacc.c:1646  */
    break;

  case 2387:
#line 17041 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 52020 "gram.c" /* yacc.c:1646  */
    break;

  case 2388:
#line 17051 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeJsonKeyValue((yyvsp[-2].node), (yyvsp[0].node)); }
#line 52026 "gram.c" /* yacc.c:1646  */
    break;

  case 2389:
#line 17054 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeJsonKeyValue((yyvsp[-2].node), (yyvsp[0].node)); }
#line 52032 "gram.c" /* yacc.c:1646  */
    break;

  case 2390:
#line 17059 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 52038 "gram.c" /* yacc.c:1646  */
    break;

  case 2391:
#line 17060 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 52044 "gram.c" /* yacc.c:1646  */
    break;

  case 2392:
#line 17061 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 52050 "gram.c" /* yacc.c:1646  */
    break;

  case 2393:
#line 17065 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 52056 "gram.c" /* yacc.c:1646  */
    break;

  case 2394:
#line 17066 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 52062 "gram.c" /* yacc.c:1646  */
    break;

  case 2395:
#line 17067 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 52068 "gram.c" /* yacc.c:1646  */
    break;

  case 2396:
#line 17071 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 52074 "gram.c" /* yacc.c:1646  */
    break;

  case 2397:
#line 17072 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));}
#line 52080 "gram.c" /* yacc.c:1646  */
    break;

  case 2398:
#line 17082 "gram.y" /* yacc.c:1646  */
    {
					JsonObjectAgg *n = makeNode(JsonObjectAgg);

					n->arg = (JsonKeyValue *) (yyvsp[-4].node);
					n->absent_on_null = (yyvsp[-3].boolean);
					n->unique = (yyvsp[-2].boolean);
					n->constructor = makeNode(JsonAggConstructor);
					n->constructor->output = (JsonOutput *) (yyvsp[-1].node);
					n->constructor->agg_order = NULL;
					n->constructor->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 52097 "gram.c" /* yacc.c:1646  */
    break;

  case 2399:
#line 17100 "gram.y" /* yacc.c:1646  */
    {
					JsonArrayAgg *n = makeNode(JsonArrayAgg);

					n->arg = (JsonValueExpr *) (yyvsp[-4].node);
					n->absent_on_null = (yyvsp[-2].boolean);
					n->constructor = makeNode(JsonAggConstructor);
					n->constructor->agg_order = (yyvsp[-3].list);
					n->constructor->output = (JsonOutput *) (yyvsp[-1].node);
					n->constructor->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 52113 "gram.c" /* yacc.c:1646  */
    break;

  case 2400:
#line 17114 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 52119 "gram.c" /* yacc.c:1646  */
    break;

  case 2401:
#line 17115 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 52125 "gram.c" /* yacc.c:1646  */
    break;

  case 2402:
#line 17124 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 52131 "gram.c" /* yacc.c:1646  */
    break;

  case 2403:
#line 17125 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 52137 "gram.c" /* yacc.c:1646  */
    break;

  case 2404:
#line 17129 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 52143 "gram.c" /* yacc.c:1646  */
    break;

  case 2405:
#line 17130 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 52149 "gram.c" /* yacc.c:1646  */
    break;

  case 2406:
#line 17134 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 52161 "gram.c" /* yacc.c:1646  */
    break;

  case 2407:
#line 17142 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-1].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 52173 "gram.c" /* yacc.c:1646  */
    break;

  case 2408:
#line 17150 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 52185 "gram.c" /* yacc.c:1646  */
    break;

  case 2409:
#line 17158 "gram.y" /* yacc.c:1646  */
    {
					ColumnRef  *n = makeNode(ColumnRef);

					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[0]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) n;
					(yyval.target)->location = (yylsp[0]);
				}
#line 52202 "gram.c" /* yacc.c:1646  */
    break;

  case 2410:
#line 17180 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 52208 "gram.c" /* yacc.c:1646  */
    break;

  case 2411:
#line 17181 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 52214 "gram.c" /* yacc.c:1646  */
    break;

  case 2412:
#line 17193 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = makeRangeVar(NULL, (yyvsp[0].str), (yylsp[0]));
				}
#line 52222 "gram.c" /* yacc.c:1646  */
    break;

  case 2413:
#line 17197 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = makeRangeVarFromQualifiedName((yyvsp[-1].str), (yyvsp[0].list), (yylsp[-1]), yyscanner);
				}
#line 52230 "gram.c" /* yacc.c:1646  */
    break;

  case 2414:
#line 17203 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 52236 "gram.c" /* yacc.c:1646  */
    break;

  case 2415:
#line 17205 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 52242 "gram.c" /* yacc.c:1646  */
    break;

  case 2416:
#line 17209 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 52248 "gram.c" /* yacc.c:1646  */
    break;

  case 2417:
#line 17211 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 52254 "gram.c" /* yacc.c:1646  */
    break;

  case 2418:
#line 17213 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 52260 "gram.c" /* yacc.c:1646  */
    break;

  case 2419:
#line 17224 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 52266 "gram.c" /* yacc.c:1646  */
    break;

  case 2420:
#line 17226 "gram.y" /* yacc.c:1646  */
    {
						(yyval.list) = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
											 yyscanner);
					}
#line 52275 "gram.c" /* yacc.c:1646  */
    break;

  case 2421:
#line 17237 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeIntConst((yyvsp[0].ival), (yylsp[0]));
				}
#line 52283 "gram.c" /* yacc.c:1646  */
    break;

  case 2422:
#line 17241 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeFloatConst((yyvsp[0].str), (yylsp[0]));
				}
#line 52291 "gram.c" /* yacc.c:1646  */
    break;

  case 2423:
#line 17245 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 52299 "gram.c" /* yacc.c:1646  */
    break;

  case 2424:
#line 17249 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 52307 "gram.c" /* yacc.c:1646  */
    break;

  case 2425:
#line 17253 "gram.y" /* yacc.c:1646  */
    {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 52320 "gram.c" /* yacc.c:1646  */
    break;

  case 2426:
#line 17262 "gram.y" /* yacc.c:1646  */
    {
					/* generic type 'literal' syntax */
					TypeName   *t = makeTypeNameFromNameList((yyvsp[-1].list));

					t->location = (yylsp[-1]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 52332 "gram.c" /* yacc.c:1646  */
    break;

  case 2427:
#line 17270 "gram.y" /* yacc.c:1646  */
    {
					/* generic syntax with a type modifier */
					TypeName   *t = makeTypeNameFromNameList((yyvsp[-5].list));
					ListCell   *lc;

					/*
					 * We must use func_arg_list and opt_sort_clause in the
					 * production to avoid reduce/reduce conflicts, but we
					 * don't actually wish to allow NamedArgExpr in this
					 * context, nor ORDER BY.
					 */
					foreach(lc, (yyvsp[-3].list))
					{
						NamedArgExpr *arg = (NamedArgExpr *) lfirst(lc);

						if (IsA(arg, NamedArgExpr))
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have parameter name"),
									 parser_errposition(arg->location)));
					}
					if ((yyvsp[-2].list) != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have ORDER BY"),
									 parser_errposition((yylsp[-2]))));

					t->typmods = (yyvsp[-3].list);
					t->location = (yylsp[-5]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 52368 "gram.c" /* yacc.c:1646  */
    break;

  case 2428:
#line 17302 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), (yyvsp[-1].typnam));
				}
#line 52376 "gram.c" /* yacc.c:1646  */
    break;

  case 2429:
#line 17306 "gram.y" /* yacc.c:1646  */
    {
					TypeName   *t = (yyvsp[-2].typnam);

					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 52387 "gram.c" /* yacc.c:1646  */
    break;

  case 2430:
#line 17313 "gram.y" /* yacc.c:1646  */
    {
					TypeName   *t = (yyvsp[-4].typnam);

					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 52399 "gram.c" /* yacc.c:1646  */
    break;

  case 2431:
#line 17321 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(true, (yylsp[0]));
				}
#line 52407 "gram.c" /* yacc.c:1646  */
    break;

  case 2432:
#line 17325 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(false, (yylsp[0]));
				}
#line 52415 "gram.c" /* yacc.c:1646  */
    break;

  case 2433:
#line 17329 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 52423 "gram.c" /* yacc.c:1646  */
    break;

  case 2434:
#line 17334 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 52429 "gram.c" /* yacc.c:1646  */
    break;

  case 2435:
#line 17335 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 52435 "gram.c" /* yacc.c:1646  */
    break;

  case 2436:
#line 17337 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 52441 "gram.c" /* yacc.c:1646  */
    break;

  case 2437:
#line 17338 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = + (yyvsp[0].ival); }
#line 52447 "gram.c" /* yacc.c:1646  */
    break;

  case 2438:
#line 17339 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = - (yyvsp[0].ival); }
#line 52453 "gram.c" /* yacc.c:1646  */
    break;

  case 2439:
#line 17344 "gram.y" /* yacc.c:1646  */
    {
					RoleSpec   *spc = (RoleSpec *) (yyvsp[0].rolespec);

					switch (spc->roletype)
					{
						case ROLESPEC_CSTRING:
							(yyval.str) = spc->rolename;
							break;
						case ROLESPEC_PUBLIC:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("role name \"%s\" is reserved",
											"public"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_SESSION_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"SESSION_USER"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_CURRENT_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"CURRENT_USER"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_CURRENT_ROLE:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"CURRENT_ROLE"),
									 parser_errposition((yylsp[0]))));
							break;
					}
				}
#line 52496 "gram.c" /* yacc.c:1646  */
    break;

  case 2440:
#line 17385 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * "public" and "none" are not keywords, but they must
					 * be treated specially here.
					 */
					RoleSpec   *n;

					if (strcmp((yyvsp[0].str), "public") == 0)
					{
						n = (RoleSpec *) makeRoleSpec(ROLESPEC_PUBLIC, (yylsp[0]));
						n->roletype = ROLESPEC_PUBLIC;
					}
					else if (strcmp((yyvsp[0].str), "none") == 0)
					{
						ereport(ERROR,
								(errcode(ERRCODE_RESERVED_NAME),
								 errmsg("role name \"%s\" is reserved",
										"none"),
								 parser_errposition((yylsp[0]))));
					}
					else
					{
						n = makeRoleSpec(ROLESPEC_CSTRING, (yylsp[0]));
						n->rolename = pstrdup((yyvsp[0].str));
					}
					(yyval.rolespec) = n;
				}
#line 52528 "gram.c" /* yacc.c:1646  */
    break;

  case 2441:
#line 17413 "gram.y" /* yacc.c:1646  */
    {
					(yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_ROLE, (yylsp[0]));
				}
#line 52536 "gram.c" /* yacc.c:1646  */
    break;

  case 2442:
#line 17417 "gram.y" /* yacc.c:1646  */
    {
					(yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0]));
				}
#line 52544 "gram.c" /* yacc.c:1646  */
    break;

  case 2443:
#line 17421 "gram.y" /* yacc.c:1646  */
    {
					(yyval.rolespec) = makeRoleSpec(ROLESPEC_SESSION_USER, (yylsp[0]));
				}
#line 52552 "gram.c" /* yacc.c:1646  */
    break;

  case 2444:
#line 17427 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].rolespec)); }
#line 52558 "gram.c" /* yacc.c:1646  */
    break;

  case 2445:
#line 17429 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].rolespec)); }
#line 52564 "gram.c" /* yacc.c:1646  */
    break;

  case 2446:
#line 17446 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);

					n->distinctClause = (yyvsp[-9].list);
					n->targetList = (yyvsp[-8].list);
					n->fromClause = (yyvsp[-7].list);
					n->whereClause = (yyvsp[-6].node);
					n->groupClause = ((yyvsp[-5].groupclause))->list;
					n->groupDistinct = ((yyvsp[-5].groupclause))->distinct;
					n->havingClause = (yyvsp[-4].node);
					n->windowClause = (yyvsp[-3].list);
					n->sortClause = (yyvsp[-2].list);
					if ((yyvsp[-1].selectlimit))
					{
						n->limitOffset = (yyvsp[-1].selectlimit)->limitOffset;
						n->limitCount = (yyvsp[-1].selectlimit)->limitCount;
						if (!n->sortClause &&
							(yyvsp[-1].selectlimit)->limitOption == LIMIT_OPTION_WITH_TIES)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("WITH TIES cannot be specified without ORDER BY clause")));
						n->limitOption = (yyvsp[-1].selectlimit)->limitOption;
					}
					n->lockingClause = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 52595 "gram.c" /* yacc.c:1646  */
    break;

  case 2447:
#line 17479 "gram.y" /* yacc.c:1646  */
    {
					PLAssignStmt *n = makeNode(PLAssignStmt);

					n->name = (yyvsp[-3].str);
					n->indirection = check_indirection((yyvsp[-2].list), yyscanner);
					/* nnames will be filled by calling production */
					n->val = (SelectStmt *) (yyvsp[0].node);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 52610 "gram.c" /* yacc.c:1646  */
    break;

  case 2448:
#line 17491 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 52616 "gram.c" /* yacc.c:1646  */
    break;

  case 2449:
#line 17492 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = psprintf("$%d", (yyvsp[0].ival)); }
#line 52622 "gram.c" /* yacc.c:1646  */
    break;

  case 2452:
#line 17513 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 52628 "gram.c" /* yacc.c:1646  */
    break;

  case 2453:
#line 17514 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 52634 "gram.c" /* yacc.c:1646  */
    break;

  case 2454:
#line 17515 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 52640 "gram.c" /* yacc.c:1646  */
    break;

  case 2455:
#line 17520 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 52646 "gram.c" /* yacc.c:1646  */
    break;

  case 2456:
#line 17521 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 52652 "gram.c" /* yacc.c:1646  */
    break;

  case 2457:
#line 17522 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 52658 "gram.c" /* yacc.c:1646  */
    break;

  case 2458:
#line 17527 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 52664 "gram.c" /* yacc.c:1646  */
    break;

  case 2459:
#line 17528 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 52670 "gram.c" /* yacc.c:1646  */
    break;

  case 2460:
#line 17529 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 52676 "gram.c" /* yacc.c:1646  */
    break;

  case 2461:
#line 17530 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 52682 "gram.c" /* yacc.c:1646  */
    break;

  case 2462:
#line 17536 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 52688 "gram.c" /* yacc.c:1646  */
    break;

  case 2463:
#line 17537 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 52694 "gram.c" /* yacc.c:1646  */
    break;

  case 2464:
#line 17538 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 52700 "gram.c" /* yacc.c:1646  */
    break;

  case 2465:
#line 17539 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 52706 "gram.c" /* yacc.c:1646  */
    break;

  case 2466:
#line 17540 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 52712 "gram.c" /* yacc.c:1646  */
    break;

  case 2467:
#line 17546 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 52718 "gram.c" /* yacc.c:1646  */
    break;

  case 2468:
#line 17547 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 52724 "gram.c" /* yacc.c:1646  */
    break;


#line 52728 "gram.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, yyscanner, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, yyscanner);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, yyscanner);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 18563 "gram.y" /* yacc.c:1906  */


/*
 * The signature of this function is required by bison.  However, we
 * ignore the passed yylloc and instead use the last token position
 * available from the scanner.
 */
static void
base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner, const char *msg)
{
	parser_yyerror(msg);
}

static RawStmt *
makeRawStmt(Node *stmt, int stmt_location)
{
	RawStmt    *rs = makeNode(RawStmt);

	rs->stmt = stmt;
	rs->stmt_location = stmt_location;
	rs->stmt_len = 0;			/* might get changed later */
	return rs;
}

/* Adjust a RawStmt to reflect that it doesn't run to the end of the string */
static void
updateRawStmtEnd(RawStmt *rs, int end_location)
{
	/*
	 * If we already set the length, don't change it.  This is for situations
	 * like "select foo ;; select bar" where the same statement will be last
	 * in the string for more than one semicolon.
	 */
	if (rs->stmt_len > 0)
		return;

	/* OK, update length of RawStmt */
	rs->stmt_len = end_location - rs->stmt_location;
}

static Node *
makeColumnRef(char *colname, List *indirection,
			  int location, core_yyscan_t yyscanner)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int			nfields = 0;
	ListCell   *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection, yyscanner);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields),
												   yyscanner);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(indirection, l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}

static Node *
makeTypeCast(Node *arg, TypeName *typename, int location)
{
	TypeCast   *n = makeNode(TypeCast);

	n->arg = arg;
	n->typeName = typename;
	n->location = location;
	return (Node *) n;
}

static Node *
makeStringConstCast(char *str, int location, TypeName *typename)
{
	Node	   *s = makeStringConst(str, location);

	return makeTypeCast(s, typename, -1);
}

static Node *
makeIntConst(int val, int location)
{
	A_Const	   *n = makeNode(A_Const);

	n->val.ival.type = T_Integer;
	n->val.ival.ival = val;
	n->location = location;

   return (Node *) n;
}

static Node *
makeFloatConst(char *str, int location)
{
	A_Const	   *n = makeNode(A_Const);

	n->val.fval.type = T_Float;
	n->val.fval.fval = str;
	n->location = location;

   return (Node *) n;
}

static Node *
makeBoolAConst(bool state, int location)
{
	A_Const	   *n = makeNode(A_Const);

	n->val.boolval.type = T_Boolean;
	n->val.boolval.boolval = state;
	n->location = location;

   return (Node *) n;
}

static Node *
makeBitStringConst(char *str, int location)
{
	A_Const	   *n = makeNode(A_Const);

	n->val.bsval.type = T_BitString;
	n->val.bsval.bsval = str;
	n->location = location;

   return (Node *) n;
}

static Node *
makeNullAConst(int location)
{
	A_Const	   *n = makeNode(A_Const);

	n->isnull = true;
	n->location = location;

	return (Node *) n;
}

static Node *
makeAConst(Node *v, int location)
{
	Node	   *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(castNode(Float, v)->fval, location);
			break;

		case T_Integer:
			n = makeIntConst(castNode(Integer, v)->ival, location);
			break;

		default:
			/* currently not used */
			Assert(false);
			n = NULL;
	}

	return n;
}

/* makeRoleSpec
 * Create a RoleSpec with the given type
 */
static RoleSpec *
makeRoleSpec(RoleSpecType type, int location)
{
	RoleSpec   *spec = makeNode(RoleSpec);

	spec->roletype = type;
	spec->location = location;

	return spec;
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection, core_yyscan_t yyscanner)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(indirection, l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* extractAggrArgTypes()
 * As above, but work from the output of the aggr_args production.
 */
static List *
extractAggrArgTypes(List *aggrargs)
{
	Assert(list_length(aggrargs) == 2);
	return extractArgTypes((List *) linitial(aggrargs));
}

/* makeOrderedSetArgs()
 * Build the result of the aggr_args production (which see the comments for).
 * This handles only the case where both given lists are nonempty, so that
 * we have to deal with multiple VARIADIC arguments.
 */
static List *
makeOrderedSetArgs(List *directargs, List *orderedargs,
				   core_yyscan_t yyscanner)
{
	FunctionParameter *lastd = (FunctionParameter *) llast(directargs);
	Integer	   *ndirectargs;

	/* No restriction unless last direct arg is VARIADIC */
	if (lastd->mode == FUNC_PARAM_VARIADIC)
	{
		FunctionParameter *firsto = (FunctionParameter *) linitial(orderedargs);

		/*
		 * We ignore the names, though the aggr_arg production allows them;
		 * it doesn't allow default values, so those need not be checked.
		 */
		if (list_length(orderedargs) != 1 ||
			firsto->mode != FUNC_PARAM_VARIADIC ||
			!equal(lastd->argType, firsto->argType))
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 errmsg("an ordered-set aggregate with a VARIADIC direct argument must have one VARIADIC aggregated argument of the same data type"),
					 parser_errposition(exprLocation((Node *) firsto))));

		/* OK, drop the duplicate VARIADIC argument from the internal form */
		orderedargs = NIL;
	}

	/* don't merge into the next line, as list_concat changes directargs */
	ndirectargs = makeInteger(list_length(directargs));

	return list_make2(list_concat(directargs, orderedargs),
					  ndirectargs);
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					SelectLimit *limitClause,
					WithClause *withClause,
					core_yyscan_t yyscanner)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 parser_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitClause && limitClause->limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 parser_errposition(exprLocation(limitClause->limitOffset))));
		stmt->limitOffset = limitClause->limitOffset;
	}
	if (limitClause && limitClause->limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 parser_errposition(exprLocation(limitClause->limitCount))));
		stmt->limitCount = limitClause->limitCount;
	}
	if (limitClause)
	{
		if (stmt->limitOption)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple limit options not allowed")));
		if (!stmt->sortClause && limitClause->limitOption == LIMIT_OPTION_WITH_TIES)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("WITH TIES cannot be specified without ORDER BY clause")));
		if (limitClause->limitOption == LIMIT_OPTION_WITH_TIES && stmt->lockingClause)
		{
			ListCell   *lc;

			foreach(lc, stmt->lockingClause)
			{
				LockingClause *lock = lfirst_node(LockingClause, lc);

				if (lock->waitPolicy == LockWaitSkip)
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("%s and %s options cannot be used together",
									"SKIP LOCKED", "WITH TIES")));
			}
		}
		stmt->limitOption = limitClause->limitOption;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 parser_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* SystemFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
SystemFuncName(char *name)
{
	return list_make2(makeString("pg_catalog"), makeString(name));
}

/* SystemTypeName()
 * Build a properly-qualified reference to a built-in type.
 *
 * typmod is defaulted, but may be changed afterwards by caller.
 * Likewise for the location.
 */
TypeName *
SystemTypeName(char *name)
{
	return makeTypeNameFromNameList(list_make2(makeString("pg_catalog"),
											   makeString(name)));
}

/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const	   *con = (A_Const *) n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (IsA(&con->val, Integer))
		{
			con->val.ival.ival = -con->val.ival.ival;
			return n;
		}
		if (IsA(&con->val, Float))
		{
			doNegateFloat(&con->val.fval);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Float *v)
{
	char	   *oldval = v->fval;

	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->fval = oldval+1;	/* just strip the '-' */
	else
		v->fval = psprintf("-%s", oldval);
}

static Node *
makeAndExpr(Node *lexpr, Node *rexpr, int location)
{
	/* Flatten "a AND b AND c ..." to a single BoolExpr on sight */
	if (IsA(lexpr, BoolExpr))
	{
		BoolExpr   *blexpr = (BoolExpr *) lexpr;

		if (blexpr->boolop == AND_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(AND_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeOrExpr(Node *lexpr, Node *rexpr, int location)
{
	/* Flatten "a OR b OR c ..." to a single BoolExpr on sight */
	if (IsA(lexpr, BoolExpr))
	{
		BoolExpr   *blexpr = (BoolExpr *) lexpr;

		if (blexpr->boolop == OR_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(OR_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeNotExpr(Node *expr, int location)
{
	return (Node *) makeBoolExpr(NOT_EXPR, list_make1(expr), location);
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeSQLValueFunction(SQLValueFunctionOp op, int32 typmod, int location)
{
	SQLValueFunction *svf = makeNode(SQLValueFunction);

	svf->op = op;
	/* svf->type will be filled during parse analysis */
	svf->typmod = typmod;
	svf->location = location;
	return (Node *) svf;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr		*x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->type = InvalidOid;			/* marks the node as not analyzed */
	x->location = location;
	return (Node *) x;
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_DEFAULT &&
			p->mode != FUNC_PARAM_IN &&
			p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions")));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName   *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Convert a list of (dotted) names to a RangeVar (like
 * makeRangeVarFromNameList, but with position support).  The
 * "AnyName" refers to the any_name production in the grammar.
 */
static RangeVar *
makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner)
{
	RangeVar   *r = makeNode(RangeVar);

	switch (list_length(names))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = NULL;
			r->relname = strVal(linitial(names));
			break;
		case 2:
			r->catalogname = NULL;
			r->schemaname = strVal(linitial(names));
			r->relname = strVal(lsecond(names));
			break;
		case 3:
			r->catalogname = strVal(linitial(names));
			r->schemaname = strVal(lsecond(names));
			r->relname = strVal(lthird(names));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
							NameListToString(names)),
					 parser_errposition(position)));
			break;
	}

	r->relpersistence = RELPERSISTENCE_PERMANENT;
	r->location = position;

	return r;
}

/*
 * Convert a relation_name with name and namelist to a RangeVar using
 * makeRangeVar.
 */
static RangeVar *
makeRangeVarFromQualifiedName(char *name, List *namelist, int location,
							  core_yyscan_t yyscanner)
{
	RangeVar   *r;

	check_qualified_name(namelist, yyscanner);
	r = makeRangeVar(NULL, NULL, location);

	switch (list_length(namelist))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = name;
			r->relname = strVal(linitial(namelist));
			break;
		case 2:
			r->catalogname = name;
			r->schemaname = strVal(linitial(namelist));
			r->relname = strVal(lsecond(namelist));
			break;
		default:
			ereport(ERROR,
					errcode(ERRCODE_SYNTAX_ERROR),
					errmsg("improper qualified name (too many dotted names): %s",
						   NameListToString(lcons(makeString(name), namelist))),
						   parser_errposition(location));
			break;
	}

	return r;
}

/* Separate Constraint nodes from COLLATE clauses in a ColQualList */
static void
SplitColQualList(List *qualList,
				 List **constraintList, CollateClause **collClause,
				 core_yyscan_t yyscanner)
{
	ListCell   *cell;

	*collClause = NULL;
	foreach(cell, qualList)
	{
		Node	   *n = (Node *) lfirst(cell);

		if (IsA(n, Constraint))
		{
			/* keep it in list */
			continue;
		}
		if (IsA(n, CollateClause))
		{
			CollateClause *c = (CollateClause *) n;

			if (*collClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("multiple COLLATE clauses not allowed"),
						 parser_errposition(c->location)));
			*collClause = c;
		}
		else
			elog(ERROR, "unexpected node type %d", (int) n->type);
		/* remove non-Constraint nodes from qualList */
		qualList = foreach_delete_current(qualList, cell);
	}
	*constraintList = qualList;
}

/*
 * Process result of ConstraintAttributeSpec, and set appropriate bool flags
 * in the output command node.  Pass NULL for any flags the particular
 * command doesn't support.
 */
static void
processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner)
{
	/* defaults */
	if (deferrable)
		*deferrable = false;
	if (initdeferred)
		*initdeferred = false;
	if (not_valid)
		*not_valid = false;

	if (cas_bits & (CAS_DEFERRABLE | CAS_INITIALLY_DEFERRED))
	{
		if (deferrable)
			*deferrable = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_INITIALLY_DEFERRED)
	{
		if (initdeferred)
			*initdeferred = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NOT_VALID)
	{
		if (not_valid)
			*not_valid = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NOT VALID",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NO_INHERIT)
	{
		if (no_inherit)
			*no_inherit = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NO INHERIT",
							constrType),
					 parser_errposition(location)));
	}
}

/*
 * Parse a user-supplied partition strategy string into parse node
 * PartitionStrategy representation, or die trying.
 */
static PartitionStrategy
parsePartitionStrategy(char *strategy)
{
	if (pg_strcasecmp(strategy, "list") == 0)
		return PARTITION_STRATEGY_LIST;
	else if (pg_strcasecmp(strategy, "range") == 0)
		return PARTITION_STRATEGY_RANGE;
	else if (pg_strcasecmp(strategy, "hash") == 0)
		return PARTITION_STRATEGY_HASH;

	ereport(ERROR,
			(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
			 errmsg("unrecognized partitioning strategy \"%s\"",
					strategy)));
	return PARTITION_STRATEGY_LIST;		/* keep compiler quiet */

}

/*
 * Process pubobjspec_list to check for errors in any of the objects and
 * convert PUBLICATIONOBJ_CONTINUATION into appropriate PublicationObjSpecType.
 */
static void
preprocess_pubobj_list(List *pubobjspec_list, core_yyscan_t yyscanner)
{
	ListCell   *cell;
	PublicationObjSpec *pubobj;
	PublicationObjSpecType prevobjtype = PUBLICATIONOBJ_CONTINUATION;

	if (!pubobjspec_list)
		return;

	pubobj = (PublicationObjSpec *) linitial(pubobjspec_list);
	if (pubobj->pubobjtype == PUBLICATIONOBJ_CONTINUATION)
		ereport(ERROR,
				errcode(ERRCODE_SYNTAX_ERROR),
				errmsg("invalid publication object list"),
				errdetail("One of TABLE or TABLES IN SCHEMA must be specified before a standalone table or schema name."),
				parser_errposition(pubobj->location));

	foreach(cell, pubobjspec_list)
	{
		pubobj = (PublicationObjSpec *) lfirst(cell);

		if (pubobj->pubobjtype == PUBLICATIONOBJ_CONTINUATION)
			pubobj->pubobjtype = prevobjtype;

		if (pubobj->pubobjtype == PUBLICATIONOBJ_TABLE)
		{
			/* relation name or pubtable must be set for this type of object */
			if (!pubobj->name && !pubobj->pubtable)
				ereport(ERROR,
						errcode(ERRCODE_SYNTAX_ERROR),
						errmsg("invalid table name"),
						parser_errposition(pubobj->location));

			if (pubobj->name)
			{
				/* convert it to PublicationTable */
				PublicationTable *pubtable = makeNode(PublicationTable);

				pubtable->relation =
					makeRangeVar(NULL, pubobj->name, pubobj->location);
				pubobj->pubtable = pubtable;
				pubobj->name = NULL;
			}
		}
		else if (pubobj->pubobjtype == PUBLICATIONOBJ_TABLES_IN_SCHEMA ||
				 pubobj->pubobjtype == PUBLICATIONOBJ_TABLES_IN_CUR_SCHEMA)
		{
			/* WHERE clause is not allowed on a schema object */
			if (pubobj->pubtable && pubobj->pubtable->whereClause)
				ereport(ERROR,
						errcode(ERRCODE_SYNTAX_ERROR),
						errmsg("WHERE clause not allowed for schema"),
						parser_errposition(pubobj->location));

			/* Column list is not allowed on a schema object */
			if (pubobj->pubtable && pubobj->pubtable->columns)
				ereport(ERROR,
						errcode(ERRCODE_SYNTAX_ERROR),
						errmsg("column specification not allowed for schema"),
						parser_errposition(pubobj->location));

			/*
			 * We can distinguish between the different type of schema
			 * objects based on whether name and pubtable is set.
			 */
			if (pubobj->name)
				pubobj->pubobjtype = PUBLICATIONOBJ_TABLES_IN_SCHEMA;
			else if (!pubobj->name && !pubobj->pubtable)
				pubobj->pubobjtype = PUBLICATIONOBJ_TABLES_IN_CUR_SCHEMA;
			else
				ereport(ERROR,
						errcode(ERRCODE_SYNTAX_ERROR),
						errmsg("invalid schema name"),
						parser_errposition(pubobj->location));
		}

		prevobjtype = pubobj->pubobjtype;
	}
}

/*----------
 * Recursive view transformation
 *
 * Convert
 *
 *     CREATE RECURSIVE VIEW relname (aliases) AS query
 *
 * to
 *
 *     CREATE VIEW relname (aliases) AS
 *         WITH RECURSIVE relname (aliases) AS (query)
 *         SELECT aliases FROM relname
 *
 * Actually, just the WITH ... part, which is then inserted into the original
 * view definition as the query.
 * ----------
 */
static Node *
makeRecursiveViewSelect(char *relname, List *aliases, Node *query)
{
	SelectStmt *s = makeNode(SelectStmt);
	WithClause *w = makeNode(WithClause);
	CommonTableExpr *cte = makeNode(CommonTableExpr);
	List	   *tl = NIL;
	ListCell   *lc;

	/* create common table expression */
	cte->ctename = relname;
	cte->aliascolnames = aliases;
	cte->ctematerialized = CTEMaterializeDefault;
	cte->ctequery = query;
	cte->location = -1;

	/* create WITH clause and attach CTE */
	w->recursive = true;
	w->ctes = list_make1(cte);
	w->location = -1;

	/* create target list for the new SELECT from the alias list of the
	 * recursive view specification */
	foreach (lc, aliases)
	{
		ResTarget *rt = makeNode(ResTarget);

		rt->name = NULL;
		rt->indirection = NIL;
		rt->val = makeColumnRef(strVal(lfirst(lc)), NIL, -1, 0);
		rt->location = -1;

		tl = lappend(tl, rt);
	}

	/* create new SELECT combining WITH clause, target list, and fake FROM
	 * clause */
	s->withClause = w;
	s->targetList = tl;
	s->fromClause = list_make1(makeRangeVar(NULL, relname, -1));

	return (Node *) s;
}

/* parser_init()
 * Initialize to parse one query string
 */
void
parser_init(base_yy_extra_type *yyext)
{
	yyext->parsetree = NIL;		/* in case grammar forgets to set it */
}
